"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/linesDiffComputer","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/lineRange","vs/editor/common/core/wordHelper","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(q){for(var t=[],F=0,S=q.length;F<S;F++)t[F]=ee[q[F]];return t};const Oe=this,Be=typeof global=="object"?global:{};var he;(function(q){q.global=Oe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=t})(he||(he={}));var he;(function(q){class t{constructor(u,y,w){this.type=u,this.detail=y,this.timestamp=w}}q.LoaderEvent=t;class F{constructor(u){this._events=[new t(1,"",u)]}record(u,y){this._events.push(new t(u,y,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=F;class S{record(u,y){}getEvents(){return[]}}S.INSTANCE=new S,q.NullLoaderEventRecorder=S})(he||(he={}));var he;(function(q){class t{static fileUriToFilePath(S,i){if(i=decodeURI(i).replace(/%23/g,"#"),S){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(S,i){return S.length>=i.length&&S.substr(0,i.length)===i}static endsWith(S,i){return S.length>=i.length&&S.substr(S.length-i.length)===i}static containsQueryString(S){return/^[^\#]*\?/gi.test(S)}static isAbsolutePath(S){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(S)}static forEachProperty(S,i){if(S){let u;for(u in S)S.hasOwnProperty(u)&&i(u,S[u])}}static isEmpty(S){let i=!0;return t.forEachProperty(S,()=>{i=!1}),i}static recursiveClone(S){if(!S||typeof S!="object"||S instanceof RegExp||!Array.isArray(S)&&Object.getPrototypeOf(S)!==Object.prototype)return S;let i=Array.isArray(S)?[]:{};return t.forEachProperty(S,(u,y)=>{y&&typeof y=="object"?i[u]=t.recursiveClone(y):i[u]=y}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(S){return t.startsWith(S,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,q.Utilities=t})(he||(he={}));var he;(function(q){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}q.ensureError=t;class F{static validateConfigurationOptions(u){function y(w){if(w.phase==="loading"){console.error('Loading "'+w.moduleId+'" failed'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}if(w.phase==="factory"){console.error('The factory function of "'+w.moduleId+'" has thrown an exception'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=y),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(q.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const w=t(new Error("INVALID cached data configuration, 'path' MUST be set"));w.phase="configuration",u.onError(w),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,y=null){let w=q.Utilities.recursiveClone(y||{});return q.Utilities.forEachProperty(u,(l,h)=>{l==="ignoreDuplicateModules"&&typeof w.ignoreDuplicateModules<"u"?w.ignoreDuplicateModules=w.ignoreDuplicateModules.concat(h):l==="paths"&&typeof w.paths<"u"?q.Utilities.forEachProperty(h,(N,M)=>w.paths[N]=M):l==="config"&&typeof w.config<"u"?q.Utilities.forEachProperty(h,(N,M)=>w.config[N]=M):w[l]=q.Utilities.recursiveClone(h)}),F.validateConfigurationOptions(w)}}q.ConfigurationOptionsUtil=F;class S{constructor(u,y){if(this._env=u,this.options=F.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let w=this.options.nodeRequire.main.filename,l=Math.max(w.lastIndexOf("/"),w.lastIndexOf("\\"));this.options.baseUrl=w.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(u,y)=>{Array.isArray(y)?this.sortedPathsRules.push({from:u,to:y}):this.sortedPathsRules.push({from:u,to:[y]})}),this.sortedPathsRules.sort((u,y)=>y.from.length-u.from.length)}cloneAndMerge(u){return new S(this._env,F.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let y;for(let w=0,l=this.sortedPathsRules.length;w<l;w++)if(y=this.sortedPathsRules[w],q.Utilities.startsWith(u,y.from)){let h=[];for(let N=0,M=y.to.length;N<M;N++)h.push(y.to[N]+u.substr(y.from.length));return h}return[u]}_addUrlArgsToUrl(u){return q.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let y=0,w=u.length;y<w;y++)u[y]=this._addUrlArgsToUrl(u[y]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let y=u,w;if(!q.Utilities.endsWith(y,".js")&&!q.Utilities.isAbsolutePath(y)){w=this._applyPaths(y);for(let l=0,h=w.length;l<h;l++)this.isBuild()&&w[l]==="empty:"||(q.Utilities.isAbsolutePath(w[l])||(w[l]=this.options.baseUrl+w[l]),!q.Utilities.endsWith(w[l],".js")&&!q.Utilities.containsQueryString(w[l])&&(w[l]=w[l]+".js"))}else!q.Utilities.endsWith(y,".js")&&!q.Utilities.containsQueryString(y)&&(y=y+".js"),w=[y];return this._addUrlArgsIfNecessaryToUrls(w)}requireToUrl(u){let y=u;return q.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],q.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}q.Configuration=S})(he||(he={}));var he;(function(q){class t{constructor(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}load(h,N,M,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=h.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new F;let m={callback:M,errorback:b};if(this._callbackMap.hasOwnProperty(N)){this._callbackMap[N].push(m);return}this._callbackMap[N]=[m],this._scriptLoader.load(h,N,()=>this.triggerCallback(N),e=>this.triggerErrorback(N,e))}triggerCallback(h){let N=this._callbackMap[h];delete this._callbackMap[h];for(let M=0;M<N.length;M++)N[M].callback()}triggerErrorback(h,N){let M=this._callbackMap[h];delete this._callbackMap[h];for(let b=0;b<M.length;b++)M[b].errorback(N)}}class F{attachListeners(h,N,M){let b=()=>{h.removeEventListener("load",m),h.removeEventListener("error",e)},m=E=>{b(),N()},e=E=>{b(),M(E)};h.addEventListener("load",m),h.addEventListener("error",e)}load(h,N,M,b){if(/^node\|/.test(N)){let m=h.getConfig().getOptionsLiteral(),e=y(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),E=N.split("|"),D=null;try{D=e(E[1])}catch(_){b(_);return}h.enqueueDefineAnonymousModule([],()=>D),M()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,M,b);const{trustedTypesPolicy:e}=h.getConfig().getOptionsLiteral();e&&(N=e.createScriptURL(N)),m.setAttribute("src",N);const{cspNonce:E}=h.getConfig().getOptionsLiteral();E&&m.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(m)}}}function S(l){const{trustedTypesPolicy:h}=l.getConfig().getOptionsLiteral();try{return(h?self.eval(h.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=S(h)),this._cachedCanUseEval}load(h,N,M,b){if(/^node\|/.test(N)){const m=h.getConfig().getOptionsLiteral(),e=y(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),E=N.split("|");let D=null;try{D=e(E[1])}catch(_){b(_);return}h.enqueueDefineAnonymousModule([],function(){return D}),M()}else{const{trustedTypesPolicy:m}=h.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(N)&&N.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(h)){fetch(N).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${N}`,(m?self.eval(m.createScript("",E)):new Function(E)).call(self),M()}).then(void 0,b);return}try{m&&(N=m.createScriptURL(N)),importScripts(N),M()}catch(E){b(E)}}}}class u{constructor(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))}_initNodeRequire(h,N){const{nodeCachedData:M}=N.getConfig().getOptionsLiteral();if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=h("module");function e(E){const D=E.constructor;let _=function(d){try{return E.require(d)}finally{}};return _.resolve=function(d,p){return D._resolveFilename(d,E,!1,p)},_.resolve.paths=function(d){return D._resolveLookupPaths(d,E)},_.main=process.mainModule,_.extensions=D._extensions,_.cache=D._cache,_}m.prototype._compile=function(E,D){const _=m.wrap(E.replace(/^#!.*/,"")),L=N.getRecorder(),d=b._getCachedDataPath(M,D),p={filename:D};let A;try{const o=b._fs.readFileSync(d);A=o.slice(0,16),p.cachedData=o.slice(16),L.record(60,d)}catch{L.record(61,d)}const r=new b._vm.Script(_,p),s=r.runInThisContext(p),c=b._path.dirname(D),a=e(this),v=[this.exports,a,this,D,c,process,Be,Buffer],f=s.apply(this.exports,v);return b._handleCachedData(r,_,d,!p.cachedData,N),b._verifyCachedData(r,_,d,A,N),f}}load(h,N,M,b){const m=h.getConfig().getOptionsLiteral(),e=y(h.getRecorder(),m.nodeRequire||q.global.nodeRequire),E=m.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,h);let D=h.getRecorder();if(/^node\|/.test(N)){let _=N.split("|"),L=null;try{L=e(_[1])}catch(d){b(d);return}h.enqueueDefineAnonymousModule([],()=>L),M()}else{N=q.Utilities.fileUriToFilePath(this._env.isWindows,N);const _=this._path.normalize(N),L=this._getElectronRendererScriptPathOrUri(_),d=Boolean(m.nodeCachedData),p=d?this._getCachedDataPath(m.nodeCachedData,N):void 0;this._readSourceAndCachedData(_,p,D,(A,r,s,c)=>{if(A){b(A);return}let a;r.charCodeAt(0)===u._BOM?a=u._PREFIX+r.substring(1)+u._SUFFIX:a=u._PREFIX+r+u._SUFFIX,a=E(a,_);const v={filename:L,cachedData:s},f=this._createAndEvalScript(h,a,v,M,b);this._handleCachedData(f,a,p,d&&!s,h),this._verifyCachedData(f,a,p,c,h)})}}_createAndEvalScript(h,N,M,b,m){const e=h.getRecorder();e.record(31,M.filename);const E=new this._vm.Script(N,M),D=E.runInThisContext(M),_=h.getGlobalAMDDefineFunc();let L=!1;const d=function(){return L=!0,_.apply(null,arguments)};return d.amd=_.amd,D.call(q.global,h.getGlobalAMDRequireFunc(),d,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),L?b():m(new Error(`Didn't receive define call in ${M.filename}!`)),E}_getElectronRendererScriptPathOrUri(h){if(!this._env.isElectronRenderer)return h;let N=h.match(/^([a-z])\:(.*)/i);return N?`file:///${(N[1].toUpperCase()+":"+N[2]).replace(/\\/g,"/")}`:`file://${h}`}_getCachedDataPath(h,N){const M=this._crypto.createHash("md5").update(N,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(N).replace(/\.js$/,"");return this._path.join(h.path,`${b}-${M}.code`)}_handleCachedData(h,N,M,b,m){h.cachedDataRejected?this._fs.unlink(M,e=>{m.getRecorder().record(62,M),this._createAndWriteCachedData(h,N,M,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(h,N,M,m)}_createAndWriteCachedData(h,N,M,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,D;const _=()=>{setTimeout(()=>{D||(D=this._crypto.createHash("md5").update(N,"utf8").digest());const L=h.createCachedData();if(!(L.length===0||L.length===e||E>=5)){if(L.length<e){_();return}e=L.length,this._fs.writeFile(M,Buffer.concat([D,L]),d=>{d&&b.getConfig().onError(d),b.getRecorder().record(63,M),_()})}},m*Math.pow(4,E++))};_()}_readSourceAndCachedData(h,N,M,b){if(!N)this._fs.readFile(h,{encoding:"utf8"},b);else{let m,e,E,D=2;const _=L=>{L?b(L):--D===0&&b(void 0,m,e,E)};this._fs.readFile(h,{encoding:"utf8"},(L,d)=>{m=d,_(L)}),this._fs.readFile(N,(L,d)=>{!L&&d&&d.length>0?(E=d.slice(0,16),e=d.slice(16),M.record(60,N)):M.record(61,N),_()})}}_verifyCachedData(h,N,M,b,m){!b||h.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(N,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${M}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(M,E=>{E&&m.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random())))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function y(l,h){if(h.__$__isRecorded)return h;const N=function(b){l.record(33,b);try{return h(b)}finally{l.record(34,b)}};return N.__$__isRecorded=!0,N}q.ensureRecordedNodeRequire=y;function w(l){return new t(l)}q.createScriptLoader=w})(he||(he={}));var he;(function(q){class t{constructor(l){let h=l.lastIndexOf("/");h!==-1?this.fromModulePath=l.substr(0,h+1):this.fromModulePath=""}static _normalizeModuleId(l){let h=l,N;for(N=/\/\.\//;N.test(h);)h=h.replace(N,"/");for(h=h.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(h);)h=h.replace(N,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h}resolveModule(l){let h=l;return q.Utilities.isAbsolutePath(h)||(q.Utilities.startsWith(h,"./")||q.Utilities.startsWith(h,"../"))&&(h=t._normalizeModuleId(this.fromModulePath+h)),h}}t.ROOT=new t(""),q.ModuleIdResolver=t;class F{constructor(l,h,N,M,b,m){this.id=l,this.strId=h,this.dependencies=N,this._callback=M,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,h){try{return{returnedValue:l.apply(q.global,h),producedError:null}}catch(N){return{returnedValue:null,producedError:N}}}static _invokeFactory(l,h,N,M){return l.shouldInvokeFactory(h)?l.shouldCatchError()?this._safeInvokeFunction(N,M):{returnedValue:N.apply(q.global,M),producedError:null}:{returnedValue:null,producedError:null}}complete(l,h,N,M){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=F._invokeFactory(h,this.strId,this._callback,N);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=q.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=M(this.id),this.error=m,h.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}q.Module=F;class S{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let h=this._strModuleIdToIntModuleId.get(l);return typeof h>"u"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(l,h),this._intModuleIdToStrModuleId[h]=l),h}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class i{constructor(l){this.id=l}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),q.RegularDependency=i;class u{constructor(l,h,N){this.id=l,this.pluginId=h,this.pluginParam=N}}q.PluginDependency=u;class y{constructor(l,h,N,M,b=0){this._env=l,this._scriptLoader=h,this._loaderAvailableTimestamp=b,this._defineFunc=N,this._requireFunc=M,this._moduleIdProvider=new S,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new y(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,h){let N=m=>m.replace(/\\/g,"/"),M=N(l),b=h.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],D=e[2],_=e[3],L=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(L),E=N(E),E===M){let d={line:parseInt(D,10),col:parseInt(_,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],h=0;for(let N=0,M=this._modules2.length;N<M;N++){let b=this._modules2[N];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];l[h++]={id:b.strId,path:m,defineLocation:m&&e?y._findRelevantLocationInStack(m,e):null,dependencies:E,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let N=null;this._config.isBuild()&&(N=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:N,dependencies:l,callback:h}}defineModule(l,h,N,M,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let E=new F(e,l,this._normalizeDependencies(h,m),N,M,m);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(D=>this._moduleIdProvider.getStrModuleId(D.id))),this._resolve(E)}_normalizeDependency(l,h){if(l==="exports")return i.EXPORTS;if(l==="module")return i.MODULE;if(l==="require")return i.REQUIRE;let N=l.indexOf("!");if(N>=0){let M=h.resolveModule(l.substr(0,N)),b=h.resolveModule(l.substr(N+1)),m=this._moduleIdProvider.getModuleId(M+"!"+b),e=this._moduleIdProvider.getModuleId(M);return new u(m,e,b)}return new i(this._moduleIdProvider.getModuleId(h.resolveModule(l)))}_normalizeDependencies(l,h){let N=[],M=0;for(let b=0,m=l.length;b<m;b++)N[M++]=this._normalizeDependency(l[b],h);return N}_relativeRequire(l,h,N,M){if(typeof h=="string")return this.synchronousRequire(h,l);this.defineModule(q.Utilities.generateAnonymousModule(),h,N,M,null,l)}synchronousRequire(l,h=new t(l)){let N=this._normalizeDependency(l,h),M=this._modules2[N.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports}configure(l,h){let N=this._config.shouldRecordStats();h?this._config=new q.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!N&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),h.dependencies,h.callback,null,h.stack)}}_createLoadError(l,h){let N=this._moduleIdProvider.getStrModuleId(l),M=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=q.ensureError(h);return b.phase="loading",b.moduleId=N,b.neededBy=M,b}_onLoadError(l,h){const N=this._createLoadError(l,h);this._modules2[l]||(this._modules2[l]=new F(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let M=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)M[e]=!1;let b=!1,m=[];for(m.push(l),M[l]=!0;m.length>0;){let e=m.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(N)||b);let D=this._inverseDependencies2[e];if(D)for(let _=0,L=D.length;_<L;_++){let d=D[_];M[d]||(m.push(d),M[d]=!0)}}b||this._config.onError(N)}_hasDependencyPath(l,h){let N=this._modules2[l];if(!N)return!1;let M=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)M[m]=!1;let b=[];for(b.push(N),M[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,D=e.length;E<D;E++){let _=e[E];if(_.id===h)return!0;let L=this._modules2[_.id];L&&!M[_.id]&&(M[_.id]=!0,b.push(L))}}return!1}_findCyclePath(l,h,N){if(l===h||N===50)return[l];let M=this._modules2[l];if(!M)return null;let b=M.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let E=this._findCyclePath(b[m].id,h,N+1);if(E!==null)return E.push(l),E}return null}_createRequire(l){let h=(N,M,b)=>this._relativeRequire(l,N,M,b);return h.toUrl=N=>this._config.requireToUrl(l.resolveModule(N)),h.getStats=()=>this.getLoaderEvents(),h.hasDependencyCycle=()=>this._hasDependencyCycle,h.config=(N,M=!1)=>{this.configure(N,M)},h.__$__nodeRequire=q.global.nodeRequire,h}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let h=this._moduleIdProvider.getStrModuleId(l),N=this._config.moduleIdToPaths(h),M=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(h.indexOf("/")===-1||M.test(h))&&N.push("node|"+h);let b=-1,m=e=>{if(b++,b>=N.length)this._onLoadError(l,e);else{let E=N[b],D=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[l]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}D.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=E),D.record(11,E),this._onLoad(l)},_=>{D.record(12,E),m(_)})}};m(null)}_loadPluginDependency(l,h){if(this._modules2[h.id]||this._knownModules2[h.id])return;this._knownModules2[h.id]=!0;let N=M=>{this.defineModule(this._moduleIdProvider.getStrModuleId(h.id),[],M,null,null)};N.error=M=>{this._config.onError(this._createLoadError(h.id,M))},l.load(h.pluginParam,this._createRequire(t.ROOT),N,this._config.getOptionsLiteral())}_resolve(l){let h=l.dependencies;if(h)for(let N=0,M=h.length;N<M;N++){let b=h[N];if(b===i.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===i.MODULE){l.unresolvedDependenciesCount--;continue}if(b===i.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof u){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let h=this.getRecorder();if(l.isComplete())return;let N=l.dependencies,M=[];if(N)for(let E=0,D=N.length;E<D;E++){let _=N[E];if(_===i.EXPORTS){M[E]=l.exports;continue}if(_===i.MODULE){M[E]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(_===i.REQUIRE){M[E]=this._createRequire(l.moduleIdResolver);continue}let L=this._modules2[_.id];if(L){M[E]=L.exports;continue}M[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(D=>this._moduleIdProvider.getStrModuleId(D));l.complete(h,this._config,M,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let E=0,D=m.length;E<D;E++){let _=m[E],L=this._modules2[_];L.unresolvedDependenciesCount--,L.unresolvedDependenciesCount===0&&this._onModuleComplete(L)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let E=0,D=e.length;E<D;E++)this._loadPluginDependency(l.exports,e[E])}}}q.ModuleManager=y})(he||(he={}));var Z,he;(function(q){const t=new q.Environment;let F=null;const S=function(w,l,h){typeof w!="string"&&(h=l,l=w,w=null),(typeof l!="object"||!Array.isArray(l))&&(h=l,l=null),l||(l=["require","exports","module"]),w?F.defineModule(w,l,h,null,null):F.enqueueDefineAnonymousModule(l,h)};S.amd={jQuery:!0};const i=function(w,l=!1){F.configure(w,l)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return F.getConfig().getOptionsLiteral()},u.reset=function(){F=F.reset()},u.getBuildInfo=function(){return F.getBuildInfo()},u.getStats=function(){return F.getLoaderEvents()},u.define=S;function y(){if(typeof q.global.require<"u"||typeof require<"u"){const w=q.global.require||require;if(typeof w=="function"&&typeof w.resolve=="function"){const l=q.ensureRecordedNodeRequire(F.getRecorder(),w);q.global.nodeRequire=l,u.nodeRequire=l,u.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(q.global.define=S),q.global.require=u)}q.init=y,(typeof q.global.define!="function"||!q.global.define.amd)&&(F=new q.ModuleManager(t,q.createScriptLoader(t),S,u,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&u.config(q.global.require),Z=function(){return S.apply(null,arguments)},Z.amd=S.amd,typeof doNotInitLoader>"u"&&y())})(he||(he={})),Z(ee[54],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(w,l,h,N){if(N=N||{},(N["vs/css"]||{}).disabled){h({});return}const b=l.toUrl(w+".css");S(w,b,()=>{h({})},m=>{typeof h.error=="function"&&h.error("Could not find "+b+".")})}t.load=F;function S(w,l,h,N){if(i(w,l)){h();return}u(w,l,h,N)}function i(w,l){const h=document.getElementsByTagName("link");for(let N=0,M=h.length;N<M;N++){const b=h[N].getAttribute("data-name"),m=h[N].getAttribute("href");if(b===w||m===l)return!0}return!1}function u(w,l,h,N){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",w),y(w,M,h,N),M.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function y(w,l,h,N){const M=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{M(),h()},m=e=>{M(),N(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),Z("vs/nls",["require","exports"],function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const S="i-default";function i(e,E){let D;return E.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(_,L)=>{const d=L[0],p=E[d];let A=_;return typeof p=="string"?A=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(A=String(p)),A}),F&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function u(e,E){let D=e[E];return D||(D=e["*"],D)?D:null}function y(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function w(e,E,D){const _=y(e)+y(E)+"vscode/"+y(D),L=await fetch(_);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function l(e){return function(E,D){const _=Array.prototype.slice.call(arguments,2);return i(e[E],_)}}function h(e,E,...D){return i(E,D)}t.localize=h;function N(e){}t.getConfiguredDefaultLocale=N;function M(e){F=e}t.setPseudoTranslation=M;function b(e,E){return{localize:l(E[e]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??(D=>{})}}t.create=b;function m(e,E,D,_){const L=_["vs/nls"]??{};if(!e||e.length===0)return D({localize:h,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const d=L.availableLanguages?u(L.availableLanguages,e):null,p=d===null||d===S;let A=".nls";p||(A=A+"."+d);const r=s=>{Array.isArray(s)?s.localize=l(s):s.localize=l(s[e]),s.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],D(s)};typeof L.loadBundle=="function"?L.loadBundle(e,d,(s,c)=>{s?E([e+".nls"],r):r(c)}):L.translationServiceUrl&&!p?(async()=>{try{const s=await w(L.translationServiceUrl,d,e);return r(s)}catch(s){if(!d.includes("-"))return console.error(s),E([e+".nls"],r);try{const c=d.split("-")[0],a=await w(L.translationServiceUrl,c,e);return L.availableLanguages??={},L.availableLanguages["*"]=c,r(a)}catch(c){return console.error(c),E([e+".nls"],r)}}})():E([e+A],r,s=>{if(A===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${d}. Falling back to the default language:`,s),E([e+".nls"],r)})}t.load=m}),function(){const q=globalThis.MonacoEnvironment,t=q&&q.baseUrl?q.baseUrl:"../../../",F=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:h=>h,createScript:(h,...N)=>{const M=N.slice(0,-1).join(","),b=N.pop().toString();return`(function anonymous(${M}) { ${b}
})`}}):void 0;function S(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((h,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const M=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(M)&&M.substring(0,globalThis.origin.length)!==globalThis.origin)&&S()){fetch(M).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${M}`,(F?globalThis.eval(F.createScript("",m)):new Function(m)).call(globalThis),h()}).then(void 0,N);return}F?importScripts(F.createScriptURL(M)):importScripts(M),h()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function y(h){i().then(()=>{u(),require([h],function(N){setTimeout(function(){const M=N.create((b,m)=>{globalThis.postMessage(b,m)},null);for(globalThis.onmessage=b=>M.onmessage(b.data,b.ports);l.length>0;){const b=l.shift();M.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&u();let w=!0;const l=[];globalThis.onmessage=h=>{if(!w){l.push(h);return}w=!1,y(h.data)}}(),Z(ee[26],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class F{constructor(i,u,y,w){this.originalStart=i,this.originalLength=u,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=F}),Z(ee[5],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class F{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?p.isErrorNoTelemetry(s)?new p(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(c=>{c(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.ErrorHandler=F,t.errorHandler=new F;function S(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=S;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){h(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function y(r){h(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=y;function w(r){if(r instanceof Error){const{name:s,message:c}=r,a=r.stacktrace||r.stack;return{$isError:!0,name:s,message:c,stack:a,noTelemetry:p.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=w;const l="Canceled";function h(r){return r instanceof N?!0:r instanceof Error&&r.name===l&&r.message===l}t.isCancellationError=h;class N extends Error{constructor(){super(l),this.name=this.message}}t.CancellationError=N;function M(){const r=new Error(l);return r.name=r.message,r}t.canceled=M;function b(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=b;function m(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=m;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function E(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=E;function D(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=D;class _ extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=_;class L extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=L;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=d;class p extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof p)return s;const c=new p;return c.message=s.message,c.stack=s.stack,c}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=p;class A extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype);debugger}}t.BugIndicatingError=A}),Z(ee[27],te([0,1,5]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function S(T,I=0){return T[T.length-(1+I)]}t.tail=S;function i(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=i;function u(T,I,U=(W,z)=>W===z){if(T===I)return!0;if(!T||!I||T.length!==I.length)return!1;for(let W=0,z=T.length;W<z;W++)if(!U(T[W],I[W]))return!1;return!0}t.equals=u;function y(T,I){const U=T.length-1;I<U&&(T[I]=T[U]),T.pop()}t.removeFastWithoutKeepingOrder=y;function w(T,I,U){return l(T.length,W=>U(T[W],I))}t.binarySearch=w;function l(T,I){let U=0,W=T-1;for(;U<=W;){const z=(U+W)/2|0,re=I(z);if(re<0)U=z+1;else if(re>0)W=z-1;else return z}return-(U+1)}t.binarySearch2=l;function h(T,I){let U=0,W=T.length;if(W===0)return 0;for(;U<W;){const z=Math.floor((U+W)/2);I(T[z])?W=z:U=z+1}return U}t.findFirstInSorted=h;function N(T,I,U){if(T=T|0,T>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],z=[],re=[],se=[];for(const oe of I){const ce=U(oe,W);ce<0?z.push(oe):ce>0?re.push(oe):se.push(oe)}return T<z.length?N(T,z,U):T<z.length+se.length?se[0]:N(T-(z.length+se.length),re,U)}t.quickSelect=N;function M(T,I){const U=[];let W;for(const z of T.slice(0).sort(I))!W||I(W[0],z)!==0?(W=[z],U.push(W)):W.push(z);return U}t.groupBy=M;function b(T,I,U){const W=[];function z(oe,ce,ge){if(ce===0&&ge.length===0)return;const me=W[W.length-1];me&&me.start+me.deleteCount===oe?(me.deleteCount+=ce,me.toInsert.push(...ge)):W.push({start:oe,deleteCount:ce,toInsert:ge})}let re=0,se=0;for(;;){if(re===T.length){z(re,0,I.slice(se));break}if(se===I.length){z(re,T.length-re,[]);break}const oe=T[re],ce=I[se],ge=U(oe,ce);ge===0?(re+=1,se+=1):ge<0?(z(re,1,[]),re+=1):ge>0&&(z(re,0,[ce]),se+=1)}return W}t.sortedDiff=b;function m(T,I,U){const W=b(T,I,U),z=[],re=[];for(const se of W)z.push(...T.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:z,added:re}}t.delta=m;function e(T,I,U){if(U===0)return[];const W=T.slice(0,U).sort(I);return D(T,I,W,U,T.length),W}t.top=e;function E(T,I,U,W,z){return U===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const oe=T.length,ce=T.slice(0,U).sort(I);for(let ge=U,me=Math.min(U+W,oe);ge<oe;ge=me,me=Math.min(me+W,oe)){if(ge>U&&await new Promise(ke=>setTimeout(ke)),z&&z.isCancellationRequested)throw new F.CancellationError;D(T,I,ce,ge,me)}return ce})().then(re,se)})}t.topAsync=E;function D(T,I,U,W,z){for(const re=U.length;W<z;W++){const se=T[W];if(I(se,U[re-1])<0){U.pop();const oe=h(U,ce=>I(se,ce)<0);U.splice(oe,0,se)}}}function _(T){return T.filter(I=>!!I)}t.coalesce=_;function L(T){let I=0;for(let U=0;U<T.length;U++)T[U]&&(T[I]=T[U],I+=1);T.length=I}t.coalesceInPlace=L;function d(T,I,U){T.splice(U,0,T.splice(I,1)[0])}t.move=d;function p(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=p;function A(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=A;function r(T,I=U=>U){const U=new Set;return T.filter(W=>{const z=I(W);return U.has(z)?!1:(U.add(z),!0)})}t.distinct=r;function s(T){const I=new Set;return U=>{const W=T(U);return I.has(W)?!1:(I.add(W),!0)}}t.uniqueFilter=s;function c(T,I){const U=a(T,I);if(U!==-1)return T[U]}t.findLast=c;function a(T,I){for(let U=T.length-1;U>=0;U--){const W=T[U];if(I(W))return U}return-1}t.lastIndex=a;function v(T,I){return T.length>0?T[0]:I}t.firstOrDefault=v;function f(T,I){return T.length>0?T[T.length-1]:I}t.lastOrDefault=f;function o(T,I,U=(W,z)=>W===z){let W=0;for(let z=0,re=Math.min(T.length,I.length);z<re&&U(T[z],I[z]);z++)W++;return W}t.commonPrefixLength=o;function R(T){return[].concat(...T)}t.flatten=R;function g(T,I){let U=typeof I=="number"?T:0;typeof I=="number"?U=T:(U=0,I=T);const W=[];if(U<=I)for(let z=U;z<I;z++)W.push(z);else for(let z=U;z>I;z--)W.push(z);return W}t.range=g;function k(T,I,U){return T.reduce((W,z)=>(W[I(z)]=U?U(z):z,W),Object.create(null))}t.index=k;function O(T,I){return T.push(I),()=>C(T,I)}t.insert=O;function C(T,I){const U=T.indexOf(I);if(U>-1)return T.splice(U,1),I}t.remove=C;function V(T,I,U){const W=T.slice(0,I),z=T.slice(I);return W.concat(U,z)}t.arrayInsert=V;function H(T,I){let U;if(typeof I=="number"){let W=I;U=()=>{const z=Math.sin(W++)*179426549;return z-Math.floor(z)}}else U=Math.random;for(let W=T.length-1;W>0;W-=1){const z=Math.floor(U()*(W+1)),re=T[W];T[W]=T[z],T[z]=re}}t.shuffle=H;function $(T,I){const U=T.indexOf(I);U>-1&&(T.splice(U,1),T.unshift(I))}t.pushToStart=$;function K(T,I){const U=T.indexOf(I);U>-1&&(T.splice(U,1),T.push(I))}t.pushToEnd=K;function X(T,I){for(const U of I)T.push(U)}t.pushMany=X;function G(T,I){return Array.isArray(T)?T.map(I):I(T)}t.mapArrayOrNot=G;function n(T){return Array.isArray(T)?T:[T]}t.asArray=n;function ue(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=ue;function ae(T,I){for(const U of T){const W=I(U);if(W!==void 0)return W}}t.mapFind=ae;function ie(T,I,U){const W=Le(T,I),z=T.length,re=U.length;T.length=z+re;for(let se=z-1;se>=W;se--)T[se+re]=T[se];for(let se=0;se<re;se++)T[se+W]=U[se]}t.insertInto=ie;function be(T,I,U,W){const z=Le(T,I),re=T.splice(z,U);return ie(T,z,W),re}t.splice=be;function Le(T,I){return I<0?Math.max(I+T.length,0):Math.min(I,T.length)}var we;(function(T){function I(z){return z<0}T.isLessThan=I;function U(z){return z>0}T.isGreaterThan=U;function W(z){return z===0}T.isNeitherLessOrGreaterThan=W,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(we=t.CompareResult||(t.CompareResult={}));function Ne(T,I){return(U,W)=>I(T(U),T(W))}t.compareBy=Ne;function Ae(...T){return(I,U)=>{for(const W of T){const z=W(I,U);if(!we.isNeitherLessOrGreaterThan(z))return z}return we.neitherLessOrGreaterThan}}t.tieBreakComparators=Ae;const Me=(T,I)=>T-I;t.numberComparator=Me;function pe(T,I){if(T.length===0)return;let U=T[0];for(let W=1;W<T.length;W++){const z=T[W];I(z,U)>0&&(U=z)}return U}t.findMaxBy=pe;function Pe(T,I){if(T.length===0)return;let U=T[0];for(let W=1;W<T.length;W++){const z=T[W];I(z,U)>=0&&(U=z)}return U}t.findLastMaxBy=Pe;function ne(T,I){return pe(T,(U,W)=>-I(U,W))}t.findMinBy=ne;class Y{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let U=this.c;for(;U<this.f.length&&I(this.f[U]);)U++;const W=U===this.c?null:this.f.slice(this.c,U);return this.c=U,W}takeFromEndWhile(I){let U=this.d;for(;U>=0&&I(this.f[U]);)U--;const W=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const U=this.f.slice(this.c,this.c+I);return this.c+=I,U}}t.ArrayQueue=Y;class J{constructor(I){this.iterate=I}forEach(I){this.iterate(U=>(I(U),!0))}toArray(){const I=[];return this.iterate(U=>(I.push(U),!0)),I}filter(I){return new J(U=>this.iterate(W=>I(W)?U(W):!0))}map(I){return new J(U=>this.iterate(W=>U(I(W))))}some(I){let U=!1;return this.iterate(W=>(U=I(W),!U)),U}findFirst(I){let U;return this.iterate(W=>I(W)?(U=W,!1):!0),U}findLast(I){let U;return this.iterate(W=>(I(W)&&(U=W),!0)),U}findLastMaxBy(I){let U,W=!0;return this.iterate(z=>((W||we.isGreaterThan(I(z,U)))&&(W=!1,U=z),!0)),U}}J.empty=new J(T=>{}),t.CallbackIterable=J}),Z(ee[10],te([0,1,5]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function S(l,h){if(!l)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=S;function i(l,h="Unreachable"){throw new Error(h)}t.assertNever=i;function u(l){if(!l)throw new F.BugIndicatingError("Assertion Failed")}t.assert=u;function y(l){if(!l()){debugger;l(),(0,F.onUnexpectedError)(new F.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function w(l,h){let N=0;for(;N<l.length-1;){const M=l[N],b=l[N+1];if(!h(M,b))return!1;N++}return!0}t.checkAdjacentItems=w}),Z(ee[14],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function F(S){const i=this;let u=!1,y;return function(){return u||(u=!0,y=S.apply(i,arguments)),y}}t.once=F}),Z(ee[15],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(S){function i(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}S.is=i;const u=Object.freeze([]);function y(){return u}S.empty=y;function*w(p){yield p}S.single=w;function l(p){return i(p)?p:w(p)}S.wrap=l;function h(p){return p||u}S.from=h;function N(p){return!p||p[Symbol.iterator]().next().done===!0}S.isEmpty=N;function M(p){return p[Symbol.iterator]().next().value}S.first=M;function b(p,A){for(const r of p)if(A(r))return!0;return!1}S.some=b;function m(p,A){for(const r of p)if(A(r))return r}S.find=m;function*e(p,A){for(const r of p)A(r)&&(yield r)}S.filter=e;function*E(p,A){let r=0;for(const s of p)yield A(s,r++)}S.map=E;function*D(...p){for(const A of p)for(const r of A)yield r}S.concat=D;function _(p,A,r){let s=r;for(const c of p)s=A(s,c);return s}S.reduce=_;function*L(p,A,r=p.length){for(A<0&&(A+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);A<r;A++)yield p[A]}S.slice=L;function d(p,A=Number.POSITIVE_INFINITY){const r=[];if(A===0)return[r,p];const s=p[Symbol.iterator]();for(let c=0;c<A;c++){const a=s.next();if(a.done)return[r,S.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return s}}]}S.consume=d})(F=t.Iterable||(t.Iterable={}))}),Z(ee[28],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(F=t.KeyCode||(t.KeyCode={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,D){this._keyCodeToStr[E]=D,this._strToKeyCode[D.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const u=new i,y=new i,w=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],h=Object.create(null),N=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>N[e]||0,toEnum:e=>h[e]||0,toString:e=>l[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],_=[];for(const L of E){const[d,p,A,r,s,c,a,v,f,o]=L;if(_[A]||(_[A]=!0,l[A]=r,h[r]=A,N[r.toLowerCase()]=A,p&&(t.IMMUTABLE_CODE_TO_KEY_CODE[A]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=A))),!D[s]){if(D[s]=!0,!c)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,c),y.define(s,f||c),w.define(s,o||f||c)}a&&(t.EVENT_KEY_CODE_MAP[a]=s),v&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[v]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function E(A){return u.keyCodeToStr(A)}e.toString=E;function D(A){return u.strToKeyCode(A)}e.fromString=D;function _(A){return y.keyCodeToStr(A)}e.toUserSettingsUS=_;function L(A){return w.keyCodeToStr(A)}e.toUserSettingsGeneral=L;function d(A){return y.strToKeyCode(A)||w.strToKeyCode(A)}e.fromUserSettings=d;function p(A){if(A>=93&&A<=108)return null;switch(A){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(A)}e.toElectronAccelerator=p})(M=t.KeyCodeUtils||(t.KeyCodeUtils={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b=t.KeyMod||(t.KeyMod={}));function m(e,E){const D=(E&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=m}),Z(ee[29],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class F{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=F}),Z(ee[6],te([0,1,14,15]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function y(f){u=f}if(t.setDisposableTracker=y,i){const f="__is_disposable_tracked__";y(new class{trackDisposable(o){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[f]||console.log(R)},3e3)}setParent(o,R){if(o&&o!==L.None)try{o[f]=!0}catch{}}markAsDisposed(o){if(o&&o!==L.None)try{o[f]=!0}catch{}}markAsSingleton(o){}})}function w(f){return u?.trackDisposable(f),f}function l(f){u?.markAsDisposed(f)}function h(f,o){u?.setParent(f,o)}function N(f,o){if(!!u)for(const R of f)u.setParent(R,o)}function M(f){return u?.markAsSingleton(f),f}t.markAsSingleton=M;function b(f){return typeof f.dispose=="function"&&f.dispose.length===0}t.isDisposable=b;function m(f){if(S.Iterable.is(f)){const o=[];for(const R of f)if(R)try{R.dispose()}catch(g){o.push(g)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}t.dispose=m;function e(f){for(const o of f)b(o)&&o.dispose();return[]}t.disposeIfDisposable=e;function E(...f){const o=D(()=>m(f));return N(f,o),o}t.combinedDisposable=E;function D(f){const o=w({dispose:(0,F.once)(()=>{l(o),f()})});return o}t.toDisposable=D;class _{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(l(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return h(o,this),this.f?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}_.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=_;class L{constructor(){this.q=new _,w(this),h(this.q,this)}dispose(){l(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}L.None=Object.freeze({dispose(){}}),t.Disposable=L;class d{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&h(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&h(o,null),o}}t.MutableDisposable=d;class p{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=p;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(o){let R=o;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,l(this))},this}}t.SafeDisposable=A;class r{constructor(){this.a=new Map}acquire(o,...R){let g=this.a.get(o);g||(g={counter:0,object:this.b(o,...R)},this.a.set(o,g));const{object:k}=g,O=(0,F.once)(()=>{--g.counter===0&&(this.c(o,g.object),this.a.delete(o))});return g.counter++,{object:k,dispose:O}}}t.ReferenceCollection=r;class s{constructor(o){this.a=o}async acquire(o,...R){const g=this.a.acquire(o,...R);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(k){throw g.dispose(),k}}}t.AsyncReferenceCollection=s;class c{constructor(o){this.object=o}dispose(){}}t.ImmortalReference=c;function a(f){const o=new _;try{f(o)}finally{o.dispose()}}t.disposeOnReturn=a;class v{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,R,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(o)?.dispose(),this.a.set(o,R)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=v}),Z(ee[16],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class F{constructor(u){this.element=u,this.next=F.Undefined,this.prev=F.Undefined}}F.Undefined=new F(void 0);class S{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let u=this.a;for(;u!==F.Undefined;){const y=u.next;u.prev=F.Undefined,u.next=F.Undefined,u=y}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,y){const w=new F(u);if(this.a===F.Undefined)this.a=w,this.b=w;else if(y){const h=this.b;this.b=w,w.prev=h,h.next=w}else{const h=this.a;this.a=w,w.next=h,h.prev=w}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(w))}}shift(){if(this.a!==F.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==F.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==F.Undefined&&u.next!==F.Undefined){const y=u.prev;y.next=u.next,u.next.prev=y}else u.prev===F.Undefined&&u.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):u.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):u.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==F.Undefined;)yield u.element,u=u.next}}t.LinkedList=S}),Z(ee[7],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let F=!1,S=!1,i=!1,u=!1,y=!1,w=!1,l=!1,h=!1,N=!1,M=!1,b,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT,E,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?_=t.globals.vscode.process:typeof process<"u"&&(_=process);const L=typeof _?.versions?.electron=="string",d=L&&_?.type==="renderer";if(typeof navigator=="object"&&!d){D=navigator.userAgent,F=D.indexOf("Windows")>=0,S=D.indexOf("Macintosh")>=0,h=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=D.indexOf("Linux")>=0,M=D?.indexOf("Mobi")>=0,w=!0,b=t.LANGUAGE_DEFAULT,m=b,e=navigator.language;const o=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),R=o&&o.getAttribute("data-settings");if(R)try{const g=JSON.parse(R),k=g.availableLanguages["*"];b=g.locale,e=g.osLocale,m=k||t.LANGUAGE_DEFAULT,E=g._translationsConfigFile}catch{}}else if(typeof _=="object"){F=_.platform==="win32",S=_.platform==="darwin",i=_.platform==="linux",u=i&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,l=L,N=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.LANGUAGE_DEFAULT,m=t.LANGUAGE_DEFAULT;const o=_.env.VSCODE_NLS_CONFIG;if(o)try{const R=JSON.parse(o),g=R.availableLanguages["*"];b=R.locale,e=R.osLocale,m=g||t.LANGUAGE_DEFAULT,E=R._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var p;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(p=t.Platform||(t.Platform={}));function A(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=A;let r=0;S?r=1:F?r=3:i&&(r=2),t.isWindows=F,t.isMacintosh=S,t.isLinux=i,t.isLinuxSnap=u,t.isNative=y,t.isElectron=l,t.isWeb=w,t.isWebWorker=w&&typeof t.globals.importScripts=="function",t.isIOS=h,t.isMobile=M,t.isCI=N,t.platform=r,t.userAgent=D,t.language=m;var s;(function(o){function R(){return t.language}o.value=R;function g(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}o.isDefaultVariant=g;function k(){return t.language==="en"}o.isDefault=k})(s=t.Language||(t.Language={})),t.locale=b,t.platformLocale=e,t.translationsConfigFile=E,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const o=[];t.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let k=0,O=o.length;k<O;k++){const C=o[k];if(C.id===g.data.vscodeScheduleAsyncWork){o.splice(k,1),C.callback();return}}});let R=0;return g=>{const k=++R;o.push({id:k,callback:g}),t.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return o=>setTimeout(o)})();var c;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(c=t.OperatingSystem||(t.OperatingSystem={})),t.OS=S||h?2:F?1:3;let a=!0,v=!1;function f(){if(!v){v=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}t.isLittleEndian=f,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Z(ee[30],te([0,1,7]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let S;if(typeof F.globals.vscode<"u"&&typeof F.globals.vscode.process<"u"){const i=F.globals.vscode.process;S={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return F.isWindows?"win32":F.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.platform=S.platform,t.arch=S.arch}),Z(ee[31],te([0,1,30]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const S=65,i=97,u=90,y=122,w=46,l=47,h=92,N=58,M=63;class b extends Error{constructor(s,c,a){let v;typeof c=="string"&&c.indexOf("not ")===0?(v="must not be",c=c.replace(/^not /,"")):v="must be";const f=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${f} ${v} of type ${c}`;o+=`. Received type ${typeof a}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,s){if(r===null||typeof r!="object")throw new b(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new b(s,"string",r)}const E=F.platform==="win32";function D(r){return r===l||r===h}function _(r){return r===l}function L(r){return r>=S&&r<=u||r>=i&&r<=y}function d(r,s,c,a){let v="",f=0,o=-1,R=0,g=0;for(let k=0;k<=r.length;++k){if(k<r.length)g=r.charCodeAt(k);else{if(a(g))break;g=l}if(a(g)){if(!(o===k-1||R===1))if(R===2){if(v.length<2||f!==2||v.charCodeAt(v.length-1)!==w||v.charCodeAt(v.length-2)!==w){if(v.length>2){const O=v.lastIndexOf(c);O===-1?(v="",f=0):(v=v.slice(0,O),f=v.length-1-v.lastIndexOf(c)),o=k,R=0;continue}else if(v.length!==0){v="",f=0,o=k,R=0;continue}}s&&(v+=v.length>0?`${c}..`:"..",f=2)}else v.length>0?v+=`${c}${r.slice(o+1,k)}`:v=r.slice(o+1,k),f=k-o-1;o=k,R=0}else g===w&&R!==-1?++R:R=-1}return v}function p(r,s){m(s,"pathObject");const c=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return c?c===s.root?`${c}${a}`:`${c}${r}${a}`:a}t.win32={resolve(...r){let s="",c="",a=!1;for(let v=r.length-1;v>=-1;v--){let f;if(v>=0){if(f=r[v],e(f,"path"),f.length===0)continue}else s.length===0?f=F.cwd():(f=F.env[`=${s}`]||F.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==s.toLowerCase()&&f.charCodeAt(2)===h)&&(f=`${s}\\`));const o=f.length;let R=0,g="",k=!1;const O=f.charCodeAt(0);if(o===1)D(O)&&(R=1,k=!0);else if(D(O))if(k=!0,D(f.charCodeAt(1))){let C=2,V=C;for(;C<o&&!D(f.charCodeAt(C));)C++;if(C<o&&C!==V){const H=f.slice(V,C);for(V=C;C<o&&D(f.charCodeAt(C));)C++;if(C<o&&C!==V){for(V=C;C<o&&!D(f.charCodeAt(C));)C++;(C===o||C!==V)&&(g=`\\\\${H}\\${f.slice(V,C)}`,R=C)}}}else R=1;else L(O)&&f.charCodeAt(1)===N&&(g=f.slice(0,2),R=2,o>2&&D(f.charCodeAt(2))&&(k=!0,R=3));if(g.length>0)if(s.length>0){if(g.toLowerCase()!==s.toLowerCase())continue}else s=g;if(a){if(s.length>0)break}else if(c=`${f.slice(R)}\\${c}`,a=k,k&&s.length>0)break}return c=d(c,!a,"\\",D),a?`${s}\\${c}`:`${s}${c}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let c=0,a,v=!1;const f=r.charCodeAt(0);if(s===1)return _(f)?"\\":r;if(D(f))if(v=!0,D(r.charCodeAt(1))){let R=2,g=R;for(;R<s&&!D(r.charCodeAt(R));)R++;if(R<s&&R!==g){const k=r.slice(g,R);for(g=R;R<s&&D(r.charCodeAt(R));)R++;if(R<s&&R!==g){for(g=R;R<s&&!D(r.charCodeAt(R));)R++;if(R===s)return`\\\\${k}\\${r.slice(g)}\\`;R!==g&&(a=`\\\\${k}\\${r.slice(g,R)}`,c=R)}}}else c=1;else L(f)&&r.charCodeAt(1)===N&&(a=r.slice(0,2),c=2,s>2&&D(r.charCodeAt(2))&&(v=!0,c=3));let o=c<s?d(r.slice(c),!v,"\\",D):"";return o.length===0&&!v&&(o="."),o.length>0&&D(r.charCodeAt(s-1))&&(o+="\\"),a===void 0?v?`\\${o}`:o:v?`${a}\\${o}`:`${a}${o}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const c=r.charCodeAt(0);return D(c)||s>2&&L(c)&&r.charCodeAt(1)===N&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,c;for(let f=0;f<r.length;++f){const o=r[f];e(o,"path"),o.length>0&&(s===void 0?s=c=o:s+=`\\${o}`)}if(s===void 0)return".";let a=!0,v=0;if(typeof c=="string"&&D(c.charCodeAt(0))){++v;const f=c.length;f>1&&D(c.charCodeAt(1))&&(++v,f>2&&(D(c.charCodeAt(2))?++v:a=!1))}if(a){for(;v<s.length&&D(s.charCodeAt(v));)v++;v>=2&&(s=`\\${s.slice(v)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const c=t.win32.resolve(r),a=t.win32.resolve(s);if(c===a||(r=c.toLowerCase(),s=a.toLowerCase(),r===s))return"";let v=0;for(;v<r.length&&r.charCodeAt(v)===h;)v++;let f=r.length;for(;f-1>v&&r.charCodeAt(f-1)===h;)f--;const o=f-v;let R=0;for(;R<s.length&&s.charCodeAt(R)===h;)R++;let g=s.length;for(;g-1>R&&s.charCodeAt(g-1)===h;)g--;const k=g-R,O=o<k?o:k;let C=-1,V=0;for(;V<O;V++){const $=r.charCodeAt(v+V);if($!==s.charCodeAt(R+V))break;$===h&&(C=V)}if(V!==O){if(C===-1)return a}else{if(k>O){if(s.charCodeAt(R+V)===h)return a.slice(R+V+1);if(V===2)return a.slice(R+V)}o>O&&(r.charCodeAt(v+V)===h?C=V:V===2&&(C=3)),C===-1&&(C=0)}let H="";for(V=v+C+1;V<=f;++V)(V===f||r.charCodeAt(V)===h)&&(H+=H.length===0?"..":"\\..");return R+=C,H.length>0?`${H}${a.slice(R,g)}`:(a.charCodeAt(R)===h&&++R,a.slice(R,g))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===h){if(s.charCodeAt(1)===h){const c=s.charCodeAt(2);if(c!==M&&c!==w)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===h)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let c=-1,a=0;const v=r.charCodeAt(0);if(s===1)return D(v)?r:".";if(D(v)){if(c=a=1,D(r.charCodeAt(1))){let R=2,g=R;for(;R<s&&!D(r.charCodeAt(R));)R++;if(R<s&&R!==g){for(g=R;R<s&&D(r.charCodeAt(R));)R++;if(R<s&&R!==g){for(g=R;R<s&&!D(r.charCodeAt(R));)R++;if(R===s)return r;R!==g&&(c=a=R+1)}}}}else L(v)&&r.charCodeAt(1)===N&&(c=s>2&&D(r.charCodeAt(2))?3:2,a=c);let f=-1,o=!0;for(let R=s-1;R>=a;--R)if(D(r.charCodeAt(R))){if(!o){f=R;break}}else o=!1;if(f===-1){if(c===-1)return".";f=c}return r.slice(0,f)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let c=0,a=-1,v=!0,f;if(r.length>=2&&L(r.charCodeAt(0))&&r.charCodeAt(1)===N&&(c=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let o=s.length-1,R=-1;for(f=r.length-1;f>=c;--f){const g=r.charCodeAt(f);if(D(g)){if(!v){c=f+1;break}}else R===-1&&(v=!1,R=f+1),o>=0&&(g===s.charCodeAt(o)?--o===-1&&(a=f):(o=-1,a=R))}return c===a?a=R:a===-1&&(a=r.length),r.slice(c,a)}for(f=r.length-1;f>=c;--f)if(D(r.charCodeAt(f))){if(!v){c=f+1;break}}else a===-1&&(v=!1,a=f+1);return a===-1?"":r.slice(c,a)},extname(r){e(r,"path");let s=0,c=-1,a=0,v=-1,f=!0,o=0;r.length>=2&&r.charCodeAt(1)===N&&L(r.charCodeAt(0))&&(s=a=2);for(let R=r.length-1;R>=s;--R){const g=r.charCodeAt(R);if(D(g)){if(!f){a=R+1;break}continue}v===-1&&(f=!1,v=R+1),g===w?c===-1?c=R:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||v===-1||o===0||o===1&&c===v-1&&c===a+1?"":r.slice(c,v)},format:p.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const c=r.length;let a=0,v=r.charCodeAt(0);if(c===1)return D(v)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(D(v)){if(a=1,D(r.charCodeAt(1))){let C=2,V=C;for(;C<c&&!D(r.charCodeAt(C));)C++;if(C<c&&C!==V){for(V=C;C<c&&D(r.charCodeAt(C));)C++;if(C<c&&C!==V){for(V=C;C<c&&!D(r.charCodeAt(C));)C++;C===c?a=C:C!==V&&(a=C+1)}}}}else if(L(v)&&r.charCodeAt(1)===N){if(c<=2)return s.root=s.dir=r,s;if(a=2,D(r.charCodeAt(2))){if(c===3)return s.root=s.dir=r,s;a=3}}a>0&&(s.root=r.slice(0,a));let f=-1,o=a,R=-1,g=!0,k=r.length-1,O=0;for(;k>=a;--k){if(v=r.charCodeAt(k),D(v)){if(!g){o=k+1;break}continue}R===-1&&(g=!1,R=k+1),v===w?f===-1?f=k:O!==1&&(O=1):f!==-1&&(O=-1)}return R!==-1&&(f===-1||O===0||O===1&&f===R-1&&f===o+1?s.base=s.name=r.slice(o,R):(s.name=r.slice(o,f),s.base=r.slice(o,R),s.ext=r.slice(f,R))),o>0&&o!==a?s.dir=r.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const A=(()=>{if(E){const r=/\\/g;return()=>{const s=F.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>F.cwd()})();t.posix={resolve(...r){let s="",c=!1;for(let a=r.length-1;a>=-1&&!c;a--){const v=a>=0?r[a]:A();e(v,"path"),v.length!==0&&(s=`${v}/${s}`,c=v.charCodeAt(0)===l)}return s=d(s,!c,"/",_),c?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l,c=r.charCodeAt(r.length-1)===l;return r=d(r,!s,"/",_),r.length===0?s?"/":c?"./":".":(c&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let s;for(let c=0;c<r.length;++c){const a=r[c];e(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const c=1,a=r.length,v=a-c,f=1,o=s.length-f,R=v<o?v:o;let g=-1,k=0;for(;k<R;k++){const C=r.charCodeAt(c+k);if(C!==s.charCodeAt(f+k))break;C===l&&(g=k)}if(k===R)if(o>R){if(s.charCodeAt(f+k)===l)return s.slice(f+k+1);if(k===0)return s.slice(f+k)}else v>R&&(r.charCodeAt(c+k)===l?g=k:k===0&&(g=0));let O="";for(k=c+g+1;k<=a;++k)(k===a||r.charCodeAt(k)===l)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(f+g)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l;let c=-1,a=!0;for(let v=r.length-1;v>=1;--v)if(r.charCodeAt(v)===l){if(!a){c=v;break}}else a=!1;return c===-1?s?"/":".":s&&c===1?"//":r.slice(0,c)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let c=0,a=-1,v=!0,f;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let o=s.length-1,R=-1;for(f=r.length-1;f>=0;--f){const g=r.charCodeAt(f);if(g===l){if(!v){c=f+1;break}}else R===-1&&(v=!1,R=f+1),o>=0&&(g===s.charCodeAt(o)?--o===-1&&(a=f):(o=-1,a=R))}return c===a?a=R:a===-1&&(a=r.length),r.slice(c,a)}for(f=r.length-1;f>=0;--f)if(r.charCodeAt(f)===l){if(!v){c=f+1;break}}else a===-1&&(v=!1,a=f+1);return a===-1?"":r.slice(c,a)},extname(r){e(r,"path");let s=-1,c=0,a=-1,v=!0,f=0;for(let o=r.length-1;o>=0;--o){const R=r.charCodeAt(o);if(R===l){if(!v){c=o+1;break}continue}a===-1&&(v=!1,a=o+1),R===w?s===-1?s=o:f!==1&&(f=1):s!==-1&&(f=-1)}return s===-1||a===-1||f===0||f===1&&s===a-1&&s===c+1?"":r.slice(s,a)},format:p.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const c=r.charCodeAt(0)===l;let a;c?(s.root="/",a=1):a=0;let v=-1,f=0,o=-1,R=!0,g=r.length-1,k=0;for(;g>=a;--g){const O=r.charCodeAt(g);if(O===l){if(!R){f=g+1;break}continue}o===-1&&(R=!1,o=g+1),O===w?v===-1?v=g:k!==1&&(k=1):v!==-1&&(k=-1)}if(o!==-1){const O=f===0&&c?1:f;v===-1||k===0||k===1&&v===o-1&&v===f+1?s.base=s.name=r.slice(O,o):(s.name=r.slice(O,v),s.base=r.slice(O,o),s.ext=r.slice(v,o))}return f>0?s.dir=r.slice(0,f-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E?t.win32.normalize:t.posix.normalize,t.isAbsolute=E?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E?t.win32.join:t.posix.join,t.resolve=E?t.win32.resolve:t.posix.resolve,t.relative=E?t.win32.relative:t.posix.relative,t.dirname=E?t.win32.dirname:t.posix.dirname,t.basename=E?t.win32.basename:t.posix.basename,t.extname=E?t.win32.extname:t.posix.extname,t.format=E?t.win32.format:t.posix.format,t.parse=E?t.win32.parse:t.posix.parse,t.toNamespacedPath=E?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E?t.win32.sep:t.posix.sep,t.delimiter=E?t.win32.delimiter:t.posix.delimiter}),Z(ee[17],te([0,1,7]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=F.globals.performance&&typeof F.globals.performance.now=="function";class i{static create(y=!0){return new i(y)}constructor(y){this.a=S&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?F.globals.performance.now():Date.now()}}t.StopWatch=i}),Z(ee[8],te([0,1,5,14,6,16,17]),function(q,t,F,S,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,l=!1;var h;(function(f){f.None=()=>i.Disposable.None;function o(ne){if(l){const{onDidAddListener:Y}=ne,J=e.create();let T=0;ne.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),Y?.()}}}function R(ne,Y){return X(ne,()=>{},0,void 0,!0,void 0,Y)}f.defer=R;function g(ne){return(Y,J=null,T)=>{let I=!1,U;return U=ne(W=>{if(!I)return U?U.dispose():I=!0,Y.call(J,W)},null,T),I&&U.dispose(),U}}f.once=g;function k(ne,Y,J){return K((T,I=null,U)=>ne(W=>T.call(I,Y(W)),null,U),J)}f.map=k;function O(ne,Y,J){return K((T,I=null,U)=>ne(W=>{Y(W),T.call(I,W)},null,U),J)}f.forEach=O;function C(ne,Y,J){return K((T,I=null,U)=>ne(W=>Y(W)&&T.call(I,W),null,U),J)}f.filter=C;function V(ne){return ne}f.signal=V;function H(...ne){return(Y,J=null,T)=>(0,i.combinedDisposable)(...ne.map(I=>I(U=>Y.call(J,U),null,T)))}f.any=H;function $(ne,Y,J,T){let I=J;return k(ne,U=>(I=Y(I,U),I),T)}f.reduce=$;function K(ne,Y){let J;const T={onWillAddFirstListener(){J=ne(I.fire,I)},onDidRemoveLastListener(){J?.dispose()}};Y||o(T);const I=new D(T);return Y?.add(I),I.event}function X(ne,Y,J=100,T=!1,I=!1,U,W){let z,re,se,oe=0,ce;const ge={leakWarningThreshold:U,onWillAddFirstListener(){z=ne(ke=>{oe++,re=Y(re,ke),T&&!se&&(me.fire(re),re=void 0),ce=()=>{const Se=re;re=void 0,se=void 0,(!T||oe>1)&&me.fire(Se),oe=0},typeof J=="number"?(clearTimeout(se),se=setTimeout(ce,J)):se===void 0&&(se=0,queueMicrotask(ce))})},onWillRemoveListener(){I&&oe>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,z.dispose()}};W||o(ge);const me=new D(ge);return W?.add(me),me.event}f.debounce=X;function G(ne,Y=0,J){return f.debounce(ne,(T,I)=>T?(T.push(I),T):[I],Y,void 0,!0,void 0,J)}f.accumulate=G;function n(ne,Y=(T,I)=>T===I,J){let T=!0,I;return C(ne,U=>{const W=T||!Y(U,I);return T=!1,I=U,W},J)}f.latch=n;function ue(ne,Y,J){return[f.filter(ne,Y,J),f.filter(ne,T=>!Y(T),J)]}f.split=ue;function ae(ne,Y=!1,J=[]){let T=J.slice(),I=ne(z=>{T?T.push(z):W.fire(z)});const U=()=>{T?.forEach(z=>W.fire(z)),T=null},W=new D({onWillAddFirstListener(){I||(I=ne(z=>W.fire(z)))},onDidAddFirstListener(){T&&(Y?setTimeout(U):U())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return W.event}f.buffer=ae;class ie{constructor(Y){this.event=Y,this.c=new i.DisposableStore}map(Y){return new ie(k(this.event,Y,this.c))}forEach(Y){return new ie(O(this.event,Y,this.c))}filter(Y){return new ie(C(this.event,Y,this.c))}reduce(Y,J){return new ie($(this.event,Y,J,this.c))}latch(){return new ie(n(this.event,void 0,this.c))}debounce(Y,J=100,T=!1,I=!1,U){return new ie(X(this.event,Y,J,T,I,U,this.c))}on(Y,J,T){return this.event(Y,J,T)}once(Y,J,T){return g(this.event)(Y,J,T)}dispose(){this.c.dispose()}}function be(ne){return new ie(ne)}f.chain=be;function Le(ne,Y,J=T=>T){const T=(...z)=>W.fire(J(...z)),I=()=>ne.on(Y,T),U=()=>ne.removeListener(Y,T),W=new D({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}f.fromNodeEventEmitter=Le;function we(ne,Y,J=T=>T){const T=(...z)=>W.fire(J(...z)),I=()=>ne.addEventListener(Y,T),U=()=>ne.removeEventListener(Y,T),W=new D({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}f.fromDOMEventEmitter=we;function Ne(ne){return new Promise(Y=>g(ne)(Y))}f.toPromise=Ne;function Ae(ne,Y){return Y(void 0),ne(J=>Y(J))}f.runAndSubscribe=Ae;function Me(ne,Y){let J=null;function T(U){J?.dispose(),J=new i.DisposableStore,Y(U,J)}T(void 0);const I=ne(U=>T(U));return(0,i.toDisposable)(()=>{I.dispose(),J?.dispose()})}f.runAndSubscribeWithStore=Me;class pe{constructor(Y,J){this.obs=Y,this.c=0,this.d=!1;const T={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};J||o(T),this.emitter=new D(T),J&&J.add(this.emitter)}beginUpdate(Y){this.c++}handleChange(Y,J){this.d=!0}endUpdate(Y){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Pe(ne,Y){return new pe(ne,Y).emitter.event}f.fromObservable=Pe})(h=t.Event||(t.Event={}));class N{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${N.c++}`,N.all.add(this)}start(o){this.d=new y.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}N.all=new Set,N.c=0,t.EventProfiling=N;let M=-1;function b(f){const o=M;return M=f,{dispose(){M=o}}}t.setGlobalLeakWarningThreshold=b;class m{constructor(o,R=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=R,this.d=0}dispose(){this.c?.clear()}check(o,R){const g=this.threshold;if(g<=0||R<g)return;this.c||(this.c=new Map);const k=this.c.get(o.value)||0;if(this.c.set(o.value,k+1),this.d-=1,this.d<=0){this.d=g*.5;let O,C=0;for(const[V,H]of this.c)(!O||C<H)&&(O=V,C=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${C}):`),console.warn(O)}return()=>{const O=this.c.get(o.value)||0;this.c.set(o.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(o,R,g){this.callback=o,this.callbackThis=R,this.stack=g,this.subscription=new i.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class D{constructor(o){this.j=!1,this.d=o,this.f=M>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new N(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const o=Array.from(this.q);queueMicrotask(()=>{for(const R of o)R.subscription.isset()&&(R.subscription.unset(),R.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,R,g)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,C;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(C=e.create(),O=this.f.check(C,this.q.size+1)),w&&(C=C??e.create());const V=new E(o,R,C),H=this.q.push(V);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,R);const $=V.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return g instanceof i.DisposableStore?g.add($):Array.isArray(g)&&g.push($),$}),this.l}fire(o){if(this.q){this.m||(this.m=new L(this.d?.onListenerError));for(const R of this.q)this.m.push(this,R,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=D;class _{constructor(o=F.onUnexpectedError){this.d=o,this.c=new u.LinkedList}get size(){return this.c.size}push(o,R,g){this.c.push(new d(o,R,g))}clear(o){const R=new u.LinkedList;for(const g of this.c)g.emitter!==o&&R.push(g);this.c=R}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(R){this.d(R)}}}}t.EventDeliveryQueue=_;class L extends _{clear(o){this.c.clear()}}class d{constructor(o,R,g){this.emitter=o,this.listener=R,this.event=g}}class p extends D{async fireAsync(o,R,g){if(!!this.q){this.c||(this.c=new u.LinkedList);for(const k of this.q)this.c.push([k,o]);for(;this.c.size>0&&!R.isCancellationRequested;){const[k,O]=this.c.shift(),C=[],V={...O,token:R,waitUntil:H=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");g&&(H=g(H,k.callback)),C.push(H)}};try{k.invoke(V)}catch(H){(0,F.onUnexpectedError)(H);continue}Object.freeze(C),await Promise.allSettled(C).then(H=>{for(const $ of H)$.status==="rejected"&&(0,F.onUnexpectedError)($.reason)})}}}}t.AsyncEmitter=p;class A extends D{constructor(o){super(o),this.h=0,this.s=new u.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}t.PauseableEmitter=A;class r extends A{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}t.DebounceEmitter=r;class s extends D{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(R=>super.fire(R)),this.c=[]}))}}t.MicrotaskEmitter=s;class c{constructor(){this.d=!1,this.f=[],this.c=new D({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const R={event:o,listener:null};this.f.push(R),this.d&&this.j(R);const g=()=>{this.d&&this.k(R);const k=this.f.indexOf(R);this.f.splice(k,1)};return(0,i.toDisposable)((0,S.once)(g))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(R=>this.c.fire(R))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=c;class a{constructor(){this.c=[]}wrapEvent(o){return(R,g,k)=>o(O=>{const C=this.c[this.c.length-1];C?C.push(()=>R.call(g,O)):R.call(g,O)},void 0,k)}bufferEvents(o){const R=[];this.c.push(R);const g=o();return this.c.pop(),R.forEach(k=>k()),g}}t.EventBufferer=a;class v{constructor(){this.c=!1,this.d=h.None,this.f=i.Disposable.None,this.g=new D({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=v}),Z(ee[18],te([0,1,8]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const S=Object.freeze(function(w,l){const h=setTimeout(w.bind(l),0);return{dispose(){clearTimeout(h)}}});var i;(function(w){function l(h){return h===w.None||h===w.Cancelled||h instanceof u?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}w.isCancellationToken=l,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(i=t.CancellationToken||(t.CancellationToken={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new F.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(l){this.a=void 0,this.b=void 0,this.b=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=i.Cancelled}dispose(l=!1){l&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=y}),Z(ee[32],te([0,1,18]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class S{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new F.CancellationTokenSource,l=this.b(w.token);return this.a={promise:l,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=S;class i{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const l=JSON.stringify(w);return this.b!==l&&(this.b=l,this.a=this.c(w)),this.a}}t.LRUCachedFunction=i;class u{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const l=this.b(w);return this.a.set(w,l),l}}t.CachedFunction=u}),Z(ee[4],te([0,1,32,29]),function(q,t,F,S){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=u;const y=/{(\d+)}/g;function w(P,...B){return B.length===0?P:P.replace(y,function(j,x){const Q=parseInt(x,10);return isNaN(Q)||Q<0||Q>=B.length?j:B[Q]})}t.format=w;const l=/{([^}]+)}/g;function h(P,B){return P.replace(l,(j,x)=>B[x]??j)}t.format2=h;function N(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=N;function M(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function b(P,B){let j=0;const x=B.charCodeAt(0);for(let Q=P.length-1;Q>=0;Q--)P.charCodeAt(Q)===x&&j++;return j}t.count=b;function m(P,B,j="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${j}`}t.truncate=m;function e(P,B=" "){const j=E(P,B);return D(j,B)}t.trim=e;function E(P,B){if(!P||!B)return P;const j=B.length;if(j===0||P.length===0)return P;let x=0;for(;P.indexOf(B,x)===x;)x=x+j;return P.substring(x)}t.ltrim=E;function D(P,B){if(!P||!B)return P;const j=B.length,x=P.length;if(j===0||x===0)return P;let Q=x,le=-1;for(;le=P.lastIndexOf(B,Q-1),!(le===-1||le+j!==Q);){if(le===0)return"";Q=le}return P.substring(0,Q)}t.rtrim=D;function _(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function L(P){return P.replace(/\*/g,"")}t.stripWildcards=L;function d(P,B,j={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=M(P)),j.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let x="";return j.global&&(x+="g"),j.matchCase||(x+="i"),j.multiline&&(x+="m"),j.unicode&&(x+="u"),new RegExp(P,x)}t.createRegExp=d;function p(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=p;function A(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=A;function r(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=r;function s(P){return P.split(/\r\n|\r|\n/)}t.splitLines=s;function c(P){for(let B=0,j=P.length;B<j;B++){const x=P.charCodeAt(B);if(x!==32&&x!==9)return B}return-1}t.firstNonWhitespaceIndex=c;function a(P,B=0,j=P.length){for(let x=B;x<j;x++){const Q=P.charCodeAt(x);if(Q!==32&&Q!==9)return P.substring(B,x)}return P.substring(B,j)}t.getLeadingWhitespace=a;function v(P,B=P.length-1){for(let j=B;j>=0;j--){const x=P.charCodeAt(j);if(x!==32&&x!==9)return j}return-1}t.lastNonWhitespaceIndex=v;function f(P,B,j){const x=[];let Q=0;for(const le of P.matchAll(B)){if(x.push(P.slice(Q,le.index)),le.index===void 0)throw new Error("match.index should be defined");Q=le.index+le[0].length,x.push(j(le[0],...le.slice(1),le.index,P,le.groups))}return x.push(P.slice(Q)),Promise.all(x).then(le=>le.join(""))}t.replaceAsync=f;function o(P,B){return P<B?-1:P>B?1:0}t.compare=o;function R(P,B,j=0,x=P.length,Q=0,le=B.length){for(;j<x&&Q<le;j++,Q++){const Re=P.charCodeAt(j),fe=B.charCodeAt(Q);if(Re<fe)return-1;if(Re>fe)return 1}const de=x-j,De=le-Q;return de<De?-1:de>De?1:0}t.compareSubstring=R;function g(P,B){return k(P,B,0,P.length,0,B.length)}t.compareIgnoreCase=g;function k(P,B,j=0,x=P.length,Q=0,le=B.length){for(;j<x&&Q<le;j++,Q++){let Re=P.charCodeAt(j),fe=B.charCodeAt(Q);if(Re===fe)continue;if(Re>=128||fe>=128)return R(P.toLowerCase(),B.toLowerCase(),j,x,Q,le);C(Re)&&(Re-=32),C(fe)&&(fe-=32);const ve=Re-fe;if(ve!==0)return ve}const de=x-j,De=le-Q;return de<De?-1:de>De?1:0}t.compareSubstringIgnoreCase=k;function O(P){return P>=48&&P<=57}t.isAsciiDigit=O;function C(P){return P>=97&&P<=122}t.isLowerAsciiLetter=C;function V(P){return P>=65&&P<=90}t.isUpperAsciiLetter=V;function H(P,B){return P.length===B.length&&k(P,B)===0}t.equalsIgnoreCase=H;function $(P,B){const j=B.length;return B.length>P.length?!1:k(P,B,0,j)===0}t.startsWithIgnoreCase=$;function K(P,B){const j=Math.min(P.length,B.length);let x;for(x=0;x<j;x++)if(P.charCodeAt(x)!==B.charCodeAt(x))return x;return j}t.commonPrefixLength=K;function X(P,B){const j=Math.min(P.length,B.length);let x;const Q=P.length-1,le=B.length-1;for(x=0;x<j;x++)if(P.charCodeAt(Q-x)!==B.charCodeAt(le-x))return x;return j}t.commonSuffixLength=X;function G(P){return 55296<=P&&P<=56319}t.isHighSurrogate=G;function n(P){return 56320<=P&&P<=57343}t.isLowSurrogate=n;function ue(P,B){return(P-55296<<10)+(B-56320)+65536}t.computeCodePoint=ue;function ae(P,B,j){const x=P.charCodeAt(j);if(G(x)&&j+1<B){const Q=P.charCodeAt(j+1);if(n(Q))return ue(x,Q)}return x}t.getNextCodePoint=ae;function ie(P,B){const j=P.charCodeAt(B-1);if(n(j)&&B>1){const x=P.charCodeAt(B-2);if(G(x))return ue(x,j)}return j}class be{get offset(){return this.e}constructor(B,j=0){this.c=B,this.d=B.length,this.e=j}setOffset(B){this.e=B}prevCodePoint(){const B=ie(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=ae(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.CodePointIterator=be;class Le{get offset(){return this.c.offset}constructor(B,j=0){this.c=new be(B,j)}nextGraphemeLength(){const B=ye.getInstance(),j=this.c,x=j.offset;let Q=B.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const le=j.offset,de=B.getGraphemeBreakType(j.nextCodePoint());if(Ue(Q,de)){j.setOffset(le);break}Q=de}return j.offset-x}prevGraphemeLength(){const B=ye.getInstance(),j=this.c,x=j.offset;let Q=B.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const le=j.offset,de=B.getGraphemeBreakType(j.prevCodePoint());if(Ue(de,Q)){j.setOffset(le);break}Q=de}return x-j.offset}eol(){return this.c.eol()}}t.GraphemeIterator=Le;function we(P,B){return new Le(P,B).nextGraphemeLength()}t.nextCharLength=we;function Ne(P,B){return new Le(P,B).prevGraphemeLength()}t.prevCharLength=Ne;function Ae(P,B){B>0&&n(P.charCodeAt(B))&&B--;const j=B+we(P,B);return[j-Ne(P,j),j]}t.getCharContainingOffset=Ae;function Me(P){const B=new Le(P);let j=0;for(;!B.eol();)j++,B.nextGraphemeLength();return j}t.charCount=Me;let pe;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(P){return pe||(pe=Pe()),pe.test(P)}t.containsRTL=ne;const Y=/^[\t\n\r\x20-\x7E]*$/;function J(P){return Y.test(P)}t.isBasicASCII=J,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=T;function I(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=I;function U(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}t.isEmojiImprecise=U;function W(P,B){if(P.length<B)return P;const j=/\b/g;let x=0;for(;j.test(P)&&!(P.length-j.lastIndex<B);)x=j.lastIndex,j.lastIndex+=1;return P.substring(x).replace(/^\s/,"")}t.lcut=W;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function re(P){return P&&(P=P.replace(z,"")),P}t.removeAnsiEscapeCodes=re,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=se;function oe(P){return se(P)?P.substr(1):P}t.stripUTF8BOM=oe;function ce(P,B){if(!P||!B||P.length<B.length)return!1;const j=B.length,x=P.toLowerCase();let Q=0,le=-1;for(;Q<j;){const de=x.indexOf(B[Q],le+1);if(de<0)return!1;le=de,Q++}return!0}t.fuzzyContains=ce;function ge(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=ge;function me(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=me;function ke(P,B=1){if(B===0)return"";let j=-1;do j=P.indexOf(`
`,j+1),B--;while(B>0&&j>=0);return j===-1?P:(P[j-1]==="\r"&&j--,P.substr(0,j))}t.getNLines=ke;function Se(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}t.singleLetterHash=Se;function qe(P){return ye.getInstance().getGraphemeBreakType(P)}t.getGraphemeBreakType=qe;function Ue(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}var We;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class ye{static getInstance(){return ye.c||(ye.c=new ye),ye.c}constructor(){this.d=Ve()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const j=this.d,x=j.length/3;let Q=1;for(;Q<=x;)if(B<j[3*Q])Q=2*Q;else if(B>j[3*Q+1])Q=2*Q+1;else return j[3*Q+2];return 0}}ye.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(P,B){if(P===0)return 0;const j=He(P,B);if(j!==void 0)return j;const x=new be(B,P);return x.prevCodePoint(),x.offset}t.getLeftDeleteOffset=je;function He(P,B){const j=new be(B,P);let x=j.prevCodePoint();for(;ze(x)||x===65039||x===8419;){if(j.offset===0)return;x=j.prevCodePoint()}if(!U(x))return;let Q=j.offset;return Q>0&&j.prevCodePoint()===8205&&(Q=j.offset),Q}function ze(P){return 127995<=P&&P<=127999}var Ce;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.noBreakWhitespace="\xA0";class Ee{static getInstance(B){return Ee.d.get(Array.from(B))}static getLocales(){return Ee.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=Ee,Ee.c=new S.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.d=new F.LRUCachedFunction(P=>{function B(fe){const ve=new Map;for(let _e=0;_e<fe.length;_e+=2)ve.set(fe[_e],fe[_e+1]);return ve}function j(fe,ve){const _e=new Map(fe);for(const[Te,Ie]of ve)_e.set(Te,Ie);return _e}function x(fe,ve){if(!fe)return ve;const _e=new Map;for(const[Te,Ie]of fe)ve.has(Te)&&_e.set(Te,Ie);return _e}const Q=i.c.value;let le=P.filter(fe=>!fe.startsWith("_")&&fe in Q);le.length===0&&(le=["_default"]);let de;for(const fe of le){const ve=B(Q[fe]);de=x(de,ve)}const De=B(Q._common),Re=j(De,de);return new Ee(Re)}),Ee.e=new S.Lazy(()=>Object.keys(Ee.c.value).filter(P=>!P.startsWith("_"))),t.AmbiguousCharacters=Ee;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(B){return Fe.e().has(B)}static get codePoints(){return Fe.e()}}Fe.d=void 0,t.InvisibleCharacters=Fe}),Z(ee[33],te([0,1,4]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function S(_){return i(_,0)}t.hash=S;function i(_,L){switch(typeof _){case"object":return _===null?u(349,L):Array.isArray(_)?l(_,L):h(_,L);case"string":return w(_,L);case"boolean":return y(_,L);case"number":return u(_,L);case"undefined":return u(937,L);default:return u(617,L)}}t.doHash=i;function u(_,L){return(L<<5)-L+_|0}t.numberHash=u;function y(_,L){return u(_?433:863,L)}function w(_,L){L=u(149417,L);for(let d=0,p=_.length;d<p;d++)L=u(_.charCodeAt(d),L);return L}t.stringHash=w;function l(_,L){return L=u(104579,L),_.reduce((d,p)=>i(p,d),L)}function h(_,L){return L=u(181387,L),Object.keys(_).sort().reduce((d,p)=>(d=w(p,d),i(_[p],d)),L)}class N{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=i(L,this.g),this.g}}t.Hasher=N;var M;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function b(_,L,d=32){const p=d-L,A=~((1<<p)-1);return(_<<L|(A&_)>>>p)>>>0}function m(_,L=0,d=_.byteLength,p=0){for(let A=0;A<d;A++)_[L+A]=p}function e(_,L,d="0"){for(;_.length<L;)_=d+_;return _}function E(_,L=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),L/4)}t.toHexString=E;class D{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const d=L.length;if(d===0)return;const p=this.p;let A=this.r,r=this.u,s,c;for(r!==0?(s=r,c=-1,r=0):(s=L.charCodeAt(0),c=0);;){let a=s;if(F.isHighSurrogate(s))if(c+1<d){const v=L.charCodeAt(c+1);F.isLowSurrogate(v)?(c++,a=F.computeCodePoint(s,v)):a=65533}else{r=s;break}else F.isLowSurrogate(s)&&(a=65533);if(A=this.w(p,A,a),c++,c<d)s=L.charCodeAt(c);else break}this.r=A,this.u=r}w(L,d,p){return p<128?L[d++]=p:p<2048?(L[d++]=192|(p&1984)>>>6,L[d++]=128|(p&63)>>>0):p<65536?(L[d++]=224|(p&61440)>>>12,L[d++]=128|(p&4032)>>>6,L[d++]=128|(p&63)>>>0):(L[d++]=240|(p&1835008)>>>18,L[d++]=128|(p&258048)>>>12,L[d++]=128|(p&4032)>>>6,L[d++]=128|(p&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=D.g,d=this.q;for(let o=0;o<64;o+=4)L.setUint32(o,d.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)L.setUint32(o,b(L.getUint32(o-12,!1)^L.getUint32(o-32,!1)^L.getUint32(o-56,!1)^L.getUint32(o-64,!1),1),!1);let p=this.h,A=this.l,r=this.m,s=this.n,c=this.o,a,v,f;for(let o=0;o<80;o++)o<20?(a=A&r|~A&s,v=1518500249):o<40?(a=A^r^s,v=1859775393):o<60?(a=A&r|A&s|r&s,v=2400959708):(a=A^r^s,v=3395469782),f=b(p,5)+a+c+v+L.getUint32(o*4,!1)&4294967295,c=s,s=r,r=b(A,30),A=p,p=f;this.h=this.h+p&4294967295,this.l=this.l+A&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+c&4294967295}}D.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=D}),Z(ee[19],te([0,1,26,33]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)m[e]=b.charCodeAt(e);return m}}t.StringDiffSequence=i;function u(M,b,m){return new N(new i(M),new i(b)).ComputeDiff(m).changes}t.stringDiff=u;class y{static Assert(b,m){if(!b)throw new Error(m)}}class w{static Copy(b,m,e,E,D){for(let _=0;_<D;_++)e[E+_]=b[m+_]}static Copy2(b,m,e,E,D){for(let _=0;_<D;_++)e[E+_]=b[m+_]}}var l;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class h{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class N{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[E,D,_]=N.o(b),[L,d,p]=N.o(m);this.d=_&&p,this.e=E,this.f=D,this.g=L,this.h=d,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(N.n(m)){const e=new Int32Array(m.length);for(let E=0,D=m.length;E<D;E++)e[E]=(0,S.stringHash)(m[E],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=N.r(this.b,b),E=N.r(this.c,m);return e===E}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,E,D){const _=[!1];let L=this.w(b,m,e,E,_);return D&&(L=this.z(L)),{quitEarly:_[0],changes:L}}w(b,m,e,E,D){for(D[0]=!1;b<=m&&e<=E&&this.p(b,e);)b++,e++;for(;m>=b&&E>=e&&this.p(m,E);)m--,E--;if(b>m||e>E){let r;return e<=E?(y.Assert(b===m+1,"originalStart should only be one more than originalEnd"),r=[new F.DiffChange(b,0,e,E-e+1)]):b<=m?(y.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.DiffChange(b,m-b+1,e,0)]):(y.Assert(b===m+1,"originalStart should only be one more than originalEnd"),y.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const _=[0],L=[0],d=this.y(b,m,e,E,_,L,D),p=_[0],A=L[0];if(d!==null)return d;if(!D[0]){const r=this.w(b,p,e,A,D);let s=[];return D[0]?s=[new F.DiffChange(p+1,m-(p+1)+1,A+1,E-(A+1)+1)]:s=this.w(p+1,m,A+1,E,D),this.H(r,s)}return[new F.DiffChange(b,m-b+1,e,E-e+1)]}x(b,m,e,E,D,_,L,d,p,A,r,s,c,a,v,f,o,R){let g=null,k=null,O=new h,C=m,V=e,H=c[0]-f[0]-E,$=-1073741824,K=this.k.length-1;do{const X=H+b;X===C||X<V&&p[X-1]<p[X+1]?(r=p[X+1],a=r-H-E,r<$&&O.MarkNextChange(),$=r,O.AddModifiedElement(r+1,a),H=X+1-b):(r=p[X-1]+1,a=r-H-E,r<$&&O.MarkNextChange(),$=r-1,O.AddOriginalElement(r,a+1),H=X-1-b),K>=0&&(p=this.k[K],b=p[0],C=1,V=p.length-1)}while(--K>=-1);if(g=O.getReverseChanges(),R[0]){let X=c[0]+1,G=f[0]+1;if(g!==null&&g.length>0){const n=g[g.length-1];X=Math.max(X,n.getOriginalEnd()),G=Math.max(G,n.getModifiedEnd())}k=[new F.DiffChange(X,s-X+1,G,v-G+1)]}else{O=new h,C=_,V=L,H=c[0]-f[0]-d,$=1073741824,K=o?this.m.length-1:this.m.length-2;do{const X=H+D;X===C||X<V&&A[X-1]>=A[X+1]?(r=A[X+1]-1,a=r-H-d,r>$&&O.MarkNextChange(),$=r+1,O.AddOriginalElement(r+1,a+1),H=X+1-D):(r=A[X-1],a=r-H-d,r>$&&O.MarkNextChange(),$=r,O.AddModifiedElement(r+1,a+1),H=X-1-D),K>=0&&(A=this.m[K],D=A[0],C=1,V=A.length-1)}while(--K>=-1);k=O.getChanges()}return this.H(g,k)}y(b,m,e,E,D,_,L){let d=0,p=0,A=0,r=0,s=0,c=0;b--,e--,D[0]=0,_[0]=0,this.k=[],this.m=[];const a=m-b+(E-e),v=a+1,f=new Int32Array(v),o=new Int32Array(v),R=E-e,g=m-b,k=b-e,O=m-E,V=(g-R)%2===0;f[R]=b,o[g]=m,L[0]=!1;for(let H=1;H<=a/2+1;H++){let $=0,K=0;A=this.J(R-H,H,R,v),r=this.J(R+H,H,R,v);for(let G=A;G<=r;G+=2){G===A||G<r&&f[G-1]<f[G+1]?d=f[G+1]:d=f[G-1]+1,p=d-(G-R)-k;const n=d;for(;d<m&&p<E&&this.p(d+1,p+1);)d++,p++;if(f[G]=d,d+p>$+K&&($=d,K=p),!V&&Math.abs(G-g)<=H-1&&d>=o[G])return D[0]=d,_[0]=p,n<=o[G]&&1447>0&&H<=1447+1?this.x(R,A,r,k,g,s,c,O,f,o,d,m,D,p,E,_,V,L):null}const X=($-b+(K-e)-H)/2;if(this.a!==null&&!this.a($,X))return L[0]=!0,D[0]=$,_[0]=K,X>0&&1447>0&&H<=1447+1?this.x(R,A,r,k,g,s,c,O,f,o,d,m,D,p,E,_,V,L):(b++,e++,[new F.DiffChange(b,m-b+1,e,E-e+1)]);s=this.J(g-H,H,g,v),c=this.J(g+H,H,g,v);for(let G=s;G<=c;G+=2){G===s||G<c&&o[G-1]>=o[G+1]?d=o[G+1]-1:d=o[G-1],p=d-(G-g)-O;const n=d;for(;d>b&&p>e&&this.p(d,p);)d--,p--;if(o[G]=d,V&&Math.abs(G-R)<=H&&d<=f[G])return D[0]=d,_[0]=p,n>=f[G]&&1447>0&&H<=1447+1?this.x(R,A,r,k,g,s,c,O,f,o,d,m,D,p,E,_,V,L):null}if(H<=1447){let G=new Int32Array(r-A+2);G[0]=R-A+1,w.Copy2(f,A,G,1,r-A+1),this.k.push(G),G=new Int32Array(c-s+2),G[0]=g-s+1,w.Copy2(o,s,G,1,c-s+1),this.m.push(G)}}return this.x(R,A,r,k,g,s,c,O,f,o,d,m,D,p,E,_,V,L)}z(b){for(let m=0;m<b.length;m++){const e=b[m],E=m<b.length-1?b[m+1].originalStart:this.f.length,D=m<b.length-1?b[m+1].modifiedStart:this.h.length,_=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<D&&(!_||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const p=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!p)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<b.length-1&&this.I(b[m],b[m+1],d)){b[m]=d[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let E=0,D=0;if(m>0){const r=b[m-1];E=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const _=e.originalLength>0,L=e.modifiedLength>0;let d=0,p=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,c=e.modifiedStart-r;if(s<E||c<D||_&&!this.s(s,s+e.originalLength)||L&&!this.u(c,c+e.modifiedLength))break;const v=(s===E&&c===D?5:0)+this.G(s,e.originalLength,c,e.modifiedLength);v>p&&(p=v,d=r)}e.originalStart-=d,e.modifiedStart-=d;const A=[null];if(m>0&&this.I(b[m-1],b[m],A)){b[m-1]=A[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const E=b[m-1],D=b[m],_=D.originalStart-E.originalStart-E.originalLength,L=E.originalStart,d=D.originalStart+D.originalLength,p=d-L,A=E.modifiedStart,r=D.modifiedStart+D.modifiedLength,s=r-A;if(_<5&&p<20&&s<20){const c=this.A(L,p,A,s,_);if(c){const[a,v]=c;(a!==E.originalStart+E.originalLength||v!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=a-E.originalStart,E.modifiedLength=v-E.modifiedStart,D.originalStart=a+_,D.modifiedStart=v+_,D.originalLength=d-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return b}A(b,m,e,E,D){if(m<D||E<D)return null;const _=b+m-D+1,L=e+E-D+1;let d=0,p=0,A=0;for(let r=b;r<_;r++)for(let s=e;s<L;s++){const c=this.B(r,s,D);c>0&&c>d&&(d=c,p=r,A=s)}return d>0?[p,A]:null}B(b,m,e){let E=0;for(let D=0;D<e;D++){if(!this.p(b+D,m+D))return 0;E+=this.e[b+D].length}return E}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,E){const D=this.D(b,m)?1:0,_=this.F(e,E)?1:0;return D+_}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const E=new Array(b.length+m.length-1);return w.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],w.Copy(m,1,E,b.length,m.length-1),E}else{const E=new Array(b.length+m.length);return w.Copy(b,0,E,0,b.length),w.Copy(m,0,E,b.length,m.length),E}}I(b,m,e){if(y.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),y.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const E=b.originalStart;let D=b.originalLength;const _=b.modifiedStart;let L=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(D=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&(L=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new F.DiffChange(E,D,_,L),!0}else return e[0]=null,!1}J(b,m,e,E){if(b>=0&&b<E)return b;const D=e,_=E-e-1,L=m%2===0;if(b<0){const d=D%2===0;return L===d?0:1}else{const d=_%2===0;return L===d?E-1:E-2}}}t.LcsDiff=N}),Z(ee[20],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function F(s){return typeof s=="string"}t.isString=F;function S(s){return Array.isArray(s)&&s.every(c=>F(c))}t.isStringArray=S;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const c=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof c}t.isTypedArray=u;function y(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=y;function w(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=w;function l(s){return s===!0||s===!1}t.isBoolean=l;function h(s){return typeof s>"u"}t.isUndefined=h;function N(s){return!M(s)}t.isDefined=N;function M(s){return h(s)||s===null}t.isUndefinedOrNull=M;function b(s,c){if(!s)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}t.assertType=b;function m(s){if(M(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=m;function e(...s){const c=[];for(let a=0;a<s.length;a++){const v=s[a];if(M(v))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);c.push(v)}return c}t.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function D(s){if(!i(s))return!1;for(const c in s)if(E.call(s,c))return!1;return!0}t.isEmptyObject=D;function _(s){return typeof s=="function"}t.isFunction=_;function L(...s){return s.length>0&&s.every(_)}t.areFunctions=L;function d(s,c){const a=Math.min(s.length,c.length);for(let v=0;v<a;v++)p(s[v],c[v])}t.validateConstraints=d;function p(s,c){if(F(c)){if(typeof s!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(_(c)){try{if(s instanceof c)return}catch{}if(!M(s)&&s.constructor===c||c.length===1&&c.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=p;function A(s){return s===null?void 0:s}t.withNullAsUndefined=A;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),Z(ee[34],te([0,1,20]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const S=Object.create(null);function i(w,l){if((0,F.isString)(l)){const h=S[l];if(h===void 0)throw new Error(`${w} references an unknown codicon: ${l}`);l=h}return S[w]=l,{id:w}}function u(){return S}t.getCodiconFontCharacters=u;function y(){return Object.values(t.Codicon)}t.getAllCodicons=y,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Z(ee[11],te([0,1,20]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const L=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([d,p])=>{L[d]=p&&typeof p=="object"?S(p):p}),L}t.deepClone=S;function i(_){if(!_||typeof _!="object")return _;const L=[_];for(;L.length>0;){const d=L.shift();Object.freeze(d);for(const p in d)if(u.call(d,p)){const A=d[p];typeof A=="object"&&!Object.isFrozen(A)&&!(0,F.isTypedArray)(A)&&L.push(A)}}return _}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function y(_,L){return w(_,L,new Set)}t.cloneAndChange=y;function w(_,L,d){if((0,F.isUndefinedOrNull)(_))return _;const p=L(_);if(typeof p<"u")return p;if(Array.isArray(_)){const A=[];for(const r of _)A.push(w(r,L,d));return A}if((0,F.isObject)(_)){if(d.has(_))throw new Error("Cannot clone recursive data-structure");d.add(_);const A={};for(const r in _)u.call(_,r)&&(A[r]=w(_[r],L,d));return d.delete(_),A}return _}function l(_,L,d=!0){return(0,F.isObject)(_)?((0,F.isObject)(L)&&Object.keys(L).forEach(p=>{p in _?d&&((0,F.isObject)(_[p])&&(0,F.isObject)(L[p])?l(_[p],L[p],d):_[p]=L[p]):_[p]=L[p]}),_):L}t.mixin=l;function h(_,L){if(_===L)return!0;if(_==null||L===null||L===void 0||typeof _!=typeof L||typeof _!="object"||Array.isArray(_)!==Array.isArray(L))return!1;let d,p;if(Array.isArray(_)){if(_.length!==L.length)return!1;for(d=0;d<_.length;d++)if(!h(_[d],L[d]))return!1}else{const A=[];for(p in _)A.push(p);A.sort();const r=[];for(p in L)r.push(p);if(r.sort(),!h(A,r))return!1;for(d=0;d<A.length;d++)if(!h(_[A[d]],L[A[d]]))return!1}return!0}t.equals=h;function N(_){const L=new Set;return JSON.stringify(_,(d,p)=>{if((0,F.isObject)(p)||Array.isArray(p)){if(L.has(p))return"[Circular]";L.add(p)}return p})}t.safeStringify=N;function M(_,L){const d=Object.create(null);return!_||!L||Object.keys(L).forEach(A=>{const r=_[A],s=L[A];h(r,s)||(d[A]=s)}),d}t.distinct=M;function b(_,L){const d=L.toLowerCase(),p=Object.keys(_).find(A=>A.toLowerCase()===d);return p?_[p]:_[L]}t.getCaseInsensitive=b;function m(_,L){const d=Object.create(null);for(const[p,A]of Object.entries(_))L(p,A)&&(d[p]=A);return d}t.filter=m;function e(_){let L=[],d=Object.getPrototypeOf(_);for(;Object.prototype!==d;)L=L.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return L}t.getAllPropertyNames=e;function E(_){const L=[];for(const d of e(_))typeof _[d]=="function"&&L.push(d);return L}t.getAllMethodNames=E;function D(_,L){const d=A=>function(){const r=Array.prototype.slice.call(arguments,0);return L(A,r)},p={};for(const A of _)p[A]=d(A);return p}t.createProxyObject=D}),Z(ee[21],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var F;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F=t.Constants||(t.Constants={}));function S(u){return u<0?0:u>255?255:u|0}t.toUint8=S;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),Z(ee[12],te([0,1,31,7]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,y=/^\/\//;function w(c,a){if(!c.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!i.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!u.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(c,a){return!c&&!a?"file":c}function h(c,a){switch(c){case"https":case"http":case"file":a?a[0]!==M&&(a=M+a):a=M;break}return a}const N="",M="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,v,f,o,R,g=!1){typeof a=="object"?(this.scheme=a.scheme||N,this.authority=a.authority||N,this.path=a.path||N,this.query=a.query||N,this.fragment=a.fragment||N):(this.scheme=l(a,g),this.authority=v||N,this.path=h(this.scheme,f||N),this.query=o||N,this.fragment=R||N,w(this,g))}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:v,authority:f,path:o,query:R,fragment:g}=a;return v===void 0?v=this.scheme:v===null&&(v=N),f===void 0?f=this.authority:f===null&&(f=N),o===void 0?o=this.path:o===null&&(o=N),R===void 0?R=this.query:R===null&&(R=N),g===void 0?g=this.fragment:g===null&&(g=N),v===this.scheme&&f===this.authority&&o===this.path&&R===this.query&&g===this.fragment?this:new E(v,f,o,R,g)}static parse(a,v=!1){const f=b.exec(a);return f?new E(f[2]||N,s(f[4]||N),s(f[5]||N),s(f[7]||N),s(f[9]||N),v):new E(N,N,N,N,N)}static file(a){let v=N;if(S.isWindows&&(a=a.replace(/\\/g,M)),a[0]===M&&a[1]===M){const f=a.indexOf(M,2);f===-1?(v=a.substring(2),a=M):(v=a.substring(2,f),a=a.substring(f)||M)}return new E("file",v,a,N,N)}static from(a){const v=new E(a.scheme,a.authority,a.path,a.query,a.fragment);return w(v,!0),v}static joinPath(a,...v){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return S.isWindows&&a.scheme==="file"?f=m.file(F.win32.join(d(a,!0),...v)).path:f=F.posix.join(a.path,...v),a.with({path:f})}toString(a=!1){return p(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const v=new E(a);return v._formatted=a.external,v._fsPath=a._sep===e?a.fsPath:null,v}}else return a}}t.URI=m;const e=S.isWindows?1:void 0;class E extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=e),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(c,a,v){let f,o=-1;for(let R=0;R<c.length;R++){const g=c.charCodeAt(R);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||v&&g===91||v&&g===93||v&&g===58)o!==-1&&(f+=encodeURIComponent(c.substring(o,R)),o=-1),f!==void 0&&(f+=c.charAt(R));else{f===void 0&&(f=c.substr(0,R));const k=D[g];k!==void 0?(o!==-1&&(f+=encodeURIComponent(c.substring(o,R)),o=-1),f+=k):o===-1&&(o=R)}}return o!==-1&&(f+=encodeURIComponent(c.substring(o))),f!==void 0?f:c}function L(c){let a;for(let v=0;v<c.length;v++){const f=c.charCodeAt(v);f===35||f===63?(a===void 0&&(a=c.substr(0,v)),a+=D[f]):a!==void 0&&(a+=c[v])}return a!==void 0?a:c}function d(c,a){let v;return c.authority&&c.path.length>1&&c.scheme==="file"?v=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?a?v=c.path.substr(1):v=c.path[1].toLowerCase()+c.path.substr(2):v=c.path,S.isWindows&&(v=v.replace(/\//g,"\\")),v}t.uriToFsPath=d;function p(c,a){const v=a?L:_;let f="",{scheme:o,authority:R,path:g,query:k,fragment:O}=c;if(o&&(f+=o,f+=":"),(R||o==="file")&&(f+=M,f+=M),R){let C=R.indexOf("@");if(C!==-1){const V=R.substr(0,C);R=R.substr(C+1),C=V.lastIndexOf(":"),C===-1?f+=v(V,!1,!1):(f+=v(V.substr(0,C),!1,!1),f+=":",f+=v(V.substr(C+1),!1,!0)),f+="@"}R=R.toLowerCase(),C=R.lastIndexOf(":"),C===-1?f+=v(R,!1,!0):(f+=v(R.substr(0,C),!1,!0),f+=R.substr(C))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const C=g.charCodeAt(1);C>=65&&C<=90&&(g=`/${String.fromCharCode(C+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const C=g.charCodeAt(0);C>=65&&C<=90&&(g=`${String.fromCharCode(C+32)}:${g.substr(2)}`)}f+=v(g,!0,!1)}return k&&(f+="?",f+=v(k,!1,!1)),O&&(f+="#",f+=a?O:_(O,!1,!1)),f}function A(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+A(c.substr(3)):c}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(c){return c.match(r)?c.replace(r,a=>A(a)):c}}),Z(ee[55],te([0,1,5,8,6,11,7,4]),function(q,t,F,S,i,u,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let h=!1;function N(c){!y.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}t.logOnceWebWorkerWarning=N;var M;(function(c){c[c.Request=0]="Request",c[c.Reply=1]="Reply",c[c.SubscribeEvent=2]="SubscribeEvent",c[c.Event=3]="Event",c[c.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class b{constructor(a,v,f,o){this.vsWorker=a,this.req=v,this.method=f,this.args=o,this.type=0}}class m{constructor(a,v,f,o){this.vsWorker=a,this.seq=v,this.res=f,this.err=o,this.type=1}}class e{constructor(a,v,f,o){this.vsWorker=a,this.req=v,this.eventName=f,this.arg=o,this.type=2}}class E{constructor(a,v,f){this.vsWorker=a,this.req=v,this.event=f,this.type=3}}class D{constructor(a,v){this.vsWorker=a,this.req=v,this.type=4}}class _{constructor(a){this.a=-1,this.g=a,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(a){this.a=a}sendMessage(a,v){const f=String(++this.b);return new Promise((o,R)=>{this.c[f]={resolve:o,reject:R},this.o(new b(this.a,f,a,v))})}listen(a,v){let f=null;const o=new S.Emitter({onWillAddFirstListener:()=>{f=String(++this.b),this.d.set(f,o),this.o(new e(this.a,f,a,v))},onDidRemoveLastListener:()=>{this.d.delete(f),this.o(new D(this.a,f)),f=null}});return o.event}handleMessage(a){!a||!a.vsWorker||this.a!==-1&&a.vsWorker!==this.a||this.h(a)}h(a){switch(a.type){case 1:return this.j(a);case 0:return this.k(a);case 2:return this.l(a);case 3:return this.m(a);case 4:return this.n(a)}}j(a){if(!this.c[a.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[a.seq];if(delete this.c[a.seq],a.err){let f=a.err;a.err.$isError&&(f=new Error,f.name=a.err.name,f.message=a.err.message,f.stack=a.err.stack),v.reject(f);return}v.resolve(a.res)}k(a){const v=a.req;this.g.handleMessage(a.method,a.args).then(o=>{this.o(new m(this.a,v,o,void 0))},o=>{o.detail instanceof Error&&(o.detail=(0,F.transformErrorForSerialization)(o.detail)),this.o(new m(this.a,v,void 0,(0,F.transformErrorForSerialization)(o)))})}l(a){const v=a.req,f=this.g.handleEvent(a.eventName,a.arg)(o=>{this.o(new E(this.a,v,o))});this.f.set(v,f)}m(a){if(!this.d.has(a.req)){console.warn("Got event for unknown req");return}this.d.get(a.req).fire(a.event)}n(a){if(!this.f.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(a.req).dispose(),this.f.delete(a.req)}o(a){const v=[];if(a.type===0)for(let f=0;f<a.args.length;f++)a.args[f]instanceof ArrayBuffer&&v.push(a.args[f]);else a.type===1&&a.res instanceof ArrayBuffer&&v.push(a.res);this.g.sendMessage(a,v)}}class L extends i.Disposable{constructor(a,v,f){super();let o=null;this.a=this.B(a.create("vs/base/common/worker/simpleWorker",V=>{this.c.handleMessage(V)},V=>{o?.(V)})),this.c=new _({sendMessage:(V,H)=>{this.a.postMessage(V,H)},handleMessage:(V,H)=>{if(typeof f[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(f[V].apply(f,H))}catch($){return Promise.reject($)}},handleEvent:(V,H)=>{if(p(V)){const $=f[V].call(f,H);if(typeof $!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return $}if(d(V)){const $=f[V];if(typeof $!="function")throw new Error(`Missing event ${V} on main thread host.`);return $}throw new Error(`Malformed event name ${V}`)}}),this.c.setWorkerId(this.a.getId());let R=null;const g=globalThis.require;typeof g<"u"&&typeof g.getConfig=="function"?R=g.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const k=(0,u.getAllMethodNames)(f);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(R)),v,k]);const O=(V,H)=>this.g(V,H),C=(V,H)=>this.c.listen(V,H);this.f=new Promise((V,H)=>{o=H,this.b.then($=>{V(A($,O,C))},$=>{H($),this.h("Worker failed to load "+v,$)})})}getProxyObject(){return this.f}g(a,v){return new Promise((f,o)=>{this.b.then(()=>{this.c.sendMessage(a,v).then(f,o)},o)})}h(a,v){console.error(a),console.info(v)}}t.SimpleWorkerClient=L;function d(c){return c[0]==="o"&&c[1]==="n"&&w.isUpperAsciiLetter(c.charCodeAt(2))}function p(c){return/^onDynamic/.test(c)&&w.isUpperAsciiLetter(c.charCodeAt(9))}function A(c,a,v){const f=g=>function(){const k=Array.prototype.slice.call(arguments,0);return a(g,k)},o=g=>function(k){return v(g,k)},R={};for(const g of c){if(p(g)){R[g]=o(g);continue}if(d(g)){R[g]=v(g,void 0);continue}R[g]=f(g)}return R}class r{constructor(a,v){this.a=v,this.b=null,this.c=new _({sendMessage:(f,o)=>{a(f,o)},handleMessage:(f,o)=>this.d(f,o),handleEvent:(f,o)=>this.f(f,o)})}onmessage(a){this.c.handleMessage(a)}d(a,v){if(a===l)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this.b[a].apply(this.b,v))}catch(f){return Promise.reject(f)}}f(a,v){if(!this.b)throw new Error("Missing requestHandler");if(p(a)){const f=this.b[a].call(this.b,v);if(typeof f!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return f}if(d(a)){const f=this.b[a];if(typeof f!="function")throw new Error(`Missing event ${a} on request handler.`);return f}throw new Error(`Malformed event name ${a}`)}g(a,v,f,o){this.c.setWorkerId(a);const k=A(o,(O,C)=>this.c.sendMessage(O,C),(O,C)=>this.c.listen(O,C));return this.a?(this.b=this.a(k),Promise.resolve((0,u.getAllMethodNames)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((O,C)=>{(globalThis.require||q)([f],H=>{if(this.b=H.create(k),!this.b){C(new Error("No RequestHandler!"));return}O((0,u.getAllMethodNames)(this.b))},C)}))}}t.SimpleWorkerServer=r;function s(c){return new r(c,null)}t.create=s}),Z(ee[22],te([0,1,21]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class S{constructor(w){const l=(0,F.toUint8)(w);this.c=l,this.a=S.d(l),this.b=new Map}static d(w){const l=new Uint8Array(256);return l.fill(w),l}set(w,l){const h=(0,F.toUint8)(l);w>=0&&w<256?this.a[w]=h:this.b.set(w,h)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=S;var i;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(i||(i={}));class u{constructor(){this.a=new S(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}t.CharacterSet=u}),Z(ee[23],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class F{constructor(i,u){this.startLineNumber=i,this.endLineNumberExclusive=u}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(i){return new F(this.startLineNumber+i,this.endLineNumberExclusive+i)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(i){return new F(Math.min(this.startLineNumber,i.startLineNumber),Math.max(this.endLineNumberExclusive,i.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=F}),Z(ee[3],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class F{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new F(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return F.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const y=i.lineNumber|0,w=u.lineNumber|0;if(y===w){const l=i.column|0,h=u.column|0;return l-h}return y-w}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=F}),Z(ee[2],te([0,1,3]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class S{constructor(u,y,w,l){u>w||u===w&&y>l?(this.startLineNumber=w,this.startColumn=l,this.endLineNumber=u,this.endColumn=y):(this.startLineNumber=u,this.startColumn=y,this.endLineNumber=w,this.endColumn=l)}isEmpty(){return S.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return S.containsPosition(this,u)}static containsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<u.startColumn||y.lineNumber===u.endLineNumber&&y.column>u.endColumn)}static strictContainsPosition(u,y){return!(y.lineNumber<u.startLineNumber||y.lineNumber>u.endLineNumber||y.lineNumber===u.startLineNumber&&y.column<=u.startColumn||y.lineNumber===u.endLineNumber&&y.column>=u.endColumn)}containsRange(u){return S.containsRange(this,u)}static containsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>u.endColumn)}strictContainsRange(u){return S.strictContainsRange(this,u)}static strictContainsRange(u,y){return!(y.startLineNumber<u.startLineNumber||y.endLineNumber<u.startLineNumber||y.startLineNumber>u.endLineNumber||y.endLineNumber>u.endLineNumber||y.startLineNumber===u.startLineNumber&&y.startColumn<=u.startColumn||y.endLineNumber===u.endLineNumber&&y.endColumn>=u.endColumn)}plusRange(u){return S.plusRange(this,u)}static plusRange(u,y){let w,l,h,N;return y.startLineNumber<u.startLineNumber?(w=y.startLineNumber,l=y.startColumn):y.startLineNumber===u.startLineNumber?(w=y.startLineNumber,l=Math.min(y.startColumn,u.startColumn)):(w=u.startLineNumber,l=u.startColumn),y.endLineNumber>u.endLineNumber?(h=y.endLineNumber,N=y.endColumn):y.endLineNumber===u.endLineNumber?(h=y.endLineNumber,N=Math.max(y.endColumn,u.endColumn)):(h=u.endLineNumber,N=u.endColumn),new S(w,l,h,N)}intersectRanges(u){return S.intersectRanges(this,u)}static intersectRanges(u,y){let w=u.startLineNumber,l=u.startColumn,h=u.endLineNumber,N=u.endColumn;const M=y.startLineNumber,b=y.startColumn,m=y.endLineNumber,e=y.endColumn;return w<M?(w=M,l=b):w===M&&(l=Math.max(l,b)),h>m?(h=m,N=e):h===m&&(N=Math.min(N,e)),w>h||w===h&&l>N?null:new S(w,l,h,N)}equalsRange(u){return S.equalsRange(this,u)}static equalsRange(u,y){return!u&&!y?!0:!!u&&!!y&&u.startLineNumber===y.startLineNumber&&u.startColumn===y.startColumn&&u.endLineNumber===y.endLineNumber&&u.endColumn===y.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(u){return new F.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(u){return new F.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,y){return new S(this.startLineNumber,this.startColumn,u,y)}setStartPosition(u,y){return new S(u,y,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(u){return new S(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return S.collapseToEnd(this)}static collapseToEnd(u){return new S(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new S(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,y=u){return new S(u.lineNumber,u.column,y.lineNumber,y.column)}static lift(u){return u?new S(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<u.startColumn)}static areIntersecting(u,y){return!(u.endLineNumber<y.startLineNumber||u.endLineNumber===y.startLineNumber&&u.endColumn<=y.startColumn||y.endLineNumber<u.startLineNumber||y.endLineNumber===u.startLineNumber&&y.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,y){if(u&&y){const h=u.startLineNumber|0,N=y.startLineNumber|0;if(h===N){const M=u.startColumn|0,b=y.startColumn|0;if(M===b){const m=u.endLineNumber|0,e=y.endLineNumber|0;if(m===e){const E=u.endColumn|0,D=y.endColumn|0;return E-D}return m-e}return M-b}return h-N}return(u?1:0)-(y?1:0)}static compareRangesUsingEnds(u,y){return u.endLineNumber===y.endLineNumber?u.endColumn===y.endColumn?u.startLineNumber===y.startLineNumber?u.startColumn-y.startColumn:u.startLineNumber-y.startLineNumber:u.endColumn-y.endColumn:u.endLineNumber-y.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=S}),Z(ee[35],te([0,1,3,2]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(i=t.SelectionDirection||(t.SelectionDirection={}));class u extends S.Range{constructor(w,l,h,N){super(w,l,h,N),this.selectionStartLineNumber=w,this.selectionStartColumn=l,this.positionLineNumber=h,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return u.selectionsEqual(this,w)}static selectionsEqual(w,l){return w.selectionStartLineNumber===l.selectionStartLineNumber&&w.selectionStartColumn===l.selectionStartColumn&&w.positionLineNumber===l.positionLineNumber&&w.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,l){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,w,l):new u(w,l,this.startLineNumber,this.startColumn)}getPosition(){return new F.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,l){return this.getDirection()===0?new u(w,l,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,w,l)}static fromPositions(w,l=w){return new u(w.lineNumber,w.column,l.lineNumber,l.column)}static fromRange(w,l){return l===0?new u(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new u(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new u(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,l){if(w&&!l||!w&&l)return!1;if(!w&&!l)return!0;if(w.length!==l.length)return!1;for(let h=0,N=w.length;h<N;h++)if(!this.selectionsEqual(w[h],l[h]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,l,h,N,M){return M===0?new u(w,l,h,N):new u(h,N,w,l)}}t.Selection=u}),Z(ee[36],te([0,1,22]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var S;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(S=t.WordCharacterClass||(t.WordCharacterClass={}));class i extends F.CharacterClassifier{constructor(w){super(0);for(let l=0,h=w.length;l<h;l++)this.set(w.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(y){const w={};return l=>(w.hasOwnProperty(l)||(w[l]=y(l)),w[l])}t.getMapForWordSeparators=u(y=>new i(y))}),Z(ee[24],te([0,1,15,6,16]),function(q,t,F,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(M=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.USUAL_WORD_SEPARATORS)M.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.DEFAULT_WORD_REGEXP=u();function y(M){let b=t.DEFAULT_WORD_REGEXP;if(M&&M instanceof RegExp)if(M.global)b=M;else{let m="g";M.ignoreCase&&(m+="i"),M.multiline&&(m+="m"),M.unicode&&(m+="u"),b=new RegExp(M.source,m)}return b.lastIndex=0,b}t.ensureValidWordDefinition=y;const w=new i.LinkedList;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(M){const b=w.unshift(M);return(0,S.toDisposable)(b)}t.setDefaultGetWordAtTextConfig=l;function h(M,b,m,e,E){if(E||(E=F.Iterable.first(w)),m.length>E.maxLen){let p=M-E.maxLen/2;return p<0?p=0:e+=p,m=m.substring(p,M+E.maxLen/2),h(M,b,m,e,E)}const D=Date.now(),_=M-1-e;let L=-1,d=null;for(let p=1;!(Date.now()-D>=E.timeBudget);p++){const A=_-E.windowSize*p;b.lastIndex=Math.max(0,A);const r=N(b,m,_,L);if(!r&&d||(d=r,A<=0))break;L=A}if(d){const p={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return b.lastIndex=0,p}return null}t.getWordAtText=h;function N(M,b,m,e){let E;for(;E=M.exec(b);){const D=E.index||0;if(D<=m&&M.lastIndex>=m)return E;if(e>0&&D>e)return null}return null}}),Z(ee[9],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class F{constructor(u,y){this.seq1Range=u,this.seq2Range=y}reverse(){return new F(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(u){return new F(this.seq1Range.join(u.seq1Range),this.seq2Range.join(u.seq2Range))}}t.SequenceDiff=F;class S{constructor(u,y){this.start=u,this.endExclusive=y}get isEmpty(){return this.start===this.endExclusive}delta(u){return new S(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new S(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}intersect(u){const y=Math.max(this.start,u.start),w=Math.min(this.endExclusive,u.endExclusive);if(y<=w)return new S(y,w)}}t.OffsetRange=S}),Z(ee[37],te([0,1,9]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function S(l,h,N){let M=N;return M=u(l,h,M),M=y(l,h,M),M}t.optimizeSequenceDiffs=S;function i(l,h,N){const M=[];for(const b of N){const m=M[M.length-1];if(!m){M.push(b);continue}b.seq1Range.start-m.seq1Range.endExclusive<=2||b.seq2Range.start-m.seq2Range.endExclusive<=2?M[M.length-1]=new F.SequenceDiff(m.seq1Range.join(b.seq1Range),m.seq2Range.join(b.seq2Range)):M.push(b)}return M}t.smoothenSequenceDiffs=i;function u(l,h,N){const M=[];N.length>0&&M.push(N[0]);for(let b=1;b<N.length;b++){const m=M[M.length-1],e=N[b];if(e.seq1Range.isEmpty){let E=!0;const D=e.seq1Range.start-m.seq1Range.endExclusive;for(let _=1;_<=D;_++)if(h.getElement(e.seq2Range.start-_)!==h.getElement(e.seq2Range.endExclusive-_)){E=!1;break}if(E){M[M.length-1]=new F.SequenceDiff(m.seq1Range,new F.OffsetRange(m.seq2Range.start,e.seq2Range.endExclusive-D));continue}}M.push(e)}return M}t.joinSequenceDiffs=u;function y(l,h,N){if(!l.getBoundaryScore||!h.getBoundaryScore)return N;for(let M=0;M<N.length;M++){const b=N[M];if(b.seq1Range.isEmpty){const m=M>0?N[M-1].seq2Range.endExclusive:-1,e=M+1<N.length?N[M+1].seq2Range.start:h.length;N[M]=w(b,l,h,e,m)}else if(b.seq2Range.isEmpty){const m=M>0?N[M-1].seq1Range.endExclusive:-1,e=M+1<N.length?N[M+1].seq1Range.start:l.length;N[M]=w(b.reverse(),h,l,e,m).reverse()}}return N}t.shiftSequenceDiffs=y;function w(l,h,N,M,b){let e=1;for(;l.seq2Range.start-e>b&&N.getElement(l.seq2Range.start-e)===N.getElement(l.seq2Range.endExclusive-e)&&e<20;)e++;e--;let E=0;for(;l.seq2Range.start+E<M&&N.getElement(l.seq2Range.start+E)===N.getElement(l.seq2Range.endExclusive+E)&&E<20;)E++;if(e===0&&E===0)return l;let D=0,_=-1;for(let L=-e;L<=E;L++){const d=l.seq2Range.start+L,p=l.seq2Range.endExclusive+L,A=l.seq1Range.start+L,r=h.getBoundaryScore(A)+N.getBoundaryScore(d)+N.getBoundaryScore(p);r>_&&(_=r,D=L)}return D!==0?new F.SequenceDiff(l.seq1Range.delta(D),l.seq2Range.delta(D)):l}}),Z(ee[38],te([0,1,9]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class S{compute(l,h){if(l.length===0)return[new F.SequenceDiff(new F.OffsetRange(0,0),new F.OffsetRange(0,h.length))];if(h.length===0)return[new F.SequenceDiff(new F.OffsetRange(0,l.length),new F.OffsetRange(0,0))];function N(d,p){for(;d<l.length&&p<h.length&&l.getElement(d)===h.getElement(p);)d++,p++;return d}let M=0;const b=new u;b.set(0,N(0,0));const m=new y;m.set(0,b.get(0)===0?null:new i(null,0,0,b.get(0)));let e=0;e:for(;;)for(M++,e=-M;e<=M;e+=2){const d=e===M?-1:b.get(e+1),p=e===-M?-1:b.get(e-1)+1,A=Math.min(Math.max(d,p),l.length),r=A-e,s=N(A,r);b.set(e,s);const c=A===d?m.get(e+1):m.get(e-1);if(m.set(e,s!==A?new i(c,A,r,s-A):c),b.get(e)===l.length&&b.get(e)-e===h.length)break e}let E=m.get(e);const D=[];let _=l.length,L=h.length;for(;;){const d=E?E.x+E.length:0,p=E?E.y+E.length:0;if((d!==_||p!==L)&&D.push(new F.SequenceDiff(new F.OffsetRange(d,_),new F.OffsetRange(p,L))),!E)break;_=E.x,L=E.y,E=E.prev}return D.reverse(),D}}t.MyersDiffAlgorithm=S;class i{constructor(l,h,N,M){this.prev=l,this.x=h,this.y=N,this.length=M}}class u{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,h){if(l<0){if(l=-l-1,l>=this.b.length){const N=this.b;this.b=new Int32Array(N.length*2),this.b.set(N)}this.b[l]=h}else{if(l>=this.a.length){const N=this.a;this.a=new Int32Array(N.length*2),this.a.set(N)}this.a[l]=h}}}class y{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,h){l<0?(l=-l-1,this.b[l]=h):this.a[l]=h}}}),Z(ee[39],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class F{constructor(i,u){this.width=i,this.height=u,this.a=[],this.a=new Array(i*u)}get(i,u){return this.a[i+u*this.width]}set(i,u,y){this.a[i+u*this.width]=y}}t.Array2D=F}),Z(ee[40],te([0,1,9,39]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class i{compute(y,w,l){const h=new S.Array2D(y.length,w.length),N=new S.Array2D(y.length,w.length),M=new S.Array2D(y.length,w.length);for(let L=0;L<y.length;L++)for(let d=0;d<w.length;d++){const p=L===0?0:h.get(L-1,d),A=d===0?0:h.get(L,d-1);let r;y.getElement(L)===w.getElement(d)?(L===0||d===0?r=0:r=h.get(L-1,d-1),L>0&&d>0&&N.get(L-1,d-1)===3&&(r+=M.get(L-1,d-1)),r+=l?l(L,d):1):r=-1;const s=Math.max(p,A,r);if(s===r){const c=L>0&&d>0?M.get(L-1,d-1):0;M.set(L,d,c+1),N.set(L,d,3)}else s===p?(M.set(L,d,0),N.set(L,d,1)):s===A&&(M.set(L,d,0),N.set(L,d,2));h.set(L,d,s)}const b=[];let m=y.length,e=w.length;function E(L,d){(L+1!==m||d+1!==e)&&b.push(new F.SequenceDiff(new F.OffsetRange(L+1,m),new F.OffsetRange(d+1,e))),m=L,e=d}let D=y.length-1,_=w.length-1;for(;D>=0&&_>=0;)N.get(D,_)===3?(E(D,_),D--,_--):N.get(D,_)===1?D--:_--;return E(-1,-1),b.reverse(),b}}t.DynamicProgrammingDiffing=i}),Z(ee[13],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.LineRangeMapping=void 0;class F{constructor(u,y,w){this.originalRange=u,this.modifiedRange=y,this.innerChanges=w}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=F;class S{constructor(u,y){this.originalRange=u,this.modifiedRange=y}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=S}),Z(ee[25],te([0,1,19,13,4,2,10,23]),function(q,t,F,S,i,u,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const l=3;class h{computeDiff(A,r,s){const a=new D(A,r,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),v=[];let f=null;for(const o of a.changes){let R;o.originalEndLineNumber===0?R=new w.LineRange(o.originalStartLineNumber+1,o.originalStartLineNumber+1):R=new w.LineRange(o.originalStartLineNumber,o.originalEndLineNumber+1);let g;o.modifiedEndLineNumber===0?g=new w.LineRange(o.modifiedStartLineNumber+1,o.modifiedStartLineNumber+1):g=new w.LineRange(o.modifiedStartLineNumber,o.modifiedEndLineNumber+1);let k=new S.LineRangeMapping(R,g,o.charChanges?.map(O=>new S.RangeMapping(new u.Range(O.originalStartLineNumber,O.originalStartColumn,O.originalEndLineNumber,O.originalEndColumn),new u.Range(O.modifiedStartLineNumber,O.modifiedStartColumn,O.modifiedEndLineNumber,O.modifiedEndColumn))));f&&(f.modifiedRange.endLineNumberExclusive===k.modifiedRange.startLineNumber||f.originalRange.endLineNumberExclusive===k.originalRange.startLineNumber)&&(k=new S.LineRangeMapping(f.originalRange.join(k.originalRange),f.modifiedRange.join(k.modifiedRange),f.innerChanges&&k.innerChanges?f.innerChanges.concat(k.innerChanges):void 0),v.pop()),v.push(k),f=k}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(v,(o,R)=>R.originalRange.startLineNumber-o.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-o.modifiedRange.endLineNumberExclusive&&o.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&o.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),{quitEarly:a.quitEarly,changes:v}}}t.SmartLinesDiffComputer=h;function N(p,A,r,s){return new F.LcsDiff(p,A,r).ComputeDiff(s)}class M{constructor(A){const r=[],s=[];for(let c=0,a=A.length;c<a;c++)r[c]=_(A[c],1),s[c]=L(A[c],1);this.lines=A,this.a=r,this.b=s}getElements(){const A=[];for(let r=0,s=this.lines.length;r<s;r++)A[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return A}getStrictElement(A){return this.lines[A]}getStartLineNumber(A){return A+1}getEndLineNumber(A){return A+1}createCharSequence(A,r,s){const c=[],a=[],v=[];let f=0;for(let o=r;o<=s;o++){const R=this.lines[o],g=A?this.a[o]:1,k=A?this.b[o]:R.length+1;for(let O=g;O<k;O++)c[f]=R.charCodeAt(O-1),a[f]=o+1,v[f]=O,f++;!A&&o<s&&(c[f]=10,a[f]=o+1,v[f]=R.length+1,f++)}return new b(c,a,v)}}class b{constructor(A,r,s){this.a=A,this.b=r,this.d=s}toString(){return"["+this.a.map((A,r)=>(A===10?"\\n":String.fromCharCode(A))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(A,r){if(A<0||A>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(A){return A>0&&A===this.b.length?this.getEndLineNumber(A-1):(this.e(A,this.b),this.b[A])}getEndLineNumber(A){return A===-1?this.getStartLineNumber(A+1):(this.e(A,this.b),this.a[A]===10?this.b[A]+1:this.b[A])}getStartColumn(A){return A>0&&A===this.d.length?this.getEndColumn(A-1):(this.e(A,this.d),this.d[A])}getEndColumn(A){return A===-1?this.getStartColumn(A+1):(this.e(A,this.d),this.a[A]===10?1:this.d[A]+1)}}class m{constructor(A,r,s,c,a,v,f,o){this.originalStartLineNumber=A,this.originalStartColumn=r,this.originalEndLineNumber=s,this.originalEndColumn=c,this.modifiedStartLineNumber=a,this.modifiedStartColumn=v,this.modifiedEndLineNumber=f,this.modifiedEndColumn=o}static createFromDiffChange(A,r,s){const c=r.getStartLineNumber(A.originalStart),a=r.getStartColumn(A.originalStart),v=r.getEndLineNumber(A.originalStart+A.originalLength-1),f=r.getEndColumn(A.originalStart+A.originalLength-1),o=s.getStartLineNumber(A.modifiedStart),R=s.getStartColumn(A.modifiedStart),g=s.getEndLineNumber(A.modifiedStart+A.modifiedLength-1),k=s.getEndColumn(A.modifiedStart+A.modifiedLength-1);return new m(c,a,v,f,o,R,g,k)}}function e(p){if(p.length<=1)return p;const A=[p[0]];let r=A[0];for(let s=1,c=p.length;s<c;s++){const a=p[s],v=a.originalStart-(r.originalStart+r.originalLength),f=a.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(v,f)<l?(r.originalLength=a.originalStart+a.originalLength-r.originalStart,r.modifiedLength=a.modifiedStart+a.modifiedLength-r.modifiedStart):(A.push(a),r=a)}return A}class E{constructor(A,r,s,c,a){this.originalStartLineNumber=A,this.originalEndLineNumber=r,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=c,this.charChanges=a}static createFromDiffResult(A,r,s,c,a,v,f){let o,R,g,k,O;if(r.originalLength===0?(o=s.getStartLineNumber(r.originalStart)-1,R=0):(o=s.getStartLineNumber(r.originalStart),R=s.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(g=c.getStartLineNumber(r.modifiedStart)-1,k=0):(g=c.getStartLineNumber(r.modifiedStart),k=c.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),v&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&a()){const C=s.createCharSequence(A,r.originalStart,r.originalStart+r.originalLength-1),V=c.createCharSequence(A,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(C.getElements().length>0&&V.getElements().length>0){let H=N(C,V,a,!0).changes;f&&(H=e(H)),O=[];for(let $=0,K=H.length;$<K;$++)O.push(m.createFromDiffChange(H[$],C,V))}}return new E(o,R,g,k,O)}}class D{constructor(A,r,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=A,this.g=r,this.h=new M(A),this.j=new M(r),this.k=d(s.maxComputationTime),this.l=d(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const A=N(this.h,this.j,this.k,this.e),r=A.changes,s=A.quitEarly;if(this.d){const f=[];for(let o=0,R=r.length;o<R;o++)f.push(E.createFromDiffResult(this.d,r[o],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:f}}const c=[];let a=0,v=0;for(let f=-1,o=r.length;f<o;f++){const R=f+1<o?r[f+1]:null,g=R?R.originalStart:this.f.length,k=R?R.modifiedStart:this.g.length;for(;a<g&&v<k;){const O=this.f[a],C=this.g[v];if(O!==C){{let V=_(O,1),H=_(C,1);for(;V>1&&H>1;){const $=O.charCodeAt(V-2),K=C.charCodeAt(H-2);if($!==K)break;V--,H--}(V>1||H>1)&&this.m(c,a+1,1,V,v+1,1,H)}{let V=L(O,1),H=L(C,1);const $=O.length+1,K=C.length+1;for(;V<$&&H<K;){const X=O.charCodeAt(V-1),G=O.charCodeAt(H-1);if(X!==G)break;V++,H++}(V<$||H<K)&&this.m(c,a+1,V,$,v+1,H,K)}}a++,v++}R&&(c.push(E.createFromDiffResult(this.d,R,this.h,this.j,this.l,this.a,this.b)),a+=R.originalLength,v+=R.modifiedLength)}return{quitEarly:s,changes:c}}m(A,r,s,c,a,v,f){if(this.n(A,r,s,c,a,v,f))return;let o;this.a&&(o=[new m(r,s,r,c,a,v,a,f)]),A.push(new E(r,r,a,a,o))}n(A,r,s,c,a,v,f){const o=A.length;if(o===0)return!1;const R=A[o-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===r&&R.modifiedEndLineNumber===a?(this.a&&R.charChanges&&R.charChanges.push(new m(r,s,r,c,a,v,a,f)),!0):R.originalEndLineNumber+1===r&&R.modifiedEndLineNumber+1===a?(R.originalEndLineNumber=r,R.modifiedEndLineNumber=a,this.a&&R.charChanges&&R.charChanges.push(new m(r,s,r,c,a,v,a,f)),!0):!1}}t.DiffComputer=D;function _(p,A){const r=i.firstNonWhitespaceIndex(p);return r===-1?A:r+1}function L(p,A){const r=i.lastNonWhitespaceIndex(p);return r===-1?A:r+2}function d(p){if(p===0)return()=>!0;const A=Date.now();return()=>Date.now()-A<p}}),Z(ee[41],te([0,1,10,23,3,2,9,40,37,38,13]),function(q,t,F,S,i,u,y,w,l,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class M{constructor(){this.b=new w.DynamicProgrammingDiffing,this.c=new h.MyersDiffAlgorithm}computeDiff(c,a,v){const f=new Map;function o(G){let n=f.get(G);return n===void 0&&(n=f.size,f.set(G,n)),n}const R=c.map(G=>o(G.trim())),g=a.map(G=>o(G.trim())),k=new e(R,c),O=new e(g,a);let C=(()=>k.length+O.length<1500?this.b.compute(k,O,(G,n)=>c[G]===a[n]?a[n].length===0?.1:1+Math.log(1+a[n].length):.99):this.c.compute(k,O))();C=(0,l.optimizeSequenceDiffs)(k,O,C);const V=[],H=G=>{for(let n=0;n<G;n++){const ue=$+n,ae=K+n;if(c[ue]!==a[ae]){const ie=this.f(c,a,new y.SequenceDiff(new y.OffsetRange(ue,ue+1),new y.OffsetRange(ae,ae+1)));for(const be of ie)V.push(be)}}};let $=0,K=0;for(const G of C){(0,F.assertFn)(()=>G.seq1Range.start-$===G.seq2Range.start-K);const n=G.seq1Range.start-$;H(n),$=G.seq1Range.endExclusive,K=G.seq2Range.endExclusive;const ue=this.f(c,a,G);for(const ae of ue)V.push(ae)}H(c.length-$);const X=b(V);return{quitEarly:!1,changes:X}}f(c,a,v){const f=new D(c,v.seq1Range),o=new D(a,v.seq2Range),R=f.length+o.length<500?this.b.compute(f,o):this.c.compute(f,o);function g(V,H){const $=[];for(;V.length>0||H.length>0;){const K=V[0],X=H[0];let G;K&&(!X||K.seq1Range.start<X.seq1Range.start)?G=V.shift():G=H.shift(),$.length>0&&$[$.length-1].seq1Range.endExclusive>=G.seq1Range.start?$[$.length-1]=$[$.length-1].join(G):$.push(G)}return $}function k(V,H,$){const K=[];let X;function G(){if(!X)return;const ue=X.s1Range.length-X.deleted,ae=X.s2Range.length-X.added;if(ue!==ae){X=void 0;return}Math.max(X.deleted,X.added)+(X.count-1)>ue&&K.push(new y.SequenceDiff(X.s1Range,X.s2Range)),X=void 0}for(const ue of $){let ae=function(Ne,Ae){(!X||!X.s1Range.equals(Ne)||!X.s2Range.equals(Ae))&&(X&&X.s1Range.endExclusive<Ne.start&&X.s2Range.endExclusive<Ae.start&&G(),X={added:0,deleted:0,count:0,s1Range:Ne,s2Range:Ae});const Me=Ne.intersect(ue.seq1Range),pe=Ae.intersect(ue.seq2Range);X.count++,X.added+=pe?.length??0,X.deleted+=Me?.length??0};const ie=V.findWordContaining(ue.seq1Range.start-1),be=H.findWordContaining(ue.seq2Range.start-1),Le=V.findWordContaining(ue.seq1Range.endExclusive),we=H.findWordContaining(ue.seq2Range.endExclusive);ie&&Le&&be&&we&&ie.equals(Le)&&be.equals(we)?ae(ie,be):(ie&&be&&ae(ie,be),Le&&we&&ae(Le,we))}return G(),g($,K)}let O=R;return O=k(f,o,O),O=(0,l.optimizeSequenceDiffs)(f,o,O),O=(0,l.smoothenSequenceDiffs)(f,o,O),O.map(V=>new N.RangeMapping(f.translateRange(V.seq1Range).delta(v.seq1Range.start),o.translateRange(V.seq2Range).delta(v.seq2Range.start)))}}t.StandardLinesDiffComputer=M;function b(s){const c=[];for(const a of m(s,(v,f)=>f.originalRange.startLineNumber-(v.originalRange.endLineNumber-(v.originalRange.endColumn>1?0:1))<=1||f.modifiedRange.startLineNumber-(v.modifiedRange.endLineNumber-(v.modifiedRange.endColumn>1?0:1))<=1)){const v=a[0],f=a[a.length-1];c.push(new N.LineRangeMapping(new S.LineRange(v.originalRange.startLineNumber,f.originalRange.endLineNumber+(f.originalRange.endColumn>1||f.modifiedRange.endColumn>1?1:0)),new S.LineRange(v.modifiedRange.startLineNumber,f.modifiedRange.endLineNumber+(f.originalRange.endColumn>1||f.modifiedRange.endColumn>1?1:0)),a))}return(0,F.assertFn)(()=>(0,F.checkAdjacentItems)(c,(a,v)=>v.originalRange.startLineNumber-a.originalRange.endLineNumberExclusive===v.modifiedRange.startLineNumber-a.modifiedRange.endLineNumberExclusive&&a.originalRange.endLineNumberExclusive<v.originalRange.startLineNumber&&a.modifiedRange.endLineNumberExclusive<v.modifiedRange.startLineNumber)),c}t.lineRangeMappingFromRangeMappings=b;function*m(s,c){let a,v;for(const f of s)v!==void 0&&c(v,f)?a.push(f):(a&&(yield a),a=[f]),v=f;a&&(yield a)}class e{constructor(c,a){this.b=c,this.c=a}getElement(c){return this.b[c]}get length(){return this.b.length}getBoundaryScore(c){const a=c===0?0:E(this.c[c-1]),v=c===this.c.length?0:E(this.c[c]);return 1e3-(a+v)}}t.LineSequence=e;function E(s){let c=0;for(;c<s.length&&(s.charCodeAt(c)===32||s.charCodeAt(c)===9);)c++;return c}class D{constructor(c,a){this.lines=c,this.lineRange=a;let v=0;this.c=new Int32Array(a.length);for(let o=a.start;o<a.endExclusive;o++)v+=c[o].length,this.c[o-a.start]=v+1,v++;this.b=new Int32Array(v);let f=0;for(let o=a.start;o<a.endExclusive;o++){const R=c[o];for(let g=0;g<R.length;g++)this.b[f+g]=R.charCodeAt(g);f+=R.length,o<c.length-1&&(this.b[f]=`
`.charCodeAt(0),f+=1)}}toString(){return`Slice: "${this.text}"`}get text(){return[...this.b].map(c=>String.fromCharCode(c)).join("")}getElement(c){return this.b[c]}get length(){return this.b.length}getBoundaryScore(c){const a=A(c>0?this.b[c-1]:-1),v=A(c<this.b.length?this.b[c]:-1);if(a===6&&v===7)return 0;let f=0;return a!==v&&(f+=10,v===1&&(f+=1)),f+=p(a),f+=p(v),f}translateOffset(c){let a=0,v=this.c.length;for(;a<v;){const o=Math.floor((a+v)/2);this.c[o]>c?v=o:a=o+1}const f=a===0?0:this.c[a-1];return new i.Position(a+1,c-f+1)}translateRange(c){return u.Range.fromPositions(this.translateOffset(c.start),this.translateOffset(c.endExclusive))}findWordContaining(c){if(c<0||c>=this.b.length||!_(this.b[c]))return;let a=c;for(;a>0&&_(this.b[a-1]);)a--;let v=c;for(;v<this.b.length&&_(this.b[v]);)v++;return new y.OffsetRange(a,v)}}function _(s){return s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57}var L;(function(s){s[s.WordLower=0]="WordLower",s[s.WordUpper=1]="WordUpper",s[s.WordNumber=2]="WordNumber",s[s.End=3]="End",s[s.Other=4]="Other",s[s.Space=5]="Space",s[s.LineBreakCR=6]="LineBreakCR",s[s.LineBreakLF=7]="LineBreakLF"})(L||(L={}));const d={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function p(s){return d[s]}function A(s){return s===10?7:s===13?6:r(s)?5:s>=97&&s<=122?0:s>=65&&s<=90?1:s>=48&&s<=57?2:s===-1?3:4}function r(s){return s===32||s===9}}),Z(ee[42],te([0,1,25,41]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new F.SmartLinesDiffComputer,experimental:new S.StandardLinesDiffComputer}}),Z(ee[43],te([0,1,22]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var S;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(S=t.State||(t.State={}));class i{constructor(e,E,D){const _=new Uint8Array(e*E);for(let L=0,d=e*E;L<d;L++)_[L]=D;this.a=_,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,D){this.a[e*this.cols+E]=D}}class u{constructor(e){let E=0,D=0;for(let L=0,d=e.length;L<d;L++){const[p,A,r]=e[L];A>E&&(E=A),p>D&&(D=p),r>D&&(D=r)}E++,D++;const _=new i(D,E,0);for(let L=0,d=e.length;L<d;L++){const[p,A,r]=e[L];_.set(p,A,r)}this.a=_,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.StateMachine=u;let y=null;function w(){return y===null&&(y=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let h=null;function N(){if(h===null){h=new F.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<m.length;E++)h.set(m.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)h.set(e.charCodeAt(E),2)}return h}class M{static a(e,E,D,_,L){let d=L-1;do{const p=E.charCodeAt(d);if(e.get(p)!==2)break;d--}while(d>_);if(_>0){const p=E.charCodeAt(_-1),A=E.charCodeAt(d);(p===40&&A===41||p===91&&A===93||p===123&&A===125)&&d--}return{range:{startLineNumber:D,startColumn:_+1,endLineNumber:D,endColumn:d+2},url:E.substring(_,d+1)}}static computeLinks(e,E=w()){const D=N(),_=[];for(let L=1,d=e.getLineCount();L<=d;L++){const p=e.getLineContent(L),A=p.length;let r=0,s=0,c=0,a=1,v=!1,f=!1,o=!1,R=!1;for(;r<A;){let g=!1;const k=p.charCodeAt(r);if(a===13){let O;switch(k){case 40:v=!0,O=0;break;case 41:O=v?0:1;break;case 91:o=!0,f=!0,O=0;break;case 93:o=!1,O=f?0:1;break;case 123:R=!0,O=0;break;case 125:O=R?0:1;break;case 39:case 34:case 96:c===k?O=1:c===39||c===34||c===96?O=0:O=1;break;case 42:O=c===42?1:0;break;case 124:O=c===124?1:0;break;case 32:O=o?0:1;break;default:O=D.get(k)}O===1&&(_.push(M.a(D,p,L,s,r)),g=!0)}else if(a===12){let O;k===91?(f=!0,O=0):O=D.get(k),O===1?g=!0:a=13}else a=E.nextState(a,k),a===0&&(g=!0);g&&(a=1,v=!1,f=!1,R=!1,s=r+1,c=k),r++}a===13&&_.push(M.a(D,p,L,s,A))}return _}}t.LinkComputer=M;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:M.computeLinks(m)}t.computeLinks=b}),Z(ee[44],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,y,w,l){if(i&&u){const h=this.a(u,l);if(h)return{range:i,value:h}}if(y&&w){const h=this.a(w,l);if(h)return{range:y,value:h}}return null}a(i,u){const y=this.b(i,u);return y!==null?y:this.d(i,u)}b(i,u){const y=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let w=Number(i);const l=parseFloat(i);return!isNaN(w)&&!isNaN(l)&&w===l?w===0&&!u?null:(w=Math.floor(w*y),w+=u?y:-y,String(w/y)):null}d(i,u){return this.e(this.c,i,u)}e(i,u,y){let w=null;for(let l=0,h=i.length;w===null&&l<h;l++)w=this.f(i[l],u,y);return w}f(i,u,y){let w=i.indexOf(u);return w>=0?(w+=y?1:-1,w<0?w=i.length-1:w%=i.length,i[w]):null}}F.INSTANCE=new F,t.BasicInplaceReplace=F}),Z(ee[45],te([0,1,11]),function(q,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var S;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(S=t.OverviewRulerLane||(t.OverviewRulerLane={}));var i;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(i=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(u=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var y;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(y=t.EndOfLinePreference||(t.EndOfLinePreference={}));var w;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(w=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var l;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(l=t.EndOfLineSequence||(t.EndOfLineSequence={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,F.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}t.TextModelResolvedOptions=h;class N{constructor(p,A){this._findMatchBrand=void 0,this.range=p,this.matches=A}}t.FindMatch=N;var M;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(M=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function b(d){return d&&typeof d.read=="function"}t.isITextSnapshot=b;var m;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(m=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class E{constructor(p,A,r,s,c,a){this.identifier=p,this.range=A,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=c,this._isTracked=a}}t.ValidAnnotatedEditOperation=E;class D{constructor(p,A,r){this.regex=p,this.wordSeparators=A,this.simpleSearch=r}}t.SearchData=D;class _{constructor(p,A,r){this.reverseEdits=p,this.changes=A,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=_;function L(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}t.shouldSynchronizeModel=L}),Z(ee[46],te([0,1,27,21]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,h){l=(0,S.toUint32)(l);const N=this.a,M=this.b,b=h.length;return b===0?!1:(this.a=new Uint32Array(N.length+b),this.a.set(N.subarray(0,l),0),this.a.set(N.subarray(l),l+b),this.a.set(h,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}setValue(l,h){return l=(0,S.toUint32)(l),h=(0,S.toUint32)(h),this.a[l]===h?!1:(this.a[l]=h,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,h){l=(0,S.toUint32)(l),h=(0,S.toUint32)(h);const N=this.a,M=this.b;if(l>=N.length)return!1;const b=N.length-l;return h>=b&&(h=b),h===0?!1:(this.a=new Uint32Array(N.length-h),this.a.set(N.subarray(0,l),0),this.a.set(N.subarray(l+h),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,S.toUint32)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let h=this.c[0]+1;h===0&&(this.b[0]=this.a[0],h++),l>=this.a.length&&(l=this.a.length-1);for(let N=h;N<=l;N++)this.b[N]=this.b[N-1]+this.a[N];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let h=0,N=this.a.length-1,M=0,b=0,m=0;for(;h<=N;)if(M=h+(N-h)/2|0,b=this.b[M],m=b-this.a[M],l<m)N=M-1;else if(l>=b)h=M+1;else break;return new y(M,l-m)}}t.PrefixSumComputer=i;class u{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const h=this.e[l],N=h>0?this.d[h-1]:0;return new y(h,l-N)}removeValues(l,h){this.a.splice(l,h),this.f(l)}insertValues(l,h){this.a=(0,F.arrayInsert)(this.a,l,h),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,h=this.a.length;l<h;l++){const N=this.a[l],M=l>0?this.d[l-1]:0;this.d[l]=M+N;for(let b=0;b<N;b++)this.e[M+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,h){this.a[l]!==h&&(this.a[l]=h,this.f(l))}}t.ConstantTimePrefixSumComputer=u;class y{constructor(l,h){this.index=l,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=h}}t.PrefixSumIndexOfResult=y}),Z(ee[47],te([0,1,4,3,46]),function(q,t,F,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(w,l,h,N){this.d=w,this.f=l,this.g=h,this.h=N,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const l=w.changes;for(const h of l)this.o(h.range),this.p(new S.Position(h.range.startLineNumber,h.range.startColumn),h.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,l=this.f.length,h=new Uint32Array(l);for(let N=0;N<l;N++)h[N]=this.f[N].length+w;this.j=new i.PrefixSumComputer(h)}}n(w,l){this.f[w]=l,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,l){if(l.length===0)return;const h=(0,F.splitLines)(l);if(h.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+h[0]+this.f[w.lineNumber-1].substring(w.column-1));return}h[h.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+h[0]);const N=new Uint32Array(h.length-1);for(let M=1;M<h.length;M++)this.f.splice(w.lineNumber+M-1,0,h[M]),N[M-1]=h[M].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,N)}}t.MirrorTextModel=u}),Z(ee[48],te([0,1,4,36,3,2,45]),function(q,t,F,S,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const w=999;class l{constructor(L,d,p,A){this.searchString=L,this.isRegex=d,this.matchCase=p,this.wordSeparators=A}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=h(this.searchString):L=this.searchString.indexOf(`
`)>=0;let d=null;try{d=F.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!d)return null;let p=!this.isRegex&&!L;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new y.SearchData(d,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}t.SearchParams=l;function h(_){if(!_||_.length===0)return!1;for(let L=0,d=_.length;L<d;L++){const p=_.charCodeAt(L);if(p===10)return!0;if(p===92){if(L++,L>=d)break;const A=_.charCodeAt(L);if(A===110||A===114||A===87)return!0}}return!1}t.isMultilineRegexSource=h;function N(_,L,d){if(!d)return new y.FindMatch(_,null);const p=[];for(let A=0,r=L.length;A<r;A++)p[A]=L[A];return new y.FindMatch(_,p)}t.createFindMatch=N;class M{constructor(L){const d=[];let p=0;for(let A=0,r=L.length;A<r;A++)L.charCodeAt(A)===10&&(d[p++]=A);this.a=d}findLineFeedCountBeforeOffset(L){const d=this.a;let p=0,A=d.length-1;if(A===-1||L<=d[0])return 0;for(;p<A;){const r=p+((A-p)/2>>0);d[r]>=L?A=r-1:d[r+1]>=L?(p=r,A=r):p=r+1}return p+1}}class b{static findMatches(L,d,p,A,r){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b(L,p,new D(s.wordSeparators,s.regex),A,r):this.c(L,p,s,A,r):[]}static a(L,d,p,A,r,s){let c,a=0;A?(a=A.findLineFeedCountBeforeOffset(r),c=d+r+a):c=d+r;let v;if(A){const g=A.findLineFeedCountBeforeOffset(r+s.length)-a;v=c+s.length+g}else v=c+s.length;const f=L.getPositionAt(c),o=L.getPositionAt(v);return new u.Range(f.lineNumber,f.column,o.lineNumber,o.column)}static b(L,d,p,A,r){const s=L.getOffsetAt(d.getStartPosition()),c=L.getValueInRange(d,1),a=L.getEOL()===`\r
`?new M(c):null,v=[];let f=0,o;for(p.reset(0);o=p.next(c);)if(v[f++]=N(this.a(L,s,c,a,o.index,o[0]),o,A),f>=r)return v;return v}static c(L,d,p,A,r){const s=[];let c=0;if(d.startLineNumber===d.endLineNumber){const v=L.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return c=this.d(p,v,d.startLineNumber,d.startColumn-1,c,s,A,r),s}const a=L.getLineContent(d.startLineNumber).substring(d.startColumn-1);c=this.d(p,a,d.startLineNumber,d.startColumn-1,c,s,A,r);for(let v=d.startLineNumber+1;v<d.endLineNumber&&c<r;v++)c=this.d(p,L.getLineContent(v),v,0,c,s,A,r);if(c<r){const v=L.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);c=this.d(p,v,d.endLineNumber,0,c,s,A,r)}return s}static d(L,d,p,A,r,s,c,a){const v=L.wordSeparators;if(!c&&L.simpleSearch){const R=L.simpleSearch,g=R.length,k=d.length;let O=-g;for(;(O=d.indexOf(R,O+g))!==-1;)if((!v||E(v,d,k,O,g))&&(s[r++]=new y.FindMatch(new u.Range(p,O+1+A,p,O+1+g+A),null),r>=a))return r;return r}const f=new D(L.wordSeparators,L.regex);let o;f.reset(0);do if(o=f.next(d),o&&(s[r++]=N(new u.Range(p,o.index+1+A,p,o.index+1+o[0].length+A),o,c),r>=a))return r;while(o);return r}static findNextMatch(L,d,p,A){const r=d.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.e(L,p,s,A):this.f(L,p,s,A)}static e(L,d,p,A){const r=new i.Position(d.lineNumber,1),s=L.getOffsetAt(r),c=L.getLineCount(),a=L.getValueInRange(new u.Range(r.lineNumber,r.column,c,L.getLineMaxColumn(c)),1),v=L.getEOL()===`\r
`?new M(a):null;p.reset(d.column-1);const f=p.next(a);return f?N(this.a(L,s,a,v,f.index,f[0]),f,A):d.lineNumber!==1||d.column!==1?this.e(L,new i.Position(1,1),p,A):null}static f(L,d,p,A){const r=L.getLineCount(),s=d.lineNumber,c=L.getLineContent(s),a=this.g(p,c,s,d.column,A);if(a)return a;for(let v=1;v<=r;v++){const f=(s+v-1)%r,o=L.getLineContent(f+1),R=this.g(p,o,f+1,1,A);if(R)return R}return null}static g(L,d,p,A,r){L.reset(A-1);const s=L.next(d);return s?N(new u.Range(p,s.index+1,p,s.index+1+s[0].length),s,r):null}static findPreviousMatch(L,d,p,A){const r=d.parseSearchRequest();if(!r)return null;const s=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.h(L,p,s,A):this.j(L,p,s,A)}static h(L,d,p,A){const r=this.b(L,new u.Range(1,1,d.lineNumber,d.column),p,A,10*w);if(r.length>0)return r[r.length-1];const s=L.getLineCount();return d.lineNumber!==s||d.column!==L.getLineMaxColumn(s)?this.h(L,new i.Position(s,L.getLineMaxColumn(s)),p,A):null}static j(L,d,p,A){const r=L.getLineCount(),s=d.lineNumber,c=L.getLineContent(s).substring(0,d.column-1),a=this.k(p,c,s,A);if(a)return a;for(let v=1;v<=r;v++){const f=(r+s-v-1)%r,o=L.getLineContent(f+1),R=this.k(p,o,f+1,A);if(R)return R}return null}static k(L,d,p,A){let r=null,s;for(L.reset(0);s=L.next(d);)r=N(new u.Range(p,s.index+1,p,s.index+1+s[0].length),s,A);return r}}t.TextModelSearch=b;function m(_,L,d,p,A){if(p===0)return!0;const r=L.charCodeAt(p-1);if(_.get(r)!==0||r===13||r===10)return!0;if(A>0){const s=L.charCodeAt(p);if(_.get(s)!==0)return!0}return!1}function e(_,L,d,p,A){if(p+A===d)return!0;const r=L.charCodeAt(p+A);if(_.get(r)!==0||r===13||r===10)return!0;if(A>0){const s=L.charCodeAt(p+A-1);if(_.get(s)!==0)return!0}return!1}function E(_,L,d,p,A){return m(_,L,d,p,A)&&e(_,L,d,p,A)}t.isValidMatch=E;class D{constructor(L,d){this._wordSeparators=L,this.a=d,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const d=L.length;let p;do{if(this.b+this.c===d||(p=this.a.exec(L),!p))return null;const A=p.index,r=p[0].length;if(A===this.b&&r===this.c){if(r===0){F.getNextCodePoint(L,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=A,this.c=r,!this._wordSeparators||E(this._wordSeparators,L,d,A,r))return p}while(p);return null}}t.Searcher=D}),Z(ee[49],te([0,1,2,48,4,10,24]),function(q,t,F,S,i,u,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class w{static computeUnicodeHighlights(e,E,D){const _=D?D.startLineNumber:1,L=D?D.endLineNumber:e.getLineCount(),d=new N(E),p=d.getCandidateCodePoints();let A;p==="allNonBasicAscii"?A=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):A=new RegExp(`${l(Array.from(p))}`,"g");const r=new S.Searcher(null,A),s=[];let c=!1,a,v=0,f=0,o=0;e:for(let R=_,g=L;R<=g;R++){const k=e.getLineContent(R),O=k.length;r.reset(0);do if(a=r.next(k),a){let C=a.index,V=a.index+a[0].length;if(C>0){const X=k.charCodeAt(C-1);i.isHighSurrogate(X)&&C--}if(V+1<O){const X=k.charCodeAt(V-1);i.isHighSurrogate(X)&&V++}const H=k.substring(C,V);let $=(0,y.getWordAtText)(C+1,y.DEFAULT_WORD_REGEXP,k,0);$&&$.endColumn<=C+1&&($=null);const K=d.shouldHighlightNonBasicASCII(H,$?$.word:null);if(K!==0){K===3?v++:K===2?f++:K===1?o++:(0,u.assertNever)(K);const X=1e3;if(s.length>=X){c=!0;break e}s.push(new F.Range(R,C+1,R,V+1))}}while(a)}return{ranges:s,hasMore:c,ambiguousCharacterCount:v,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:o}}static computeUnicodeHighlightReason(e,E){const D=new N(E);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),d=D.ambiguousCharacters.getPrimaryConfusable(L),p=i.AmbiguousCharacters.getLocales().filter(A=>!i.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,A])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=w;function l(m,e){return`[${i.escapeRegExpCharacters(m.map(D=>String.fromCodePoint(D)).join(""))}]`}var h;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(h=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class N{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of i.InvisibleCharacters.codePoints)M(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const D=e.codePointAt(0);if(this.a.has(D))return 0;if(this.b.nonBasicASCII)return 1;let _=!1,L=!1;if(E)for(const d of E){const p=d.codePointAt(0),A=i.isBasicASCII(d);_=_||A,!A&&!this.ambiguousCharacters.isAmbiguous(p)&&!i.InvisibleCharacters.isInvisibleCharacter(p)&&(L=!0)}return!_&&L?0:this.b.invisibleCharacters&&!M(e)&&i.InvisibleCharacters.isInvisibleCharacter(D)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function M(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),Z(ee[50],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F=t.AccessibilitySupport||(t.AccessibilitySupport={}));var S;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(S=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u=t.CompletionItemKind||(t.CompletionItemKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=t.CompletionItemTag||(t.CompletionItemTag={}));var w;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var h;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(h=t.CursorChangeReason||(t.CursorChangeReason={}));var N;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(N=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var M;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(M=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.parameterHints=82]="parameterHints",n[n.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",n[n.quickSuggestions=85]="quickSuggestions",n[n.quickSuggestionsDelay=86]="quickSuggestionsDelay",n[n.readOnly=87]="readOnly",n[n.renameOnType=88]="renameOnType",n[n.renderControlCharacters=89]="renderControlCharacters",n[n.renderFinalNewline=90]="renderFinalNewline",n[n.renderLineHighlight=91]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=93]="renderValidationDecorations",n[n.renderWhitespace=94]="renderWhitespace",n[n.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",n[n.roundedSelection=96]="roundedSelection",n[n.rulers=97]="rulers",n[n.scrollbar=98]="scrollbar",n[n.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=100]="scrollBeyondLastLine",n[n.scrollPredominantAxis=101]="scrollPredominantAxis",n[n.selectionClipboard=102]="selectionClipboard",n[n.selectionHighlight=103]="selectionHighlight",n[n.selectOnLineNumbers=104]="selectOnLineNumbers",n[n.showFoldingControls=105]="showFoldingControls",n[n.showUnused=106]="showUnused",n[n.snippetSuggestions=107]="snippetSuggestions",n[n.smartSelect=108]="smartSelect",n[n.smoothScrolling=109]="smoothScrolling",n[n.stickyScroll=110]="stickyScroll",n[n.stickyTabStops=111]="stickyTabStops",n[n.stopRenderingLineAfter=112]="stopRenderingLineAfter",n[n.suggest=113]="suggest",n[n.suggestFontSize=114]="suggestFontSize",n[n.suggestLineHeight=115]="suggestLineHeight",n[n.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",n[n.suggestSelection=117]="suggestSelection",n[n.tabCompletion=118]="tabCompletion",n[n.tabIndex=119]="tabIndex",n[n.unicodeHighlighting=120]="unicodeHighlighting",n[n.unusualLineTerminators=121]="unusualLineTerminators",n[n.useShadowDOM=122]="useShadowDOM",n[n.useTabStops=123]="useTabStops",n[n.wordBreak=124]="wordBreak",n[n.wordSeparators=125]="wordSeparators",n[n.wordWrap=126]="wordWrap",n[n.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=129]="wordWrapColumn",n[n.wordWrapOverride1=130]="wordWrapOverride1",n[n.wordWrapOverride2=131]="wordWrapOverride2",n[n.wrappingIndent=132]="wrappingIndent",n[n.wrappingStrategy=133]="wrappingStrategy",n[n.showDeprecated=134]="showDeprecated",n[n.inlayHints=135]="inlayHints",n[n.editorClassName=136]="editorClassName",n[n.pixelRatio=137]="pixelRatio",n[n.tabFocusMode=138]="tabFocusMode",n[n.layoutInfo=139]="layoutInfo",n[n.wrappingInfo=140]="wrappingInfo"})(m=t.EditorOption||(t.EditorOption={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E=t.EndOfLineSequence||(t.EndOfLineSequence={}));var D;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(D=t.IndentAction||(t.IndentAction={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var L;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(L=t.InlayHintKind||(t.InlayHintKind={}));var d;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(d=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var p;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(p=t.KeyCode||(t.KeyCode={}));var A;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(A=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var c;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(c=t.MouseTargetType||(t.MouseTargetType={}));var a;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(a=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var v;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(v=t.OverviewRulerLane||(t.OverviewRulerLane={}));var f;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(f=t.PositionAffinity||(t.PositionAffinity={}));var o;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(o=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var R;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(R=t.RenderMinimap||(t.RenderMinimap={}));var g;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(g=t.ScrollType||(t.ScrollType={}));var k;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(k=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var O;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(O=t.SelectionDirection||(t.SelectionDirection={}));var C;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(C=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var V;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(V=t.SymbolKind||(t.SymbolKind={}));var H;(function(n){n[n.Deprecated=1]="Deprecated"})(H=t.SymbolTag||(t.SymbolTag={}));var $;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})($=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var K;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(K=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var X;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(X=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var G;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(G=t.WrappingIndent||(t.WrappingIndent={}))}),Z(ee[51],te([0,1,8,6]),function(q,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new F.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,l){return this.a.set(w,l),this.handleChange([w]),(0,S.toDisposable)(()=>{this.a.get(w)===l&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,l){this.b.get(w)?.dispose();const h=new u(this,w,l);return this.b.set(w,h),(0,S.toDisposable)(()=>{const N=this.b.get(w);!N||N!==h||(this.b.delete(w),N.dispose())})}async getOrCreate(w){const l=this.get(w);if(l)return l;const h=this.b.get(w);return!h||h.isResolved?null:(await h.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const h=this.b.get(w);return!!(!h||h.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=i;class u extends S.Disposable{get isResolved(){return this.c}constructor(w,l,h){super(),this.f=w,this.g=l,this.h=h,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),Z(ee[52],te([0,1,34,12,2,51]),function(q,t,F,S,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class y{constructor(k,O,C){this.offset=k,this.type=O,this.language=C,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=y;class w{constructor(k,O){this.tokens=k,this.endState=O,this._tokenizationResultBrand=void 0}}t.TokenizationResult=w;class l{constructor(k,O){this.tokens=k,this.endState=O,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=l;var h;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(h=t.CompletionItemKind||(t.CompletionItemKind={}));var N;(function(g){const k=new Map;k.set(0,F.Codicon.symbolMethod),k.set(1,F.Codicon.symbolFunction),k.set(2,F.Codicon.symbolConstructor),k.set(3,F.Codicon.symbolField),k.set(4,F.Codicon.symbolVariable),k.set(5,F.Codicon.symbolClass),k.set(6,F.Codicon.symbolStruct),k.set(7,F.Codicon.symbolInterface),k.set(8,F.Codicon.symbolModule),k.set(9,F.Codicon.symbolProperty),k.set(10,F.Codicon.symbolEvent),k.set(11,F.Codicon.symbolOperator),k.set(12,F.Codicon.symbolUnit),k.set(13,F.Codicon.symbolValue),k.set(15,F.Codicon.symbolEnum),k.set(14,F.Codicon.symbolConstant),k.set(15,F.Codicon.symbolEnum),k.set(16,F.Codicon.symbolEnumMember),k.set(17,F.Codicon.symbolKeyword),k.set(27,F.Codicon.symbolSnippet),k.set(18,F.Codicon.symbolText),k.set(19,F.Codicon.symbolColor),k.set(20,F.Codicon.symbolFile),k.set(21,F.Codicon.symbolReference),k.set(22,F.Codicon.symbolCustomColor),k.set(23,F.Codicon.symbolFolder),k.set(24,F.Codicon.symbolTypeParameter),k.set(25,F.Codicon.account),k.set(26,F.Codicon.issues);function O(H){let $=k.get(H);return $||(console.info("No codicon found for CompletionItemKind "+H),$=F.Codicon.symbolProperty),$}g.toIcon=O;const C=new Map;C.set("method",0),C.set("function",1),C.set("constructor",2),C.set("field",3),C.set("variable",4),C.set("class",5),C.set("struct",6),C.set("interface",7),C.set("module",8),C.set("property",9),C.set("event",10),C.set("operator",11),C.set("unit",12),C.set("value",13),C.set("constant",14),C.set("enum",15),C.set("enum-member",16),C.set("enumMember",16),C.set("keyword",17),C.set("snippet",27),C.set("text",18),C.set("color",19),C.set("file",20),C.set("reference",21),C.set("customcolor",22),C.set("folder",23),C.set("type-parameter",24),C.set("typeParameter",24),C.set("account",25),C.set("issue",26);function V(H,$){let K=C.get(H);return typeof K>"u"&&!$&&(K=9),K}g.fromString=V})(N=t.CompletionItemKinds||(t.CompletionItemKinds={}));var M;(function(g){g[g.Deprecated=1]="Deprecated"})(M=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(g){g[g.None=0]="None",g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(b=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var E;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(E=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var D;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(D=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var _;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(_=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function L(g){return g&&S.URI.isUri(g.uri)&&i.Range.isIRange(g.range)&&(i.Range.isIRange(g.originSelectionRange)||i.Range.isIRange(g.targetSelectionRange))}t.isLocationLink=L;var d;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(d=t.SymbolKind||(t.SymbolKind={}));var p;(function(g){g[g.Deprecated=1]="Deprecated"})(p=t.SymbolTag||(t.SymbolTag={}));var A;(function(g){const k=new Map;k.set(0,F.Codicon.symbolFile),k.set(1,F.Codicon.symbolModule),k.set(2,F.Codicon.symbolNamespace),k.set(3,F.Codicon.symbolPackage),k.set(4,F.Codicon.symbolClass),k.set(5,F.Codicon.symbolMethod),k.set(6,F.Codicon.symbolProperty),k.set(7,F.Codicon.symbolField),k.set(8,F.Codicon.symbolConstructor),k.set(9,F.Codicon.symbolEnum),k.set(10,F.Codicon.symbolInterface),k.set(11,F.Codicon.symbolFunction),k.set(12,F.Codicon.symbolVariable),k.set(13,F.Codicon.symbolConstant),k.set(14,F.Codicon.symbolString),k.set(15,F.Codicon.symbolNumber),k.set(16,F.Codicon.symbolBoolean),k.set(17,F.Codicon.symbolArray),k.set(18,F.Codicon.symbolObject),k.set(19,F.Codicon.symbolKey),k.set(20,F.Codicon.symbolNull),k.set(21,F.Codicon.symbolEnumMember),k.set(22,F.Codicon.symbolStruct),k.set(23,F.Codicon.symbolEvent),k.set(24,F.Codicon.symbolOperator),k.set(25,F.Codicon.symbolTypeParameter);function O(C){let V=k.get(C);return V||(console.info("No codicon found for SymbolKind "+C),V=F.Codicon.symbolProperty),V}g.toIcon=O})(A=t.SymbolKinds||(t.SymbolKinds={}));class r{static fromValue(k){switch(k){case"comment":return r.Comment;case"imports":return r.Imports;case"region":return r.Region}return new r(k)}constructor(k){this.value=k}}r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region"),t.FoldingRangeKind=r;var s;(function(g){function k(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}g.is=k})(s=t.Command||(t.Command={}));var c;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(c=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var a;(function(g){g[g.Unresolved=0]="Unresolved",g[g.Resolved=1]="Resolved"})(a=t.CommentThreadState||(t.CommentThreadState={}));var v;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(v=t.CommentMode||(t.CommentMode={}));var f;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(f=t.InlayHintKind||(t.InlayHintKind={}));class o{constructor(k){this.b=k,this.a=null}dispose(){this.a&&this.a.then(k=>{k&&k.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.LazyTokenizationSupport=o,t.TokenizationRegistry=new u.TokenizationRegistry;var R;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(R=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),Z(ee[53],te([0,1,18,8,28,12,3,2,35,52,50]),function(q,t,F,S,i,u,y,w,l,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class M{static chord(e,E){return(0,i.KeyChord)(e,E)}}M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256,t.KeyMod=M;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.CancellationTokenSource,Emitter:S.Emitter,KeyCode:N.KeyCode,KeyMod:M,Position:y.Position,Range:w.Range,Selection:l.Selection,SelectionDirection:N.SelectionDirection,MarkerSeverity:N.MarkerSeverity,MarkerTag:N.MarkerTag,Uri:u.URI,Token:h.Token}}t.createMonacoBaseAPI=b}),Z(ee[56],te([0,1,19,12,3,2,47,24,43,44,53,17,49,25,13,42,11,5]),function(q,t,F,S,i,u,y,w,l,h,N,M,b,m,e,E,D,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class L extends y.MirrorTextModel{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,s){const c=(0,w.getWordAtText)(r.column,(0,w.ensureValidWordDefinition)(s),this.f[r.lineNumber-1],0);return c?new u.Range(r.lineNumber,c.startColumn,r.lineNumber,c.endColumn):null}getWordUntilPosition(r,s){const c=this.getWordAtPosition(r,s);return c?{word:this.f[r.lineNumber-1].substring(c.startColumn-1,r.column-1),startColumn:c.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const s=this.f,c=this.q.bind(this);let a=0,v="",f=0,o=[];return{*[Symbol.iterator](){for(;;)if(f<o.length){const R=v.substring(o[f].start,o[f].end);f+=1,yield R}else if(a<s.length)v=s[a],o=c(v,r),f=0,a+=1;else break}}}getLineWords(r,s){const c=this.f[r-1],a=this.q(c,s),v=[];for(const f of a)v.push({word:c.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return v}q(r,s){const c=[];let a;for(s.lastIndex=0;(a=s.exec(r))&&a[0].length!==0;)c.push({start:a.index,end:a.index+a[0].length});return c}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const s=this.g,c=r.startLineNumber-1,a=r.endLineNumber-1,v=[];v.push(this.f[c].substring(r.startColumn-1));for(let f=c+1;f<a;f++)v.push(this.f[f]);return v.push(this.f[a].substring(0,r.endColumn-1)),v.join(s)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),c=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,c)}}r(r){const s=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),c=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return s.lineNumber!==r.startLineNumber||s.column!==r.startColumn||c.lineNumber!==r.endLineNumber||c.column!==r.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:c.lineNumber,endColumn:c.column}:r}s(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:s,column:c}=r,a=!1;if(s<1)s=1,c=1,a=!0;else if(s>this.f.length)s=this.f.length,c=this.f[s-1].length+1,a=!0;else{const v=this.f[s-1].length+1;c<1?(c=1,a=!0):c>v&&(c=v,a=!0)}return a?{lineNumber:s,column:c}:r}}class d{constructor(r,s){this.d=r,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(s=>r.push(this.f[s])),r}acceptNewModel(r){this.f[r.url]=new L(S.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,s){if(!this.f[r])return;this.f[r].onEvents(s)}acceptRemovedModel(r){!this.f[r]||delete this.f[r]}async computeUnicodeHighlights(r,s,c){const a=this.j(r);return a?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,s,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,s,c,a){const v=this.j(r),f=this.j(s);return!v||!f?null:d.l(v,f,c,a)}static l(r,s,c,a){const v=a==="experimental"?E.linesDiffComputers.experimental:E.linesDiffComputers.smart,f=r.getLinesContent(),o=s.getLinesContent(),R=v.computeDiff(f,o,c);return{identical:R.changes.length>0?!1:this.n(r,s),quitEarly:R.quitEarly,changes:R.changes.map(k=>[k.originalRange.startLineNumber,k.originalRange.endLineNumberExclusive,k.modifiedRange.startLineNumber,k.modifiedRange.endLineNumberExclusive,k.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}}static n(r,s){const c=r.getLineCount(),a=s.getLineCount();if(c!==a)return!1;for(let v=1;v<=c;v++){const f=r.getLineContent(v),o=s.getLineContent(v);if(f!==o)return!1}return!0}async computeDirtyDiff(r,s,c){const a=this.j(r),v=this.j(s);if(!a||!v)return null;const f=a.getLinesContent(),o=v.getLinesContent();return new m.DiffComputer(f,o,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,s,c){const a=this.j(r);if(!a)return s;const v=[];let f;s=s.slice(0).sort((o,R)=>{if(o.range&&R.range)return u.Range.compareRangesUsingStarts(o.range,R.range);const g=o.range?0:1,k=R.range?0:1;return g-k});for(let{range:o,text:R,eol:g}of s){if(typeof g=="number"&&(f=g),u.Range.isEmpty(o)&&!R)continue;const k=a.getValueInRange(o);if(R=R.replace(/\r\n|\n|\r/g,a.eol),k===R)continue;if(Math.max(R.length,k.length)>d.o){v.push({range:o,text:R});continue}const O=(0,F.stringDiff)(k,R,c),C=a.offsetAt(u.Range.lift(o).getStartPosition());for(const V of O){const H=a.positionAt(C+V.originalStart),$=a.positionAt(C+V.originalStart+V.originalLength),K={text:R.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:H.lineNumber,startColumn:H.column,endLineNumber:$.lineNumber,endColumn:$.column}};a.getValueInRange(K.range)!==K.text&&v.push(K)}}return typeof f=="number"&&v.push({eol:f,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeHumanReadableDiff(r,s){const c=this.j(r);if(!c)return s;const a=[];let v;s=s.slice(0).sort((f,o)=>{if(f.range&&o.range)return u.Range.compareRangesUsingStarts(f.range,o.range);const R=f.range?0:1,g=o.range?0:1;return R-g});for(let{range:f,text:o,eol:R}of s){let V=function(G,n,ue){return G.map(ae=>ae.innerChanges?new e.LineRangeMapping(ae.originalRange,ae.modifiedRange,ae.innerChanges.map(ie=>ie.originalRange.endColumn===1&&ie.originalRange.endLineNumber>n?ie.originalRange.isEmpty()||ie.modifiedRange.isEmpty()?new e.RangeMapping(new u.Range(ie.originalRange.startLineNumber-1,Number.MAX_SAFE_INTEGER,ie.originalRange.endLineNumber-1,Number.MAX_SAFE_INTEGER),new u.Range(ie.modifiedRange.startLineNumber-1,Number.MAX_SAFE_INTEGER,ie.modifiedRange.endLineNumber-1,Number.MAX_SAFE_INTEGER)):new e.RangeMapping(new u.Range(ie.originalRange.startLineNumber,ie.originalRange.startColumn,ie.originalRange.endLineNumber-1,Number.MAX_SAFE_INTEGER),new u.Range(ie.modifiedRange.startLineNumber,ie.modifiedRange.startColumn,ie.modifiedRange.endLineNumber-1,Number.MAX_SAFE_INTEGER)):ie)):ae)},K=function(G,n){return new i.Position(G.lineNumber+n.lineNumber-1,n.lineNumber===1?G.column+n.column-1:n.column)},X=function(G,n){const ue=[];for(let ae=n.startLineNumber;ae<=n.endLineNumber;ae++){const ie=G[ae-1];ae===n.startLineNumber&&ae===n.endLineNumber?ue.push(ie.substring(n.startColumn-1,n.endColumn-1)):ae===n.startLineNumber?ue.push(ie.substring(n.startColumn-1)):ae===n.endLineNumber?ue.push(ie.substring(0,n.endColumn-1)):ue.push(ie)}return ue};if(typeof R=="number"&&(v=R),u.Range.isEmpty(f)&&!o)continue;const g=c.getValueInRange(f);if(o=o.replace(/\r\n|\n|\r/g,c.eol),g===o)continue;if(Math.max(o.length,g.length)>d.o){a.push({range:f,text:o});continue}const k=g.split(/\r\n|\n|\r/),O=o.split(/\r\n|\n|\r/),C=E.linesDiffComputers.experimental.computeDiff(k,O,{maxComputationTimeMs:1e3,ignoreTrimWhitespace:!1}),H=V(C.changes,k.length,O.length),$=u.Range.lift(f).getStartPosition();for(const G of H)if(G.innerChanges)for(const n of G.innerChanges)a.push({range:u.Range.fromPositions(K($,n.originalRange.getStartPosition()),K($,n.originalRange.getEndPosition())),text:X(O,n.modifiedRange).join(c.eol)});else throw new _.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof v=="number"&&a.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a}async computeLinks(r){const s=this.j(r);return s?(0,l.computeLinks)(s):null}async textualSuggest(r,s,c,a){const v=new M.StopWatch(!0),f=new RegExp(c,a),o=new Set;e:for(const R of r){const g=this.j(R);if(!!g){for(const k of g.words(f))if(!(k===s||!isNaN(Number(k)))&&(o.add(k),o.size>d.p))break e}}return{words:Array.from(o),duration:v.elapsed()}}async computeWordRanges(r,s,c,a){const v=this.j(r);if(!v)return Object.create(null);const f=new RegExp(c,a),o=Object.create(null);for(let R=s.startLineNumber;R<s.endLineNumber;R++){const g=v.getLineWords(R,f);for(const k of g){if(!isNaN(Number(k.word)))continue;let O=o[k.word];O||(O=[],o[k.word]=O),O.push({startLineNumber:R,startColumn:k.startColumn,endLineNumber:R,endColumn:k.endColumn})}}return o}async navigateValueSet(r,s,c,a,v){const f=this.j(r);if(!f)return null;const o=new RegExp(a,v);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const R=f.getValueInRange(s),g=f.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},o);if(!g)return null;const k=f.getValueInRange(g);return h.BasicInplaceReplace.INSTANCE.navigateValueSet(s,R,g,k,c)}loadForeignModule(r,s,c){const a=(o,R)=>this.d.fhr(o,R),f={host:(0,D.createProxyObject)(c,a),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(f,s),Promise.resolve((0,D.getAllMethodNames)(this.h))):new Promise((o,R)=>{q([r],g=>{this.h=g.create(f,s),o((0,D.getAllMethodNames)(this.h))},R)})}fmr(r,s){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,s))}catch(c){return Promise.reject(c)}}}d.o=1e5,d.p=1e4,t.EditorSimpleWorker=d;function p(A){return new d(A,null)}t.create=p,typeof importScripts=="function"&&(globalThis.monaco=(0,N.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
