"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/objects","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/server/node/serverEnvironmentService","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/uriIpc","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/hash","vs/base/common/glob","path","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],ve=function(ae){for(var e=[],y=0,R=ae.length;y<R;y++)e[y]=pe[ae[y]];return e};define(pe[139],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class y{static get(){const a=new Map,D=new Map,C=new Map,k=new Map;function v(m,p){m.has(p.detail)||m.set(p.detail,-p.timestamp)}function g(m,p){const b=m.get(p.detail);!b||b>=0||m.set(p.detail,b+p.timestamp)}let T=[];typeof ae.getStats=="function"&&(T=ae.getStats().slice(0).sort((m,p)=>m.timestamp-p.timestamp));for(const m of T)switch(m.type){case 10:v(a,m);break;case 11:case 12:g(a,m);break;case 21:v(D,m);break;case 22:g(D,m);break;case 33:v(C,m);break;case 34:g(C,m);break;case 31:v(k,m);break;case 32:g(k,m);break}let I=0;C.forEach(m=>I+=m);function E(m){const p=[];return m.forEach((b,o)=>p.push([o,b])),p}return{amdLoad:E(a),amdInvoke:E(D),nodeRequire:E(C),nodeEval:E(k),nodeRequireTotal:I}}static toMarkdownTable(a,D){let C="";const k=[];return a.forEach((v,g)=>{k[g]=v.length}),D.forEach(v=>{v.forEach((g,T)=>{typeof g>"u"&&(g=v[T]="-");const I=g.toString().length;k[T]=Math.max(I,k[T])})}),a.forEach((v,g)=>{C+=`| ${v+" ".repeat(k[g]-v.toString().length)} `}),C+=`|
`,a.forEach((v,g)=>{C+=`| ${"-".repeat(k[g])} `}),C+=`|
`,D.forEach(v=>{v.forEach((g,T)=>{typeof g<"u"&&(C+=`| ${g+" ".repeat(k[T]-g.toString().length)} `)}),C+=`|
`}),C}}e.LoaderStats=y}),define(pe[90],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function y(C){return(k,v,g)=>{let T=null,I=null;if(typeof g.value=="function"?(T="value",I=g.value):typeof g.get=="function"&&(T="get",I=g.get),!I)throw new Error("not supported");g[T]=C(I,v)}}function R(C,k,v){let g=null,T=null;if(typeof v.value=="function"?(g="value",T=v.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(g="get",T=v.get),!T)throw new Error("not supported");const I=`$memoize$${k}`;v[g]=function(...E){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,E)}),this[I]}}e.memoize=R;function a(C,k,v){return y((g,T)=>{const I=`$debounce$${T}`,E=`$debounce$result$${T}`;return function(...m){this[E]||(this[E]=v?v():void 0),clearTimeout(this[I]),k&&(this[E]=k(this[E],...m),m=[this[E]]),this[I]=setTimeout(()=>{g.apply(this,m),this[E]=v?v():void 0},C)}})}e.debounce=a;function D(C,k,v){return y((g,T)=>{const I=`$throttle$timer$${T}`,E=`$throttle$result$${T}`,m=`$throttle$lastRun$${T}`,p=`$throttle$pending$${T}`;return function(...b){if(this[E]||(this[E]=v?v():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...b)),this[p])return;const o=this[m]+C;o<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[E]]),this[E]=v?v():void 0):(this[p]=!0,this[I]=setTimeout(()=>{this[p]=!1,this[m]=Date.now(),g.apply(this,[this[E]]),this[E]=v?v():void 0},o-Date.now()))}})}e.throttle=D}),define(pe[9],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=y,e.errorHandler=new y;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function a(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=a;function D(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=D;function C(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function k(t){if(t instanceof Error){const{name:n,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const v="Canceled";function g(t){return t instanceof T?!0:t instanceof Error&&t.name===v&&t.message===v}e.isCancellationError=g;class T extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=T;function I(){const t=new Error(v);return t.name=t.message,t}e.canceled=I;function E(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=E;function m(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=m;function p(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function b(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=b;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class d extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=d;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=h;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const r=new w;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class L extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(pe[18],ve([1,0,9]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(j,H=0){return j[j.length-(1+H)]}e.tail=R;function a(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=a;function D(j,H,J=(V,X)=>V===X){if(j===H)return!0;if(!j||!H||j.length!==H.length)return!1;for(let V=0,X=j.length;V<X;V++)if(!J(j[V],H[V]))return!1;return!0}e.equals=D;function C(j,H){const J=j.length-1;H<J&&(j[H]=j[J]),j.pop()}e.removeFastWithoutKeepingOrder=C;function k(j,H,J){return v(j.length,V=>J(j[V],H))}e.binarySearch=k;function v(j,H){let J=0,V=j-1;for(;J<=V;){const X=(J+V)/2|0,x=H(X);if(x<0)J=X+1;else if(x>0)V=X-1;else return X}return-(J+1)}e.binarySearch2=v;function g(j,H){let J=0,V=j.length;if(V===0)return 0;for(;J<V;){const X=Math.floor((J+V)/2);H(j[X])?V=X:J=X+1}return J}e.findFirstInSorted=g;function T(j,H,J){if(j=j|0,j>=H.length)throw new TypeError("invalid index");const V=H[Math.floor(H.length*Math.random())],X=[],x=[],Q=[];for(const ce of H){const Ee=J(ce,V);Ee<0?X.push(ce):Ee>0?x.push(ce):Q.push(ce)}return j<X.length?T(j,X,J):j<X.length+Q.length?Q[0]:T(j-(X.length+Q.length),x,J)}e.quickSelect=T;function I(j,H){const J=[];let V;for(const X of j.slice(0).sort(H))!V||H(V[0],X)!==0?(V=[X],J.push(V)):V.push(X);return J}e.groupBy=I;function E(j,H,J){const V=[];function X(ce,Ee,Ce){if(Ee===0&&Ce.length===0)return;const ke=V[V.length-1];ke&&ke.start+ke.deleteCount===ce?(ke.deleteCount+=Ee,ke.toInsert.push(...Ce)):V.push({start:ce,deleteCount:Ee,toInsert:Ce})}let x=0,Q=0;for(;;){if(x===j.length){X(x,0,H.slice(Q));break}if(Q===H.length){X(x,j.length-x,[]);break}const ce=j[x],Ee=H[Q],Ce=J(ce,Ee);Ce===0?(x+=1,Q+=1):Ce<0?(X(x,1,[]),x+=1):Ce>0&&(X(x,0,[Ee]),Q+=1)}return V}e.sortedDiff=E;function m(j,H,J){const V=E(j,H,J),X=[],x=[];for(const Q of V)X.push(...j.slice(Q.start,Q.start+Q.deleteCount)),x.push(...Q.toInsert);return{removed:X,added:x}}e.delta=m;function p(j,H,J){if(J===0)return[];const V=j.slice(0,J).sort(H);return o(j,H,V,J,j.length),V}e.top=p;function b(j,H,J,V,X){return J===0?Promise.resolve([]):new Promise((x,Q)=>{(async()=>{const ce=j.length,Ee=j.slice(0,J).sort(H);for(let Ce=J,ke=Math.min(J+V,ce);Ce<ce;Ce=ke,ke=Math.min(ke+V,ce)){if(Ce>J&&await new Promise(Me=>setTimeout(Me)),X&&X.isCancellationRequested)throw new y.CancellationError;o(j,H,Ee,Ce,ke)}return Ee})().then(x,Q)})}e.topAsync=b;function o(j,H,J,V,X){for(const x=J.length;V<X;V++){const Q=j[V];if(H(Q,J[x-1])<0){J.pop();const ce=g(J,Ee=>H(Q,Ee)<0);J.splice(ce,0,Q)}}}function d(j){return j.filter(H=>!!H)}e.coalesce=d;function h(j){let H=0;for(let J=0;J<j.length;J++)j[J]&&(j[H]=j[J],H+=1);j.length=H}e.coalesceInPlace=h;function f(j,H,J){j.splice(J,0,j.splice(H,1)[0])}e.move=f;function w(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=w;function L(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=L;function t(j,H=J=>J){const J=new Set;return j.filter(V=>{const X=H(V);return J.has(X)?!1:(J.add(X),!0)})}e.distinct=t;function n(j){const H=new Set;return J=>{const V=j(J);return H.has(V)?!1:(H.add(V),!0)}}e.uniqueFilter=n;function r(j,H){const J=i(j,H);if(J!==-1)return j[J]}e.findLast=r;function i(j,H){for(let J=j.length-1;J>=0;J--){const V=j[J];if(H(V))return J}return-1}e.lastIndex=i;function l(j,H){return j.length>0?j[0]:H}e.firstOrDefault=l;function c(j,H){return j.length>0?j[j.length-1]:H}e.lastOrDefault=c;function s(j,H,J=(V,X)=>V===X){let V=0;for(let X=0,x=Math.min(j.length,H.length);X<x&&J(j[X],H[X]);X++)V++;return V}e.commonPrefixLength=s;function u(j){return[].concat(...j)}e.flatten=u;function S(j,H){let J=typeof H=="number"?j:0;typeof H=="number"?J=j:(J=0,H=j);const V=[];if(J<=H)for(let X=J;X<H;X++)V.push(X);else for(let X=J;X>H;X--)V.push(X);return V}e.range=S;function A(j,H,J){return j.reduce((V,X)=>(V[H(X)]=J?J(X):X,V),Object.create(null))}e.index=A;function O(j,H){return j.push(H),()=>B(j,H)}e.insert=O;function B(j,H){const J=j.indexOf(H);if(J>-1)return j.splice(J,1),H}e.remove=B;function q(j,H,J){const V=j.slice(0,H),X=j.slice(H);return V.concat(J,X)}e.arrayInsert=q;function le(j,H){let J;if(typeof H=="number"){let V=H;J=()=>{const X=Math.sin(V++)*179426549;return X-Math.floor(X)}}else J=Math.random;for(let V=j.length-1;V>0;V-=1){const X=Math.floor(J()*(V+1)),x=j[V];j[V]=j[X],j[X]=x}}e.shuffle=le;function fe(j,H){const J=j.indexOf(H);J>-1&&(j.splice(J,1),j.unshift(H))}e.pushToStart=fe;function ue(j,H){const J=j.indexOf(H);J>-1&&(j.splice(J,1),j.push(H))}e.pushToEnd=ue;function re(j,H){for(const J of H)j.push(J)}e.pushMany=re;function _(j,H){return Array.isArray(j)?j.map(H):H(j)}e.mapArrayOrNot=_;function ee(j){return Array.isArray(j)?j:[j]}e.asArray=ee;function ne(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ne;function ie(j,H){for(const J of j){const V=H(J);if(V!==void 0)return V}}e.mapFind=ie;function G(j,H,J){const V=Z(j,H),X=j.length,x=J.length;j.length=X+x;for(let Q=X-1;Q>=V;Q--)j[Q+x]=j[Q];for(let Q=0;Q<x;Q++)j[Q+V]=J[Q]}e.insertInto=G;function U(j,H,J,V){const X=Z(j,H),x=j.splice(X,J);return G(j,X,V),x}e.splice=U;function Z(j,H){return H<0?Math.max(H+j.length,0):Math.min(H,j.length)}var oe;(function(j){function H(X){return X<0}j.isLessThan=H;function J(X){return X>0}j.isGreaterThan=J;function V(X){return X===0}j.isNeitherLessOrGreaterThan=V,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(oe=e.CompareResult||(e.CompareResult={}));function me(j,H){return(J,V)=>H(j(J),j(V))}e.compareBy=me;function $(...j){return(H,J)=>{for(const V of j){const X=V(H,J);if(!oe.isNeitherLessOrGreaterThan(X))return X}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const W=(j,H)=>j-H;e.numberComparator=W;function N(j,H){if(j.length===0)return;let J=j[0];for(let V=1;V<j.length;V++){const X=j[V];H(X,J)>0&&(J=X)}return J}e.findMaxBy=N;function P(j,H){if(j.length===0)return;let J=j[0];for(let V=1;V<j.length;V++){const X=j[V];H(X,J)>=0&&(J=X)}return J}e.findLastMaxBy=P;function M(j,H){return N(j,(J,V)=>-H(J,V))}e.findMinBy=M;class K{constructor(H){this.f=H,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(H){let J=this.c;for(;J<this.f.length&&H(this.f[J]);)J++;const V=J===this.c?null:this.f.slice(this.c,J);return this.c=J,V}takeFromEndWhile(H){let J=this.d;for(;J>=0&&H(this.f[J]);)J--;const V=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const H=this.f[this.c];return this.c++,H}removeLast(){const H=this.f[this.d];return this.d--,H}takeCount(H){const J=this.f.slice(this.c,this.c+H);return this.c+=H,J}}e.ArrayQueue=K;class te{constructor(H){this.iterate=H}forEach(H){this.iterate(J=>(H(J),!0))}toArray(){const H=[];return this.iterate(J=>(H.push(J),!0)),H}filter(H){return new te(J=>this.iterate(V=>H(V)?J(V):!0))}map(H){return new te(J=>this.iterate(V=>J(H(V))))}some(H){let J=!1;return this.iterate(V=>(J=H(V),!J)),J}findFirst(H){let J;return this.iterate(V=>H(V)?(J=V,!1):!0),J}findLast(H){let J;return this.iterate(V=>(H(V)&&(J=V),!0)),J}findLastMaxBy(H){let J,V=!0;return this.iterate(X=>((V||oe.isGreaterThan(H(X,J)))&&(V=!1,J=X),!0)),J}}te.empty=new te(j=>{}),e.CallbackIterable=te}),define(pe[91],ve([1,0,9]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(v,g){if(!v)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=R;function a(v,g="Unreachable"){throw new Error(g)}e.assertNever=a;function D(v){if(!v)throw new y.BugIndicatingError("Assertion Failed")}e.assert=D;function C(v){if(!v()){debugger;v(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function k(v,g){let T=0;for(;T<v.length-1;){const I=v[T],E=v[T+1];if(!g(I,E))return!1;T++}return!0}e.checkAdjacentItems=k}),define(pe[71],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(R){const a=this;let D=!1,C;return function(){return D||(D=!0,C=R.apply(a,arguments)),C}}e.once=y}),define(pe[56],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(R){function a(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}R.is=a;const D=Object.freeze([]);function C(){return D}R.empty=C;function*k(w){yield w}R.single=k;function v(w){return a(w)?w:k(w)}R.wrap=v;function g(w){return w||D}R.from=g;function T(w){return!w||w[Symbol.iterator]().next().done===!0}R.isEmpty=T;function I(w){return w[Symbol.iterator]().next().value}R.first=I;function E(w,L){for(const t of w)if(L(t))return!0;return!1}R.some=E;function m(w,L){for(const t of w)if(L(t))return t}R.find=m;function*p(w,L){for(const t of w)L(t)&&(yield t)}R.filter=p;function*b(w,L){let t=0;for(const n of w)yield L(n,t++)}R.map=b;function*o(...w){for(const L of w)for(const t of L)yield t}R.concat=o;function d(w,L,t){let n=t;for(const r of w)n=L(n,r);return n}R.reduce=d;function*h(w,L,t=w.length){for(L<0&&(L+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);L<t;L++)yield w[L]}R.slice=h;function f(w,L=Number.POSITIVE_INFINITY){const t=[];if(L===0)return[t,w];const n=w[Symbol.iterator]();for(let r=0;r<L;r++){const i=n.next();if(i.done)return[t,R.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}R.consume=f})(y=e.Iterable||(e.Iterable={}))}),define(pe[72],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var a;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(a=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function C(t,n=!1){let r=0;const i=t.length;let l="",c=0,s=16,u=0;function S(ue){let re=0,_=0;for(;re<ue;){const ee=t.charCodeAt(r);if(ee>=48&&ee<=57)_=_*16+ee-48;else if(ee>=65&&ee<=70)_=_*16+ee-65+10;else if(ee>=97&&ee<=102)_=_*16+ee-97+10;else break;r++,re++}return re<ue&&(_=-1),_}function A(ue){r=ue,l="",c=0,s=16,u=0}function O(){const ue=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return u=3,t.substring(ue,r);let re=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;re=r}else u=3;return t.substring(ue,re)}function B(){let ue="",re=r;for(;;){if(r>=i){ue+=t.substring(re,r),u=2;break}const _=t.charCodeAt(r);if(_===34){ue+=t.substring(re,r),r++;break}if(_===92){if(ue+=t.substring(re,r),r++,r>=i){u=2;break}switch(t.charCodeAt(r++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const ne=S(4);ne>=0?ue+=String.fromCharCode(ne):u=4;break}default:u=5}re=r;continue}if(_>=0&&_<=31)if(v(_)){ue+=t.substring(re,r),u=2;break}else u=6;r++}return ue}function q(){if(l="",u=0,c=r,r>=i)return c=i,s=17;let ue=t.charCodeAt(r);if(k(ue)){do r++,l+=String.fromCharCode(ue),ue=t.charCodeAt(r);while(k(ue));return s=15}if(v(ue))return r++,l+=String.fromCharCode(ue),ue===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),s=14;switch(ue){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,l=B(),s=10;case 47:{const re=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!v(t.charCodeAt(r));)r++;return l=t.substring(re,r),s=12}if(t.charCodeAt(r+1)===42){r+=2;const _=i-1;let ee=!1;for(;r<_;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ee=!0;break}r++}return ee||(r++,u=1),l=t.substring(re,r),s=13}return l+=String.fromCharCode(ue),r++,s=16}case 45:if(l+=String.fromCharCode(ue),r++,r===i||!g(t.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=O(),s=11;default:for(;r<i&&le(ue);)r++,ue=t.charCodeAt(r);if(c!==r){switch(l=t.substring(c,r),l){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return l+=String.fromCharCode(ue),r++,s=16}}function le(ue){if(k(ue)||v(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let ue;do ue=q();while(ue>=12&&ue<=15);return ue}return{setPosition:A,getPosition:()=>r,scan:n?fe:q,getToken:()=>s,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>u}}e.createScanner=C;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function I(t,n){const r=[],i=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(S,A,O,B){c.value=S,c.offset=A,c.length=O,c.type=B,c.colonOffset=void 0,l=c}try{f(t,{onObjectBegin:(S,A)=>{if(n<=S)throw i;l=void 0,s=n>S,r.push("")},onObjectProperty:(S,A,O)=>{if(n<A||(u(S,A,O,"property"),r[r.length-1]=S,n<=A+O))throw i},onObjectEnd:(S,A)=>{if(n<=S)throw i;l=void 0,r.pop()},onArrayBegin:(S,A)=>{if(n<=S)throw i;l=void 0,r.push(0)},onArrayEnd:(S,A)=>{if(n<=S)throw i;l=void 0,r.pop()},onLiteralValue:(S,A,O)=>{if(n<A||(u(S,A,O,L(S)),n<=A+O))throw i},onSeparator:(S,A,O)=>{if(n<=A)throw i;if(S===":"&&l&&l.type==="property")l.colonOffset=A,s=!1,l=void 0;else if(S===","){const B=r[r.length-1];typeof B=="number"?r[r.length-1]=B+1:(s=!0,r[r.length-1]=""),l=void 0}}})}catch(S){if(S!==i)throw S}return{path:r,previousNode:l,isAtPropertyKey:s,matches:S=>{let A=0;for(let O=0;A<S.length&&O<r.length;O++)if(S[A]===r[O]||S[A]==="*")A++;else if(S[A]!=="**")return!1;return A===S.length}}}e.getLocation=I;function E(t,n=[],r=D.DEFAULT){let i=null,l=[];const c=[];function s(S){Array.isArray(l)?l.push(S):i!==null&&(l[i]=S)}return f(t,{onObjectBegin:()=>{const S={};s(S),c.push(l),l=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const S=[];s(S),c.push(l),l=S,i=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:s,onError:(S,A,O)=>{n.push({error:S,offset:A,length:O})}},r),l[0]}e.parse=E;function m(t,n=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function c(S){return i.children.push(S),S}f(t,{onObjectBegin:S=>{i=c({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,A,O)=>{i=c({type:"property",offset:A,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:A,length:O,parent:i})},onObjectEnd:(S,A)=>{i.length=S+A-i.offset,i=i.parent,l(S+A)},onArrayBegin:(S,A)=>{i=c({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,A)=>{i.length=S+A-i.offset,i=i.parent,l(S+A)},onLiteralValue:(S,A,O)=>{c({type:L(S),offset:A,length:O,parent:i,value:S}),l(A+O)},onSeparator:(S,A,O)=>{i.type==="property"&&(S===":"?i.colonOffset=A:S===","&&l(A))},onError:(S,A,O)=>{n.push({error:S,offset:A,length:O})}},r);const u=i.children[0];return u&&delete u.parent,u}e.parseTree=m;function p(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],l=!0;break}if(!l)return}else{const l=i;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=p;function b(t){if(!t.parent||!t.parent.children)return[];const n=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=b;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=o(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function d(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=d;function h(t,n,r=!1){if(d(t,n,r)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=n;l++){const c=h(i[l],n,r);if(c)return c}return t}}e.findNodeAtOffset=h;function f(t,n,r=D.DEFAULT){const i=C(t,!1);function l(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(me){return me?$=>me($,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=l(n.onObjectBegin),u=c(n.onObjectProperty),S=l(n.onObjectEnd),A=l(n.onArrayBegin),O=l(n.onArrayEnd),B=c(n.onLiteralValue),q=c(n.onSeparator),le=l(n.onComment),fe=c(n.onError),ue=r&&r.disallowComments,re=r&&r.allowTrailingComma;function _(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:ue||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(me){case 12:case 13:ue?ee(10):le();break;case 16:ee(1);break;case 15:case 14:break;default:return me}}}function ee(me,$=[],W=[]){if(fe(me),$.length+W.length>0){let N=i.getToken();for(;N!==17;){if($.indexOf(N)!==-1){_();break}else if(W.indexOf(N)!==-1)break;N=_()}}}function ne(me){const $=i.getTokenValue();return me?B($):u($),_(),!0}function ie(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(ee(2),me=0)}catch{ee(2)}B(me);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return _(),!0}function G(){return i.getToken()!==10?(ee(3,[],[2,5]),!1):(ne(!1),i.getToken()===6?(q(":"),_(),oe()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function U(){s(),_();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||ee(4,[],[]),q(","),_(),i.getToken()===2&&re)break}else me&&ee(6,[],[]);G()||ee(4,[],[2,5]),me=!0}return S(),i.getToken()!==2?ee(7,[2],[]):_(),!0}function Z(){A(),_();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||ee(4,[],[]),q(","),_(),i.getToken()===4&&re)break}else me&&ee(6,[],[]);oe()||ee(4,[],[4,5]),me=!0}return O(),i.getToken()!==4?ee(8,[4],[]):_(),!0}function oe(){switch(i.getToken()){case 3:return Z();case 1:return U();case 10:return ne(!0);default:return ie()}}return _(),i.getToken()===17?r.allowEmptyContent?!0:(ee(4,[],[]),!1):oe()?(i.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.visit=f;function w(t,n){const r=C(t),i=[];let l,c=0,s;do switch(s=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:c!==s&&i.push(t.substring(c,s)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),c=r.getPosition();break}while(l!==17);return i.join("")}e.stripComments=w;function L(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(pe[140],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(a){this.d=a,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(a){this.c=a}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=y}),define(pe[2],ve([1,0,71,56]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const a=!1;let D=null;function C(c){D=c}if(e.setDisposableTracker=C,a){const c="__is_disposable_tracked__";C(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==h.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==h.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function k(c){return D?.trackDisposable(c),c}function v(c){D?.markAsDisposed(c)}function g(c,s){D?.setParent(c,s)}function T(c,s){if(!!D)for(const u of c)D.setParent(u,s)}function I(c){return D?.markAsSingleton(c),c}e.markAsSingleton=I;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function m(c){if(R.Iterable.is(c)){const s=[];for(const u of c)if(u)try{u.dispose()}catch(S){s.push(S)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=m;function p(c){for(const s of c)E(s)&&s.dispose();return[]}e.disposeIfDisposable=p;function b(...c){const s=o(()=>m(c));return T(c,s),s}e.combinedDisposable=b;function o(c){const s=k({dispose:(0,y.once)(()=>{v(s),c()})});return s}e.toDisposable=o;class d{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(v(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return g(s,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class h{constructor(){this.q=new d,k(this),g(this.q,this)}dispose(){v(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}h.None=Object.freeze({dispose(){}}),e.Disposable=h;class f{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&g(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&g(s,null),s}}e.MutableDisposable=f;class w{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(s){let u=s;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,v(this))},this}}e.SafeDisposable=L;class t{constructor(){this.a=new Map}acquire(s,...u){let S=this.a.get(s);S||(S={counter:0,object:this.b(s,...u)},this.a.set(s,S));const{object:A}=S,O=(0,y.once)(()=>{--S.counter===0&&(this.c(s,S.object),this.a.delete(s))});return S.counter++,{object:A,dispose:O}}}e.ReferenceCollection=t;class n{constructor(s){this.a=s}async acquire(s,...u){const S=this.a.acquire(s,...u);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(A){throw S.dispose(),A}}}e.AsyncReferenceCollection=n;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function i(c){const s=new d;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=i;class l{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,u,S=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this.a.get(s)?.dispose(),this.a.set(s,u)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(pe[92],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(D){this.element=D,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class R{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let D=this.a;for(;D!==y.Undefined;){const C=D.next;D.prev=y.Undefined,D.next=y.Undefined,D=C}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,C){const k=new y(D);if(this.a===y.Undefined)this.a=k,this.b=k;else if(C){const g=this.b;this.b=k,k.prev=g,g.next=k}else{const g=this.a;this.a=k,k.next=g,g.prev=k}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(k))}}shift(){if(this.a!==y.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==y.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==y.Undefined&&D.next!==y.Undefined){const C=D.prev;C.next=D.next,D.next.prev=C}else D.prev===y.Undefined&&D.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):D.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):D.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==y.Undefined;)yield D.element,D=D.next}}e.LinkedList=R}),define(pe[27],ve([1,0]),function(ae,e){"use strict";var y,R,a;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(b,o,d){let h=b.get(o);return h===void 0&&(h=d,b.set(o,h)),h}e.getOrSet=D;function C(b){const o=[];return b.forEach((d,h)=>{o.push(`${h} => ${d}`)}),`Map(${b.size}) {${o.join(", ")}}`}e.mapToString=C;function k(b){const o=[];return b.forEach(d=>{o.push(d)}),`Set(${b.size}) {${o.join(", ")}}`}e.setToString=k;class v{constructor(o,d){this.uri=o,this.value=d}}class g{constructor(o,d){this[y]="ResourceMap",o instanceof g?(this.b=new Map(o.b),this.c=d??g.a):(this.b=new Map,this.c=o??g.a)}set(o,d){return this.b.set(this.c(o),new v(o,d)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[h,f]of this.b)o(f.value,f.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}g.a=b=>b.toString(),e.ResourceMap=g;class T{constructor(o,d){this[R]="ResourceSet",!o||typeof o=="function"?this.a=new g(o):(this.a=new g(d),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,d){this.a.forEach((h,f)=>o.call(d,f,f,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var I;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class E{constructor(){this[a]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,d=0){const h=this.a.get(o);if(!!h)return d!==0&&this.j(h,d),h.value}set(o,d,h=0){let f=this.a.get(o);if(f)f.value=d,h!==0&&this.j(f,h);else{switch(f={key:o,value:d,next:void 0,previous:void 0},h){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(o,f),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.a.get(o);if(!!d)return this.a.delete(o),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,d){const h=this.e;let f=this.b;for(;f;){if(d?o.bind(d)(f.value,f.key,this):o(f.value,f.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const o=this,d=this.e;let h=this.b;const f={[Symbol.iterator](){return f},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.key,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}values(){const o=this,d=this.e;let h=this.b;const f={[Symbol.iterator](){return f},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.value,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}entries(){const o=this,d=this.e;let h=this.b;const f={[Symbol.iterator](){return f},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:[h.key,h.value],done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>o;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const d=o.next,h=o.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}o.next=void 0,o.previous=void 0,this.e++}j(o,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.b)return;const h=o.next,f=o.previous;o===this.c?(f.next=void 0,this.c=f):(h.previous=f,f.next=h),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(d===2){if(o===this.c)return;const h=o.next,f=o.previous;o===this.b?(h.previous=void 0,this.b=h):(h.previous=f,f.next=h),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((d,h)=>{o.push([h,d])}),o}fromJSON(o){this.clear();for(const[d,h]of o)this.set(d,h)}}e.LinkedMap=E;class m extends E{constructor(o,d=1){super(),this.k=o,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=m;class p{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let d=this.a.get(o)||0;return d===0?!1:(d--,d===0?this.a.delete(o):this.a.set(o,d),!0)}has(o){return this.a.has(o)}}e.CounterSet=p}),function(ae,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(pe[141],ve([0]),e):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(j,H){for(var J=0;J<H.length;J++){var V=H[J];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(j,V.key,V)}}function y(j,H,J){return H&&e(j.prototype,H),J&&e(j,J),Object.defineProperty(j,"prototype",{writable:!1}),j}function R(j,H){if(!!j){if(typeof j=="string")return a(j,H);var J=Object.prototype.toString.call(j).slice(8,-1);if(J==="Object"&&j.constructor&&(J=j.constructor.name),J==="Map"||J==="Set")return Array.from(j);if(J==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))return a(j,H)}}function a(j,H){(H==null||H>j.length)&&(H=j.length);for(var J=0,V=new Array(H);J<H;J++)V[J]=j[J];return V}function D(j,H){var J=typeof Symbol<"u"&&j[Symbol.iterator]||j["@@iterator"];if(J)return(J=J.call(j)).next.bind(J);if(Array.isArray(j)||(J=R(j))||H&&j&&typeof j.length=="number"){J&&(j=J);var V=0;return function(){return V>=j.length?{done:!0}:{done:!1,value:j[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=C();function k(j){ae.defaults=j}var v=/[&<>"']/,g=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(H){return E[H]};function p(j,H){if(H){if(v.test(j))return j.replace(g,m)}else if(T.test(j))return j.replace(I,m);return j}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(j){return j.replace(b,function(H,J){return J=J.toLowerCase(),J==="colon"?":":J.charAt(0)==="#"?J.charAt(1)==="x"?String.fromCharCode(parseInt(J.substring(2),16)):String.fromCharCode(+J.substring(1)):""})}var d=/(^|[^\[])\^/g;function h(j,H){j=typeof j=="string"?j:j.source,H=H||"";var J={replace:function(X,x){return x=x.source||x,x=x.replace(d,"$1"),j=j.replace(X,x),J},getRegex:function(){return new RegExp(j,H)}};return J}var f=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function L(j,H,J){if(j){var V;try{V=decodeURIComponent(o(J)).replace(f,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}H&&!w.test(J)&&(J=l(H,J));try{J=encodeURI(J).replace(/%25/g,"%")}catch{return null}return J}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(j,H){t[" "+j]||(n.test(j)?t[" "+j]=j+"/":t[" "+j]=S(j,"/",!0)),j=t[" "+j];var J=j.indexOf(":")===-1;return H.substring(0,2)==="//"?J?H:j.replace(r,"$1")+H:H.charAt(0)==="/"?J?H:j.replace(i,"$1")+H:j+H}var c={exec:function(){}};function s(j){for(var H=1,J,V;H<arguments.length;H++){J=arguments[H];for(V in J)Object.prototype.hasOwnProperty.call(J,V)&&(j[V]=J[V])}return j}function u(j,H){var J=j.replace(/\|/g,function(x,Q,ce){for(var Ee=!1,Ce=Q;--Ce>=0&&ce[Ce]==="\\";)Ee=!Ee;return Ee?"|":" |"}),V=J.split(/ \|/),X=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>H)V.splice(H);else for(;V.length<H;)V.push("");for(;X<V.length;X++)V[X]=V[X].trim().replace(/\\\|/g,"|");return V}function S(j,H,J){var V=j.length;if(V===0)return"";for(var X=0;X<V;){var x=j.charAt(V-X-1);if(x===H&&!J)X++;else if(x!==H&&J)X++;else break}return j.slice(0,V-X)}function A(j,H){if(j.indexOf(H[1])===-1)return-1;for(var J=j.length,V=0,X=0;X<J;X++)if(j[X]==="\\")X++;else if(j[X]===H[0])V++;else if(j[X]===H[1]&&(V--,V<0))return X;return-1}function O(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(j,H){if(H<1)return"";for(var J="";H>1;)H&1&&(J+=j),H>>=1,j+=j;return J+j}function q(j,H,J,V){var X=H.href,x=H.title?p(H.title):null,Q=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){V.state.inLink=!0;var ce={type:"link",raw:J,href:X,title:x,text:Q,tokens:V.inlineTokens(Q)};return V.state.inLink=!1,ce}return{type:"image",raw:J,href:X,title:x,text:p(Q)}}function le(j,H){var J=j.match(/^(\s+)(?:```)/);if(J===null)return H;var V=J[1];return H.split(`
`).map(function(X){var x=X.match(/^\s+/);if(x===null)return X;var Q=x[0];return Q.length>=V.length?X.slice(V.length):X}).join(`
`)}var fe=function(){function j(J){this.options=J||ae.defaults}var H=j.prototype;return H.space=function(V){var X=this.rules.block.newline.exec(V);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},H.code=function(V){var X=this.rules.block.code.exec(V);if(X){var x=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?x:S(x,`
`)}}},H.fences=function(V){var X=this.rules.block.fences.exec(V);if(X){var x=X[0],Q=le(x,X[3]||"");return{type:"code",raw:x,lang:X[2]?X[2].trim():X[2],text:Q}}},H.heading=function(V){var X=this.rules.block.heading.exec(V);if(X){var x=X[2].trim();if(/#$/.test(x)){var Q=S(x,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(x=Q.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:x,tokens:this.lexer.inline(x)}}},H.hr=function(V){var X=this.rules.block.hr.exec(V);if(X)return{type:"hr",raw:X[0]}},H.blockquote=function(V){var X=this.rules.block.blockquote.exec(V);if(X){var x=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},H.list=function(V){var X=this.rules.block.list.exec(V);if(X){var x,Q,ce,Ee,Ce,ke,Me,$e,ge,Se,ye,Fe,Ne=X[1].trim(),et=Ne.length>1,Ve={type:"list",raw:"",ordered:et,start:et?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=et?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=et?Ne:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Fe=!1,!(!(X=Xe.exec(V))||this.rules.block.hr.test(V)));){if(x=X[0],V=V.substring(x.length),$e=X[2].split(`
`,1)[0],ge=V.split(`
`,1)[0],this.options.pedantic?(Ee=2,ye=$e.trimLeft()):(Ee=X[2].search(/[^ ]/),Ee=Ee>4?1:Ee,ye=$e.slice(Ee),Ee+=X[1].length),ke=!1,!$e&&/^ *$/.test(ge)&&(x+=ge+`
`,V=V.substring(ge.length+1),Fe=!0),!Fe)for(var Qe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ze=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");V&&(Se=V.split(`
`,1)[0],$e=Se,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test($e)||he.test($e)||Qe.test($e)||Ze.test(V)));){if($e.search(/[^ ]/)>=Ee||!$e.trim())ye+=`
`+$e.slice(Ee);else if(!ke)ye+=`
`+$e;else break;!ke&&!$e.trim()&&(ke=!0),x+=Se+`
`,V=V.substring(Se.length+1)}Ve.loose||(Me?Ve.loose=!0:/\n *\n *$/.test(x)&&(Me=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ye),Q&&(ce=Q[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:x,task:!!Q,checked:ce,loose:!1,text:ye}),Ve.raw+=x}Ve.items[Ve.items.length-1].raw=x.trimRight(),Ve.items[Ve.items.length-1].text=ye.trimRight(),Ve.raw=Ve.raw.trimRight();var Ie=Ve.items.length;for(Ce=0;Ce<Ie;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var Te=Ve.items[Ce].tokens.filter(function(Le){return Le.type==="space"}),Be=Te.every(function(Le){for(var je=Le.raw.split(""),We=0,Ye=D(je),qe;!(qe=Ye()).done;){var Ke=qe.value;if(Ke===`
`&&(We+=1),We>1)return!0}return!1});!Ve.loose&&Te.length&&Be&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},H.html=function(V){var X=this.rules.block.html.exec(V);if(X){var x={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var Q=this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]);x.type="paragraph",x.text=Q,x.tokens=this.lexer.inline(Q)}return x}},H.def=function(V){var X=this.rules.block.def.exec(V);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var x=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:X[0],href:X[2],title:X[3]}}},H.table=function(V){var X=this.rules.block.table.exec(V);if(X){var x={type:"table",header:u(X[1]).map(function(Me){return{text:Me}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=X[0];var Q=x.align.length,ce,Ee,Ce,ke;for(ce=0;ce<Q;ce++)/^ *-+: *$/.test(x.align[ce])?x.align[ce]="right":/^ *:-+: *$/.test(x.align[ce])?x.align[ce]="center":/^ *:-+ *$/.test(x.align[ce])?x.align[ce]="left":x.align[ce]=null;for(Q=x.rows.length,ce=0;ce<Q;ce++)x.rows[ce]=u(x.rows[ce],x.header.length).map(function(Me){return{text:Me}});for(Q=x.header.length,Ee=0;Ee<Q;Ee++)x.header[Ee].tokens=this.lexer.inline(x.header[Ee].text);for(Q=x.rows.length,Ee=0;Ee<Q;Ee++)for(ke=x.rows[Ee],Ce=0;Ce<ke.length;Ce++)ke[Ce].tokens=this.lexer.inline(ke[Ce].text);return x}}},H.lheading=function(V){var X=this.rules.block.lheading.exec(V);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},H.paragraph=function(V){var X=this.rules.block.paragraph.exec(V);if(X){var x=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:x,tokens:this.lexer.inline(x)}}},H.text=function(V){var X=this.rules.block.text.exec(V);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},H.escape=function(V){var X=this.rules.inline.escape.exec(V);if(X)return{type:"escape",raw:X[0],text:p(X[1])}},H.tag=function(V){var X=this.rules.inline.tag.exec(V);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]):X[0]}},H.link=function(V){var X=this.rules.inline.link.exec(V);if(X){var x=X[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var Q=S(x.slice(0,-1),"\\");if((x.length-Q.length)%2===0)return}else{var ce=A(X[2],"()");if(ce>-1){var Ee=X[0].indexOf("!")===0?5:4,Ce=Ee+X[1].length+ce;X[2]=X[2].substring(0,ce),X[0]=X[0].substring(0,Ce).trim(),X[3]=""}}var ke=X[2],Me="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);$e&&(ke=$e[1],Me=$e[3])}else Me=X[3]?X[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(x)?ke=ke.slice(1):ke=ke.slice(1,-1)),q(X,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},H.reflink=function(V,X){var x;if((x=this.rules.inline.reflink.exec(V))||(x=this.rules.inline.nolink.exec(V))){var Q=(x[2]||x[1]).replace(/\s+/g," ");if(Q=X[Q.toLowerCase()],!Q||!Q.href){var ce=x[0].charAt(0);return{type:"text",raw:ce,text:ce}}return q(x,Q,x[0],this.lexer)}},H.emStrong=function(V,X,x){x===void 0&&(x="");var Q=this.rules.inline.emStrong.lDelim.exec(V);if(!!Q&&!(Q[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Q[1]||Q[2]||"";if(!ce||ce&&(x===""||this.rules.inline.punctuation.exec(x))){var Ee=Q[0].length-1,Ce,ke,Me=Ee,$e=0,ge=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,X=X.slice(-1*V.length+Ee);(Q=ge.exec(X))!=null;)if(Ce=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ce){if(ke=Ce.length,Q[3]||Q[4]){Me+=ke;continue}else if((Q[5]||Q[6])&&Ee%3&&!((Ee+ke)%3)){$e+=ke;continue}if(Me-=ke,!(Me>0)){if(ke=Math.min(ke,ke+Me+$e),Math.min(Ee,ke)%2){var Se=V.slice(1,Ee+Q.index+ke);return{type:"em",raw:V.slice(0,Ee+Q.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ye=V.slice(2,Ee+Q.index+ke-1);return{type:"strong",raw:V.slice(0,Ee+Q.index+ke+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},H.codespan=function(V){var X=this.rules.inline.code.exec(V);if(X){var x=X[2].replace(/\n/g," "),Q=/[^ ]/.test(x),ce=/^ /.test(x)&&/ $/.test(x);return Q&&ce&&(x=x.substring(1,x.length-1)),x=p(x,!0),{type:"codespan",raw:X[0],text:x}}},H.br=function(V){var X=this.rules.inline.br.exec(V);if(X)return{type:"br",raw:X[0]}},H.del=function(V){var X=this.rules.inline.del.exec(V);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},H.autolink=function(V,X){var x=this.rules.inline.autolink.exec(V);if(x){var Q,ce;return x[2]==="@"?(Q=p(this.options.mangle?X(x[1]):x[1]),ce="mailto:"+Q):(Q=p(x[1]),ce=Q),{type:"link",raw:x[0],text:Q,href:ce,tokens:[{type:"text",raw:Q,text:Q}]}}},H.url=function(V,X){var x;if(x=this.rules.inline.url.exec(V)){var Q,ce;if(x[2]==="@")Q=p(this.options.mangle?X(x[0]):x[0]),ce="mailto:"+Q;else{var Ee;do Ee=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(Ee!==x[0]);Q=p(x[0]),x[1]==="www."?ce="http://"+Q:ce=Q}return{type:"link",raw:x[0],text:Q,href:ce,tokens:[{type:"text",raw:Q,text:Q}]}}},H.inlineText=function(V,X){var x=this.rules.inline.text.exec(V);if(x){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]):x[0]:Q=p(this.options.smartypants?X(x[0]):x[0]),{type:"text",raw:x[0],text:Q}}},j}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=h(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=h(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=h(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=h(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=h(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=h(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=s({},ue),ue.gfm=s({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=h(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=h(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=s({},ue.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:h(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=h(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=h(ue._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=h(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=h(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=h(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=h(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=h(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=h(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=h(re.reflink).replace("label",re._label).replace("ref",ue._label).getRegex(),re.nolink=h(re.nolink).replace("ref",ue._label).getRegex(),re.reflinkSearch=h(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=s({},re),re.pedantic=s({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=s({},re.normal,{escape:h(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=h(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=s({},re.gfm,{br:h(re.br).replace("{2,}","*").getRegex(),text:h(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(j){var H="",J,V,X=j.length;for(J=0;J<X;J++)V=j.charCodeAt(J),Math.random()>.5&&(V="x"+V.toString(16)),H+="&#"+V+";";return H}var ne=function(){function j(J){this.tokens=[],this.tokens.links=Object.create(null),this.options=J||ae.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:ue.normal,inline:re.normal};this.options.pedantic?(V.block=ue.pedantic,V.inline=re.pedantic):this.options.gfm&&(V.block=ue.gfm,this.options.breaks?V.inline=re.breaks:V.inline=re.gfm),this.tokenizer.rules=V}j.lex=function(V,X){var x=new j(X);return x.lex(V)},j.lexInline=function(V,X){var x=new j(X);return x.inlineTokens(V)};var H=j.prototype;return H.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},H.blockTokens=function(V,X){var x=this;X===void 0&&(X=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Me,$e,ge){return $e+"    ".repeat(ge.length)});for(var Q,ce,Ee,Ce;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(Q=Me.call({lexer:x},V,X))?(V=V.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.space(V)){V=V.substring(Q.raw.length),Q.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(Q);continue}if(Q=this.tokenizer.code(V)){V=V.substring(Q.raw.length),ce=X[X.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q);continue}if(Q=this.tokenizer.fences(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.heading(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.hr(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.blockquote(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.list(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.html(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.def(V)){V=V.substring(Q.raw.length),ce=X[X.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.lheading(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Ee=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,$e=V.slice(1),ge=void 0;x.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},$e),typeof ge=="number"&&ge>=0&&(Me=Math.min(Me,ge))}),Me<1/0&&Me>=0&&(Ee=V.substring(0,Me+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(Ee))){ce=X[X.length-1],Ce&&ce.type==="paragraph"?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q),Ce=Ee.length!==V.length,V=V.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(V)){V=V.substring(Q.raw.length),ce=X[X.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+Q.raw,ce.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):X.push(Q);continue}if(V){var ke="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,X},H.inline=function(V,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:V,tokens:X}),X},H.inlineTokens=function(V,X){var x=this;X===void 0&&(X=[]);var Q,ce,Ee,Ce=V,ke,Me,$e;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)ge.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,ke.index)+"["+B("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"["+B("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Me||($e=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Q=ye.call({lexer:x},V,X))?(V=V.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.tag(V)){V=V.substring(Q.raw.length),ce=X[X.length-1],ce&&Q.type==="text"&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.link(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(Q.raw.length),ce=X[X.length-1],ce&&Q.type==="text"&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.emStrong(V,Ce,$e)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.codespan(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.br(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.del(V)){V=V.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.autolink(V,ee)){V=V.substring(Q.raw.length),X.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(V,ee))){V=V.substring(Q.raw.length),X.push(Q);continue}if(Ee=V,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Fe=V.slice(1),Ne=void 0;x.options.extensions.startInline.forEach(function(et){Ne=et.call({lexer:this},Fe),typeof Ne=="number"&&Ne>=0&&(ye=Math.min(ye,Ne))}),ye<1/0&&ye>=0&&(Ee=V.substring(0,ye+1))}(),Q=this.tokenizer.inlineText(Ee,_)){V=V.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&($e=Q.raw.slice(-1)),Me=!0,ce=X[X.length-1],ce&&ce.type==="text"?(ce.raw+=Q.raw,ce.text+=Q.text):X.push(Q);continue}if(V){var Se="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return X},y(j,null,[{key:"rules",get:function(){return{block:ue,inline:re}}}]),j}(),ie=function(){function j(J){this.options=J||ae.defaults}var H=j.prototype;return H.code=function(V,X,x){var Q=(X||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(V,Q);ce!=null&&ce!==V&&(x=!0,V=ce)}return V=V.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+p(Q,!0)+'">'+(x?V:p(V,!0))+`</code></pre>
`:"<pre><code>"+(x?V:p(V,!0))+`</code></pre>
`},H.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},H.html=function(V){return V},H.heading=function(V,X,x,Q){if(this.options.headerIds){var ce=this.options.headerPrefix+Q.slug(x);return"<h"+X+' id="'+ce+'">'+V+"</h"+X+`>
`}return"<h"+X+">"+V+"</h"+X+`>
`},H.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},H.list=function(V,X,x){var Q=X?"ol":"ul",ce=X&&x!==1?' start="'+x+'"':"";return"<"+Q+ce+`>
`+V+"</"+Q+`>
`},H.listitem=function(V){return"<li>"+V+`</li>
`},H.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},H.paragraph=function(V){return"<p>"+V+`</p>
`},H.table=function(V,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+X+`</table>
`},H.tablerow=function(V){return`<tr>
`+V+`</tr>
`},H.tablecell=function(V,X){var x=X.header?"th":"td",Q=X.align?"<"+x+' align="'+X.align+'">':"<"+x+">";return Q+V+("</"+x+`>
`)},H.strong=function(V){return"<strong>"+V+"</strong>"},H.em=function(V){return"<em>"+V+"</em>"},H.codespan=function(V){return"<code>"+V+"</code>"},H.br=function(){return this.options.xhtml?"<br/>":"<br>"},H.del=function(V){return"<del>"+V+"</del>"},H.link=function(V,X,x){if(V=L(this.options.sanitize,this.options.baseUrl,V),V===null)return x;var Q='<a href="'+p(V)+'"';return X&&(Q+=' title="'+X+'"'),Q+=">"+x+"</a>",Q},H.image=function(V,X,x){if(V=L(this.options.sanitize,this.options.baseUrl,V),V===null)return x;var Q='<img src="'+V+'" alt="'+x+'"';return X&&(Q+=' title="'+X+'"'),Q+=this.options.xhtml?"/>":">",Q},H.text=function(V){return V},j}(),G=function(){function j(){}var H=j.prototype;return H.strong=function(V){return V},H.em=function(V){return V},H.codespan=function(V){return V},H.del=function(V){return V},H.html=function(V){return V},H.text=function(V){return V},H.link=function(V,X,x){return""+x},H.image=function(V,X,x){return""+x},H.br=function(){return""},j}(),U=function(){function j(){this.seen={}}var H=j.prototype;return H.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},H.getNextSafeSlug=function(V,X){var x=V,Q=0;if(this.seen.hasOwnProperty(x)){Q=this.seen[V];do Q++,x=V+"-"+Q;while(this.seen.hasOwnProperty(x))}return X||(this.seen[V]=Q,this.seen[x]=0),x},H.slug=function(V,X){X===void 0&&(X={});var x=this.serialize(V);return this.getNextSafeSlug(x,X.dryrun)},j}(),Z=function(){function j(J){this.options=J||ae.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new U}j.parse=function(V,X){var x=new j(X);return x.parse(V)},j.parseInline=function(V,X){var x=new j(X);return x.parseInline(V)};var H=j.prototype;return H.parse=function(V,X){X===void 0&&(X=!0);var x="",Q,ce,Ee,Ce,ke,Me,$e,ge,Se,ye,Fe,Ne,et,Ve,Xe,Qe,Ze,Ge,he,Ie=V.length;for(Q=0;Q<Ie;Q++){if(ye=V[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(he=this.options.extensions.renderers[ye.type].call({parser:this},ye),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){x+=he||"";continue}switch(ye.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,o(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",$e="",Ce=ye.header.length,ce=0;ce<Ce;ce++)$e+=this.renderer.tablecell(this.parseInline(ye.header[ce].tokens),{header:!0,align:ye.align[ce]});for(ge+=this.renderer.tablerow($e),Se="",Ce=ye.rows.length,ce=0;ce<Ce;ce++){for(Me=ye.rows[ce],$e="",ke=Me.length,Ee=0;Ee<ke;Ee++)$e+=this.renderer.tablecell(this.parseInline(Me[Ee].tokens),{header:!1,align:ye.align[Ee]});Se+=this.renderer.tablerow($e)}x+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(ye.tokens),x+=this.renderer.blockquote(Se);continue}case"list":{for(Fe=ye.ordered,Ne=ye.start,et=ye.loose,Ce=ye.items.length,Se="",ce=0;ce<Ce;ce++)Xe=ye.items[ce],Qe=Xe.checked,Ze=Xe.task,Ve="",Xe.task&&(Ge=this.renderer.checkbox(Qe),et?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=Ge+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=Ge+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:Ge}):Ve+=Ge),Ve+=this.parse(Xe.tokens,et),Se+=this.renderer.listitem(Ve,Ze,Qe);x+=this.renderer.list(Se,Fe,Ne);continue}case"html":{x+=this.renderer.html(ye.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Se=ye.tokens?this.parseInline(ye.tokens):ye.text;Q+1<Ie&&V[Q+1].type==="text";)ye=V[++Q],Se+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);x+=X?this.renderer.paragraph(Se):Se;continue}default:{var Te='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return x},H.parseInline=function(V,X){X=X||this.renderer;var x="",Q,ce,Ee,Ce=V.length;for(Q=0;Q<Ce;Q++){if(ce=V[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(Ee=this.options.extensions.renderers[ce.type].call({parser:this},ce),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){x+=Ee||"";continue}switch(ce.type){case"escape":{x+=X.text(ce.text);break}case"html":{x+=X.html(ce.text);break}case"link":{x+=X.link(ce.href,ce.title,this.parseInline(ce.tokens,X));break}case"image":{x+=X.image(ce.href,ce.title,ce.text);break}case"strong":{x+=X.strong(this.parseInline(ce.tokens,X));break}case"em":{x+=X.em(this.parseInline(ce.tokens,X));break}case"codespan":{x+=X.codespan(ce.text);break}case"br":{x+=X.br();break}case"del":{x+=X.del(this.parseInline(ce.tokens,X));break}case"text":{x+=X.text(ce.text);break}default:{var ke='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return x},j}();function oe(j,H,J){if(typeof j>"u"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof H=="function"&&(J=H,H=null),H=s({},oe.defaults,H||{}),O(H),J){var V=H.highlight,X;try{X=ne.lex(j,H)}catch(Ce){return J(Ce)}var x=function(ke){var Me;if(!ke)try{H.walkTokens&&oe.walkTokens(X,H.walkTokens),Me=Z.parse(X,H)}catch($e){ke=$e}return H.highlight=V,ke?J(ke):J(null,Me)};if(!V||V.length<3||(delete H.highlight,!X.length))return x();var Q=0;oe.walkTokens(X,function(Ce){Ce.type==="code"&&(Q++,setTimeout(function(){V(Ce.text,Ce.lang,function(ke,Me){if(ke)return x(ke);Me!=null&&Me!==Ce.text&&(Ce.text=Me,Ce.escaped=!0),Q--,Q===0&&x()})},0))}),Q===0&&x();return}function ce(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+p(Ce.message+"",!0)+"</pre>";throw Ce}try{var Ee=ne.lex(j,H);if(H.walkTokens){if(H.async)return Promise.all(oe.walkTokens(Ee,H.walkTokens)).then(function(){return Z.parse(Ee,H)}).catch(ce);oe.walkTokens(Ee,H.walkTokens)}return Z.parse(Ee,H)}catch(Ce){ce(Ce)}}oe.options=oe.setOptions=function(j){return s(oe.defaults,j),k(oe.defaults),oe},oe.getDefaults=C,oe.defaults=ae.defaults,oe.use=function(){for(var j=arguments.length,H=new Array(j),J=0;J<j;J++)H[J]=arguments[J];var V=s.apply(void 0,[{}].concat(H)),X=oe.defaults.extensions||{renderers:{},childTokens:{}},x;H.forEach(function(Q){if(Q.extensions&&(x=!0,Q.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var Ce=X.renderers?X.renderers[Ee.name]:null;Ce?X.renderers[Ee.name]=function(){for(var ke=arguments.length,Me=new Array(ke),$e=0;$e<ke;$e++)Me[$e]=arguments[$e];var ge=Ee.renderer.apply(this,Me);return ge===!1&&(ge=Ce.apply(this,Me)),ge}:X.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[Ee.level]?X[Ee.level].unshift(Ee.tokenizer):X[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?X.startBlock?X.startBlock.push(Ee.start):X.startBlock=[Ee.start]:Ee.level==="inline"&&(X.startInline?X.startInline.push(Ee.start):X.startInline=[Ee.start]))}Ee.childTokens&&(X.childTokens[Ee.name]=Ee.childTokens)})),Q.renderer&&function(){var Ee=oe.defaults.renderer||new ie,Ce=function($e){var ge=Ee[$e];Ee[$e]=function(){for(var Se=arguments.length,ye=new Array(Se),Fe=0;Fe<Se;Fe++)ye[Fe]=arguments[Fe];var Ne=Q.renderer[$e].apply(Ee,ye);return Ne===!1&&(Ne=ge.apply(Ee,ye)),Ne}};for(var ke in Q.renderer)Ce(ke);V.renderer=Ee}(),Q.tokenizer&&function(){var Ee=oe.defaults.tokenizer||new fe,Ce=function($e){var ge=Ee[$e];Ee[$e]=function(){for(var Se=arguments.length,ye=new Array(Se),Fe=0;Fe<Se;Fe++)ye[Fe]=arguments[Fe];var Ne=Q.tokenizer[$e].apply(Ee,ye);return Ne===!1&&(Ne=ge.apply(Ee,ye)),Ne}};for(var ke in Q.tokenizer)Ce(ke);V.tokenizer=Ee}(),Q.walkTokens){var ce=oe.defaults.walkTokens;V.walkTokens=function(Ee){var Ce=[];return Ce.push(Q.walkTokens.call(this,Ee)),ce&&(Ce=Ce.concat(ce.call(this,Ee))),Ce}}x&&(V.extensions=X),oe.setOptions(V)})},oe.walkTokens=function(j,H){for(var J=[],V=function(){var ce=x.value;switch(J=J.concat(H.call(oe,ce)),ce.type){case"table":{for(var Ee=D(ce.header),Ce;!(Ce=Ee()).done;){var ke=Ce.value;J=J.concat(oe.walkTokens(ke.tokens,H))}for(var Me=D(ce.rows),$e;!($e=Me()).done;)for(var ge=$e.value,Se=D(ge),ye;!(ye=Se()).done;){var Fe=ye.value;J=J.concat(oe.walkTokens(Fe.tokens,H))}break}case"list":{J=J.concat(oe.walkTokens(ce.items,H));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[ce.type]?oe.defaults.extensions.childTokens[ce.type].forEach(function(Ne){J=J.concat(oe.walkTokens(ce[Ne],H))}):ce.tokens&&(J=J.concat(oe.walkTokens(ce.tokens,H)))}},X=D(j),x;!(x=X()).done;)V();return J},oe.parseInline=function(j,H){if(typeof j>"u"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");H=s({},oe.defaults,H||{}),O(H);try{var J=ne.lexInline(j,H);return H.walkTokens&&oe.walkTokens(J,H.walkTokens),Z.parseInline(J,H)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+p(V.message+"",!0)+"</pre>";throw V}},oe.Parser=Z,oe.parser=Z.parse,oe.Renderer=ie,oe.TextRenderer=G,oe.Lexer=ne,oe.lexer=ne.lex,oe.Tokenizer=fe,oe.Slugger=U,oe.parse=oe;var me=oe.options,$=oe.setOptions,W=oe.use,N=oe.walkTokens,P=oe.parseInline,M=oe,K=Z.parse,te=ne.lex;ae.Lexer=ne,ae.Parser=Z,ae.Renderer=ie,ae.Slugger=U,ae.TextRenderer=G,ae.Tokenizer=fe,ae.getDefaults=C,ae.lexer=te,ae.marked=oe,ae.options=me,ae.parse=M,ae.parseInline=P,ae.parser=K,ae.setOptions=$,ae.use=W,ae.walkTokens=N,Object.defineProperty(ae,"__esModule",{value:!0})}),define(pe[93],ve([1,0,27]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new y.LRUCache(1e4);function a(g){return v(g,"NFC",R)}e.normalizeNFC=a;const D=new y.LRUCache(1e4);function C(g){return v(g,"NFD",D)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function v(g,T,I){if(!g)return g;const E=I.get(g);if(E)return E;let m;return k.test(g)?m=g.normalize(T):m=g,I.set(g,m),m}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(T){return C(T).replace(g,"")}}()}),define(pe[142],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function y(k,v,g){return Math.min(Math.max(k,v),g)}e.clamp=y;function R(k,v){return(v+k%v)%v}e.rot=R;class a{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=a;class D{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class C{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const g=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ae(a){const D=[];typeof a=="number"&&D.push("code/timeOrigin",a);function C(v){D.push(v,Date.now())}function k(){const v=[];for(let g=0;g<D.length;g+=2)v.push({name:D[g],startTime:D[g+1]});return v}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(a){performance.mark(a)},getMarks(){let a=performance.timeOrigin;typeof a!="number"&&(a=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(a)}];for(const C of performance.getEntriesByType("mark"))D.push({name:C.name,startTime:Math.round(a+C.startTime)});return D}};if(typeof process=="object"){const a=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(a)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function y(a){return a.MonacoPerformanceMarks||(a.MonacoPerformanceMarks=e()),a.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),define(pe[3],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let y=!1,R=!1,a=!1,D=!1,C=!1,k=!1,v=!1,g=!1,T=!1,I=!1,E,m=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,b,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const h=typeof d?.versions?.electron=="string",f=h&&d?.type==="renderer";if(typeof navigator=="object"&&!f){o=navigator.userAgent,y=o.indexOf("Windows")>=0,R=o.indexOf("Macintosh")>=0,g=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=o.indexOf("Linux")>=0,I=o?.indexOf("Mobi")>=0,k=!0,E=e.LANGUAGE_DEFAULT,m=E,p=navigator.language;const s=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),u=s&&s.getAttribute("data-settings");if(u)try{const S=JSON.parse(u),A=S.availableLanguages["*"];E=S.locale,p=S.osLocale,m=A||e.LANGUAGE_DEFAULT,b=S._translationsConfigFile}catch{}}else if(typeof d=="object"){y=d.platform==="win32",R=d.platform==="darwin",a=d.platform==="linux",D=a&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,v=h,T=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),S=u.availableLanguages["*"];E=u.locale,p=u.osLocale,m=S||e.LANGUAGE_DEFAULT,b=u._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function L(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=L;let t=0;R?t=1:y?t=3:a&&(t=2),e.isWindows=y,e.isMacintosh=R,e.isLinux=a,e.isLinuxSnap=D,e.isNative=C,e.isElectron=v,e.isWeb=k,e.isWebWorker=k&&typeof e.globals.importScripts=="function",e.isIOS=g,e.isMobile=I,e.isCI=T,e.platform=t,e.userAgent=o,e.language=m;var n;(function(s){function u(){return e.language}s.value=u;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=S;function A(){return e.language==="en"}s.isDefault=A})(n=e.Language||(e.Language={})),e.locale=E,e.platformLocale=p,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let A=0,O=s.length;A<O;A++){const B=s[A];if(B.id===S.data.vscodeScheduleAsyncWork){s.splice(A,1),B.callback();return}}});let u=0;return S=>{const A=++u;s.push({id:A,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||g?2:y?1:3;let i=!0,l=!1;function c(){if(!l){l=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[28],ve([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const a=y.globals.vscode.process;R={get platform(){return a.platform},get arch(){return a.arch},get env(){return a.env},cwd(){return a.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(pe[7],ve([1,0,28]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,a=97,D=90,C=122,k=46,v=47,g=92,T=58,I=63;class E extends Error{constructor(n,r,i){let l;typeof r=="string"&&r.indexOf("not ")===0?(l="must not be",r=r.replace(/^not /,"")):l="must be";const c=n.indexOf(".")!==-1?"property":"argument";let s=`The "${n}" ${c} ${l} of type ${r}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,n){if(t===null||typeof t!="object")throw new E(n,"Object",t)}function p(t,n){if(typeof t!="string")throw new E(n,"string",t)}const b=y.platform==="win32";function o(t){return t===v||t===g}function d(t){return t===v}function h(t){return t>=R&&t<=D||t>=a&&t<=C}function f(t,n,r,i){let l="",c=0,s=-1,u=0,S=0;for(let A=0;A<=t.length;++A){if(A<t.length)S=t.charCodeAt(A);else{if(i(S))break;S=v}if(i(S)){if(!(s===A-1||u===1))if(u===2){if(l.length<2||c!==2||l.charCodeAt(l.length-1)!==k||l.charCodeAt(l.length-2)!==k){if(l.length>2){const O=l.lastIndexOf(r);O===-1?(l="",c=0):(l=l.slice(0,O),c=l.length-1-l.lastIndexOf(r)),s=A,u=0;continue}else if(l.length!==0){l="",c=0,s=A,u=0;continue}}n&&(l+=l.length>0?`${r}..`:"..",c=2)}else l.length>0?l+=`${r}${t.slice(s+1,A)}`:l=t.slice(s+1,A),c=A-s-1;s=A,u=0}else S===k&&u!==-1?++u:u=-1}return l}function w(t,n){m(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let n="",r="",i=!1;for(let l=t.length-1;l>=-1;l--){let c;if(l>=0){if(c=t[l],p(c,"path"),c.length===0)continue}else n.length===0?c=y.cwd():(c=y.env[`=${n}`]||y.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==n.toLowerCase()&&c.charCodeAt(2)===g)&&(c=`${n}\\`));const s=c.length;let u=0,S="",A=!1;const O=c.charCodeAt(0);if(s===1)o(O)&&(u=1,A=!0);else if(o(O))if(A=!0,o(c.charCodeAt(1))){let B=2,q=B;for(;B<s&&!o(c.charCodeAt(B));)B++;if(B<s&&B!==q){const le=c.slice(q,B);for(q=B;B<s&&o(c.charCodeAt(B));)B++;if(B<s&&B!==q){for(q=B;B<s&&!o(c.charCodeAt(B));)B++;(B===s||B!==q)&&(S=`\\\\${le}\\${c.slice(q,B)}`,u=B)}}}else u=1;else h(O)&&c.charCodeAt(1)===T&&(S=c.slice(0,2),u=2,s>2&&o(c.charCodeAt(2))&&(A=!0,u=3));if(S.length>0)if(n.length>0){if(S.toLowerCase()!==n.toLowerCase())continue}else n=S;if(i){if(n.length>0)break}else if(r=`${c.slice(u)}\\${r}`,i=A,A&&n.length>0)break}return r=f(r,!i,"\\",o),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){p(t,"path");const n=t.length;if(n===0)return".";let r=0,i,l=!1;const c=t.charCodeAt(0);if(n===1)return d(c)?"\\":t;if(o(c))if(l=!0,o(t.charCodeAt(1))){let u=2,S=u;for(;u<n&&!o(t.charCodeAt(u));)u++;if(u<n&&u!==S){const A=t.slice(S,u);for(S=u;u<n&&o(t.charCodeAt(u));)u++;if(u<n&&u!==S){for(S=u;u<n&&!o(t.charCodeAt(u));)u++;if(u===n)return`\\\\${A}\\${t.slice(S)}\\`;u!==S&&(i=`\\\\${A}\\${t.slice(S,u)}`,r=u)}}}else r=1;else h(c)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),r=2,n>2&&o(t.charCodeAt(2))&&(l=!0,r=3));let s=r<n?f(t.slice(r),!l,"\\",o):"";return s.length===0&&!l&&(s="."),s.length>0&&o(t.charCodeAt(n-1))&&(s+="\\"),i===void 0?l?`\\${s}`:s:l?`${i}\\${s}`:`${i}${s}`},isAbsolute(t){p(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return o(r)||n>2&&h(r)&&t.charCodeAt(1)===T&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let c=0;c<t.length;++c){const s=t[c];p(s,"path"),s.length>0&&(n===void 0?n=r=s:n+=`\\${s}`)}if(n===void 0)return".";let i=!0,l=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++l;const c=r.length;c>1&&o(r.charCodeAt(1))&&(++l,c>2&&(o(r.charCodeAt(2))?++l:i=!1))}if(i){for(;l<n.length&&o(n.charCodeAt(l));)l++;l>=2&&(n=`\\${n.slice(l)}`)}return e.win32.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n)return"";const r=e.win32.resolve(t),i=e.win32.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let c=t.length;for(;c-1>l&&t.charCodeAt(c-1)===g;)c--;const s=c-l;let u=0;for(;u<n.length&&n.charCodeAt(u)===g;)u++;let S=n.length;for(;S-1>u&&n.charCodeAt(S-1)===g;)S--;const A=S-u,O=s<A?s:A;let B=-1,q=0;for(;q<O;q++){const fe=t.charCodeAt(l+q);if(fe!==n.charCodeAt(u+q))break;fe===g&&(B=q)}if(q!==O){if(B===-1)return i}else{if(A>O){if(n.charCodeAt(u+q)===g)return i.slice(u+q+1);if(q===2)return i.slice(u+q)}s>O&&(t.charCodeAt(l+q)===g?B=q:q===2&&(B=3)),B===-1&&(B=0)}let le="";for(q=l+B+1;q<=c;++q)(q===c||t.charCodeAt(q)===g)&&(le+=le.length===0?"..":"\\..");return u+=B,le.length>0?`${le}${i.slice(u,S)}`:(i.charCodeAt(u)===g&&++u,i.slice(u,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===g){if(n.charCodeAt(1)===g){const r=n.charCodeAt(2);if(r!==I&&r!==k)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(h(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===g)return`\\\\?\\${n}`;return t},dirname(t){p(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const l=t.charCodeAt(0);if(n===1)return o(l)?t:".";if(o(l)){if(r=i=1,o(t.charCodeAt(1))){let u=2,S=u;for(;u<n&&!o(t.charCodeAt(u));)u++;if(u<n&&u!==S){for(S=u;u<n&&o(t.charCodeAt(u));)u++;if(u<n&&u!==S){for(S=u;u<n&&!o(t.charCodeAt(u));)u++;if(u===n)return t;u!==S&&(r=i=u+1)}}}}else h(l)&&t.charCodeAt(1)===T&&(r=n>2&&o(t.charCodeAt(2))?3:2,i=r);let c=-1,s=!0;for(let u=n-1;u>=i;--u)if(o(t.charCodeAt(u))){if(!s){c=u;break}}else s=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,l=!0,c;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let s=n.length-1,u=-1;for(c=t.length-1;c>=r;--c){const S=t.charCodeAt(c);if(o(S)){if(!l){r=c+1;break}}else u===-1&&(l=!1,u=c+1),s>=0&&(S===n.charCodeAt(s)?--s===-1&&(i=c):(s=-1,i=u))}return r===i?i=u:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=r;--c)if(o(t.charCodeAt(c))){if(!l){r=c+1;break}}else i===-1&&(l=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=0,r=-1,i=0,l=-1,c=!0,s=0;t.length>=2&&t.charCodeAt(1)===T&&h(t.charCodeAt(0))&&(n=i=2);for(let u=t.length-1;u>=n;--u){const S=t.charCodeAt(u);if(o(S)){if(!c){i=u+1;break}continue}l===-1&&(c=!1,l=u+1),S===k?r===-1?r=u:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||l===-1||s===0||s===1&&r===l-1&&r===i+1?"":t.slice(r,l)},format:w.bind(null,"\\"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,l=t.charCodeAt(0);if(r===1)return o(l)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(o(l)){if(i=1,o(t.charCodeAt(1))){let B=2,q=B;for(;B<r&&!o(t.charCodeAt(B));)B++;if(B<r&&B!==q){for(q=B;B<r&&o(t.charCodeAt(B));)B++;if(B<r&&B!==q){for(q=B;B<r&&!o(t.charCodeAt(B));)B++;B===r?i=B:B!==q&&(i=B+1)}}}}else if(h(l)&&t.charCodeAt(1)===T){if(r<=2)return n.root=n.dir=t,n;if(i=2,o(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let c=-1,s=i,u=-1,S=!0,A=t.length-1,O=0;for(;A>=i;--A){if(l=t.charCodeAt(A),o(l)){if(!S){s=A+1;break}continue}u===-1&&(S=!1,u=A+1),l===k?c===-1?c=A:O!==1&&(O=1):c!==-1&&(O=-1)}return u!==-1&&(c===-1||O===0||O===1&&c===u-1&&c===s+1?n.base=n.name=t.slice(s,u):(n.name=t.slice(s,c),n.base=t.slice(s,u),n.ext=t.slice(c,u))),s>0&&s!==i?n.dir=t.slice(0,s-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(b){const t=/\\/g;return()=>{const n=y.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>y.cwd()})();e.posix={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const l=i>=0?t[i]:L();p(l,"path"),l.length!==0&&(n=`${l}/${n}`,r=l.charCodeAt(0)===v)}return n=f(n,!r,"/",d),r?`/${n}`:n.length>0?n:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v,r=t.charCodeAt(t.length-1)===v;return t=f(t,!n,"/",d),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];p(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(p(t,"from"),p(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const r=1,i=t.length,l=i-r,c=1,s=n.length-c,u=l<s?l:s;let S=-1,A=0;for(;A<u;A++){const B=t.charCodeAt(r+A);if(B!==n.charCodeAt(c+A))break;B===v&&(S=A)}if(A===u)if(s>u){if(n.charCodeAt(c+A)===v)return n.slice(c+A+1);if(A===0)return n.slice(c+A)}else l>u&&(t.charCodeAt(r+A)===v?S=A:A===0&&(S=0));let O="";for(A=r+S+1;A<=i;++A)(A===i||t.charCodeAt(A)===v)&&(O+=O.length===0?"..":"/..");return`${O}${n.slice(c+S)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v;let r=-1,i=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===v){if(!i){r=l;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&p(n,"ext"),p(t,"path");let r=0,i=-1,l=!0,c;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let s=n.length-1,u=-1;for(c=t.length-1;c>=0;--c){const S=t.charCodeAt(c);if(S===v){if(!l){r=c+1;break}}else u===-1&&(l=!1,u=c+1),s>=0&&(S===n.charCodeAt(s)?--s===-1&&(i=c):(s=-1,i=u))}return r===i?i=u:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===v){if(!l){r=c+1;break}}else i===-1&&(l=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){p(t,"path");let n=-1,r=0,i=-1,l=!0,c=0;for(let s=t.length-1;s>=0;--s){const u=t.charCodeAt(s);if(u===v){if(!l){r=s+1;break}continue}i===-1&&(l=!1,i=s+1),u===k?n===-1?n=s:c!==1&&(c=1):n!==-1&&(c=-1)}return n===-1||i===-1||c===0||c===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:w.bind(null,"/"),parse(t){p(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===v;let i;r?(n.root="/",i=1):i=0;let l=-1,c=0,s=-1,u=!0,S=t.length-1,A=0;for(;S>=i;--S){const O=t.charCodeAt(S);if(O===v){if(!u){c=S+1;break}continue}s===-1&&(u=!1,s=S+1),O===k?l===-1?l=S:A!==1&&(A=1):l!==-1&&(A=-1)}if(s!==-1){const O=c===0&&r?1:c;l===-1||A===0||A===1&&l===s-1&&l===c+1?n.base=n.name=t.slice(O,s):(n.name=t.slice(O,l),n.base=t.slice(O,s),n.ext=t.slice(l,s))}return c>0?n.dir=t.slice(0,c-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(pe[57],ve([1,0,7]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(T){const I=(0,y.extname)(T),E=R[I.toLowerCase()];return E!==void 0?E:C(T)}e.getMediaOrTextMime=D;function C(T){const I=(0,y.extname)(T);return a[I.toLowerCase()]}e.getMediaMime=C;function k(T){for(const I in a)if(a[I]===T)return I}e.getExtensionForMimeType=k;const v=/^(.+)\/(.+?)(;.+)?$/;function g(T,I){const E=v.exec(T);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:I?void 0:T}e.normalizeMimeType=g}),define(pe[58],ve([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var a;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(a=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...v){const g=v.reduce((E,m)=>(E[m]=!0,E),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(k).filter(E=>!g[E]).forEach(E=>{for(let m=0;m<T.length;m++)if(E.search(T[m])!==-1){delete k[E];break}})}e.sanitizeProcessEnvironment=D;function C(k){!k||(delete k.DEBUG,y.isMacintosh&&delete k.DYLD_LIBRARY_PATH,y.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:ae)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function y(R){if(e[R])return e[R].exports;var a=e[R]={i:R,l:!1,exports:{}};return ae[R].call(a.exports,a,a.exports,y),a.l=!0,a.exports}return y.m=ae,y.c=e,y.d=function(R,a,D){y.o(R,a)||Object.defineProperty(R,a,{enumerable:!0,get:D})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,a){if(1&a&&(R=y(R)),8&a||4&a&&typeof R=="object"&&R&&R.__esModule)return R;var D=Object.create(null);if(y.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:R}),2&a&&typeof R!="string")for(var C in R)y.d(D,C,function(k){return R[k]}.bind(null,C));return D},y.n=function(R){var a=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(a,"a",a),a},y.o=function(R,a){return Object.prototype.hasOwnProperty.call(R,a)},y.p="",y(y.s=0)}([function(ae,e,y){(function(R){var a;e=ae.exports=W,a=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],v=e.src=[],g=0,T=g++;v[T]="0|[1-9]\\d*";var I=g++;v[I]="[0-9]+";var E=g++;v[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=g++;v[m]="("+v[T]+")\\.("+v[T]+")\\.("+v[T]+")";var p=g++;v[p]="("+v[I]+")\\.("+v[I]+")\\.("+v[I]+")";var b=g++;v[b]="(?:"+v[T]+"|"+v[E]+")";var o=g++;v[o]="(?:"+v[I]+"|"+v[E]+")";var d=g++;v[d]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var h=g++;v[h]="(?:-?("+v[o]+"(?:\\."+v[o]+")*))";var f=g++;v[f]="[0-9A-Za-z-]+";var w=g++;v[w]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var L=g++,t="v?"+v[m]+v[d]+"?"+v[w]+"?";v[L]="^"+t+"$";var n="[v=\\s]*"+v[p]+v[h]+"?"+v[w]+"?",r=g++;v[r]="^"+n+"$";var i=g++;v[i]="((?:<|>)?=?)";var l=g++;v[l]=v[I]+"|x|X|\\*";var c=g++;v[c]=v[T]+"|x|X|\\*";var s=g++;v[s]="[v=\\s]*("+v[c]+")(?:\\.("+v[c]+")(?:\\.("+v[c]+")(?:"+v[d]+")?"+v[w]+"?)?)?";var u=g++;v[u]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[h]+")?"+v[w]+"?)?)?";var S=g++;v[S]="^"+v[i]+"\\s*"+v[s]+"$";var A=g++;v[A]="^"+v[i]+"\\s*"+v[u]+"$";var O=g++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=g++;v[B]="(?:~>?)";var q=g++;v[q]="(\\s*)"+v[B]+"\\s+",k[q]=new RegExp(v[q],"g");var le=g++;v[le]="^"+v[B]+v[s]+"$";var fe=g++;v[fe]="^"+v[B]+v[u]+"$";var ue=g++;v[ue]="(?:\\^)";var re=g++;v[re]="(\\s*)"+v[ue]+"\\s+",k[re]=new RegExp(v[re],"g");var _=g++;v[_]="^"+v[ue]+v[s]+"$";var ee=g++;v[ee]="^"+v[ue]+v[u]+"$";var ne=g++;v[ne]="^"+v[i]+"\\s*("+n+")$|^$";var ie=g++;v[ie]="^"+v[i]+"\\s*("+t+")$|^$";var G=g++;v[G]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[s]+")",k[G]=new RegExp(v[G],"g");var U=g++;v[U]="^\\s*("+v[s]+")\\s+-\\s+("+v[s]+")\\s*$";var Z=g++;v[Z]="^\\s*("+v[u]+")\\s+-\\s+("+v[u]+")\\s*$";var oe=g++;v[oe]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)a(me,v[me]),k[me]||(k[me]=new RegExp(v[me]));function $(ge,Se){if(ge instanceof W)return ge;if(typeof ge!="string"||ge.length>D||!(Se?k[r]:k[L]).test(ge))return null;try{return new W(ge,Se)}catch{return null}}function W(ge,Se){if(ge instanceof W){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof W))return new W(ge,Se);a("SemVer",ge,Se),this.loose=Se;var ye=ge.trim().match(Se?k[r]:k[L]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Ne=+Fe;if(Ne>=0&&Ne<C)return Ne}return Fe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=$,e.valid=function(ge,Se){var ye=$(ge,Se);return ye?ye.version:null},e.clean=function(ge,Se){var ye=$(ge.trim().replace(/^[=v]+/,""),Se);return ye?ye.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(ge){return a("SemVer.compare",this.version,this.loose,ge),ge instanceof W||(ge=new W(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},W.prototype.compareMain=function(ge){return ge instanceof W||(ge=new W(ge,this.loose)),P(this.major,ge.major)||P(this.minor,ge.minor)||P(this.patch,ge.patch)},W.prototype.comparePre=function(ge){if(ge instanceof W||(ge=new W(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var ye=this.prerelease[Se],Fe=ge.prerelease[Se];if(a("prerelease compare",Se,ye,Fe),ye===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ye===void 0)return-1;if(ye!==Fe)return P(ye,Fe)}while(++Se)},W.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,ye,Fe){typeof ye=="string"&&(Fe=ye,ye=void 0);try{return new W(ge,ye).inc(Se,Fe).version}catch{return null}},e.diff=function(ge,Se){if(j(ge,Se))return null;var ye=$(ge),Fe=$(Se);if(ye.prerelease.length||Fe.prerelease.length){for(var Ne in ye)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ye[Ne]!==Fe[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in ye)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ye[Ne]!==Fe[Ne])return Ne},e.compareIdentifiers=P;var N=/^[0-9]+$/;function P(ge,Se){var ye=N.test(ge),Fe=N.test(Se);return ye&&Fe&&(ge=+ge,Se=+Se),ye&&!Fe?-1:Fe&&!ye?1:ge<Se?-1:ge>Se?1:0}function M(ge,Se,ye){return new W(ge,ye).compare(new W(Se,ye))}function K(ge,Se,ye){return M(ge,Se,ye)>0}function te(ge,Se,ye){return M(ge,Se,ye)<0}function j(ge,Se,ye){return M(ge,Se,ye)===0}function H(ge,Se,ye){return M(ge,Se,ye)!==0}function J(ge,Se,ye){return M(ge,Se,ye)>=0}function V(ge,Se,ye){return M(ge,Se,ye)<=0}function X(ge,Se,ye,Fe){var Ne;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Ne=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Ne=ge!==ye;break;case"":case"=":case"==":Ne=j(ge,ye,Fe);break;case"!=":Ne=H(ge,ye,Fe);break;case">":Ne=K(ge,ye,Fe);break;case">=":Ne=J(ge,ye,Fe);break;case"<":Ne=te(ge,ye,Fe);break;case"<=":Ne=V(ge,ye,Fe);break;default:throw new TypeError("Invalid operator: "+Se)}return Ne}function x(ge,Se){if(ge instanceof x){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof x))return new x(ge,Se);a("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,a("comp",this)}e.rcompareIdentifiers=function(ge,Se){return P(Se,ge)},e.major=function(ge,Se){return new W(ge,Se).major},e.minor=function(ge,Se){return new W(ge,Se).minor},e.patch=function(ge,Se){return new W(ge,Se).patch},e.compare=M,e.compareLoose=function(ge,Se){return M(ge,Se,!0)},e.rcompare=function(ge,Se,ye){return M(Se,ge,ye)},e.sort=function(ge,Se){return ge.sort(function(ye,Fe){return e.compare(ye,Fe,Se)})},e.rsort=function(ge,Se){return ge.sort(function(ye,Fe){return e.rcompare(ye,Fe,Se)})},e.gt=K,e.lt=te,e.eq=j,e.neq=H,e.gte=J,e.lte=V,e.cmp=X,e.Comparator=x;var Q={};function ce(ge,Se){if(ge instanceof ce)return ge.loose===Se?ge:new ce(ge.raw,Se);if(ge instanceof x)return new ce(ge.value,Se);if(!(this instanceof ce))return new ce(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function Ee(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Ce(ge,Se,ye,Fe,Ne,et,Ve,Xe,Qe,Ze,Ge,he,Ie){return((Se=Ee(ye)?"":Ee(Fe)?">="+ye+".0.0":Ee(Ne)?">="+ye+"."+Fe+".0":">="+Se)+" "+(Xe=Ee(Qe)?"":Ee(Ze)?"<"+(+Qe+1)+".0.0":Ee(Ge)?"<"+Qe+"."+(+Ze+1)+".0":he?"<="+Qe+"."+Ze+"."+Ge+"-"+he:"<="+Xe)).trim()}function ke(ge,Se){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(Se))return!1;if(Se.prerelease.length){for(ye=0;ye<ge.length;ye++)if(a(ge[ye].semver),ge[ye].semver!==Q&&ge[ye].semver.prerelease.length>0){var Fe=ge[ye].semver;if(Fe.major===Se.major&&Fe.minor===Se.minor&&Fe.patch===Se.patch)return!0}return!1}return!0}function Me(ge,Se,ye){try{Se=new ce(Se,ye)}catch{return!1}return Se.test(ge)}function $e(ge,Se,ye,Fe){var Ne,et,Ve,Xe,Qe;switch(ge=new W(ge,Fe),Se=new ce(Se,Fe),ye){case">":Ne=K,et=V,Ve=te,Xe=">",Qe=">=";break;case"<":Ne=te,et=J,Ve=K,Xe="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(ge,Se,Fe))return!1;for(var Ze=0;Ze<Se.set.length;++Ze){var Ge=Se.set[Ze],he=null,Ie=null;if(Ge.forEach(function(Te){Te.semver===Q&&(Te=new x(">=0.0.0")),he=he||Te,Ie=Ie||Te,Ne(Te.semver,he.semver,Fe)?he=Te:Ve(Te.semver,Ie.semver,Fe)&&(Ie=Te)}),he.operator===Xe||he.operator===Qe||(!Ie.operator||Ie.operator===Xe)&&et(ge,Ie.semver)||Ie.operator===Qe&&Ve(ge,Ie.semver))return!1}return!0}x.prototype.parse=function(ge){var Se=this.loose?k[ne]:k[ie],ye=ge.match(Se);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new W(ye[2],this.loose):this.semver=Q},x.prototype.toString=function(){return this.value},x.prototype.test=function(ge){return a("Comparator.test",ge,this.loose),this.semver===Q||(typeof ge=="string"&&(ge=new W(ge,this.loose)),X(ge,this.operator,this.semver,this.loose))},x.prototype.intersects=function(ge,Se){if(!(ge instanceof x))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ce(ge.value,Se),Me(this.value,ye,Se);if(ge.operator==="")return ye=new ce(this.value,Se),Me(ge.semver,ye,Se);var Fe=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),et=this.semver.version===ge.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Xe=X(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Qe=X(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Fe||Ne||et&&Ve||Xe||Qe},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),a("range",ge,Se);var ye=Se?k[Z]:k[U];ge=ge.replace(ye,Ce),a("hyphen replace",ge),ge=ge.replace(k[G],"$1$2$3"),a("comparator trim",ge,k[G]),ge=(ge=(ge=ge.replace(k[q],"$1~")).replace(k[re],"$1^")).split(/\s+/).join(" ");var Fe=Se?k[ne]:k[ie],Ne=ge.split(" ").map(function(et){return function(Ve,Xe){return a("comp",Ve),Ve=function(Qe,Ze){return Qe.trim().split(/\s+/).map(function(Ge){return function(he,Ie){a("caret",he,Ie);var Te=Ie?k[ee]:k[_];return he.replace(Te,function(Be,Le,je,We,Ye){var qe;return a("caret",he,Be,Le,je,We,Ye),Ee(Le)?qe="":Ee(je)?qe=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(We)?qe=Le==="0"?">="+Le+"."+je+".0 <"+Le+"."+(+je+1)+".0":">="+Le+"."+je+".0 <"+(+Le+1)+".0.0":Ye?(a("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),qe=Le==="0"?je==="0"?">="+Le+"."+je+"."+We+Ye+" <"+Le+"."+je+"."+(+We+1):">="+Le+"."+je+"."+We+Ye+" <"+Le+"."+(+je+1)+".0":">="+Le+"."+je+"."+We+Ye+" <"+(+Le+1)+".0.0"):(a("no pr"),qe=Le==="0"?je==="0"?">="+Le+"."+je+"."+We+" <"+Le+"."+je+"."+(+We+1):">="+Le+"."+je+"."+We+" <"+Le+"."+(+je+1)+".0":">="+Le+"."+je+"."+We+" <"+(+Le+1)+".0.0"),a("caret return",qe),qe})}(Ge,Ze)}).join(" ")}(Ve,Xe),a("caret",Ve),Ve=function(Qe,Ze){return Qe.trim().split(/\s+/).map(function(Ge){return function(he,Ie){var Te=Ie?k[fe]:k[le];return he.replace(Te,function(Be,Le,je,We,Ye){var qe;return a("tilde",he,Be,Le,je,We,Ye),Ee(Le)?qe="":Ee(je)?qe=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(We)?qe=">="+Le+"."+je+".0 <"+Le+"."+(+je+1)+".0":Ye?(a("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),qe=">="+Le+"."+je+"."+We+Ye+" <"+Le+"."+(+je+1)+".0"):qe=">="+Le+"."+je+"."+We+" <"+Le+"."+(+je+1)+".0",a("tilde return",qe),qe})}(Ge,Ze)}).join(" ")}(Ve,Xe),a("tildes",Ve),Ve=function(Qe,Ze){return a("replaceXRanges",Qe,Ze),Qe.split(/\s+/).map(function(Ge){return function(he,Ie){he=he.trim();var Te=Ie?k[A]:k[S];return he.replace(Te,function(Be,Le,je,We,Ye,qe){a("xRange",he,Be,Le,je,We,Ye,qe);var Ke=Ee(je),tt=Ke||Ee(We),Je=tt||Ee(Ye);return Le==="="&&Je&&(Le=""),Ke?Be=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Je?(tt&&(We=0),Je&&(Ye=0),Le===">"?(Le=">=",tt?(je=+je+1,We=0,Ye=0):Je&&(We=+We+1,Ye=0)):Le==="<="&&(Le="<",tt?je=+je+1:We=+We+1),Be=Le+je+"."+We+"."+Ye):tt?Be=">="+je+".0.0 <"+(+je+1)+".0.0":Je&&(Be=">="+je+"."+We+".0 <"+je+"."+(+We+1)+".0"),a("xRange return",Be),Be})}(Ge,Ze)}).join(" ")}(Ve,Xe),a("xrange",Ve),Ve=function(Qe,Ze){return a("replaceStars",Qe,Ze),Qe.trim().replace(k[oe],"")}(Ve,Xe),a("stars",Ve),Ve}(et,Se)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(et){return!!et.match(Fe)})),Ne=Ne.map(function(et){return new x(et,Se)})},ce.prototype.intersects=function(ge,Se){if(!(ge instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Fe){return ge.set.some(function(Ne){return Ne.every(function(et){return Fe.intersects(et,Se)})})})})},e.toComparators=function(ge,Se){return new ce(ge,Se).set.map(function(ye){return ye.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new W(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],ge))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(ge,Se,ye){var Fe=null,Ne=null;try{var et=new ce(Se,ye)}catch{return null}return ge.forEach(function(Ve){et.test(Ve)&&(Fe&&Ne.compare(Ve)!==-1||(Ne=new W(Fe=Ve,ye)))}),Fe},e.minSatisfying=function(ge,Se,ye){var Fe=null,Ne=null;try{var et=new ce(Se,ye)}catch{return null}return ge.forEach(function(Ve){et.test(Ve)&&(Fe&&Ne.compare(Ve)!==1||(Ne=new W(Fe=Ve,ye)))}),Fe},e.validRange=function(ge,Se){try{return new ce(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,ye){return $e(ge,Se,"<",ye)},e.gtr=function(ge,Se,ye){return $e(ge,Se,">",ye)},e.outside=$e,e.prerelease=function(ge,Se){var ye=$(ge,Se);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,Se,ye){return ge=new ce(ge,ye),Se=new ce(Se,ye),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof W)return ge;if(typeof ge!="string")return null;var Se=ge.match(k[O]);return Se==null?null:$((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,y(1))},function(ae,e){var y,R,a=ae.exports={};function D(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(o){if(y===setTimeout)return setTimeout(o,0);if((y===D||!y)&&setTimeout)return y=setTimeout,setTimeout(o,0);try{return y(o,0)}catch{try{return y.call(null,o,0)}catch{return y.call(this,o,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:D}catch{y=D}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var v,g=[],T=!1,I=-1;function E(){T&&v&&(T=!1,v.length?g=v.concat(g):I=-1,g.length&&m())}function m(){if(!T){var o=k(E);T=!0;for(var d=g.length;d;){for(v=g,g=[];++I<d;)v&&v[I].run();I=-1,d=g.length}v=null,T=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(o)}}function p(o,d){this.fun=o,this.array=d}function b(){}a.nextTick=function(o){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];g.push(new p(o,d)),g.length!==1||T||k(m)},p.prototype.run=function(){this.fun.apply(null,this.array)},a.title="browser",a.browser=!0,a.env={},a.argv=[],a.version="",a.versions={},a.on=b,a.addListener=b,a.once=b,a.off=b,a.removeListener=b,a.removeAllListeners=b,a.emit=b,a.prependListener=b,a.prependOnceListener=b,a.listeners=function(o){return[]},a.binding=function(o){throw new Error("process.binding is not supported")},a.cwd=function(){return"/"},a.chdir=function(o){throw new Error("process.chdir is not supported")},a.umask=function(){return 0}}])}),define(pe[143],ve([1,0]),function(ae,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(k,v,g){this.level=k,this.key=v,this.value=g,this.forward=[]}}const a=void 0;class D{constructor(k,v=2**16){this.comparator=k,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new R(this.c,a,a)}get size(){return this.f}clear(){this.e=new R(this.c,a,a)}has(k){return Boolean(D.g(this,k,this.comparator))}get(k){return D.g(this,k,this.comparator)?.value}set(k,v){return D.h(this,k,v,this.comparator)&&(this.f+=1),this}delete(k){const v=D.k(this,k,this.comparator);return v&&(this.f-=1),v}forEach(k,v){let g=this.e.forward[0];for(;g;)k.call(v,g.value,g.key,this),g=g.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",v=this.e.forward[0];for(;v;)k+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return k}static g(k,v,g){let T=k.e;for(let I=k.d-1;I>=0;I--)for(;T.forward[I]&&g(T.forward[I].key,v)<0;)T=T.forward[I];if(T=T.forward[0],T&&g(T.key,v)===0)return T}static h(k,v,g,T){const I=[];let E=k.e;for(let m=k.d-1;m>=0;m--){for(;E.forward[m]&&T(E.forward[m].key,v)<0;)E=E.forward[m];I[m]=E}if(E=E.forward[0],E&&T(E.key,v)===0)return E.value=g,!1;{const m=D.j(k);if(m>k.d){for(let p=k.d;p<m;p++)I[p]=k.e;k.d=m}E=new R(m,v,g);for(let p=0;p<m;p++)E.forward[p]=I[p].forward[p],I[p].forward[p]=E;return!0}}static j(k,v=.5){let g=1;for(;Math.random()<v&&g<k.c;)g+=1;return g}static k(k,v,g){const T=[];let I=k.e;for(let E=k.d-1;E>=0;E--){for(;I.forward[E]&&g(I.forward[E].key,v)<0;)I=I.forward[E];T[E]=I}if(I=I.forward[0],!I||g(I.key,v)!==0)return!1;for(let E=0;E<k.d&&T[E].forward[E]===I;E++)T[E].forward[E]=I.forward[E];for(;k.d>0&&k.e.forward[k.d-1]===a;)k.d-=1;return!0}}e.SkipList=D}),define(pe[94],ve([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=y.globals.performance&&typeof y.globals.performance.now=="function";class a{static create(C=!0){return new a(C)}constructor(C){this.a=R&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?y.globals.performance.now():Date.now()}}e.StopWatch=a}),define(pe[6],ve([1,0,9,71,2,92,94]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,v=!1;var g;(function(c){c.None=()=>a.Disposable.None;function s(M){if(v){const{onDidAddListener:K}=M,te=p.create();let j=0;M.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),te.print()),K?.()}}}function u(M,K){return re(M,()=>{},0,void 0,!0,void 0,K)}c.defer=u;function S(M){return(K,te=null,j)=>{let H=!1,J;return J=M(V=>{if(!H)return J?J.dispose():H=!0,K.call(te,V)},null,j),H&&J.dispose(),J}}c.once=S;function A(M,K,te){return ue((j,H=null,J)=>M(V=>j.call(H,K(V)),null,J),te)}c.map=A;function O(M,K,te){return ue((j,H=null,J)=>M(V=>{K(V),j.call(H,V)},null,J),te)}c.forEach=O;function B(M,K,te){return ue((j,H=null,J)=>M(V=>K(V)&&j.call(H,V),null,J),te)}c.filter=B;function q(M){return M}c.signal=q;function le(...M){return(K,te=null,j)=>(0,a.combinedDisposable)(...M.map(H=>H(J=>K.call(te,J),null,j)))}c.any=le;function fe(M,K,te,j){let H=te;return A(M,J=>(H=K(H,J),H),j)}c.reduce=fe;function ue(M,K){let te;const j={onWillAddFirstListener(){te=M(H.fire,H)},onDidRemoveLastListener(){te?.dispose()}};K||s(j);const H=new o(j);return K?.add(H),H.event}function re(M,K,te=100,j=!1,H=!1,J,V){let X,x,Q,ce=0,Ee;const Ce={leakWarningThreshold:J,onWillAddFirstListener(){X=M(Me=>{ce++,x=K(x,Me),j&&!Q&&(ke.fire(x),x=void 0),Ee=()=>{const $e=x;x=void 0,Q=void 0,(!j||ce>1)&&ke.fire($e),ce=0},typeof te=="number"?(clearTimeout(Q),Q=setTimeout(Ee,te)):Q===void 0&&(Q=0,queueMicrotask(Ee))})},onWillRemoveListener(){H&&ce>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,X.dispose()}};V||s(Ce);const ke=new o(Ce);return V?.add(ke),ke.event}c.debounce=re;function _(M,K=0,te){return c.debounce(M,(j,H)=>j?(j.push(H),j):[H],K,void 0,!0,void 0,te)}c.accumulate=_;function ee(M,K=(j,H)=>j===H,te){let j=!0,H;return B(M,J=>{const V=j||!K(J,H);return j=!1,H=J,V},te)}c.latch=ee;function ne(M,K,te){return[c.filter(M,K,te),c.filter(M,j=>!K(j),te)]}c.split=ne;function ie(M,K=!1,te=[]){let j=te.slice(),H=M(X=>{j?j.push(X):V.fire(X)});const J=()=>{j?.forEach(X=>V.fire(X)),j=null},V=new o({onWillAddFirstListener(){H||(H=M(X=>V.fire(X)))},onDidAddFirstListener(){j&&(K?setTimeout(J):J())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return V.event}c.buffer=ie;class G{constructor(K){this.event=K,this.c=new a.DisposableStore}map(K){return new G(A(this.event,K,this.c))}forEach(K){return new G(O(this.event,K,this.c))}filter(K){return new G(B(this.event,K,this.c))}reduce(K,te){return new G(fe(this.event,K,te,this.c))}latch(){return new G(ee(this.event,void 0,this.c))}debounce(K,te=100,j=!1,H=!1,J){return new G(re(this.event,K,te,j,H,J,this.c))}on(K,te,j){return this.event(K,te,j)}once(K,te,j){return S(this.event)(K,te,j)}dispose(){this.c.dispose()}}function U(M){return new G(M)}c.chain=U;function Z(M,K,te=j=>j){const j=(...X)=>V.fire(te(...X)),H=()=>M.on(K,j),J=()=>M.removeListener(K,j),V=new o({onWillAddFirstListener:H,onDidRemoveLastListener:J});return V.event}c.fromNodeEventEmitter=Z;function oe(M,K,te=j=>j){const j=(...X)=>V.fire(te(...X)),H=()=>M.addEventListener(K,j),J=()=>M.removeEventListener(K,j),V=new o({onWillAddFirstListener:H,onDidRemoveLastListener:J});return V.event}c.fromDOMEventEmitter=oe;function me(M){return new Promise(K=>S(M)(K))}c.toPromise=me;function $(M,K){return K(void 0),M(te=>K(te))}c.runAndSubscribe=$;function W(M,K){let te=null;function j(J){te?.dispose(),te=new a.DisposableStore,K(J,te)}j(void 0);const H=M(J=>j(J));return(0,a.toDisposable)(()=>{H.dispose(),te?.dispose()})}c.runAndSubscribeWithStore=W;class N{constructor(K,te){this.obs=K,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{K.addObserver(this)},onDidRemoveLastListener:()=>{K.removeObserver(this)}};te||s(j),this.emitter=new o(j),te&&te.add(this.emitter)}beginUpdate(K){this.c++}handleChange(K,te){this.d=!0}endUpdate(K){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function P(M,K){return new N(M,K).emitter.event}c.fromObservable=P})(g=e.Event||(e.Event={}));class T{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${T.c++}`,T.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}T.all=new Set,T.c=0,e.EventProfiling=T;let I=-1;function E(c){const s=I;return I=c,{dispose(){I=s}}}e.setGlobalLeakWarningThreshold=E;class m{constructor(s,u=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=u,this.d=0}dispose(){this.c?.clear()}check(s,u){const S=this.threshold;if(S<=0||u<S)return;this.c||(this.c=new Map);const A=this.c.get(s.value)||0;if(this.c.set(s.value,A+1),this.d-=1,this.d<=0){this.d=S*.5;let O,B=0;for(const[q,le]of this.c)(!O||B<le)&&(O=q,B=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${B}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(s,u,S){this.callback=s,this.callbackThis=u,this.stack=S,this.subscription=new a.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class o{constructor(s){this.j=!1,this.d=s,this.f=I>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const s=Array.from(this.q);queueMicrotask(()=>{for(const u of s)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,u,S)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),a.Disposable.None;const A=this.q.isEmpty();A&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=p.create(),O=this.f.check(B,this.q.size+1)),k&&(B=B??p.create());const q=new b(s,u,B),le=this.q.push(q);A&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,u);const fe=q.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),le(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return S instanceof a.DisposableStore?S.add(fe):Array.isArray(S)&&S.push(fe),fe}),this.l}fire(s){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const u of this.q)this.m.push(this,u,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=o;class d{constructor(s=y.onUnexpectedError){this.d=s,this.c=new D.LinkedList}get size(){return this.c.size}push(s,u,S){this.c.push(new f(s,u,S))}clear(s){const u=new D.LinkedList;for(const S of this.c)S.emitter!==s&&u.push(S);this.c=u}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(u){this.d(u)}}}}e.EventDeliveryQueue=d;class h extends d{clear(s){this.c.clear()}}class f{constructor(s,u,S){this.emitter=s,this.listener=u,this.event=S}}class w extends o{async fireAsync(s,u,S){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const A of this.q)this.c.push([A,s]);for(;this.c.size>0&&!u.isCancellationRequested;){const[A,O]=this.c.shift(),B=[],q={...O,token:u,waitUntil:le=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");S&&(le=S(le,A.callback)),B.push(le)}};try{A.invoke(q)}catch(le){(0,y.onUnexpectedError)(le);continue}Object.freeze(B),await Promise.allSettled(B).then(le=>{for(const fe of le)fe.status==="rejected"&&(0,y.onUnexpectedError)(fe.reason)})}}}}e.AsyncEmitter=w;class L extends o{constructor(s){super(s),this.h=0,this.s=new D.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=L;class t extends L{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class n extends o{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new o({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const u={event:s,listener:null};this.f.push(u),this.d&&this.j(u);const S=()=>{this.d&&this.k(u);const A=this.f.indexOf(u);this.f.splice(A,1)};return(0,a.toDisposable)((0,R.once)(S))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(u=>this.c.fire(u))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class i{constructor(){this.c=[]}wrapEvent(s){return(u,S,A)=>s(O=>{const B=this.c[this.c.length-1];B?B.push(()=>u.call(S,O)):u.call(S,O)},void 0,A)}bufferEvents(s){const u=[];this.c.push(u);const S=s();return this.c.pop(),u.forEach(A=>A()),S}}e.EventBufferer=i;class l{constructor(){this.c=!1,this.d=g.None,this.f=a.Disposable.None,this.g=new o({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(pe[20],ve([1,0,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(k,v){const g=setTimeout(k.bind(v),0);return{dispose(){clearTimeout(g)}}});var a;(function(k){function v(g){return g===k.None||g===k.Cancelled||g instanceof D?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}k.isCancellationToken=v,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(a=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new y.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(v){this.a=void 0,this.b=void 0,this.b=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=a.Cancelled}dispose(v=!1){v&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=a.None}}e.CancellationTokenSource=C}),define(pe[144],ve([1,0,20]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new y.CancellationTokenSource,v=this.b(k.token);return this.a={promise:v,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=R;class a{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const v=JSON.stringify(k);return this.b!==v&&(this.b=v,this.a=this.c(k)),this.a}}e.LRUCachedFunction=a;class D{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const v=this.b(k);return this.a.set(k,v),v}}e.CachedFunction=D}),define(pe[46],ve([1,0,9,2]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function a(w){const L=w;return L?typeof L.read=="function":!1}e.isReadable=a;function D(w){const L=w;return L?[L.on,L.pause,L.resume,L.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function C(w){const L=w;return L?D(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(w,L){return new v(w,L)}e.newWriteableStream=k;class v{constructor(L,t){this.e=L,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(t=>t(L))}h(L){this.c.error.length===0?(0,y.onUnexpectedError)(L):this.c.error.slice(0).forEach(t=>t(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,t){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(L,t){if(this.a.destroyed)return;let n;switch(L){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(w,L){const t=[];let n;for(;(n=w.read())!==null;)t.push(n);return L(t)}e.consumeReadable=g;function T(w,L,t){const n=[];let r;for(;(r=w.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?L(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return w.read()}}}e.peekReadable=T;function I(w,L){return new Promise((t,n)=>{const r=[];E(w,{onData:i=>{L&&r.push(i)},onError:i=>{L?n(i):t(void 0)},onEnd:()=>{t(L?L(r):void 0)}})})}e.consumeStream=I;function E(w,L){let t=!1;return w.on("error",n=>{t||L.onError(n)}),w.on("end",()=>{t||L.onEnd()}),w.on("data",n=>{t||L.onData(n)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=E;function m(w,L){return new Promise((t,n)=>{const r=new R.DisposableStore,i=[],l=u=>{if(i.push(u),i.length>L)return r.dispose(),w.pause(),t({stream:w,buffer:i,ended:!1})},c=u=>n(u),s=()=>t({stream:w,buffer:i,ended:!0});r.add((0,R.toDisposable)(()=>w.removeListener("error",c))),w.on("error",c),r.add((0,R.toDisposable)(()=>w.removeListener("end",s))),w.on("end",s),r.add((0,R.toDisposable)(()=>w.removeListener("data",l))),w.on("data",l)})}e.peekStream=m;function p(w,L){const t=k(L);return t.end(w),t}e.toStream=p;function b(){const w=k(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=b;function o(w){let L=!1;return{read:()=>L?null:(L=!0,w)}}e.toReadable=o;function d(w,L,t){const n=k(t);return E(w,{onData:r=>n.write(L.data(r)),onError:r=>n.error(L.error?L.error(r):r),onEnd:()=>n.end()}),n}e.transform=d;function h(w,L,t){let n=!1;return{read:()=>{const r=L.read();return n?r:(n=!0,r!==null?t([w,r]):w)}}}e.prefixedReadable=h;function f(w,L,t){let n=!1;const r=k(t);return E(L,{onData:i=>n?r.write(i):(n=!0,r.write(t([w,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(w)),r.end()}}),r}e.prefixedStream=f}),define(pe[15],ve([1,0,46]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let a,D;class C{static alloc(u){return R?new C(Buffer.allocUnsafe(u)):new C(new Uint8Array(u))}static wrap(u){return R&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new C(u)}static fromString(u,S){return!(S?.dontUseNodeBuffer||!1)&&R?new C(Buffer.from(u)):(a||(a=new TextEncoder),new C(a.encode(u)))}static fromByteArray(u){const S=C.alloc(u.length);for(let A=0,O=u.length;A<O;A++)S.buffer[A]=u[A];return S}static concat(u,S){if(typeof S>"u"){S=0;for(let B=0,q=u.length;B<q;B++)S+=u[B].byteLength}const A=C.alloc(S);let O=0;for(let B=0,q=u.length;B<q;B++){const le=u[B];A.set(le,O),O+=le.byteLength}return A}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=C.alloc(this.byteLength);return u.set(this),u}toString(){return R?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(u,S){return new C(this.buffer.subarray(u,S))}set(u,S){if(u instanceof C)this.buffer.set(u.buffer,S);else if(u instanceof Uint8Array)this.buffer.set(u,S);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),S);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return g(this.buffer,u)}writeUInt32BE(u,S){T(this.buffer,u,S)}readUInt32LE(u){return I(this.buffer,u)}writeUInt32LE(u,S){E(this.buffer,u,S)}readUInt8(u){return m(this.buffer,u)}writeUInt8(u,S){p(this.buffer,u,S)}}e.VSBuffer=C;function k(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=k;function v(s,u,S){s[S+0]=u&255,u=u>>>8,s[S+1]=u&255}e.writeUInt16LE=v;function g(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=g;function T(s,u,S){s[S+3]=u,u=u>>>8,s[S+2]=u,u=u>>>8,s[S+1]=u,u=u>>>8,s[S]=u}e.writeUInt32BE=T;function I(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=I;function E(s,u,S){s[S+0]=u&255,u=u>>>8,s[S+1]=u&255,u=u>>>8,s[S+2]=u&255,u=u>>>8,s[S+3]=u&255}e.writeUInt32LE=E;function m(s,u){return s[u]}e.readUInt8=m;function p(s,u,S){s[S]=u}e.writeUInt8=p;function b(s){return y.consumeReadable(s,u=>C.concat(u))}e.readableToBuffer=b;function o(s){return y.toReadable(s)}e.bufferToReadable=o;function d(s){return y.consumeStream(s,u=>C.concat(u))}e.streamToBuffer=d;async function h(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=h;function f(s){return y.toStream(s,u=>C.concat(u))}e.bufferToStream=f;function w(s){return y.transform(s,{data:u=>typeof u=="string"?C.fromString(u):C.wrap(u)},u=>C.concat(u))}e.streamToBufferReadableStream=w;function L(s){return y.newWriteableStream(u=>C.concat(u),s)}e.newWriteableBufferStream=L;function t(s,u){return y.prefixedReadable(s,u,S=>C.concat(S))}e.prefixedBufferReadable=t;function n(s,u){return y.prefixedStream(s,u,S=>C.concat(S))}e.prefixedBufferStream=n;function r(s){let u=0,S=0,A=0;const O=new Uint8Array(Math.floor(s.length/4*3)),B=le=>{switch(S){case 3:O[A++]=u|le,S=0;break;case 2:O[A++]=u|le>>>2,u=le<<6,S=3;break;case 1:O[A++]=u|le>>>4,u=le<<4,S=2;break;default:u=le<<2,S=1}};for(let le=0;le<s.length;le++){const fe=s.charCodeAt(le);if(fe>=65&&fe<=90)B(fe-65);else if(fe>=97&&fe<=122)B(fe-97+26);else if(fe>=48&&fe<=57)B(fe-48+52);else if(fe===43||fe===45)B(62);else if(fe===47||fe===95)B(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${s[le]}`)}}const q=A;for(;S>0;)B(0);return C.wrap(O).slice(0,q)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},u=!0,S=!1){const A=S?l:i;let O="";const B=s.byteLength%3;let q=0;for(;q<s.byteLength-B;q+=3){const le=s[q+0],fe=s[q+1],ue=s[q+2];O+=A[le>>>2],O+=A[(le<<4|fe>>>4)&63],O+=A[(fe<<2|ue>>>6)&63],O+=A[ue&63]}if(B===1){const le=s[q+0];O+=A[le>>>2],O+=A[le<<4&63],u&&(O+="==")}else if(B===2){const le=s[q+0],fe=s[q+1];O+=A[le>>>2],O+=A[(le<<4|fe>>>4)&63],O+=A[fe<<2&63],u&&(O+="=")}return O}e.encodeBase64=c}),define(pe[17],ve([1,0,144,140]),function(ae,e,y,R){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=D;const C=/{(\d+)}/g;function k(he,...Ie){return Ie.length===0?he:he.replace(C,function(Te,Be){const Le=parseInt(Be,10);return isNaN(Le)||Le<0||Le>=Ie.length?Te:Ie[Le]})}e.format=k;const v=/{([^}]+)}/g;function g(he,Ie){return he.replace(v,(Te,Be)=>Ie[Be]??Te)}e.format2=g;function T(he){return he.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=T;function I(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function E(he,Ie){let Te=0;const Be=Ie.charCodeAt(0);for(let Le=he.length-1;Le>=0;Le--)he.charCodeAt(Le)===Be&&Te++;return Te}e.count=E;function m(he,Ie,Te="\u2026"){return he.length<=Ie?he:`${he.substr(0,Ie)}${Te}`}e.truncate=m;function p(he,Ie=" "){const Te=b(he,Ie);return o(Te,Ie)}e.trim=p;function b(he,Ie){if(!he||!Ie)return he;const Te=Ie.length;if(Te===0||he.length===0)return he;let Be=0;for(;he.indexOf(Ie,Be)===Be;)Be=Be+Te;return he.substring(Be)}e.ltrim=b;function o(he,Ie){if(!he||!Ie)return he;const Te=Ie.length,Be=he.length;if(Te===0||Be===0)return he;let Le=Be,je=-1;for(;je=he.lastIndexOf(Ie,Le-1),!(je===-1||je+Te!==Le);){if(je===0)return"";Le=je}return he.substring(0,Le)}e.rtrim=o;function d(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(he){return he.replace(/\*/g,"")}e.stripWildcards=h;function f(he,Ie,Te={}){if(!he)throw new Error("Cannot create regex from empty string");Ie||(he=I(he)),Te.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let Be="";return Te.global&&(Be+="g"),Te.matchCase||(Be+="i"),Te.multiline&&(Be+="m"),Te.unicode&&(Be+="u"),new RegExp(he,Be)}e.createRegExp=f;function w(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function L(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function t(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=t;function n(he){return he.split(/\r\n|\r|\n/)}e.splitLines=n;function r(he){for(let Ie=0,Te=he.length;Ie<Te;Ie++){const Be=he.charCodeAt(Ie);if(Be!==32&&Be!==9)return Ie}return-1}e.firstNonWhitespaceIndex=r;function i(he,Ie=0,Te=he.length){for(let Be=Ie;Be<Te;Be++){const Le=he.charCodeAt(Be);if(Le!==32&&Le!==9)return he.substring(Ie,Be)}return he.substring(Ie,Te)}e.getLeadingWhitespace=i;function l(he,Ie=he.length-1){for(let Te=Ie;Te>=0;Te--){const Be=he.charCodeAt(Te);if(Be!==32&&Be!==9)return Te}return-1}e.lastNonWhitespaceIndex=l;function c(he,Ie,Te){const Be=[];let Le=0;for(const je of he.matchAll(Ie)){if(Be.push(he.slice(Le,je.index)),je.index===void 0)throw new Error("match.index should be defined");Le=je.index+je[0].length,Be.push(Te(je[0],...je.slice(1),je.index,he,je.groups))}return Be.push(he.slice(Le)),Promise.all(Be).then(je=>je.join(""))}e.replaceAsync=c;function s(he,Ie){return he<Ie?-1:he>Ie?1:0}e.compare=s;function u(he,Ie,Te=0,Be=he.length,Le=0,je=Ie.length){for(;Te<Be&&Le<je;Te++,Le++){const qe=he.charCodeAt(Te),Ke=Ie.charCodeAt(Le);if(qe<Ke)return-1;if(qe>Ke)return 1}const We=Be-Te,Ye=je-Le;return We<Ye?-1:We>Ye?1:0}e.compareSubstring=u;function S(he,Ie){return A(he,Ie,0,he.length,0,Ie.length)}e.compareIgnoreCase=S;function A(he,Ie,Te=0,Be=he.length,Le=0,je=Ie.length){for(;Te<Be&&Le<je;Te++,Le++){let qe=he.charCodeAt(Te),Ke=Ie.charCodeAt(Le);if(qe===Ke)continue;if(qe>=128||Ke>=128)return u(he.toLowerCase(),Ie.toLowerCase(),Te,Be,Le,je);B(qe)&&(qe-=32),B(Ke)&&(Ke-=32);const tt=qe-Ke;if(tt!==0)return tt}const We=Be-Te,Ye=je-Le;return We<Ye?-1:We>Ye?1:0}e.compareSubstringIgnoreCase=A;function O(he){return he>=48&&he<=57}e.isAsciiDigit=O;function B(he){return he>=97&&he<=122}e.isLowerAsciiLetter=B;function q(he){return he>=65&&he<=90}e.isUpperAsciiLetter=q;function le(he,Ie){return he.length===Ie.length&&A(he,Ie)===0}e.equalsIgnoreCase=le;function fe(he,Ie){const Te=Ie.length;return Ie.length>he.length?!1:A(he,Ie,0,Te)===0}e.startsWithIgnoreCase=fe;function ue(he,Ie){const Te=Math.min(he.length,Ie.length);let Be;for(Be=0;Be<Te;Be++)if(he.charCodeAt(Be)!==Ie.charCodeAt(Be))return Be;return Te}e.commonPrefixLength=ue;function re(he,Ie){const Te=Math.min(he.length,Ie.length);let Be;const Le=he.length-1,je=Ie.length-1;for(Be=0;Be<Te;Be++)if(he.charCodeAt(Le-Be)!==Ie.charCodeAt(je-Be))return Be;return Te}e.commonSuffixLength=re;function _(he){return 55296<=he&&he<=56319}e.isHighSurrogate=_;function ee(he){return 56320<=he&&he<=57343}e.isLowSurrogate=ee;function ne(he,Ie){return(he-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=ne;function ie(he,Ie,Te){const Be=he.charCodeAt(Te);if(_(Be)&&Te+1<Ie){const Le=he.charCodeAt(Te+1);if(ee(Le))return ne(Be,Le)}return Be}e.getNextCodePoint=ie;function G(he,Ie){const Te=he.charCodeAt(Ie-1);if(ee(Te)&&Ie>1){const Be=he.charCodeAt(Ie-2);if(_(Be))return ne(Be,Te)}return Te}class U{get offset(){return this.e}constructor(Ie,Te=0){this.c=Ie,this.d=Ie.length,this.e=Te}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=G(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=ie(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.CodePointIterator=U;class Z{get offset(){return this.c.offset}constructor(Ie,Te=0){this.c=new U(Ie,Te)}nextGraphemeLength(){const Ie=Fe.getInstance(),Te=this.c,Be=Te.offset;let Le=Ie.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const je=Te.offset,We=Ie.getGraphemeBreakType(Te.nextCodePoint());if(Se(Le,We)){Te.setOffset(je);break}Le=We}return Te.offset-Be}prevGraphemeLength(){const Ie=Fe.getInstance(),Te=this.c,Be=Te.offset;let Le=Ie.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const je=Te.offset,We=Ie.getGraphemeBreakType(Te.prevCodePoint());if(Se(We,Le)){Te.setOffset(je);break}Le=We}return Be-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function oe(he,Ie){return new Z(he,Ie).nextGraphemeLength()}e.nextCharLength=oe;function me(he,Ie){return new Z(he,Ie).prevGraphemeLength()}e.prevCharLength=me;function $(he,Ie){Ie>0&&ee(he.charCodeAt(Ie))&&Ie--;const Te=Ie+oe(he,Ie);return[Te-me(he,Te),Te]}e.getCharContainingOffset=$;function W(he){const Ie=new Z(he);let Te=0;for(;!Ie.eol();)Te++,Ie.nextGraphemeLength();return Te}e.charCount=W;let N;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(he){return N||(N=P()),N.test(he)}e.containsRTL=M;const K=/^[\t\n\r\x20-\x7E]*$/;function te(he){return K.test(he)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=j;function H(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=H;function J(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=J;function V(he,Ie){if(he.length<Ie)return he;const Te=/\b/g;let Be=0;for(;Te.test(he)&&!(he.length-Te.lastIndex<Ie);)Be=Te.lastIndex,Te.lastIndex+=1;return he.substring(Be).replace(/^\s/,"")}e.lcut=V;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function x(he){return he&&(he=he.replace(X,"")),he}e.removeAnsiEscapeCodes=x,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function ce(he){return Q(he)?he.substr(1):he}e.stripUTF8BOM=ce;function Ee(he,Ie){if(!he||!Ie||he.length<Ie.length)return!1;const Te=Ie.length,Be=he.toLowerCase();let Le=0,je=-1;for(;Le<Te;){const We=Be.indexOf(Ie[Le],je+1);if(We<0)return!1;je=We,Le++}return!0}e.fuzzyContains=Ee;function Ce(he,Ie=!1){return he?(Ie&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=Ce;function ke(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=ke;function Me(he,Ie=1){if(Ie===0)return"";let Te=-1;do Te=he.indexOf(`
`,Te+1),Ie--;while(Ie>0&&Te>=0);return Te===-1?he:(he[Te-1]==="\r"&&Te--,he.substr(0,Te))}e.getNLines=Me;function $e(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=$e;function ge(he){return Fe.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=ge;function Se(he,Ie){return he===0?Ie!==5&&Ie!==7:he===2&&Ie===3?!1:he===4||he===2||he===3||Ie===4||Ie===2||Ie===3?!0:!(he===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(he===11||he===9)&&(Ie===9||Ie===10)||(he===12||he===10)&&Ie===10||Ie===5||Ie===13||Ie===7||he===1||he===13&&Ie===14||he===6&&Ie===6)}var ye;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Ne()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Te=this.d,Be=Te.length/3;let Le=1;for(;Le<=Be;)if(Ie<Te[3*Le])Le=2*Le;else if(Ie>Te[3*Le+1])Le=2*Le+1;else return Te[3*Le+2];return 0}}Fe.c=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function et(he,Ie){if(he===0)return 0;const Te=Ve(he,Ie);if(Te!==void 0)return Te;const Be=new U(Ie,he);return Be.prevCodePoint(),Be.offset}e.getLeftDeleteOffset=et;function Ve(he,Ie){const Te=new U(Ie,he);let Be=Te.prevCodePoint();for(;Xe(Be)||Be===65039||Be===8419;){if(Te.offset===0)return;Be=Te.prevCodePoint()}if(!J(Be))return;let Le=Te.offset;return Le>0&&Te.prevCodePoint()===8205&&(Le=Te.offset),Le}function Xe(he){return 127995<=he&&he<=127999}var Qe;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Ze{static getInstance(Ie){return Ze.d.get(Array.from(Ie))}static getLocales(){return Ze.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}a=Ze,Ze.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ze.d=new y.LRUCachedFunction(he=>{function Ie(Ke){const tt=new Map;for(let Je=0;Je<Ke.length;Je+=2)tt.set(Ke[Je],Ke[Je+1]);return tt}function Te(Ke,tt){const Je=new Map(Ke);for(const[lt,mt]of tt)Je.set(lt,mt);return Je}function Be(Ke,tt){if(!Ke)return tt;const Je=new Map;for(const[lt,mt]of Ke)tt.has(lt)&&Je.set(lt,mt);return Je}const Le=a.c.value;let je=he.filter(Ke=>!Ke.startsWith("_")&&Ke in Le);je.length===0&&(je=["_default"]);let We;for(const Ke of je){const tt=Ie(Le[Ke]);We=Be(We,tt)}const Ye=Ie(Le._common),qe=Te(Ye,We);return new Ze(qe)}),Ze.e=new R.Lazy(()=>Object.keys(Ze.c.value).filter(he=>!he.startsWith("_"))),e.AmbiguousCharacters=Ze;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(Ie){return Ge.e().has(Ie)}static get codePoints(){return Ge.e()}}Ge.d=void 0,e.InvisibleCharacters=Ge}),define(pe[145],ve([1,0,27,17]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function a(...x){return function(Q,ce){for(let Ee=0,Ce=x.length;Ee<Ce;Ee++){const ke=x[Ee](Q,ce);if(ke)return ke}return null}}e.or=a,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(x,Q,ce){if(!ce||ce.length<Q.length)return null;let Ee;return x?Ee=R.startsWithIgnoreCase(ce,Q):Ee=ce.indexOf(Q)===0,Ee?Q.length>0?[{start:0,end:Q.length}]:[]:null}function C(x,Q){const ce=Q.toLowerCase().indexOf(x.toLowerCase());return ce===-1?null:[{start:ce,end:ce+x.length}]}e.matchesContiguousSubString=C;function k(x,Q){return v(x.toLowerCase(),Q.toLowerCase(),0,0)}e.matchesSubString=k;function v(x,Q,ce,Ee){if(ce===x.length)return[];if(Ee===Q.length)return null;if(x[ce]===Q[Ee]){let Ce=null;return(Ce=v(x,Q,ce+1,Ee+1))?d({start:Ee,end:Ee+1},Ce):null}return v(x,Q,ce,Ee+1)}function g(x){return 97<=x&&x<=122}function T(x){return 65<=x&&x<=90}e.isUpper=T;function I(x){return 48<=x&&x<=57}function E(x){return x===32||x===9||x===10||x===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>m.add(x.charCodeAt(0)));function p(x){return E(x)||m.has(x)}function b(x,Q){return x===Q||p(x)&&p(Q)}function o(x){return g(x)||T(x)||I(x)}function d(x,Q){return Q.length===0?Q=[x]:x.end===Q[0].start?Q[0].start=x.start:Q.unshift(x),Q}function h(x,Q){for(let ce=Q;ce<x.length;ce++){const Ee=x.charCodeAt(ce);if(T(Ee)||I(Ee)||ce>0&&!o(x.charCodeAt(ce-1)))return ce}return x.length}function f(x,Q,ce,Ee){if(ce===x.length)return[];if(Ee===Q.length)return null;if(x[ce]!==Q[Ee].toLowerCase())return null;{let Ce=null,ke=Ee+1;for(Ce=f(x,Q,ce+1,Ee+1);!Ce&&(ke=h(Q,ke))<Q.length;)Ce=f(x,Q,ce+1,ke),ke++;return Ce===null?null:d({start:Ee,end:Ee+1},Ce)}}function w(x){let Q=0,ce=0,Ee=0,Ce=0,ke=0;for(let ye=0;ye<x.length;ye++)ke=x.charCodeAt(ye),T(ke)&&Q++,g(ke)&&ce++,o(ke)&&Ee++,I(ke)&&Ce++;const Me=Q/x.length,$e=ce/x.length,ge=Ee/x.length,Se=Ce/x.length;return{upperPercent:Me,lowerPercent:$e,alphaPercent:ge,numericPercent:Se}}function L(x){const{upperPercent:Q,lowerPercent:ce}=x;return ce===0&&Q>.6}function t(x){const{upperPercent:Q,lowerPercent:ce,alphaPercent:Ee,numericPercent:Ce}=x;return ce>.2&&Q<.8&&Ee>.6&&Ce<.2}function n(x){let Q=0,ce=0,Ee=0,Ce=0;for(let ke=0;ke<x.length;ke++)Ee=x.charCodeAt(ke),T(Ee)&&Q++,g(Ee)&&ce++,E(Ee)&&Ce++;return(Q===0||ce===0)&&Ce===0?x.length<=30:Q<=5}function r(x,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!n(x)||Q.length>60)return null;const ce=w(Q);if(!t(ce)){if(!L(ce))return null;Q=Q.toLowerCase()}let Ee=null,Ce=0;for(x=x.toLowerCase();Ce<Q.length&&(Ee=f(x,Q,0,Ce))===null;)Ce=h(Q,Ce+1);return Ee}e.matchesCamelCase=r;function i(x,Q,ce=!1){if(!Q||Q.length===0)return null;let Ee=null,Ce=0;for(x=x.toLowerCase(),Q=Q.toLowerCase();Ce<Q.length&&(Ee=l(x,Q,0,Ce,ce))===null;)Ce=c(Q,Ce+1);return Ee}e.matchesWords=i;function l(x,Q,ce,Ee,Ce){if(ce===x.length)return[];if(Ee===Q.length)return null;if(b(x.charCodeAt(ce),Q.charCodeAt(Ee))){let ke=null,Me=Ee+1;if(ke=l(x,Q,ce+1,Ee+1,Ce),!Ce)for(;!ke&&(Me=c(Q,Me))<Q.length;)ke=l(x,Q,ce+1,Me,Ce),Me++;return ke?x.charCodeAt(ce)!==Q.charCodeAt(Ee)?ke:d({start:Ee,end:Ee+1},ke):null}else return null}function c(x,Q){for(let ce=Q;ce<x.length;ce++)if(p(x.charCodeAt(ce))||ce>0&&p(x.charCodeAt(ce-1)))return ce;return x.length}const s=a(e.matchesPrefix,r,C),u=a(e.matchesPrefix,r,k),S=new y.LRUCache(1e4);function A(x,Q,ce=!1){if(typeof x!="string"||typeof Q!="string")return null;let Ee=S.get(x);Ee||(Ee=new RegExp(R.convertSimple2RegExpPattern(x),"i"),S.set(x,Ee));const Ce=Ee.exec(Q);return Ce?[{start:Ce.index,end:Ce.index+Ce[0].length}]:ce?u(x,Q):s(x,Q)}e.matchesFuzzy=A;function O(x,Q){const ce=K(x,x.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?q(ce):null}e.matchesFuzzy2=O;function B(x,Q,ce,Ee,Ce,ke){const Me=Math.min(13,x.length);for(;ce<Me;ce++){const $e=K(x,Q,ce,Ee,Ce,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if($e)return $e}return[0,ke]}e.anyScore=B;function q(x){if(typeof x>"u")return[];const Q=[],ce=x[1];for(let Ee=x.length-1;Ee>1;Ee--){const Ce=x[Ee]+ce,ke=Q[Q.length-1];ke&&ke.end===Ce?ke.end=Ce+1:Q.push({start:Ce,end:Ce+1})}return Q}e.createMatches=q;const le=128;function fe(){const x=[],Q=[];for(let ce=0;ce<=le;ce++)Q[ce]=0;for(let ce=0;ce<=le;ce++)x.push(Q.slice(0));return x}function ue(x){const Q=[];for(let ce=0;ce<=x;ce++)Q[ce]=0;return Q}const re=ue(2*le),_=ue(2*le),ee=fe(),ne=fe(),ie=fe(),G=!1;function U(x,Q,ce,Ee,Ce){function ke($e,ge,Se=" "){for(;$e.length<ge;)$e=Se+$e;return $e}let Me=` |   |${Ee.split("").map($e=>ke($e,3)).join("|")}
`;for(let $e=0;$e<=ce;$e++)$e===0?Me+=" |":Me+=`${Q[$e-1]}|`,Me+=x[$e].slice(0,Ce+1).map(ge=>ke(ge.toString(),3)).join("|")+`
`;return Me}function Z(x,Q,ce,Ee){x=x.substr(Q),ce=ce.substr(Ee),console.log(U(ne,x,x.length,ce,ce.length)),console.log(U(ie,x,x.length,ce,ce.length)),console.log(U(ee,x,x.length,ce,ce.length))}function oe(x,Q){if(Q<0||Q>=x.length)return!1;const ce=x.codePointAt(Q);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ce)}}function me(x,Q){if(Q<0||Q>=x.length)return!1;switch(x.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function $(x,Q,ce){return Q[x]!==ce[x]}function W(x,Q,ce,Ee,Ce,ke,Me=!1){for(;Q<ce&&Ce<ke;)x[Q]===Ee[Ce]&&(Me&&(re[Q]=Ce),Q+=1),Ce+=1;return Q===ce}e.isPatternInWord=W;var N;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(N||(N={}));var P;(function(x){x.Default=[-100,0];function Q(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}x.isDefault=Q})(P=e.FuzzyScore||(e.FuzzyScore={}));class M{constructor(Q,ce){this.firstMatchCanBeWeak=Q,this.boostFullMatch=ce}}M.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=M;function K(x,Q,ce,Ee,Ce,ke,Me=M.default){const $e=x.length>le?le:x.length,ge=Ee.length>le?le:Ee.length;if(ce>=$e||ke>=ge||$e-ce>ge-ke||!W(Q,ce,$e,Ce,ke,ge,!0))return;te($e,ge,ce,ke,Q,Ce);let Se=1,ye=1,Fe=ce,Ne=ke;const et=[!1];for(Se=1,Fe=ce;Fe<$e;Se++,Fe++){const Ge=re[Fe],he=_[Fe],Ie=Fe+1<$e?_[Fe+1]:ge;for(ye=Ge-ke+1,Ne=Ge;Ne<Ie;ye++,Ne++){let Te=Number.MIN_SAFE_INTEGER,Be=!1;Ne<=he&&(Te=j(x,Q,Fe,ce,Ee,Ce,Ne,ge,ke,ee[Se-1][ye-1]===0,et));let Le=0;Te!==Number.MAX_SAFE_INTEGER&&(Be=!0,Le=Te+ne[Se-1][ye-1]);const je=Ne>Ge,We=je?ne[Se][ye-1]+(ee[Se][ye-1]>0?-5:0):0,Ye=Ne>Ge+1&&ee[Se][ye-1]>0,qe=Ye?ne[Se][ye-2]+(ee[Se][ye-2]>0?-5:0):0;if(Ye&&(!je||qe>=We)&&(!Be||qe>=Le))ne[Se][ye]=qe,ie[Se][ye]=3,ee[Se][ye]=0;else if(je&&(!Be||We>=Le))ne[Se][ye]=We,ie[Se][ye]=2,ee[Se][ye]=0;else if(Be)ne[Se][ye]=Le,ie[Se][ye]=1,ee[Se][ye]=ee[Se-1][ye-1]+1;else throw new Error("not possible")}}if(G&&Z(x,ce,Ee,ke),!et[0]&&!Me.firstMatchCanBeWeak)return;Se--,ye--;const Ve=[ne[Se][ye],ke];let Xe=0,Qe=0;for(;Se>=1;){let Ge=ye;do{const he=ie[Se][Ge];if(he===3)Ge=Ge-2;else if(he===2)Ge=Ge-1;else break}while(Ge>=1);Xe>1&&Q[ce+Se-1]===Ce[ke+ye-1]&&!$(Ge+ke-1,Ee,Ce)&&Xe+1>ee[Se][Ge]&&(Ge=ye),Ge===ye?Xe++:Xe=1,Qe||(Qe=Ge),Se--,ye=Ge-1,Ve.push(ye)}ge===$e&&Me.boostFullMatch&&(Ve[0]+=2);const Ze=Qe-$e;return Ve[0]-=Ze,Ve}e.fuzzyScore=K;function te(x,Q,ce,Ee,Ce,ke){let Me=x-1,$e=Q-1;for(;Me>=ce&&$e>=Ee;)Ce[Me]===ke[$e]&&(_[Me]=$e,Me--),$e--}function j(x,Q,ce,Ee,Ce,ke,Me,$e,ge,Se,ye){if(Q[ce]!==ke[Me])return Number.MIN_SAFE_INTEGER;let Fe=1,Ne=!1;return Me===ce-Ee?Fe=x[ce]===Ce[Me]?7:5:$(Me,Ce,ke)&&(Me===0||!$(Me-1,Ce,ke))?(Fe=x[ce]===Ce[Me]?7:5,Ne=!0):oe(ke,Me)&&(Me===0||!oe(ke,Me-1))?Fe=5:(oe(ke,Me-1)||me(ke,Me-1))&&(Fe=5,Ne=!0),Fe>1&&ce===Ee&&(ye[0]=!0),Ne||(Ne=$(Me,Ce,ke)||oe(ke,Me-1)||me(ke,Me-1)),ce===Ee?Me>ge&&(Fe-=Ne?3:5):Se?Fe+=Ne?2:0:Fe+=Ne?0:1,Me+1===$e&&(Fe-=Ne?3:5),Fe}function H(x,Q,ce,Ee,Ce,ke,Me){return V(x,Q,ce,Ee,Ce,ke,!0,Me)}e.fuzzyScoreGracefulAggressive=H;function J(x,Q,ce,Ee,Ce,ke,Me){return V(x,Q,ce,Ee,Ce,ke,!1,Me)}e.fuzzyScoreGraceful=J;function V(x,Q,ce,Ee,Ce,ke,Me,$e){let ge=K(x,Q,ce,Ee,Ce,ke,$e);if(ge&&!Me)return ge;if(x.length>=3){const Se=Math.min(7,x.length-1);for(let ye=ce+1;ye<Se;ye++){const Fe=X(x,ye);if(Fe){const Ne=K(Fe,Fe.toLowerCase(),ce,Ee,Ce,ke,$e);Ne&&(Ne[0]-=3,(!ge||Ne[0]>ge[0])&&(ge=Ne))}}}return ge}function X(x,Q){if(Q+1>=x.length)return;const ce=x[Q],Ee=x[Q+1];if(ce!==Ee)return x.slice(0,Q)+Ee+ce+x.slice(Q+2)}}),define(pe[73],ve([1,0,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(d){return a(d,0)}e.hash=R;function a(d,h){switch(typeof d){case"object":return d===null?D(349,h):Array.isArray(d)?v(d,h):g(d,h);case"string":return k(d,h);case"boolean":return C(d,h);case"number":return D(d,h);case"undefined":return D(937,h);default:return D(617,h)}}e.doHash=a;function D(d,h){return(h<<5)-h+d|0}e.numberHash=D;function C(d,h){return D(d?433:863,h)}function k(d,h){h=D(149417,h);for(let f=0,w=d.length;f<w;f++)h=D(d.charCodeAt(f),h);return h}e.stringHash=k;function v(d,h){return h=D(104579,h),d.reduce((f,w)=>a(w,f),h)}function g(d,h){return h=D(181387,h),Object.keys(d).sort().reduce((f,w)=>(f=k(w,f),a(d[w],f)),h)}class T{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=a(h,this.g),this.g}}e.Hasher=T;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function E(d,h,f=32){const w=f-h,L=~((1<<w)-1);return(d<<h|(L&d)>>>w)>>>0}function m(d,h=0,f=d.byteLength,w=0){for(let L=0;L<f;L++)d[h+L]=w}function p(d,h,f="0"){for(;d.length<h;)d=f+d;return d}function b(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(f=>f.toString(16).padStart(2,"0")).join(""):p((d>>>0).toString(16),h/4)}e.toHexString=b;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const f=h.length;if(f===0)return;const w=this.p;let L=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=h.charCodeAt(0),r=0);;){let i=n;if(y.isHighSurrogate(n))if(r+1<f){const l=h.charCodeAt(r+1);y.isLowSurrogate(l)?(r++,i=y.computeCodePoint(n,l)):i=65533}else{t=n;break}else y.isLowSurrogate(n)&&(i=65533);if(L=this.w(w,L,i),r++,r<f)n=h.charCodeAt(r);else break}this.r=L,this.u=t}w(h,f,w){return w<128?h[f++]=w:w<2048?(h[f++]=192|(w&1984)>>>6,h[f++]=128|(w&63)>>>0):w<65536?(h[f++]=224|(w&61440)>>>12,h[f++]=128|(w&4032)>>>6,h[f++]=128|(w&63)>>>0):(h[f++]=240|(w&1835008)>>>18,h[f++]=128|(w&258048)>>>12,h[f++]=128|(w&4032)>>>6,h[f++]=128|(w&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=o.g,f=this.q;for(let s=0;s<64;s+=4)h.setUint32(s,f.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)h.setUint32(s,E(h.getUint32(s-12,!1)^h.getUint32(s-32,!1)^h.getUint32(s-56,!1)^h.getUint32(s-64,!1),1),!1);let w=this.h,L=this.l,t=this.m,n=this.n,r=this.o,i,l,c;for(let s=0;s<80;s++)s<20?(i=L&t|~L&n,l=1518500249):s<40?(i=L^t^n,l=1859775393):s<60?(i=L&t|L&n|t&n,l=2400959708):(i=L^t^n,l=3395469782),c=E(w,5)+i+r+l+h.getUint32(s*4,!1)&4294967295,r=n,n=t,t=E(L,30),L=w,w=c;this.h=this.h+w&4294967295,this.l=this.l+L&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}o.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=o}),define(pe[59],ve([1,0,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(a){a[a.Ignore=0]="Ignore",a[a.Info=1]="Info",a[a.Warning=2]="Warning",a[a.Error=3]="Error"})(R||(R={})),function(a){const D="error",C="warning",k="warn",v="info",g="ignore";function T(E){return E?y.equalsIgnoreCase(D,E)?a.Error:y.equalsIgnoreCase(C,E)||y.equalsIgnoreCase(k,E)?a.Warning:y.equalsIgnoreCase(v,E)?a.Info:a.Ignore:a.Ignore}a.fromValue=T;function I(E){switch(E){case a.Error:return D;case a.Warning:return C;case a.Info:return v;default:return g}}a.toString=I}(R||(R={})),e.default=R}),define(pe[146],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[60],ve([1,0,18,17]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class a{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const p=m.charCodeAt(0),b=this.b.charCodeAt(this.c);return p-b}value(){return this.b[this.c]}}e.StringIterator=a;class D{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,R.compareSubstring)(m,this.b,0,m.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class C{constructor(m=!0,p=!0){this.f=m,this.g=p}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let p=m.length-1;p>=0;p--,this.c--){const b=this.b.charCodeAt(p);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,R.compareSubstring)(m,this.b,0,m.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class v{constructor(m,p){this.f=m,this.g=p,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(m,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,R.compare)(m,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=v;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(T||(T={}));class I{static forUris(m=()=>!1,p=()=>!1){return new I(new v(m,p))}static forPaths(m=!1){return new I(new C(void 0,!m))}static forStrings(){return new I(new a)}static forConfigKeys(){return new I(new D)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,p){if(p){const b=p.slice(0);(0,y.shuffle)(b);for(const o of b)this.set(o,m)}else{const b=m.slice(0);(0,y.shuffle)(b);for(const o of b)this.set(o[0],o[1])}}set(m,p){const b=this.b.reset(m);let o;this.c||(this.c=new g,this.c.segment=b.value());const d=[];for(o=this.c;;){const f=b.cmp(o.segment);if(f>0)o.left||(o.left=new g,o.left.segment=b.value()),d.push([-1,o]),o=o.left;else if(f<0)o.right||(o.right=new g,o.right.segment=b.value()),d.push([1,o]),o=o.right;else if(b.hasNext())b.next(),o.mid||(o.mid=new g,o.mid.segment=b.value()),d.push([0,o]),o=o.mid;else break}const h=o.value;o.value=p,o.key=m;for(let f=d.length-1;f>=0;f--){const w=d[f][1];w.updateHeight();const L=w.balanceFactor();if(L<-1||L>1){const t=d[f][0],n=d[f+1][0];if(t===1&&n===1)d[f][1]=w.rotateLeft();else if(t===-1&&n===-1)d[f][1]=w.rotateRight();else if(t===1&&n===-1)w.right=d[f+1][1]=d[f+1][1].rotateRight(),d[f][1]=w.rotateLeft();else if(t===-1&&n===1)w.left=d[f+1][1]=d[f+1][1].rotateLeft(),d[f][1]=w.rotateRight();else throw new Error;if(f>0)switch(d[f-1][0]){case-1:d[f-1][1].left=d[f][1];break;case 1:d[f-1][1].right=d[f][1];break;case 0:d[f-1][1].mid=d[f][1];break}else this.c=d[0][1]}}return h}get(m){return this.d(m)?.value}d(m){const p=this.b.reset(m);let b=this.c;for(;b;){const o=p.cmp(b.segment);if(o>0)b=b.left;else if(o<0)b=b.right;else if(p.hasNext())p.next(),b=b.mid;else break}return b}has(m){const p=this.d(m);return!(p?.value===void 0&&p?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,p){const b=this.b.reset(m),o=[];let d=this.c;for(;d;){const h=b.cmp(d.segment);if(h>0)o.push([-1,d]),d=d.left;else if(h<0)o.push([1,d]),d=d.right;else if(b.hasNext())b.next(),o.push([0,d]),d=d.mid;else break}if(!!d){if(p?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:f,value:w,segment:L}=h;this.e(h.key,!1),d.key=f,d.value=w,d.segment=L}}else{const h=d.left??d.right;if(o.length>0){const[f,w]=o[o.length-1];switch(f){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this.c=h}for(let h=o.length-1;h>=0;h--){const f=o[h][1];f.updateHeight();const w=f.balanceFactor();if(w>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),o[h][1]=f.rotateLeft()):w<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),o[h][1]=f.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this.c=o[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const p=this.b.reset(m);let b=this.c,o;for(;b;){const d=p.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(p.hasNext())p.next(),o=b.value||o,b=b.mid;else break}return b&&b.value||o}findSuperstr(m){return this.g(m,!1)}g(m,p){const b=this.b.reset(m);let o=this.c;for(;o;){const d=b.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(b.hasNext())b.next(),o=o.mid;else return o.mid?this.h(o.mid):p?o.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[p,b]of this)m(b,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const p=[];return this.j(m,p),p[Symbol.iterator]()}j(m,p){!m||(m.left&&this.j(m.left,p),m.value&&p.push([m.key,m.value]),m.mid&&this.j(m.mid,p),m.right&&this.j(m.right,p))}_isBalanced(){const m=p=>{if(!p)return!0;const b=p.balanceFactor();return b<-1||b>1?!1:m(p.left)&&m(p.right)};return m(this.c)}}e.TernarySearchTree=I}),define(pe[8],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function y(n){return typeof n=="string"}e.isString=y;function R(n){return Array.isArray(n)&&n.every(r=>y(r))}e.isStringArray=R;function a(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=a;function D(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=D;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function k(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=k;function v(n){return n===!0||n===!1}e.isBoolean=v;function g(n){return typeof n>"u"}e.isUndefined=g;function T(n){return!I(n)}e.isDefined=T;function I(n){return g(n)||n===null}e.isUndefinedOrNull=I;function E(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=E;function m(n){if(I(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=m;function p(...n){const r=[];for(let i=0;i<n.length;i++){const l=n[i];if(I(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(l)}return r}e.assertAllDefined=p;const b=Object.prototype.hasOwnProperty;function o(n){if(!a(n))return!1;for(const r in n)if(b.call(n,r))return!1;return!0}e.isEmptyObject=o;function d(n){return typeof n=="function"}e.isFunction=d;function h(...n){return n.length>0&&n.every(d)}e.areFunctions=h;function f(n,r){const i=Math.min(n.length,r.length);for(let l=0;l<i;l++)w(n[l],r[l])}e.validateConstraints=f;function w(n,r){if(y(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(n instanceof r)return}catch{}if(!I(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function L(n){return n===null?void 0:n}e.withNullAsUndefined=L;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(pe[47],ve([1,0,8]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function a(k,v){if((0,y.isString)(v)){const g=R[v];if(g===void 0)throw new Error(`${k} references an unknown codicon: ${v}`);v=g}return R[k]=v,{id:k}}function D(){return R}e.getCodiconFontCharacters=D;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:a("add",6e4),plus:a("plus",6e4),gistNew:a("gist-new",6e4),repoCreate:a("repo-create",6e4),lightbulb:a("lightbulb",60001),lightBulb:a("light-bulb",60001),repo:a("repo",60002),repoDelete:a("repo-delete",60002),gistFork:a("gist-fork",60003),repoForked:a("repo-forked",60003),gitPullRequest:a("git-pull-request",60004),gitPullRequestAbandoned:a("git-pull-request-abandoned",60004),recordKeys:a("record-keys",60005),keyboard:a("keyboard",60005),tag:a("tag",60006),tagAdd:a("tag-add",60006),tagRemove:a("tag-remove",60006),person:a("person",60007),personFollow:a("person-follow",60007),personOutline:a("person-outline",60007),personFilled:a("person-filled",60007),gitBranch:a("git-branch",60008),gitBranchCreate:a("git-branch-create",60008),gitBranchDelete:a("git-branch-delete",60008),sourceControl:a("source-control",60008),mirror:a("mirror",60009),mirrorPublic:a("mirror-public",60009),star:a("star",60010),starAdd:a("star-add",60010),starDelete:a("star-delete",60010),starEmpty:a("star-empty",60010),comment:a("comment",60011),commentAdd:a("comment-add",60011),alert:a("alert",60012),warning:a("warning",60012),search:a("search",60013),searchSave:a("search-save",60013),logOut:a("log-out",60014),signOut:a("sign-out",60014),logIn:a("log-in",60015),signIn:a("sign-in",60015),eye:a("eye",60016),eyeUnwatch:a("eye-unwatch",60016),eyeWatch:a("eye-watch",60016),circleFilled:a("circle-filled",60017),primitiveDot:a("primitive-dot",60017),closeDirty:a("close-dirty",60017),debugBreakpoint:a("debug-breakpoint",60017),debugBreakpointDisabled:a("debug-breakpoint-disabled",60017),debugHint:a("debug-hint",60017),primitiveSquare:a("primitive-square",60018),edit:a("edit",60019),pencil:a("pencil",60019),info:a("info",60020),issueOpened:a("issue-opened",60020),gistPrivate:a("gist-private",60021),gitForkPrivate:a("git-fork-private",60021),lock:a("lock",60021),mirrorPrivate:a("mirror-private",60021),close:a("close",60022),removeClose:a("remove-close",60022),x:a("x",60022),repoSync:a("repo-sync",60023),sync:a("sync",60023),clone:a("clone",60024),desktopDownload:a("desktop-download",60024),beaker:a("beaker",60025),microscope:a("microscope",60025),vm:a("vm",60026),deviceDesktop:a("device-desktop",60026),file:a("file",60027),fileText:a("file-text",60027),more:a("more",60028),ellipsis:a("ellipsis",60028),kebabHorizontal:a("kebab-horizontal",60028),mailReply:a("mail-reply",60029),reply:a("reply",60029),organization:a("organization",60030),organizationFilled:a("organization-filled",60030),organizationOutline:a("organization-outline",60030),newFile:a("new-file",60031),fileAdd:a("file-add",60031),newFolder:a("new-folder",60032),fileDirectoryCreate:a("file-directory-create",60032),trash:a("trash",60033),trashcan:a("trashcan",60033),history:a("history",60034),clock:a("clock",60034),folder:a("folder",60035),fileDirectory:a("file-directory",60035),symbolFolder:a("symbol-folder",60035),logoGithub:a("logo-github",60036),markGithub:a("mark-github",60036),github:a("github",60036),terminal:a("terminal",60037),console:a("console",60037),repl:a("repl",60037),zap:a("zap",60038),symbolEvent:a("symbol-event",60038),error:a("error",60039),stop:a("stop",60039),variable:a("variable",60040),symbolVariable:a("symbol-variable",60040),array:a("array",60042),symbolArray:a("symbol-array",60042),symbolModule:a("symbol-module",60043),symbolPackage:a("symbol-package",60043),symbolNamespace:a("symbol-namespace",60043),symbolObject:a("symbol-object",60043),symbolMethod:a("symbol-method",60044),symbolFunction:a("symbol-function",60044),symbolConstructor:a("symbol-constructor",60044),symbolBoolean:a("symbol-boolean",60047),symbolNull:a("symbol-null",60047),symbolNumeric:a("symbol-numeric",60048),symbolNumber:a("symbol-number",60048),symbolStructure:a("symbol-structure",60049),symbolStruct:a("symbol-struct",60049),symbolParameter:a("symbol-parameter",60050),symbolTypeParameter:a("symbol-type-parameter",60050),symbolKey:a("symbol-key",60051),symbolText:a("symbol-text",60051),symbolReference:a("symbol-reference",60052),goToFile:a("go-to-file",60052),symbolEnum:a("symbol-enum",60053),symbolValue:a("symbol-value",60053),symbolRuler:a("symbol-ruler",60054),symbolUnit:a("symbol-unit",60054),activateBreakpoints:a("activate-breakpoints",60055),archive:a("archive",60056),arrowBoth:a("arrow-both",60057),arrowDown:a("arrow-down",60058),arrowLeft:a("arrow-left",60059),arrowRight:a("arrow-right",60060),arrowSmallDown:a("arrow-small-down",60061),arrowSmallLeft:a("arrow-small-left",60062),arrowSmallRight:a("arrow-small-right",60063),arrowSmallUp:a("arrow-small-up",60064),arrowUp:a("arrow-up",60065),bell:a("bell",60066),bold:a("bold",60067),book:a("book",60068),bookmark:a("bookmark",60069),debugBreakpointConditionalUnverified:a("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:a("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:a("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:a("debug-breakpoint-data-unverified",60072),debugBreakpointData:a("debug-breakpoint-data",60073),debugBreakpointDataDisabled:a("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:a("debug-breakpoint-log-unverified",60074),debugBreakpointLog:a("debug-breakpoint-log",60075),debugBreakpointLogDisabled:a("debug-breakpoint-log-disabled",60075),briefcase:a("briefcase",60076),broadcast:a("broadcast",60077),browser:a("browser",60078),bug:a("bug",60079),calendar:a("calendar",60080),caseSensitive:a("case-sensitive",60081),check:a("check",60082),checklist:a("checklist",60083),chevronDown:a("chevron-down",60084),dropDownButton:a("drop-down-button",60084),chevronLeft:a("chevron-left",60085),chevronRight:a("chevron-right",60086),chevronUp:a("chevron-up",60087),chromeClose:a("chrome-close",60088),chromeMaximize:a("chrome-maximize",60089),chromeMinimize:a("chrome-minimize",60090),chromeRestore:a("chrome-restore",60091),circle:a("circle",60092),circleOutline:a("circle-outline",60092),debugBreakpointUnverified:a("debug-breakpoint-unverified",60092),circleSlash:a("circle-slash",60093),circuitBoard:a("circuit-board",60094),clearAll:a("clear-all",60095),clippy:a("clippy",60096),closeAll:a("close-all",60097),cloudDownload:a("cloud-download",60098),cloudUpload:a("cloud-upload",60099),code:a("code",60100),collapseAll:a("collapse-all",60101),colorMode:a("color-mode",60102),commentDiscussion:a("comment-discussion",60103),compareChanges:a("compare-changes",60157),creditCard:a("credit-card",60105),dash:a("dash",60108),dashboard:a("dashboard",60109),database:a("database",60110),debugContinue:a("debug-continue",60111),debugDisconnect:a("debug-disconnect",60112),debugPause:a("debug-pause",60113),debugRestart:a("debug-restart",60114),debugStart:a("debug-start",60115),debugStepInto:a("debug-step-into",60116),debugStepOut:a("debug-step-out",60117),debugStepOver:a("debug-step-over",60118),debugStop:a("debug-stop",60119),debug:a("debug",60120),deviceCameraVideo:a("device-camera-video",60121),deviceCamera:a("device-camera",60122),deviceMobile:a("device-mobile",60123),diffAdded:a("diff-added",60124),diffIgnored:a("diff-ignored",60125),diffModified:a("diff-modified",60126),diffRemoved:a("diff-removed",60127),diffRenamed:a("diff-renamed",60128),diff:a("diff",60129),discard:a("discard",60130),editorLayout:a("editor-layout",60131),emptyWindow:a("empty-window",60132),exclude:a("exclude",60133),extensions:a("extensions",60134),eyeClosed:a("eye-closed",60135),fileBinary:a("file-binary",60136),fileCode:a("file-code",60137),fileMedia:a("file-media",60138),filePdf:a("file-pdf",60139),fileSubmodule:a("file-submodule",60140),fileSymlinkDirectory:a("file-symlink-directory",60141),fileSymlinkFile:a("file-symlink-file",60142),fileZip:a("file-zip",60143),files:a("files",60144),filter:a("filter",60145),flame:a("flame",60146),foldDown:a("fold-down",60147),foldUp:a("fold-up",60148),fold:a("fold",60149),folderActive:a("folder-active",60150),folderOpened:a("folder-opened",60151),gear:a("gear",60152),gift:a("gift",60153),gistSecret:a("gist-secret",60154),gist:a("gist",60155),gitCommit:a("git-commit",60156),gitCompare:a("git-compare",60157),gitMerge:a("git-merge",60158),githubAction:a("github-action",60159),githubAlt:a("github-alt",60160),globe:a("globe",60161),grabber:a("grabber",60162),graph:a("graph",60163),gripper:a("gripper",60164),heart:a("heart",60165),home:a("home",60166),horizontalRule:a("horizontal-rule",60167),hubot:a("hubot",60168),inbox:a("inbox",60169),issueClosed:a("issue-closed",60324),issueReopened:a("issue-reopened",60171),issues:a("issues",60172),italic:a("italic",60173),jersey:a("jersey",60174),json:a("json",60175),bracket:a("bracket",60175),kebabVertical:a("kebab-vertical",60176),key:a("key",60177),law:a("law",60178),lightbulbAutofix:a("lightbulb-autofix",60179),linkExternal:a("link-external",60180),link:a("link",60181),listOrdered:a("list-ordered",60182),listUnordered:a("list-unordered",60183),liveShare:a("live-share",60184),loading:a("loading",60185),location:a("location",60186),mailRead:a("mail-read",60187),mail:a("mail",60188),markdown:a("markdown",60189),megaphone:a("megaphone",60190),mention:a("mention",60191),milestone:a("milestone",60192),mortarBoard:a("mortar-board",60193),move:a("move",60194),multipleWindows:a("multiple-windows",60195),mute:a("mute",60196),noNewline:a("no-newline",60197),note:a("note",60198),octoface:a("octoface",60199),openPreview:a("open-preview",60200),package_:a("package",60201),paintcan:a("paintcan",60202),pin:a("pin",60203),play:a("play",60204),run:a("run",60204),plug:a("plug",60205),preserveCase:a("preserve-case",60206),preview:a("preview",60207),project:a("project",60208),pulse:a("pulse",60209),question:a("question",60210),quote:a("quote",60211),radioTower:a("radio-tower",60212),reactions:a("reactions",60213),references:a("references",60214),refresh:a("refresh",60215),regex:a("regex",60216),remoteExplorer:a("remote-explorer",60217),remote:a("remote",60218),remove:a("remove",60219),replaceAll:a("replace-all",60220),replace:a("replace",60221),repoClone:a("repo-clone",60222),repoForcePush:a("repo-force-push",60223),repoPull:a("repo-pull",60224),repoPush:a("repo-push",60225),report:a("report",60226),requestChanges:a("request-changes",60227),rocket:a("rocket",60228),rootFolderOpened:a("root-folder-opened",60229),rootFolder:a("root-folder",60230),rss:a("rss",60231),ruby:a("ruby",60232),saveAll:a("save-all",60233),saveAs:a("save-as",60234),save:a("save",60235),screenFull:a("screen-full",60236),screenNormal:a("screen-normal",60237),searchStop:a("search-stop",60238),server:a("server",60240),settingsGear:a("settings-gear",60241),settings:a("settings",60242),shield:a("shield",60243),smiley:a("smiley",60244),sortPrecedence:a("sort-precedence",60245),splitHorizontal:a("split-horizontal",60246),splitVertical:a("split-vertical",60247),squirrel:a("squirrel",60248),starFull:a("star-full",60249),starHalf:a("star-half",60250),symbolClass:a("symbol-class",60251),symbolColor:a("symbol-color",60252),symbolCustomColor:a("symbol-customcolor",60252),symbolConstant:a("symbol-constant",60253),symbolEnumMember:a("symbol-enum-member",60254),symbolField:a("symbol-field",60255),symbolFile:a("symbol-file",60256),symbolInterface:a("symbol-interface",60257),symbolKeyword:a("symbol-keyword",60258),symbolMisc:a("symbol-misc",60259),symbolOperator:a("symbol-operator",60260),symbolProperty:a("symbol-property",60261),wrench:a("wrench",60261),wrenchSubaction:a("wrench-subaction",60261),symbolSnippet:a("symbol-snippet",60262),tasklist:a("tasklist",60263),telescope:a("telescope",60264),textSize:a("text-size",60265),threeBars:a("three-bars",60266),thumbsdown:a("thumbsdown",60267),thumbsup:a("thumbsup",60268),tools:a("tools",60269),triangleDown:a("triangle-down",60270),triangleLeft:a("triangle-left",60271),triangleRight:a("triangle-right",60272),triangleUp:a("triangle-up",60273),twitter:a("twitter",60274),unfold:a("unfold",60275),unlock:a("unlock",60276),unmute:a("unmute",60277),unverified:a("unverified",60278),verified:a("verified",60279),versions:a("versions",60280),vmActive:a("vm-active",60281),vmOutline:a("vm-outline",60282),vmRunning:a("vm-running",60283),watch:a("watch",60284),whitespace:a("whitespace",60285),wholeWord:a("whole-word",60286),window:a("window",60287),wordWrap:a("word-wrap",60288),zoomIn:a("zoom-in",60289),zoomOut:a("zoom-out",60290),listFilter:a("list-filter",60291),listFlat:a("list-flat",60292),listSelection:a("list-selection",60293),selection:a("selection",60293),listTree:a("list-tree",60294),debugBreakpointFunctionUnverified:a("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:a("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:a("debug-breakpoint-function-disabled",60296),debugStackframeActive:a("debug-stackframe-active",60297),circleSmallFilled:a("circle-small-filled",60298),debugStackframeDot:a("debug-stackframe-dot",60298),debugStackframe:a("debug-stackframe",60299),debugStackframeFocused:a("debug-stackframe-focused",60299),debugBreakpointUnsupported:a("debug-breakpoint-unsupported",60300),symbolString:a("symbol-string",60301),debugReverseContinue:a("debug-reverse-continue",60302),debugStepBack:a("debug-step-back",60303),debugRestartFrame:a("debug-restart-frame",60304),callIncoming:a("call-incoming",60306),callOutgoing:a("call-outgoing",60307),menu:a("menu",60308),expandAll:a("expand-all",60309),feedback:a("feedback",60310),groupByRefType:a("group-by-ref-type",60311),ungroupByRefType:a("ungroup-by-ref-type",60312),account:a("account",60313),bellDot:a("bell-dot",60314),debugConsole:a("debug-console",60315),library:a("library",60316),output:a("output",60317),runAll:a("run-all",60318),syncIgnored:a("sync-ignored",60319),pinned:a("pinned",60320),githubInverted:a("github-inverted",60321),debugAlt:a("debug-alt",60305),serverProcess:a("server-process",60322),serverEnvironment:a("server-environment",60323),pass:a("pass",60324),stopCircle:a("stop-circle",60325),playCircle:a("play-circle",60326),record:a("record",60327),debugAltSmall:a("debug-alt-small",60328),vmConnect:a("vm-connect",60329),cloud:a("cloud",60330),merge:a("merge",60331),exportIcon:a("export",60332),graphLeft:a("graph-left",60333),magnet:a("magnet",60334),notebook:a("notebook",60335),redo:a("redo",60336),checkAll:a("check-all",60337),pinnedDirty:a("pinned-dirty",60338),passFilled:a("pass-filled",60339),circleLargeFilled:a("circle-large-filled",60340),circleLarge:a("circle-large",60341),circleLargeOutline:a("circle-large-outline",60341),combine:a("combine",60342),gather:a("gather",60342),table:a("table",60343),variableGroup:a("variable-group",60344),typeHierarchy:a("type-hierarchy",60345),typeHierarchySub:a("type-hierarchy-sub",60346),typeHierarchySuper:a("type-hierarchy-super",60347),gitPullRequestCreate:a("git-pull-request-create",60348),runAbove:a("run-above",60349),runBelow:a("run-below",60350),notebookTemplate:a("notebook-template",60351),debugRerun:a("debug-rerun",60352),workspaceTrusted:a("workspace-trusted",60353),workspaceUntrusted:a("workspace-untrusted",60354),workspaceUnspecified:a("workspace-unspecified",60355),terminalCmd:a("terminal-cmd",60356),terminalDebian:a("terminal-debian",60357),terminalLinux:a("terminal-linux",60358),terminalPowershell:a("terminal-powershell",60359),terminalTmux:a("terminal-tmux",60360),terminalUbuntu:a("terminal-ubuntu",60361),terminalBash:a("terminal-bash",60362),arrowSwap:a("arrow-swap",60363),copy:a("copy",60364),personAdd:a("person-add",60365),filterFilled:a("filter-filled",60366),wand:a("wand",60367),debugLineByLine:a("debug-line-by-line",60368),inspect:a("inspect",60369),layers:a("layers",60370),layersDot:a("layers-dot",60371),layersActive:a("layers-active",60372),compass:a("compass",60373),compassDot:a("compass-dot",60374),compassActive:a("compass-active",60375),azure:a("azure",60376),issueDraft:a("issue-draft",60377),gitPullRequestClosed:a("git-pull-request-closed",60378),gitPullRequestDraft:a("git-pull-request-draft",60379),debugAll:a("debug-all",60380),debugCoverage:a("debug-coverage",60381),runErrors:a("run-errors",60382),folderLibrary:a("folder-library",60383),debugContinueSmall:a("debug-continue-small",60384),beakerStop:a("beaker-stop",60385),graphLine:a("graph-line",60386),graphScatter:a("graph-scatter",60387),pieChart:a("pie-chart",60388),bracketDot:a("bracket-dot",60389),bracketError:a("bracket-error",60390),lockSmall:a("lock-small",60391),azureDevops:a("azure-devops",60392),verifiedFilled:a("verified-filled",60393),newLine:a("newline",60394),layout:a("layout",60395),layoutActivitybarLeft:a("layout-activitybar-left",60396),layoutActivitybarRight:a("layout-activitybar-right",60397),layoutPanelLeft:a("layout-panel-left",60398),layoutPanelCenter:a("layout-panel-center",60399),layoutPanelJustify:a("layout-panel-justify",60400),layoutPanelRight:a("layout-panel-right",60401),layoutPanel:a("layout-panel",60402),layoutSidebarLeft:a("layout-sidebar-left",60403),layoutSidebarRight:a("layout-sidebar-right",60404),layoutStatusbar:a("layout-statusbar",60405),layoutMenubar:a("layout-menubar",60406),layoutCentered:a("layout-centered",60407),layoutSidebarRightOff:a("layout-sidebar-right-off",60416),layoutPanelOff:a("layout-panel-off",60417),layoutSidebarLeftOff:a("layout-sidebar-left-off",60418),target:a("target",60408),indent:a("indent",60409),recordSmall:a("record-small",60410),errorSmall:a("error-small",60411),arrowCircleDown:a("arrow-circle-down",60412),arrowCircleLeft:a("arrow-circle-left",60413),arrowCircleRight:a("arrow-circle-right",60414),arrowCircleUp:a("arrow-circle-up",60415),heartFilled:a("heart-filled",60420),map:a("map",60421),mapFilled:a("map-filled",60422),circleSmall:a("circle-small",60423),bellSlash:a("bell-slash",60424),bellSlashDot:a("bell-slash-dot",60425),commentUnresolved:a("comment-unresolved",60426),gitPullRequestGoToChanges:a("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:a("git-pull-request-new-changes",60428),searchFuzzy:a("search-fuzzy",60429),commentDraft:a("comment-draft",60430),send:a("send",60431),sparkle:a("sparkle",60432),insert:a("insert",60433),dialogError:a("dialog-error","error"),dialogWarning:a("dialog-warning","warning"),dialogInfo:a("dialog-info","info"),dialogClose:a("dialog-close","close"),treeItemExpanded:a("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:a("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:a("tree-filter-on-type-off","list-selection"),treeFilterClear:a("tree-filter-clear","close"),treeItemLoading:a("tree-item-loading","loading"),menuSelection:a("menu-selection","check"),menuSubmenu:a("menu-submenu","chevron-right"),menuBarMore:a("menubar-more","more"),scrollbarButtonLeft:a("scrollbar-button-left","triangle-left"),scrollbarButtonRight:a("scrollbar-button-right","triangle-right"),scrollbarButtonUp:a("scrollbar-button-up","triangle-up"),scrollbarButtonDown:a("scrollbar-button-down","triangle-down"),toolBarMore:a("toolbar-more","more"),quickInputBack:a("quick-input-back","arrow-left")}}),define(pe[38],ve([1,0,7,3,17,8]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(c){return c===47||c===92}e.isPathSeparator=C;function k(c){return c.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=k;function v(c){return c.indexOf("/")===-1&&(c=k(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=v;function g(c,s=y.posix.sep){if(!c)return"";const u=c.length,S=c.charCodeAt(0);if(C(S)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let O=3;const B=O;for(;O<u&&!C(c.charCodeAt(O));O++);if(B!==O&&!C(c.charCodeAt(O+1))){for(O+=1;O<u;O++)if(C(c.charCodeAt(O)))return c.slice(0,O+1).replace(/[\\/]/g,s)}}return s}else if(d(S)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+s:c.slice(0,2);let A=c.indexOf("://");if(A!==-1){for(A+=3;A<u;A++)if(C(c.charCodeAt(A)))return c.slice(0,A+1)}return""}e.getRoot=g;function T(c){if(!R.isWindows||!c||c.length<5)return!1;let s=c.charCodeAt(0);if(s!==92||(s=c.charCodeAt(1),s!==92))return!1;let u=2;const S=u;for(;u<c.length&&(s=c.charCodeAt(u),s!==92);u++);return!(S===u||(s=c.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=T;const I=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(c,s=R.isWindows){const u=s?I:E;return!(!c||c.length===0||/^\s+$/.test(c)||(u.lastIndex=0,u.test(c))||s&&m.test(c)||c==="."||c===".."||s&&c[c.length-1]==="."||s&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=p;function b(c,s,u){const S=c===s;return!u||S?S:!c||!s?!1:(0,a.equalsIgnoreCase)(c,s)}e.isEqual=b;function o(c,s,u,S=y.sep){if(c===s)return!0;if(!c||!s||s.length>c.length)return!1;if(u){if(!(0,a.startsWithIgnoreCase)(c,s))return!1;if(s.length===c.length)return!0;let O=s.length;return s.charAt(s.length-1)===S&&O--,c.charAt(O)===S}return s.charAt(s.length-1)!==S&&(s+=S),c.indexOf(s)===0}e.isEqualOrParent=o;function d(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=d;function h(c,s){return R.isWindows&&c.endsWith(":")&&(c+=y.sep),(0,y.isAbsolute)(c)||(c=(0,y.join)(s,c)),c=(0,y.normalize)(c),R.isWindows?(c=(0,a.rtrim)(c,y.sep),c.endsWith(":")&&(c+=y.sep)):(c=(0,a.rtrim)(c,y.sep),c||(c=y.sep)),c}e.sanitizeFilePath=h;function f(c){const s=(0,y.normalize)(c);return R.isWindows?c.length>3?!1:w(s)&&(c.length===2||s.charCodeAt(2)===92):s===y.posix.sep}e.isRootOrDriveLetter=f;function w(c,s=R.isWindows){return s?d(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function L(c){return w(c)?c[0]:void 0}e.getDriveLetter=L;function t(c,s,u){return s.length>c.length?-1:c===s?0:(u&&(c=c.toLowerCase(),s=s.toLowerCase()),c.indexOf(s))}e.indexOfPath=t;function n(c){const s=c.split(":");let u,S,A;for(const O of s){const B=Number(O);(0,D.isNumber)(B)?S===void 0?S=B:A===void 0&&(A=B):u=u?[u,O].join(":"):O}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:S!==void 0?S:void 0,column:A!==void 0?A:S!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(c,s,u=8){let S="";for(let O=0;O<u;O++){let B;O===0&&R.isWindows&&!s&&(u===3||u===4)?B=i:B=r,S+=B.charAt(Math.floor(Math.random()*B.length))}let A;return s?A=`${s}-${S}`:A=S,c?(0,y.join)(c,A):A}e.randomPath=l}),define(pe[22],ve([1,0,8]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([f,w])=>{h[f]=w&&typeof w=="object"?R(w):w}),h}e.deepClone=R;function a(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const f=h.shift();Object.freeze(f);for(const w in f)if(D.call(f,w)){const L=f[w];typeof L=="object"&&!Object.isFrozen(L)&&!(0,y.isTypedArray)(L)&&h.push(L)}}return d}e.deepFreeze=a;const D=Object.prototype.hasOwnProperty;function C(d,h){return k(d,h,new Set)}e.cloneAndChange=C;function k(d,h,f){if((0,y.isUndefinedOrNull)(d))return d;const w=h(d);if(typeof w<"u")return w;if(Array.isArray(d)){const L=[];for(const t of d)L.push(k(t,h,f));return L}if((0,y.isObject)(d)){if(f.has(d))throw new Error("Cannot clone recursive data-structure");f.add(d);const L={};for(const t in d)D.call(d,t)&&(L[t]=k(d[t],h,f));return f.delete(d),L}return d}function v(d,h,f=!0){return(0,y.isObject)(d)?((0,y.isObject)(h)&&Object.keys(h).forEach(w=>{w in d?f&&((0,y.isObject)(d[w])&&(0,y.isObject)(h[w])?v(d[w],h[w],f):d[w]=h[w]):d[w]=h[w]}),d):h}e.mixin=v;function g(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let f,w;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(f=0;f<d.length;f++)if(!g(d[f],h[f]))return!1}else{const L=[];for(w in d)L.push(w);L.sort();const t=[];for(w in h)t.push(w);if(t.sort(),!g(L,t))return!1;for(f=0;f<L.length;f++)if(!g(d[L[f]],h[L[f]]))return!1}return!0}e.equals=g;function T(d){const h=new Set;return JSON.stringify(d,(f,w)=>{if((0,y.isObject)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.safeStringify=T;function I(d,h){const f=Object.create(null);return!d||!h||Object.keys(h).forEach(L=>{const t=d[L],n=h[L];g(t,n)||(f[L]=n)}),f}e.distinct=I;function E(d,h){const f=h.toLowerCase(),w=Object.keys(d).find(L=>L.toLowerCase()===f);return w?d[w]:d[h]}e.getCaseInsensitive=E;function m(d,h){const f=Object.create(null);for(const[w,L]of Object.entries(d))h(w,L)&&(f[w]=L);return f}e.filter=m;function p(d){let h=[],f=Object.getPrototypeOf(d);for(;Object.prototype!==f;)h=h.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return h}e.getAllPropertyNames=p;function b(d){const h=[];for(const f of p(d))typeof d[f]=="function"&&h.push(f);return h}e.getAllMethodNames=b;function o(d,h){const f=L=>function(){const t=Array.prototype.slice.call(arguments,0);return h(L,t)},w={};for(const L of d)w[L]=f(L);return w}e.createProxyObject=o}),define(pe[95],ve([1,0,47]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(C){function k(v){return v&&typeof v=="object"&&typeof v.id=="string"}C.isThemeColor=k})(R=e.ThemeColor||(e.ThemeColor={}));function a(C){return{id:C}}e.themeColorFromId=a;var D;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function v(h){const f=k.exec(h.id);if(!f)return v(y.Codicon.error);const[,w,L]=f,t=["codicon","codicon-"+w];return L&&t.push("codicon-modifier-"+L.substring(1)),t}C.asClassNameArray=v;function g(h){return v(h).join(" ")}C.asClassName=g;function T(h){return"."+v(h).join(".")}C.asCSSSelector=T;function I(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}C.isThemeIcon=I;const E=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function m(h){const f=E.exec(h);if(!f)return;const[,w]=f;return{id:w}}C.fromString=m;function p(h){return{id:h}}C.fromId=p;function b(h,f){let w=h.id;const L=w.lastIndexOf("~");return L!==-1&&(w=w.substring(0,L)),f&&(w=`${w}~${f}`),{id:w}}C.modify=b;function o(h){const f=h.id.lastIndexOf("~");if(f!==-1)return h.id.substring(f+1)}C.getModifier=o;function d(h,f){return h.id===f.id&&h.color?.id===f.color?.id}C.isEqual=d})(D=e.ThemeIcon||(e.ThemeIcon={}))}),define(pe[147],ve([1,0,145,17,95]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const D="$(",C=new RegExp(`\\$\\(${a.ThemeIcon.iconNameExpression}(?:${a.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${C.source}`,"g");function v(d){return d.replace(k,(h,f)=>f?h:`\\${h}`)}e.escapeIcons=v;const g=new RegExp(`\\\\${C.source}`,"g");function T(d){return d.replace(g,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=T;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function E(d){return d.indexOf(D)===-1?d:d.replace(I,(h,f,w,L)=>w?h:f||L||"")}e.stripIcons=E;function m(d){return d?d.replace(/\$\((.*?)\)/g,(h,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=m;const p=new RegExp(`\\$\\(${a.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(d){p.lastIndex=0;let h="";const f=[];let w=0;for(;;){const L=p.lastIndex,t=p.exec(d),n=d.substring(L,t?.index);if(n.length>0){h+=n;for(let r=0;r<n.length;r++)f.push(w)}if(!t)break;w+=t[0].length}return{text:h,iconOffsets:f}}e.parseLabelWithIcons=b;function o(d,h,f=!1){const{text:w,iconOffsets:L}=h;if(!L||L.length===0)return(0,y.matchesFuzzy)(d,w,f);const t=(0,R.ltrim)(w," "),n=w.length-t.length,r=(0,y.matchesFuzzy)(d,t,f);if(r)for(const i of r){const l=L[i.start+n]+n;i.start+=l,i.end+=l}return r}e.matchesFuzzyIconAware=o}),define(pe[4],ve([1,0,7,3]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const a=/^\w[\w\d+.-]*$/,D=/^\//,C=/^\/\//;function k(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!a.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,i){return!r&&!i?"file":r}function g(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const T="",I="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,l,c,s,u,S=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=v(i,S),this.authority=l||T,this.path=g(this.scheme,c||T),this.query=s||T,this.fragment=u||T,k(this,S))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:l,authority:c,path:s,query:u,fragment:S}=i;return l===void 0?l=this.scheme:l===null&&(l=T),c===void 0?c=this.authority:c===null&&(c=T),s===void 0?s=this.path:s===null&&(s=T),u===void 0?u=this.query:u===null&&(u=T),S===void 0?S=this.fragment:S===null&&(S=T),l===this.scheme&&c===this.authority&&s===this.path&&u===this.query&&S===this.fragment?this:new b(l,c,s,u,S)}static parse(i,l=!1){const c=E.exec(i);return c?new b(c[2]||T,n(c[4]||T),n(c[5]||T),n(c[7]||T),n(c[9]||T),l):new b(T,T,T,T,T)}static file(i){let l=T;if(R.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const c=i.indexOf(I,2);c===-1?(l=i.substring(2),i=I):(l=i.substring(2,c),i=i.substring(c)||I)}return new b("file",l,i,T,T)}static from(i){const l=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return k(l,!0),l}static joinPath(i,...l){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return R.isWindows&&i.scheme==="file"?c=m.file(y.win32.join(f(i,!0),...l)).path:c=y.posix.join(i.path,...l),i.with({path:c})}toString(i=!1){return w(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const l=new b(i);return l._formatted=i.external,l._fsPath=i._sep===p?i.fsPath:null,l}}else return i}}e.URI=m;const p=R.isWindows?1:void 0;class b extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,i,l){let c,s=-1;for(let u=0;u<r.length;u++){const S=r.charCodeAt(u);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||i&&S===47||l&&S===91||l&&S===93||l&&S===58)s!==-1&&(c+=encodeURIComponent(r.substring(s,u)),s=-1),c!==void 0&&(c+=r.charAt(u));else{c===void 0&&(c=r.substr(0,u));const A=o[S];A!==void 0?(s!==-1&&(c+=encodeURIComponent(r.substring(s,u)),s=-1),c+=A):s===-1&&(s=u)}}return s!==-1&&(c+=encodeURIComponent(r.substring(s))),c!==void 0?c:r}function h(r){let i;for(let l=0;l<r.length;l++){const c=r.charCodeAt(l);c===35||c===63?(i===void 0&&(i=r.substr(0,l)),i+=o[c]):i!==void 0&&(i+=r[l])}return i!==void 0?i:r}function f(r,i){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,R.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=f;function w(r,i){const l=i?h:d;let c="",{scheme:s,authority:u,path:S,query:A,fragment:O}=r;if(s&&(c+=s,c+=":"),(u||s==="file")&&(c+=I,c+=I),u){let B=u.indexOf("@");if(B!==-1){const q=u.substr(0,B);u=u.substr(B+1),B=q.lastIndexOf(":"),B===-1?c+=l(q,!1,!1):(c+=l(q.substr(0,B),!1,!1),c+=":",c+=l(q.substr(B+1),!1,!0)),c+="@"}u=u.toLowerCase(),B=u.lastIndexOf(":"),B===-1?c+=l(u,!1,!0):(c+=l(u.substr(0,B),!1,!0),c+=u.substr(B))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const B=S.charCodeAt(1);B>=65&&B<=90&&(S=`/${String.fromCharCode(B+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const B=S.charCodeAt(0);B>=65&&B<=90&&(S=`${String.fromCharCode(B+32)}:${S.substr(2)}`)}c+=l(S,!0,!1)}return A&&(c+="?",c+=l(A,!1,!1)),O&&(c+="#",c+=i?O:d(O,!1,!1)),c}function L(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+L(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,i=>L(i)):r}}),define(pe[148],ve([1,0,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(g){const T=g;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=R;function a(g){const T=[];let I;try{const E=JSON.parse(g.arguments),m=E[E.length-1];m&&m.__$stack&&(E.pop(),I=m.__$stack),T.push(...E)}catch{T.push("Unable to log remote console arguments",g.arguments)}return{args:T,stack:I}}e.parse=a;function D(g){if(typeof g!="string")return D(a(g).stack);const T=g;if(T){const I=C(T),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(E&&E.length===4)return{uri:y.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=D;function C(g){if(!g)return g;const T=g.indexOf(`
`);return T===-1?g:g.substring(0,T)}function k(g,T){const{args:I,stack:E}=a(g),m=typeof I[0]=="string"&&I.length===1;let p=C(E);p&&(p=`(${p.trim()})`);let b=[];if(typeof I[0]=="string"?p&&m?b=[`%c[${T}] %c${I[0]} %c${p}`,v("blue"),v(""),v("grey")]:b=[`%c[${T}] %c${I[0]}`,v("blue"),v(""),...I.slice(1)]:b=[`%c[${T}]%`,v("blue"),...I],p&&!m&&b.push(p),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=k;function v(g){return`color: ${g}`}}),define(pe[61],ve([1,0,15,17,4]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(g){return JSON.stringify(g,k)}e.stringify=D;function C(g){let T=JSON.parse(g);return T=v(T),T}e.parse=C;function k(g,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,R.regExpFlags)(T)}:T}function v(g,T=0){if(!g||T>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return a.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof y.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let I=0;I<g.length;++I)g[I]=v(g[I],T+1);else for(const I in g)Object.hasOwnProperty.call(g,I)&&(g[I]=v(g[I],T+1))}return g}e.revive=v}),define(pe[13],ve([1,0,9,3,4]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${D.vscodeRemoteResource}`}set(T,I,E){this.a[T]=I,this.b[T]=E}setConnectionToken(T,I){this.c[T]=I}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(o){return y.onUnexpectedError(o),T}const I=T.authority;let E=this.a[I];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const m=this.b[I],p=this.c[I];let b=`path=${encodeURIComponent(T.path)}`;return typeof p=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),a.URI.from({scheme:R.isWeb?this.d:D.vscodeRemoteResource,authority:`${E}:${m}`,path:R.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:b})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(T){const I=this.b(T,ae);return this.uriToBrowserUri(I)}uriToBrowserUri(T){return T.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${k.a}`)?T.with({scheme:D.vscodeFileResource,authority:T.authority||k.a,query:null,fragment:null}):T}asFileUri(T){const I=this.b(T,ae);return this.uriToFileUri(I)}uriToFileUri(T){return T.scheme===D.vscodeFileResource?T.with({scheme:D.file,authority:T.authority!==k.a?T.authority:null,query:null,fragment:null}):T}b(T,I){return a.URI.isUri(T)?T:a.URI.parse(I.toUrl(T))}}k.a="vscode-app",e.FileAccess=new k;var v;(function(g){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(T.get("3"));const I="vscode-coi";function E(p){let b;typeof p=="string"?b=new URL(p).searchParams:p instanceof URL?b=p.searchParams:a.URI.isUri(p)&&(b=new URL(p.toString(!0)).searchParams);const o=b?.get(I);if(!!o)return T.get(o)}g.getHeadersFromQuery=E;function m(p,b,o){if(!globalThis.crossOriginIsolated)return;const d=b&&o?"3":o?"2":"1";p instanceof URLSearchParams?p.set(I,d):p[I]=d}g.addSearchParam=m})(v=e.COI||(e.COI={}))}),define(pe[19],ve([1,0,38,13,7,3,17,4]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(m){return(0,k.uriToFsPath)(m,!0)}e.originalFSPath=v;class g{constructor(p){this.a=p}compare(p,b,o=!1){return p===b?0:(0,C.compare)(this.getComparisonKey(p,o),this.getComparisonKey(b,o))}isEqual(p,b,o=!1){return p===b?!0:!p||!b?!1:this.getComparisonKey(p,o)===this.getComparisonKey(b,o)}getComparisonKey(p,b=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,b,o=!1){if(p.scheme===b.scheme){if(p.scheme===R.Schemas.file)return y.isEqualOrParent(v(p),v(b),this.a(p))&&p.query===b.query&&(o||p.fragment===b.fragment);if((0,e.isEqualAuthority)(p.authority,b.authority))return y.isEqualOrParent(p.path,b.path,this.a(p),"/")&&p.query===b.query&&(o||p.fragment===b.fragment)}return!1}joinPath(p,...b){return k.URI.joinPath(p,...b)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return a.posix.basename(p.path)}extname(p){return a.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let b;return p.scheme===R.Schemas.file?b=k.URI.file(a.dirname(v(p))).path:(b=a.posix.dirname(p.path),p.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),b="/")),p.with({path:b})}normalizePath(p){if(!p.path.length)return p;let b;return p.scheme===R.Schemas.file?b=k.URI.file(a.normalize(v(p))).path:b=a.posix.normalize(p.path),p.with({path:b})}relativePath(p,b){if(p.scheme!==b.scheme||!(0,e.isEqualAuthority)(p.authority,b.authority))return;if(p.scheme===R.Schemas.file){const h=a.relative(v(p),v(b));return D.isWindows?y.toSlashes(h):h}let o=p.path||"/";const d=b.path||"/";if(this.a(p)){let h=0;for(const f=Math.min(o.length,d.length);h<f&&!(o.charCodeAt(h)!==d.charCodeAt(h)&&o.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);o=d.substr(0,h)+o.substr(h)}return a.posix.relative(o,d)}resolvePath(p,b){if(p.scheme===R.Schemas.file){const o=k.URI.file(a.resolve(v(p),b));return p.with({authority:o.authority,path:o.path})}return b=y.toPosixPath(b),p.with({path:a.posix.resolve(p.path,b)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,b){return p===b||p!==void 0&&b!==void 0&&(0,C.equalsIgnoreCase)(p,b)}hasTrailingPathSeparator(p,b=a.sep){if(p.scheme===R.Schemas.file){const o=v(p);return o.length>y.getRoot(o).length&&o[o.length-1]===b}else{const o=p.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,b=a.sep){return(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,b=a.sep){let o=!1;if(p.scheme===R.Schemas.file){const d=v(p);o=d!==void 0&&d.length===y.getRoot(d).length&&d[d.length-1]===b}else{b="/";const d=p.path;o=d.length===1&&d.charCodeAt(d.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(p,b)?p.with({path:p.path+"/"}):p}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(m=>m.scheme===R.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new g(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(m,p){const b=[];for(let o=0;o<m.length;o++){const d=p(m[o]);m.some((h,f)=>f===o?!1:(0,e.isEqualOrParent)(d,p(h)))||b.push(m[o])}return b}e.distinctParents=T;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function p(b){const o=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[w,L]=f.split(":");w&&L&&o.set(w,L)});const h=b.path.substring(0,b.path.indexOf(";"));return h&&o.set(m.META_DATA_MIME,h),o}m.parseMetaData=p})(I=e.DataUri||(e.DataUri={}));function E(m,p,b){if(p){let o=m.path;return o&&o[0]!==a.posix.sep&&(o=a.posix.sep+o),m.with({scheme:b,authority:p,path:o})}return m.with({scheme:b})}e.toLocalResource=E}),define(pe[14],ve([1,0,20,9,6,2,19,3,146]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(W){return!!W&&typeof W.then=="function"}e.isThenable=g;function T(W){const N=new y.CancellationTokenSource,P=W(N.token),M=new Promise((K,te)=>{const j=N.token.onCancellationRequested(()=>{j.dispose(),N.dispose(),te(new R.CancellationError)});Promise.resolve(P).then(H=>{j.dispose(),N.dispose(),K(H)},H=>{j.dispose(),N.dispose(),te(H)})});return new class{cancel(){N.cancel()}then(K,te){return M.then(K,te)}catch(K){return this.then(void 0,K)}finally(K){return M.finally(K)}}}e.createCancelablePromise=T;function I(W,N,P){return new Promise((M,K)=>{const te=N.onCancellationRequested(()=>{te.dispose(),M(P)});W.then(M,K).finally(()=>te.dispose())})}e.raceCancellation=I;function E(W,N){return new Promise((P,M)=>{const K=N.onCancellationRequested(()=>{K.dispose(),M(new R.CancellationError)});W.then(P,M).finally(()=>K.dispose())})}e.raceCancellationError=E;async function m(W){let N=-1;const P=W.map((K,te)=>K.then(j=>(N=te,j))),M=await Promise.race(P);return W.forEach((K,te)=>{te!==N&&K.cancel()}),M}e.raceCancellablePromises=m;function p(W,N,P){let M;const K=setTimeout(()=>{M?.(void 0),P?.()},N);return Promise.race([W.finally(()=>clearTimeout(K)),new Promise(te=>M=te)])}e.raceTimeout=p;function b(W){return new Promise((N,P)=>{const M=W();g(M)?M.then(N,P):N(M)})}e.asPromise=b;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const P=()=>{this.b=null;const M=this.queue(this.d);return this.d=null,M};this.b=new Promise(M=>{this.a.then(P,P).then(M)})}return new Promise((P,M)=>{this.b.then(P,M)})}return this.a=N(),new Promise((P,M)=>{this.a.then(K=>{this.a=null,P(K)},K=>{this.a=null,M(K)})})}}e.Throttler=o;class d{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=d;class h{constructor(){this.a=new Map}queue(N,P){const K=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.a.get(N)===K&&this.a.delete(N)});return this.a.set(N,K),K}}e.SequencerByKey=h;const f=(W,N)=>{let P=!0;const M=setTimeout(()=>{P=!1,N()},W);return{isTriggered:()=>P,dispose:()=>{clearTimeout(M),P=!1}}},w=W=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,W())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class L{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,P=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((K,te)=>{this.d=K,this.f=te}).then(()=>{if(this.b=null,this.d=null,this.g){const K=this.g;return this.g=null,K()}}));const M=()=>{this.a=null,this.d?.(null)};return this.a=P===v.MicrotaskDelay?w(M):f(P,M),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class t{constructor(N){this.a=new L(N),this.b=new o}trigger(N,P){return this.a.trigger(()=>this.b.queue(N),P)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((N,P)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(W,N){return N?new Promise((P,M)=>{const K=setTimeout(()=>{te.dispose(),P()},W),te=N.onCancellationRequested(()=>{clearTimeout(K),te.dispose(),M(new R.CancellationError)})}):T(P=>i(W,P))}e.timeout=i;function l(W,N=0){const P=setTimeout(W,N);return(0,D.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=l;function c(W){const N=[];let P=0;const M=W.length;function K(){return P<M?W[P++]():null}function te(j){j!=null&&N.push(j);const H=K();return H?H.then(te):Promise.resolve(N)}return Promise.resolve(null).then(te)}e.sequence=c;function s(W,N=M=>!!M,P=null){let M=0;const K=W.length,te=()=>{if(M>=K)return Promise.resolve(P);const j=W[M++];return Promise.resolve(j()).then(J=>N(J)?Promise.resolve(J):te())};return te()}e.first=s;function u(W,N=M=>!!M,P=null){if(W.length===0)return Promise.resolve(P);let M=W.length;const K=()=>{M=-1;for(const te of W)te.cancel?.()};return new Promise((te,j)=>{for(const H of W)H.then(J=>{--M>=0&&N(J)?(K(),te(J)):M===0&&te(P)}).catch(J=>{--M>=0&&(K(),j(J))})})}e.firstParallel=u;class S{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new a.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((P,M)=>{this.f.push({factory:N,c:P,e:M}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const P=N.factory();P.then(N.c,N.e),P.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class A extends S{constructor(){super(1)}}e.Queue=A;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new G;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,P=C.extUri){const M=P.getComparisonKey(N);let K=this.a.get(M);return K||(K=new A,a.Event.once(K.onDrained)(()=>{K?.dispose(),this.a.delete(M),this.f()}),this.a.set(M,K)),K}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class B{constructor(N,P){this.a=-1,typeof N=="function"&&typeof P=="number"&&this.setIfNotSet(N,P)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,P){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},P)}setIfNotSet(N,P){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},P))}}e.TimeoutTimer=B;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,P){this.cancel(),this.a=setInterval(()=>{N()},P)}}e.IntervalTimer=q;class le{constructor(N,P){this.b=-1,this.a=N,this.d=P,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=le;class fe{constructor(N,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.a=N,this.b=P,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=fe;class ue extends le{constructor(N,P){super(N,P),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ue;class re extends D.Disposable{constructor(N,P){super(),this.g=N,this.h=P,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const P of N)this.a.push(P);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,k.setTimeout0)(()=>{if(N)return;const P=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(W,N)=>{const P=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(P))}}}}();class _{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(P){this.g=P}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=_;async function ee(W,N,P){let M;for(let K=0;K<P;K++)try{return await W()}catch(te){M=te,await i(N)}throw M}e.retry=ee;class ne{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,P,M){return this.a={taskId:N,cancel:()=>M?.(),promise:P},P.then(()=>this.d(N),()=>this.d(N)),P}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let P,M;const K=new Promise((te,j)=>{P=te,M=j});this.b={run:N,promise:K,promiseResolve:P,promiseReject:M}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ne;class ie{constructor(N,P=()=>Date.now()){this.d=N,this.f=P,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=ie;class G{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,P)=>{this.a=N,this.b=P})}complete(N){return new Promise(P=>{this.a(N),this.f=!0,P()})}error(N){return new Promise(P=>{this.b(N),this.d=!0,P()})}cancel(){new Promise(N=>{this.b(new R.CancellationError),this.d=!0,N()})}}e.DeferredPromise=G;var U;(function(W){async function N(M){let K;const te=await Promise.all(M.map(j=>j.then(H=>H,H=>{K||(K=H)})));if(typeof K<"u")throw K;return te}W.settled=N;function P(M){return new Promise(async(K,te)=>{try{await M(K,te)}catch(j){te(j)}})}W.withAsyncBody=P})(U=e.Promises||(e.Promises={}));var Z;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(Z||(Z={}));class oe{static fromArray(N){return new oe(P=>{P.emitMany(N)})}static fromPromise(N){return new oe(async P=>{P.emitMany(await N)})}static fromPromises(N){return new oe(async P=>{await Promise.all(N.map(async M=>P.emitOne(await M)))})}static merge(N){return new oe(async P=>{await Promise.all(N.map(async M=>{for await(const K of M)P.emitOne(K)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new a.Emitter,queueMicrotask(async()=>{const P={emitOne:M=>this.g(M),emitMany:M=>this.h(M),reject:M=>this.k(M)};try{await Promise.resolve(N(P)),this.j()}catch(M){this.k(M)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await a.Event.toPromise(this.f.event)}while(!0)}}}static map(N,P){return new oe(async M=>{for await(const K of N)M.emitOne(P(K))})}map(N){return oe.map(this,N)}static filter(N,P){return new oe(async M=>{for await(const K of N)P(K)&&M.emitOne(K)})}filter(N){return oe.filter(this,N)}static coalesce(N){return oe.filter(N,P=>!!P)}coalesce(){return oe.coalesce(this)}static async toPromise(N){const P=[];for await(const M of N)P.push(M);return P}toPromise(){return oe.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}oe.EMPTY=oe.fromArray([]),e.AsyncIterableObject=oe;class me extends oe{constructor(N,P){super(P),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=me;function $(W){const N=new y.CancellationTokenSource,P=W(N.token);return new me(N,async M=>{const K=N.token.onCancellationRequested(()=>{K.dispose(),N.dispose(),M.reject(new R.CancellationError)});try{for await(const te of P){if(N.token.isCancellationRequested)return;M.emitOne(te)}K.dispose(),N.dispose()}catch(te){K.dispose(),N.dispose(),M.reject(te)}})}e.createCancelableAsyncIterable=$}),define(pe[74],ve([1,0,18,14,38,27,7,3,17]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",I="[^/\\\\]",E=/\//g;function m(ie,G){switch(ie){case 0:return"";case 1:return`${I}*?`;default:return`(?:${T}|${I}+${T}${G?`|${T}${I}+`:""})*?`}}function p(ie,G){if(!ie)return[];const U=[];let Z=!1,oe=!1,me="";for(const $ of ie){switch($){case G:if(!Z&&!oe){U.push(me),me="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}me+=$}return me&&U.push(me),U}e.splitGlobAware=p;function b(ie){if(!ie)return"";let G="";const U=p(ie,e.GLOB_SPLIT);if(U.every(Z=>Z===e.GLOBSTAR))G=".*";else{let Z=!1;U.forEach((oe,me)=>{if(oe===e.GLOBSTAR){if(Z)return;G+=m(2,me===U.length-1)}else{let $=!1,W="",N=!1,P="";for(const M of oe){if(M!=="}"&&$){W+=M;continue}if(N&&(M!=="]"||!P)){let K;M==="-"?K=M:(M==="^"||M==="!")&&!P?K="^":M===e.GLOB_SPLIT?K="":K=(0,v.escapeRegExpCharacters)(M),P+=K;continue}switch(M){case"{":$=!0;continue;case"[":N=!0;continue;case"}":{G+=`(?:${p(W,",").map(j=>b(j)).join("|")})`,$=!1,W="";break}case"]":{G+="["+P+"]",N=!1,P="";break}case"?":G+=I;continue;case"*":G+=m(1);continue;default:G+=(0,v.escapeRegExpCharacters)(M)}}me<U.length-1&&(U[me+1]!==e.GLOBSTAR||me+2<U.length)&&(G+=T)}Z=oe===e.GLOBSTAR})}return G}const o=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(ie,G){if(!ie)return r;let U;typeof ie!="string"?U=ie.pattern:U=ie,U=U.trim();const Z=`${U}_${!!G.trimForExclusions}`;let oe=t.get(Z);if(oe)return l(oe,ie);let me;return o.test(U)?oe=s(U.substr(4),U):(me=d.exec(c(U,G)))?oe=u(me[1],U):(G.trimForExclusions?f:h).test(U)?oe=S(U,G):(me=w.exec(c(U,G)))?oe=A(me[1].substr(1),U,!0):(me=L.exec(c(U,G)))?oe=A(me[1],U,!1):oe=O(U),t.set(Z,oe),l(oe,ie)}function l(ie,G){if(typeof G=="string")return ie;const U=function(Z,oe){return(0,a.isEqualOrParent)(Z,G.base,!k.isLinux)?ie((0,v.ltrim)(Z.substr(G.base.length),C.sep),oe):null};return U.allBasenames=ie.allBasenames,U.allPaths=ie.allPaths,U.basenames=ie.basenames,U.patterns=ie.patterns,U}function c(ie,G){return G.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function s(ie,G){return function(U,Z){return typeof U=="string"&&U.endsWith(ie)?G:null}}function u(ie,G){const U=`/${ie}`,Z=`\\${ie}`,oe=function($,W){return typeof $!="string"?null:W?W===ie?G:null:$===ie||$.endsWith(U)||$.endsWith(Z)?G:null},me=[ie];return oe.basenames=me,oe.patterns=[G],oe.allBasenames=me,oe}function S(ie,G){const U=ee(ie.slice(1,-1).split(",").map(W=>i(W,G)).filter(W=>W!==r),ie),Z=U.length;if(!Z)return r;if(Z===1)return U[0];const oe=function(W,N){for(let P=0,M=U.length;P<M;P++)if(U[P](W,N))return ie;return null},me=U.find(W=>!!W.allBasenames);me&&(oe.allBasenames=me.allBasenames);const $=U.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return $.length&&(oe.allPaths=$),oe}function A(ie,G,U){const Z=C.sep===C.posix.sep,oe=Z?ie:ie.replace(E,C.sep),me=C.sep+oe,$=C.posix.sep+ie;let W;return U?W=function(N,P){return typeof N=="string"&&(N===oe||N.endsWith(me)||!Z&&(N===ie||N.endsWith($)))?G:null}:W=function(N,P){return typeof N=="string"&&(N===oe||!Z&&N===ie)?G:null},W.allPaths=[(U?"*/":"./")+ie],W}function O(ie){try{const G=new RegExp(`^${b(ie)}$`);return function(U){return G.lastIndex=0,typeof U=="string"&&G.test(U)?ie:null}}catch{return r}}function B(ie,G,U){return!ie||typeof G!="string"?!1:q(ie)(G,void 0,U)}e.match=B;function q(ie,G={}){if(!ie)return n;if(typeof ie=="string"||le(ie)){const U=i(ie,G);if(U===r)return n;const Z=function(oe,me){return!!U(oe,me)};return U.allBasenames&&(Z.allBasenames=U.allBasenames),U.allPaths&&(Z.allPaths=U.allPaths),Z}return re(ie,G)}e.parse=q;function le(ie){const G=ie;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=le;function fe(ie){return ie.allBasenames||[]}e.getBasenameTerms=fe;function ue(ie){return ie.allPaths||[]}e.getPathTerms=ue;function re(ie,G){const U=ee(Object.getOwnPropertyNames(ie).map(W=>_(W,ie[W],G)).filter(W=>W!==r)),Z=U.length;if(!Z)return r;if(!U.some(W=>!!W.requiresSiblings)){if(Z===1)return U[0];const W=function(M,K){let te;for(let j=0,H=U.length;j<H;j++){const J=U[j](M,K);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(te||(te=[]),te.push(J))}return te?(async()=>{for(const j of te){const H=await j;if(typeof H=="string")return H}return null})():null},N=U.find(M=>!!M.allBasenames);N&&(W.allBasenames=N.allBasenames);const P=U.reduce((M,K)=>K.allPaths?M.concat(K.allPaths):M,[]);return P.length&&(W.allPaths=P),W}const oe=function(W,N,P){let M,K;for(let te=0,j=U.length;te<j;te++){const H=U[te];H.requiresSiblings&&P&&(N||(N=(0,C.basename)(W)),M||(M=N.substr(0,N.length-(0,C.extname)(W).length)));const J=H(W,N,M,P);if(typeof J=="string")return J;(0,R.isThenable)(J)&&(K||(K=[]),K.push(J))}return K?(async()=>{for(const te of K){const j=await te;if(typeof j=="string")return j}return null})():null},me=U.find(W=>!!W.allBasenames);me&&(oe.allBasenames=me.allBasenames);const $=U.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return $.length&&(oe.allPaths=$),oe}function _(ie,G,U){if(G===!1)return r;const Z=i(ie,U);if(Z===r)return r;if(typeof G=="boolean")return Z;if(G){const oe=G.when;if(typeof oe=="string"){const me=($,W,N,P)=>{if(!P||!Z($,W))return null;const M=oe.replace("$(basename)",()=>N),K=P(M);return(0,R.isThenable)(K)?K.then(te=>te?ie:null):K?ie:null};return me.requiresSiblings=!0,me}}return Z}function ee(ie,G){const U=ie.filter(W=>!!W.basenames);if(U.length<2)return ie;const Z=U.reduce((W,N)=>{const P=N.basenames;return P?W.concat(P):W},[]);let oe;if(G){oe=[];for(let W=0,N=Z.length;W<N;W++)oe.push(G)}else oe=U.reduce((W,N)=>{const P=N.patterns;return P?W.concat(P):W},[]);const me=function(W,N){if(typeof W!="string")return null;if(!N){let M;for(M=W.length;M>0;M--){const K=W.charCodeAt(M-1);if(K===47||K===92)break}N=W.substr(M)}const P=Z.indexOf(N);return P!==-1?oe[P]:null};me.basenames=Z,me.patterns=oe,me.allBasenames=Z;const $=ie.filter(W=>!W.basenames);return $.push(me),$}function ne(ie,G){return(0,y.equals)(ie,G,(U,Z)=>typeof U=="string"&&typeof Z=="string"?U===Z:typeof U!="string"&&typeof Z!="string"?U.base===Z.base&&U.pattern===Z.pattern:!1)}e.patternsEquals=ne}),define(pe[96],ve([1,0,9,147,19,17,4]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(d="",h=!1){if(this.value=d,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(d,h=0){return this.value+=E(this.supportThemeIcons?(0,R.escapeIcons)(d):d).replace(/([ \t]+)/g,(f,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,h){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(d,h,f){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(d),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(d,h){const f=new RegExp((0,D.escapeRegExpCharacters)(h),"g");return d.replace(f,(w,L)=>d.charAt(L-1)!=="\\"?`\\${w}`:w)}}e.MarkdownString=v;function g(o){return T(o)?!o.value:Array.isArray(o)?o.every(g):!0}e.isEmptyMarkdownString=g;function T(o){return o instanceof v?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function I(o,d){return o===d?!0:!o||!d?!1:o.value===d.value&&o.isTrusted===d.isTrusted&&o.supportThemeIcons===d.supportThemeIcons&&o.supportHtml===d.supportHtml&&(o.baseUri===d.baseUri||!!o.baseUri&&!!d.baseUri&&(0,a.isEqual)(C.URI.from(o.baseUri),C.URI.from(d.baseUri)))}e.markdownStringEqual=I;function E(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function m(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=m;function p(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function b(o){const d=[],h=o.split("|").map(w=>w.trim());o=h[0];const f=h[1];if(f){const w=/height=(\d+)/.exec(f),L=/width=(\d+)/.exec(f),t=w?w[1]:"",n=L?L[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&d.push(`width="${n}"`),i&&d.push(`height="${t}"`)}return{href:o,dimensions:d}}e.parseHrefAndDimensions=b}),define(pe[149],ve([1,0,18,38,7,3,19,17]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function v(r,i){const{os:l,tildify:c,relative:s}=i;if(s){const A=g(r,s,l);if(typeof A=="string")return A}let u=r.fsPath;if(l===1&&!D.isWindows?u=u.replace(/\//g,"\\"):l!==1&&D.isWindows&&(u=u.replace(/\\/g,"/")),l!==1&&c?.userHome){const A=c.userHome.fsPath;let O;r.scheme!==c.userHome.scheme&&r.path.startsWith(a.posix.sep)?O=c.userHome.with({path:r.path}).fsPath:O=r.fsPath,u=E(O,A,l)}return(l===1?a.win32:a.posix).normalize(T(u,l===1))}e.getPathLabel=v;function g(r,i,l){const c=l===1?a.win32:a.posix,s=l===3?C.extUri:C.extUriIgnorePathCase,u=i.getWorkspace(),S=(0,y.firstOrDefault)(u.folders);if(!S)return;r.scheme!==S.uri.scheme&&r.path.startsWith(a.posix.sep)&&(r=S.uri.with({path:r.path}));const A=i.getWorkspaceFolder(r);if(!A)return;let O;if(s.isEqual(A.uri,r)?O="":O=s.relativePath(A.uri,r)??"",O&&(O=c.normalize(O)),u.folders.length>1&&!i.noPrefix){const B=A.name?A.name:s.basenameOrAuthority(A.uri);O=O?`${B} \u2022 ${O}`:B}return O}function T(r,i=D.isWindows){return(0,R.hasDriveLetter)(r,i)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=T;let I=Object.create(null);function E(r,i,l=D.OS){if(l===1||!r||!i)return r;let c=I.original===i?I.normalized:void 0;c||(c=i,D.isWindows&&(c=(0,R.toSlashes)(c)),c=`${(0,k.rtrim)(c,a.posix.sep)}${a.posix.sep}`,I={original:i,normalized:c});let s=r;return D.isWindows&&(s=(0,R.toSlashes)(s)),(l===3?s.startsWith(c):(0,k.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:r}e.tildify=E;function m(r,i){return r.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=m;const p="\u2026",b="\\\\",o="~";function d(r,i=a.sep){const l=new Array(r.length);let c=!1;for(let s=0;s<r.length;s++){const u=r[s];if(u===""){l[s]=`.${i}`;continue}if(!u){l[s]=u;continue}c=!0;let S="",A=u;A.indexOf(b)===0?(S=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length)):A.indexOf(i)===0?(S=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(o)===0&&(S=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const O=A.split(i);for(let B=1;c&&B<=O.length;B++)for(let q=O.length-B;c&&q>=0;q--){c=!1;let le=O.slice(q,q+B).join(i);for(let fe=0;!c&&fe<r.length;fe++)if(fe!==s&&r[fe]&&r[fe].indexOf(le)>-1){const ue=q+B===O.length,re=q>0&&r[fe].indexOf(i)>-1?i+le:le,_=r[fe].endsWith(re);c=!ue||_}if(!c){let fe="";(O[0].endsWith(":")||S!=="")&&(q===1&&(q=0,B++,le=O[0]+i+le),q>0&&(fe=O[0]+i),fe=S+fe),q>0&&(fe=fe+p+i),fe=fe+le,q+B<O.length&&(fe=fe+i+p),l[s]=fe}}c&&(l[s]=u)}return l}e.shorten=d;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function f(r,i=Object.create(null)){const l=[];let c=!1,s="";for(const u of r)if(u==="$"||c&&u==="{")s&&l.push({value:s,type:h.TEXT}),s="",c=!0;else if(u==="}"&&c){const S=i[s];if(typeof S=="string")S.length&&l.push({value:S,type:h.VARIABLE});else if(S){const A=l[l.length-1];(!A||A.type!==h.SEPARATOR)&&l.push({value:S.label,type:h.SEPARATOR})}s="",c=!1}else s+=u;return s&&!c&&l.push({value:s,type:h.TEXT}),l.filter((u,S)=>{if(u.type===h.SEPARATOR){const A=l[S-1],O=l[S+1];return[A,O].every(B=>B&&(B.type===h.VARIABLE||B.type===h.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=f;function w(r,i){return D.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function L(r,i){return D.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=L;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(r){const i=r.indexOf("/")!==-1?a.posix:a.win32,l=i.basename(r),c=i.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(pe[48],ve([1,0,15,4]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function a(I){return I.toJSON()}class D{constructor(E){this.a=E}transformIncoming(E){const m=this.a.transformIncoming(E);return m===E?E:a(R.URI.from(m))}transformOutgoing(E){const m=this.a.transformOutgoing(E);return m===E?E:a(R.URI.from(m))}transformOutgoingURI(E){const m=this.a.transformOutgoing(E);return m===E?E:R.URI.from(m)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function C(I,E,m){if(!I||m>200)return null;if(typeof I=="object"){if(I instanceof R.URI)return E.transformOutgoing(I);for(const p in I)if(Object.hasOwnProperty.call(I,p)){const b=C(I[p],E,m+1);b!==null&&(I[p]=b)}}return null}function k(I,E){const m=C(I,E,0);return m===null?I:m}e.transformOutgoingURIs=k;function v(I,E,m,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return m?R.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);if(I instanceof y.VSBuffer)return null;for(const b in I)if(Object.hasOwnProperty.call(I,b)){const o=v(I[b],E,m,p+1);o!==null&&(I[b]=o)}}return null}function g(I,E){const m=v(I,E,!1,0);return m===null?I:m}e.transformIncomingURIs=g;function T(I,E){const m=v(I,E,!0,0);return m===null?I:m}e.transformAndReviveIncomingURIs=T}),define(pe[21],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(a){return y.test(a)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let a;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?a=crypto.getRandomValues.bind(crypto):a=function(k){for(let v=0;v<k.length;v++)k[v]=Math.floor(Math.random()*256);return k};const D=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){a(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let v=0,g="";return g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+="-",g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g+=C[D[v++]],g}}()}),define(pe[150],ve([1,0,18,21]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function a(k){return{id:(0,R.generateUuid)(),asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=a;function D(k,v,g){return{id:(0,R.generateUuid)(),asString:async()=>"",asFile:()=>({name:k,uri:v,data:g}),value:void 0}}e.createFileDataTransferItem=D;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(v){return this.a.has(this.b(v))}get(v){return this.a.get(this.b(v))?.[0]}append(v,g){const T=this.a.get(v);T?T.push(g):this.a.set(this.b(v),[g])}replace(v,g){this.a.set(this.b(v),[g])}delete(v){this.a.delete(this.b(v))}*entries(){for(const[v,g]of this.a.entries())for(const T of g)yield[v,T]}values(){return Array.from(this.a.values()).flat()}forEach(v){for(const[g,T]of this.entries())v(T,g)}b(v){return v.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:k=>(0,y.distinct)(k.map(v=>v.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function ae(e,y,R){function a(m){return new Promise(p=>y.exists(m,p))}function D(m){return new Promise((p,b)=>{const o=new Date;y.utimes(m,o,o,d=>d?b(d):p())})}function C(m){return new Promise((p,b)=>y.mkdir(m,{recursive:!0},o=>o&&o.code!=="EEXIST"?b(o):p(m)))}function k(m){return new Promise((p,b)=>y.rm(m,{recursive:!0,force:!0,maxRetries:3},o=>o?b(o):p()))}function v(m){return new Promise((p,b)=>y.readFile(m,"utf8",(o,d)=>o?b(o):p(d)))}function g(m,p){return new Promise((b,o)=>y.writeFile(m,p,"utf8",d=>d?o(d):b()))}async function T(m){const p=e.join(m,"languagepacks.json");try{return JSON.parse(await v(p))}catch{}}function I(m,p){try{for(;p;){if(m[p])return p;{const b=p.lastIndexOf("-");if(b>0)p=p.substring(0,b);else return}}}catch(b){console.error("Resolving language pack configuration failed.",b)}}function E(m,p,b,o,d){const h=function(w){return R.mark("code/didGenerateNls"),Promise.resolve({locale:w,osLocale:d,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),o==="pseudo")return Promise.resolve({locale:o,osLocale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:o,osLocale:d,availableLanguages:{}});if(o&&(o==="en"||o==="en-us"))return Promise.resolve({locale:o,osLocale:d,availableLanguages:{}});const f=o;try{return m?T(p).then(w=>{if(!w)return h(f);const L=I(w,o);if(!L)return h(f);o=L;const t=w[o];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?h(f):a(n).then(r=>{if(!r)return h(f);const i=t.hash+"."+o,l=e.join(p,"clp",i),c=e.join(l,m),s=e.join(l,"tcf.json"),u=e.join(l,"corrupted.info"),S={locale:f,osLocale:d,availableLanguages:{"*":o},_languagePackId:i,_translationsConfigFile:s,_cacheRoot:l,_resolvedLanguagePackCoreLocation:c,_corruptedFile:u};return a(u).then(A=>{let O;return A?O=k(l):O=Promise.resolve(void 0),O.then(()=>a(c).then(B=>B?(D(c).catch(()=>{}),R.mark("code/didGenerateNls"),S):C(c).then(()=>Promise.all([v(b),v(n)])).then(q=>{const le=JSON.parse(q[0]),fe=JSON.parse(q[1]).contents,ue=Object.keys(le.bundles),re=[];for(const _ of ue){const ee=le.bundles[_],ne=Object.create(null);for(const ie of ee){const G=le.keys[ie],U=le.messages[ie],Z=fe[ie];let oe;if(Z){oe=[];for(let me=0;me<G.length;me++){const $=G[me],W=typeof $=="string"?$:$.key;let N=Z[W];N===void 0&&(N=U[me]),oe.push(N)}}else oe=U;ne[ie]=oe}re.push(g(e.join(c,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(ne)))}return re.push(g(s,JSON.stringify(t.translations))),Promise.all(re)}).then(()=>(R.mark("code/didGenerateNls"),S)).catch(q=>(console.error("Generating translation files failed.",q),h(o)))))})})}):h(f)}catch(w){return console.error("Generating translation files failed.",w),h(o)}}return{getNLSConfiguration:E}}if(typeof define=="function")define(pe[151],ve([75,33,42]),function(e,y,R){return ae(e,y,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),R=require("../common/performance");module.exports=ae(e,y,R)}else throw new Error("Unknown context")}(),define(pe[152],ve([1,0,29]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function a(C){const k=C.replace(/\-/g,":").toLowerCase();return!R.has(k)}function D(){const C=(0,y.networkInterfaces)();for(const k in C){const v=C[k];if(v){for(const{mac:g}of v)if(a(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(pe[97],ve([1,0,29,60,21,152]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(g){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,T=0;const I=(0,y.networkInterfaces)();for(const E in I){const m=I[E];if(m)for(const{mac:p,internal:b}of m)b||(T+=1,this.c(p.toUpperCase())&&(g+=1))}this.b=T>0?g/T:0}return this.b}};let C;async function k(g){return C||(C=(async()=>await v(g)||a.generateUuid())()),C}e.getMachineId=k;async function v(g){try{const T=await new Promise((E,m)=>{ae(["crypto"],E,m)}),I=(0,D.getMac)();return T.createHash("sha256").update(I,"utf8").digest("hex")}catch(T){g(T);return}}}),define(pe[23],ve([1,0,33,29,292,14,38,93,7,3,19,4]),function(ae,e,y,R,a,D,C,k,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function m(re,_=E.UNLINK){if((0,C.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return _===E.UNLINK?b(re):p(re)}async function p(re){try{const _=(0,C.randomPath)((0,R.tmpdir)());try{await y.promises.rename(re,_)}catch(ee){return ee.code==="ENOENT"?void 0:b(re)}b(_).catch(ee=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function b(re){return(0,a.promisify)(y.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function o(re){if((0,C.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function d(re,_){return w(await(_?h(re):(0,a.promisify)(y.readdir)(re)))}async function h(re){try{return await(0,a.promisify)(y.readdir)(re,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const _=[],ee=await d(re);for(const ne of ee){let ie=!1,G=!1,U=!1;try{const Z=await e.Promises.lstat((0,v.join)(re,ne));ie=Z.isFile(),G=Z.isDirectory(),U=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}_.push({name:ne,isFile:()=>ie,isDirectory:()=>G,isSymbolicLink:()=>U})}return _}function f(re){return w(y.readdirSync(re))}e.readdirSync=f;function w(re){return re.map(_=>typeof _=="string"?g.isMacintosh?(0,k.normalizeNFC)(_):_:(_.name=g.isMacintosh?(0,k.normalizeNFC)(_.name):_.name,_))}async function L(re){const _=await d(re),ee=[];for(const ne of _)await n.existsDirectory((0,v.join)(re,ne))&&ee.push(ne);return ee}function t(re,_=1e3){return new Promise(ee=>{let ne=!1;const ie=setInterval(()=>{ne||(ne=!0,y.access(re,G=>{ne=!1,G&&(clearInterval(ie),ee(void 0))}))},_)})}e.whenDeleted=t;var n;(function(re){async function _(ie){let G;try{if(G=await e.Promises.lstat(ie),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(ie),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(g.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ie)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw Z}throw U}}re.stat=_;async function ee(ie){try{const{stat:G,symbolicLink:U}=await re.stat(ie);return G.isFile()&&U?.dangling!==!0}catch{}return!1}re.existsFile=ee;async function ne(ie){try{const{stat:G,symbolicLink:U}=await re.stat(ie);return G.isDirectory()&&U?.dangling!==!0}catch{}return!1}re.existsDirectory=ne})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(re,_,ee){return r.queueFor(I.URI.file(re),T.extUriBiasedIgnorePathCase).queue(()=>{const ne=S(ee);return new Promise((ie,G)=>s(re,_,ne,U=>U?G(U):ie()))})}let l=!0;function c(re){l=re}e.configureFlushOnWrite=c;function s(re,_,ee,ne){if(!l)return y.writeFile(re,_,{mode:ee.mode,flag:ee.flag},ne);y.open(re,ee.flag,ee.mode,(ie,G)=>{if(ie)return ne(ie);y.writeFile(G,_,U=>{if(U)return y.close(G,()=>ne(U));y.fdatasync(G,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),c(!1)),y.close(G,oe=>ne(oe))))})})}function u(re,_,ee){const ne=S(ee);if(!l)return y.writeFileSync(re,_,{mode:ne.mode,flag:ne.flag});const ie=y.openSync(re,ne.flag,ne.mode);try{y.writeFileSync(ie,_);try{y.fdatasyncSync(ie)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),c(!1)}}finally{y.closeSync(ie)}}e.writeFileSync=u;function S(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function A(re,_){if(re!==_)try{await e.Promises.rename(re,_)}catch(ee){if(re.toLowerCase()!==_.toLowerCase()&&ee.code==="EXDEV"||re.endsWith("."))await O(re,_,{preserveSymlinks:!1}),await m(re,E.MOVE);else throw ee}}async function O(re,_,ee){return q(re,_,{root:{source:re,target:_},options:ee,handledSourcePaths:new Set})}const B=511;async function q(re,_,ee){if(ee.handledSourcePaths.has(re))return;ee.handledSourcePaths.add(re);const{stat:ne,symbolicLink:ie}=await n.stat(re);if(ie){if(ee.options.preserveSymlinks)try{return await ue(re,_,ee)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(ie.dangling)return}return ne.isDirectory()?le(re,_,ne.mode&B,ee):fe(re,_,ne.mode&B)}async function le(re,_,ee,ne){await e.Promises.mkdir(_,{recursive:!0,mode:ee});const ie=await d(re);for(const G of ie)await q((0,v.join)(re,G),(0,v.join)(_,G),ne)}async function fe(re,_,ee){await e.Promises.copyFile(re,_),await e.Promises.chmod(_,ee)}async function ue(re,_,ee){let ne=await e.Promises.readlink(re);(0,C.isEqualOrParent)(ne,ee.root.source,!g.isLinux)&&(ne=(0,v.join)(ee.root.target,ne.substr(ee.root.source.length+1))),await e.Promises.symlink(ne,_)}e.Promises=new class{get access(){return(0,a.promisify)(y.access)}get stat(){return(0,a.promisify)(y.stat)}get lstat(){return(0,a.promisify)(y.lstat)}get utimes(){return(0,a.promisify)(y.utimes)}get read(){return(re,_,ee,ne,ie)=>new Promise((G,U)=>{y.read(re,_,ee,ne,ie,(Z,oe,me)=>Z?U(Z):G({bytesRead:oe,buffer:me}))})}get readFile(){return(0,a.promisify)(y.readFile)}get write(){return(re,_,ee,ne,ie)=>new Promise((G,U)=>{y.write(re,_,ee,ne,ie,(Z,oe,me)=>Z?U(Z):G({bytesWritten:oe,buffer:me}))})}get appendFile(){return(0,a.promisify)(y.appendFile)}get fdatasync(){return(0,a.promisify)(y.fdatasync)}get truncate(){return(0,a.promisify)(y.truncate)}get rename(){return(0,a.promisify)(y.rename)}get copyFile(){return(0,a.promisify)(y.copyFile)}get open(){return(0,a.promisify)(y.open)}get close(){return(0,a.promisify)(y.close)}get symlink(){return(0,a.promisify)(y.symlink)}get readlink(){return(0,a.promisify)(y.readlink)}get chmod(){return(0,a.promisify)(y.chmod)}get mkdir(){return(0,a.promisify)(y.mkdir)}get unlink(){return(0,a.promisify)(y.unlink)}get rmdir(){return(0,a.promisify)(y.rmdir)}get realpath(){return(0,a.promisify)(y.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return m}get move(){return A}get copy(){return O}}}),define(pe[153],ve([1,0,33,7,3,17,23]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(E){if(a.isLinux)return E;const m=(0,R.dirname)(E);if(E===m)return E;const p=((0,R.basename)(E)||E).toLowerCase();try{const o=(0,C.readdirSync)(m).filter(d=>d.toLowerCase()===p);if(o.length===1){const d=k(m);if(d)return(0,R.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(p);if(d>=0){const h=k(m);if(h)return(0,R.join)(h,o[d])}}}catch{}return null}e.realcaseSync=k;async function v(E){if(a.isLinux)return E;const m=(0,R.dirname)(E);if(E===m)return E;const p=((0,R.basename)(E)||E).toLowerCase();try{const o=(await C.Promises.readdir(m)).filter(d=>d.toLowerCase()===p);if(o.length===1){const d=await v(m);if(d)return(0,R.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(p);if(d>=0){const h=await v(m);if(h)return(0,R.join)(h,o[d])}}}catch{}return null}e.realcase=v;async function g(E){try{return await C.Promises.realpath(E)}catch{const p=I(E);return await C.Promises.access(p,y.constants.R_OK),p}}e.realpath=g;function T(E){try{return y.realpathSync(E)}catch{const p=I(E);return y.accessSync(p,y.constants.R_OK),p}}e.realpathSync=T;function I(E){return(0,D.rtrim)((0,R.normalize)(E),R.sep)}}),define(pe[154],ve([1,0,98]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function R(k,v,g,T=1){let I=!1;return new Promise(E=>{const m=setTimeout(()=>{if(!I)return I=!0,E(0)},g);a(k,v,T,p=>{if(!I)return I=!0,clearTimeout(m),E(p)})})}e.findFreePort=R;function a(k,v,g,T){if(v===0)return T(0);const I=new y.Socket;I.once("connect",()=>(C(I),a(k+g,v-1,g,T))),I.once("data",()=>{}),I.once("error",E=>(C(I),E.code!=="ECONNREFUSED"?a(k+g,v-1,g,T):T(k))),I.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(k,v,g,T="127.0.0.1"){let I=!1,E,m=1;const p=y.createServer({pauseOnConnect:!0});function b(o,d){I||(I=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),d(o))}return new Promise(o=>{E=setTimeout(()=>{b(0,o)},g),p.on("listening",()=>{b(k,o)}),p.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&m<v?(k++,m++,p.listen(k,T)):b(0,o)}),p.on("close",()=>{b(0,o)}),p.listen(k,T)})}e.findFreePortFaster=D;function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(v){console.error(v)}}}),define(pe[99],ve([1,0,29,7,23]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var v;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(v||(v={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class I{constructor(L,t,n){this.exePath=L,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await a.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:w=!1}={}){return w?g===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:w=!1,findPreview:L=!1}={}){const t=E({useAlternateBitness:w});if(!t)return null;const n=R.join(t,"PowerShell");if(!await a.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const s of await a.Promises.readdir(n)){let u=-1;if(L){const A=s.indexOf("-");if(A<0)continue;const O=s.substring(0,A);if(!D.test(O)||s.substring(A+1)!=="preview")continue;u=parseInt(O,10)}else{if(!D.test(s))continue;u=parseInt(s,10)}if(u<=r)continue;const S=R.join(n,s,"pwsh.exe");!await a.SymlinkSupport.existsFile(S)||(i=S,r=u)}if(!i)return null;const l=t.includes("x86")?" (x86)":"",c=L?" Preview":"";return new I(i,`PowerShell${c}${l}`,!0)}async function p({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const L=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await a.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=w?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await a.Promises.readdir(L))if(t.test(r)){const i=R.join(L,r,"pwsh.exe");return new I(i,n)}return null}function b(){const w=R.join(y.homedir(),".dotnet","tools","pwsh.exe");return new I(w,".NET Core PowerShell Global Tool")}function o(){const w=R.join(process.env.windir,g===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(w,"Windows PowerShell",!0)}async function*d(){let w=await m();w&&(yield w),w=await m({useAlternateBitness:!0}),w&&(yield w),w=await p(),w&&(yield w),w=b(),w&&(yield w),w=await m({findPreview:!0}),w&&(yield w),w=await p({findPreview:!0}),w&&(yield w),w=await m({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=o(),w&&(yield w)}async function*h(){for await(const w of d())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=h;async function f(){for await(const w of h())return w;return null}e.getFirstAvailablePowerShellInstallation=f}),define(pe[100],ve([1,0,7,3,28,58,8,23]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function v(I=a.env){return I.comspec||"cmd.exe"}e.getWindowsShell=v;function g(I){let E=[],m=!1;const p=function(b){if(m){E.push(b);return}(!I.send(b,d=>{if(d&&console.error(d),m=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(f=>p(f))}})||R.isWindows)&&(m=!0)};return{send:p}}e.createQueuedSender=g;var T;(function(I){async function E(m,p,b){if(y.isAbsolute(m))return m;if(p===void 0&&(p=a.cwd()),y.dirname(m)!=="."||(b===void 0&&C.isString(a.env.PATH)&&(b=a.env.PATH.split(y.delimiter)),b===void 0||b.length===0))return y.join(p,m);async function d(h){if(await k.Promises.exists(h)){let f;try{f=await k.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(f=await k.Promises.lstat(h))}return f?!f.isDirectory():!1}return!1}for(const h of b){let f;if(y.isAbsolute(h)?f=y.join(h,m):f=y.join(p,h,m),await d(f))return f;let w=f+".com";if(await d(w)||(w=f+".exe",await d(w)))return w}return y.join(p,m)}I.findExecutable=E})(T=e.win32||(e.win32={}))}),define(pe[101],ve([1,0,49,13]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function a(C){return new Promise((k,v)=>{let g;const T=new Map;function I(m,p,b,o,d){const h=T.get(p);if(m===C||h){const f={name:E(b),cmd:b,pid:m,ppid:p,load:o,mem:d};T.set(m,f),m===C&&(g=f),h&&(h.children||(h.children=[]),h.children.push(f),h.children.length>1&&(h.children=h.children.sort((w,L)=>w.pid-L.pid)))}}function E(m){const p=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,h=/conhost\.exe/i,f=/--type=([a-zA-Z-]+)/;if(o.exec(m))return"electron-crash-reporter";if(d.exec(m))return"winpty-process";if(h.exec(m))return"console-window-host (Windows internal process)";let w=f.exec(m);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?p.exec(m)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const L=/[a-zA-Z-]+\.js/g;let t="";do w=L.exec(m),w&&(t+=w+" ");while(w);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(m)?`electron-nodejs (${m})`:m}if(process.platform==="win32"){const m=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,b)=>{ae(["windows-process-tree"],p,b)}).then(p=>{p.getProcessList(C,b=>{if(!b){v(new Error(`Root process ${C} not found`));return}p.getProcessCpuUsage(b,o=>{const d=new Map;o.forEach(h=>{const f=m(h.commandLine||"");d.set(h.pid,{name:E(f),cmd:f,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),g=d.get(C),g?(d.forEach(h=>{const f=d.get(h.ppid);f&&(f.children||(f.children=[]),f.children.push(h))}),d.forEach(h=>{h.children&&(h.children=h.children.sort((f,w)=>f.pid-w.pid))}),k(g)):v(new Error(`Root process ${C} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let m=function(){let p=[g];const b=[];for(;p.length;){const d=p.shift();d&&(b.push(d.pid),d.children&&(p=p.concat(d.children)))}let o=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+b.join(" "),(0,y.exec)(o,{},(d,h,f)=>{if(d||f)v(d||new Error(f.toString()));else{const w=h.toString().split(`
`);for(let L=0;L<b.length;L++){const t=T.get(b[L]);t.load=parseFloat(w[L])}if(!g){v(new Error(`Root process ${C} not found`));return}k(g)}})};(0,y.exec)("which ps",{},(p,b,o)=>{if(p||o)if(process.platform!=="linux")v(p||new Error(o.toString()));else{const d=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(d,{},(h,f,w)=>{h||w?v(h||new Error(w.toString())):(D(f,I),m())})}else{const d=b.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${d} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,w,L)=>{f||L&&!L.includes("screen size is bogus")?v(f||new Error(L.toString())):(D(w,I),process.platform==="linux"?m():g?k(g):v(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=a;function D(C,k){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=C.toString().split(`
`);for(const T of g){const I=v.exec(T.trim());I&&I.length===6&&k(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(pe[155],ve([1,0,29,3,99,100]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(I,E){return I===1?R.isWindows?T():D.getWindowsShell(E):v(I,E)}e.getSystemShell=C;let k=null;function v(I,E){if(R.isLinux&&I===2||R.isMacintosh&&I===3)return"/bin/bash";if(!k){let m;if(R.isWindows)m="/bin/bash";else{if(m=E.SHELL,!m)try{m=(0,y.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}k=m}return k}let g=null;async function T(){return g||(g=(await(0,a.getFirstAvailablePowerShellInstallation)()).exePath),g}});var Re=this&&this.__decorate||function(ae,e,y,R){var a=arguments.length,D=a<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(ae,e,y,R);else for(var k=ae.length-1;k>=0;k--)(C=ae[k])&&(D=(a<3?C(D):a>3?C(e,y,D):C(e,y))||D);return a>3&&D&&Object.defineProperty(e,y,D),D};define(pe[43],ve([1,0,18,14,15,20,90,9,6,2,61,17,8]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(m||(m={}));function p(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(b||(b={}));function o(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(d||(d={}));function h(G){let U=0;for(let Z=0;;Z+=7){const oe=G.read(1);if(U|=(oe.buffer[0]&127)<<Z,!(oe.buffer[0]&128))return U}}const f=r(0);function w(G,U){if(U===0){G.write(f);return}let Z=0;for(let me=U;me!==0;me=me>>>7)Z++;const oe=a.VSBuffer.alloc(Z);for(let me=0;U!==0;me++)oe.buffer[me]=U&127,U=U>>>7,U>0&&(oe.buffer[me]|=128);G.write(oe)}class L{constructor(U){this.b=U,this.a=0}read(U){const Z=this.b.slice(this.a,this.a+U);return this.a+=Z.byteLength,Z}}e.BufferReader=L;class t{constructor(){this.a=[]}get buffer(){return a.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var n;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(n||(n={}));function r(G){const U=a.VSBuffer.alloc(1);return U.writeUInt8(G,0),U}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},l=typeof Buffer<"u";function c(G,U){if(typeof U>"u")G.write(i.Undefined);else if(typeof U=="string"){const Z=a.VSBuffer.fromString(U);G.write(i.String),w(G,Z.byteLength),G.write(Z)}else if(l&&Buffer.isBuffer(U)){const Z=a.VSBuffer.wrap(U);G.write(i.Buffer),w(G,Z.byteLength),G.write(Z)}else if(U instanceof a.VSBuffer)G.write(i.VSBuffer),w(G,U.byteLength),G.write(U);else if(Array.isArray(U)){G.write(i.Array),w(G,U.length);for(const Z of U)c(G,Z)}else if(typeof U=="number"&&(U|0)===U)G.write(i.Uint),w(G,U);else{const Z=a.VSBuffer.fromString(JSON.stringify(U));G.write(i.Object),w(G,Z.byteLength),G.write(Z)}}e.serialize=c;function s(G){switch(G.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return G.read(h(G)).toString();case n.Buffer:return G.read(h(G)).buffer;case n.VSBuffer:return G.read(h(G));case n.Array:{const Z=h(G),oe=[];for(let me=0;me<Z;me++)oe.push(s(G));return oe}case n.Object:return JSON.parse(G.read(h(G)).toString());case n.Int:return h(G)}}e.deserialize=s;class u{constructor(U,Z,oe=null,me=1e3){this.h=U,this.j=Z,this.k=oe,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($=>this.q($)),this.m({type:200})}registerChannel(U,Z){this.b.set(U,Z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const Z=this.o([U.type]);this.k?.logOutgoing(Z,0,1,o(U.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(Z,U.id,1,o(U.type),U.data);return}}}o(U,Z=void 0){const oe=new t;return c(oe,U),c(oe,Z),this.p(oe.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const Z=new L(U),oe=s(Z),me=s(Z),$=oe[0];switch($){case 100:return this.k?.logIncoming(U.byteLength,oe[1],1,`${p($)}: ${oe[2]}.${oe[3]}`,me),this.s({type:$,id:oe[1],channelName:oe[2],name:oe[3],arg:me});case 102:return this.k?.logIncoming(U.byteLength,oe[1],1,`${p($)}: ${oe[2]}.${oe[3]}`,me),this.t({type:$,id:oe[1],channelName:oe[2],name:oe[3],arg:me});case 101:return this.k?.logIncoming(U.byteLength,oe[1],1,`${p($)}`),this.u({type:$,id:oe[1]});case 103:return this.k?.logIncoming(U.byteLength,oe[1],1,`${p($)}`),this.u({type:$,id:oe[1]})}}s(U){const Z=this.b.get(U.channelName);if(!Z){this.v(U);return}const oe=new D.CancellationTokenSource;let me;try{me=Z.call(this.j,U.name,U.arg,oe.token)}catch(N){me=Promise.reject(N)}const $=U.id;me.then(N=>{this.m({id:$,data:N,type:201}),this.d.delete(U.id)},N=>{N instanceof Error?this.m({id:$,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:$,data:N,type:203}),this.d.delete(U.id)});const W=(0,g.toDisposable)(()=>oe.cancel());this.d.set(U.id,W)}t(U){const Z=this.b.get(U.channelName);if(!Z){this.v(U);return}const oe=U.id,$=Z.listen(this.j,U.name,U.arg)(W=>this.m({id:oe,data:W,type:204}));this.d.set(U.id,$)}u(U){const Z=this.d.get(U.id);Z&&(Z.dispose(),this.d.delete(U.id))}v(U){let Z=this.g.get(U.channelName);Z||(Z=[],this.g.set(U.channelName,Z));const oe=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:U,timeoutTimer:oe})}w(U){const Z=this.g.get(U);if(Z){for(const oe of Z)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var S;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(U,Z=null){this.l=U,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=Z}getChannel(U){const Z=this;return{call(oe,me,$){return Z.a?Promise.reject(new k.CancellationError):Z.m(U,oe,me,$)},listen(oe,me){return Z.a?v.Event.None:Z.o(U,oe,me)}}}m(U,Z,oe,me=D.CancellationToken.None){const $=this.g++,N={id:$,type:100,channelName:U,name:Z,arg:oe};if(me.isCancellationRequested)return Promise.reject(new k.CancellationError);let P;return new Promise((K,te)=>{if(me.isCancellationRequested)return te(new k.CancellationError);const j=()=>{const X=x=>{switch(x.type){case 201:this.f.delete($),K(x.data);break;case 202:{this.f.delete($);const Q=new Error(x.data.message);Q.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,Q.name=x.data.name,te(Q);break}case 203:this.f.delete($),te(x.data);break}};this.f.set($,X),this.p(N)};let H=null;this.b===d.Idle?j():(H=(0,R.createCancelablePromise)(X=>this.u()),H.then(()=>{H=null,j()}));const J=()=>{H?(H.cancel(),H=null):this.p({id:$,type:101}),te(new k.CancellationError)},V=me.onCancellationRequested(J);P=(0,g.combinedDisposable)((0,g.toDisposable)(J),V),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(U,Z,oe){const me=this.g++,W={id:me,type:102,channelName:U,name:Z,arg:oe};let N=null;const P=new v.Emitter({onWillAddFirstListener:()=>{N=(0,R.createCancelablePromise)(K=>this.u()),N.then(()=>{N=null,this.d.add(P),this.p(W)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(P),this.p({id:me,type:103}))}}),M=K=>P.fire(K.data);return this.f.set(me,M),P.event}p(U){switch(U.type){case 100:case 102:{const Z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(Z,U.id,0,`${p(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const Z=this.q([U.type,U.id]);this.j?.logOutgoing(Z,U.id,0,p(U.type));return}}}q(U,Z=void 0){const oe=new t;return c(oe,U),c(oe,Z),this.r(oe.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const Z=new L(U),oe=s(Z),me=s(Z),$=oe[0];switch($){case 200:return this.j?.logIncoming(U.byteLength,0,0,o($)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,oe[1],0,o($),me),this.t({type:oe[0],id:oe[1],data:me})}}t(U){if(U.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}Re([C.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class O{get connections(){const U=[];return this.f.forEach(Z=>U.push(Z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new v.Emitter,this.onDidAddConnection=this.g.event,this.h=new v.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:Z,onDidClientDisconnect:oe})=>{v.Event.once(Z.onMessage)($=>{const W=new L($),N=s(W),P=new u(Z,N),M=new A(Z);this.a.forEach((te,j)=>P.registerChannel(j,te));const K={channelServer:P,channelClient:M,ctx:N};this.f.add(K),this.g.fire(K),oe(()=>{P.dispose(),M.dispose(),this.f.delete(K),this.h.fire(K)})})})}getChannel(U,Z){const oe=this;return{call(me,$,W){let N;if((0,E.isFunction)(Z)){const M=(0,y.getRandomElement)(oe.connections.filter(Z));N=M?Promise.resolve(M):v.Event.toPromise(v.Event.filter(oe.onDidAddConnection,Z))}else N=Z.routeCall(oe,me,$);const P=N.then(M=>M.channelClient.getChannel(U));return q(P).call(me,$,W)},listen(me,$){if((0,E.isFunction)(Z))return oe.j(U,Z,me,$);const W=Z.routeEvent(oe,me,$).then(N=>N.channelClient.getChannel(U));return q(W).listen(me,$)}}}j(U,Z,oe,me){const $=this;let W=new g.DisposableStore;const N=new v.Emitter({onWillAddFirstListener:()=>{W=new g.DisposableStore;const P=new v.EventMultiplexer,M=new Map,K=j=>{const J=j.channelClient.getChannel(U).listen(oe,me),V=P.add(J);M.set(j,V)},te=j=>{const H=M.get(j);!H||(H.dispose(),M.delete(j))};$.connections.filter(Z).forEach(K),v.Event.filter($.onDidAddConnection,Z)(K,void 0,W),$.onDidRemoveConnection(te,void 0,W),P.event(N.fire,N,W),W.add(P)},onDidRemoveLastListener:()=>{W.dispose()}});return N.event}registerChannel(U,Z){this.a.set(U,Z),this.f.forEach(oe=>{oe.channelServer.registerChannel(U,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class B{constructor(U,Z,oe=null){const me=new t;c(me,Z),U.send(me.buffer),this.a=new A(U,oe),this.d=new u(U,Z,oe)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,Z){this.d.registerChannel(U,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function q(G){return{call(U,Z,oe){return G.then(me=>me.call(U,Z,oe))},listen(U,Z){const oe=new v.Relay;return G.then(me=>oe.input=me.listen(U,Z)),oe.event}}}e.getDelayedChannel=q;function le(G){let U=!1;return{call(Z,oe,me){return U?G.call(Z,oe,me):(0,R.timeout)(0).then(()=>U=!0).then(()=>G.call(Z,oe,me))},listen(Z,oe){if(U)return G.listen(Z,oe);const me=new v.Relay;return(0,R.timeout)(0).then(()=>U=!0).then(()=>me.input=G.listen(Z,oe)),me.event}}}e.getNextTickChannel=le;class fe{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const Z of U.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await v.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=fe;var ue;(function(G){function U($,W){const N=$,P=W&&W.disableMarshalling,M=new Map;for(const K in N)oe(K)&&M.set(K,v.Event.buffer(N[K],!0));return new class{listen(K,te,j){const H=M.get(te);if(H)return H;if(me(te)){const J=N[te];if(typeof J=="function")return J.call(N,j)}throw new Error(`Event not found: ${te}`)}call(K,te,j){const H=N[te];if(typeof H=="function"){if(!P&&Array.isArray(j))for(let J=0;J<j.length;J++)j[J]=(0,T.revive)(j[J]);return H.apply(N,j)}throw new Error(`Method not found: ${te}`)}}}G.fromService=U;function Z($,W){const N=W&&W.disableMarshalling;return new Proxy({},{get(P,M){if(typeof M=="string")return W?.properties?.has(M)?W.properties.get(M):me(M)?function(K){return $.listen(M,K)}:oe(M)?$.listen(M):async function(...K){let te;W&&!(0,E.isUndefinedOrNull)(W.context)?te=[W.context,...K]:te=K;const j=await $.call(M,te);return N?j:(0,T.revive)(j)};throw new Error(`Property not found: ${String(M)}`)}})}G.toService=Z;function oe($){return $[0]==="o"&&$[1]==="n"&&I.isUpperAsciiLetter($.charCodeAt(2))}function me($){return/^onDynamic/.test($)&&I.isUpperAsciiLetter($.charCodeAt(9))}})(ue=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const U=G.toString();if(U!=="[object Object]")return U}return G}function ee(G){return Array.isArray(G)?G.map(_):_(G)}function ne(G,U,Z,oe,me,$,W){W=ee(W);const N=re[me],P=N[oe%N.length];let M=[`%c[${G}]%c[${String(U).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test($)?(M=M.concat(W),M.push(")")):M.push(W),console.log.apply(console,M)}class ie{constructor(U,Z){this.d=U,this.f=Z,this.a=0,this.b=0}logOutgoing(U,Z,oe,me,$){this.b+=U,ne(this.d,this.b,U,Z,oe,me,$)}logIncoming(U,Z,oe,me,$){this.a+=U,ne(this.f,this.a,U,Z,oe,me,$)}}e.IPCLogger=ie}),define(pe[102],ve([1,0,14,15,6,2,43]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(A){A.Created="created",A.Read="read",A.Write="write",A.Open="open",A.Error="error",A.Close="close",A.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",A.NodeEndReceived="nodeEndReceived",A.NodeEndSent="nodeEndSent",A.NodeDrainBegin="nodeDrainBegin",A.NodeDrainEnd="nodeDrainEnd",A.zlibInflateError="zlibInflateError",A.zlibInflateData="zlibInflateData",A.zlibInflateInitialWrite="zlibInflateInitialWrite",A.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",A.zlibInflateWrite="zlibInflateWrite",A.zlibInflateFlushFired="zlibInflateFlushFired",A.zlibDeflateError="zlibDeflateError",A.zlibDeflateData="zlibDeflateData",A.zlibDeflateWrite="zlibDeflateWrite",A.zlibDeflateFlushFired="zlibDeflateFlushFired",A.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",A.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",A.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",A.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",A.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",A.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",A.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",A.ProtocolHeaderRead="protocolHeaderRead",A.ProtocolMessageRead="protocolMessageRead",A.ProtocolHeaderWrite="protocolHeaderWrite",A.ProtocolMessageWrite="protocolMessageWrite",A.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var v;(function(A){A.enableDiagnostics=!1,A.records=[];const O=new WeakMap;let B=0;function q(fe,ue){if(!O.has(fe)){const re=String(++B);O.set(fe,re)}return O.get(fe)}function le(fe,ue,re,_){if(!A.enableDiagnostics)return;const ee=q(fe,ue);if(_ instanceof R.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const ne=R.VSBuffer.alloc(_.byteLength);ne.set(_),A.records.push({timestamp:Date.now(),id:ee,label:ue,type:re,buff:ne})}else A.records.push({timestamp:Date.now(),id:ee,label:ue,type:re,data:_})}A.traceSocketEvent=le})(v=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(A){A[A.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",A[A.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function I(){return T||(T=R.VSBuffer.alloc(0)),T}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,B){if(O===0)return I();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ue=this.a[0];return B&&(this.a.shift(),this.b-=O),ue}if(this.a[0].byteLength>O){const ue=this.a[0].slice(0,O);return B&&(this.a[0]=this.a[0].slice(O),this.b-=O),ue}const q=R.VSBuffer.alloc(O);let le=0,fe=0;for(;O>0;){const ue=this.a[fe];if(ue.byteLength>O){const re=ue.slice(0,O);q.set(re,le),le+=O,B&&(this.a[fe]=ue.slice(O),this.b-=O),O-=O}else q.set(ue,le),le+=ue.byteLength,B?(this.a.shift(),this.b-=ue.byteLength):fe++,O-=ue.byteLength}return q}}e.ChunkStream=E;var m;(function(A){A[A.None=0]="None",A[A.Regular=1]="Regular",A[A.Control=2]="Control",A[A.Ack=3]="Ack",A[A.Disconnect=5]="Disconnect",A[A.ReplayRequest=6]="ReplayRequest",A[A.Pause=7]="Pause",A[A.Resume=8]="Resume",A[A.KeepAlive=9]="KeepAlive",A[A.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",A[A.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(m||(m={}));function p(A){switch(A){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(A){A[A.HeaderLength=13]="HeaderLength",A[A.AcknowledgeTime=2e3]="AcknowledgeTime",A[A.TimeoutTime=2e4]="TimeoutTime",A[A.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",A[A.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",A[A.KeepAliveSendTime=5e3]="KeepAliveSendTime",A[A.LatencySampleTime=6e4]="LatencySampleTime",A[A.LatencySampleCount=5]="LatencySampleCount",A[A.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",A[A.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(O,B,q,le){this.type=O,this.id=B,this.ack=q,this.data=le,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends D.Disposable{constructor(O){super(),this.f=this.B(new a.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new E,this.B(this.a.onData(B=>this.acceptChunk(B))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const B=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=B.readUInt32BE(9),this.g.messageType=B.readUInt8(0),this.g.id=B.readUInt32BE(1),this.g.ack=B.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const q=this.g.messageType,le=this.g.id,fe=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",B),this.f.fire(new o(q,le,fe,B)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const B=R.VSBuffer.alloc(13);B.writeUInt8(O.type,0),B.writeUInt32BE(O.id,1),B.writeUInt32BE(O.ack,5),B.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(B,O.data)}g(O,B){const q=this.f===0;return this.d.push(O,B),this.f+=O.byteLength+B.byteLength,q}h(){const O=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,B){this.g(O,B)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class f extends D.Disposable{constructor(O){super(),this.f=new a.Emitter,this.onMessage=this.f.event,this.g=new a.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(B=>{B.type===1&&this.f.fire(B.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new o(1,0,0,O))}}e.Protocol=f;class w extends C.IPCClient{static fromSocket(O,B){return new w(new f(O),B)}get onDidDispose(){return this.b.onDidDispose}constructor(O,B,q=null){super(O,B,q),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=w;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class t{constructor(O){this.data=O,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let O=0,B=this.a;for(;B;)B=B.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let B=0,q=this.a;for(;q;)O[B++]=q.data,q=q.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const B=new t(O);if(!this.a){this.a=B,this.b=B;return}this.b.next=B,this.b=B}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const O=Date.now();for(let B=0;B<r.a;B++)this.c[B]=O-1e3*B;setInterval(()=>{for(let B=r.a;B>=1;B--)this.c[B]=this.c[B-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),B=(1+r.a)*1e3;let q=0;for(let le=0;le<r.a;le++)O-this.c[le]<=B&&q++;return 1-q/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var i;(function(A){A[A.Good=0]="Good",A[A.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function l(A){switch(A){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class c{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=c;class s{constructor(O,B){this.roundTripTime=O,this.recentHighRoundTripCount=B}}e.HighRoundTripTimeEvent=s;class u{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??r.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=O.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(B=>this.E(B))),this.t.add(this.o.onClose(B=>this.A.fire(B))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(B=>this.J(B))),this.t.add(this.r.onHighRoundTripTime(B=>this.C.fire(B))),this.t.add(this.r.onDidChangeConnectionHealth(B=>this.D.fire(B))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new o(5,0,0,I());this.p.write(O),this.p.flush()}sendPause(){const O=new o(7,0,0,I());this.p.write(O)}sendResume(){const O=new o(8,0,0,I());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,B){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(q=>this.E(q))),this.t.add(this.o.onClose(q=>this.A.fire(q))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(q=>this.J(q))),this.t.add(this.r.onHighRoundTripTime(q=>this.C.fire(q))),this.t.add(this.r.onDidChangeConnectionHealth(q=>this.D.fire(q))),this.q.acceptChunk(B)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new o(3,0,this.h,I());this.p.write(O);const B=this.b.toArray();for(let q=0,le=B.length;q<le;q++)this.p.write(B[q]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const B=this.b.peek();if(B&&B.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const B=Date.now();B-this.m>1e4&&(this.m=B,this.p.write(new o(6,0,0,I())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const B=this.b.toArray();for(let q=0,le=B.length;q<le;q++)this.p.write(B[q]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const B=++this.c;this.h=this.g;const q=new o(1,B,this.h,O);this.b.push(q),this.a||(this.p.write(q),this.G())}sendControl(O){const B=new o(2,0,0,O);this.p.write(B)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),B=Date.now()-O.writtenTime,q=Date.now()-this.q.lastReadTime,le=Date.now()-this.n;if(B>=2e4&&q>=2e4&&le>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:B,timeSinceLastReceivedSomeData:q});return}const fe=Math.max(2e4-B,2e4-q,2e4-le,500);this.f=setTimeout(()=>{this.f=null,this.G()},fe)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new o(3,0,this.h,I());this.p.write(O)}I(){this.h=this.g;const O=new o(9,0,this.h,I());this.p.write(O)}J(O){this.h=this.g;const B=new o(10,0,this.h,O);this.p.write(B)}K(O){this.h=this.g;const B=new o(11,0,this.h,O);this.p.write(B)}}e.PersistentProtocol=u;class S extends D.Disposable{constructor(){super(),this.a=this.B(new a.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new a.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new a.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new y.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,B=R.VSBuffer.alloc(4);B.writeUInt32BE(O,0),this.a.fire(B)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const B=O.readUInt32BE(0);if(this.g<=0||B!==this.h)return;const q=Date.now()-this.g,le=this.k++;this.j[le%this.j.length]=q;const fe=this.l,ue=this.j.filter(re=>re>=1e3).length;this.l=ue>=3?1:0,q>1e3&&this.b.fire(new s(q,ue)),fe!==this.l&&this.c.fire(this.l)}}}),define(pe[103],ve([1,0,49,14,15,20,148,9,6,2,22,100,58,43]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends m.ChannelServer{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",h=>a.VSBuffer.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=p;class b{constructor(d,h){this.i=d,this.j=h,this.c=new Set,this.g=new Map,this.h=new v.Emitter,this.onDidProcessExit=this.h.event;const f=h&&h.timeout?h.timeout:6e4;this.b=new R.Delayer(f),this.d=null,this.f=null}getChannel(d){const h=this;return{call(f,w,L){return h.k(d,f,w,L)},listen(f,w){return h.l(d,f,w)}}}k(d,h,f,w=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const L=this.n(d),t=(0,R.createCancelablePromise)(i=>L.call(h,f,i)),n=w.onCancellationRequested(()=>t.cancel()),r=(0,g.toDisposable)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,h,f){if(!this.b)return v.Event.None;this.b.cancel();let w;const L=new v.Emitter({onWillAddFirstListener:()=>{w=this.n(d).listen(h,f)(L.fire,L),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(h.env),this.d=(0,y.fork)(this.i,d,h);const f=new v.Emitter;v.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,C.isRemoteConsoleLog)(l)){(0,C.log)(l,`IPC Library: ${this.j.serverName}`);return}f.fire(a.VSBuffer.wrap(Buffer.from(l,"base64")))});const L=this.j.useQueue?(0,I.createQueuedSender)(this.d):this.d,t=l=>this.d&&this.d.connected&&L.send(l.buffer.toString("base64")),n=f.event,r={send:t,onMessage:n};this.f=new m.ChannelClient(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,c)=>{process.removeListener("exit",i),this.c.forEach(s=>(0,g.dispose)(s)),this.c.clear(),l!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:c})})}return this.f}n(d){let h=this.g.get(d);return h||(h=this.m.getChannel(d),this.g.set(d,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(pe[62],ve([1,0,15,9,6,2,7,3,21,43,102]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(s,u){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,u)}constructor(s,u=""){this.f=!0,this.debugLabel=u,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,R.onUnexpectedError)(S)}},this.socket.on("error",this.a),this.b=S=>{this.traceSocketEvent("close",{hadError:S}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const u=S=>{this.traceSocketEvent("read",S),s(y.VSBuffer.wrap(S))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(s){const u=S=>{s({type:0,hadError:S,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(s){const u=()=>{s()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,R.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,R.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=E;var m;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize",c[c.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var p;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(p||(p={}));class b extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,u){this.socket.traceSocketEvent(s,u)}constructor(s,u,S,A){super(),this.f=this.B(new a.Emitter),this.g=this.B(new a.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:S?.byteLength||0,recordInflateBytes:A}),this.a=this.B(new o(this,u,S,A,this.f,(O,B)=>this.k(O,B))),this.B(this.a.onError(O=>{console.error(O),(0,R.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new T.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await a.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){let u=0;for(;u<s.byteLength;)this.a.writeMessage(s.slice(u,Math.min(u+262144,s.byteLength))),u+=262144}k(s,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let S=2;s.byteLength<126?S+=0:s.byteLength<2**16?S+=2:S+=8;const A=y.VSBuffer.alloc(S);if(u?A.writeUInt8(194,0):A.writeUInt8(130,0),s.byteLength<126)A.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(s.byteLength>>>8&255,++O),A.writeUInt8(s.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(s.byteLength>>>24&255,++O),A.writeUInt8(s.byteLength>>>16&255,++O),A.writeUInt8(s.byteLength>>>8&255,++O),A.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(y.VSBuffer.concat([A,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),S=u.readUInt8(0),A=(S&128)>>>7,O=(S&64)>>>6,B=u.readUInt8(1),q=(B&128)>>>7,le=B&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=A,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(A),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),S=u.readUInt8(1),A=(S&128)>>>7;let O=S&127,B=1;O===126?O=u.readUInt8(++B)*2**8+u.readUInt8(++B):O===127&&(O=u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*0+u.readUInt8(++B)*2**24+u.readUInt8(++B)*2**16+u.readUInt8(++B)*2**8+u.readUInt8(++B));let q=0;A&&(q=u.readUInt8(++B)*2**24+u.readUInt8(++B)*2**16+u.readUInt8(++B)*2**8+u.readUInt8(++B)),this.j.state=3,this.j.readLen=O,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),f(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await a.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class o extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:y.VSBuffer.alloc(0)}constructor(s,u,S,A,O,B){super(),this.l=s,this.m=O,this.n=B,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new a.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new a.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,u?(this.b=this.B(new d(this.l,A,S,{windowBits:15})),this.f=this.B(new h(this.l,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const u=await this.s(this.f,s);this.n(u,!0)}else this.n(s,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(s,u){return new Promise((S,A)=>{s.write(u),s.flush(O=>S(O))})}acceptFrame(s,u,S){this.h.push({data:s,isCompressed:u,isLastFrameOfMessage:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const u=await this.w(this.b,s.data,s.isLastFrameOfMessage);this.m.fire(u)}else this.m.fire(s.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(s,u,S){return new Promise((A,O)=>{s.write(u),S&&s.write(y.VSBuffer.fromByteArray([0,0,255,255])),s.flush(B=>A(B))})}}class d extends D.Disposable{get recordedInflateBytes(){return this.j?y.VSBuffer.concat(this.f):y.VSBuffer.alloc(0)}constructor(s,u,S,A){super(),this.h=s,this.j=u,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=I().zlib.createInflateRaw(A),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(y.VSBuffer.wrap(O))}),S&&(this.h.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this.b.write(S.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=y.VSBuffer.concat(this.g);this.g.length=0,s(u)})}}class h extends D.Disposable{constructor(s,u){super(),this.g=s,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.b=I().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",S=>{this.g.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.g.traceSocketEvent("zlibDeflateData",S),this.f.push(y.VSBuffer.wrap(S))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=y.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),s(u)})}}function f(c,s){if(s===0)return;const u=c.byteLength>>>2;for(let le=0;le<u;le++){const fe=c.readUInt32BE(le*4);c.writeUInt32BE(fe^s,le*4)}const S=u*4,A=c.byteLength-S,O=s>>>24&255,B=s>>>16&255,q=s>>>8&255;A>=1&&c.writeUInt8(c.readUInt8(S)^O,S),A>=2&&c.writeUInt8(c.readUInt8(S+1)^B,S+1),A>=3&&c.writeUInt8(c.readUInt8(S+2)^q,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const w={[2]:107,[1]:103};function L(){const c=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;const s=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:I().os.tmpdir(),u=(0,C.join)(s,`vscode-ipc-${c}.sock`);return n(u),u}e.createRandomIPCHandle=L;function t(c,s,u){const S=I().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${u}-${s}-sock`;const A=u.substr(0,4),O=s.substr(0,6),B=S.substr(0,8);let q;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?q=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${B}-${A}-${O}.sock`):q=(0,C.join)(c,`${A}-${O}.sock`),n(q),q}e.createStaticIPCHandle=t;function n(c){const s=w[k.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{static b(s){const u=a.Event.fromNodeEventEmitter(s,"connection");return a.Event.map(u,S=>({protocol:new T.Protocol(new E(S,"ipc-server-connection")),onDidClientDisconnect:a.Event.once(a.Event.fromNodeEventEmitter(S,"close"))}))}constructor(s){super(r.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function i(c){return new Promise((s,u)=>{const S=I().net.createServer();S.on("error",u),S.listen(c,()=>{S.removeListener("error",u),s(new r(S))})})}e.serve=i;function l(c,s){return new Promise((u,S)=>{const A=I().net.createConnection(c,()=>{A.removeListener("error",S),u(T.Client.fromSocket(new E(A,`ipc-client${s}`),s))});A.once("error",S)})}e.connect=l}),define(pe[156],ve([1,0,14,6,2,8]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",I[I.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function k(I){const E=I;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var v;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class g extends a.Disposable{constructor(E,m=Object.create(null)){super(),this.m=E,this.n=m,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=new y.ThrottledDelayer(g.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((m,p)=>this.s(p,m)),E.deleted?.forEach(m=>this.s(m,void 0))}s(E,m){if(this.c===v.Closed)return;let p=!1;(0,D.isUndefinedOrNull)(m)?p=this.f.delete(E):this.f.get(E)!==m&&(this.f.set(E,m),p=!0),p&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,m){const p=this.f.get(E);return(0,D.isUndefinedOrNull)(p)?m:p}getBoolean(E,m){const p=this.get(E);return(0,D.isUndefinedOrNull)(p)?m:p==="true"}getNumber(E,m){const p=this.get(E);return(0,D.isUndefinedOrNull)(p)?m:parseInt(p,10)}async set(E,m){if(this.c===v.Closed)return;if((0,D.isUndefinedOrNull)(m))return this.delete(E);const p=String(m);if(this.f.get(E)!==p)return this.f.set(E,p),this.j.set(E,p),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===v.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=v.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(!!this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(!!this.u)return new Promise(E=>this.l.push(E))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}g.a=100,e.Storage=g;class T{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((m,p)=>this.a.set(p,m)),E.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=T}),define(pe[104],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(a,D){this.lineNumber=a,this.column=D}with(a=this.lineNumber,D=this.column){return a===this.lineNumber&&D===this.column?this:new y(a,D)}delta(a=0,D=0){return this.with(this.lineNumber+a,this.column+D)}equals(a){return y.equals(this,a)}static equals(a,D){return!a&&!D?!0:!!a&&!!D&&a.lineNumber===D.lineNumber&&a.column===D.column}isBefore(a){return y.isBefore(this,a)}static isBefore(a,D){return a.lineNumber<D.lineNumber?!0:D.lineNumber<a.lineNumber?!1:a.column<D.column}isBeforeOrEqual(a){return y.isBeforeOrEqual(this,a)}static isBeforeOrEqual(a,D){return a.lineNumber<D.lineNumber?!0:D.lineNumber<a.lineNumber?!1:a.column<=D.column}static compare(a,D){const C=a.lineNumber|0,k=D.lineNumber|0;if(C===k){const v=a.column|0,g=D.column|0;return v-g}return C-k}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(a){return new y(a.lineNumber,a.column)}static isIPosition(a){return a&&typeof a.lineNumber=="number"&&typeof a.column=="number"}}e.Position=y}),define(pe[50],ve([1,0,104]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(D,C,k,v){D>k||D===k&&C>v?(this.startLineNumber=k,this.startColumn=v,this.endLineNumber=D,this.endColumn=C):(this.startLineNumber=D,this.startColumn=C,this.endLineNumber=k,this.endColumn=v)}isEmpty(){return R.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return R.containsPosition(this,D)}static containsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<D.startColumn||C.lineNumber===D.endLineNumber&&C.column>D.endColumn)}static strictContainsPosition(D,C){return!(C.lineNumber<D.startLineNumber||C.lineNumber>D.endLineNumber||C.lineNumber===D.startLineNumber&&C.column<=D.startColumn||C.lineNumber===D.endLineNumber&&C.column>=D.endColumn)}containsRange(D){return R.containsRange(this,D)}static containsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>D.endColumn)}strictContainsRange(D){return R.strictContainsRange(this,D)}static strictContainsRange(D,C){return!(C.startLineNumber<D.startLineNumber||C.endLineNumber<D.startLineNumber||C.startLineNumber>D.endLineNumber||C.endLineNumber>D.endLineNumber||C.startLineNumber===D.startLineNumber&&C.startColumn<=D.startColumn||C.endLineNumber===D.endLineNumber&&C.endColumn>=D.endColumn)}plusRange(D){return R.plusRange(this,D)}static plusRange(D,C){let k,v,g,T;return C.startLineNumber<D.startLineNumber?(k=C.startLineNumber,v=C.startColumn):C.startLineNumber===D.startLineNumber?(k=C.startLineNumber,v=Math.min(C.startColumn,D.startColumn)):(k=D.startLineNumber,v=D.startColumn),C.endLineNumber>D.endLineNumber?(g=C.endLineNumber,T=C.endColumn):C.endLineNumber===D.endLineNumber?(g=C.endLineNumber,T=Math.max(C.endColumn,D.endColumn)):(g=D.endLineNumber,T=D.endColumn),new R(k,v,g,T)}intersectRanges(D){return R.intersectRanges(this,D)}static intersectRanges(D,C){let k=D.startLineNumber,v=D.startColumn,g=D.endLineNumber,T=D.endColumn;const I=C.startLineNumber,E=C.startColumn,m=C.endLineNumber,p=C.endColumn;return k<I?(k=I,v=E):k===I&&(v=Math.max(v,E)),g>m?(g=m,T=p):g===m&&(T=Math.min(T,p)),k>g||k===g&&v>T?null:new R(k,v,g,T)}equalsRange(D){return R.equalsRange(this,D)}static equalsRange(D,C){return!D&&!C?!0:!!D&&!!C&&D.startLineNumber===C.startLineNumber&&D.startColumn===C.startColumn&&D.endLineNumber===C.endLineNumber&&D.endColumn===C.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(D){return new y.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(D){return new y.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,C){return new R(this.startLineNumber,this.startColumn,D,C)}setStartPosition(D,C){return new R(D,C,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(D){return new R(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(D){return new R(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new R(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,C=D){return new R(D.lineNumber,D.column,C.lineNumber,C.column)}static lift(D){return D?new R(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<D.startColumn)}static areIntersecting(D,C){return!(D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<=C.startColumn||C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,C){if(D&&C){const g=D.startLineNumber|0,T=C.startLineNumber|0;if(g===T){const I=D.startColumn|0,E=C.startColumn|0;if(I===E){const m=D.endLineNumber|0,p=C.endLineNumber|0;if(m===p){const b=D.endColumn|0,o=C.endColumn|0;return b-o}return m-p}return I-E}return g-T}return(D?1:0)-(C?1:0)}static compareRangesUsingEnds(D,C){return D.endLineNumber===C.endLineNumber?D.endColumn===C.endColumn?D.startLineNumber===C.startLineNumber?D.startColumn-C.startColumn:D.startLineNumber-C.startLineNumber:D.endColumn-C.endColumn:D.endLineNumber-C.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.Range=R}),define(pe[157],ve([1,0,6,2]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class a{constructor(){this.a=new Map,this.b=new Map,this.c=new y.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(k){this.c.fire({changedLanguages:k,changedColorMap:!1})}register(k,v){return this.a.set(k,v),this.handleChange([k]),(0,R.toDisposable)(()=>{this.a.get(k)===v&&(this.a.delete(k),this.handleChange([k]))})}get(k){return this.a.get(k)||null}registerFactory(k,v){this.b.get(k)?.dispose();const g=new D(this,k,v);return this.b.set(k,g),(0,R.toDisposable)(()=>{const T=this.b.get(k);!T||T!==g||(this.b.delete(k),T.dispose())})}async getOrCreate(k){const v=this.get(k);if(v)return v;const g=this.b.get(k);return!g||g.isResolved?null:(await g.resolve(),this.get(k))}isResolved(k){if(this.get(k))return!0;const g=this.b.get(k);return!!(!g||g.isResolved)}setColorMap(k){this.d=k,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=a;class D extends R.Disposable{get isResolved(){return this.c}constructor(k,v,g){super(),this.f=k,this.g=v,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const k=await this.h.tokenizationSupport;this.c=!0,k&&!this.a&&this.B(this.f.register(this.g,k))}}}),define(pe[158],ve([1,0,47,4,50,157]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(A,O,B){this.offset=A,this.type=O,this.language=B,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class k{constructor(A,O){this.tokens=A,this.endState=O,this._tokenizationResultBrand=void 0}}e.TokenizationResult=k;class v{constructor(A,O){this.tokens=A,this.endState=O,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=v;var g;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(S){const A=new Map;A.set(0,y.Codicon.symbolMethod),A.set(1,y.Codicon.symbolFunction),A.set(2,y.Codicon.symbolConstructor),A.set(3,y.Codicon.symbolField),A.set(4,y.Codicon.symbolVariable),A.set(5,y.Codicon.symbolClass),A.set(6,y.Codicon.symbolStruct),A.set(7,y.Codicon.symbolInterface),A.set(8,y.Codicon.symbolModule),A.set(9,y.Codicon.symbolProperty),A.set(10,y.Codicon.symbolEvent),A.set(11,y.Codicon.symbolOperator),A.set(12,y.Codicon.symbolUnit),A.set(13,y.Codicon.symbolValue),A.set(15,y.Codicon.symbolEnum),A.set(14,y.Codicon.symbolConstant),A.set(15,y.Codicon.symbolEnum),A.set(16,y.Codicon.symbolEnumMember),A.set(17,y.Codicon.symbolKeyword),A.set(27,y.Codicon.symbolSnippet),A.set(18,y.Codicon.symbolText),A.set(19,y.Codicon.symbolColor),A.set(20,y.Codicon.symbolFile),A.set(21,y.Codicon.symbolReference),A.set(22,y.Codicon.symbolCustomColor),A.set(23,y.Codicon.symbolFolder),A.set(24,y.Codicon.symbolTypeParameter),A.set(25,y.Codicon.account),A.set(26,y.Codicon.issues);function O(le){let fe=A.get(le);return fe||(console.info("No codicon found for CompletionItemKind "+le),fe=y.Codicon.symbolProperty),fe}S.toIcon=O;const B=new Map;B.set("method",0),B.set("function",1),B.set("constructor",2),B.set("field",3),B.set("variable",4),B.set("class",5),B.set("struct",6),B.set("interface",7),B.set("module",8),B.set("property",9),B.set("event",10),B.set("operator",11),B.set("unit",12),B.set("value",13),B.set("constant",14),B.set("enum",15),B.set("enum-member",16),B.set("enumMember",16),B.set("keyword",17),B.set("snippet",27),B.set("text",18),B.set("color",19),B.set("file",20),B.set("reference",21),B.set("customcolor",22),B.set("folder",23),B.set("type-parameter",24),B.set("typeParameter",24),B.set("account",25),B.set("issue",26);function q(le,fe){let ue=B.get(le);return typeof ue>"u"&&!fe&&(ue=9),ue}S.fromString=q})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(S){S[S.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var p;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(p=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function h(S){return S&&R.URI.isUri(S.uri)&&a.Range.isIRange(S.range)&&(a.Range.isIRange(S.originSelectionRange)||a.Range.isIRange(S.targetSelectionRange))}e.isLocationLink=h;var f;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var w;(function(S){S[S.Deprecated=1]="Deprecated"})(w=e.SymbolTag||(e.SymbolTag={}));var L;(function(S){const A=new Map;A.set(0,y.Codicon.symbolFile),A.set(1,y.Codicon.symbolModule),A.set(2,y.Codicon.symbolNamespace),A.set(3,y.Codicon.symbolPackage),A.set(4,y.Codicon.symbolClass),A.set(5,y.Codicon.symbolMethod),A.set(6,y.Codicon.symbolProperty),A.set(7,y.Codicon.symbolField),A.set(8,y.Codicon.symbolConstructor),A.set(9,y.Codicon.symbolEnum),A.set(10,y.Codicon.symbolInterface),A.set(11,y.Codicon.symbolFunction),A.set(12,y.Codicon.symbolVariable),A.set(13,y.Codicon.symbolConstant),A.set(14,y.Codicon.symbolString),A.set(15,y.Codicon.symbolNumber),A.set(16,y.Codicon.symbolBoolean),A.set(17,y.Codicon.symbolArray),A.set(18,y.Codicon.symbolObject),A.set(19,y.Codicon.symbolKey),A.set(20,y.Codicon.symbolNull),A.set(21,y.Codicon.symbolEnumMember),A.set(22,y.Codicon.symbolStruct),A.set(23,y.Codicon.symbolEvent),A.set(24,y.Codicon.symbolOperator),A.set(25,y.Codicon.symbolTypeParameter);function O(B){let q=A.get(B);return q||(console.info("No codicon found for SymbolKind "+B),q=y.Codicon.symbolProperty),q}S.toIcon=O})(L=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(A){switch(A){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(A)}constructor(A){this.value=A}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var n;(function(S){function A(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}S.is=A})(n=e.Command||(e.Command={}));var r;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={}));class s{constructor(A){this.b=A,this.a=null}dispose(){this.a&&this.a.then(A=>{A&&A.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=s,e.TokenizationRegistry=new D.TokenizationRegistry;var u;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(u=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[159],ve([10,11]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(pe[160],ve([1,0,6,2,159]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class D extends R.Disposable{constructor(E,m="",p="",b=!0,o){super(),this.j=this.B(new y.Emitter),this.onDidChange=this.j.event,this.z=!0,this.m=E,this.n=m,this.w=p,this.z=b,this.D=o}get id(){return this.m}get label(){return this.n}set label(E){this.F(E)}F(E){this.n!==E&&(this.n=E,this.j.fire({label:E}))}get tooltip(){return this.u||""}set tooltip(E){this.G(E)}G(E){this.u!==E&&(this.u=E,this.j.fire({tooltip:E}))}get class(){return this.w}set class(E){this.H(E)}H(E){this.w!==E&&(this.w=E,this.j.fire({class:E}))}get enabled(){return this.z}set enabled(E){this.I(E)}I(E){this.z!==E&&(this.z=E,this.j.fire({enabled:E}))}get checked(){return this.C}set checked(E){this.J(E)}J(E){this.C!==E&&(this.C=E,this.j.fire({checked:E}))}async run(E,m){this.D&&await this.D(E)}}e.Action=D;class C extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new y.Emitter),this.onWillRun=this.f.event,this.h=this.B(new y.Emitter),this.onDidRun=this.h.event}async run(E,m){if(!E.enabled)return;this.f.fire({action:E});let p;try{await this.k(E,m)}catch(b){p=b}this.h.fire({action:E,error:p})}async k(E,m){await E.run(m)}}e.ActionRunner=C;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...E){let m=[];for(const p of E)p.length&&(m.length?m=[...m,new k,...p]:m=p);return m}async run(){}}k.ID="vs.actions.separator",e.Separator=k;class v{get actions(){return this.a}constructor(E,m,p,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=E,this.label=m,this.class=b,this.a=p}async run(){}}e.SubmenuAction=v;class g extends D{constructor(){super(g.ID,a.localize(0,null),void 0,!1)}}g.ID="vs.actions.empty",e.EmptySubmenuAction=g;function T(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=T}),define(pe[161],ve([10,11]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(pe[162],ve([1,0,161]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,a=R*60,D=a*24,C=D*7,k=D*30,v=D*365;function g(I,E,m,p){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,y.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!p&&b<30)return(0,y.localize)(1,null);let o;return b<R?(o=b,E?o===1?m?(0,y.localize)(2,null,o):(0,y.localize)(3,null,o):m?(0,y.localize)(4,null,o):(0,y.localize)(5,null,o):o===1?m?(0,y.localize)(6,null,o):(0,y.localize)(7,null,o):m?(0,y.localize)(8,null,o):(0,y.localize)(9,null,o)):b<a?(o=Math.floor(b/R),E?o===1?m?(0,y.localize)(10,null,o):(0,y.localize)(11,null,o):m?(0,y.localize)(12,null,o):(0,y.localize)(13,null,o):o===1?m?(0,y.localize)(14,null,o):(0,y.localize)(15,null,o):m?(0,y.localize)(16,null,o):(0,y.localize)(17,null,o)):b<D?(o=Math.floor(b/a),E?o===1?m?(0,y.localize)(18,null,o):(0,y.localize)(19,null,o):m?(0,y.localize)(20,null,o):(0,y.localize)(21,null,o):o===1?m?(0,y.localize)(22,null,o):(0,y.localize)(23,null,o):m?(0,y.localize)(24,null,o):(0,y.localize)(25,null,o)):b<C?(o=Math.floor(b/D),E?o===1?(0,y.localize)(26,null,o):(0,y.localize)(27,null,o):o===1?(0,y.localize)(28,null,o):(0,y.localize)(29,null,o)):b<k?(o=Math.floor(b/C),E?o===1?m?(0,y.localize)(30,null,o):(0,y.localize)(31,null,o):m?(0,y.localize)(32,null,o):(0,y.localize)(33,null,o):o===1?m?(0,y.localize)(34,null,o):(0,y.localize)(35,null,o):m?(0,y.localize)(36,null,o):(0,y.localize)(37,null,o)):b<v?(o=Math.floor(b/k),E?o===1?m?(0,y.localize)(38,null,o):(0,y.localize)(39,null,o):m?(0,y.localize)(40,null,o):(0,y.localize)(41,null,o):o===1?m?(0,y.localize)(42,null,o):(0,y.localize)(43,null,o):m?(0,y.localize)(44,null,o):(0,y.localize)(45,null,o)):(o=Math.floor(b/v),E?o===1?m?(0,y.localize)(46,null,o):(0,y.localize)(47,null,o):m?(0,y.localize)(48,null,o):(0,y.localize)(49,null,o):o===1?m?(0,y.localize)(50,null,o):(0,y.localize)(51,null,o):m?(0,y.localize)(52,null,o):(0,y.localize)(53,null,o))}e.fromNow=g;function T(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(pe[163],ve([10,11]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(pe[39],ve([1,0,18,8,163]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(I,E){return E&&(I.stack||I.stacktrace)?a.localize(0,null,k(I),C(I.stack)||C(I.stacktrace)):k(I)}function C(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?a.localize(1,null,I.message):I.message||a.localize(2,null)}function v(I=null,E=!1){if(!I)return a.localize(3,null);if(Array.isArray(I)){const m=y.coalesce(I),p=v(m[0],E);return m.length>1?a.localize(4,null,p,m.length):p}if(R.isString(I))return I;if(I.detail){const m=I.detail;if(m.error)return D(m.error,E);if(m.exception)return D(m.exception,E)}return I.stack?D(I,E):I.message?I.message:a.localize(5,null)}e.toErrorMessage=v;function g(I){const E=I;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=g;function T(I,E){let m;return typeof I=="string"?m=new Error(I):m=I,m.actions=E,m}e.createErrorWithActions=T}),define(pe[164],ve([10,11]),function(ae,e){return ae.create("vs/base/common/jsonErrorMessages",e)}),define(pe[165],ve([1,0,164]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(a){switch(a){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(pe[166],ve([10,11]),function(ae,e){return ae.create("vs/base/node/zip",e)}),define(pe[167],ve([10,11]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[168],ve([10,11]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[169],ve([10,11]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(pe[170],ve([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(pe[171],ve([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argvHelper",e)}),define(pe[172],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[173],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[174],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[175],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[176],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[177],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[178],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[179],ve([10,11]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[180],ve([10,11]),function(ae,e){return ae.create("vs/platform/files/common/fileService",e)}),define(pe[181],ve([10,11]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(pe[182],ve([10,11]),function(ae,e){return ae.create("vs/platform/files/common/io",e)}),define(pe[183],ve([10,11]),function(ae,e){return ae.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[184],ve([10,11]),function(ae,e){return ae.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[185],ve([10,11]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(pe[186],ve([10,11]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(pe[187],ve([10,11]),function(ae,e){return ae.create("vs/platform/shell/node/shellEnv",e)}),define(pe[188],ve([10,11]),function(ae,e){return ae.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[189],ve([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[190],ve([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[191],ve([10,11]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[192],ve([10,11]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(pe[193],ve([10,11]),function(ae,e){return ae.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[194],ve([10,11]),function(ae,e){return ae.create("vs/server/node/serverEnvironmentService",e)}),define(pe[195],ve([10,11]),function(ae,e){return ae.create("vs/server/node/serverServices",e)}),define(pe[196],ve([10,11]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[197],ve([10,11]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(pe[198],ve([10,11]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[199],ve([10,11]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[200],ve([1,0,9,169]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var a;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(a=e.TokenType||(e.TokenType={}));function D(...g){switch(g.length){case 1:return(0,R.localize)(0,null,g[0]);case 2:return(0,R.localize)(1,null,g[0],g[1]);case 3:return(0,R.localize)(2,null,g[0],g[1],g[2]);default:return}}const C=(0,R.localize)(3,null),k=(0,R.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,y.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const I=this.d,E=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:E};this.g.push({offset:I,lexeme:E,additionalInfo:T}),this.f.push(m)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const I=this.c.substring(this.d,this.e),E=v.b.get(I);E?this.k(E):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,I=!1,E=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(k);return}const p=this.c.charCodeAt(T);if(I)I=!1;else if(p===47&&!E){T++;break}else p===91?E=!0:p===92?I=!0:p===93&&(E=!1);T++}for(;T<this.c.length&&v.a.has(this.c.charCodeAt(T));)T++;this.e=T;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}v.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=v}),define(pe[201],ve([1,0,6,2]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class a{constructor(){this.a=new y.Emitter,this.b=new y.Emitter,this.c=new y.Emitter,this.d=new y.Emitter}call(k,v,g){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(k,v,g){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}a.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=a;class D extends R.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,v,g){this.b.call("attach",[k,v,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,v){this.b.call("terminate",[k,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,v){return this.b.call("openExtensionDevelopmentHostWindow",[k,v])}}e.ExtensionHostDebugChannelClient=D}),define(pe[202],ve([1,0,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class R{constructor(C){this.a=C}listen(C,k,v){throw new Error("Invalid listen")}call(C,k,v){switch(k){case"download":return this.a.download(y.URI.revive(v[0]),y.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=R;class a{constructor(C,k){this.a=C,this.b=k}async download(C,k){const v=this.b();v&&(C=v.transformOutgoingURI(C),k=v.transformOutgoingURI(k)),await this.a.call("download",[C,k])}}e.DownloadServiceChannelClient=a}),define(pe[203],ve([1,0,162,90,13,7,28,19,4]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,D.dirname)(a.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(v.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.join)(m,"argv.json")):(0,k.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(a.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?v.URI.file((0,D.resolve)(m)):v.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const b=C.env.VSCODE_PORTABLE;return b?(0,D.join)(b,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(p=>/^[^:/?#]+?:\/\//.test(p)?v.URI.parse(p):v.URI.file((0,D.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const p of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);b&&b[1]&&b[2]&&m.push([b[1],b[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=C.env.VSCODE_PORTABLE;return m?v.URI.file((0,D.join)(m,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,p,b){this.a=m,this.b=p,this.c=b,this.editSessionId=this.args.editSessionId}}Re([R.memoize],g.prototype,"appRoot",null),Re([R.memoize],g.prototype,"userHome",null),Re([R.memoize],g.prototype,"userDataPath",null),Re([R.memoize],g.prototype,"appSettingsHome",null),Re([R.memoize],g.prototype,"tmpDir",null),Re([R.memoize],g.prototype,"cacheHome",null),Re([R.memoize],g.prototype,"stateResource",null),Re([R.memoize],g.prototype,"userRoamingDataHome",null),Re([R.memoize],g.prototype,"userDataSyncHome",null),Re([R.memoize],g.prototype,"sync",null),Re([R.memoize],g.prototype,"machineSettingsResource",null),Re([R.memoize],g.prototype,"workspaceStorageHome",null),Re([R.memoize],g.prototype,"localHistoryHome",null),Re([R.memoize],g.prototype,"keyboardLayoutResource",null),Re([R.memoize],g.prototype,"argvResource",null),Re([R.memoize],g.prototype,"isExtensionDevelopment",null),Re([R.memoize],g.prototype,"untitledWorkspacesHome",null),Re([R.memoize],g.prototype,"builtinExtensionsPath",null),Re([R.memoize],g.prototype,"extensionsPath",null),Re([R.memoize],g.prototype,"extensionDevelopmentLocationURI",null),Re([R.memoize],g.prototype,"extensionDevelopmentKind",null),Re([R.memoize],g.prototype,"extensionTestsLocationURI",null),Re([R.memoize],g.prototype,"debugExtensionHost",null),Re([R.memoize],g.prototype,"logLevel",null),Re([R.memoize],g.prototype,"extensionLogLevel",null),Re([R.memoize],g.prototype,"serviceMachineIdResource",null),Re([R.memoize],g.prototype,"disableTelemetry",null),Re([R.memoize],g.prototype,"disableWorkspaceTrust",null),Re([R.memoize],g.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=g;function T(E,m){return I(E["inspect-extensions"],E["inspect-brk-extensions"],5870,m,E.debugId,E.extensionEnvironment)}e.parseExtensionHostDebugPort=T;function I(E,m,p,b,o,d){const f=Number(m||E)||(b?null:p),w=f?Boolean(!!m):!1;let L;if(d)try{L=JSON.parse(d)}catch{}return{port:f,break:w,debugId:o,env:L}}e.parseDebugParams=I}),define(pe[63],ve([1,0,293,3,170]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,a.localize)(0,null),e:(0,a.localize)(1,null),t:(0,a.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,a.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,a.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,a.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,a.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,a.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,a.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,a.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,a.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,a.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,a.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,a.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,a.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,a.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,a.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,a.localize)(17,null)},category:{type:"string",cat:"e",description:(0,a.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,a.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,a.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,a.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,a.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,a.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,a.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,a.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,a.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,a.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,a.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,a.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,a.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,a.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,a.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,a.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,a.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,a.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(b,o,d=C){const h=b.find(c=>c.length>0&&c[0]!=="-"),f={},w=["_"],L=[],t={};let n;for(const c in o){const s=o[c];s.type==="subcommand"?c===h&&(n=s):(s.alias&&(f[c]=s.alias),s.type==="string"||s.type==="string[]"?(w.push(c),s.deprecates&&w.push(...s.deprecates)):s.type==="boolean"&&(L.push(c),s.deprecates&&L.push(...s.deprecates)),s.global&&(t[c]=s))}if(n&&h){const c=t;for(const A in n.options)c[A]=n.options[A];const s=b.filter(A=>A!==h),u=d.getSubcommandReporter?d.getSubcommandReporter(h):void 0,S=k(s,c,u);return{[h]:S,_:[]}}const r=y(b,{string:w,boolean:L,alias:f}),i={},l=r;i._=r._.map(c=>String(c)).filter(c=>c.length>0),delete l._;for(const c in o){const s=o[c];if(s.type==="subcommand")continue;s.alias&&delete l[s.alias];let u=l[c];if(s.deprecates)for(const S of s.deprecates)l.hasOwnProperty(S)&&(u||(u=l[S],u&&d.onDeprecatedOption(S,s.deprecationMessage||(0,a.localize)(36,null,c))),delete l[S]);if(typeof u<"u"){if(s.type==="string[]"){if(Array.isArray(u)||(u=[u]),!s.allowEmptyValue){const S=u.filter(A=>A.length>0);S.length!==u.length&&(d.onEmptyValue(c),u=S.length>0?S:void 0)}}else s.type==="string"&&(Array.isArray(u)?(u=u.pop(),d.onMultipleValues(c,u)):!u&&!s.allowEmptyValue&&(d.onEmptyValue(c),u=void 0));i[c]=u,s.deprecationMessage&&d.onDeprecatedOption(c,s.deprecationMessage)}delete l[c]}for(const c in l)d.onUnknownOption(c);return i}e.parseArgs=k;function v(b,o){let d="";return o.args&&(Array.isArray(o.args)?d=` <${o.args.join("> <")}>`:d=` <${o.args}>`),o.alias?`-${o.alias} --${b}${d}`:`--${b}${d}`}function g(b,o){const d=[];for(const h in b){const f=b[h],w=v(h,f);d.push([w,f.description])}return T(d,o)}e.formatOptions=g;function T(b,o){const h=b.reduce((L,t)=>Math.max(L,t[0].length),12)+2+1;if(o-h<25)return b.reduce((L,t)=>L.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=o-h-1,w=[];for(const L of b){const t=L[0],n=E(L[1],f),r=I(h-t.length-2);w.push("  "+t+r+n[0]);for(let i=1;i<n.length;i++)w.push(I(h)+n[i])}return w}function I(b){return" ".repeat(b)}function E(b,o){const d=[];for(;b.length;){const h=b.length<o?b.length:b.lastIndexOf(" ",o),f=b.slice(0,h).trim();b=b.slice(h),d.push(f)}return d}function m(b,o,d,h,f){const w=process.stdout.isTTY&&process.stdout.columns||80,L=f?.noInputFiles!==!0?`[${(0,a.localize)(37,null)}...]`:"",t=[`${b} ${d}`];t.push(""),t.push(`${(0,a.localize)(38,null)}: ${o} [${(0,a.localize)(39,null)}]${L}`),t.push(""),f?.noPipe!==!0&&(R.isWindows?t.push((0,a.localize)(40,null,o)):t.push((0,a.localize)(41,null,o)),t.push(""));const n={},r=[];for(const i in h){const l=h[i];if(l.type==="subcommand")l.description&&r.push({command:i,description:l.description});else if(l.description&&l.cat){let c=n[l.cat];c||(n[l.cat]=c={}),c[i]=l}}for(const i in n){const l=i,c=n[l];c&&(t.push(D[l]),t.push(...g(c,w)),t.push(""))}return r.length&&(t.push((0,a.localize)(42,null)),t.push(...T(r.map(i=>[i.command,i.description]),w)),t.push("")),t.join(`
`)}e.buildHelpMessage=m;function p(b,o){return`${b||(0,a.localize)(43,null)}
${o||(0,a.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=p}),define(pe[204],ve([1,0,294,171,63]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function C(E,m){const p=(w,L)=>{console.warn((0,R.localize)(0,null,w,L))},b=w=>{console.warn((0,R.localize)(1,null,w))},o=(w,L)=>{console.warn((0,R.localize)(2,null,w,L))},d=w=>({onUnknownOption:L=>{w!=="tunnel"&&console.warn((0,R.localize)(3,null,L,w))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:o,getSubcommandReporter:w!=="tunnel"?d:void 0}),h={onUnknownOption:w=>{console.warn((0,R.localize)(4,null,w))},onMultipleValues:p,onEmptyValue:b,onDeprecatedOption:o,getSubcommandReporter:d},f=(0,a.parseArgs)(E,a.OPTIONS,m?h:void 0);return f.goto&&f._.forEach(w=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,R.localize)(5,null))),f["max-memory"]&&y(parseInt(f["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),f}function k(E){const m=E.findIndex(p=>!/^-/.test(p));if(m>-1)return[...E.slice(0,m),...E.slice(m+1)]}function v(E){let[,...m]=E;process.env.VSCODE_DEV&&(m=k(m)||[]);const p=!I(process.env);return C(m,p)}e.parseMainProcessArgv=v;function g(E){let[,,...m]=E;return process.env.VSCODE_DEV&&(m=k(m)||[]),C(m,!0)}e.parseCLIProcessArgv=g;function T(E,...m){const p=E.indexOf("--");return p===-1?E.push(...m):E.splice(p,0,...m),E}e.addArg=T;function I(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function ae(e,y,R){function a(C,k){const v=D(C,k),g=[v];return e.isAbsolute(v)||g.unshift(R),e.resolve(...g)}function D(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,k);const T=C["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(I,"AppData","Roaming")}break;case"darwin":g=e.join(y.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,k)}return{getUserDataPath:a}}if(typeof define=="function")define(pe[205],ve([75,29,28]),function(e,y,R){return ae(e,y,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=ae(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[105],ve([1,0,29,203,205]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class D extends R.AbstractNativeEnvironmentService{constructor(g,T){super(g,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,a.getUserDataPath)(g,T.nameShort)},T)}}e.NativeEnvironmentService=D;function C(v,g){return(0,R.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,g,v.extensionEnvironment)}e.parsePtyHostDebugPort=C;function k(v,g){return(0,R.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,g,v.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(pe[206],ve([1,0,8,175]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function a(C,k,v){try{D(C,k,v)}catch(g){console.error(g?.message??g)}return C}e.localizeManifest=a;function D(C,k,v){const g=(T,I,E)=>{const m=T[I];if((0,y.isString)(m)){const p=m,b=p.length;if(b>1&&p[0]==="%"&&p[b-1]==="%"){const o=p.substr(1,b-2);let d=k[o];d===void 0&&v&&(d=v[o]);const h=typeof d=="string"?d:d?.message,f=v?.[o],w=typeof f=="string"?f:f?.message;if(!h){w||console.warn(`[${C.name}]: ${(0,R.localize)(0,null,o)}`);return}if(E&&(I==="title"||I==="category")&&w&&w!==h){const L={value:h,original:w};T[I]=L}else T[I]=h}}else if((0,y.isObject)(m))for(const p in m)m.hasOwnProperty(p)&&(p==="commands"?g(m,p,!0):g(m,p,E));else if(Array.isArray(m))for(let p=0;p<m.length;p++)g(m,p,E)};for(const T in C)C.hasOwnProperty(T)&&g(C,T)}}),define(pe[76],ve([1,0,19,59,179,51]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function v(d){return d=d.trim(),d==="*"||C.test(d)}e.isValidVersionStr=v;function g(d){if(!v(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=g;function T(d){if(!d)return null;const h=d.majorBase,f=d.majorMustEqual,w=d.minorBase;let L=d.minorMustEqual;const t=d.patchBase;let n=d.patchMustEqual;d.hasCaret&&(h===0||(L=!1),n=!1);let r=0;if(d.preRelease){const i=k.exec(d.preRelease);if(i){const[,l,c,s]=i;r=Date.UTC(Number(l),Number(c)-1,Number(s))}}return{majorBase:h,majorMustEqual:f,minorBase:w,minorMustEqual:L,patchBase:t,patchMustEqual:n,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function I(d,h,f){let w;typeof d=="string"?w=T(g(d)):w=d;let L;h instanceof Date?L=h.getTime():typeof h=="string"&&(L=new Date(h).getTime());let t;if(typeof f=="string"?t=T(g(f)):t=f,!w||!t)return!1;const n=w.majorBase,r=w.minorBase,i=w.patchBase;let l=t.majorBase,c=t.minorBase,s=t.patchBase;const u=t.notBefore;let S=t.majorMustEqual,A=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?n>l?!0:n<l?!1:r>c?!0:r<c||L&&L<u?!1:i>=s:(n===1&&l===0&&(!S||!A||!O)&&(l=1,c=0,s=0,S=!0,A=!1,O=!1),n<l?!1:n>l?!S:r<c?!1:r>c?!A:i<s?!1:i>s?!O:!(L&&L<u))}e.isValidVersion=I;function E(d,h,f,w,L){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([R.default.Error,a.localize(0,null)]),t;if(typeof w.name!="string")return t.push([R.default.Error,a.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([R.default.Error,a.localize(2,null,"version")]),t;if(!w.engines)return t.push([R.default.Error,a.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([R.default.Error,a.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!o(w.extensionDependencies))return t.push([R.default.Error,a.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!o(w.activationEvents))return t.push([R.default.Error,a.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([R.default.Error,a.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([R.default.Warning,a.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([R.default.Error,a.localize(9,null,"main")]),t;{const i=(0,y.joinPath)(f,w.main);(0,y.isEqualOrParent)(i,f)||t.push([R.default.Warning,a.localize(10,null,i.path,f.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([R.default.Error,a.localize(11,null,"browser")]),t;{const i=(0,y.joinPath)(f,w.browser);(0,y.isEqualOrParent)(i,f)||t.push([R.default.Warning,a.localize(12,null,i.path,f.path)])}}if(!D.valid(w.version))return t.push([R.default.Error,a.localize(13,null)]),t;const n=[];if(!m(d,h,w,L,n))for(const i of n)t.push([R.default.Error,i]);return t}e.validateExtensionManifest=E;function m(d,h,f,w,L){return w||typeof f.main>"u"&&typeof f.browser>"u"?!0:b(d,h,f.engines.vscode,L)}e.isValidExtensionVersion=m;function p(d,h,f){return d==="*"||b(h,f,d)}e.isEngineValid=p;function b(d,h,f,w=[]){const L=T(g(f));if(!L)return w.push(a.localize(14,null,f)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return w.push(a.localize(15,null,f)),!1}else if(!L.majorMustEqual)return w.push(a.localize(16,null,f)),!1;return I(d,h,L)?!0:(w.push(a.localize(17,null,d,f)),!1)}function o(d){if(!Array.isArray(d))return!1;for(let h=0,f=d.length;h<f;h++)if(typeof d[h]!="string")return!1;return!0}}),define(pe[207],ve([1,0,15,21]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function a(D,C,k){let v=k&&k.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const T=(await C.readFile(D.serviceMachineIdResource)).value.toString();v=(0,R.isUUID)(T)?T:null}catch{v=null}if(!v){v=(0,R.generateUuid)();try{await C.writeFile(D.serviceMachineIdResource,y.VSBuffer.fromString(v))}catch{}}return k?.store("storage.serviceMachineId",v,-1,1),v}e.getServiceMachineId=a}),define(pe[64],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(a,D=[],C=!1){this.ctor=a,this.staticArguments=D,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=y}),define(pe[208],ve([1,0,64]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var a;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(a=e.InstantiationType||(e.InstantiationType={}));function D(k,v,g){v instanceof y.SyncDescriptor||(v=new y.SyncDescriptor(v,[],Boolean(g))),R.push([k,v])}e.registerSingleton=D;function C(){return R}e.getSingletonServiceDescriptors=C}),define(pe[209],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(D,C){this.key=D,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class R{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const C of this.a.values())C.outgoing.size===0&&D.push(C);return D}insertEdge(D,C){const k=this.lookupOrInsertNode(D),v=this.lookupOrInsertNode(C);k.outgoing.set(v.key,v),v.incoming.set(k.key,k)}removeNode(D){const C=this.b(D);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(D){const C=this.b(D);let k=this.a.get(C);return k||(k=new y(C,D),this.a.set(C,k)),k}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[C,k]of this.a)D.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,C]of this.a){const k=new Set([D]),v=this.c(C,k);if(v)return v}}c(D,C){for(const[k,v]of D.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const g=this.c(v,C);if(g)return g;C.delete(k)}}}e.Graph=R}),define(pe[5],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(v){return v[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(y=e._util||(e._util={})),e.IInstantiationService=a("instantiationService");function R(C,k,v){k[y.DI_TARGET]===k?k[y.DI_DEPENDENCIES].push({id:C,index:v}):(k[y.DI_DEPENDENCIES]=[{id:C,index:v}],k[y.DI_TARGET]=k)}function a(C){if(y.serviceIds.has(C))return y.serviceIds.get(C);const k=function(v,g,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(k,v,T)};return k.toString=()=>C,y.serviceIds.set(C,k),k}e.createDecorator=a;function D(C){return C}e.refineServiceDecorator=D}),define(pe[24],ve([1,0,8,4,5]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,a.createDecorator)("configurationService");function D(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof R.URI)}e.isConfigurationOverrides=D;function C(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=v;function g(o,d){const h=Object.create(null);for(const f in o)T(h,f,o[f],d);return h}e.toValuesTree=g;function T(o,d,h,f){const w=d.split("."),L=w.pop();let t=o;for(let n=0;n<w.length;n++){const r=w[n];let i=t[r];switch(typeof i){case"undefined":i=t[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${w.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[L]=h}catch{f(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function I(o,d){const h=d.split(".");E(o,h)}e.removeFromValueTree=I;function E(o,d){const h=d.shift();if(d.length===0){delete o[h];return}if(Object.keys(o).indexOf(h)!==-1){const f=o[h];typeof f=="object"&&!Array.isArray(f)&&(E(f,d),Object.keys(f).length===0&&delete o[h])}}function m(o,d,h){function f(t,n){let r=t;for(const i of n){if(typeof r!="object"||r===null)return;r=r[i]}return r}const w=d.split("."),L=f(o,w);return typeof L>"u"?h:L}e.getConfigurationValue=m;function p(o,d,h){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in o?y.isObject(o[f])&&y.isObject(d[f])?p(o[f],d[f],h):h&&(o[f]=d[f]):o[f]=d[f])})}e.merge=p;function b(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(pe[65],ve([1,0,3,17,200,5,168,9]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",y.isMacintosh),v.set("isLinux",y.isLinux),v.set("isWindows",y.isWindows),v.set("isWeb",y.isWeb),v.set("isMacNative",y.isMacintosh&&!y.isWeb),v.set("isEdge",y.isEdge),v.set("isFirefox",y.isFirefox),v.set("isChrome",y.isChrome),v.set("isSafari",y.isSafari);function g(N,P){if(v.get(N)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(N,P)}e.setConstant=g;const T=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));const E={regexParsingWithErrorRecovery:!0},m=(0,C.localize)(0,null),p=(0,C.localize)(1,null),b=(0,C.localize)(2,null),o=(0,C.localize)(3,null),d=(0,C.localize)(4,null),h=(0,C.localize)(5,null),f=(0,C.localize)(6,null),w=(0,C.localize)(7,null);class L{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=E){this.k=P,this.d=new a.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const K=this.D(),te=K.type===17?h:void 0;throw this.h.push({message:d,offset:K.offset,lexeme:a.Scanner.getLexeme(K),additionalInfo:te}),L.c}return M}catch(M){if(M!==L.c)throw M;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const M=this.o();P.push(M)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const M=this.s();P.push(M)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,o),M?.negate()}case 17:return this.z(),B.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,o),M}case 17:{const M=P.lexeme;if(this.z(),this.y(9)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==10)throw this.B("REGEX",te);const j=te.lexeme,H=j.lastIndexOf("/"),J=H===j.length-1?void 0:this.w(j.substring(H+1));let V;try{V=new RegExp(j.substring(1,H),J)}catch{throw this.B("REGEX",te)}return _.create(M,V)}switch(te.type){case 10:case 19:{const j=[te.lexeme];this.z();let H=this.D(),J=0;for(let ce=0;ce<te.lexeme.length;ce++)te.lexeme.charCodeAt(ce)===40?J++:te.lexeme.charCodeAt(ce)===41&&J--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let ce=0;ce<H.lexeme.length;ce++)H.lexeme.charCodeAt(ce)===40?J++:te.lexeme.charCodeAt(ce)===41&&J--}if(J<0)break;j.push(a.Scanner.getLexeme(H)),this.z(),H=this.D()}const V=j.join(""),X=V.lastIndexOf("/"),x=X===V.length-1?void 0:this.w(V.substring(X+1));let Q;try{Q=new RegExp(V.substring(1,X),x)}catch{throw this.B("REGEX",te)}return t.regex(M,Q)}case 18:{const j=te.lexeme;this.z();let H=null;if(!(0,R.isFalsyOrWhitespace)(j)){const J=j.indexOf("/"),V=j.lastIndexOf("/");if(J!==V&&J>=0){const X=j.slice(J+1,V),x=j[V+1]==="i"?"i":"";try{H=new RegExp(X,x)}catch{throw this.B("REGEX",te)}}}if(H===null)throw this.B("REGEX",te);return _.create(M,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const te=this.u();return t.notIn(M,te)}switch(this.D().type){case 3:{this.z();const te=this.u();if(this.x().type===18)return t.equals(M,te);switch(te){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,te)}}case 4:{this.z();const te=this.u();if(this.x().type===18)return t.notEquals(M,te);switch(te){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,te)}}case 5:return this.z(),ue.create(M,this.u());case 6:return this.z(),re.create(M,this.u());case 7:return this.z(),le.create(M,this.u());case 8:return this.z(),fe.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:f,offset:P.offset,lexeme:"",additionalInfo:w}),L.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,M){if(this.C(P))return this.z();throw this.B(M,this.D())}B(P,M,K){const te=(0,C.localize)(8,null,P,a.Scanner.getLexeme(M)),j=M.offset,H=a.Scanner.getLexeme(M);return this.h.push({message:te,offset:j,lexeme:H,additionalInfo:K}),L.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}L.c=new Error,e.Parser=L;class t{static false(){return l.INSTANCE}static true(){return c.INSTANCE}static has(P){return s.create(P)}static equals(P,M){return u.create(P,M)}static notEquals(P,M){return O.create(P,M)}static regex(P,M){return _.create(P,M)}static in(P,M){return S.create(P,M)}static notIn(P,M){return A.create(P,M)}static not(P){return B.create(P)}static and(...P){return ie.create(P,null,!0)}static or(...P){return G.create(P,null,!0)}static greater(P,M){return le.create(P,M)}static greaterEquals(P,M){return fe.create(P,M)}static smaller(P,M){return ue.create(P,M)}static smallerEquals(P,M){return re.create(P,M)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}t.c=new L({regexParsingWithErrorRecovery:!1}),e.ContextKeyExpr=t;function n(N){const P=new L({regexParsingWithErrorRecovery:!1});return N.map(M=>(P.parse(M),P.lexingErrors.length>0?P.lexingErrors.map(K=>({errorMessage:K.additionalInfo?(0,C.localize)(9,null,K.additionalInfo):(0,C.localize)(10,null),offset:K.offset,length:K.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(K=>({errorMessage:K.additionalInfo?`${K.message}. ${K.additionalInfo}`:K.message,offset:K.offset,length:K.lexeme.length})):[]))}e.validateWhenClauses=n;function r(N,P){const M=N?N.substituteConstants():void 0,K=P?P.substituteConstants():void 0;return!M&&!K?!0:!M||!K?!1:M.equals(K)}e.expressionsAreEqualWithConstantSubstitution=r;function i(N,P){return N.cmp(P)}class l{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return c.INSTANCE}}l.INSTANCE=new l,e.ContextKeyFalseExpr=l;class c{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return l.INSTANCE}}c.INSTANCE=new c,e.ContextKeyTrueExpr=c;class s{static create(P,M=null){const K=v.get(P);return typeof K=="boolean"?K?c.INSTANCE:l.INSTANCE:new s(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:Z(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=v.get(this.key);return typeof P=="boolean"?P?c.INSTANCE:l.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=s;class u{static create(P,M,K=null){if(typeof M=="boolean")return M?s.create(P,K):B.create(P,K);const te=v.get(P);return typeof te=="boolean"?M===(te?"true":"false")?c.INSTANCE:l.INSTANCE:new u(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?c.INSTANCE:l.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class S{static create(P,M){return new S(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),K=P.getValue(this.d);return Array.isArray(M)?M.includes(K):typeof K=="string"&&typeof M=="object"&&M!==null?T.call(M,K):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=S;class A{static create(P,M){return new A(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=S.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=A;class O{static create(P,M,K=null){if(typeof M=="boolean")return M?B.create(P,K):s.create(P,K);const te=v.get(P);return typeof te=="boolean"?M===(te?"true":"false")?l.INSTANCE:c.INSTANCE:new O(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?l.INSTANCE:c.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=O;class B{static create(P,M=null){const K=v.get(P);return typeof K=="boolean"?K?l.INSTANCE:c.INSTANCE:new B(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:Z(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=v.get(this.c);return typeof P=="boolean"?P?l.INSTANCE:c.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=s.create(this.c,this)),this.d}}e.ContextKeyNotExpr=B;function q(N,P){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?P(N):l.INSTANCE}class le{static create(P,M,K=null){return q(M,te=>new le(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=le;class fe{static create(P,M,K=null){return q(M,te=>new fe(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=fe;class ue{static create(P,M,K=null){return q(M,te=>new ue(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=fe.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ue;class re{static create(P,M,K=null){return q(M,te=>new re(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:oe(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=re;class _{static create(P,M){return new _(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return M<K?-1:M>K?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return this.d===P.d&&M===K}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.ContextKeyRegexExpr=_;class ee{static create(P){return new ee(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new ee(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ee;function ne(N){let P=null;for(let M=0,K=N.length;M<K;M++){const te=N[M].substituteConstants();if(N[M]!==te&&P===null){P=[];for(let j=0;j<M;j++)P[j]=N[j]}P!==null&&(P[M]=te)}return P===null?N:P}class ie{static create(P,M,K){return ie.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ne(this.expr);return P===this.expr?this:ie.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,K){const te=[];let j=!1;for(const H of P)if(!!H){if(H.type===1){j=!0;continue}if(H.type===0)return l.INSTANCE;if(H.type===6){te.push(...H.expr);continue}te.push(H)}if(te.length===0&&j)return c.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(i);for(let H=1;H<te.length;H++)te[H-1].equals(te[H])&&(te.splice(H,1),H--);if(te.length===1)return te[0];for(;te.length>1;){const H=te[te.length-1];if(H.type!==9)break;te.pop();const J=te.pop(),V=te.length===0,X=G.create(H.expr.map(x=>ie.create([x,J],null,K)),null,V);X&&(te.push(X),te.sort(i))}if(te.length===1)return te[0];if(K){for(let H=0;H<te.length;H++)for(let J=H+1;J<te.length;J++)if(te[H].negate().equals(te[J]))return l.INSTANCE;if(te.length===1)return te[0]}return new ie(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new ie(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=G.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=ie;class G{static create(P,M,K){return G.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=ne(this.expr);return P===this.expr?this:G.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,K){let te=[],j=!1;if(P){for(let H=0,J=P.length;H<J;H++){const V=P[H];if(!!V){if(V.type===0){j=!0;continue}if(V.type===1)return c.INSTANCE;if(V.type===9){te=te.concat(V.expr);continue}te.push(V)}}if(te.length===0&&j)return l.INSTANCE;te.sort(i)}if(te.length!==0){if(te.length===1)return te[0];for(let H=1;H<te.length;H++)te[H-1].equals(te[H])&&(te.splice(H,1),H--);if(te.length===1)return te[0];if(K){for(let H=0;H<te.length;H++)for(let J=H+1;J<te.length;J++)if(te[H].negate().equals(te[J]))return c.INSTANCE;if(te.length===1)return te[0]}return new G(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new G(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),K=P.shift(),te=[];for(const j of W(M))for(const H of W(K))te.push(ie.create([j,H],null,!1));P.unshift(G.create(te,null,!1))}this.c=G.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=G;class U extends s{static all(){return U.d.values()}constructor(P,M,K){super(P,null),this.f=M,typeof K=="object"?U.d.push({...K,key:P}):K!==!0&&U.d.push({key:P,description:K,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return u.create(this.key,P)}notEqualsTo(P){return O.create(this.key,P)}}U.d=[],e.RawContextKey=U,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function Z(N,P){return N<P?-1:N>P?1:0}function oe(N,P,M,K){return N<M?-1:N>M?1:P<K?-1:P>K?1:0}function me(N,P){if(N.type===0||P.type===1)return!0;if(N.type===9)return P.type===9?$(N.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(me(N,M))return!0;return!1}if(N.type===6){if(P.type===6)return $(P.expr,N.expr);for(const M of N.expr)if(me(M,P))return!0;return!1}return N.equals(P)}e.implies=me;function $(N,P){let M=0,K=0;for(;M<N.length&&K<P.length;){const te=N[M].cmp(P[K]);if(te<0)return!1;te===0&&M++,K++}return M===N.length}function W(N){return N.type===9?N.expr:[N]}}),define(pe[77],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class R{constructor(){this.a={}}async getPassword(D,C){return this.a[D]?.[C]??null}async setPassword(D,C,k){this.a[D]=this.a[D]??{},this.a[D][C]=k}async deletePassword(D,C){return this.a[D]?.[C]?(delete this.a[D][C],Object.keys(this.a[D]).length===0&&delete this.a[D],!0):!1}async findPassword(D){return JSON.stringify(this.a[D])??null}async findCredentials(D){const C=[];for(const k of Object.keys(this.a[D]||{}))C.push({account:k,password:this.a[D][k]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=R}),define(pe[210],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R;class a{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=a}),define(pe[78],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,y.createDecorator)("downloadService")}),define(pe[211],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(pe[25],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[30],ve([1,0,173,5]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function a(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=a;function D(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function C(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function k(h,f){return f==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function v(h,f,w){return k(f,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:g(w).includes(h)}e.isTargetPlatformCompatible=v;function g(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var m;(function(h){h.Install="install",h.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var p;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));var o;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o=e.ExtensionSignaturetErrorCode||(e.ExtensionSignaturetErrorCode={}));class d extends Error{constructor(f,w){super(f),this.code=w,this.name=w}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,y.localize)(1,null),original:"Preferences"}}),define(pe[212],ve([1,0,6,2,22,4,48,30]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(o,d){return o?D.URI.revive(d?d.transformIncoming(o):o):void 0}function g(o,d){return d?d.transformOutgoingURI(o):o}function T(o,d){d=d||C.DefaultURITransformer;const h=o.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...o,manifest:void 0},d),manifest:h}}function I(o,d){return o?.profileLocation?(0,C.transformAndReviveIncomingURIs)(o,d??C.DefaultURITransformer):o}function E(o,d){return d?(0,a.cloneAndChange)(o,h=>h instanceof D.URI?d.transformOutgoingURI(h):void 0):o}class m{constructor(d,h){this.a=d,this.b=h,this.onInstallExtension=y.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,h){const f=this.b(d);switch(h){case"onInstallExtension":return y.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,f):w.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,w=>w.map(L=>({...L,local:L.local?E(L.local,f):L.local,profileLocation:L.profileLocation?g(L.profileLocation,f):L.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,f):w.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,f):w.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,w=>E(w,f))}throw new Error("Invalid listen")}async call(d,h,f){const w=this.b(d);switch(h){case"zip":{const L=T(f[0],w),t=await this.a.zip(L);return g(t,w)}case"unzip":return this.a.unzip(v(f[0],w));case"install":return this.a.install(v(f[0],w),I(f[1],w));case"installFromLocation":return this.a.installFromLocation(v(f[0],w),v(f[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],w),v(f[2],w));case"getManifest":return this.a.getManifest(v(f[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],I(f[1],w));case"uninstall":return this.a.uninstall(T(f[0],w),I(f[1],w));case"reinstallFromGallery":return this.a.reinstallFromGallery(T(f[0],w));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],w))).map(t=>E(t,w));case"copyExtensions":return this.a.copyExtensions(v(f[0],w),v(f[1],w));case"updateMetadata":{const L=await this.a.updateMetadata(T(f[0],w),f[1],v(f[2],w));return E(L,w)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class p extends R.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(d){super(),this.k=d,this.c=this.B(new y.Emitter),this.f=this.B(new y.Emitter),this.g=this.B(new y.Emitter),this.h=this.B(new y.Emitter),this.j=this.B(new y.Emitter),this.B(this.k.listen("onInstallExtension")(h=>this.l(this.c,{...h,source:this.m(h.source)?D.URI.revive(h.source):h.source,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(h=>this.l(this.f,h.map(f=>({...f,local:f.local?T(f.local,null):f.local,source:this.m(f.source)?D.URI.revive(f.source):f.source,profileLocation:D.URI.revive(f.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(h=>this.l(this.g,{...h,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(h=>this.l(this.h,{...h,profileLocation:D.URI.revive(h.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(h=>this.j.fire(T(h,null))))}l(d,h){d.fire(h)}m(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(d){const h=await this.getTargetPlatform();return d.allTargetPlatforms.some(f=>(0,k.isTargetPlatformCompatible)(f,d.allTargetPlatforms,h))}zip(d){return Promise.resolve(this.k.call("zip",[d]).then(h=>D.URI.revive(h)))}unzip(d){return Promise.resolve(this.k.call("unzip",[d]))}install(d,h){return Promise.resolve(this.k.call("install",[d,h])).then(f=>T(f,null))}installFromLocation(d,h){return Promise.resolve(this.k.call("installFromLocation",[d,h])).then(f=>T(f,null))}async installExtensionsFromProfile(d,h,f){return(await this.k.call("installExtensionsFromProfile",[d,h,f])).map(L=>T(L,null))}getManifest(d){return Promise.resolve(this.k.call("getManifest",[d]))}installFromGallery(d,h){return Promise.resolve(this.k.call("installFromGallery",[d,h])).then(f=>T(f,null))}uninstall(d,h){return Promise.resolve(this.k.call("uninstall",[d,h]))}reinstallFromGallery(d){return Promise.resolve(this.k.call("reinstallFromGallery",[d])).then(h=>T(h,null))}getInstalled(d=null,h){return Promise.resolve(this.k.call("getInstalled",[d,h])).then(f=>f.map(w=>T(w,null)))}updateMetadata(d,h,f){return Promise.resolve(this.k.call("updateMetadata",[d,h,f])).then(w=>T(w,null))}copyExtensions(d,h){return this.k.call("copyExtensions",[d,h])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(d,h,f){const w=await this.k.call("download",[d,h,f]);return D.URI.revive(w)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class b{constructor(d){this.a=d}listen(d,h){throw new Error("Invalid listen")}call(d,h,f){switch(h){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(pe[79],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,y.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((D,C)=>ae(["node-vsce-sign"],async k=>D(k),C))),this.a}async verify(D,C,k){let v;try{v=await this.b()}catch{return!1}return v.verify(D,C,k)}}e.ExtensionSignatureVerificationService=R}),define(pe[16],ve([1,0,60,7,17,8,4,181,5,3,13]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,v.createDecorator)("fileService");function I(U){return U.create===!0}e.isFileOpenForWriteOptions=I;var E;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var m;(function(U){U[U.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var p;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function o(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=d;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;function w(U){return b(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var L;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(L=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(Z,oe){const me=new t(Z.toString(),oe);return i(me,oe),me}constructor(Z,oe){super(Z),this.code=oe}}e.FileSystemProviderError=t;function n(U,Z){return t.create(U,Z)}e.createFileSystemProviderError=n;function r(U){return U||n((0,k.localize)(0,null),L.Unknown)}e.ensureFileSystemProviderError=r;function i(U,Z){return U.name=Z?`${Z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function l(U){if(!U)return L.Unknown;if(U instanceof t)return U.code;const Z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!Z)return L.Unknown;switch(Z[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileExceedsMemoryLimit:return L.FileExceedsMemoryLimit;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}e.toFileSystemProviderErrorCode=l;function c(U){if(U instanceof B)return U.fileOperationResult;switch(l(U)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 10;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileExceedsMemoryLimit:return 9;case L.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(Z,oe,me){this.resource=Z,this.operation=oe,this.target=me}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=u;var S;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(S=e.FileChangeType||(e.FileChangeType={}));class A{constructor(Z,oe){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const me=new Map;for(const $ of Z){const W=me.get($.type);switch(W?W.push([$.resource,$]):me.set($.type,[[$.resource,$]]),$.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}}for(const[$,W]of me)switch($){case 1:this.a=y.TernarySearchTree.forUris(()=>oe),this.a.fill(W);break;case 0:this.b=y.TernarySearchTree.forUris(()=>oe),this.b.fill(W);break;case 2:this.c=y.TernarySearchTree.forUris(()=>oe),this.c.fill(W);break}}contains(Z,...oe){return this.d(Z,{includeChildren:!1},...oe)}affects(Z,...oe){return this.d(Z,{includeChildren:!0},...oe)}d(Z,oe,...me){if(!Z)return!1;const $=me.length>0;return!!((!$||me.includes(1))&&(this.a?.get(Z)||oe.includeChildren&&this.a?.findSuperstr(Z))||(!$||me.includes(0))&&(this.b?.get(Z)||oe.includeChildren&&this.b?.findSuperstr(Z))||(!$||me.includes(2))&&(this.c?.findSubstr(Z)||oe.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=A;function O(U,Z,oe){return!U||!Z||U===Z||Z.length>U.length?!1:(Z.charAt(Z.length-1)!==R.sep&&(Z+=R.sep),oe?(0,a.startsWithIgnoreCase)(U,Z):U.indexOf(Z)===0)}e.isParent=O;class B extends Error{constructor(Z,oe,me){super(Z),this.fileOperationResult=oe,this.options=me}}e.FileOperationError=B;class q extends B{constructor(Z,oe,me,$){super(Z,oe,$),this.fileOperationResult=oe,this.size=me}}e.TooLargeFileOperationError=q;class le extends B{constructor(Z,oe,me){super(Z,2,me),this.stat=oe}}e.NotModifiedSinceFileOperationError=le;var fe;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(fe=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ue;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=re;async function _(U,Z){if(!Z.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(oe=>{const me=Z.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===U.scheme&&$.added&&(me.dispose(),oe())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ee{static formatSize(Z){return(0,D.isNumber)(Z)||(Z=0),Z<ee.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<ee.MB?(0,k.localize)(2,null,(Z/ee.KB).toFixed(2)):Z<ee.GB?(0,k.localize)(3,null,(Z/ee.MB).toFixed(2)):Z<ee.TB?(0,k.localize)(4,null,(Z/ee.GB).toFixed(2)):(0,k.localize)(5,null,(Z/ee.TB).toFixed(2))}}ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB,e.ByteSize=ee;var ne;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ie(U){return{maxFileSize:U===0?300*ee.MB:16*ee.GB,maxHeapSize:U===0?700*ee.MB:2*700*ee.MB}}e.getPlatformFileLimits=ie;function G(U){const Z=typeof U=="string"||U?.scheme===T.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===T.Schemas.file?1024*ee.MB:Z?10*ee.MB:g.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=G}),define(pe[213],ve([1,0,15,39,9,6,2,46,4,21,16]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends C.Disposable{constructor(m,p){super(),this.a=m,this.b=p,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,g.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,p){const{buffer:b}=await this.a.call("readFile",[m,p]);return b}readFileStream(m,p,b){const o=(0,k.newWriteableStream)(h=>y.VSBuffer.concat(h.map(f=>y.VSBuffer.wrap(f))).buffer),d=this.a.listen("readFileStream",[m,p])(h=>{if(h instanceof y.VSBuffer)o.write(h.buffer);else{if(h==="end")o.end();else{let f;if(h instanceof Error)f=h;else{const w=h;f=(0,T.createFileSystemProviderError)(w.message??(0,R.toErrorMessage)(w),w.code??T.FileSystemProviderErrorCode.Unknown)}o.error(f),o.end()}d.dispose()}});return b.onCancellationRequested(()=>{o.error((0,a.canceled)()),o.end(),d.dispose()}),o}writeFile(m,p,b){return this.a.call("writeFile",[m,y.VSBuffer.wrap(p),b])}open(m,p){return this.a.call("open",[m,p])}close(m){return this.a.call("close",[m])}async read(m,p,b,o,d){const[h,f]=await this.a.call("read",[m,p,d]);return b.set(h.buffer.slice(0,f),o),f}write(m,p,b,o,d){return this.a.call("write",[m,p,y.VSBuffer.wrap(b),o,d])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,p){return this.a.call("delete",[m,p])}rename(m,p,b){return this.a.call("rename",[m,p,b])}copy(m,p,b){return this.a.call("copy",[m,p,b])}cloneFile(m,p){return this.a.call("cloneFile",[m,p])}i(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const p=m;this.f.fire(p.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const p=m;this.g.fire(p)}}))}watch(m,p){const b=(0,g.generateUuid)();return this.a.call("watch",[this.h,b,m,p]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=I}),define(pe[106],ve([1,0,15,9,182,16]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(T,I,E,m,p,b){let o;try{await k(T,I,E,m,p,b)}catch(d){o=d}finally{o&&p.errorTransformer&&(o=p.errorTransformer(o)),typeof o<"u"&&E.error(o),E.end()}}e.readFileIntoStream=C;async function k(T,I,E,m,p,b){v(b);const o=await T.open(I,{create:!1});try{v(b);let d=0,h=0,f=p&&typeof p.length=="number"?p.length:void 0,w=y.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),L=p&&typeof p.position=="number"?p.position:0,t=0;do h=await T.read(o,L,w.buffer,t,w.byteLength-t),L+=h,t+=h,d+=h,typeof f=="number"&&(f-=h),t===w.byteLength&&(await E.write(m(w)),w=y.VSBuffer.alloc(Math.min(p.bufferSize,typeof f=="number"?f:p.bufferSize)),t=0);while(h>0&&(typeof f!="number"||f>0)&&v(b)&&g(d,p));if(t>0){let n=t;typeof f=="number"&&(n=Math.min(t,f)),E.write(m(w.slice(0,n)))}}catch(d){throw(0,D.ensureFileSystemProviderError)(d)}finally{await T.close(o)}}function v(T){if(T.isCancellationRequested)throw(0,R.canceled)();return!0}function g(T,I){if(I?.limits){if(typeof I.limits.memory=="number"&&T>I.limits.memory)throw(0,D.createFileSystemProviderError)((0,a.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&T>I.limits.size)throw(0,D.createFileSystemProviderError)((0,a.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(pe[66],ve([1,0,74,2,7,3,4,16]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(d){return d.recursive===!0}e.isRecursiveWatchRequest=v;class g extends R.Disposable{constructor(h,f,w,L){super(),this.h=h,this.i=f,this.j=w,this.k=L,this.c=this.B(new R.MutableDisposable),this.f=void 0,this.g=0}m(){const h=new R.DisposableStore;this.c.value=h,this.b=this.l(h),this.b.setVerboseLogging(this.j),h.add(this.b.onDidChangeFile(f=>this.h(f))),h.add(this.b.onDidLogMessage(f=>this.i(f))),h.add(this.b.onDidError(f=>this.n(f)))}n(h){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${h}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${h}`):this.r(h)}p(h){this.g++,this.m(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.j=h,await this.b?.setVerboseLogging(h)}r(h){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${h}`})}s(h){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}g.a=5,e.AbstractWatcherClient=g;class T extends g{constructor(h,f,w){super(h,f,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class I extends g{constructor(h,f,w){super(h,f,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function E(d){return d.map(h=>({type:h.type,resource:C.URI.file(h.path)}))}e.toFileChanges=E;function m(d){const h=new o;for(const f of d)h.processEvent(f);return h.coalesce()}e.coalesceEvents=m;function p(d,h){return typeof h=="string"&&!h.startsWith(y.GLOBSTAR)&&!(0,a.isAbsolute)(h)?{base:d,pattern:h}:h}e.normalizeWatcherPattern=p;function b(d,h){const f=[];for(const w of h)f.push((0,y.parse)(p(d,w)));return f}e.parseWatcherPatterns=b;class o{constructor(){this.a=new Set,this.b=new Map}c(h){return D.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const f=this.b.get(this.c(h));let w=!1;if(f){const L=f.type,t=h.type;f.path!==h.path&&(h.type===2||h.type===1)?w=!0:L===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(f)):L===2&&t===1?f.type=0:L===1&&t===0||(f.type=t)}else w=!0;w&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],f=[];return Array.from(this.a).filter(w=>w.type!==2?(h.push(w),!1):!0).sort((w,L)=>w.path.length-L.path.length).filter(w=>f.some(L=>(0,k.isParent)(w.path,L,!D.isLinux))?!1:(f.push(w.path),!0)).concat(h)}}}),define(pe[214],ve([1,0,33,14,20,38,2,93,7,3,153,23,66]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends C.Disposable{constructor(o,d,h,f){super(),this.j=o,this.k=d,this.l=h,this.m=f,this.c=this.B(new R.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new R.RunOnceWorker(w=>this.u(w),m.b)),this.g=(0,E.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,E.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new a.CancellationTokenSource,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const d=await I.Promises.stat(o);this.B(await this.s(o,d.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let d=o.path;try{d=await I.Promises.realpath(o.path),o.path===d&&(d=await(0,T.realcase)(o.path)??o.path),o.path!==d&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${d})`)}catch{}return d}async s(o,d){if(g.isMacintosh&&(0,D.isEqualOrParent)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const h=new a.CancellationTokenSource(this.i.token),f=new C.DisposableStore;try{const w=(0,v.basename)(o),L=(0,y.watch)(o);f.add((0,C.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(d)try{for(const r of await I.Promises.readdir(o))t.add(r)}catch(r){this.w(r)}const n=new Map;f.add((0,C.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),L.on("error",(r,i)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),L.on("change",(r,i)=>{if(h.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let l="";if(i&&(l=i.toString(),g.isMacintosh&&(l=(0,k.normalizeNFC)(l))),!(!l||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){n.get(l)?.dispose();const c=setTimeout(async()=>{if(n.delete(l),l===w&&!await I.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,v.join)(o,l));if(h.token.isCancellationRequested)return;let u;s?t.has(l)?u=0:(u=1,t.add(l)):(t.delete(l),u=2),this.t({path:(0,v.join)(this.j.path,l),type:u})},m.a);n.set(l,(0,C.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(l)?c=0:(c=1,t.add(l)),this.t({path:(0,v.join)(this.j.path,l),type:c})}else if(r==="rename"||l!==w){const c=setTimeout(async()=>{const s=await I.Promises.exists(o);h.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},m.a);f.clear(),f.add((0,C.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await I.Promises.exists(o)&&!h.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${w.toString()})`)}return(0,C.toDisposable)(()=>{h.dispose(!0),f.dispose()})}t(o,d=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!d&&this.g.some(h=>h(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!d&&this.h&&this.h.length>0&&!this.h.some(h=>h(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const d=(0,E.coalesceEvents)(o);if(d.length>0){if(this.m)for(const f of d)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(d)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(g.isLinux)return I.Promises.exists(o);try{const d=(0,v.basename)(o);return(await I.Promises.readdir((0,v.dirname)(o))).some(f=>f===d)}catch(d){return this.z(d),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}m.a=100,m.b=75,e.NodeJSFileWatcherLibrary=m;async function p(b,o,d,h,f=512){const w=await I.Promises.open(b,"r"),L=Buffer.allocUnsafe(f),t=new a.CancellationTokenSource(h);let n,r=!1;const i={path:b,excludes:[],recursive:!1},l=new m(i,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:u}=await I.Promises.read(w,L,0,f,null);if(!u||t.token.isCancellationRequested)break;o(L.slice(0,u))}}catch(u){n=new Error(u),t.dispose(!0)}finally{r=!1}}})()});return await l.ready,d(),new Promise((c,s)=>{t.token.onCancellationRequested(async()=>{l.dispose();try{await I.Promises.close(w)}catch(u){n=new Error(u)}n?s(n):c()})})}e.watchFileContents=p}),define(pe[215],ve([1,0,6,74,2,3,214]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends a.Disposable{constructor(){super(...arguments),this.a=this.B(new y.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new y.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(g){const T=this.i(g),I=T.filter(m=>{const p=this.c.get(m.path);return p?!(0,R.patternsEquals)(p.request.excludes,m.excludes)||!(0,R.patternsEquals)(p.request.includes,m.includes):!0}),E=Array.from(this.c.values()).filter(({request:m})=>!T.find(p=>p.path===m.path&&(0,R.patternsEquals)(p.excludes,m.excludes)&&(0,R.patternsEquals)(p.includes,m.includes))).map(({request:m})=>m.path);I.length&&this.j(`Request to start watching: ${I.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const m of E)this.h(m);for(const m of I)this.g(m)}g(g){const T=new C.NodeJSFileWatcherLibrary(g,E=>this.a.fire(E),E=>this.b.fire(E),this.f),I={request:g,instance:T};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const T=this.c.get(g);T&&(this.c.delete(g),T.instance.dispose())}i(g){const T=new Map;for(const I of g){const E=D.isLinux?I.path:I.path.toLowerCase();T.set(E,I)}return Array.from(T.values())}async setVerboseLogging(g){this.f=g;for(const[,T]of this.c)T.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,T){return T?`[File Watcher (node.js)] ${g} (path: ${T.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=k}),define(pe[216],ve([1,0,66,215]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class a extends y.AbstractNonRecursiveWatcherClient{constructor(C,k,v){super(C,k,v),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=a}),define(pe[217],ve([1,0,13,43,103,66]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends D.AbstractUniversalWatcherClient{constructor(v,g,T){super(v,g,T),this.m()}l(v){const g=v.add(new a.Client(y.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(g.onDidProcessExit(({code:T,signal:I})=>this.n(`terminated by itself with code ${T}, signal: ${I}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(pe[80],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...a){this.a=new Map;for(const[D,C]of a)this.set(D,C)}set(a,D){const C=this.a.get(a);return this.a.set(a,D),C}has(a){return this.a.has(a)}get(a){return this.a.get(a)}}e.ServiceCollection=y}),define(pe[107],ve([1,0,14,9,2,64,209,5,80,92]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class I extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class E{constructor(o=new v.ServiceCollection,d=!1,h,f=T){this.f=o,this.g=d,this.h=h,this.i=f,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=f?h?._globalGraph??new C.Graph(w=>w):void 0}createChild(o){return new E(o,this.g,this,this.i)}invokeFunction(o,...d){const h=p.traceInvocation(this.i,o);let f=!1;try{return o({get:L=>{if(f)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(L,h);if(!t)throw new Error(`[invokeFunction] unknown service '${L}'`);return t}},...d)}finally{f=!0,h.stop()}}createInstance(o,...d){let h,f;return o instanceof D.SyncDescriptor?(h=p.traceCreation(this.i,o.ctor),f=this.j(o.ctor,o.staticArguments.concat(d),h)):(h=p.traceCreation(this.i,o),f=this.j(o,d,h)),h.stop(),f}j(o,d=[],h){const f=k._util.getServiceDependencies(o).sort((t,n)=>t.index-n.index),w=[];for(const t of f){const n=this.m(t.id,h);n||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(n)}const L=f.length>0?f[0].index:d.length;if(d.length!==L){console.trace(`[createInstance] First service dependency of ${o.name} at position ${L+1} conflicts with ${d.length} static arguments`);const t=L-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,L)}return Reflect.construct(o,d.concat(w))}k(o,d){if(this.f.get(o)instanceof D.SyncDescriptor)this.f.set(o,d);else if(this.h)this.h.k(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const d=this.f.get(o);return!d&&this.h?this.h.l(o):d}m(o,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.l(o);return h instanceof D.SyncDescriptor?this.q(o,h,d.branch(o,!0)):(d.branch(o,!1),h)}q(o,d,h){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,d,h)}finally{this.o.delete(o)}}r(o,d,h){const f=new C.Graph(t=>t.id.toString());let w=0;const L=[{id:o,desc:d,_trace:h}];for(;L.length;){const t=L.pop();if(f.lookupOrInsertNode(t),w++>1e3)throw new I(f);for(const n of k._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${o} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof D.SyncDescriptor){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};f.insertEdge(t,i),L.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:n}of t){if(this.l(n.id)instanceof D.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}f.removeNode(n)}}return this.l(o)}s(o,d,h=[],f,w){if(this.f.get(o)instanceof D.SyncDescriptor)return this.t(o,d,h,f,w);if(this.h)return this.h.s(o,d,h,f,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(o,d,h=[],f,w){if(f){const L=new E(void 0,this.g,this,this.i);L.c=String(o);const t=new Map,n=new y.IdleValue(()=>{const r=L.j(d,h,w);for(const[i,l]of t){const c=r[i];if(typeof c=="function")for(const s of l)c.apply(r,s)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let s=t.get(i);return s||(s=new g.LinkedList,t.set(i,s)),(S,A,O)=>{const B=s.push([S,A,O]);return(0,a.toDisposable)(B)}}if(i in r)return r[i];const l=n.value;let c=l[i];return typeof c!="function"||(c=c.bind(l),r[i]=c),c},set(r,i,l){return n.value[i]=l,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,h,w)}u(o,d){if(d&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=E;var m;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(m||(m={}));class p{static traceInvocation(o,d){return o?new p(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(o,d){return o?new p(1,d.name):p.c}constructor(o,d){this.type=o,this.name=d,this.g=Date.now(),this.h=[]}branch(o,d){const h=new p(3,o.toString());return this.h.push([o,d,h]),h}stop(){const o=Date.now()-this.g;p.f+=o;let d=!1;function h(w,L){const t=[],n=new Array(w+1).join("	");for(const[r,i,l]of L.h)if(i&&l){d=!0,t.push(`${n}CREATES -> ${r}`);const c=h(w+1,l);c&&t.push(c)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(o>2||d)&&p.all.add(f.join(`
`))}}p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0,e.Trace=p}),define(pe[218],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,y.createDecorator)("labelService");var R;(function(a){a[a.SHORT=0]="SHORT",a[a.MEDIUM=1]="MEDIUM",a[a.LONG=2]="LONG"})(R=e.Verbosity||(e.Verbosity={}))});var Ae=this&&this.__param||function(ae,e){return function(y,R){e(y,R,ae)}};define(pe[81],ve([1,0,20,2,3,184,30,5]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function v(T){return T.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=v,e.ILanguagePackService=(0,k.createDecorator)("languagePackService");let g=class extends R.Disposable{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new y.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let E;try{E=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const p=E.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(o=>o.startsWith("lp-"))).map(b=>{const o=b.properties.localizedLanguages?.[0],d=v(b);return{...this.f(d,o,b),extensionId:b.identifier.id,galleryExtension:b}});return p.push(this.f("en","English")),p}f(I,E,m){const p=E??I;let b;if(p!==I&&(b=`(${I})`),I.toLowerCase()===a.language.toLowerCase()&&(b??="",b+=(0,D.localize)(0,null)),m?.installCount){b??="";const o=m.installCount;let d;o>1e6?d=`${Math.floor(o/1e5)/10}M`:o>1e3?d=`${Math.floor(o/1e3)}K`:d=String(o),b+=` $(cloud-download) ${d}`}return{id:I,label:p,description:b}}};g=Re([Ae(0,C.IExtensionGalleryService)],g),e.LanguagePackBaseService=g}),define(pe[12],ve([1,0,39,6,73,2,27,3,19,8,4,65,5]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function m(){return new Date().toISOString()}function p(S){return(0,g.isNumber)(S)}e.isLogLevel=p;var b;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function o(S,A,O){switch(A){case b.Trace:S.trace(O);break;case b.Debug:S.debug(O);break;case b.Info:S.info(O);break;case b.Warning:S.warn(O);break;case b.Error:S.error(O);break;case b.Off:break;default:throw new Error(`Invalid log level ${A}`)}}e.log=o;function d(S,A=!1){let O="";for(let B=0;B<S.length;B++){let q=S[B];if(q instanceof Error&&(q=(0,y.toErrorMessage)(q,A)),typeof q=="object")try{q=JSON.stringify(q)}catch{}O+=(B>0?" ":"")+q}return O}class h extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==b.Off&&this.b<=A}}e.AbstractLogger=h;class f extends h{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...O){this.f(b.Trace)&&this.g(b.Trace,d([A,...O],!0))}debug(A,...O){this.f(b.Debug)&&this.g(b.Debug,d([A,...O]))}info(A,...O){this.f(b.Info)&&this.g(b.Info,d([A,...O]))}warn(A,...O){this.f(b.Warning)&&this.g(b.Warning,d([A,...O]))}error(A,...O){if(this.f(b.Error))if(A instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=A.stack,this.g(b.Error,d(B))}else this.g(b.Error,d([A,...O]))}flush(){}}e.AbstractMessageLogger=f;class w extends h{constructor(A=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(A),this.g=!k.isWindows}trace(A,...O){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...O):console.log(`[main ${m()}]`,A,...O))}debug(A,...O){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...O):console.log(`[main ${m()}]`,A,...O))}info(A,...O){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...O):console.log(`[main ${m()}]`,A,...O))}warn(A,...O){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,A,...O):console.warn(`[main ${m()}]`,A,...O))}error(A,...O){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,A,...O):console.error(`[main ${m()}]`,A,...O))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class L extends h{constructor(A=e.DEFAULT_LOG_LEVEL,O=!0){super(),this.g=O,this.setLevel(A)}trace(A,...O){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...O):console.log(A,...O))}debug(A,...O){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...O):console.log(A,...O))}info(A,...O){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...O):console.log(A,...O))}warn(A,...O){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...O):console.log(A,...O))}error(A,...O){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...O):console.error(A,...O))}dispose(){}flush(){}}e.ConsoleLogger=L;class t extends h{constructor(A,O=e.DEFAULT_LOG_LEVEL){super(),this.g=A,this.setLevel(O)}trace(A,...O){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(A),...O])}debug(A,...O){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(A),...O])}info(A,...O){this.f(b.Info)&&this.g.log(b.Info,[this.h(A),...O])}warn(A,...O){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(A),...O])}error(A,...O){this.f(b.Error)&&this.g.log(b.Error,[this.h(A),...O])}h(A){return typeof A=="string"?A:(0,y.toErrorMessage)(A,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends h{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const O of this.g)O.setLevel(A);super.setLevel(A)}trace(A,...O){for(const B of this.g)B.trace(A,...O)}debug(A,...O){for(const B of this.g)B.debug(A,...O)}info(A,...O){for(const B of this.g)B.info(A,...O)}warn(A,...O){for(const B of this.g)B.warn(A,...O)}error(A,...O){for(const B of this.g)B.error(A,...O)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose()}}e.MultiplexLogger=n;class r extends D.Disposable{constructor(A,O,B){if(super(),this.h=A,this.j=O,this.b=new C.ResourceMap,this.c=this.B(new R.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeVisibility=this.g.event,B)for(const q of B)this.b.set(q.resource,{logger:void 0,info:q})}k(A){return(0,g.isString)(A)?[...this.b.values()].find(O=>O.info.id===A):this.b.get(A)}getLogger(A){return this.k(A)?.logger}createLogger(A,O){const B=this.l(A),q=(0,g.isString)(A)?A:O?.id??(0,a.hash)(B.toString()).toString(16);let le=this.b.get(B)?.logger;const fe=O?.logLevel==="always"?b.Trace:O?.logLevel;le||(le=this.m(B,fe??this.getLogLevel(B)??this.h,{...O,id:q}));const ue={logger:le,info:{resource:B,id:q,logLevel:fe,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(ue.info),this.b.set(B,ue),le}l(A){return(0,g.isString)(A)?(0,v.joinPath)(this.j,`${A}.log`):A}setLogLevel(A,O){if(T.URI.isUri(A)){const B=A,q=O,le=this.b.get(B);le&&q!==le.info.logLevel&&(le.info.logLevel=q===this.h?void 0:q,le.logger?.setLevel(q),this.b.set(le.info.resource,le),this.f.fire([B,q]))}else{this.h=A;for(const[B,q]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,O){const B=this.k(A);B&&O!==!B.info.hidden&&(B.info.hidden=!O,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,O]))}getLogLevel(A){let O;return A&&(O=this.b.get(A)?.info.logLevel),O??this.h}registerLogger(A){const O=this.b.get(A.resource);O?O.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const O=this.b.get(A);O&&(O.logger&&O.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(A){}getLevel(){return b.Info}trace(A,...O){}debug(A,...O){}info(A,...O){}warn(A,...O){}error(A,...O){}critical(A,...O){}dispose(){}flush(){}}e.NullLogger=i;class l extends i{}e.NullLogService=l;function c(S){if(S.verbose)return b.Trace;if(typeof S.logLevel=="string"){const A=u(S.logLevel.toLowerCase());if(A!==void 0)return A}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function s(S){switch(S){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=s;function u(S){switch(S){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",s(b.Info))}),define(pe[219],ve([1,0,77,6,2,12,3,14]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=class Yt extends a.Disposable{constructor(T){super(),this.h=T,this.c=this.B(new R.Emitter),this.onDidChangePassword=this.c.event,this.g=new k.SequencerByKey}async getPassword(T,I){this.h.trace("Getting password from keytar:",T,I);let E;try{E=await this.i()}catch{return null}return await this.g.queue(T+I,()=>this.k(E,T,I))}async k(T,I,E){const m=await(0,k.retry)(()=>T.getPassword(I,E),50,3);if(!m)return this.h.trace("Did not get a password from keytar for account:",E),m;let p,b;try{const o=JSON.parse(m);p=o.content,b=o.hasNextChunk}catch{}if(!p||!b)return this.h.trace("Got password from keytar for account:",E),m;try{let o=1;for(;b;){const d=await(0,k.retry)(()=>T.getPassword(I,`${E}-${o}`),50,3),h=JSON.parse(d);p+=h.content,b=h.hasNextChunk,o++}return this.h.trace(`Got ${o}-chunked password from keytar for account:`,E),p}catch(o){return this.h.error(o),m}}async setPassword(T,I,E){this.h.trace("Setting password using keytar:",T,I);let m;try{m=await this.i()}catch(p){throw this.j?.(p),p}await this.g.queue(T+I,()=>this.l(m,T,I,E)),this.c.fire({service:T,account:I})}async l(T,I,E,m){if(!C.isWindows){await(0,k.retry)(()=>T.setPassword(I,E,m),50,3),this.h.trace("Set password from keytar for account:",E);return}if(await this.m(T,I,E),m.length<=Yt.b){await(0,k.retry)(()=>T.setPassword(I,E,m),50,3),this.h.trace("Set password from keytar for account:",E);return}let p=0,b=0,o=!0;const d=[];for(;o;){const h=m.substring(p,p+Yt.b);p+=Yt.b,o=m.length-p>0;const f={content:h,hasNextChunk:o};d.push((0,k.retry)(()=>T.setPassword(I,b?`${E}-${b}`:E,JSON.stringify(f)),50,3)),b++}await Promise.all(d),this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,E)}async deletePassword(T,I){this.h.trace("Deleting password using keytar:",T,I);let E;try{E=await this.i()}catch(p){throw this.j?.(p),p}const m=await this.g.queue(T+I,()=>this.m(E,T,I));return m&&this.c.fire({service:T,account:I}),m}async m(T,I,E){const m=await T.getPassword(I,E);if(!m)return this.h.trace("Did not get a password to delete from keytar for account:",E),!1;let p,b;try{const d=JSON.parse(m);p=d.content,b=d.hasNextChunk}catch{}let o=0;if(p&&b)try{for(o++;b;){const d=`${E}-${o}`,h=await T.getPassword(I,d);await T.deletePassword(I,d),b=JSON.parse(h).hasNextChunk,o++}}catch(d){this.h.error(d)}return await T.deletePassword(I,E)?(this.h.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,E),!0):(this.h.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,E),!1)}async findPassword(T){let I;try{I=await this.i()}catch{return null}return await I.findPassword(T)}async findCredentials(T){let I;try{I=await this.i()}catch{return[]}return await I.findCredentials(T)}clear(){return this.f instanceof y.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};v.a=2500,v.b=v.a-100,v=Re([Ae(0,D.ILogService)],v),e.BaseCredentialsMainService=v}),define(pe[220],ve([1,0,12]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let R=class{constructor(D,C){this.a=D,this.b=C}c(){return new Promise((D,C)=>ae(["vscode-encrypt"],D,C))}async encrypt(D){let C;try{C=await this.c()}catch{return D}try{return C.encrypt(this.a,D)}catch(k){return this.b.error(k),D}}async decrypt(D){let C;try{C=await this.c()}catch{return D}try{return C.decrypt(this.a,D)}catch(k){return this.b.error(k),D}}};R=Re([Ae(1,y.ILogService)],R),e.EncryptionMainService=R}),define(pe[221],ve([1,0,18,14,9,6,2,7,66,12]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends C.Disposable{constructor(E,m){super(),this.a=E,this.b=m,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(E,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(E,m):this.u(E,m)}l(E,m){const p={path:this.C(E),excludes:m.excludes,includes:m.includes,recursive:m.recursive},b=(0,y.insert)(this.j,p);return this.m(),(0,C.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,a.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,v.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&E.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,m){const p={path:this.C(E),excludes:m.excludes,includes:m.includes,recursive:!1},b=(0,y.insert)(this.s,p);return this.v(),(0,C.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,a.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,v.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,k.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(pe[108],ve([1,0,18,14,15,20,6,73,56,2,60,13,42,19,46,180,16,106,12,9]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends g.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${t}`);const r=new g.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),r.add(n.onDidChangeFile(i=>this.R.fire(new o.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,g.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,g.dispose)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(r){n.push(r)}}),!this.h.has(t)&&await R.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,m.isAbsolutePath)(t))throw new o.FileOperationError((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const r=new f.ErrorNoTelemetry;throw r.message=(0,b.localize)(1,null,t.toString()),r}return n}async k(t){const n=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(n)||(0,o.hasReadWriteCapability)(n)||(0,o.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,o.hasOpenReadWriteCloseCapability)(n)||(0,o.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(r){throw(0,o.toFileSystemProviderErrorCode)(r)===o.FileSystemProviderErrorCode.FileNotFound?new o.FileOperationError((0,b.localize)(2,null,this.nb(t)),1):(0,o.ensureFileSystemProviderError)(r)}}async n(t,n){const r=await this.j(t),i=this.O(r),l=n?.resolveTo,c=n?.resolveSingleChildDescendants,s=n?.resolveMetadata,u=await r.stat(t);let S;return this.p(r,t,u,void 0,!!s,(A,O)=>(S||(S=T.TernarySearchTree.forUris(()=>!i),S.set(t,!0),l&&S.fill(!0,l)),S.get(A.resource)||S.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&c?O===1:!1))}async p(t,n,r,i,l,c){const{providerExtUri:s}=this.N(t),u={resource:n,name:s.basename(n),isFile:(r.type&o.FileType.File)!==0,isDirectory:(r.type&o.FileType.Directory)!==0,isSymbolicLink:(r.type&o.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&o.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,o.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(u.isDirectory&&c(u,i)){try{const S=await t.readdir(n),A=await R.Promises.settled(S.map(async([O,B])=>{try{const q=s.joinPath(n,O),le=l?await t.stat(q):{type:B};return await this.p(t,q,le,S.length,l,c)}catch(q){return this.b.trace(q),null}}));u.children=(0,y.coalesce)(A)}catch(S){this.b.trace(S),u.children=[]}return u}return u}async resolveAll(t){return R.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),r=await n.stat(t);return this.p(n,t,r,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(r){return r}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new o.FileOperationError((0,b.localize)(3,null,this.nb(t)),3,n)}async createFile(t,n=a.VSBuffer.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,n);return this.m.fire(new o.FileOperationEvent(t,0,i)),i}async writeFile(t,n,r){const i=this.lb(await this.l(t),t),{providerExtUri:l}=this.N(i);try{await this.s(i,t,r)||await this.P(i,l.dirname(t));let s;if((0,o.hasReadWriteCapability)(i)&&!(n instanceof a.VSBuffer))if((0,p.isReadableStream)(n)){const u=await(0,p.peekStream)(n,3);u.ended?s=a.VSBuffer.concat(u.buffer):s=u}else s=(0,p.peekReadable)(n,u=>a.VSBuffer.concat(u),3);else s=n;!(0,o.hasOpenReadWriteCloseCapability)(i)||(0,o.hasReadWriteCapability)(i)&&s instanceof a.VSBuffer?await this.cb(i,t,r,s):await this.Y(i,t,r,s instanceof a.VSBuffer?(0,a.bufferToReadable)(s):s),this.m.fire(new o.FileOperationEvent(t,4))}catch(c){throw new o.FileOperationError((0,b.localize)(4,null,this.nb(t),(0,o.ensureFileSystemProviderError)(c).toString()),(0,o.toFileOperationResult)(c),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,r){if(!!r?.unlock&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(n)));let l;try{l=await t.stat(n)}catch{return}if((l.type&o.FileType.Directory)!==0)throw new o.FileOperationError((0,b.localize)(6,null,this.nb(n)),0,r);if(this.mb(n,l),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==o.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&r.mtime<l.mtime&&r.etag!==(0,o.etag)({mtime:r.mtime,size:l.size}))throw new o.FileOperationError((0,b.localize)(7,null),3,r);return l}async readFile(t,n,r){const i=await this.k(t);return n?.atomic?this.t(i,t,n,r):this.u(i,t,n,r)}async t(t,n,r,i){return new Promise((l,c)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,n,r,i);l(s)}catch(s){c(s)}})})}async u(t,n,r,i){const l=await this.v(t,n,{...r,preferUnbuffered:!0},i);return{...l,value:await(0,a.streamToBuffer)(l.value)}}async readFileStream(t,n,r){const i=await this.k(t);return this.v(i,t,n,r)}async v(t,n,r,i){const l=new D.CancellationTokenSource(i),c=this.F(n,r).then(u=>u,u=>{throw l.cancel(),u});let s;try{return typeof r?.etag=="string"&&r.etag!==o.ETAG_DISABLED&&await c,r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)||!((0,o.hasOpenReadWriteCloseCapability)(t)||(0,o.hasFileReadStreamCapability)(t))||(0,o.hasReadWriteCapability)(t)&&r?.preferUnbuffered?s=this.D(t,n,r):(0,o.hasFileReadStreamCapability)(t)?s=this.z(t,n,l.token,r):s=this.C(t,n,l.token,r),{...await c,value:s}}catch(u){throw s&&await(0,p.consumeStream)(s),this.w(u,n,r)}}w(t,n,r){const i=(0,b.localize)(8,null,this.nb(n),(0,o.ensureFileSystemProviderError)(t).toString());return t instanceof o.NotModifiedSinceFileOperationError?new o.NotModifiedSinceFileOperationError(i,t.stat,r):t instanceof o.TooLargeFileOperationError?new o.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new o.FileOperationError(i,(0,o.toFileOperationResult)(t),r)}z(t,n,r,i=Object.create(null)){const l=t.readFileStream(n,i,r);return(0,p.transform)(l,{data:c=>c instanceof a.VSBuffer?c:a.VSBuffer.wrap(c),error:c=>this.w(c,n,i)},c=>a.VSBuffer.concat(c))}C(t,n,r,i=Object.create(null)){const l=(0,a.newWriteableBufferStream)();return(0,d.readFileIntoStream)(t,n,l,c=>c,{...i,bufferSize:this.a,errorTransformer:c=>this.w(c,n,i)},r),l}D(t,n,r){const i=(0,p.newWriteableStream)(l=>a.VSBuffer.concat(l));return(async()=>{try{let l;r?.atomic&&(0,o.hasFileAtomicReadCapability)(t)?l=await t.readFile(n,{atomic:!0}):l=await t.readFile(n),typeof r?.position=="number"&&(l=l.slice(r.position)),typeof r?.length=="number"&&(l=l.slice(0,r.length)),this.G(n,l.byteLength,r),i.end(a.VSBuffer.wrap(l))}catch(l){i.error(l),i.end()}})(),i}async F(t,n){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new o.FileOperationError((0,b.localize)(9,null,this.nb(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==o.ETAG_DISABLED&&n.etag===r.etag)throw new o.NotModifiedSinceFileOperationError((0,b.localize)(10,null),r,n);return this.G(t,r.size,n),r}G(t,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new o.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(t)),i,n,r)}}async canMove(t,n,r){return this.H(t,n,"move",r)}async canCopy(t,n,r){return this.H(t,n,"copy",r)}async H(t,n,r,i){if(t.toString()!==n.toString())try{const l=r==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(n),n);await this.M(l,t,c,n,r,i)}catch(l){return l}return!0}async move(t,n,r){const i=this.lb(await this.l(t),t),l=this.lb(await this.l(n),n),c=await this.I(i,t,l,n,"move",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,c==="move"?2:3,s)),s}async copy(t,n,r){const i=await this.k(t),l=this.lb(await this.l(n),n),c=await this.I(i,t,l,n,"copy",!!r),s=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,c==="copy"?3:2,s)),s}async I(t,n,r,i,l,c){if(n.toString()===i.toString())return l;const{exists:s,isSameResourceWithDifferentPathCase:u}=await this.M(t,n,r,i,l,c);if(s&&!u&&c&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),l==="copy"){if(t===r&&(0,o.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:c});else{const S=await this.resolve(n);S.isDirectory?await this.L(t,S,r,i):await this.J(t,n,r,i)}return l}else return t===r?(await t.rename(n,i,{overwrite:c}),l):(await this.I(t,n,r,i,"copy",c),await this.del(n,{recursive:!0}),"copy")}async J(t,n,r,i){if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.eb(t,n,r,i);if((0,o.hasOpenReadWriteCloseCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.kb(t,n,r,i);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasOpenReadWriteCloseCapability)(r))return this.ib(t,n,r,i);if((0,o.hasReadWriteCapability)(t)&&(0,o.hasReadWriteCapability)(r))return this.gb(t,n,r,i)}async L(t,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await R.Promises.settled(n.children.map(async l=>{const c=this.N(r).providerExtUri.joinPath(i,l.name);return l.isDirectory?this.L(t,await this.resolve(l.resource),r,c):this.J(t,l.resource,r,c)}))}async M(t,n,r,i,l,c){let s=!1;if(t===r){const{providerExtUri:S,isPathCaseSensitive:A}=this.N(t);if(A||(s=S.isEqual(n,i)),s&&l==="copy")throw new Error((0,b.localize)(12,null,this.nb(n),this.nb(i)));if(!s&&S.isEqualOrParent(i,n))throw new Error((0,b.localize)(13,null,this.nb(n),this.nb(i)))}const u=await this.exists(i);if(u&&!s){if(!c)throw new o.FileOperationError((0,b.localize)(14,null,this.nb(n),this.nb(i)),4);if(t===r){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(n,i))throw new Error((0,b.localize)(15,null,this.nb(n),this.nb(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:s}}N(t){const n=this.O(t);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.lb(await this.j(t),t);await this.P(n,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.FileOperationEvent(t,0,r)),r}async P(t,n){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(((await t.stat(n)).type&o.FileType.Directory)===0)throw new Error((0,b.localize)(16,null,this.nb(n)));break}catch(l){if((0,o.toFileSystemProviderErrorCode)(l)!==o.FileSystemProviderErrorCode.FileNotFound)throw l;r.push(i.basename(n)),n=i.dirname(n)}for(let l=r.length-1;l>=0;l--){n=i.joinPath(n,r[l]);try{await t.mkdir(n)}catch(c){if((0,o.toFileSystemProviderErrorCode)(c)!==o.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,n){try{await this.Q(t,n)}catch(r){return r}return!0}async Q(t,n){const r=this.lb(await this.j(t),t);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(t)));let l;try{l=await r.stat(t)}catch{}if(l)this.mb(t,l);else throw new o.FileOperationError((0,b.localize)(18,null,this.nb(t)),1);if(!!!n?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(t)))}return r}async del(t,n){const r=await this.Q(t,n),i=!!n?.useTrash,l=!!n?.recursive;await r.delete(t,{recursive:l,useTrash:i}),this.m.fire(new o.FileOperationEvent(t,1))}async cloneFile(t,n){const r=await this.j(t),i=this.lb(await this.l(n),n);if(r===i&&this.N(r).providerExtUri.isEqual(t,n))return;if(r===i&&(0,o.hasFileCloneCapability)(r))return r.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const l=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,o.hasFileFolderCopyCapability)(r)?l.queue(()=>r.copy(t,n,{overwrite:!0})):l.queue(()=>this.J(r,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const r=new g.DisposableStore;let i=!1,l=()=>{i=!0};return r.add((0,g.toDisposable)(()=>l())),(async()=>{try{const c=await this.W(t,n);i?(0,g.dispose)(c):l=()=>(0,g.dispose)(c)}catch(c){this.b.error(c)}})(),r}async W(t,n){const r=await this.j(t),i=(0,k.hash)([this.N(r).providerExtUri.getComparisonKey(t),n]);let l=this.U.get(i);return l||(l={count:0,disposable:r.watch(t,n)},this.U.set(i,l)),l.count+=1,(0,g.toDisposable)(()=>{l&&(l.count--,l.count===0&&((0,g.dispose)(l.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,g.dispose)(t.disposable);this.U.clear()}async Y(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const l=await t.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.Z(t,l,i):await this.ab(t,l,i)}catch(c){throw(0,o.ensureFileSystemProviderError)(c)}finally{await t.close(l)}})}async Z(t,n,r){let i=0,l;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=a.VSBuffer.concat(r.buffer);await this.bb(t,n,c,c.byteLength,i,0),i+=c.byteLength}if(r.ended)return;l=r.stream}else l=r;return new Promise((c,s)=>{(0,p.listenStream)(l,{onData:async u=>{l.pause();try{await this.bb(t,n,u,u.byteLength,i,0)}catch(S){return s(S)}i+=u.byteLength,setTimeout(()=>l.resume())},onError:u=>s(u),onEnd:()=>c()})})}async ab(t,n,r){let i=0,l;for(;(l=r.read())!==null;)await this.bb(t,n,l,l.byteLength,i,0),i+=l.byteLength}async bb(t,n,r,i,l,c){let s=0;for(;s<i;)s+=await t.write(n,l+s,r.buffer,c+s,i-s)}async cb(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.db(t,n,r,i))}async db(t,n,r,i){let l;i instanceof a.VSBuffer?l=i:(0,p.isReadableStream)(i)?l=await(0,a.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?l=await(0,a.bufferedStreamToBuffer)(i):l=(0,a.readableToBuffer)(i),await t.writeFile(n,l.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async eb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,n,r,i))}async fb(t,n,r,i){let l,c;try{l=await t.open(n,{create:!1}),c=await r.open(i,{create:!0,unlock:!1});const s=a.VSBuffer.alloc(this.a);let u=0,S=0,A=0;do A=await t.read(l,u,s.buffer,S,s.byteLength-S),await this.bb(r,c,s,A,u,S),u+=A,S+=A,S===s.byteLength&&(S=0);while(A>0)}catch(s){throw(0,o.ensureFileSystemProviderError)(s)}finally{await R.Promises.settled([typeof l=="number"?t.close(l):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async gb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,n,r,i))}async hb(t,n,r,i){return r.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async ib(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,n,r,i))}async jb(t,n,r,i){const l=await r.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(n);await this.bb(r,l,a.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,o.ensureFileSystemProviderError)(c)}finally{await r.close(l)}}async kb(t,n,r,i){const l=await(0,a.streamToBuffer)(this.C(t,n,D.CancellationToken.None));await this.cb(r,i,void 0,l)}lb(t,n){if(t.capabilities&2048)throw new o.FileOperationError((0,b.localize)(20,null,this.nb(n)),6);return t}mb(t,n){if((n.permissions??0)&o.FilePermission.Readonly)throw new o.FileOperationError((0,b.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===I.Schemas.file?t.fsPath:t.toString(!0)}};w=Re([Ae(0,h.ILogService)],w),e.FileService=w}),define(pe[67],ve([1,0,33,295,14,27,15,6,38,2,7,3,19,46,23,183,16,106,221,39,217,216]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(y)}catch(n){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(n)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i),this.onDidChangeCapabilities=k.Event.None,this.H=new D.ResourceMap(l=>E.extUriBiasedIgnorePathCase.getComparisonKey(l)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,I.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:l}=await p.SymlinkSupport.stat(this.C(r));return{type:this.G(i,l),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(r){try{const i=await p.Promises.readdir(this.C(r),{withFileTypes:!0}),l=[];return await Promise.all(i.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,E.joinPath)(r,c.name))).type:s=this.G(c),l.push([c.name,s])}catch(s){this.a.trace(s)}})),l}catch(i){throw this.Y(i)}}G(r,i){let l;return i?.dangling?l=o.FileType.Unknown:r.isFile()?l=o.FileType.File:r.isDirectory()?l=o.FileType.Directory:l=o.FileType.Unknown,i&&(l|=o.FileType.SymbolicLink),l}async I(r){const i=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let l;for(;l=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await l.wait();const c=new a.Barrier;return this.H.set(r,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(r)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(r,i){let l;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),l=await this.I(r));const c=this.C(r);return await p.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{l?.dispose()}}J(r){t.D&&this.a.trace(r)}readFileStream(r,i,l){const c=(0,m.newWriteableStream)(s=>C.VSBuffer.concat(s.map(u=>C.VSBuffer.wrap(u))).buffer);return(0,d.readFileIntoStream)(this,r,c,s=>s.buffer,{...i,bufferSize:256*1024},l),c}async writeFile(r,i,l){let c;try{const s=this.C(r);if(!l.create||!l.overwrite){if(await p.Promises.exists(s)){if(!l.overwrite)throw(0,o.createFileSystemProviderError)((0,b.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,o.createFileSystemProviderError)((0,b.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(s){throw await this.Z(r,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){t.O=r}async open(r,i){const l=this.C(r);let c;(0,o.isFileOpenForWriteOptions)(i)&&(c=await this.I(r));let s;try{if((0,o.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await p.SymlinkSupport.stat(l);S.mode&128||await p.Promises.chmod(l,S.mode|128)}catch(S){this.a.trace(S)}let u;if((0,o.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await p.Promises.truncate(l,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}u||(u="w")}else u="r";s=await p.Promises.open(l,u)}catch(u){throw c?.dispose(),(0,o.isFileOpenForWriteOptions)(i)?await this.Z(r,u):this.Y(u)}if(this.L.set(s,0),(0,o.isFileOpenForWriteOptions)(i)&&this.N.set(s,r),c){const u=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${l})`),this.M.set(s,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${l})`),u.dispose())}return s}async close(r){const i=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&t.O)try{await p.Promises.fdatasync(r)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await p.Promises.close(r)}catch(l){throw this.Y(l)}finally{i&&(this.M.get(r)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,l,c,s){const u=this.P(r,i);let S=null;try{S=(await p.Promises.read(r,l,c,s,u)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(r,u,S)}return S}P(r,i){return i===this.L.get(r)?null:i}Q(r,i,l){const c=this.L.get(r);typeof c=="number"&&(typeof i=="number"||(typeof l=="number"?this.L.set(r,c+l):this.L.delete(r)))}async write(r,i,l,c,s){return(0,a.retry)(()=>this.R(r,i,l,c,s),100,3)}async R(r,i,l,c,s){const u=this.P(r,i);let S=null;try{S=(await p.Promises.write(r,l,c,s,u)).bytesWritten}catch(A){throw await this.Z(this.N.get(r),A)}finally{this.Q(r,u,S)}return S}async mkdir(r){try{await p.Promises.mkdir(this.C(r))}catch(i){throw this.Y(i)}}async delete(r,i){try{const l=this.C(r);i.recursive?await p.Promises.rm(l,p.RimRafMode.MOVE):await p.Promises.unlink(l)}catch(l){throw this.Y(l)}}async rename(r,i,l){const c=this.C(r),s=this.C(i);if(c!==s)try{await this.S(r,i,"move",l.overwrite),await p.Promises.move(c,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(2,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(s)),u.toString()))),this.Y(u)}}async copy(r,i,l){const c=this.C(r),s=this.C(i);if(c!==s)try{await this.S(r,i,"copy",l.overwrite),await p.Promises.copy(c,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,b.localize)(3,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(s)),u.toString()))),this.Y(u)}}async S(r,i,l,c){const s=this.C(r),u=this.C(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,v.isEqual)(s,u,!0)),S&&l==="copy")throw(0,o.createFileSystemProviderError)((0,b.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(!S&&await p.Promises.exists(u)){if(!c)throw(0,o.createFileSystemProviderError)((0,b.localize)(5,null),o.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(r,i){return this.U(r,i,!1)}async U(r,i,l){const c=this.C(r),s=this.C(i),u=!!(this.capabilities&1024);if((0,v.isEqual)(c,s,!u))return;const S=new g.DisposableStore;try{const[A,O]=await Promise.all([this.I(r),this.I(i)]);S.add(A),S.add(O),l&&await p.Promises.mkdir((0,T.dirname)(s),{recursive:!0}),await p.Promises.copyFile(c,s)}catch(A){if(A.code==="ENOENT"&&!l)return this.U(r,i,!0);throw this.Y(A)}finally{S.dispose()}}p(r,i,l){return new w.UniversalWatcherClient(c=>r(c),c=>i(c),l)}y(r,i,l){return new L.NodeJSWatcherClient(c=>r(c),c=>i(c),l)}Y(r){if(r instanceof o.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=o.FileSystemProviderErrorCode.NoPermissions;break;default:i=o.FileSystemProviderErrorCode.Unknown}return(0,o.createFileSystemProviderError)(r,i)}async Z(r,i){let l=this.Y(i);if(r&&l.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.C(r));c.mode&128||(l=(0,o.createFileSystemProviderError)(i,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return l}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(pe[222],ve([1,0,6,67,2,15,46,20]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends a.Disposable{constructor(I,E){super(),this.a=I,this.b=E,this.w=new Map,this.y=new Map}call(I,E,m){const p=this.c(I);switch(E){case"stat":return this.g(p,m[0]);case"readdir":return this.h(p,m[0]);case"open":return this.l(p,m[0],m[1]);case"close":return this.m(m[0]);case"read":return this.n(m[0],m[1],m[2]);case"readFile":return this.i(p,m[0],m[1]);case"write":return this.p(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.k(p,m[0],m[1],m[2]);case"rename":return this.t(p,m[0],m[1],m[2]);case"copy":return this.u(p,m[0],m[1],m[2]);case"cloneFile":return this.v(p,m[0],m[1]);case"mkdir":return this.r(p,m[0]);case"delete":return this.s(p,m[0],m[1]);case"watch":return this.C(p,m[0],m[1],m[2],m[3]);case"unwatch":return this.D(m[0],m[1])}throw new Error(`IPC Command ${E} not found`)}listen(I,E,m){const p=this.c(I);switch(E){case"fileChange":return this.z(p,m[0]);case"readFileStream":return this.j(p,m[0],m[1])}throw new Error(`Unknown event ${E}`)}g(I,E){const m=this.f(I,E,!0);return this.a.stat(m)}h(I,E){const m=this.f(I,E);return this.a.readdir(m)}async i(I,E,m){const p=this.f(I,E,!0),b=await this.a.readFile(p,m);return D.VSBuffer.wrap(b)}j(I,E,m){const p=this.f(I,E,!0),b=new k.CancellationTokenSource,o=new y.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),d=this.a.readFileStream(p,m,b.token);return(0,C.listenStream)(d,{onData:h=>o.fire(D.VSBuffer.wrap(h)),onError:h=>o.fire(h),onEnd:()=>{o.fire("end"),o.dispose(),b.dispose()}}),o.event}k(I,E,m,p){const b=this.f(I,E);return this.a.writeFile(b,m.buffer,p)}l(I,E,m){const p=this.f(I,E,!0);return this.a.open(p,m)}m(I){return this.a.close(I)}async n(I,E,m){const p=D.VSBuffer.alloc(m),b=0,o=await this.a.read(I,E,p.buffer,b,m);return[p,o]}p(I,E,m,p,b){return this.a.write(I,E,m.buffer,p,b)}r(I,E){const m=this.f(I,E);return this.a.mkdir(m)}s(I,E,m){const p=this.f(I,E);return this.a.delete(p,m)}t(I,E,m,p){const b=this.f(I,E),o=this.f(I,m);return this.a.rename(b,o,p)}u(I,E,m,p){const b=this.f(I,E),o=this.f(I,m);return this.a.copy(b,o,p)}v(I,E,m){const p=this.f(I,E),b=this.f(I,m);return this.a.cloneFile(p,b)}z(I,E){const m=new y.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(I,m))},onDidRemoveLastListener:()=>{(0,a.dispose)(this.w.get(E)),this.w.delete(E)}});return m.event}async C(I,E,m,p,b){const o=this.w.get(E);if(o){const d=this.f(I,p),h=o.watch(m,d,b);this.y.set(E+m,h)}}async D(I,E){const m=I+E,p=this.y.get(m);p&&((0,a.dispose)(p),this.y.delete(m))}dispose(){super.dispose();for(const[,I]of this.y)I.dispose();this.y.clear();for(const[,I]of this.w)I.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class g extends a.Disposable{constructor(I,E,m,p){super(),this.c=I,this.f=m,this.g=p,this.a=new Map,this.b=this.B(new R.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(I){const E=this.B(new y.Emitter);this.B(E.event(m=>{I.fire(m.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type})))})),this.B(this.b.onDidChangeFile(m=>E.fire(m))),this.B(this.b.onDidWatchError(m=>I.fire(m)))}i(I){}j(I){}watch(I,E,m){const p=this.j(this.g);return Array.isArray(p)&&(m.excludes=[...m.excludes,...p]),this.a.set(I,this.b.watch(E,m)),(0,a.toDisposable)(()=>{(0,a.dispose)(this.a.get(I)),this.a.delete(I)})}dispose(){super.dispose();for(const[,I]of this.a)I.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=g}),define(pe[109],ve([1,0,4,6,12,2]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends a.AbstractLoggerService{constructor(I,E,m,p,b){super(E,m,p),this.n=I,this.p=b,this.B(b.listen("onDidChangeLogLevel",I)(o=>{(0,a.isLogLevel)(o)?super.setLogLevel(o):super.setLogLevel(y.URI.revive(o[0]),o[1])})),this.B(b.listen("onDidChangeVisibility",I)(([o,d])=>super.setVisibility(y.URI.revive(o),d))),this.B(b.listen("onDidChangeLoggers",I)(({added:o,removed:d})=>{for(const h of o)super.registerLogger({...h,resource:y.URI.revive(h.resource)});for(const h of d)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new a.AdapterLogger({log:(I,E)=>{this.p.call("consoleLog",[I,E])}})}registerLogger(I){super.registerLogger(I),this.p.call("registerLogger",[I,this.n])}deregisterLogger(I){super.deregisterLogger(I),this.p.call("deregisterLogger",[I,this.n])}setLogLevel(I,E){super.setLogLevel(I,E),this.p.call("setLogLevel",[I,E])}setVisibility(I,E){super.setVisibility(I,E),this.p.call("setVisibility",[this.l(I),E])}m(I,E,m){return new k(this.p,I,E,m,this.n)}static setLogLevel(I,E,m){return I.call("setLogLevel",[E,m])}}e.LoggerChannelClient=C;class k extends a.AbstractMessageLogger{constructor(I,E,m,p,b){super(p?.logLevel==="always"),this.m=I,this.n=E,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[E,p,b]).then(()=>{this.r(this.l),this.k=!0})}g(I,E){const m=[[I,E]];this.k?this.r(m):this.l.push(...m)}r(I){this.m.call("log",[this.n,I])}}class v{constructor(I,E){this.a=I,this.b=E}listen(I,E){const m=this.b(I);switch(E){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(b=>this.c(b,m)),removed:[...p.removed].map(b=>this.c(b,m))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,p=>[m.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,p=>(0,a.isLogLevel)(p)?p:[m.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${E}`)}async call(I,E,m){const p=this.b(I);switch(E){case"setLogLevel":return(0,a.isLogLevel)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(y.URI.revive(p.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,p)))}throw new Error(`Call not found: ${E}`)}c(I,E){return{...I,resource:E.transformOutgoingURI(I.resource)}}}e.LoggerChannel=v;class g extends D.Disposable{constructor(I,E){super(),E.call("setLogLevel",[I.getLogLevel()]),this.B(I.onDidChangeLogLevel(m=>E.call("setLogLevel",[m]))),E.call("getRegisteredLoggers").then(m=>{for(const p of m)I.registerLogger({...p,resource:y.URI.revive(p.resource)})}),this.B(E.listen("onDidChangeVisibility")(([m,p])=>I.setVisibility(y.URI.revive(m),p))),this.B(E.listen("onDidChangeLoggers")(({added:m,removed:p})=>{for(const b of m)I.registerLogger({...b,resource:y.URI.revive(b.resource)});for(const b of p)I.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=g}),define(pe[110],ve([1,0,2,12]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class a extends y.Disposable{constructor(C,k=[]){super(),this.a=new R.MultiplexLogger([C,...k]),this.B(C.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.LogService=a}),define(pe[223],ve([1,0,16,12]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var a;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(a||(a={}));async function D(g,T,I,E,m){try{const p=await new Promise((o,d)=>{ae(["spdlog"],o,d)});p.setFlushOn(a.Trace);const b=await p.createAsyncRotatingLogger(g,T,I,E);return m?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(p){console.error(p)}return null}function C(g,T,I){switch(T){case R.LogLevel.Trace:g.trace(I);break;case R.LogLevel.Debug:g.debug(I);break;case R.LogLevel.Info:g.info(I);break;case R.LogLevel.Warning:g.warn(I);break;case R.LogLevel.Error:g.error(I);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function k(g,T){switch(T){case R.LogLevel.Trace:g.setLevel(a.Trace);break;case R.LogLevel.Debug:g.setLevel(a.Debug);break;case R.LogLevel.Info:g.setLevel(a.Info);break;case R.LogLevel.Warning:g.setLevel(a.Warning);break;case R.LogLevel.Error:g.setLevel(a.Error);break;case R.LogLevel.Off:g.setLevel(a.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class v extends R.AbstractMessageLogger{constructor(T,I,E,m,p){super(),this.k=[],this.setLevel(p),this.l=this.n(T,I,E,m),this.B(this.onDidChangeLogLevel(b=>{this.m&&k(this.m,b)}))}async n(T,I,E,m){const p=E?6:1,b=30/p*y.ByteSize.MB,o=await D(T,I,b,p,m);if(o){this.m=o,k(this.m,this.getLevel());for(const{level:d,message:h}of this.k)C(this.m,d,h);this.k=[]}}g(T,I){this.m?C(this.m,T,I):this.getLevel()<=T&&this.k.push({level:T,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=v}),define(pe[111],ve([1,0,21,12,223]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class D extends R.AbstractLoggerService{m(k,v,g){return new a.SpdLogLogger((0,y.generateUuid)(),k.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,v)}}e.LoggerService=D}),define(pe[224],ve([1,0,59,185,5]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var C;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function g(p,b){return b-p}v.compare=g;const T=Object.create(null);T[v.Error]=(0,R.localize)(0,null),T[v.Warning]=(0,R.localize)(1,null),T[v.Info]=(0,R.localize)(2,null);function I(p){return T[p]||""}v.toString=I;function E(p){switch(p){case y.default.Error:return v.Error;case y.default.Warning:return v.Warning;case y.default.Info:return v.Info;case y.default.Ignore:return v.Hint}}v.fromSeverity=E;function m(p){switch(p){case v.Error:return y.default.Error;case v.Warning:return y.default.Warning;case v.Info:return y.default.Info;case v.Hint:return y.default.Ignore}}v.toSeverity=m}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(v){const g="";function T(E){return I(E,!0)}v.makeKey=T;function I(E,m){const p=[g];return E.source?p.push(E.source.replace("\xA6","\\\xA6")):p.push(g),E.code?typeof E.code=="string"?p.push(E.code.replace("\xA6","\\\xA6")):p.push(E.code.value.replace("\xA6","\\\xA6")):p.push(g),E.severity!==void 0&&E.severity!==null?p.push(C.toString(E.severity)):p.push(g),E.message&&m?p.push(E.message.replace("\xA6","\\\xA6")):p.push(g),E.startLineNumber!==void 0&&E.startLineNumber!==null?p.push(E.startLineNumber.toString()):p.push(g),E.startColumn!==void 0&&E.startColumn!==null?p.push(E.startColumn.toString()):p.push(g),E.endLineNumber!==void 0&&E.endLineNumber!==null?p.push(E.endLineNumber.toString()):p.push(g),E.endColumn!==void 0&&E.endColumn!==null?p.push(E.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}v.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,a.createDecorator)("markerService")}),define(pe[68],ve([1,0,6,56,2,5]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class C extends a.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const T=Object.keys(this.f).length;return this.f={...g,...this.f},T!==Object.keys(this.f).length&&await this.i(g),R.Iterable.reduce(this.g.entries(),(I,[E,m])=>({...I,[E]:m}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(g,[T,I])=>({...g,[T]:{definition:I,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=C;class k{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(pe[52],ve([1,0,3,28]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.context<"u"){const D=y.globals.vscode.context.configuration();if(D)a=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:D.version})}Object.assign(a,{extensionsGallery:R.env.EXTENSIONS_GALLERY?JSON.parse(R.env.EXTENSIONS_GALLERY):a.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else a={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.77.2",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.77.3",commit:"704ed70d4fd1c6bd6342c436f1ede30d1cff4710",date:"2023-04-13T18:36:32.554Z"},Object.keys(a).length===0&&Object.assign(a,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(pe[26],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[40],ve([1,0,91,8]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class a{constructor(){this.a=new Map}add(C,k){y.ok(R.isString(C)),y.ok(R.isObject(k)),y.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new a}),define(pe[225],ve([1,0,6,40]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function a(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class D{constructor(){this.b=new y.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,g){this.a[a(v)]=g,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const C=new D;R.Registry.add(e.Extensions.JSONContribution,C)}),define(pe[53],ve([1,0,18,6,8,167,24,225,40]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=v.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:l}of t)for(const c in i)if(n.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),u=s?.valuesSources??new Map;if(l)for(const B of Object.keys(i[c]))u.set(B,l);const S={...s?.value||{},...i[c]};this.a.set(c,{source:l,value:S,valuesSources:u});const A=(0,C.getLanguageTagSettingPlainKey)(c),O={type:"object",default:S,description:D.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:a.isString(l)?void 0:l,defaultValueSource:l};r.push(...b(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:i[c],source:l});const s=this.d[c];s&&(this.w(c,s),this.r(c,s))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const l in r){const c=this.a.get(l),s=a.isString(i)?i:i?.id,u=a.isString(c?.source)?c?.source:c?.source?.id;if(s===u)if(n.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const S=this.d[l];S&&(this.w(l,S),this.r(l,S))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const l in i.properties){n.add(l);const c=this.d[l];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[l],this.s(l,i.properties[l])}i.allOf?.forEach(l=>r(l))};for(const i of t){r(i);const l=this.c.indexOf(i);l!==-1&&this.c.splice(l,1)}}p(t,n=!0,r,i,l=3,c){l=a.isUndefinedOrNull(t.scope)?l:t.scope;const s=t.properties;if(s)for(const S in s){const A=s[S];if(n&&f(S,A)){delete s[S];continue}if(A.source=r,A.defaultDefaultValue=s[S].default,this.w(S,A),e.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=a.isUndefinedOrNull(A.scope)?l:A.scope,A.restricted=a.isUndefinedOrNull(A.restricted)?!!i?.includes(S):A.restricted),s[S].hasOwnProperty("included")&&!s[S].included){this.f[S]=s[S],delete s[S];continue}else this.d[S]=s[S],s[S].policy?.name&&this.e.set(s[S].policy.name,S);!s[S].deprecationMessage&&s[S].markdownDeprecationMessage&&(s[S].deprecationMessage=s[S].markdownDeprecationMessage),c.add(S)}const u=t.allOf;if(u)for(const S of u)this.p(S,n,r,i,l,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const c in i)this.r(c,i[c]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,l=r?.source;a.isUndefined(i)&&(i=n.defaultDefaultValue,l=void 0),a.isUndefined(i)&&(i=d(n.type)),n.default=i,n.defaultValueSource=l}}const m="\\[([^\\]]+)\\]",p=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(L){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let n=p.exec(L);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=p.exec(L)}}return(0,y.distinct)(t)}e.overrideIdentifiersFromKey=b;function o(L){return L.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=o;function d(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new E;v.Registry.add(e.Extensions.Configuration,h);function f(L,t){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?D.localize(7,null,L):h.getConfigurationProperties()[L]!==void 0?D.localize(8,null,L):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,L,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=f;function w(){const L=[],t=h.getConfigurationProperties();for(const n of Object.keys(t))L.push([n,t[n].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=w}),define(pe[112],ve([1,0,18,6,72,2,27,22,8,4,24,53,40]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(n){return Object.isFrozen(n)?n:k.deepFreeze(n)}class p{constructor(r={},i=[],l=[],c){this.b=r,this.c=i,this.d=l,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof p)return i;const l=new b("");return l.parseRaw(i),l.configurationModel});this.f=r.reduce((i,l)=>l===i?l:i.merge(l),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const l=this.rawConfiguration.getValue(r),c=i?this.rawConfiguration.getOverrideValue(r,i):void 0,s=i?this.rawConfiguration.override(i).getValue(r):l;return{value:l,override:c,merged:s}}getOverrideValue(r,i){const l=this.i(i);return l?r?(0,T.getConfigurationValue)(l,r):l:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const l of this.overrides)l.identifiers.includes(r)&&i.push(...l.keys);return y.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return y.distinct(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=k.deepClone(this.contents),l=k.deepClone(this.overrides),c=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of r)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(i,u.contents);for(const S of u.overrides){const[A]=l.filter(O=>y.equals(O.identifiers,S.identifiers));A?(this.h(A.contents,S.contents),A.keys.push(...S.keys),A.keys=y.distinct(A.keys)):l.push(k.deepClone(S))}for(const S of u.keys)c.indexOf(S)===-1&&c.push(S)}return new p(i,c,l,s.every(u=>u instanceof p)?void 0:s)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const l={};for(const c of y.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[c];const u=i[c];u&&(typeof s=="object"&&typeof u=="object"?(s=k.deepClone(s),this.h(s,u)):s=u),l[c]=s}return new p(l,this.keys,this.overrides)}h(r,i){for(const l of Object.keys(i)){if(l in r&&v.isObject(r[l])&&v.isObject(i[l])){this.h(r[l],i[l]);continue}r[l]=k.deepClone(i[l])}}i(r){let i=null,l=null;const c=s=>{s&&(l?this.h(l,s):l=k.deepClone(s))};for(const s of this.overrides)y.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&c(s.contents);return c(i),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(l=>y.equals(l.identifiers,(0,I.overrideIdentifiersFromKey)(r))),1))}j(r,i,l){(0,T.addToValueTree)(this.contents,r,i,c=>console.error(c)),l=l||this.keys.indexOf(r)===-1,l&&this.keys.push(r),I.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],c=>console.error(c))})}}e.ConfigurationModel=p;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!v.isUndefinedOrNull(r)){const l=this.g(r);this.parseRaw(l,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:l,keys:c,overrides:s,restricted:u,hasExcludedProperties:S}=this.h(r,i);this.b=new p(l,c,s,S?[r]:void 0),this.c=u||[]}g(r){let i={},l=null,c=[];const s=[],u=[];function S(O){Array.isArray(c)?c.push(O):l!==null&&(c[l]=O)}const A={onObjectBegin:()=>{const O={};S(O),s.push(c),c=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const O=[];S(O),s.push(c),c=O,l=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:S,onError:(O,B,q)=>{u.push({error:O,offset:B,length:q})}};if(r)try{a.visit(r,A),i=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(r,i){const l=E.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.i(r,l,!0,i);r=c.raw;const s=(0,T.toValuesTree)(r,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),u=Object.keys(r),S=this.j(r,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:s,keys:u,overrides:S,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,i,l,c){let s=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const u={},S=[];for(const A in r)if(I.OVERRIDE_PROPERTY_REGEX.test(A)&&l){const O=this.i(r[A],i,!1,c);u[A]=O.raw,s=s||O.hasExcludedProperties,S.push(...O.restricted)}else{const O=i[A],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&S.push(A),(B===void 0||c.scopes===void 0||c.scopes.includes(B))&&!(c.skipRestricted&&O?.restricted)?u[A]=r[A]:s=!0}return{raw:u,restricted:S,hasExcludedProperties:s}}j(r,i){const l=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const s={};for(const u in r[c])s[u]=r[c][u];l.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(s),contents:(0,T.toValuesTree)(s,i)})}return l}}e.ConfigurationModelParser=b;class o extends D.Disposable{constructor(r,i,l,c){super(),this.f=r,this.g=i,this.h=c,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&l.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class d{constructor(r,i,l,c,s,u,S,A,O,B,q,le,fe){this.a=r,this.b=i,this.c=l,this.overrideIdentifiers=c,this.d=s,this.f=u,this.g=S,this.h=A,this.i=O,this.j=B,this.k=q,this.l=le,this.m=fe}get value(){return m(this.c)}n(r,i,l){const c=r.inspect(i,l);return{get value(){return m(c.value)},get override(){return m(c.override)},get merged(){return m(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,l,c,s=new p,u=new p,S=new C.ResourceMap,A=new p,O=new C.ResourceMap){this.c=r,this.d=i,this.f=l,this.g=c,this.h=s,this.i=u,this.j=S,this.l=A,this.m=O,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(r,i,l){return this.q(r,i,l).getValue(r)}updateValue(r,i,l={}){let c;l.resource?(c=this.m.get(l.resource),c||(c=new p,this.m.set(l.resource,c))):c=this.l,i===void 0?c.removeValue(r):c.setValue(r,i),l.resource||(this.a=null)}inspect(r,i,l){const c=this.q(r,i,l),s=this.u(i.resource,l),u=i.resource?this.m.get(i.resource)||this.l:this.l,S=new Set;for(const A of c.overrides)for(const O of A.identifiers)c.getOverrideValue(r,O)!==void 0&&S.add(O);return new d(r,i,c.getValue(r),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,s||void 0,u)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const l=[];if(!i){const{added:c,updated:s,removed:u}=L(this.c,r);i=[...c,...s,...u]}for(const c of i)for(const s of(0,I.overrideIdentifiersFromKey)(c)){const u=this.c.getKeysForOverrideIdentifier(s),S=r.getKeysForOverrideIdentifier(s),A=[...S.filter(O=>u.indexOf(O)===-1),...u.filter(O=>S.indexOf(O)===-1),...u.filter(O=>!k.equals(this.c.override(s).getValue(O),r.override(s).getValue(O)))];l.push([s,A])}return this.updateDefaultConfiguration(r),{keys:i,overrides:l}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:l,removed:c}=L(this.d,r),s=[...i,...l,...c];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.applicationConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.localUserConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.remoteUserConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:l,removed:c,overrides:s}=L(this.workspaceConfiguration,r),u=[...i,...l,...c];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const l=this.p.get(r),{added:c,updated:s,removed:u,overrides:S}=L(l,i),A=[...c,...s,...u];return(A.length||!l)&&this.updateFolderConfiguration(r,i),{keys:A,overrides:S}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:l,updated:c,removed:s,overrides:u}=L(i,void 0);return{keys:[...l,...c,...s],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,l){let c=this.r(i,l);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}r({resource:r},i){let l=this.s();if(i&&r){const c=i.getFolder(r);c&&(l=this.t(c.uri)||l);const s=this.m.get(r);s&&(l=l.merge(s))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const l=this.s(),c=this.j.get(r);c?(i=l.merge(c),this.b.set(r,i)):i=l}return i}u(r,i){if(i&&r){const l=i.getFolder(r);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:l,overrides:c,keys:s}=this.j.get(i);return r.push([i,{contents:l,overrides:c,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(l=>r.add(l))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(l=>r.add(l))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.i.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.x(r.defaults),l=this.x(r.policy),c=this.x(r.application),s=this.x(r.user),u=this.x(r.workspace),S=r.folders.reduce((A,O)=>(A.set(g.URI.revive(O[0]),this.x(O[1])),A),new C.ResourceMap);return new h(i,l,c,s,new p,u,S,new p,new C.ResourceMap)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=h;function f(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const c of n)c.keys.forEach(s=>r.add(s)),c.overrides.forEach(([s,u])=>{const S=(0,C.getOrSet)(i,s,new Set);u.forEach(A=>S.add(A))});const l=[];return i.forEach((c,s)=>l.push([s,[...c.values()]])),{keys:[...r.values()],overrides:l}}e.mergeChanges=f;class w{constructor(r,i,l,c){this.change=r,this.f=i,this.g=l,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of r.keys)this.affectedKeys.add(s);for(const[,s]of r.overrides)for(const u of s)this.affectedKeys.add(u);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const l=this.a+r,c=this.d.indexOf(l);if(c<0)return!1;const s=c+l.length;if(s>=this.d.length)return!1;const u=this.d.charCodeAt(s);if(u!==this.b&&u!==this.c)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,A=this.g.getValue(r,i,this.h);return!k.equals(S,A)}return!0}}e.ConfigurationChangeEvent=w;function L(n,r){const{added:i,removed:l,updated:c}=t(r?.rawConfiguration,n?.rawConfiguration),s=[],u=n?.getAllOverrideIdentifiers()||[],S=r?.getAllOverrideIdentifiers()||[];if(r){const A=S.filter(O=>!u.includes(O));for(const O of A)s.push([O,r.getKeysForOverrideIdentifier(O)])}if(n){const A=u.filter(O=>!S.includes(O));for(const O of A)s.push([O,n.getKeysForOverrideIdentifier(O)])}if(r&&n){for(const A of u)if(S.includes(A)){const O=t({contents:n.getOverrideValue(void 0,A)||{},keys:n.getKeysForOverrideIdentifier(A)},{contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)});s.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:l,updated:c,overrides:s}}function t(n,r){const i=n?r?n.keys.filter(s=>r.keys.indexOf(s)===-1):[...n.keys]:[],l=r?n?r.keys.filter(s=>n.keys.indexOf(s)===-1):[...r.keys]:[],c=[];if(n&&r){for(const s of r.keys)if(n.keys.indexOf(s)!==-1){const u=(0,T.getConfigurationValue)(r.contents,s),S=(0,T.getConfigurationValue)(n.contents,s);k.equals(u,S)||c.push(s)}}return{added:i,removed:l,updated:c}}}),define(pe[226],ve([1,0,18,6,2,22,8,112,53,12,68,40]),function(ae,e,y,R,a,D,C,k,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class E extends a.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:d})=>this.c(Array.from(o),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,d){this.h(o,I.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new k.ConfigurationModel;const o=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,d){const h=this.f();for(const f of o){const w=h[f],L=d[f];w!==void 0?this.b.addValue(f,w):L?this.b.addValue(f,L.default):this.b.removeValue(f)}}}e.DefaultConfiguration=E;class m{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let p=class extends a.Disposable{get configurationModel(){return this.b}constructor(o,d,h){super(),this.c=o,this.f=d,this.g=h,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const d={},h=[],f=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const w of o){const L=f[w];if(!L){h.push(w);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}h.push(w),d[L.policy.name]={type:L.type}}}return(0,C.isEmptyObject)(d)||await this.f.updatePolicyDefinitions(d),h}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const d=I.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),h=(0,y.coalesce)(o.map(f=>d.get(f)));this.j(h,!0)}j(o,d){this.g.trace("PolicyConfiguration#update",o);const h=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),f=[],w=this.b.isEmpty();for(const L of o){const t=h[L]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(w?n!==void 0:!(0,D.equals)(this.b.getValue(L),n))&&f.push([L,n])}else this.b.getValue(L)!==void 0&&f.push([L,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const L=this.b;this.b=new k.ConfigurationModel;for(const t of L.keys)this.b.setValue(t,L.getValue(t));for(const[t,n]of f)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);d&&this.a.fire(this.b)}}};p=Re([Ae(1,T.IPolicyService),Ae(2,g.ILogService)],p),e.PolicyConfiguration=p}),define(pe[113],ve([1,0,14,6,2,19,24,112,226,68]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends a.Disposable{constructor(E,m,p,b){super(),this.i=E,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.DefaultConfiguration),this.c=p instanceof g.NullPolicyService?new v.NullPolicyConfiguration:this.B(new v.PolicyConfiguration(this.b,p,b)),this.f=this.B(new k.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,m)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:d})=>this.k(o,d))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,m,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(E,m,new k.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(E,m){const p=typeof E=="string"?E:void 0,b=(0,C.isConfigurationOverrides)(E)?E:(0,C.isConfigurationOverrides)(m)?m:{};return this.a.getValue(p,b,void 0)}updateValue(E,m,p,b){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const m=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(p,m,2)}k(E,m){const p=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(E,m);this.m(b,p,7)}l(E){const m=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(E);this.m(p,m,7)}m(E,m,p){const b=new k.ConfigurationChangeEvent(E,{data:m},this.a);b.source=p,b.sourceConfig=this.n(p),this.h.fire(b)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(pe[114],ve([1,0,9,5]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var a;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(a=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends y.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof D&&v._code===a.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof D&&v._code===a.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof D&&v._code===a.NoResolverFound}static isHandled(v){return v instanceof D&&v.isHandled}constructor(v,g=a.Unknown,T){super(v),this._message=v,this._code=g,this._detail=T,this.isHandled=g===a.NotAvailable&&T===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function C(k){const v=k.indexOf("+");return v===-1?k:k.substring(0,v)}e.getRemoteAuthorityPrefix=C}),define(pe[227],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,y.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(pe[54],ve([1,0,13]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(g){return g.scheme===y.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=R;function a(g){if(!g)return;const T=g.indexOf("+");return T<0?g:g.substr(0,T)}e.getRemoteName=a;function D(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=D;function C(g){const{host:T,port:I}=v(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:I}}e.parseAuthorityWithPort=C;function k(g,T){let{host:I,port:E}=v(g);return typeof E>"u"&&(E=T),{host:I,port:E}}e.parseAuthorityWithOptionalPort=k;function v(g){const T=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=g.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:g,port:void 0}}}),define(pe[36],ve([1,0,17,5,54]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var k;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class v{constructor(o){this.value=o,this.c=o.toLowerCase()}static equals(o,d){if(typeof o>"u"||o===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof o=="string"||typeof d=="string"){const h=typeof o=="string"?o:o.value,f=typeof d=="string"?d:d.value;return y.equalsIgnoreCase(h,f)}return o.c===d.c}static toKey(o){return typeof o=="string"?o.toLowerCase():o.c}}e.ExtensionIdentifier=v;class g{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const d of o)this.add(d)}add(o){this.c.add(v.toKey(o))}delete(o){return this.c.delete(v.toKey(o))}has(o){return this.c.has(v.toKey(o))}}e.ExtensionIdentifierSet=g;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(v.toKey(o))}get(o){return this.c.get(v.toKey(o))}has(o){return this.c.has(v.toKey(o))}set(o,d){this.c.set(v.toKey(o),d)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function I(b){return E(b)}e.isApplicationScopedExtension=I;function E(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(b,o){if(o){const d=`onResolveRemoteAuthority:${(0,a.getRemoteName)(o)}`;return!!b.activationEvents?.includes(d)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[228],ve([1,0,9,36]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class a{constructor(){this.a=new Map,this.b=new WeakMap}register(C,k){this.a.set(C,k)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const k=Object.create(null);for(const v of C){const g=this.readActivationEvents(v);g.length>0&&(k[R.ExtensionIdentifier.toKey(v.identifier)]=g)}return k}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const k=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];if(!C.contributes)return k;for(const v in C.contributes){const g=this.a.get(v);if(!g)continue;const T=C.contributes[v],I=Array.isArray(T)?T:[T];try{g(I,k)}catch(E){(0,y.onUnexpectedError)(E)}}return k}}e.ImplicitActivationEventsImpl=a,e.ImplicitActivationEvents=new a}),define(pe[229],ve([1,0,2,36,16]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends y.Disposable{constructor(k,v,g,T,I){super(),this.a=k,this.b=v,this.c=g,this.f=I,this.B(T.onDidInstallExtensions(E=>this.g(E))),this.B(T.onDidUninstallExtension(E=>this.h(E)))}g(k){for(const v of k)v.local&&this.invalidate(v.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,k)&&await this.i(v);else await this.i(this.a.defaultProfile)}async i(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,R.USER_MANIFEST_CACHE_FILE))}catch(v){(0,a.toFileOperationResult)(v)!==1&&this.f.error(v)}}}e.ExtensionsManifestCache=D}),define(pe[44],ve([1,0,15,9,2,186,53,5,12,40]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class T{constructor(L){this.b=L}toJSON(){if(!this.a){const L=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?L[t]="*****":L[t]=this.b[t];this.a=L}return this.a}}class I extends a.Disposable{constructor(L,t){super(),this.b=0,this.a=t.createLogger(L?"remotenetwork":"network",{name:L?(0,D.localize)(0,null):(0,D.localize)(1,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async c(L,t,n){const r=`${L} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new T(t.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.getErrorMessage)(i)),i}}}e.AbstractRequestService=I;function E(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.isSuccess=E;function m(w){return w.res.statusCode===204}async function p(w){return m(w)?null:(await(0,y.streamToBuffer)(w.stream)).toString()}e.asText=p;async function b(w){if(!E(w))throw new Error("Server returned "+w.res.statusCode);return p(w)}e.asTextOrError=b;async function o(w){if(!E(w))throw new Error("Server returned "+w.res.statusCode);if(m(w))return null;const t=(await(0,y.streamToBuffer)(w.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=o;function d(w){f(w)}e.updateProxyConfigurationsScope=d;let h;function f(w){const L=g.Registry.as(C.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,D.localize)(2,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[h],remove:t?[t]:[]})}f(1)}),define(pe[230],ve([1,0,20,13,16,44]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let C=class{constructor(v,g){this.a=v,this.b=g}async download(v,g,T=y.CancellationToken.None){if(v.scheme===R.Schemas.file||v.scheme===R.Schemas.vscodeRemote){await this.b.copy(v,g);return}const I={type:"GET",url:v.toString(!0)},E=await this.a.request(I,T);if(E.res.statusCode===200)await this.b.writeFile(g,E.stream);else{const m=await(0,D.asTextOrError)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${m}`)}}};C=Re([Ae(0,D.IRequestService),Ae(1,a.IFileService)],C),e.DownloadService=C}),define(pe[231],ve([1,0,15,20]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class a{constructor(k){this.a=k}listen(k,v){throw new Error("Invalid listen")}call(k,v,g,T=R.CancellationToken.None){switch(v){case"request":return this.a.request(g[0],T).then(async({res:I,stream:E})=>{const m=await(0,y.streamToBuffer)(E);return[{statusCode:I.statusCode,headers:I.headers},m]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=a;class D{constructor(k){this.a=k}async request(k,v){const[g,T]=await this.a.call("request",[k],v);return{res:g,stream:(0,y.bufferToStream)(T)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=D}),define(pe[232],ve([1,0,82,8]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function a(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function D(C,k,v={}){const g=(0,y.parse)(C),T=v.proxyUrl||a(g,k);if(!T)return null;const I=(0,y.parse)(T);if(!/^https?:$/.test(I.protocol||""))return null;const E={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,R.isBoolean)(v.strictSSL)?v.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((m,p)=>{ae(["http-proxy-agent"],m,p)}))(E):new(await new Promise((m,p)=>{ae(["https-proxy-agent"],m,p)}))(E)}e.getProxyAgent=D}),define(pe[83],ve([1,0,49,7,187,20,39,9,3,21,155,204,14,142]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function b(d,h,f,w){return f["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(w)&&!f["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(w)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=E.Promises.withAsyncBody(async(L,t)=>{const n=new D.CancellationTokenSource;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,m.clamp)(i,1,120)*1e3);const l=setTimeout(()=>{n.dispose(!0),t(new Error((0,a.localize)(0,null)))},r);try{L(await o(h,n.token))}catch(c){!(0,k.isCancellationError)(c)&&!n.token.isCancellationRequested?t(new Error((0,a.localize)(1,null,(0,C.toErrorMessage)(c)))):L({})}finally{clearTimeout(l),n.dispose()}})),p)}e.getResolvedShellEnv=b;async function o(d,h){const f=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",f);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",w);const L=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(L+"({.*})"+L),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,T.getSystemShell)(v.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,l)=>{if(h.isCancellationRequested)return l(new k.CancellationError);const c=(0,R.basename)(r);let s,u;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${S} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,u=["-Login","-Command"]):(s=`'${process.execPath}' ${S} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,c==="tcsh"||c==="csh"?u=["-ic"]:u=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),s);const A=(0,y.spawn)(r,[...u,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});h.onCancellationRequested(()=>(A.kill(),l(new k.CancellationError))),A.on("error",q=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(q)),l(q)});const O=[];A.stdout.on("data",q=>O.push(q));const B=[];A.stderr.on("data",q=>B.push(q)),A.on("close",(q,le)=>{const fe=Buffer.concat(O).toString("utf8");d.trace("getUnixShellEnvironment#raw",fe);const ue=Buffer.concat(B).toString("utf8");if(ue.trim()&&d.trace("getUnixShellEnvironment#stderr",ue),q||le)return l(new Error((0,a.localize)(2,null,q,le)));const re=t.exec(fe),_=re?re[1]:"{}";try{const ee=JSON.parse(_);f?ee.ELECTRON_RUN_AS_NODE=f:delete ee.ELECTRON_RUN_AS_NODE,w?ee.ELECTRON_NO_ATTACH_CONSOLE=w:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.VSCODE_RESOLVING_ENVIRONMENT,delete ee.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ee),i(ee)}catch(ee){d.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(ee)),l(ee)}})})}}),define(pe[233],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,y.createDecorator)("stateReadService"),e.IStateService=(0,y.createDecorator)("stateService")}),define(pe[234],ve([1,0,14,15,8,25,16,12]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var v;(function(E){E[E.IMMEDIATE=0]="IMMEDIATE",E[E.DELAYED=1]="DELAYED"})(v=e.SaveStrategy||(e.SaveStrategy={}));class g{constructor(m,p,b,o){this.f=m,this.g=b,this.h=o,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=p===0?void 0:new y.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,p){const b=this.a[m];return(0,a.isUndefinedOrNull)(b)?p:b}setItem(m,p){this.setItems([{key:m,data:p}])}setItems(m){let p=!1;for(const{key:b,data:o}of m)this.a[b]!==o&&((0,a.isUndefinedOrNull)(o)?(0,a.isUndefined)(this.a[b])||(this.a[b]=void 0,p=!0):(this.a[b]=o,p=!0));p&&this.j()}removeItem(m){(0,a.isUndefined)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(m)),this.b=m}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=g;let T=class{constructor(m,p,b,o){this.a=new g(p.stateResource,m,b,o)}async init(){await this.a.init()}getItem(m,p){return this.a.getItem(m,p)}};T=Re([Ae(1,D.IEnvironmentService),Ae(2,k.ILogService),Ae(3,C.IFileService)],T),e.StateReadonlyService=T;class I extends T{setItem(m,p){this.a.setItem(m,p)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.StateService=I}),define(pe[115],ve([1,0,3,28,21]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(v){if(y.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function C(v,g,T,I,E,m,p,b){const o=Object.create(null);o["common.machineId"]=m,o.sessionID=(0,a.generateUuid)()+Date.now(),o.commitHash=I,o.version=E,o["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,y.PlatformToString)(y.platform),o["common.nodePlatform"]=R.platform,o["common.nodeArch"]=T,o["common.product"]=b||"desktop",p&&(o["common.msftInternal"]=p);let d=0;const h=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),y.isLinuxSnap&&(o["common.snap"]="true");const f=D(g);return f&&(o["common.platformDetail"]=f),o}e.resolveCommonProperties=C;function k(v){const g=R.env.USERDNSDOMAIN;if(!g)return!1;const T=g.toLowerCase();return v.some(I=>T===I)}e.verifyMicrosoftInternalDomain=k}),define(pe[235],ve([1,0,18,9,2,22,16]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(g){function T(I,E){return I.callstack<E.callstack?-1:I.callstack>E.callstack?1:0}g.compare=T})(k=e.ErrorEvent||(e.ErrorEvent={}));class v{constructor(T,I=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new a.DisposableStore,this.c=T,this.d=I;const E=R.errorHandler.addListener(m=>this.j(m));this.h.add((0,a.toDisposable)(E)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),R.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof C.FileOperationError||T?.message?.includes("Unable to read file")))return;const I=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,E=T.message?T.message:(0,D.safeStringify)(T);!I||this.k({msg:E,callstack:I})}k(T){const I=(0,y.binarySearch)(this.g,T,k.compare);I<0?(T.count=1,this.g.splice(~I,0,T)):(this.g[I].count||(this.g[I].count=0),this.g[I].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(pe[236],ve([1,0,2]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class R extends y.Disposable{constructor(D,C){super(),this.a=D,this.b=C}async call(D,C,k){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:v}=k;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:g}=k;return this.b?this.b.log(v,g):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(D,C,k){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=R}),define(pe[31],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var a;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(a=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(pe[237],ve([1,0,29,14,72,13,7,3,4,97,23,101,210,16,26,31]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const o=new Map;async function d(t,n){const r=`${t}::${n.join(":")}`,i=o.get(r);if(i)return i;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,u=2e4;function S(O,B,q,le){const fe=B.substring(O.length+1);return R.Promises.withAsyncBody(async ue=>{let re;try{re=await T.Promises.readdir(B,{withFileTypes:!0})}catch{ue();return}if(le.count>=u){le.count+=re.length,le.maxReached=!0,ue();return}let _=re.length;if(_===0){ue();return}let ee=re;le.count+re.length>u&&(le.maxReached=!0,_=u-le.count,ee=re.slice(0,_)),le.count+=re.length;for(const ne of ee)if(ne.isDirectory()){if(q.includes(ne.name)||await S(O,(0,C.join)(B,ne.name),q,le),--_===0){ue();return}}else{const ie=ne.name.lastIndexOf(".");if(ie>=0){const G=ne.name.substring(ie+1);G&&c.set(G,(c.get(G)??0)+1)}for(const G of l)G.relativePathPattern?.test(fe)!==!1&&G.filePattern.test(ne.name)&&s.set(G.tag,(s.get(G.tag)??0)+1);if(--_===0){ue();return}}})}const A=R.Promises.withAsyncBody(async O=>{const B={count:0,maxReached:!1};await S(t,t,n,B);const q=await w(t);O({configFiles:h(s),fileTypes:h(c),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:q})});return o.set(r,A),A}e.collectWorkspaceStats=d;function h(t){return Array.from(t.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function f(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.virtualMachineHint.value()*100)}%`},n=y.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=f;async function w(t){try{const n=new Map,r=(0,C.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(r),l=[],c=(0,a.parse)(i.toString(),l);if(l.length)return console.log(`Unable to parse ${r}`),[];if((0,a.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const u=s.type;u&&(n.has(u)?n.set(u,n.get(u)+1):n.set(u,1))}return h(n)}catch{return[]}}e.collectLaunchConfigs=w;let L=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const i=y.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(y.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||r.push(`Load (avg):       ${y.loadavg().map(l=>Math.round(l)).join(", ")}`),r.push(`VM:               ${Math.round(g.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,I.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[l,c]=i,s=this.m(n,l);return r.forEach(u=>{if((0,E.isRemoteDiagnosticError)(u))s+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(s+=`

Remote: ${u.hostName}`,u.processes&&(s+=`
${this.m(n,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const S of Object.keys(u.workspaceMetadata)){const A=u.workspaceMetadata[S];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${S}): ${O}`,c+=this.h(A)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(n,r){const{memory:i,vmHint:l,os:c,cpus:s}=f(),u={os:c,memory:i,cpus:s,vmHint:l,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return k.isWindows||(u.load=`${y.loadavg().map(S=>Math.round(S)).join(", ")}`),k.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(n,r){const i=[];return(0,I.listProcesses)(n.mainPID).then(async l=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,l)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),r.forEach(c=>{if((0,E.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(n,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[s];let S=`${u.fileCount} files`;u.maxFilesReached&&(S=`more than ${S}`),i.push(`Folder (${s}): ${S}`),i.push(this.h(u))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const r=[];let l=0;const c=(A,O)=>{const B=` ${A}(${O})`;l+B.length>60?(r.push(s),s="|                 ",l=s.length):l+=B.length,s+=B};let s="|      File types:";const u=10,S=n.fileTypes.length>u?u:n.fileTypes.length;for(let A=0;A<S;A++){const O=n.fileTypes[A];c(O.name,O.count)}if(r.push(s),n.configFiles.length>=0&&(s="|      Conf files:",l=0,n.configFiles.forEach(A=>{c(A.name,A.count)}),r.push(s)),n.launchConfigFiles.length>0){let A="|      Launch Configs:";n.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),r.push(A)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const r=[],i=[];return n.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(r.push(`|  Window (${l.title})`),l.folderURIs.forEach(c=>{const s=v.URI.revive(c);if(s.scheme===D.Schemas.file){const u=s.fsPath;i.push(d(u,["node_modules",".git"]).then(S=>{let A=`${S.fileCount} files`;S.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,C.basename)(u)}): ${A}`),r.push(this.h(S))}).catch(S=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${S.toString()})`)}))}else r.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(l=>r.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}m(n,r){const i=new Map;n.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),n.pidToNames.forEach(({pid:c,name:s})=>i.set(c,s));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,i,l,r,0),l.join(`
`)}n(n,r,i,l,c){const s=c===0;let u;s?u=l.pid===n?`${this.d.applicationName} main`:"remote agent":r.has(l.pid)?u=r.get(l.pid):u=`${"  ".repeat(c)} ${l.name}`;const S=process.platform==="win32"?l.mem:y.totalmem()*(l.mem/100);i.push(`${l.load.toFixed(0).padStart(5," ")}	${(S/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(l.children)&&l.children.forEach(A=>this.n(n,r,i,A,c+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:i}of n.folders){const l=v.URI.revive(i);if(l.scheme!==D.Schemas.file)continue;const c=l.fsPath;try{(await d(c,["node_modules",".git"])).fileTypes.forEach(u=>r.add(u.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const i=v.URI.revive(r);if(i.scheme!==D.Schemas.file)continue;const l=i.fsPath;try{const c=await d(l,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};L=Re([Ae(0,b.ITelemetryService),Ae(1,p.IProductService)],L),e.DiagnosticsService=L}),define(pe[37],ve([1,0,22,8,6,24,54,115,31]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(l){this.value=l}}e.TelemetryTrustedValue=g;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class I{async publicLog(l,c,s){}async publicLogError(l,c,s){}}e.NullEndpointTelemetryService=I,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,l){return a.Event.debounce(l.onDidChangeConfiguration,(s,u)=>{const S=s?new Set([...s.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:S}},1e3,!0)(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(s.source),configurationKeys:Array.from(s.affectedKeys)})})}e.configurationTelemetry=E;function m(i,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!i.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=m;function p(i,l){return!(l.isBuilt||l.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=p;function b(i){const l=i.getValue(v.TELEMETRY_SETTING_ID),c=i.getValue(v.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function o(i){const l={},c={},s={};f(i,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const S=s[u];typeof S=="number"?c[u]=S:typeof S=="boolean"?c[u]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${S.length}`),l[u]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[u]=S)}return{properties:l,measurements:c}}e.validateTelemetryData=o;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const l=(0,C.getRemoteName)(i);return d.has(l)?l:"other"}e.cleanRemoteAuthority=h;function f(i,l,c=0,s){if(!!i)for(const u of Object.getOwnPropertyNames(i)){const S=i[u],A=s?s+u:u;Array.isArray(S)?l[A]=(0,y.safeStringify)(S):S instanceof Date?l[A]=S.toISOString():(0,R.isObject)(S)?c<2?f(S,l,c+1,A+"."):l[A]=(0,y.safeStringify)(S):l[A]=S}}function w(i,l){const c=i.msftInternalDomains||[],s=l.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(c)||s}e.isInternalTelemetry=w;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function t(i,l){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let c=i;const s=[];for(const O of l)for(;;){const B=O.exec(i);if(!B)break;s.push([B.index,O.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let A=0;for(c="";;){const O=S.exec(i);if(!O)break;const B=s.some(([q,le])=>O.index<le&&q<S.lastIndex);!u.test(O[0])&&!B&&(c+=i.substring(A,O.index)+"<REDACTED: user-file-path>",A=S.lastIndex)}return A<i.length&&(c+=i.substr(A)),c}function n(i){if(!i)return i;const l=i.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of c)if(s.regex.test(l))return`<REDACTED: ${s.label}>`;return i}function r(i,l){return(0,y.cloneAndChange)(i,c=>{if(c instanceof g)return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=t(s,l);for(const u of l)s=s.replace(u,"");return s=n(s),s}})}e.cleanData=r}),define(pe[34],ve([1,0,17,30,36,3,4,9,28,37]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,y.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=T;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const l=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,l,c)}static parse(i){const l=I.exec(i);return l&&l[1]&&l[2]?new E({id:l[1]},l[2],l[4]||void 0):null}constructor(i,l,c="undefined"){this.version=l,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=m.exec(r);return i&&i[1]?[o(i[1]),i[2]]:[o(r),void 0]}e.getIdAndVersion=p;function b(r,i){return`${r}.${i}`}e.getExtensionId=b;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function d(r,i){return o(b(r??a.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=d;function h(r,i){const l=[],c=s=>{for(const u of l)if(u.some(S=>T(i(S),i(s))))return u;return null};for(const s of r){const u=c(s);u?u.push(s):l.push([s])}return l}e.groupByExtension=h;function f(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function w(r){return{id:new g.TelemetryTrustedValue(r.identifier.id),name:new g.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new a.ExtensionIdentifier("pprice.better-merge");function L(r,i){const l=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&l.every(u=>!T(u.identifier,{id:s}))){const u=r.filter(S=>T(S.identifier,{id:s}));u.length===1&&(l.push(u[0]),c.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=L;async function t(r,i){if(!D.isLinux)return!1;let l;try{l=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(s))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const l=await t(r,i),c=(0,R.getTargetPlatform)(l?"alpine":D.platform,v.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=n}),define(pe[116],ve([1,0,20,9,13,19,51,4,174,30,34,36]),function(ae,e,y,R,a,D,C,k,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const E=o=>(0,v.localize)(0,null,o),m=(0,v.localize)(1,null,"ms-dotnettools.csharp");function p(o,d){return d?`${o.publisher}.${o.name}@${o.version}`:`${o.publisher}.${o.name}`}let b=class{constructor(d,h,f){this.a=d,this.b=h,this.d=f}get f(){}async listExtensions(d,h,f){let w=await this.b.getInstalled(1,f);const L=I.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(h&&h!==""){if(L.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),L.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),w=w.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let t;for(const n of w)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(p(n.manifest,d)))}async installExtensions(d,h,f,w){const L=[],t=[];d.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const n=[];let r=[];const i=(c,s,u)=>{r.push({id:c,version:s!=="prerelease"?s:void 0,installOptions:{...f,isBuiltin:u,installPreReleaseVersion:s==="prerelease"||f.installPreReleaseVersion}})};for(const c of d)if(c instanceof k.URI)n.push({vsix:c,installOptions:f});else{const[s,u]=(0,T.getIdAndVersion)(c);i(s,u,!1)}for(const c of h)if(c instanceof k.URI)n.push({vsix:c,installOptions:{...f,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,u]=(0,T.getIdAndVersion)(c);i(s,u,!0)}const l=await this.b.getInstalled(1,f.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:c,installOptions:s})=>{try{const u=await this.g(c,s,w,l);u&&t.push(u)}catch(u){this.a.error(u),L.push(c.toString())}})),r.length&&(r=r.filter(({id:c,version:s})=>{const u=l.find(S=>(0,T.areSameExtensions)(S.identifier,{id:c}));if(u){if(!w&&(!s||s==="prerelease"&&u.preRelease))return this.a.info((0,v.localize)(5,null,c,u.manifest.version,c)),!1;if(s&&u.manifest.version===s)return this.a.info((0,v.localize)(6,null,`${c}@${s}`)),!1}return!0}),r.length)){const c=await this.h(r);await Promise.all(r.map(async s=>{const u=c.get(s.id.toLowerCase());if(u)try{const S=await this.j(s,u,l);S&&t.push(S)}catch(S){this.a.error(S.message||S.stack||S),L.push(s.id)}else this.a.error(`${E(s.version?`${s.id}@${s.version}`:s.id)}
${m}`),L.push(s.id)}))}if(L.length)throw new Error((0,v.localize)(7,null,L.join(", ")))}async g(d,h,f,w){const L=await this.b.getManifest(d);if(!L)throw new Error("Invalid vsix");if(await this.l(L,f,h.profileLocation,w))try{return await this.b.install(d,h),this.a.info((0,v.localize)(8,null,(0,D.basename)(d))),L}catch(n){if((0,R.isCancellationError)(n))return this.a.info((0,v.localize)(9,null,(0,D.basename)(d))),null;throw n}return null}async h(d){const h=new Map,f=d.some(t=>t.installOptions.installPreReleaseVersion),w=await this.b.getTargetPlatform(),L=await this.d.getExtensions(d.map(t=>({...t,preRelease:f})),{targetPlatform:w},y.CancellationToken.None);for(const t of L)h.set(t.identifier.id.toLowerCase(),t);return h}async j({id:d,version:h,installOptions:f},w,L){const t=await this.d.getManifest(w,y.CancellationToken.None);if(t&&!this.k(t))return null;const n=L.find(r=>(0,T.areSameExtensions)(r.identifier,w.identifier));if(n){if(w.version===n.manifest.version)return this.a.info((0,v.localize)(10,null,h?`${d}@${h}`:d)),null;this.a.info((0,v.localize)(11,null,d,w.version))}try{f.isBuiltin?this.a.info(h?(0,v.localize)(12,null,d,h):(0,v.localize)(13,null,d)):this.a.info(h?(0,v.localize)(14,null,d,h):(0,v.localize)(15,null,d));const r=await this.b.installFromGallery(w,{...f,installGivenVersion:!!h});return this.a.info((0,v.localize)(16,null,d,r.manifest.version)),t}catch(r){if((0,R.isCancellationError)(r))return this.a.info((0,v.localize)(17,null,d)),null;throw r}}k(d){return!0}async l(d,h,f,w){if(!h){const L={id:(0,T.getGalleryExtensionId)(d.publisher,d.name)},t=w.find(n=>(0,T.areSameExtensions)(L,n.identifier)&&(0,C.gt)(n.manifest.version,d.version));if(t)return this.a.info((0,v.localize)(18,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,h,f){const w=async t=>{if(t instanceof k.URI){const n=await this.b.getManifest(t);return p(n)}return t},L=[];for(const t of d){const n=await w(t),i=(await this.b.getInstalled(void 0,f)).filter(l=>(0,T.areSameExtensions)(l.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${m}`);if(i.some(l=>l.type===0)){this.a.info((0,v.localize)(19,null,n));return}if(!h&&i.some(l=>l.isBuiltin)){this.a.info((0,v.localize)(20,null,n));return}this.a.info((0,v.localize)(21,null,n));for(const l of i)await this.b.uninstall(l,{profileLocation:f}),L.push(l);this.f?this.a.info((0,v.localize)(22,null,n,this.f)):this.a.info((0,v.localize)(23,null,n))}}async locateExtension(d){const h=await this.b.getInstalled();d.forEach(f=>{h.forEach(w=>{if(w.identifier.id===f&&w.location.scheme===a.Schemas.file){this.a.info(w.location.fsPath);return}})})}m(d){return this.f?(0,v.localize)(24,null,d,this.f):(0,v.localize)(25,null,d)}};b=Re([Ae(1,g.IExtensionManagementService),Ae(2,g.IExtensionGalleryService)],b),e.ExtensionManagementCLI=b}),define(pe[238],ve([1,0,6,2,27,34,36]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class k extends R.Disposable{constructor(g,T,I,E,m,p,b){super(),this.f=g,this.g=T,this.h=I,this.i=E,this.j=m,this.k=p,this.l=b,this.a=this.B(new y.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,o=>b.error(o))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(g=>this.p(g.added,g.removed))),this.B(this.i.onAddExtensions(g=>this.r(g))),this.B(this.i.onDidAddExtensions(g=>this.s(g))),this.B(this.i.onRemoveExtensions(g=>this.t(g))),this.B(this.i.onDidRemoveExtensions(g=>this.u(g))),this.B(this.k.onDidFilesChange(g=>this.v(g)))}async p(g,T){try{await Promise.all(T.map(I=>(this.c.deleteAndDispose(I.id),this.z(I.extensionsResource)))),g.length&&await Promise.all(g.map(I=>(this.c.set(I.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(I.extensionsResource)),this.k.watch(I.extensionsResource))),this.y(I.extensionsResource))))}catch(I){throw this.l.error(I),I}}async r(g){for(const T of g.extensions)this.D(this.G(T.identifier,T.version),g.profileLocation)}async s(g){for(const T of g.extensions){const I=this.G(T.identifier,T.version);g.error?this.F(I,g.profileLocation):this.D(I,g.profileLocation)}}async t(g){for(const T of g.extensions)this.F(this.G(T.identifier,T.version),g.profileLocation)}async u(g){const T=[],I=[];for(const E of g.extensions){const m=this.G(E.identifier,E.version);g.error?this.D(m,g.profileLocation):(this.F(m,g.profileLocation),this.b.has(m)||(this.l.debug("Extension is removed from all profiles",E.identifier.id,E.version),I.push(this.f.scanInstalledExtensionAtLocation(E.location).then(p=>{p?T.push(p):this.l.info("Extension not found at the location",E.location.toString())},p=>this.l.error(p)))))}try{await Promise.all(I),T.length&&await this.C(T)}catch(E){this.l.error(E)}}v(g){for(const T of this.h.profiles)g.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(g){const T=[],I=[],E=await this.i.scanProfileExtensions(g),m=new Set,p=new Set;for(const[b,o]of this.b)o.has(g)&&p.add(b);for(const b of E){const o=this.G(b.identifier,b.version);m.add(o),p.has(o)||(T.push(b.identifier),this.D(o,g))}for(const b of p)if(!m.has(b)){const o=this.H(b);o&&(I.push(o.identifier),this.F(b,g))}(T.length||I.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:g}:void 0,removed:I.length?{extensions:I,profileLocation:g}:void 0})}async y(g){const T=await this.i.scanProfileExtensions(g);for(const I of T)this.D(this.G(I.identifier,I.version),g)}async z(g){for(const T of[...this.b.keys()])this.F(T,g);await this.C()}async C(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.G(I.identifier,I.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}D(g,T){let I=this.b.get(g);I||this.b.set(g,I=new a.ResourceSet(E=>this.j.extUri.getComparisonKey(E))),I.add(T)}F(g,T){const I=this.b.get(g);I&&I.delete(T),I?.size||this.b.delete(g)}G(g,T){return`${C.ExtensionIdentifier.toKey(g.id)}@${T}`}H(g){const[T,I]=(0,D.getIdAndVersion)(g);return I?{identifier:{id:T},version:I}:void 0}}e.ExtensionsWatcher=k}),define(pe[239],ve([1,0,207,37]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function a(D,C,k,v,g,T,I){const E={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${C.nameShort})`};if((0,R.supportsTelemetry)(C,k)&&(0,R.getTelemetryLevel)(v)===3){const m=await(0,y.getServiceMachineId)(k,g,T);E["X-Market-User-Id"]=m,E["VSCode-SessionId"]=I.machineId||m}return E}e.resolveMarketplaceHeaders=a}),define(pe[117],ve([1,0,118,18,14,2,13,7,23,25,30,34,12,81,4]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=class extends m.LanguagePackBaseService{constructor(f,w,L,t){super(L),this.h=f,this.i=t,this.g=this.B(new o(w,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(f,w){const t=(await this.g.getLanguagePacks())[w];if(!t){this.i.warn(`No language pack found for ${w}`);return}const n=t.translations[f];return n?p.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),w=Object.keys(f).map(L=>{const t=f[L];return{...this.f(L,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((L,t)=>L.label.localeCompare(t.label)),w}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const w=await this.g.getLanguagePacks();Object.keys(w).some(L=>w[L]&&w[L].extensions.some(t=>(0,I.areSameExtensions)(t.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),L=await this.g.update(w);return!(0,R.equals)(Object.keys(f),Object.keys(L))}};b=Re([Ae(0,T.IExtensionManagementService),Ae(1,g.INativeEnvironmentService),Ae(2,T.IExtensionGalleryService),Ae(3,E.ILogService)],b),e.NativeLanguagePackService=b;let o=class extends D.Disposable{constructor(f,w){super(),this.i=w,this.c={},this.f=(0,k.join)(f.userDataPath,"languagepacks.json"),this.g=new a.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(w=>{Object.keys(w).forEach(L=>delete w[L]),this.j(w,...f)}).then(()=>this.c)}j(f,...w){for(const L of w)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.k(f,L);Object.keys(f).forEach(L=>this.l(f[L]))}k(f,w){const L=w.identifier,t=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const n of t)if(w.location.scheme===C.Schemas.file&&d(n)){let r=f[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},f[n.languageId]=r);const i=r.extensions.filter(l=>(0,I.areSameExtensions)(l.extensionIdentifier,L))[0];i?i.version=w.manifest.version:r.extensions.push({extensionIdentifier:L,version:w.manifest.version});for(const l of n.translations)r.translations[l.id]=(0,k.join)(w.location.fsPath,l.path)}}l(f){if(f){const w=(0,y.createHash)("md5");for(const L of f.extensions)w.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);f.hash=w.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let w=null;return v.Promises.readFile(this.f,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(w=f(L),L)).then(L=>{for(const n of Object.keys(L))L[n]||delete L[n];this.c=L,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>w,L=>this.i.error(L))})}};o=Re([Ae(0,g.INativeEnvironmentService),Ae(1,E.ILogService)],o);function d(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const f of h.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(pe[240],ve([1,0,9,22,37]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function k(g,T,I){const E=await new Promise((d,h)=>{ae(["@microsoft/1ds-core-js"],d,h)}),m=await new Promise((d,h)=>{ae(["@microsoft/1ds-post-js"],d,h)}),p=new E.AppInsightsCore,b=new m.PostChannel,o={instrumentationKey:g,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(I){o.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:I};o.extensionConfig[b.identifier]=d}return p.initialize(o,[]),p.addTelemetryInitializer(d=>{T&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),p}class v{constructor(T,I,E,m,p){this.e=T,this.f=I,this.g=E,this.h=p,this.c=D,this.d=C,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(T){if(!!this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(I=>{T(I)},I=>{(0,y.onUnexpectedError)(I),console.error(I)})}}log(T,I){if(!this.a)return;I=(0,R.mixin)(I,this.g),I=(0,a.validateTelemetryData)(I);const E=this.f+"/"+T;try{this.i(m=>{m.pluginVersionString=I?.properties.version??"Unknown",m.track({name:E,baseData:{name:E,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(I=>{I.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(pe[241],ve([1,0,2,22,3,17,188,24,53,52,26,40,31,37]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(d,h,f){this.k=h,this.l=f,this.d={},this.i=new y.DisposableStore,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(E.TELEMETRY_SETTING_ID)||w.affectsConfiguration(E.TELEMETRY_OLD_SETTING_ID)||w.affectsConfiguration(E.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(d,h){this.d[d]=h}m(){let d=(0,m.getTelemetryLevel)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const f=h.usage?3:h.error?2:0;d=Math.min(d,f)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,h,f){this.g<h||(f=(0,R.mixin)(f,this.d),f=(0,m.cleanData)(f,this.j),f=(0,R.mixin)(f,this.c),this.b.forEach(w=>w.log(d,f)))}publicLog(d,h){this.n(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){!this.h||this.n(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=Re([Ae(1,k.IConfigurationService),Ae(2,T.IProductService)],p),e.TelemetryService=p;function b(){const o=(0,C.localize)(0,null,g.default.nameLong),d=g.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=a.isWeb?"":(0,C.localize)(3,null),f=(0,C.localize)(4,null),w=(0,C.localize)(5,null),L=(0,C.localize)(6,null),t=(0,C.localize)(7,null),n=`
|       | ${f} | ${w} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${o} ${d} ${h}

&nbsp;

${t}
${n}

&nbsp;

${r}
`}I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,C.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,C.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[242],ve([1,0,24,5,26,31,241,37]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends C.TelemetryService{constructor(T,I,E,m){super(T,E,m),this.o=I}publicLog(T,I){if(!(this.o<3))return super.publicLog(T,I)}publicLog2(T,I){return this.publicLog(T,I)}publicLogError(T,I){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,I)}publicLogError2(T,I){return this.publicLogError(T,I)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};v=Re([Ae(2,y.IConfigurationService),Ae(3,a.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends k.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,R.refineServiceDecorator)(D.ITelemetryService)}),define(pe[243],ve([1,0,244,240]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class a extends R.AbstractOneDataSystemAppender{constructor(C,k,v,g){const T={sendPOST:(I,E)=>{const m={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const p=y.request(I.urlString,m,b=>{b.on("data",function(o){E(b.statusCode??200,b.headers,o.toString())}),b.on("error",function(o){E(0,{})})});p.write(I.data),p.end()}catch{E(0,{})}}};super(C,k,v,g,T)}}e.OneDataSystemAppender=a}),define(pe[245],ve([1,0,9,235]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class a extends R.default{i(){(0,y.setUnexpectedErrorHandler)(k=>console.error(k));const C=[];process.on("unhandledRejection",(k,v)=>{C.push(v),setTimeout(()=>{const g=C.indexOf(v);g>=0&&v.catch(T=>{C.splice(g,1),(0,y.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),k&&(0,y.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const v=C.indexOf(k);v>=0&&C.splice(v,1)}),process.on("uncaughtException",k=>{(0,y.isSigPipeError)(k)||(0,y.onUnexpectedError)(k)})}}e.default=a}),define(pe[119],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(y=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(pe[120],ve([1,0,3,119]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class a{constructor(v){this.collections=v,this.map=new Map,v.forEach((g,T)=>{const I=g.map.entries();let E=I.next();for(;!E.done;){const m=E.value[0];let p=this.map.get(m);if(p||(p=[],this.map.set(m,p)),p.length>0&&p[0].type===R.EnvironmentVariableMutatorType.Replace){E=I.next();continue}const b=E.value[1];p.unshift({extensionIdentifier:T,value:b.value,type:b.type}),E=I.next()}})}async applyToProcessEnvironment(v,g){let T;y.isWindows&&(T={},Object.keys(v).forEach(I=>T[I.toLowerCase()]=I));for(const[I,E]of this.map){const m=y.isWindows&&T[I.toLowerCase()]||I;for(const p of E){const b=g?await g(p.value):p.value;switch(p.type){case R.EnvironmentVariableMutatorType.Append:v[m]=(v[m]||"")+b;break;case R.EnvironmentVariableMutatorType.Prepend:v[m]=b+(v[m]||"");break;case R.EnvironmentVariableMutatorType.Replace:v[m]=b;break}}}}diff(v){const g=new Map,T=new Map,I=new Map;if(v.map.forEach((E,m)=>{const p=this.map.get(m),b=D(E,p);b&&g.set(m,b)}),this.map.forEach((E,m)=>{const p=v.map.get(m),b=D(E,p);b&&I.set(m,b)}),this.map.forEach((E,m)=>{const p=v.map.get(m),b=C(E,p);b&&T.set(m,b)}),!(g.size===0&&T.size===0&&I.size===0))return{added:g,changed:T,removed:I}}}e.MergedEnvironmentVariableCollection=a;function D(k,v){if(!v)return k;const g=new Set;v.forEach(I=>g.add(I.extensionIdentifier));const T=[];return k.forEach(I=>{g.has(I.extensionIdentifier)||T.push(I)}),T.length===0?void 0:T}function C(k,v){if(!v)return;const g=new Map;v.forEach(I=>g.set(I.extensionIdentifier,I));const T=[];return k.forEach(I=>{const E=g.get(I.extensionIdentifier);E&&(I.type!==E.type||I.value!==E.value)&&T.push(E)}),T.length===0?void 0:T}}),define(pe[84],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function y(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=y;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R;function a(C){return Array.from(C.entries()).map(k=>[k[0],y(k[1].map)])}e.serializeEnvironmentVariableCollections=a;function D(C){return new Map(C.map(k=>[k[0],{map:R(k[1])}]))}e.deserializeEnvironmentVariableCollections=D}),define(pe[246],ve([1,0,14,20,6,2,12]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let k=class extends D.Disposable{constructor(g,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new a.Emitter),this.onCreateRequest=this.g.event,this.b=g===void 0?15e3:g}createRequest(g){return new Promise((T,I)=>{const E=++this.a;this.c.set(E,T),this.g.fire({requestId:E,...g});const m=new R.CancellationTokenSource;(0,y.timeout)(this.b,m.token).then(()=>I(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,D.toDisposable)(()=>m.cancel())])})}acceptReply(g,T){const I=this.c.get(g);I?(this.c.delete(g),(0,D.dispose)(this.f.get(g)||[]),this.f.delete(g),I(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${g}`)}};k=Re([Ae(1,C.ILogService)],k),e.RequestStore=k}),define(pe[121],ve([1,0,5,65]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new R.RawContextKey("terminalTabFocusMode",!1,!0);var a;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(a=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(C=e.PosixShellType||(e.PosixShellType={}));var k;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var v;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(v=e.TitleEventSource||(e.TitleEventSource={}));var g;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Logger="logger",f.Heartbeat="heartbeat"})(g=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,y.createDecorator)("ptyService");var T;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(f){f.TerminalView="view",f.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var p;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var b;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(b=e.FlowControlConstants||(e.FlowControlConstants={}));var o;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(o=e.ProfileSource||(e.ProfileSource={}));var d;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var h;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(h=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(pe[247],ve([1,0,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function R(C){let k=C;k.includes("\\")&&(k=k.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return k=k.replace(v,""),`'${k}'`}e.escapeNonWindowsPath=R;function a(C,k,v){if(!C)return"";if(!k)return C;k.match(/[\/\\]$/)&&(k=k.slice(0,k.length-1));const g=C.replace(/\\/g,"/").toLowerCase(),T=k.replace(/\\/g,"/").toLowerCase();return g.includes(T)?`~${v}${C.slice(k.length+1)}`:C}e.collapseTildePath=a;function D(C){return C.match(/^['"].*['"]$/)&&(C=C.substring(1,C.length-1)),y.OS===1&&C&&C[1]===":"?C[0].toUpperCase()+C.substring(1):C}e.sanitizeCwd=D}),define(pe[248],ve([1,0,47,4,190,95]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(E,m){const p=[{name:null,description:(0,a.localize)(0,null)}];return p.push(...E.map(b=>({name:b.profileName,description:k(b)}))),m&&p.push(...m.map(b=>({name:b.title,description:v(b)}))),{values:p.map(b=>b.name),markdownDescriptions:p.map(b=>b.description)}}e.createProfileSchemaEnums=C;function k(E){let m=`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:y.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?m+=`
- args: "${E.args}"`:m+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(m+=`
- overrideName: ${E.overrideName}`),E.color&&(m+=`
- color: ${E.color}`),E.env&&(m+=`
- env: ${JSON.stringify(E.env)}`),m}function v(E){return`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:y.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function g(E,m){if(!E&&!m)return!0;if(typeof E=="string"&&typeof m=="string")return E===m;if(Array.isArray(E)&&Array.isArray(m)){if(E.length!==m.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==m[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=g;function T(E,m){if(!E&&!m)return!0;if(!E||!m)return!1;if(D.ThemeIcon.isThemeIcon(E)&&D.ThemeIcon.isThemeIcon(m))return E.id===m.id&&E.color===m.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof m=="object"&&"light"in m&&"dark"in m){const p=E,b=m;if((R.URI.isUri(p.light)||I(p.light))&&(R.URI.isUri(p.dark)||I(p.dark))&&(R.URI.isUri(b.light)||I(b.light))&&(R.URI.isUri(b.dark)||I(b.dark)))return p.light.path===b.light.path&&p.dark.path===b.dark.path}if(R.URI.isUri(E)&&R.URI.isUri(m)||I(E)||I(m)){const p=E,b=m;return p.path===b.path&&p.scheme===b.scheme}return!1}e.terminalIconsEqual=T;function I(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=I}),define(pe[249],ve([1,0,47,189,53,40,248]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,y.getAllCodicons)(),w=>w.id),markdownEnumDescriptions:Array.from((0,y.getAllCodicons)(),w=>`$(${w.id})`)};const k={args:{description:(0,R.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,R.localize)(1,null),type:"boolean"},icon:{description:(0,R.localize)(2,null),...e.terminalIconSchema},color:{description:(0,R.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,R.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,R.localize)(5,null),type:["string","array"],items:{type:"string"}},...k}},g={type:"object",required:["path"],properties:{path:{description:(0,R.localize)(6,null),type:["string"],items:{type:"string"}},...k}},T=(0,R.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,R.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,R.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,R.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,R.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,R.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),o={id:"terminal",order:100,title:(0,R.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,R.localize)(26,null)}},{type:"string",markdownDescription:(0,R.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,R.localize)(29,null),enum:["PowerShell","Git Bash"]},...k}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(30,null),type:"string"},id:{description:(0,R.localize)(31,null),type:"string"},title:{description:(0,R.localize)(32,null),type:"string"},...k}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(34,null),type:"string"},id:{description:(0,R.localize)(35,null),type:"string"},title:{description:(0,R.localize)(36,null),type:"string"},...k}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(38,null),type:"string"},id:{description:(0,R.localize)(39,null),type:"string"},title:{description:(0,R.localize)(40,null),type:"string"},...k}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,R.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,R.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,R.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,R.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,R.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){D.Registry.as(a.Extensions.Configuration).registerConfiguration(o),f()}e.registerTerminalPlatformConfiguration=d;let h;function f(w,L){const t=D.Registry.as(a.Extensions.Configuration);let n;w&&(n=(0,C.createProfileSchemaEnums)(w?.profiles,L));const r=h;h={id:"terminal",order:100,title:(0,R.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:w?.os===3?n?.values:void 0,markdownEnumDescriptions:w?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:w?.os===2?n?.values:void 0,markdownEnumDescriptions:w?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:w?.os===1?n?.values:void 0,markdownEnumDescriptions:w?.os===1?n?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[h],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(pe[250],ve([1,0,29,13,22,7,3,28,17,8,23,119,84,120]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let l=0;return i&&i.length===4&&(l=parseInt(i[3])),l}e.getWindowsBuildNumber=p;async function b(i,l,c,s=k.env,u=T.Promises.exists){if(D.isAbsolute(i))return await u(i)?i:void 0;if(l===void 0&&(l=k.cwd()),D.dirname(i)!=="."){const B=D.join(l,i);return await u(B)?B:void 0}const A=(0,a.getCaseInsensitive)(s,"PATH");if(c===void 0&&(0,g.isString)(A)&&(c=A.split(D.delimiter)),c===void 0||c.length===0){const B=D.join(l,i);return await u(B)?B:void 0}for(const B of c){let q;if(D.isAbsolute(B)?q=D.join(B,i):q=D.join(l,B,i),await u(q))return q;if(C.isWindows){let le=q+".com";if(await u(le)||(le=q+".exe",await u(le)))return le}}const O=D.join(l,i);return await u(O)?O:void 0}e.findExecutable=b;function o(i,l,c,s,u){const S=C.isWindows&&(!l.windowsEnableConpty||p()<18309);if(!l.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||S)return;const A=i.args,O=k.platform==="win32"?D.basename(i.executable).toLowerCase():D.basename(i.executable),B=D.dirname(R.FileAccess.asFileUri("").fsPath);let q;const le={VSCODE_INJECTION:"1"};if(C.isWindows){if(O==="pwsh.exe"||O==="powershell.exe")return!A||n(A)?q=f.get(h.WindowsPwsh):t(A)&&(q=f.get(h.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B,""),l.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:le}):void 0;s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(O){case"bash":return!A||A.length===0?q=f.get(h.Bash):r(A)&&(le.VSCODE_SHELL_LOGIN="1",d(l,le),q=f.get(h.Bash)),q?(q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B),{newArgs:q,envMixin:le}):void 0;case"fish":{const fe=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ue=D.join(B,"out/vs/workbench/contrib/xdg_data");return le.XDG_DATA_DIRS=`${fe}:${ue}`,d(l,le),{newArgs:void 0,envMixin:le}}case"pwsh":return!A||n(A)?q=f.get(h.Pwsh):t(A)&&(q=f.get(h.PwshLogin)),q?(l.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B,""),{newArgs:q,envMixin:le}):void 0;case"zsh":{if(!A||A.length===0?q=f.get(h.Zsh):r(A)?(q=f.get(h.ZshLogin),d(l,le)):(A===f.get(h.Zsh)||A===f.get(h.ZshLogin))&&(q=A),!q)return;q=[...q],q[q.length-1]=(0,v.format)(q[q.length-1],B);let fe;try{fe=y.userInfo().username}catch{fe="unknown"}const ue=D.join(y.tmpdir(),`${fe}-${u.applicationName}-zsh`);le.ZDOTDIR=ue;const re=c?.ZDOTDIR??y.homedir()??"~";le.USER_ZDOTDIR=re;const _=[];return _.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.join(ue,".zshrc")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.join(ue,".zprofile")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.join(ue,".zshenv")}),_.push({source:D.join(B,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.join(ue,".zlogin")}),{newArgs:q,envMixin:le,filesToCopy:_}}}s.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=o;function d(i,l){if(C.isMacintosh&&i.environmentVariableCollections){const c=(0,E.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),u=new m.MergedEnvironmentVariableCollection(c).map.get("PATH"),S=[];if(u)for(const A of u)A.type===I.EnvironmentVariableMutatorType.Prepend&&S.push(A.value);S.length>0&&(l.VSCODE_PATH_PREFIX=S.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const f=new Map;f.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(h.Zsh,["-i"]),f.set(h.ZshLogin,["-il"]),f.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],L=["-nol","-nologo"];function t(i){return typeof i=="string"?w.includes(i.toLowerCase()):i.length===1&&w.includes(i[0].toLowerCase())||i.length===2&&(w.includes(i[0].toLowerCase())||w.includes(i[1].toLowerCase()))&&(L.includes(i[0].toLowerCase())||L.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?L.includes(i.toLowerCase()):i.length===0||i?.length===1&&L.includes(i[0].toLowerCase())}function r(i){return i==="string"&&w.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&w.includes(i[0].toLowerCase())}}),define(pe[251],ve([1,0,49,47,7,3,8,23,99,250,75]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,E=!0;function m(i,l,c,s,u=process.env,S,A,O,B){return S=S||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},D.isWindows?p(c,S,u,A,s.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:s.getValue("terminal.integrated.profiles.windows"),typeof l=="string"?l:s.getValue("terminal.integrated.defaultProfile.windows"),B,O):t(S,A,c,i&&typeof i=="object"?{...i}:s.getValue(D.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof l=="string"?l:s.getValue(D.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),B,O,u)}e.detectAvailableProfiles=m;async function p(i,l,c,s,u,S,A,O,B){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),le=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let fe=!1;(0,g.getWindowsBuildNumber)()>=16299&&(fe=!0),await d(O);const ue=new Map;if(i){ue.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${le}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${le}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.Codicon.terminalBash,isAutoDetected:!0});const _=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${le}\\cmd.exe`,args:["/K",_],requiresPath:process.env.CMDER_ROOT?_:{path:_,isUnsafe:!0},isAutoDetected:!0})}n(S,ue);const re=await b(ue.entries(),A,l,c,s,B);if(i||u)try{const _=await w(`${le}\\${fe?"wsl":"bash"}.exe`,A);for(const ee of _)(!S||!(ee.profileName in S))&&re.push(ee)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return re}async function b(i,l,c,s=process.env,u,S){const A=[];for(const[O,B]of i){if(B===null)continue;let q,le,fe;if("source"in B){const ee=I?.get(B.source);if(!ee)continue;q=ee.paths,le=B.args||ee.args,B.icon?fe=o(B.icon):ee.icon&&(fe=ee.icon)}else q=Array.isArray(B.path)?B.path:[B.path],le=D.isWindows||Array.isArray(B.args)?B.args:void 0,fe=o(B.icon);let ue;if(S){const ee=q.map(ie=>typeof ie=="string"?ie:ie.path),ne=await S(ee);ue=new Array(q.length);for(let ie=0;ie<q.length;ie++)typeof q[ie]=="string"?ue[ie]=ne[ie]:ue[ie]={path:ne[ie],isUnsafe:!0}}else ue=q.slice();let re;if(B.requiresPath){let ee;if((0,C.isString)(B.requiresPath)?ee=B.requiresPath:(ee=B.requiresPath.path,B.requiresPath.isUnsafe&&(re=ee)),!await c.existsFile(ee))continue}const _=await r(O,l,ue,c,s,le,B.env,B.overrideName,B.isAutoDetected,re);_?(_.isAutoDetected=B.isAutoDetected,_.icon=fe,_.color=B.color,A.push(_)):u?.debug("Terminal profile not validated",O,q)}return u?.debug("Validated terminal profiles",A),A}function o(i){return typeof i=="string"?{id:i}:i}async function d(i){if(I&&!i)return;const[l,c]=await Promise.all([h(),i||f()]);I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:l,args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:c,icon:R.Codicon.terminalPowershell})}async function h(){const i=new Set,l=await(0,g.findExecutable)("git.exe");if(l){const u=(0,T.dirname)(l);i.add((0,T.resolve)(u,"../.."))}function c(u,S){S&&u.add(S)}c(i,process.env.ProgramW6432),c(i,process.env.ProgramFiles),c(i,process.env["ProgramFiles(X86)"]),c(i,`${process.env.LocalAppData}\\Program`);const s=[];for(const u of i)s.push(`${u}\\Git\\bin\\bash.exe`,`${u}\\Git\\usr\\bin\\bash.exe`,`${u}\\usr\\bin\\bash.exe`);return s.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),s}async function f(){const i=[];for await(const l of(0,v.enumeratePowerShellInstallations)())i.push(l.exePath);return i}async function w(i,l){const c=[],s=await new Promise((A,O)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(B,q)=>{if(B)return O("Problem occurred when getting wsl distros");A(q)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),S=s.split(u).filter(A=>A.trim().length>0&&A!=="");for(const A of S){if(A===""||A.startsWith("docker-desktop"))continue;const O=`${A} (WSL)`,B={profileName:O,path:i,args:["-d",`${A}`],isDefault:O===l,icon:L(A),isAutoDetected:!1};c.push(B)}return c}function L(i){return i.includes("Ubuntu")?R.Codicon.terminalUbuntu:i.includes("Debian")?R.Codicon.terminalDebian:R.Codicon.terminalLinux}async function t(i,l,c,s,u,S,A,O){const B=new Map;if(c){const q=(await i.readFile("/etc/shells")).toString(),le=S||q.split(`
`).filter(ue=>ue.trim().includes("#")&&ue.trim().length>0),fe=new Map;for(const ue of le){let re=(0,a.basename)(ue),_=fe.get(re)||0;_++,_>1&&(re=`${re} (${_})`),fe.set(re,_),B.set(re,{path:ue,isAutoDetected:!0})}}return n(s,B),await b(B.entries(),u,i,O,l,A)}function n(i,l){if(!!i)for(const[c,s]of Object.entries(i))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?l.delete(c):(s.icon=s.icon||l.get(c)?.icon,l.set(c,s))}async function r(i,l,c,s,u,S,A,O,B,q){if(c.length===0)return Promise.resolve(void 0);const le=c.shift();if(le==="")return r(i,l,c,s,u,S,A,O,B);const fe=typeof le!="string"&&le.isUnsafe,ue=typeof le=="string"?le:le.path,re={profileName:i,path:ue,args:S,env:A,overrideName:O,isAutoDetected:B,isDefault:i===l,isUnsafePath:fe,requiresUnsafePath:q};if((0,a.basename)(ue)===ue){const ee=u.PATH?u.PATH.split(a.delimiter):void 0,ne=await(0,g.findExecutable)(ue,void 0,ee,void 0,s.existsFile);return ne?(re.path=ne,re.isFromPath=!0,re):r(i,l,c,s,u,S)}return await s.existsFile((0,a.normalize)(ue))?re:r(i,l,c,s,u,S,A,O,B)}}),define(pe[252],ve([1,0,6,2,13,3,43,103,24,25,105,83,12,246,121,249,251,109]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(L){L[L.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let f=0,w=class extends R.Disposable{constructor(t,n,r,i,l,c){super(),this.C=t,this.D=n,this.F=r,this.G=i,this.H=l,this.I=c,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new y.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new y.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new y.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new y.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new y.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new y.Emitter),this.onProcessData=this.s.event,this.t=this.B(new y.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new y.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new y.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new y.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new y.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new y.Emitter),this.onProcessExit=this.z.event,(0,b.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,R.toDisposable)(()=>this.O())),this.f=this.B(new m.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(D.isWindows)return process.env;try{return await(0,I.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,T.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);n&&(n.break&&n.port?t.debugBrk=n.port:!n.break&&n.port&&(t.debug=n.port));const r=new k.Client(a.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(r.onDidProcessExit(c=>{this.l.fire(c.code),this.i||(this.g<=h.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))})),this.B(new d.RemoteLoggerChannelClient(this.I,r.getChannel(p.TerminalIpcChannels.Logger)));const l=C.ProxyChannel.toService(r.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(c=>this.s.fire(c))),this.B(l.onProcessReady(c=>this.t.fire(c))),this.B(l.onProcessExit(c=>this.z.fire(c))),this.B(l.onDidChangeProperty(c=>this.y.fire(c))),this.B(l.onProcessReplay(c=>this.u.fire(c))),this.B(l.onProcessOrphanQuestion(c=>this.v.fire(c))),this.B(l.onDidRequestDetach(c=>this.w.fire(c))),[r,l]}dispose(){this.i=!0,super.dispose()}async createProcess(t,n,r,i,l,c,s,u,S,A,O){const B=setTimeout(()=>this.S(),p.HeartbeatConstants.CreateProcessTimeout),q=await this.b.createProcess(t,n,r,i,l,c,s,u,S,A,O);return clearTimeout(B),f=Math.max(f,q),q}updateTitle(t,n,r){return this.b.updateTitle(t,n,r)}updateIcon(t,n,r,i){return this.b.updateIcon(t,n,r,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,n){return this.b.detachFromProcess(t,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,n){return this.b.shutdown(t,n)}input(t,n){return this.b.input(t,n)}processBinary(t,n){return this.b.processBinary(t,n)}resize(t,n,r){return this.b.resize(t,n,r)}acknowledgeDataEvent(t,n){return this.b.acknowledgeDataEvent(t,n)}setUnicodeVersion(t,n){return this.b.setUnicodeVersion(t,n)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,n){return this.b.installAutoReply(t,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,n,r,i=!1){const l=await this.c;return(0,o.detectAvailableProfiles)(n,r,i,this.F,l,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,n){return this.b.getWslPath(t,n)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,n){return this.b.requestDetachInstance(t,n)}async acceptDetachInstanceReply(t,n){return this.b.acceptDetachInstanceReply(t,n)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,n){return this.b.reviveTerminalProcesses(t,n)}async refreshProperty(t,n){return this.b.refreshProperty(t,n)}async updateProperty(t,n,r){return this.b.updateProperty(t,n,r)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,n){return this.f.createRequest({workspaceId:t,originalText:n})}async acceptPtyHostResolvedVariables(t,n){this.f.acceptReply(t,n)}};w=Re([Ae(2,v.IConfigurationService),Ae(3,g.IEnvironmentService),Ae(4,E.ILogService),Ae(5,E.ILoggerService)],w),e.PtyHostService=w}),define(pe[35],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(pe[122],ve([1,0,35,208,16,19,143,6,2]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{constructor(E){this.uri=E,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let T=class{constructor(E){this.g=E,this.c=new v.DisposableStore,this.f=2**16;const m=new Map,p=b=>{let o=m.get(b.scheme);return o===void 0&&(o=E.hasProvider(b)&&!this.g.hasCapability(b,1024),m.set(b.scheme,o)),o};this.c.add(k.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(b=>{m.delete(b.scheme)})),this.extUri=new D.ExtUri(p),this.d=new C.SkipList((b,o)=>this.extUri.compare(b,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,D.normalizePath)(E));const m=this.d.get(E);return m?m.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new g(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((p,b)=>p[1].time<b[1].time?1:p[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const m=this.f*.5;for(let p=0;p<m;p++)this.d.set(E[p][0],E[p][1].touch())}};T=Re([Ae(0,a.IFileService)],T),e.UriIdentityService=T,(0,R.registerSingleton)(y.IUriIdentityService,T,1)}),define(pe[85],ve([1,0,192,7,60,19,4,5,13]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function g(i){const l=i;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=g;function T(i){return typeof i?.id=="string"&&!g(i)&&!E(i)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(i,l){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=I;function E(i){const l=i;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=E;function m(i){const l=i;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function b(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=b;function o(i){const l=i;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=o;class d{constructor(l,c,s,u,S){this.h=l,this.j=s,this.k=u,this.l=S,this.c=a.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=a.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,D.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function f(i){return new h({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(i,l){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,l.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function L(i){let l;return C.URI.isUri(i)?l=i:l=i.configuration,l?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,l){return!w(i,l)&&!L(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,R.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(pe[32],ve([1,0,73,6,2,19,4,191,25,16,5,12,85,27,35,14,21,17,8]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&C.URI.isUri(i.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function w(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:C.URI.revive(r.location).with({scheme:i}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=w;function L(r,i,l,c,s){return{id:r,name:i,location:l,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,D.joinPath)(l,"globalStorage"),settingsResource:(0,D.joinPath)(l,"settings.json"),keybindingsResource:(0,D.joinPath)(l,"keybindings.json"),tasksResource:(0,D.joinPath)(l,"tasks.json"),snippetsHome:(0,D.joinPath)(l,"snippets"),extensionsResource:(0,D.joinPath)(l,"extensions.json"),cacheHome:(0,D.joinPath)(c,r),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=L;let t=class extends a.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,l,c,s){super(),this.n=i,this.r=l,this.s=c,this.t=s,this.f=!0,this.h=this.B(new R.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new R.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new R.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new R.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,D.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const u of this.J()){if(!u.name||!(0,h.isString)(u.name)||!u.location){this.t.warn("Skipping the invalid stored profile",u.location||u.name);continue}i.push(L((0,D.basename)(u.location),u.name,u.location,this.g,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}}catch(u){this.t.error(u)}const l=new m.ResourceMap,c=new Map,s=this.w();if(i.unshift({...s,extensionsResource:this.O()??s.extensionsResource,isDefault:!0}),i.length)try{const u=this.M();if(u.workspaces)for(const[S,A]of Object.entries(u.workspaces)){const O=C.URI.parse(S),B=i.find(q=>q.id===A);B&&l.set(O,B)}if(u.emptyWindows)for(const[S,A]of Object.entries(u.emptyWindows)){const O=i.find(B=>B.id===A);O&&c.set(S,O)}}catch(u){this.t.error(u)}this.u={profiles:i,workspaces:l,emptyWindows:c}}return this.u}w(){return L("__default__profile__",(0,k.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const l="Temp",c=new RegExp(`${(0,d.escapeRegExpCharacters)(l)}\\s(\\d+)`);let s=0;for(const S of this.profiles){const A=c.exec(S.name),O=A?parseInt(A[1]):0;s=O>s?O:s}const u=`${l} ${s+1}`;return this.createProfile((0,y.hash)((0,o.generateUuid)()).toString(16),u,{transient:!0},i)}async createNamedProfile(i,l,c){return this.createProfile((0,y.hash)((0,o.generateUuid)()).toString(16),i,l,c)}async createProfile(i,l,c,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.y(i,l,c);return s&&await this.setProfileForWorkspace(s,u),u}async y(i,l,c){if(!(0,h.isString)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.l.get(l);return s||(s=(async()=>{try{const u=this.profiles.find(O=>O.name===l||O.id===i);if(u)return u;const S=L(i,l,(0,D.joinPath)(this.profilesHome,i),this.g,c);await this.r.createFolder(S.location);const A=[];return this.i.fire({profile:S,join(O){A.push(O)}}),await b.Promises.settled(A),this.D([S],[],[]),S}finally{this.l.delete(l)}})(),this.l.set(l,s)),s}async updateProfile(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(s=>s.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=L(c.id,l.name??c.name,c.location,this.g,{shortName:l.shortName??c.shortName,transient:l.transient??c.isTransient,useDefaultFlags:l.useDefaultFlags??c.useDefaultFlags}),this.D([],[],[c]),c}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(s=>s.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this.j.fire({profile:l,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.t.error(s)}for(const s of[...this.v.emptyWindows.keys()])l.id===this.v.emptyWindows.get(s)?.id&&this.v.emptyWindows.delete(s);for(const s of[...this.v.workspaces.keys()])l.id===this.v.workspaces.get(s)?.id&&this.v.workspaces.delete(s);this.H(),this.D([],[l],[]);try{await this.r.del(l.cacheHome,{recursive:!0})}catch(s){(0,g.toFileOperationResult)(s)!==1&&this.t.error(s)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(l.location,{recursive:!0})}catch(s){this.t.error(s)}}async setProfileForWorkspace(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(s=>s.id===l.id);if(!c)throw new Error(`Profile '${l.name}' does not exist`);this.G(i,c)}unsetWorkspace(i,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,l)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(!!this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(l=>l.isDirectory&&this.profiles.every(c=>!this.s.extUri.isEqual(c.location,l.resource))).map(l=>this.r.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(l=>!this.C(l));await Promise.allSettled(i.map(l=>this.removeProfile(l)))}getProfileForWorkspace(i){const l=this.z(i);return C.URI.isUri(l)?this.m.workspaces.get(l)??this.v.workspaces.get(l):this.m.emptyWindows.get(l)??this.v.emptyWindows.get(l)}z(i){return(0,E.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,E.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.m.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.v.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,i.location))||[...this.v.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,i.location)))}D(i,l,c){const s=[...this.profiles,...i],u=[];this.m.profiles=[];for(let S of s)S.isDefault||l.some(A=>S.id===A.id)||(S=c.find(A=>S.id===A.id)??S,S.isTransient?this.m.profiles.push(S):u.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.L(u),this.u=void 0,this.F(i,l,c)}F(i,l,c){this.h.fire({added:i,removed:l,updated:c,all:this.profiles})}G(i,l,c){c=l?.isTransient?!0:c,c||this.G(i,void 0,!0);const s=this.z(i),u=c?this.m:this.v;C.URI.isUri(s)?(u.workspaces.delete(s),l&&u.workspaces.set(s,l)):(u.emptyWindows.delete(s),l&&u.emptyWindows.set(s,l)),c||this.H()}H(){const i={};for(const[c,s]of this.v.workspaces.entries())i[c.toString()]=s.id;const l={};for(const[c,s]of this.v.emptyWindows.entries())l[c.toString()]=s.id;this.N({workspaces:i,emptyWindows:l}),this.u=void 0}I(i){const l={},c=this.w();if(i.workspaces)for(const[u,S]of Object.entries(i.workspaces)){const A=C.URI.parse(S);l[u]=this.s.extUri.isEqual(A,c.location)?c.id:this.s.extUri.basename(A)}const s={};if(i.emptyWindows)for(const[u,S]of Object.entries(i.emptyWindows)){const A=C.URI.parse(S);s[u]=this.s.extUri.isEqual(A,c.location)?c.id:this.s.extUri.basename(A)}return{workspaces:l,emptyWindows:s}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",t=Re([Ae(0,v.IEnvironmentService),Ae(1,g.IFileService),Ae(2,p.IUriIdentityService),Ae(3,I.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(pe[253],ve([1,0,18,14,20,9,6,2,3,8,4,172,30,34,36,12,26,31,32]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends k.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,l,c,s,u){super(),this.t=i,this.u=l,this.v=c,this.w=s,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new C.Emitter),this.m=this.B(new C.Emitter),this.n=this.B(new C.Emitter),this.p=this.B(new C.Emitter),this.s=[],this.B((0,k.toDisposable)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.k.forEach(S=>S.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const l=await this.getTargetPlatform();return i.allTargetPlatforms.some(c=>(0,E.isTargetPlatformCompatible)(c,i.allTargetPlatforms,l))}async installFromGallery(i,l={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(I.localize(0,null),E.ExtensionManagementErrorCode.Internal);const c=await this.G(i,!!l.installGivenVersion,!!l.installPreReleaseVersion);return await this.z(c.manifest,c.extension,l)}catch(c){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:c}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(c),L(c)}}async uninstall(i,l={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,l)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,l,c){const s=c.isApplicationScoped||c.isBuiltin||(0,p.isApplicationScopedExtension)(i),u={...c,installOnlyNewlyAddedFromExtensionPack:T.URI.isUri(l)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:s,profileLocation:s?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},S=fe=>`${m.ExtensionKey.create(fe).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!T.URI.isUri(l)){const fe=this.j.get(S(l));if(fe)return this.v.info("Extensions is already requested to install",l.identifier.id),fe.task.waitUntilTaskIsFinished()}const A=[],O=[],B=[],q=this.Q(i,l,u);T.URI.isUri(l)||this.j.set(S(l),{task:q,waitingTasks:[]}),this.l.fire({identifier:q.identifier,source:l,profileLocation:u.profileLocation}),this.v.info("Installing extension:",q.identifier.id),A.push({task:q,manifest:i});let le=!1;try{if(u.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const ue=await this.F(q.identifier,i,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),re=await this.getInstalled(void 0,u.profileLocation);for(const{gallery:_,manifest:ee}of(0,y.distinct)(ue,({gallery:ne})=>ne.identifier.id)){le=le||!!ee.extensionDependencies?.some(G=>(0,m.areSameExtensions)({id:G},q.identifier));const ne=S(_),ie=this.j.get(ne);if(ie){if(this.C(q,ie.task)){const G=ie.task.identifier;this.v.info("Waiting for already requested installing extension",G.id,q.identifier.id),ie.waitingTasks.push(q),O.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,U=>U.some(Z=>(0,m.areSameExtensions)(Z.identifier,G)))).then(U=>{if(this.v.info("Finished waiting for already requested installing extension",G.id,q.identifier.id),!U.find(oe=>(0,m.areSameExtensions)(oe.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!re.some(({identifier:G})=>(0,m.areSameExtensions)(G,_.identifier))){const G=this.Q(ee,_,{...u,donotIncludePackAndDependencies:!0});this.j.set(ne,{task:G,waitingTasks:[q]}),this.l.fire({identifier:G.identifier,source:_,profileLocation:u.profileLocation}),this.v.info("Installing extension:",G.identifier.id,q.identifier.id),A.push({task:G,manifest:ee})}}}catch(ue){if(T.URI.isUri(q.source))(0,y.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",q.identifier.id,ue.message),(0,y.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",q.identifier.id,ue.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),ue}const fe=A.reduce((ue,{task:re,manifest:_})=>(ue.set(re.identifier.id.toLowerCase(),{task:re,manifest:_}),ue),new Map);for(;fe.size;){let ue;const re=[...fe.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(ee=>fe.has(ee.toLowerCase())));re.length?ue=fe.size===1?re:re.filter(({task:_})=>!(_===q&&!le)):(this.v.info("Found extensions with circular dependencies",re.map(({task:_})=>_.identifier.id)),ue=[...fe.values()]),await this.D(ue.map(async({task:_})=>{const ee=new Date().getTime();try{const ne=await _.run();if(await this.D(this.s.map(ie=>ie.postInstall(ne,_.source,u,a.CancellationToken.None))),!T.URI.isUri(_.source)){const ie=_.operation===3,G=ie?void 0:(new Date().getTime()-_.source.lastUpdated)/1e3;if(t(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),verificationStatus:_.verificationStatus,duration:new Date().getTime()-ee,durationSinceUpdate:G}),v.isWeb&&_.operation!==3)try{await this.t.reportStatistic(ne.manifest.publisher,ne.manifest.name,ne.manifest.version,"install")}catch{}}B.push({local:ne,identifier:_.identifier,operation:_.operation,source:_.source,context:u.context,profileLocation:_.profileLocation,applicationScoped:ne.isApplicationScoped})}catch(ne){throw T.URI.isUri(_.source)||t(this.u,_.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),verificationStatus:_.verificationStatus,duration:new Date().getTime()-ee,error:ne}),this.v.error("Error while installing the extension:",_.identifier.id),ne}finally{fe.delete(_.identifier.id.toLowerCase())}}))}return O.length&&await this.D(O),B.forEach(({identifier:ue})=>this.v.info("Extension installed successfully:",ue.id)),this.m.fire(B),B.filter(({identifier:ue})=>(0,m.areSameExtensions)(ue,q.identifier))[0].local}catch(fe){if(A.forEach(({task:ue})=>ue.cancel()),B.length)try{const ue=await Promise.allSettled(B.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let re=0;re<ue.length;re++){const _=ue[re],{identifier:ee}=B[re];_.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ee.id):this.v.warn("Rollback: Error while uninstalling extension",ee.id,(0,D.getErrorMessage)(_.reason))}}catch(ue){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ue),B.map(({identifier:re})=>re.id))}throw this.m.fire(A.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:u.context,profileLocation:u.profileLocation}))),fe}finally{for(const{task:fe}of A)fe.source&&!T.URI.isUri(fe.source)&&this.j.delete(S(fe.source))}}C(i,l){for(const[,{task:c,waitingTasks:s}]of this.j.entries())if(c===i&&(s.includes(l)||s.some(u=>this.C(u,l)))||c===l&&s[0]&&!this.C(i,s[0]))return!1;return!0}async D(i){const l=[],c=[],s=await Promise.allSettled(i);for(const u of s)u.status==="fulfilled"?l.push(u.value):c.push(u.reason);if(c.length)throw w(c);return l}async F(i,l,c,s,u){if(!this.t.isEnabled())return[];const S=await this.getInstalled(void 0,u),A=[],O=[],B=async(q,le)=>{A.push(q);const fe=le.extensionDependencies||[],ue=[...fe];if(le.extensionPack){const re=c?S.find(_=>(0,m.areSameExtensions)(_.identifier,q)):void 0;for(const _ of le.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ee=>(0,m.areSameExtensions)({id:ee},{id:_}))||ue.every(ee=>!(0,m.areSameExtensions)({id:ee},{id:_}))&&ue.push(_)}if(ue.length){const re=ue.filter(_=>A.every(ee=>!(0,m.areSameExtensions)(ee,{id:_})));if(re.length){const _=await this.t.getExtensions(re.map(ee=>({id:ee,preRelease:s})),a.CancellationToken.None);for(const ee of _){if(A.find(G=>(0,m.areSameExtensions)(G,ee.identifier)))continue;const ne=fe.some(G=>(0,m.areSameExtensions)({id:G},ee.identifier));let ie;try{ie=await this.G(ee,!1,s)}catch(G){if(G instanceof E.ExtensionManagementError&&G.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ne){this.v.info("Skipping the packed extension as it cannot be installed",ee.identifier.id);continue}else throw G}O.push({gallery:ie.extension,manifest:ie.manifest}),await B(ie.extension.identifier,ie.manifest)}}}};return await B(i,l),O}async G(i,l,c){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,m.areSameExtensions)(i.identifier,A)))throw new E.ExtensionManagementError(I.localize(1,null,i.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const A=await this.getTargetPlatform();throw new E.ExtensionManagementError(I.localize(2,null,i.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(A)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(i,l,c);if(u){if(c&&!l&&i.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(I.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],a.CancellationToken.None))[0]?new E.ExtensionManagementError(I.localize(4,null,i.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(I.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const S=await this.t.getManifest(u,a.CancellationToken.None);if(S===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(S.version!==u.version)throw new E.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:S}}async H(i,l,c){const s=await this.getTargetPlatform();let u=null;return!l&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==c&&(u=(await this.t.getExtensions([{...i.identifier,preRelease:c}],{targetPlatform:s,compatible:!0},a.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(i,c,s)&&(u=i),u||(l?u=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:s,compatible:!0},a.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(i,c,s)),u}async I(i,l){const c={...l,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},s=q=>`${q.id.toLowerCase()}${c.versionOnly?`-${i.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,u=this.k.get(s(i.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),u.waitUntilTaskIsFinished();const S=q=>{const le=this.R(q,c);return this.k.set(s(le.extension.identifier),le),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${q.identifier.id}@${q.manifest.version}`),this.n.fire({identifier:q.identifier,profileLocation:c.profileLocation,applicationScoped:q.isApplicationScoped}),le},A=(q,le)=>{le?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString(),le.message):this.v.error("Failed to uninstall extension:",`${q.identifier.id}@${q.manifest.version}`,le.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${q.identifier.id}@${q.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${q.identifier.id}@${q.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(q),error:le}),this.p.fire({identifier:q.identifier,error:le?.code,profileLocation:c.profileLocation,applicationScoped:q.isApplicationScoped})},O=[],B=[];try{O.push(S(i));const q=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const le=this.M(i,q);for(const fe of le)this.k.has(s(fe.identifier))?this.v.info("Extensions is already requested to uninstall",fe.identifier.id):O.push(S(fe))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(O.map(le=>le.extension),q,i),await this.D(O.map(async le=>{try{if(await le.run(),await this.D(this.s.map(fe=>fe.postUninstall(le.extension,c,a.CancellationToken.None))),le.extension.identifier.uuid)try{await this.t.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}A(le.extension)}catch(fe){const ue=fe instanceof E.ExtensionManagementError?fe:new E.ExtensionManagementError((0,D.getErrorMessage)(fe),E.ExtensionManagementErrorCode.Internal);throw A(le.extension,ue),ue}finally{B.push(le)}}))}catch(q){const le=q instanceof E.ExtensionManagementError?q:new E.ExtensionManagementError((0,D.getErrorMessage)(q),E.ExtensionManagementErrorCode.Internal);for(const fe of O){try{fe.cancel()}catch{}B.includes(fe)||A(fe.extension,le)}throw le}finally{for(const q of O)this.k.delete(s(q.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",q.extension.identifier.id)}}J(i,l,c){for(const s of i){const u=this.N(s,l);if(u.length){const S=u.filter(A=>!i.some(O=>(0,m.areSameExtensions)(O.identifier,A.identifier)));if(S.length)throw new Error(this.L(s,S,c))}}}L(i,l,c){return c===i?l.length===1?I.localize(6,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?I.localize(7,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):I.localize(8,null,c.manifest.displayName||c.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?I.localize(9,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?I.localize(10,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):I.localize(11,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}M(i,l,c=[]){if(c.indexOf(i)!==-1)return[];c.push(i);const s=i.manifest.extensionPack?i.manifest.extensionPack:[];if(s.length){const u=l.filter(A=>!A.isBuiltin&&s.some(O=>(0,m.areSameExtensions)({id:O},A.identifier))),S=[];for(const A of u)S.push(...this.M(A,l,c));return[...u,...S]}return[]}N(i,l){return l.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=Re([Ae(0,E.IExtensionGalleryService),Ae(1,d.ITelemetryService),Ae(2,b.ILogService),Ae(3,o.IProductService),Ae(4,h.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function w(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((l,c)=>new Error(`${l.message}${l.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=w;function L(r){if(r instanceof E.ExtensionManagementError)return r;const i=new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:l,verificationStatus:c,duration:s,error:u,durationSinceUpdate:S}){let A,O;(0,g.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(A=E.ExtensionManagementErrorCode.Signature,O=c),c="Unverified")),u&&(u instanceof E.ExtensionManagementError?(A=u.code,u.code===E.ExtensionManagementErrorCode.Signature&&(O=u.message)):A=E.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...l,verificationStatus:c,success:!u,duration:s,errorcode:A,errorcodeDetail:O,durationSinceUpdate:S})}class n{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(i=>new Promise((l,c)=>{const s=i.onCancellationRequested(()=>{s.dispose(),c(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(pe[45],ve([1,0,14,15,2,6,27,4,30,34,16,5,12,32,35,8,9,31]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class f extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let w=class extends a.Disposable{constructor(r,i,l,c,s,u){super(),this.i=r,this.j=i,this.k=l,this.l=c,this.m=s,this.n=u,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const l=[],c=[];try{return await this.p(i,s=>{const u=[];for(const S of s)r.some(([A])=>(0,g.areSameExtensions)(A.identifier,S.identifier)&&A.manifest.version!==S.version)?l.push(S):u.push(S);for(const[S,A]of r)if(!u.some(O=>(0,g.areSameExtensions)(O.identifier,S.identifier)&&O.version===S.manifest.version)){const O={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:A};c.push(O),u.push(O)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),u}),c.length&&this.c.fire({extensions:c,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),c}catch(s){throw c.length&&this.c.fire({extensions:c,error:s,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:s,profileLocation:i}),s}}async updateMetadata(r,i){const l=[];return await this.p(i,c=>{const s=[];for(const u of c){const S=r.find(([A])=>(0,g.areSameExtensions)(A.identifier,u.identifier)&&A.manifest.version===u.version);S&&(u.metadata={...u.metadata,...S[1]},l.push(u)),s.push(u)}return s}),l}async removeExtensionFromProfile(r,i){const l=[];this.f.fire({extensions:l,profileLocation:i});try{await this.p(i,c=>{const s=[];for(const u of c)(0,g.areSameExtensions)(u.identifier,r.identifier)?l.push(u):s.push(u);return l.length&&this.f.fire({extensions:l,profileLocation:i}),s}),l.length&&this.g.fire({extensions:l,profileLocation:i})}catch(c){throw l.length&&this.g.fire({extensions:l,error:c,profileLocation:i}),c}}async p(r,i,l){return this.w(r).queue(async()=>{let c=[],s;try{const u=await this.j.readFile(r);s=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,T.toFileOperationResult)(u)!==1)throw u;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&l?.bailOutWhenFileNotFound)throw new f((0,o.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(r);let u=!1;for(const S of s){L(S)||this.r(r);let A;if((0,b.isString)(S.relativeLocation)&&S.relativeLocation)A=this.t(S.relativeLocation);else if((0,b.isString)(S.location))A=this.t(S.location),u=!0,S.relativeLocation=S.location,S.location=A.toJSON();else{A=k.URI.revive(S.location);const O=this.s(A);O&&(u=!0,S.relativeLocation=O)}c.push({identifier:S.identifier,location:A,version:S.version,metadata:S.metadata})}u&&await this.j.writeFile(r,R.VSBuffer.fromString(JSON.stringify(s)))}if(i){c=i(c);const u=c.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.s(S.location),metadata:S.metadata}));await this.j.writeFile(r,R.VSBuffer.fromString(JSON.stringify(u)))}return c})}r(r){const i=new f(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let l;try{l=(await this.j.readFile(r)).value.toString()}catch(s){if((0,T.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",r.toString());let c;try{const s=JSON.parse(l);Array.isArray(s)&&s.every(u=>L(u))?c=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(c)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(c)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,T.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(r)}catch(s){(0,T.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(i)}catch(s){(0,T.toFileOperationResult)(s)!==1&&this.n.error(s)}return c})()),this.u}w(r){let i=this.h.get(r);return i||(i=new y.Queue,this.h.set(r,i)),i}};w=Re([Ae(1,T.IFileService),Ae(2,m.IUserDataProfilesService),Ae(3,p.IUriIdentityService),Ae(4,d.ITelemetryService),Ae(5,E.ILogService)],w),e.AbstractExtensionsProfileScannerService=w;function L(n){return(0,b.isObject)(n)&&(0,v.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,b.isString)(n.location)&&n.location)&&((0,b.isUndefined)(n.relativeLocation)||(0,b.isString)(n.relativeLocation))&&n.version&&(0,b.isString)(n.version)}function t(n){return n?(0,b.isString)(n.path)&&(0,b.isString)(n.scheme):!1}}),define(pe[55],ve([1,0,18,14,22,15,9,72,165,2,13,7,3,19,51,59,8,4,176,25,34,36,76,16,5,12,26,6,61,45,32,35,206]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var B;(function(ee){function ne(ie,G){if(ie===G)return!0;const U=Object.keys(ie),Z=new Set;for(const oe of Object.keys(G))Z.add(oe);if(U.length!==Z.size)return!1;for(const oe of U){if(ie[oe]!==G[oe])return!1;Z.delete(oe)}return Z.size===0}ee.equals=ne})(B=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let q=class extends g.Disposable{constructor(ne,ie,G,U,Z,oe,me,$,W,N,P,M){super(),this.systemExtensionsLocation=ne,this.userExtensionsLocation=ie,this.l=G,this.m=U,this.n=Z,this.r=oe,this.s=me,this.t=$,this.u=W,this.v=N,this.w=P,this.y=M,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ue,this.m,this.h)),this.j=this.B(this.y.createInstance(ue,this.m,this.h)),this.k=this.B(this.y.createInstance(fe,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,w.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(ne,ie,G){const[U,Z]=await Promise.all([this.scanSystemExtensions(ne),this.scanUserExtensions(ie)]),oe=G?await this.scanExtensionsUnderDevelopment(ne,[...U,...Z]):[];return this.G(U,Z,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ne){const ie=[];ie.push(this.H(!!ne.useCache,ne.language)),ie.push(this.I(ne.language,!!ne.checkControlFile));const[G,U]=await Promise.all(ie);return this.F([...G,...U],0,ne,!1)}async scanUserExtensions(ne){const ie=ne.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",ie);const G=this.w.extUri.isEqual(ne.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(ie,!!ne.profileLocation,1,!ne.includeUninstalled,ne.language,!0,G),Z=ne.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let oe;try{oe=await Z.scanExtensions(U)}catch(me){if(me instanceof u.ExtensionsProfileScanningError&&me.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),oe=await Z.scanExtensions(U);else throw me}return oe=await this.F(oe,1,ne,!0),this.t.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(ne,ie){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const G=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===T.Schemas.file).map(async U=>{const Z=await this.L(U,!1,1,!0,ne.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Z)).map(me=>(me.type=ie.find($=>(0,w.areSameExtensions)($.identifier,me.identifier))?.type??me.type,this.k.validate(me,Z)))}))).flat();return this.F(G,"development",ne,!0)}return[]}async scanExistingExtension(ne,ie,G){const U=await this.L(ne,!1,ie,!0,G.language,!0,void 0),Z=await this.k.scanExtension(U);return!Z||!G.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(ne,ie,G){const U=await this.L(ne,!1,ie,!0,G.language,!0,void 0),Z=await this.k.scanOneOrMultipleExtensions(U);return this.F(Z,ie,G,!0)}async scanMetadata(ne){const ie=(0,m.joinPath)(ne,"package.json"),G=(await this.s.readFile(ie)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(ne,ie){const G=(0,m.joinPath)(ne,"package.json"),U=(await this.s.readFile(G)).value.toString(),Z=JSON.parse(U);ie.isMachineScoped=ie.isMachineScoped||void 0,ie.isBuiltin=ie.isBuiltin||void 0,Z.__metadata={...Z.__metadata,...ie},await this.s.writeFile((0,m.joinPath)(ne,"package.json"),D.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ne){if(ne instanceof u.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw ne}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ne=await this.scanUserExtensions({includeInvalid:!0});if(ne.length)await this.r.addExtensionsToProfile(ne.map(ie=>[ie,ie.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(ie){(0,n.toFileOperationResult)(ie)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(ie))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ne){this.t.error(ne)}finally{this.C=void 0}})()),this.C}async F(ne,ie,G,U){return G.includeAllVersions||(ne=this.G(ie===0?ne:void 0,ie===1?ne:void 0,ie==="development"?ne:void 0,await this.getTargetPlatform(),U)),G.includeInvalid||(ne=ne.filter(Z=>Z.isValid)),ne.sort((Z,oe)=>{const me=I.basename(Z.location.fsPath),$=I.basename(oe.location.fsPath);return me<$?-1:me>$?1:0})}G(ne,ie,G,U,Z){const oe=($,W,N)=>{if($.isValid&&!W.isValid)return!1;if($.isValid===W.isValid){if(Z&&p.gt($.manifest.version,W.manifest.version))return this.t.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(p.eq($.manifest.version,W.manifest.version)){if($.type===0)return this.t.debug(`Skipping extension ${W.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===U)return this.t.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${$.location.path} with ${W.location.path}.`):this.t.debug(`Overwriting user extension ${$.location.path} with ${W.location.path}.`),!0},me=new L.ExtensionIdentifierMap;return ne?.forEach($=>{const W=me.get($.identifier.id);(!W||oe(W,$,!1))&&me.set($.identifier.id,$)}),ie?.forEach($=>{const W=me.get($.identifier.id);if(!W&&ne&&$.type===0){this.t.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!W||oe(W,$,!1))&&me.set($.identifier.id,$)}),G?.forEach($=>{const W=me.get($.identifier.id);(!W||oe(W,$,!0))&&me.set($.identifier.id,$),me.set($.identifier.id,$)}),[...me.values()]}async H(ne,ie){this.t.trace("Started scanning system extensions");const G=await this.L(this.systemExtensionsLocation,!1,0,!0,ie,!0,void 0),Z=await(ne&&!G.devMode?this.i:this.k).scanExtensions(G);return this.t.trace("Scanned system extensions:",Z.length),Z}async I(ne,ie){const G=this.u.isBuilt?[]:this.v.builtInExtensions;if(!G?.length)return[];this.t.trace("Started scanning dev system extensions");const U=ie?await this.J():{},Z=[],oe=d.URI.file(I.normalize(I.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $ of G){const W=U[$.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":Z.push((0,m.joinPath)(oe,$.name));break;default:Z.push(d.URI.file(W));break}}const me=await Promise.all(Z.map(async $=>this.k.scanExtension(await this.L($,!1,0,!0,ne,!0,void 0))));return this.t.trace("Scanned dev system extensions:",me.length),(0,y.coalesce)(me)}async J(){try{const ne=await this.s.readFile(this.l);return JSON.parse(ne.value.toString())}catch{return{}}}async L(ne,ie,G,U,Z,oe,me){const $=await this.f(Z??E.language),W=await this.M(ne),N=ie&&!this.w.extUri.isEqual(ne,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=N?await this.M(N):void 0;return new le(ne,W,N,P,ie,me,G,U,oe,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,Z,$)}async M(ne){try{const ie=await this.s.stat(ne);if(typeof ie.mtime=="number")return ie.mtime}catch{}}};q=Re([Ae(4,S.IUserDataProfilesService),Ae(5,u.IExtensionsProfileScannerService),Ae(6,n.IFileService),Ae(7,i.ILogService),Ae(8,f.IEnvironmentService),Ae(9,l.IProductService),Ae(10,A.IUriIdentityService),Ae(11,r.IInstantiationService)],q),e.AbstractExtensionsScannerService=q;class le{constructor(ne,ie,G,U,Z,oe,me,$,W,N,P,M,K,te,j){this.location=ne,this.mtime=ie,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=U,this.profile=Z,this.profileScanOptions=oe,this.type=me,this.excludeObsolete=$,this.validate=W,this.productVersion=N,this.productDate=P,this.productCommit=M,this.devMode=K,this.language=te,this.translations=j}static createNlsConfiguration(ne){return{language:ne.language,pseudo:ne.language==="pseudo",devMode:ne.devMode,translations:ne.translations}}static equals(ne,ie){return(0,m.isEqual)(ne.location,ie.location)&&ne.mtime===ie.mtime&&(0,m.isEqual)(ne.applicationExtensionslocation,ie.applicationExtensionslocation)&&ne.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&ne.profile===ie.profile&&a.equals(ne.profileScanOptions,ie.profileScanOptions)&&ne.type===ie.type&&ne.excludeObsolete===ie.excludeObsolete&&ne.validate===ie.validate&&ne.productVersion===ie.productVersion&&ne.productDate===ie.productDate&&ne.productCommit===ie.productCommit&&ne.devMode===ie.devMode&&ne.language===ie.language&&B.equals(ne.translations,ie.translations)}}e.ExtensionScannerInput=le;let fe=class extends g.Disposable{constructor(ne,ie,G,U,Z){super(),this.f=ne,this.g=ie,this.h=G,this.i=U,this.j=Z}async scanExtensions(ne){const ie=ne.profile?await this.l(ne):await this.k(ne);let G={};if(ne.excludeObsolete&&ne.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();G=JSON.parse(U)}catch{}return(0,o.isEmptyObject)(G)?ie:ie.filter(U=>!G[w.ExtensionKey.create(U).toString()])}async k(ne){const ie=await this.i.resolve(ne.location);if(!ie.children?.length)return[];const G=await Promise.all(ie.children.map(async U=>{if(!U.isDirectory||ne.type===1&&(0,m.basename)(U.resource).indexOf(".")===0)return null;const Z=new le(U.resource,ne.mtime,ne.applicationExtensionslocation,ne.applicationExtensionslocationMtime,ne.profile,ne.profileScanOptions,ne.type,ne.excludeObsolete,ne.validate,ne.productVersion,ne.productDate,ne.productCommit,ne.devMode,ne.language,ne.translations);return this.scanExtension(Z)}));return(0,y.coalesce)(G).sort((U,Z)=>U.location.path<Z.location.path?-1:1)}async l(ne){let ie=await this.m(ne.location,()=>!0,ne);if(ne.applicationExtensionslocation&&!this.h.extUri.isEqual(ne.location,ne.applicationExtensionslocation)){ie=ie.filter(U=>!U.metadata?.isApplicationScoped);const G=await this.m(ne.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,ne);ie.push(...G)}return ie}async m(ne,ie,G){const U=await this.g.scanProfileExtensions(ne,G.profileScanOptions);if(!U.length)return[];const Z=await Promise.all(U.map(async oe=>{if(ie(oe)){const me=new le(oe.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(me,oe.metadata)}return null}));return(0,y.coalesce)(Z)}async scanOneOrMultipleExtensions(ne){try{if(await this.i.exists((0,m.joinPath)(ne.location,"package.json"))){const ie=await this.scanExtension(ne);return ie?[ie]:[]}else return await this.scanExtensions(ne)}catch(ie){return this.j.error(`Error scanning extensions at ${ne.location.path}:`,(0,C.getErrorMessage)(ie)),[]}}async scanExtension(ne,ie){try{let G=await this.scanExtensionManifest(ne.location);if(G){G.publisher||(G.publisher=L.UNDEFINED_PUBLISHER),ie=ie??G.__metadata,delete G.__metadata;const U=(0,w.getGalleryExtensionId)(G.publisher,G.name),Z=ie?.id?{id:U,uuid:ie.id}:{id:U},oe=ie?.isSystem?0:ne.type,me=oe===0||!!ie?.isBuiltin;G=await this.n(ne.location,G,le.createNlsConfiguration(ne));const $={type:oe,identifier:Z,manifest:G,location:ne.location,isBuiltin:me,targetPlatform:ie?.targetPlatform??"undefined",metadata:ie,isValid:!0,validations:[]};return ne.validate?this.validate($,ne):$}}catch(G){ne.type!==0&&this.j.error(G)}return null}validate(ne,ie){let G=!0;const U=(0,t.validateExtensionManifest)(ie.productVersion,ie.productDate,ie.location,ne.manifest,ne.isBuiltin);for(const[Z,oe]of U)Z===b.default.Error&&(G=!1,this.j.error(this.u(ie.location,oe)));return ne.isValid=G,ne.validations=U,ne}async scanExtensionManifest(ne){const ie=(0,m.joinPath)(ne,"package.json");let G;try{G=(await this.i.readFile(ie)).value.toString()}catch(Z){return(0,n.toFileOperationResult)(Z)!==1&&this.j.error(this.u(ne,(0,h.localize)(0,null,ie.path,Z.message))),null}let U;try{U=JSON.parse(G)}catch{const oe=[];(0,k.parse)(G,oe);for(const me of oe)this.j.error(this.u(ne,(0,h.localize)(1,null,ie.path,me.offset,me.length,(0,v.getParseErrorMessage)(me.error))));return null}return(0,k.getNodeType)(U)!=="object"?(this.j.error(this.u(ne,(0,h.localize)(2,null,ie.path))),null):U}async n(ne,ie,G){const U=await this.r(ne,ie,G);if(U)try{const Z=[],oe=await this.s(U.default,Z);if(Z.length>0)return Z.forEach($=>{this.j.error(this.u(ne,(0,h.localize)(3,null,U.default?.path,(0,v.getParseErrorMessage)($.error))))}),ie;if((0,k.getNodeType)(U)!=="object")return this.j.error(this.u(ne,(0,h.localize)(4,null,U.default?.path))),ie;const me=U.values||Object.create(null);return(0,O.localizeManifest)(ie,me,oe)}catch{}return ie}async r(ne,ie,G){const U=(0,m.joinPath)(ne,"package.nls.json"),Z=(W,N)=>{N.forEach(P=>{this.j.error(this.u(ne,(0,h.localize)(5,null,W?.path,(0,v.getParseErrorMessage)(P.error))))})},oe=W=>{this.j.error(this.u(ne,(0,h.localize)(6,null,W?.path)))},me=`${ie.publisher}.${ie.name}`,$=G.translations[me];if($)try{const W=d.URI.file($),N=(await this.i.readFile(W)).value.toString(),P=[],M=(0,k.parse)(N,P);return P.length>0?(Z(W,P),{values:void 0,default:U}):(0,k.getNodeType)(M)!=="object"?(oe(W),{values:void 0,default:U}):{values:M.contents?M.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let N;try{N=await this.t(ne,G)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const P=(await this.i.readFile(N.localized)).value.toString(),M=[],K=(0,k.parse)(P,M);return M.length>0?(Z(N.localized,M),{values:void 0,default:N.original}):(0,k.getNodeType)(K)!=="object"?(oe(N.localized),{values:void 0,default:N.original}):{values:K,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(ne,ie){if(ne)try{const G=(await this.i.readFile(ne)).value.toString();return(0,k.parse)(G,ie)}catch{}}t(ne,ie){return new Promise((G,U)=>{const Z=oe=>{const me=(0,m.joinPath)(ne,`package.nls.${oe}.json`);this.i.exists(me).then($=>{$&&G({localized:me,original:(0,m.joinPath)(ne,"package.nls.json")});const W=oe.lastIndexOf("-");W===-1?G({localized:(0,m.joinPath)(ne,"package.nls.json"),original:null}):(oe=oe.substring(0,W),Z(oe))})};if(ie.devMode||ie.pseudo||!ie.language)return G({localized:(0,m.joinPath)(ne,"package.nls.json"),original:null});Z(ie.language)})}u(ne,ie){return`[${ne.path}]: ${ie}`}};fe=Re([Ae(1,u.IExtensionsProfileScannerService),Ae(2,A.IUriIdentityService),Ae(3,n.IFileService),Ae(4,i.ILogService)],fe);let ue=class extends fe{constructor(ne,ie,G,U,Z,oe,me){super(ie,U,Z,oe,me),this.z=ne,this.C=G,this.w=this.B(new R.ThrottledDelayer(3e3)),this.y=this.B(new c.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(ne){const ie=this.H(ne),G=await this.D(ie);if(this.v=ne,G&&G.input&&le.equals(G.input,this.v))return this.j.debug("Using cached extensions scan result",ne.location.toString()),this.w.trigger(()=>this.G()),G.result.map(Z=>(Z.location=d.URI.revive(Z.location),Z));const U=await super.scanExtensions(ne);return await this.F(ie,{input:ne,result:U}),U}async D(ne){try{const ie=await this.i.readFile(ne),G=JSON.parse(ie.value.toString());return{result:G.result,input:(0,s.revive)(G.input)}}catch(ie){this.j.debug("Error while reading the extension cache file:",ne.path,(0,C.getErrorMessage)(ie))}return null}async F(ne,ie){try{await this.i.writeFile(ne,D.VSBuffer.fromString(JSON.stringify(ie)))}catch(G){this.j.debug("Error while writing the extension cache file:",ne.path,(0,C.getErrorMessage)(G))}}async G(){if(!this.v)return;const ne=this.H(this.v),ie=await this.D(ne);if(!ie)return;const G=ie.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!a.equals(U,G))try{this.j.info("Invalidating Cache",G,U),await this.i.del(ne),this.y.fire()}catch(Z){this.j.error(Z)}}H(ne){const ie=this.I(ne);return this.h.extUri.joinPath(ie.cacheHome,ne.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}I(ne){return ne.type===0?this.C.defaultProfile:ne.profile?this.h.extUri.isEqual(ne.location,this.z.extensionsResource)?this.z:this.C.profiles.find(ie=>this.h.extUri.isEqual(ne.location,ie.extensionsResource))??this.z:this.C.defaultProfile}};ue=Re([Ae(2,S.IUserDataProfilesService),Ae(3,u.IExtensionsProfileScannerService),Ae(4,A.IUriIdentityService),Ae(5,n.IFileService),Ae(6,i.ILogService)],ue);function re(ee,ne){const ie=(0,w.getExtensionId)(ee.manifest.publisher,ee.manifest.name);return{id:ie,identifier:new L.ExtensionIdentifier(ie),isBuiltin:ee.type===0,isUserBuiltin:ee.type===1&&ee.isBuiltin,isUnderDevelopment:ne,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,...ee.manifest}}e.toExtensionDescription=re;class _ extends q{constructor(ne,ie,G,U,Z,oe,me,$,W,N,P,M){super(ne,ie,(0,m.joinPath)(G,".vscode-oss-dev","extensions","control.json"),U,Z,oe,me,$,W,N,P,M),this.N=(async()=>{if(E.translationsConfigFile)try{const K=await this.s.readFile(d.URI.file(E.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}f(ne){return this.N}}e.NativeExtensionsScannerService=_}),define(pe[254],ve([1,0,49,14,39,6,2,13,7,23,12,32]),function(ae,e,y,R,a,D,C,k,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=class extends C.Disposable{constructor(p,b){super(),this.b=p,this.f=b,this.a=new R.Limiter(5)}async postUninstall(p){const b=this.g(p,"uninstall");b&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(o){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(o)}}));try{await g.Promises.rm(this.j(p))}catch(o){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(o)}}g(p,b){const o=`vscode:${b}`;if(p.location.scheme===k.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[o]=="string"){const d=p.manifest.scripts[o].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${o} should be a node script`),null):{script:(0,v.join)(p.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(p,b,o,d,h){return new Promise((f,w)=>{const L=this.i(p,b,o,h);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?w(r):f(void 0)};L.on("error",r=>{n((0,a.toErrorMessage)(r)||"Unknown")}),L.on("exit",(r,i)=>{n(r?`post-${b} process exited with code ${r}`:void 0)}),d&&(t=setTimeout(()=>{t=null,L.kill(),w("timed out")},5e3))})}i(p,b,o,d){const h={silent:!0,execArgv:void 0},f=(0,y.fork)(p,[`--type=extension-post-${b}`,...o],h);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const w=D.Event.fromNodeEventEmitter(f.stdout,"data"),L=D.Event.fromNodeEventEmitter(f.stderr,"data");w(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${b}`,r)),L(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${b}`,r));const t=D.Event.any(D.Event.map(w,r=>({data:`%c${r}`,format:[""]})),D.Event.map(L,r=>({data:`%c${r}`,format:["color: red"]})));return D.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),f}j(p){return(0,v.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};E=Re([Ae(0,I.IUserDataProfilesService),Ae(1,T.ILogService)],E),e.ExtensionsLifecycle=E}),define(pe[123],ve([1,0,12,32,35,31,45,16,25,4]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=class extends C.AbstractExtensionsProfileScannerService{constructor(E,m,p,b,o,d){super(g.URI.file(E.extensionsPath),m,p,b,o,d)}};T=Re([Ae(0,v.INativeEnvironmentService),Ae(1,k.IFileService),Ae(2,R.IUserDataProfilesService),Ae(3,a.IUriIdentityService),Ae(4,D.ITelemetryService),Ae(5,y.ILogService)],T),e.ExtensionsProfileScannerService=T}),define(pe[255],ve([1,0,14,6,2,42,8,156,5,32]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var T;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var E;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function m(h){const f=h.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=m;class p extends a.Disposable{constructor(f={flushInterval:p.a}){super(),this.j=f,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new y.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new a.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,y.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,a.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(f,w){if(w===e.TARGET_KEY){switch(f){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:w,target:this.F(f)[w]})}r(f){this.f.fire({reason:f})}get(f,w,L){return this.L(w)?.get(f,L)}getBoolean(f,w,L){return this.L(w)?.getBoolean(f,L)}getNumber(f,w,L){return this.L(w)?.getNumber(f,L)}store(f,w,L,t){if((0,C.isUndefinedOrNull)(w)){this.remove(f,L);return}this.t(()=>{this.u(f,L,t),this.L(L)?.set(f,w)})}remove(f,w){this.t(()=>{this.u(f,w,void 0),this.L(w)?.delete(f)})}t(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,w){const L=[],t=this.F(f);for(const n of Object.keys(t))t[n]===w&&L.push(n);return L}u(f,w,L){const t=this.F(w);typeof L=="number"?t[f]!==L&&(t[f]=L,this.L(w)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[f]=="number"&&(delete t[f],this.L(w)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(f){switch(f){case-1:return this.D;case 0:return this.z;default:return this.w}}G(f){const w=this.L(f);return w?m(w):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=T.NONE){this.f.fire({reason:f});const w=this.L(-1),L=this.L(0),t=this.L(1);switch(f){case T.NONE:await y.Promises.settled([w?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await y.Promises.settled([w?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return d(f,w,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(f,w){return this.r(T.NONE),(0,g.isUserDataProfile)(f)?this.N(f,w):this.O(f,w)}H(f,w){return!(f.id===w.id||b(w)&&b(f))}I(f,w,L,t){this.t(()=>{if(t)for(const[n,r]of f)w.set(n,r);else{const n=new Set;for(const[r,i]of f)n.add(r),w.get(r)!==i&&this.n(L,r);for(const[r]of w.items)n.has(r)||this.n(L,r)}})}}p.a=60*1e3,e.AbstractStorageService=p;function b(h){return h.isDefault||!!h.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class o extends p{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(f=>this.n(1,f))),this.B(this.P.onDidChangeStorage(f=>this.n(0,f))),this.B(this.p.onDidChangeStorage(f=>this.n(-1,f)))}L(f){switch(f){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(f){return!1}}e.InMemoryStorageService=o;async function d(h,f,w,L,t,n){const r=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,l=new Map;h.forEach((B,q)=>{i.set(q,B),l.set(q,r(B))});const c=new Map,s=new Map;f.forEach((B,q)=>{c.set(q,B),s.set(q,r(B))});const u=new Map,S=new Map;w.forEach((B,q)=>{u.set(q,B),S.set(q,r(B))}),console.group(L!==t?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const A=[];if(i.forEach((B,q)=>{A.push({key:q,value:B})}),console.table(A),console.groupEnd(),console.log(l),L!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const B=[];c.forEach((q,le)=>{B.push({key:le,value:q})}),console.table(B),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${n})`);const O=[];u.forEach((B,q)=>{O.push({key:q,value:B})}),console.table(O),console.groupEnd(),console.log(S)}e.logStorage=d}),define(pe[124],ve([1,0,18,20,9,3,28,8,4,24,25,30,34,76,16,12,26,44,239,255,31]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=D.isWeb?"web":(0,I.getTargetPlatform)(D.platform,C.arch),t="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...N){return String(N.reduce((P,M)=>P|M,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class S{constructor(P=u){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new S({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const K=[...this.d.criteria,...M.length?M.map(te=>({filterType:P,value:te})):[{filterType:P}]];return new S({...this.d,criteria:K})}withSortBy(P){return new S({...this.d,sortBy:P})}withSortOrder(P){return new S({...this.d,sortOrder:P})}withFlags(...P){return new S({...this.d,flags:P.reduce((M,K)=>M|K,0)})}withAssetTypes(...P){return new S({...this.d,assetTypes:P})}withSource(P){return new S({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:j,flags:H,assetTypes:J}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:j}],assetTypes:J,flags:H}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(N,P){const M=(N||[]).filter(K=>K.statisticName===P)[0];return M?M.value:0}function O(N){const P="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(K=>K.assetType.indexOf(P)===0).reduce((K,te)=>{const j=le(N,te.assetType);return j&&K.push([te.assetType.substring(P.length),j]),K},[])}function B(N){if(N.properties){const P=N.properties.filter(te=>te.key===l.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=P.filter(te=>M.test(te.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return le(N,l.Repository)}function q(N){return{uri:`${N.fallbackAssetUri}/${l.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${l.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function le(N,P){return N.files.filter(K=>K.assetType===P)[0]?{uri:`${N.assetUri}/${P}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${P}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function fe(N,P){const M=N.properties?N.properties.filter(te=>te.key===P):[],K=M.length>0&&M[0].value;return K?K.split(",").map(te=>(0,E.adoptToGalleryExtensionId)(te)):[]}function ue(N){const P=N.properties?N.properties.filter(M=>M.key===c.Engine):[];return P.length>0&&P[0].value||""}function re(N){const P=N.properties?N.properties.filter(M=>M.key===c.PreRelease):[];return P.length>0&&P[0].value==="true"}function _(N){const P=N.properties?N.properties.filter(K=>K.key===c.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function ee(N){return N.properties?.find(P=>P.key===c.SponsorLink)?.value}function ne(N){return N.indexOf("preview")!==-1}function ie(N){return N.targetPlatform?(0,I.toTargetPlatform)(N.targetPlatform):"undefined"}function G(N){const P=(0,y.distinct)(N.versions.map(ie)),M=!!N.tags?.includes(I.WEB_EXTENSION_TAG),K=P.indexOf("web");return M?K===-1&&P.push("web"):K!==-1&&P.splice(K,1),P}function U(N,P){const M=(0,I.getFallbackTargetPlarforms)(P);for(let K=0;K<N.length;K++){const te=N[K];if(te.version===N[K-1]?.version){let j=K;const H=ie(te);if(H===P)for(;j>0&&N[j-1].version===te.version;)j--;else if(M.includes(H))for(;j>0&&N[j-1].version===te.version&&ie(N[j-1])!==P;)j--;j!==K&&(N.splice(K,1),N.splice(j,0,te))}}return N}e.sortExtensionVersions=U;function Z(N,P,M){N.telemetryData={index:P,querySource:M,queryActivityId:N.queryContext?.[t]}}function oe(N,P,M,K){const te=N.versions[0],j={manifest:le(P,l.Manifest),readme:le(P,l.Details),changelog:le(P,l.Changelog),license:le(P,l.License),repository:B(P),download:q(P),icon:le(P,l.Icon),signature:le(P,l.Signature),coreTranslations:O(P)};return{identifier:{id:(0,E.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:P.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(te),description:N.shortDescription||"",installCount:A(N.statistics,"install"),rating:A(N.statistics,"averagerating"),ratingCount:A(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:M,assets:j,properties:{dependencies:fe(P,c.Dependency),extensionPack:fe(P,c.ExtensionPack),engine:ue(P),localizedLanguages:_(P),targetPlatform:ie(P),isPreReleaseVersion:re(P)},hasPreReleaseVersion:re(te),hasReleaseVersion:!0,preview:ne(N.flags),isSigned:!!j.signature,queryContext:K}}let me=class{constructor(P,M,K,te,j,H,J,V){this.k=M,this.l=K,this.n=te,this.o=j,this.q=H,this.u=J,this.w=V;const X=J.extensionsGallery,x=X?.servicePPEUrl&&V.getValue("_extensionsGallery.enablePPE");this.d=x?X.servicePPEUrl:X?.serviceUrl,this.g=x?void 0:X?.searchUrl,this.h=X?.controlUrl,this.j=(0,h.resolveMarketplaceHeaders)(J.version,J,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,K){const te=R.CancellationToken.isCancellationToken(M)?{}:M,j=R.CancellationToken.isCancellationToken(M)?M:K,H=[],J=[],V=[],X=[];let x=!0;for(const Ee of P){Ee.uuid?J.push(Ee.uuid):H.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);V.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&X.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),x=x&&!!Ee.hasPreRelease&&!Ce}if(!J.length&&!H.length)return[];let Q=new S().withPage(1,P.length);J.length&&(Q=Q.withFilter(i.ExtensionId,...J)),H.length&&(Q=Q.withFilter(i.ExtensionName,...H)),(te.queryAllVersions||x)&&(Q=Q.withFlags(Q.flags,n.IncludeVersions)),te.source&&(Q=Q.withSource(te.source));const{extensions:ce}=await this.z(Q,{targetPlatform:te.targetPlatform??L,includePreRelease:V,versions:X,compatible:!!te.compatible},j);return te.source&&ce.forEach((Ee,Ce)=>Z(Ee,Ce,te.source)),ce}async getCompatibleExtension(P,M,K){if((0,I.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(P,M,K))return P;const te=new S().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:j}=await this.z(te,{targetPlatform:K,compatible:!0,includePreRelease:M},R.CancellationToken.None);return j[0]||null}async isExtensionCompatible(P,M,K){if(!(0,I.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,K)||!M&&P.properties.isPreReleaseVersion)return!1;let te=P.properties.engine;if(!te){const j=await this.getManifest(P,R.CancellationToken.None);if(!j)throw new Error("Manifest was not found");te=j.engines.vscode}return(0,m.isEngineValid)(te,this.u.version,this.u.date)}async y(P,M,K,te,j){if(!(0,I.isTargetPlatformCompatible)(ie(P),te,j)||M!=="any"&&re(P)!==(M==="prerelease"))return!1;if(K)try{const H=await this.E(P);if(!(0,m.isEngineValid)(H,this.u.version,this.u.date))return!1}catch(H){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,a.getErrorMessage)(H)),!1}return!0}async query(P,M){let K=P.text||"";const te=P.pageSize??50;let j=new S().withPage(1,te);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,Q,ce)=>(j=j.withFilter(i.Category,ce||Q),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,Q,ce)=>(j=j.withFilter(i.Tag,ce||Q),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),j=j.withFilter(i.SearchText,K)),j=j.withSortBy(0)):P.ids?j=j.withFilter(i.ExtensionId,...P.ids):P.names?j=j.withFilter(i.ExtensionName,...P.names):j=j.withSortBy(4),typeof P.sortBy=="number"&&(j=j.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(j=j.withSortOrder(P.sortOrder)),P.source&&(j=j.withSource(P.source));const H=async(x,Q)=>{const{extensions:ce,total:Ee}=await this.z(x,{targetPlatform:L,compatible:!1,includePreRelease:!!P.includePreRelease},Q);return ce.forEach((Ce,ke)=>Z(Ce,(x.pageNumber-1)*x.pageSize+ke,P.source)),{extensions:ce,total:Ee}},{extensions:J,total:V}=await H(j,M),X=async(x,Q)=>{if(Q.isCancellationRequested)throw new a.CancellationError;const{extensions:ce}=await H(j.withPage(x+1),Q);return ce};return{firstPage:J,total:V,pageSize:j.pageSize,getPage:X}}async z(P,M,K){const te=P.flags;!!(P.flags&n.IncludeLatestVersionOnly)&&!!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(P.flags&n.IncludeLatestVersionOnly)&&!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),P=P.withFlags(P.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:j,total:H,context:J}=await this.B(P,K);if(!(P.flags&n.IncludeLatestVersionOnly)){const Q=[];for(const ce of j){const Ee=await this.A(ce,M,J);Ee&&Q.push(Ee)}return{extensions:Q,total:H}}const X=[],x=new Map;for(let Q=0;Q<j.length;Q++){const ce=j[Q],Ee={id:(0,E.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},Ce=(0,k.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,E.areSameExtensions)(Me,Ee))?.includePreRelease;if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(G(ce),M.targetPlatform))continue;const ke=await this.A(ce,M,J);!ke||ke.properties.isPreReleaseVersion&&(!Ce||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?x.set(ce.extensionId,Q):X.push([Q,ke])}if(x.size){const Q=new Date().getTime(),ce=new S().withFlags(te&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,x.size).withFilter(i.ExtensionId,...x.keys()),{extensions:Ee}=await this.z(ce,M,K);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Q,count:x.size});for(const Ce of Ee){const ke=x.get(Ce.identifier.uuid);X.push([ke,Ce])}}return{extensions:X.sort((Q,ce)=>Q[0]-ce[0]).map(([,Q])=>Q),total:H}}async A(P,M,K){const te={id:(0,E.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},j=M.versions?.find(X=>(0,E.areSameExtensions)(X,te))?.version,H=(0,k.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(X=>(0,E.areSameExtensions)(X,te))?.includePreRelease,J=G(P),V=U(P.versions,M.targetPlatform);if(M.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(J,M.targetPlatform))return null;for(let X=0;X<V.length;X++){const x=V[X];if(!(j&&x.version!==j)){if(await this.y(x,H?"any":"release",M.compatible,J,M.targetPlatform))return oe(P,x,J,K);if(j&&x.version===j)return null}}return j||M.compatible?null:oe(P,P.versions[0],J)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const K=await this.j,te=JSON.stringify(P.raw),j={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(te.length)},H=new Date().getTime();let J,V,X=0;try{if(J=await this.k.request({type:"POST",url:this.g&&P.criteria.some(Q=>Q.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:te,headers:j},M),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:X};const x=await(0,d.asJson)(J);if(x){const Q=x.results[0],ce=Q.extensions,Ee=Q.resultMetadata&&Q.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return X=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:X,context:{[t]:J.res.headers.activityid}}}return{galleryExtensions:[],total:X}}catch(x){throw V=x,x}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(te.length),duration:new Date().getTime()-H,success:!!J&&(0,d.isSuccess)(J),responseBodySize:J?.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:V?(0,a.isCancellationError)(V)?"canceled":(0,a.getErrorMessage)(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(P,M,K,te){if(!this.isEnabled())return;const j=D.isWeb?this.x(`/itemName/${P}.${M}/version/${K}/statType/${te==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${K}/stats?statType=${te}`),H=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",V={...await this.j,Accept:H};try{await this.k.request({type:"POST",url:j,headers:V},R.CancellationToken.None)}catch{}}async download(P,M,K){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const te=(0,E.getGalleryExtensionTelemetryData)(P),j=new Date().getTime(),H=Q=>this.o.publicLog("galleryService:downloadVSIX",{...te,duration:Q}),J=K===2?"install":K===3?"update":"",V=J?{uri:`${P.assets.download.uri}${v.URI.parse(P.assets.download.uri).query?"&":"?"}${J}=true`,fallbackUri:`${P.assets.download.fallbackUri}${v.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${J}=true`}:P.assets.download,X=P.queryContext?.[t]?{[t]:P.queryContext[t]}:void 0,x=await this.D(V,X?{headers:X}:void 0);await this.q.writeFile(M,x.stream),H(new Date().getTime()-j)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const K=await this.D(P.assets.signature);await this.q.writeFile(M,K.stream)}async getReadme(P,M){if(P.assets.readme){const K=await this.D(P.assets.readme,{},M);return await(0,d.asTextOrError)(K)||""}return""}async getManifest(P,M){if(P.assets.manifest){const K=await this.D(P.assets.manifest,{},M),te=await(0,d.asTextOrError)(K);return te?JSON.parse(te):null}return null}async C(P,M){const K=le(P,l.Manifest);if(!K)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},j=await this.D(K,{headers:te});return await(0,d.asJson)(j)}async getCoreTranslation(P,M){const K=P.assets.coreTranslations.filter(te=>te[0]===M.toUpperCase())[0];if(K){const te=await this.D(K[1]),j=await(0,d.asTextOrError)(te);return j?JSON.parse(j):null}return null}async getChangelog(P,M){if(P.assets.changelog){const K=await this.D(P.assets.changelog,{},M);return await(0,d.asTextOrError)(K)||""}return""}async getAllCompatibleVersions(P,M,K){let te=new S().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?te=te.withFilter(i.ExtensionId,P.identifier.uuid):te=te.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:j}=await this.B(te,R.CancellationToken.None);if(!j.length)return[];const H=G(j[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(H,K))return[];const J=[];await Promise.all(j[0].versions.map(async x=>{try{await this.y(x,M?"any":"release",!0,H,K)&&J.push(x)}catch{}}));const V=[],X=new Set;for(const x of U(J,K))X.has(x.version)||(X.add(x.version),V.push({version:x.version,date:x.lastUpdated,isPreReleaseVersion:re(x)}));return V}async D(P,M={},K=R.CancellationToken.None){const te=await this.j,j={type:"GET"},H={...te,...M.headers||{}};M={...M,...j,headers:H};const J=P.uri,V=P.fallbackUri,X={...M,url:J};try{const x=await this.k.request(X,K);if(x.res.statusCode===200)return x;const Q=await(0,d.asTextOrError)(x);throw new Error(`Expected 200, got back ${x.res.statusCode} instead.

${Q}`)}catch(x){if((0,a.isCancellationError)(x))throw x;const Q=(0,a.getErrorMessage)(x);this.o.publicLog2("galleryService:cdnFallback",{url:J,message:Q});const ce={...M,url:V};return this.k.request(ce,K)}}async E(P){let M=ue(P);if(!M){const K=await this.C(P,R.CancellationToken.None);if(!K)throw new Error("Manifest was not found");M=K.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,d.asJson)(P),K=[],te={};if(M){for(const j of M.malicious)K.push({id:j});if(M.migrateToPreRelease)for(const[j,H]of Object.entries(M.migrateToPreRelease))(!H.engine||(0,m.isEngineValid)(H.engine,this.u.version,this.u.date))&&(te[j.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[j,H]of Object.entries(M.deprecated))H&&(te[j.toLowerCase()]=(0,k.isBoolean)(H)?{}:H)}return{malicious:K,deprecated:te}}};me=Re([Ae(1,d.IRequestService),Ae(2,b.ILogService),Ae(3,T.IEnvironmentService),Ae(4,w.ITelemetryService),Ae(5,p.IFileService),Ae(6,o.IProductService),Ae(7,g.IConfigurationService)],me);let $=class extends me{constructor(P,M,K,te,j,H,J,V){super(P,M,K,te,j,H,J,V)}};$=Re([Ae(0,f.IStorageService),Ae(1,d.IRequestService),Ae(2,b.ILogService),Ae(3,T.IEnvironmentService),Ae(4,w.ITelemetryService),Ae(5,p.IFileService),Ae(6,o.IProductService),Ae(7,g.IConfigurationService)],$),e.ExtensionGalleryService=$;let W=class extends me{constructor(P,M,K,te,j,H,J){super(void 0,P,M,K,te,j,H,J)}};W=Re([Ae(0,d.IRequestService),Ae(1,b.ILogService),Ae(2,T.IEnvironmentService),Ae(3,w.ITelemetryService),Ae(4,p.IFileService),Ae(5,o.IProductService),Ae(6,g.IConfigurationService)],W),e.ExtensionGalleryServiceWithNoStorageService=W}),define(pe[256],ve([1,0,6,2,32,48]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class C{constructor(g,T){this.a=g,this.b=T}listen(g,T){const I=this.b(g);switch(T){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,E=>({all:E.all.map(m=>(0,D.transformOutgoingURIs)({...m},I)),added:E.added.map(m=>(0,D.transformOutgoingURIs)({...m},I)),removed:E.removed.map(m=>(0,D.transformOutgoingURIs)({...m},I)),updated:E.updated.map(m=>(0,D.transformOutgoingURIs)({...m},I))}))}throw new Error(`Invalid listen ${T}`)}async call(g,T,I){const E=this.b(g);switch(T){case"createProfile":{const m=await this.a.createProfile(I[0],I[1],I[2]);return(0,D.transformOutgoingURIs)({...m},E)}case"updateProfile":{let m=(0,a.reviveProfile)((0,D.transformIncomingURIs)(I[0],E),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,I[1]),(0,D.transformOutgoingURIs)({...m},E)}case"removeProfile":{const m=(0,a.reviveProfile)((0,D.transformIncomingURIs)(I[0],E),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${T}`)}}e.RemoteUserDataProfilesServiceChannel=C;class k extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,T,I){super(),this.profilesHome=T,this.f=I,this.a=[],this.b=this.B(new y.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(E=>(0,a.reviveProfile)(E,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(E=>{const m=E.added.map(o=>(0,a.reviveProfile)(o,this.profilesHome.scheme)),p=E.removed.map(o=>(0,a.reviveProfile)(o,this.profilesHome.scheme)),b=E.updated.map(o=>(0,a.reviveProfile)(o,this.profilesHome.scheme));this.a=E.all.map(o=>(0,a.reviveProfile)(o,this.profilesHome.scheme)),this.b.fire({added:m,removed:p,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,T,I){const E=await this.f.call("createNamedProfile",[g,T,I]);return(0,a.reviveProfile)(E,this.profilesHome.scheme)}async createProfile(g,T,I,E){const m=await this.f.call("createProfile",[g,T,I,E]);return(0,a.reviveProfile)(m,this.profilesHome.scheme)}async createTransientProfile(g){const T=await this.f.call("createTransientProfile",[g]);return(0,a.reviveProfile)(T,this.profilesHome.scheme)}async setProfileForWorkspace(g,T){await this.f.call("setProfileForWorkspace",[g,T])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,T){const I=await this.f.call("updateProfile",[g,T]);return(0,a.reviveProfile)(I,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=k}),define(pe[125],ve([1,0,4,25,16,12,233,35,32,8,234]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let I=class Jt extends v.UserDataProfilesService{constructor(b,o,d,h,f){super(d,h,o,f),this.P=b,this.Q=d}J(){return this.P.getItem(Jt.b,[]).map(o=>({...o,location:(0,g.isString)(o.location)?this.s.extUri.joinPath(this.profilesHome,o.location):y.URI.revive(o.location)}))}M(){const b=this.P.getItem(Jt.c,{});return this.P.getItem(Jt.a,!1)?b:this.I(b)}O(){return this.s.extUri.joinPath(y.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I.a="profileAssociationsMigration",I=Re([Ae(0,C.IStateReadService),Ae(1,k.IUriIdentityService),Ae(2,R.INativeEnvironmentService),Ae(3,a.IFileService),Ae(4,D.ILogService)],I),e.UserDataProfilesReadonlyService=I;let E=class Nt extends I{constructor(b,o,d,h,f){super(b,o,d,h,f),this.W=b}L(b){b.length?this.W.setItem(Nt.b,b.map(o=>({...o,location:this.s.extUri.basename(o.location)}))):this.W.removeItem(Nt.b)}J(){const b=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(b),this.W.setItem("userDataProfilesMigration",!0)),b}N(b){b.emptyWindows||b.workspaces?this.W.setItem(Nt.c,b):this.W.removeItem(Nt.c)}M(){const b="workspaceAndProfileInfo",o=this.W.getItem(b,void 0);if(o){this.W.removeItem(b);const h=o.reduce((f,{workspace:w,profile:L})=>(f[y.URI.revive(w).toString()]=y.URI.revive(L).toString(),f),{});this.W.setItem(Nt.c,{workspaces:h})}const d=super.M();return this.W.getItem(Nt.a,!1)||(this.N(d),this.W.setItem(Nt.a,!0)),d}};E=Re([Ae(0,C.IStateService),Ae(1,k.IUriIdentityService),Ae(2,R.INativeEnvironmentService),Ae(3,a.IFileService),Ae(4,D.ILogService)],E),e.UserDataProfilesService=E;let m=class extends E{constructor(b,o,d,h){super(new T.StateService(0,o,h,d),b,o,d,h)}async init(){return await this.W.init(),super.init()}};m=Re([Ae(0,k.IUriIdentityService),Ae(1,R.INativeEnvironmentService),Ae(2,a.IFileService),Ae(3,D.ILogService)],m),e.ServerUserDataProfilesService=m}),define(pe[126],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,y.createDecorator)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(D,C){this.a.set(D,C)}getExitInfo(D){return this.a.get(D)||null}}e.ExtensionHostStatusService=R}),define(pe[257],ve([1,0,6,14]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function a(C){let k=0,v=0,g=0;C>=1e3&&(g=Math.floor(C/1e3),C-=g*1e3),g>=60&&(v=Math.floor(g/60),g-=v*60),v>=60&&(k=Math.floor(v/60),v-=k*60);const T=k?`${k}h`:"",I=v?`${v}m`:"",E=g?`${g}s`:"",m=C?`${C}ms`:"";return`${T}${I}${E}${m}`}class D{constructor(k,v,g,T){this.i=k,this.j=v,this.a=new y.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=g,this.protocol=T,this.e=!1,this.f=new R.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${a(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${a(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${a(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(k){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${k}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${a(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const k=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),k.end(),this.a.fire(void 0)}acceptReconnection(k,v,g){this.d=k,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,g),this.protocol.endAcceptReconnection()}}e.ManagementConnection=D}),define(pe[86],ve([1,0,33,13,7,151,52]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const k=a.join(R.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function g(p){return new Promise(b=>y.exists(p,b))}function T(p,b){return g(k).then(o=>{if(!o||!C.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const d=`${p}||${b}`;let h=v.get(d);return h||(h=D.getNLSConfiguration(C.default.commit,b,k,p,p).then(f=>(I.is(f)&&(f._languagePackSupport=!0),f.locale!=="en"&&f.locale!=="en-us"&&Object.keys(f.availableLanguages).length===0&&v.delete(d),f)),v.set(d,h)),h})}e.getNLSConfiguration=T;var I;(function(p){function b(o){const d=o;return d&&typeof d._languagePackId=="string"}p.is=b})(I=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const E=async p=>{try{const b=m(await y.promises.readFile(p,"utf8"));return JSON.parse(b).locale}catch(b){return b.code!=="ENOENT"&&console.warn(b),"en"}};e.getLocaleFromConfig=E;const m=p=>{const b=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return p.replace(b,(o,d,h,f,w)=>{if(f)return"";if(w){const L=w.length;return L>2&&w[L-1]===`
`?w[L-2]==="\r"?`\r
`:`
`:""}else return o})}}),define(pe[127],ve([1,0,19,4,25,45,55,16,5,12,26,35,32,86]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends C.AbstractExtensionsScannerService{constructor(o,d,h,f,w,L,t,n){super(R.URI.file(w.builtinExtensionsPath),R.URI.file(w.extensionsPath),(0,y.joinPath)(w.userHome,".vscode-oss-dev","extensions","control.json"),o.defaultProfile,o,d,h,f,w,L,t,n),this.N=w}async f(o){const d=await(0,m.getNLSConfiguration)(o,this.N.userDataPath);if(m.InternalNLSConfiguration.is(d))try{const h=await this.s.readFile(R.URI.file(d._translationsConfigFile));return JSON.parse(h.value.toString())}catch{}return Object.create(null)}};p=Re([Ae(0,E.IUserDataProfilesService),Ae(1,D.IExtensionsProfileScannerService),Ae(2,k.IFileService),Ae(3,g.ILogService),Ae(4,a.INativeEnvironmentService),Ae(5,T.IProductService),Ae(6,I.IUriIdentityService),Ae(7,v.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(pe[258],ve([1,0,259,33,7,21,13,23]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var g;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(g=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(h){return!0}}e.NoneServerConnectionToken=T;class I{constructor(h){this.value=h,this.type=1}validate(h){return h===this.value}}e.OptionalServerConnectionToken=I;class E{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.MandatoryServerConnectionToken=E;class m{constructor(h){this.message=h}}e.ServerConnectionTokenParseError=m;async function p(d,h){const f=d["without-connection-token"],w=d["connection-token"],L=d["connection-token-file"],t=d.compatibility==="1.63";if(f)return typeof w<"u"||typeof L<"u"?new m("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof L<"u"){if(typeof w<"u")return new m("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=R.readFileSync(L).toString().replace(/\r?\n$/,"")}catch{return new m(`Unable to read the connection token file at '${L}'.`)}return v.test(n)?new E(n):new m(`The connection token defined in '${L} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof w<"u"?v.test(w)?t?new I(w):new E(w):new m(`The connection token '${w} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new I(await h())):new E(await h())}e.parseServerConnectionToken=p;async function b(d){return p(d,async()=>{if(!d["user-data-dir"])return(0,D.generateUuid)();const f=a.join(d["user-data-dir"],"token");try{const t=(await k.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(v.test(t))return t}catch{}const w=(0,D.generateUuid)();try{await k.Promises.writeFile(f,w,{mode:384})}catch{}return w})}e.determineServerConnectionToken=b;function o(d,h,f){if(d.validate(f.query[C.connectionTokenQueryName]))return!0;const w=y.parse(h.headers.cookie||"");return d.validate(w[C.connectionTokenCookieName])}e.requestHasValidConnectionToken=o}),define(pe[41],ve([1,0,194,105,63,5,25]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":a.OPTIONS["user-data-dir"],"enable-smoke-test-driver":a.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":a.OPTIONS["disable-telemetry"],"disable-workspace-trust":a.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:a.OPTIONS.log,logsPath:a.OPTIONS.logsPath,"force-disable-user-env":a.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":a.OPTIONS["extensions-dir"],"extensions-download-dir":a.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":a.OPTIONS["builtin-extensions-dir"],"install-extension":a.OPTIONS["install-extension"],"install-builtin-extension":a.OPTIONS["install-builtin-extension"],"uninstall-extension":a.OPTIONS["uninstall-extension"],"list-extensions":a.OPTIONS["list-extensions"],"locate-extension":a.OPTIONS["locate-extension"],"show-versions":a.OPTIONS["show-versions"],category:a.OPTIONS.category,force:a.OPTIONS.force,"do-not-sync":a.OPTIONS["do-not-sync"],"pre-release":a.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:a.OPTIONS.help,version:a.OPTIONS.version,"locate-shell-integration-path":a.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:a.OPTIONS._},e.IServerEnvironmentService=(0,D.refineServiceDecorator)(C.IEnvironmentService);class k extends R.NativeEnvironmentService{get isRemoteServer(){return!0}get args(){return super.args}}e.ServerEnvironmentService=k}),define(pe[260],ve([1,0,77,12,41,26,219,21,18]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let g=class extends C.BaseCredentialsMainService{constructor(I,E,m){super(I),this.p=E,this.r=m,this.p.args["github-auth"]&&this.t(this.p.args["github-auth"]).catch(p=>{this.h.error("Failed to store provided GitHub token",p)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new y.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((I,E)=>{ae(["keytar"],I,E)}),await this.f.findCredentials("test-keytar-loads")}catch(I){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${I.message??I}`),this.f=new y.InMemoryCredentialsProvider}return this.f}async t(I){const E="vscode.github-authentication",m=`${await this.getSecretStoragePrefix()}${E}`,p="github.auth",o=[["read:user","user:email","repo"]].map(f=>({id:(0,k.generateUuid)(),scopes:f.sort(),accessToken:I})),d=await this.getPassword(m,p);let h;if(d)try{const f=JSON.parse(d);f.content=JSON.parse(f.content),h=f}catch(f){this.h.error("Failed to parse existing GitHub credentials",f)}return h?.content&&(h.content=h.content.filter(f=>{const w=f.scopes.sort();return!o.find(L=>(0,v.equals)(w,L.scopes)&&L.account?.label===f.account?.label)})),this.setPassword(m,p,JSON.stringify({extensionId:E,...h||{},content:JSON.stringify([...o,...h?.content||[]])}))}};g=Re([Ae(0,R.ILogService),Ae(1,a.IServerEnvironmentService),Ae(2,D.IProductService)],g),e.CredentialsWebMainService=g}),define(pe[261],ve([1,0,296,244,262,29]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class C extends y.AppInsightsCore{constructor(v){super(),this.a=v}track(v){const g=v.baseData||{};g.properties||(g.properties={}),g.measurements||(g.measurements={});try{const T=D.cpus();g.measurements.cores=T.length,g.properties["common.cpuModel"]=T[0].model}catch{}try{g.measurements.memoryFree=D.freemem(),g.measurements.memoryTotal=D.totalmem()}catch{}try{g.properties["common.shell"]=D.userInfo().shell,g.properties["common.release"]=D.release(),g.properties["common.arch"]=D.arch()}catch{}try{const T=(/^http:/.test(this.a)?a:R).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});T.on("error",()=>{}),T.write(JSON.stringify(g)),T.end()}catch{}}}e.TelemetryClient=C}),define(pe[263],ve([1,0,33,75,82,259,118,38,57,3,12,41,7,13,21,26,44,20,4,15,8,86,54]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(B,q,le,fe){q.writeHead(le,{"Content-Type":"text/plain"}),q.end(fe)}e.serveError=r;var i;(function(B){B[B.NO_CACHING=0]="NO_CACHING",B[B.ETAG=1]="ETAG",B[B.NO_EXPIRY=2]="NO_EXPIRY"})(i=e.CacheControl||(e.CacheControl={}));async function l(B,q,le,fe,ue,re){try{const _=await y.promises.stat(B);if(q===1){const ee=`W/"${[_.ino,_.size,_.mtime.getTime()].join("-")}"`;if(fe.headers["if-none-match"]===ee)return ue.writeHead(304),void ue.end();re.Etag=ee}else q===2?re["Cache-Control"]="public, max-age=31536000":q===0&&(re["Cache-Control"]="no-store");re["Content-Type"]=n[(0,E.extname)(B)]||(0,v.getMediaMime)(B)||"text/plain",ue.writeHead(200,re),(0,y.createReadStream)(B).pipe(ue)}catch(_){return _.code!=="ENOENT"?(le.error(_),console.error(_.toString())):console.error(`File not found: ${B}`),ue.writeHead(404,{"Content-Type":"text/plain"}),void ue.end("Not found")}}e.serveFile=l;const c=(0,E.dirname)(m.FileAccess.asFileUri("").fsPath);let s=class{constructor(q,le,fe,ue,re){this.f=q,this.g=le,this.h=fe,this.i=ue,this.j=re,this.a=this.j.extensionsGallery?.resourceUrlTemplate?h.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const _=(0,t.getRemoteServerRootPath)(re);this.b=`${_}/static`,this.c=`${_}/callback`,this.d="/web-extension-resource"}async handle(q,le,fe){try{const ue=fe.pathname;return ue.startsWith(this.b)&&ue.charCodeAt(this.b.length)===47?this.k(q,le,fe):ue==="/"?this.n(q,le,fe):ue===this.c?this.p(le):ue.startsWith(this.d)&&ue.charCodeAt(this.d.length)===47?this.m(q,le,fe):r(q,le,404,"Not found.")}catch(ue){return this.h.error(ue),console.error(ue.toString()),r(q,le,500,"Internal Server Error.")}}async k(q,le,fe){const ue=Object.create(null),_=decodeURIComponent(fe.pathname).substring(this.b.length+1),ee=(0,E.join)(c,_);return(0,k.isEqualOrParent)(ee,c,!g.isLinux)?l(ee,this.g.isBuilt?2:1,this.h,q,le,ue):r(q,le,400,"Bad request.")}l(q){const le=q.authority.indexOf(".");return le!==-1?q.authority.substring(le+1):void 0}async m(q,le,fe){if(!this.a)return r(q,le,500,"No extension gallery service configured.");const ue=decodeURIComponent(fe.pathname),re=(0,E.normalize)(ue.substring(this.d.length+1)),_=h.URI.parse(re).with({scheme:this.a.scheme,authority:re.substring(0,re.indexOf("/")),path:re.substring(re.indexOf("/")+1)});if(this.l(this.a)!==this.l(_))return r(q,le,403,"Request Forbidden");const ee={},ne=me=>{const $=q.headers[me];$&&((0,w.isString)($)||$[0])?ee[me]=(0,w.isString)($)?$:$[0]:me!==me.toLowerCase()&&ne(me.toLowerCase())};ne("X-Client-Name"),ne("X-Client-Version"),ne("X-Machine-Id"),ne("X-Client-Commit");const ie=await this.i.request({type:"GET",url:_.toString(!0),headers:ee},d.CancellationToken.None),G=ie.res.statusCode||500;if(G!==200){let me=null;try{me=await(0,o.asTextOrError)(ie)}catch{}return r(q,le,G,me||`Request failed with status ${G}`)}const U=Object.create(null),Z=me=>{const $=ie.res.headers[me];$?U[me]=$:me!==me.toLowerCase()&&Z(me.toLowerCase())};Z("Cache-Control"),Z("Content-Type"),le.writeHead(200,U);const oe=await(0,f.streamToBuffer)(ie.stream);return void le.end(oe.buffer)}async n(q,le,fe){const ue=fe.query[m.connectionTokenQueryName];if(typeof ue=="string"){const te=Object.create(null);te["Set-Cookie"]=D.serialize(m.connectionTokenCookieName,ue,{sameSite:"lax",maxAge:60*60*24*7});const j=Object.create(null);for(const J in fe.query)J!==m.connectionTokenQueryName&&(j[J]=fe.query[J]);const H=a.format({pathname:"/",query:j});return te.Location=H,le.writeHead(302,te),void le.end()}const re="remote";if(!re)return r(q,le,400,"Bad request.");function _(te){return JSON.stringify(te).replace(/"/g,"&quot;")}let ee;this.g.args["enable-smoke-test-driver"]&&(ee=!1);const ne=te=>te&&h.URI.file(R.resolve(te)).with({scheme:m.Schemas.vscodeRemote,authority:re}),ie=m.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,G=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,p.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,U=(0,e.relativeRoot)((0,e.getOriginalUrl)(q)),Z=(0,e.relativePath)((0,e.getOriginalUrl)(q)),oe=this.g.args.locale||await(0,L.getLocaleFromConfig)(this.g.argvResource.fsPath),me=await(0,L.getNLSConfiguration)(oe,this.g.userDataPath),$={remoteAuthority:re,webviewEndpoint:Z+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:ee,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:ne(this.g.args["default-folder"]),workspaceUri:ne(this.g.args["default-workspace"]),productConfiguration:{codeServerVersion:this.j.codeServerVersion,rootEndpoint:U,updateEndpoint:this.g.args["disable-update-check"]?void 0:U+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?U+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??U+"/proxy/{{port}}/",serviceWorker:{scope:Z+"/",path:U+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery},callbackRoute:this.c},W=this.j.extensionsGallery?.nlsBaseUrl,N={WORKBENCH_WEB_CONFIGURATION:_($),WORKBENCH_AUTH_SESSION:G?_(G):"",WORKBENCH_WEB_BASE_URL:Z+this.b,WORKBENCH_NLS_BASE_URL:Z+(W?`${W}${W.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:U,VS_BASE:Z,NLS_CONFIGURATION:_(me)};let P;try{P=(await y.promises.readFile(ie)).toString().replace(/\{\{([^}]+)\}\}/g,(j,H)=>N[H]??"undefined")}catch{return le.writeHead(404,{"Content-Type":"text/plain"}),void le.end("Not found")}const M=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(P).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),K={"Content-Type":"text/html","Content-Security-Policy":M};return this.f.type!==0&&(K["Set-Cookie"]=D.serialize(m.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),le.writeHead(200,K),void le.end(P)}o(q){const le=/<script>([\s\S]+?)<\/script>/img,fe=[];let ue;for(;ue=le.exec(q);){const re=C.createHash("sha256"),_=ue[1].replace(/\r\n/g,`
`),ee=re.update(Buffer.from(_)).digest().toString("base64");fe.push(`'sha256-${ee}'`)}return fe}async p(q){const le=m.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,fe=(await y.promises.readFile(le)).toString(),ue=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(fe).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return q.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ue}),void q.end(fe)}};s=Re([Ae(1,I.IServerEnvironmentService),Ae(2,T.ILogService),Ae(3,o.IRequestService),Ae(4,b.IProductService)],s),e.WebClientServer=s;const u=(B,q=!1)=>B.replace(/\/\/+/g,"/").replace(/\/+$/,q?"/":"");e.normalizeUrlPath=u;const S=B=>{const q=(B.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(q>1?"../".repeat(q-1):""))};e.relativeRoot=S;const A=B=>{const q=B.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+q[q.length-1])};e.relativePath=A;const O=B=>B.originalUrl||B.url;e.getOriginalUrl=O}),define(pe[264],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,y.createDecorator)("IExtHostInitDataService")}),define(pe[265],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class R{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=R}),define(pe[69],ve([1,0,48]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(D){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:D,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function a(D){return new y.URITransformer(R(D))}e.createURITransformer=a}),define(pe[266],ve([1,0,3,42,4,69,48,101,237,7,19]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class I{constructor(m,p,b,o){this.b=m,this.c=p,this.d=b,this.e=o}async call(m,p,b){switch(p){case"getEnvironmentData":{const o=b,d=(0,D.createURITransformer)(o.remoteAuthority);let h=await this.f(o.profile);return h=(0,C.transformOutgoingURIs)(h,d),h}case"getExtensionHostExitInfo":{const o=b;return this.e.getExitInfo(o.reconnectionToken)}case"getDiagnosticInfo":{const o=b,d={machineInfo:(0,v.getMachineInfo)()},h=o.includeProcesses?(0,k.listProcesses)(process.pid):Promise.resolve();let f=[];const w={};if(o.folders){const L=(0,D.createURITransformer)("");f=o.folders.map(n=>a.URI.revive(L.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,v.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(r=>{w[(0,g.basename)(n.fsPath)]=r}))}return Promise.all([h,...f]).then(([L,t])=>(d.processes=L||void 0,d.workspaceMetadata=o.folders?w:void 0,d))}}throw new Error(`IPC Command ${p} not found`)}listen(m,p,b){throw new Error("Not supported")}async f(m){return m&&!this.d.profiles.some(p=>p.id===m)&&await this.d.createProfile(m,m),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:a.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,T.joinPath)(this.c.logsHome,`exthost${I.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(p=>({...p}))}}}}I.a=1,e.RemoteAgentEnvironmentChannel=I}),define(pe[267],ve([1,0,4,69,67,7,222]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class k extends C.AbstractDiskFileSystemProviderChannel{constructor(T,I){super(new a.DiskFileSystemProvider(T),T),this.H=I,this.G=new Map,this.B(this.a)}c(T){let I=this.G.get(T.remoteAuthority);return I||(I=(0,R.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,I)),I}f(T,I,E=!1){if(E&&I.path==="/vscode-resource"&&I.query){const m=JSON.parse(I.query).requestResourcePath;return y.URI.from({scheme:"file",path:m})}return y.URI.revive(T.transformIncoming(I))}F(T,I){return new v(T,I,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=k;class v extends C.AbstractSessionFileWatcher{constructor(T,I,E,m){super(T,I,E,m)}i(T){const I=T.args["file-watcher-polling"];if(I){const E=I.split(D.delimiter),m=Number(E[0]);if(m>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:m}}}j(T){if(T.extensionsPath)return[D.posix.join(T.extensionsPath,"**")]}}}),define(pe[87],ve([1,0,197,8,4,2,5,40,16,13,39,160,59]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var m;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(m=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b($){const W=$;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}e.isEditorPaneWithSelection=b;function o($,W,N){for(const P of N.visibleEditorPanes)if(P.group.id===W&&$.matches(P.input))return P.getViewState()}e.findViewStateForEditor=o;function d($){if(u($))return!1;const W=$;return a.URI.isUri(W?.resource)}e.isResourceEditorInput=d;function h($){if(u($))return!1;const W=$;return W?.original!==void 0&&W.modified!==void 0}e.isResourceDiffEditorInput=h;function f($){if(u($)||h($))return!1;const W=$;return W?.primary!==void 0&&W.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function w($){if(u($))return!1;const W=$;return W?W.resource===void 0||W.resource.scheme===g.Schemas.untitled||W.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;const L=/Untitled-\d+/;function t($){return $.scheme===g.Schemas.untitled&&$.path.length>1&&!L.test($.path)}e.isUntitledWithAssociatedResource=t;function n($){if(u($))return!1;const W=$;return a.URI.isUri(W?.base?.resource)&&a.URI.isUri(W?.input1?.resource)&&a.URI.isUri(W?.input2?.resource)&&a.URI.isUri(W?.result?.resource)}e.isResourceMergeEditorInput=n;var r;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var i;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(W,N){let P=this.a.get(W);return P||(P={source:W,label:N},this.a.set(W,P)),P.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.SaveSourceRegistry=new l;var c;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription",$[$.CanDropIntoEditor=128]="CanDropIntoEditor",$[$.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends D.Disposable{}e.AbstractEditorInput=s;function u($){return $ instanceof s}e.isEditorInput=u;function S($){const W=$;return a.URI.isUri(W?.preferredResource)}function A($){const W=$;return u(W?.primary)&&u(W?.secondary)}e.isSideBySideEditorInput=A;function O($){const W=$;return u(W?.modified)&&u(W?.original)}e.isDiffEditorInput=O;function B($,W,N,P,M){return me(P,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const K={...N,limits:{size:Number.MAX_VALUE}};$.openEditor(W,K)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>M.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:E.default.Warning})}e.createTooLargeFileError=B;function q($){return u($?.editor)}e.isEditorInputWithOptions=q;function le($){const W=$;return q($)&&W?.group!==void 0}e.isEditorInputWithOptionsAndGroup=le;function fe($){const W=$;return typeof W?.groupId=="number"&&u(W.editor)}e.isEditorIdentifier=fe;var ue;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(ue=e.EditorCloseContext||(e.EditorCloseContext={}));var re;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(re=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var _;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(_=e.SideBySideEditor||(e.SideBySideEditor={}));class ee{getOriginalUri(W,N){if(!W)return;if(n(W))return e.EditorResourceAccessor.getOriginalUri(W.result,N);if(N?.supportSideBySide){const{primary:M,secondary:K}=this.a(W);if(M&&K){if(N?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===_.ANY)return this.getOriginalUri(M,{filterByScheme:N.filterByScheme})??this.getOriginalUri(K,{filterByScheme:N.filterByScheme});W=N.supportSideBySide===_.PRIMARY?M:K}}if(h(W)||f(W)||n(W))return;const P=S(W)?W.preferredResource:W.resource;return!P||!N||!N.filterByScheme?P:this.b(P,N.filterByScheme)}a(W){return A(W)||f(W)?{primary:W.primary,secondary:W.secondary}:O(W)||h(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,N){if(!W)return;if(n(W))return e.EditorResourceAccessor.getCanonicalUri(W.result,N);if(N?.supportSideBySide){const{primary:M,secondary:K}=this.a(W);if(M&&K){if(N?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===_.ANY)return this.getCanonicalUri(M,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:N.filterByScheme});W=N.supportSideBySide===_.PRIMARY?M:K}}if(h(W)||f(W)||n(W))return;const P=W.resource;return!P||!N||!N.filterByScheme?P:this.b(P,N.filterByScheme)}b(W,N){if(Array.isArray(N)){if(N.some(P=>W.scheme===P))return W}else if(N===W.scheme)return W}}e.EditorResourceAccessor=new ee;var ne;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(ne=e.CloseDirection||(e.CloseDirection={}));class ie{constructor(){this.c=new Map,this.d=new Map}start(W){const N=this.a=W.get(C.IInstantiationService);for(const[P,M]of this.c)this.e(P,M,N);this.c.clear()}e(W,N,P){const M=P.createInstance(N);this.d.set(W,M)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(W,N){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,N,this.a):this.c.set(W,N),(0,D.toDisposable)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new ie);async function G($,W,N){return!$||!$.length?[]:await Promise.all($.map(async P=>{const M=a.URI.revive(P.fileUri);if(!M){N.info("Cannot resolve the path because it is not valid.",P);return}if(!await W.canHandleResource(M)){N.info("Cannot resolve the path because it cannot be handled",P);return}let te=P.exists,j=P.type;if(typeof te!="boolean"||typeof j!="number")try{j=(await W.stat(M)).isDirectory?v.FileType.Directory:v.FileType.Unknown,te=!0}catch(J){N.error(J),te=!1}if(!te&&P.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",P);return}if(j===v.FileType.Directory){N.info("Cannot resolve the path because it is a directory",P);return}const H={...P.options,pinned:!0};return te?{resource:M,options:H}:{resource:M,options:H,forceUntitled:!0}}))}e.pathsToEditors=G;var U;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function Z($){const W=$;if(!W)return!1;const N=W;if(N.modified)return Z(N.modified);const P=W;return!!(P.contributionsState&&P.viewState&&Array.isArray(P.cursorState))}e.isTextEditorViewState=Z;function oe($){return(0,T.isErrorWithActions)($)}e.isEditorOpenError=oe;function me($,W,N){const P=(0,T.createErrorWithActions)($,W);return P.forceMessage=N?.forceMessage,P.forceSeverity=N?.forceSeverity,P.allowDialog=N?.allowDialog,P}e.createEditorOpenError=me}),define(pe[128],ve([1,0,15,74,56,57,13,7,3,65]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var m;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(m=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var b;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(b=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var h;(function(_){_.scheme=C.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],ne=new RegExp(`^[${ee.join("")}]+`),ie=7;function G(W,N){const P=N.toString(ie),K=`${P.length<ee.length?ee[P.length-1]:"z"}${P}s${(0,y.encodeBase64)(y.VSBuffer.fromString(W.scheme),!0,!0)}`;return W.with({scheme:_.scheme,fragment:K})}_.generate=G;function U(W){if(W.scheme!==_.scheme)return;const N=W.fragment.indexOf("s");if(N<0)return;const P=parseInt(W.fragment.substring(0,N).replace(ne,""),ie),M=(0,y.decodeBase64)(W.fragment.substring(N+1)).toString();if(!isNaN(P))return{handle:P,notebook:W.with({scheme:M,fragment:null})}}_.parse=U;function Z(W,N){return W.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${W.scheme!==C.Schemas.file?W.scheme:""}`})}_.generateCellOutputUri=Z;function oe(W){if(W.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!N)return;const P=N[1]&&N[1]!==""?N[1]:void 0,M=N[2];return{outputId:P,notebook:W.with({scheme:M||C.Schemas.file,fragment:null})}}_.parseCellOutputUri=oe;function me(W,N,P){return _.generate(W,N).with({scheme:P})}_.generateCellPropertyUri=me;function $(W,N){if(W.scheme===N)return _.parse(W.with({scheme:_.scheme}))}_.parseCellPropertyUri=$})(h=e.CellUri||(e.CellUri={}));const f=_=>v.isWindows?_.replace(/\//g,"\\"):_;class w{constructor(ee=[],ne=e.NOTEBOOK_DISPLAY_ORDER){this.e=ne,this.d=[...new Set(ee)].map(ie=>({pattern:ie,matches:R.parse(f(ie))}))}sort(ee){const ne=new Map(a.Iterable.map(ee,G=>[G,f(G)]));let ie=[];for(const{matches:G}of this.d)for(const[U,Z]of ne)if(G(Z)){ie.push(U),ne.delete(U);break}return ne.size&&(ie=ie.concat([...ne.keys()].sort((G,U)=>this.e.indexOf(G)-this.e.indexOf(U)))),ie}prioritize(ee,ne){const ie=this.f(ee);if(ie===-1){this.d.unshift({pattern:ee,matches:R.parse(f(ee))});return}const G=new Set(ne.map(Z=>this.f(Z,ie)));G.delete(-1);const U=Array.from(G).sort();this.d.splice(ie+1,0,...U.map(Z=>this.d[Z]));for(let Z=U.length-1;Z>=0;Z--)this.d.splice(U[Z],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,ne=this.d.length){const ie=f(ee);for(let G=0;G<ne;G++)if(this.d[G].matches(ie))return G;return-1}}e.MimeTypeDisplayOrder=w;function L(_,ee,ne,ie=(G,U)=>G===U){const G=[];function U(me,$,W){if($===0&&W.length===0)return;const N=G[G.length-1];N&&N.start+N.deleteCount===me?(N.deleteCount+=$,N.toInsert.push(...W)):G.push({start:me,deleteCount:$,toInsert:W})}let Z=0,oe=0;for(;;){if(Z===_.length){U(Z,0,ee.slice(oe));break}if(oe===ee.length){U(Z,_.length-Z,[]);break}const me=_[Z],$=ee[oe];if(ie(me,$)){Z+=1,oe+=1;continue}ne($)?(U(Z,1,[]),Z+=1):(U(Z,0,[$]),oe+=1)}return G}e.diff=L,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(_){_.default="default",_.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(_){const ee=_;return!!((typeof ee.include=="string"||R.isRelativePattern(ee.include))&&(typeof ee.exclude=="string"||R.isRelativePattern(ee.exclude)))}e.isDocumentExcludePattern=n;function r(_,ee,ne){if(Array.isArray(_.viewType)&&_.viewType.indexOf(ee)>=0||_.viewType===ee)return!0;if(_.filenamePattern){const ie=n(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,G=n(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(R.match(ie,(0,k.basename)(ne.fsPath).toLowerCase()))return!(G&&R.match(G,(0,k.basename)(ne.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",logging:"notebook.logging"};var i;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(ee){return`${l.d}${ee}`}static parse(ee){if(ee.startsWith(l.d))return ee.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function c(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.isTextStreamMime=c;const s=new TextDecoder;function u(_){const ee=[];let ne=!1;for(const ie of _)(ee.length===0||ne)&&(ee.push(ie),ne=!0);return B(ee),re(y.VSBuffer.concat(ee.map(ie=>y.VSBuffer.wrap(ie))))}e.compressOutputItemStreams=u;const S=`${String.fromCharCode(27)}[A`,A=S.split("").map(_=>_.charCodeAt(0)),O=10;function B(_){_.forEach((ee,ne)=>{if(ne===0||ee.length<S.length)return;const ie=_[ne-1],G=ee.subarray(0,S.length);if(G[0]===A[0]&&G[1]===A[1]&&G[2]===A[2]){const U=ie.lastIndexOf(O);if(U===-1)return;_[ne-1]=ie.subarray(0,U),_[ne]=ee.subarray(S.length)}})}function q(_){let ee=_;do _=ee,ee=_.replace(/[^\n]\x08/gm,"");while(ee.length<_.length);return _}function le(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const ee=_.match(/^(.*)\r+/m)[1];let ne=_.match(/\r+(.*)$/m)[1];ne=ne+ee.slice(ne.length,ee.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return _}const fe="\b".charCodeAt(0),ue="\r".charCodeAt(0);function re(_){return!_.buffer.includes(fe)&&!_.buffer.includes(ue)?_:y.VSBuffer.fromString(le(q(s.decode(_.buffer))))}}),define(pe[268],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,y.createDecorator)("environmentVariableService")}),define(pe[269],ve([1,0,7,58,3,247,8]),function(ae,e,y,R,a,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function k(t,n){if(!!n)if(a.isWindows)for(const r in n){let i=r;for(const c in t)if(r.toLowerCase()===c.toLowerCase()){i=c;break}const l=n[r];l!==void 0&&v(t,i,l)}else Object.keys(n).forEach(r=>{const i=n[r];i!==void 0&&v(t,r,i)})}e.mergeEnvironments=k;function v(t,n,r){typeof r=="string"?t[n]=r:delete t[n]}function g(t,n,r,i){t.TERM_PROGRAM="vscode",n&&(t.TERM_PROGRAM_VERSION=n),E(t,i)&&(t.LANG=m(r)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=g;function T(t,n){if(!!n)for(const r of Object.keys(n)){const i=n[r];i!=null&&(t[r]=i)}}async function I(t,n){return await Promise.all(Object.entries(n).map(async([r,i])=>{if(typeof i=="string")try{n[r]=await t(i)}catch{n[r]=i}})),n}function E(t,n){if(n==="on")return!0;if(n==="auto"){const r=t.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=E;function m(t){const n=t?t.split("-"):[],r=n.length;if(r===0)return"en_US.UTF-8";if(r===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=m;async function p(t,n,r,i,l,c){if(t.cwd){const u=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,S=await b(u,r);return(0,D.sanitizeCwd)(S||u)}let s;return!t.ignoreConfigurationCwd&&l&&(r&&(l=await b(l,r,c)),l&&(y.isAbsolute(l)?s=l:i&&(s=y.join(i.fsPath,l)))),s||(s=i?i.fsPath:n||""),(0,D.sanitizeCwd)(s)}e.getCwd=p;async function b(t,n,r){if(n)try{return await n(t)}catch(i){r?.error("Could not resolve terminal cwd",i);return}return t}function o(t,n,r){if(!!r)return i=>r.resolveWithEnvironment(n,t,i)}e.createVariableResolver=o;async function d(t,n,r,i,l,c,s,u=a.platform){let S;s&&(S=f(t,"automationShell",u)),S||(S=f(t,"shell",u));let A=S||n;if(u===3&&!r&&i){const O=y.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();A&&A.toLowerCase().indexOf(O)===0&&(A=y.join(i,"System32",A.substr(O.length+1)))}if(A&&u===3&&(A=A.replace(/\//g,"\\")),l)try{A=await l(A)}catch(O){c.error("Could not resolve shell",O)}return A}e.getDefaultShell=d;async function h(t,n,r,i,l=a.platform){if(n&&f(t,"automationShell",l))return[];const c=l===3?"windows":l===1?"osx":"linux";let s=t(`terminal.integrated.shellArgs.${c}`);if(!s)return[];if(typeof s=="string"&&l===3)return r?await r(s):s;if(r){const u=[];for(const S of s)try{u.push(await r(S))}catch(A){i.error(`Could not resolve terminal.integrated.shellArgs.${c}`,A),u.push(S)}s=u}return s}e.getDefaultShellArgs=h;function f(t,n,r=a.platform){return t(`terminal.integrated.${n}.${r===3?"windows":r===1?"osx":"linux"}`)}async function w(t,n,r,i,l,c){const s={};if(t.strictEnv)T(s,t.env);else{T(s,c);const u={...n};r&&(u&&await I(r,u),t.env&&await I(r,t.env)),(0,R.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),k(s,u),k(s,t.env),g(s,i,a.language,l)}return s}e.createTerminalEnvironment=w;async function L(t,n,r,i,l,c,s=a.isWindows){let u;if((0,C.isString)(t)?u=t:(u=t.fsPath,s&&c!==1?u=u.replace(/\\/g,"/"):!s&&c===1&&(u=u.replace(/\//g,"\\"))),!n)return u;const S=u.includes(" "),A=u.includes("(")||u.includes(")"),O=y.basename(n,".exe"),B=O==="pwsh"||r==="pwsh"||O==="powershell"||r==="powershell";if(B&&(S||u.includes("'")))return`& '${u.replace(/'/g,"''")}'`;if(A&&B)return`& '${u}'`;if(c===1){if(i!==void 0)return i==="gitbash"?(0,D.escapeNonWindowsPath)(u.replace(/\\/g,"/")):i==="wsl"?l?.getWslPath(u,"win-to-unix")||u:S?`"${u}"`:u;const q=n.toLowerCase();return q.includes("wsl")||q.includes("bash.exe")&&!q.toLowerCase().includes("git")?l?.getWslPath(u,"win-to-unix")||u:S?`"${u}"`:u}return(0,D.escapeNonWindowsPath)(u)}e.preparePathForShell=L}),define(pe[70],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(D){D.Delimiter="\0"})(y=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class a{static fromExtHostTestItem(C,k,v=C.parent){if(C._isRoot)return new a([k]);const g=[C.id];for(let T=v;T&&T.id!==k;T=T.parent)g.push(T.id);return g.push(k),new a(g.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new a(C.split("\0"))}static join(C,k){return new a([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static parentId(C){const k=C.lastIndexOf("\0");return k===-1?void 0:C.slice(0,k)}static localId(C){const k=C.lastIndexOf("\0");return k===-1?C:C.slice(k+1)}static compare(C,k){return C===k?0:k.startsWith(C+"\0")?2:C.startsWith(k+"\0")?3:1}constructor(C,k=C.length){if(this.path=C,this.d=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new a(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new a(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new a(this.path,C)}compare(C){if(typeof C=="string")return a.compare(this.toString(),C);for(let k=0;k<C.d&&k<this.d;k++)if(C.path[k]!==this.path[k])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=a}),define(pe[88],ve([1,0,4,50,70]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable",s[s.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const k=s=>"runId"in s;e.isStartControllerTests=k;var v;(function(s){s.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),s.deserialize=u=>({range:R.Range.lift(u.range),uri:y.URI.revive(u.uri)})})(v=e.IRichLocation||(e.IRichLocation={}));var g;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(g=e.TestMessageType||(e.TestMessageType={}));var T;(function(s){s.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&v.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&v.deserialize(u.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(s,u)=>`${u?"s":"e"}${s}`;e.getMarkId=I;var E;(function(s){s.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&v.serialize(u.location)}),s.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&v.deserialize(u.location)})})(E=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(s){s.serialize=u=>u.type===0?T.serialize(u):E.serialize(u),s.deserialize=u=>u.type===0?T.deserialize(u):E.deserialize(u)})(m=e.ITestMessage||(e.ITestMessage={}));var p;(function(s){s.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),s.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.serialize)}),s.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const b="\0",o=(s,u)=>s+b+u;e.namespaceTestTag=o;const d=s=>{const u=s.indexOf(b);return{ctrlId:s.slice(0,u),tagId:s.slice(u+1)}};e.denamespaceTestTag=d;var h;(function(s){s.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),s.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?R.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(h=e.ITestItem||(e.ITestItem={}));var f;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var w;(function(s){s.serialize=u=>({expand:u.expand,item:h.serialize(u.item)}),s.deserialize=u=>({controllerId:a.TestId.root(u.item.extId),expand:u.expand,item:h.deserialize(u.item)})})(w=e.InternalTestItem||(e.InternalTestItem={}));var L;(function(s){s.serialize=u=>{let S;return u.item&&(S={},u.item.label!==void 0&&(S.label=u.item.label),u.item.tags!==void 0&&(S.tags=u.item.tags),u.item.busy!==void 0&&(S.busy=u.item.busy),u.item.uri!==void 0&&(S.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(S.range=u.item.range?.toJSON()),u.item.description!==void 0&&(S.description=u.item.description),u.item.error!==void 0&&(S.error=u.item.error),u.item.sortText!==void 0&&(S.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:S}},s.deserialize=u=>{let S;return u.item&&(S={},u.item.label!==void 0&&(S.label=u.item.label),u.item.tags!==void 0&&(S.tags=u.item.tags),u.item.busy!==void 0&&(S.busy=u.item.busy),u.item.range!==void 0&&(S.range=u.item.range?R.Range.lift(u.item.range):null),u.item.description!==void 0&&(S.description=u.item.description),u.item.error!==void 0&&(S.error=u.item.error),u.item.sortText!==void 0&&(S.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:S}}})(L=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(s,u)=>{u.expand!==void 0&&(s.expand=u.expand),u.item!==void 0&&(s.item=s.item?Object.assign(s.item,u.item):u.item)};e.applyTestItemUpdate=t;var n;(function(s){s.serializeWithoutMessages=u=>({...w.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.serializeWithoutMessages),retired:u.retired}),s.serialize=u=>({...w.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.serialize),retired:u.retired}),s.deserialize=u=>({...w.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(p.deserialize),retired:!0})})(n=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(s){s.deserialize=u=>u.op===0?{op:u.op,item:w.deserialize(u.item)}:u.op===1?{op:u.op,item:L.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,s.serialize=u=>u.op===0?{op:u.op,item:w.serialize(u.item)}:u.op===1?{op:u.op,item:L.serialize(u.item)}:u})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const S=this.o();for(const A of u)switch(A.op){case 0:this.j(w.deserialize(A.item),S);break;case 1:this.k(L.deserialize(A.item),S);break;case 3:this.l(A.itemId,S);break;case 5:this.m(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}S.complete?.()}j(u,S){const A=a.TestId.parentId(u.item.extId)?.toString();let O;if(!A)O=this.p(u),this.f.add(O),this.d.set(u.item.extId,O);else if(this.d.has(A)){const B=this.d.get(A);B.children.add(u.item.extId),O=this.p(u,B),this.d.set(u.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return S.add?.(O),u.expand===2&&this.g++,O}k(u,S){const A=this.d.get(u.extId);if(!!A)return u.expand!==void 0&&(A.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(A,u),S.update?.(A),A}l(u,S){const A=this.d.get(u);if(!A)return;const O=a.TestId.parentId(A.item.extId)?.toString();O?this.d.get(O).children.delete(A.item.extId):this.f.delete(A);const B=[[u]];for(;B.length;)for(const q of B.pop()){const le=this.d.get(q);le&&(B.push(le.children),this.d.delete(q),S.remove?.(le,le!==A),le.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(pe[129],ve([1,0,14,6,2,91,88,70]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(v=e.TestItemEventOp||(e.TestItemEventOp={}));const g=(h,f)=>h===f,I=Object.entries({range:(h,f)=>h===f?!0:!h||!f?!1:h.equalsRange(f),busy:g,label:g,description:g,error:g,sortText:g,tags:(h,f)=>!(h.length!==f.length||h.some(w=>!f.includes(w)))}),E=(h,f)=>{let w;for(const[L,t]of I)t(h[L],f[L])||(w?w[L]=f[L]:w={[L]:f[L]});return w};class m extends a.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new y.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const w of this.tree.values())this.G(w)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const w of this.k)if(w.op===2&&w.uri===f.uri){w.docv=f.docv;return}break}case 1:{const w=this.k[this.k.length-1];if(w){if(w.op===1&&w.item.extId===f.item.extId){(0,C.applyTestItemUpdate)(w.item,f.item);return}if(w.op===0&&w.item.item.extId===f.item.extId){(0,C.applyTestItemUpdate)(w.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,w){const L=this.tree.get(f);if(!!L){if((L.expandLevels===void 0||w>L.expandLevels)&&(L.expandLevels=w),L.expand===1){const t=this.I(L);return t.isOpen()?this.H(L,w-1):t.wait().then(()=>this.H(L,w-1))}else if(L.expand===3)return L.resolveBarrier?.isOpen()===!1?L.resolveBarrier.wait().then(()=>this.H(L,w-1)):this.H(L,w-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,w){switch(w.op){case 3:this.L(k.TestId.joinToString(f.fullId,w.id));break;case 0:this.u(w.item,f);break;case 5:for(const L of w.ops)this.p(f,L);break;case 1:this.w(w.new,w.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:w.update}});break;case 6:this.s(f.actual.uri);break;default:(0,D.assertNever)(w)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,w){const L=k.TestId.fromExtHostTestItem(f,this.root.id,w?.actual),t=this.m.getApiFor(f);t.parent&&t.parent!==w?.actual&&this.m.getChildren(t.parent).delete(f.id);let n=this.tree.get(L.toString());if(!n){n={fullId:L,actual:f,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(f,w),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(f)}}),this.F(f,n,w);return}if(n.actual===f){this.D(f,n,w);return}if(n.actual.uri?.toString()!==f.uri?.toString())return this.L(L.toString()),this.u(f,w);const r=this.m.getChildren(n.actual),i=n.actual,l=E(this.m.toITestItem(i),this.m.toITestItem(f));this.m.getApiFor(i).listener=void 0,n.actual=f,n.expand=0,l&&(l.hasOwnProperty("tags")&&(this.w(f.tags,i.tags,L.toString()),delete l.tags),this.p(n,{op:4,update:l})),this.F(f,n,w);for(const[c,s]of r)this.m.getChildren(f).get(s.id)||this.L(k.TestId.joinToString(L,s.id));this.s(n.actual.uri)}w(f,w,L){const t=new Set(w.map(n=>n.id));for(const n of f)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:L,item:{tags:f.map(n=>(0,C.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(f){const w=this.j.get(f.id);w?w.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const w=this.j.get(f);w&&!--w.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,f)}))}C(f,w){this.m.getApiFor(f).parent=w&&w.actual!==this.root?w.actual:void 0}D(f,w,L){this.C(f,L);const t=this.m.getApiFor(f);t.parent=L?.actual,t.listener=n=>this.p(w,n),this.G(w)}F(f,w,L){this.D(f,w,L);for(const[t,n]of this.m.getChildren(f))this.u(n,w)}G(f){let w;this.h?f.resolveBarrier?w=f.resolveBarrier.isOpen()?3:2:w=f.actual.canResolveChildren?1:0:w=0,w!==f.expand&&(f.expand=w,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:w}}),w===1&&f.expandLevels!==void 0&&this.I(f))}H(f,w){if(w<0)return;const L=[];for(const[t,n]of this.m.getChildren(f.actual)){const r=this.expand(k.TestId.joinToString(f.fullId,n.id),w);(0,y.isThenable)(r)&&L.push(r)}if(L.length)return Promise.all(L).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const n=new y.Barrier;return n.open(),n}f.expand=2,this.J(f);const w=f.resolveBarrier=new y.Barrier,L=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(n){L(n)}return(0,y.isThenable)(t)?t.catch(L).then(()=>{w.open(),this.G(f)}):(w.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const w=this.tree.get(f);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const L=[w];for(;L.length;){const t=L.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.m.getChildren(t.actual))L.push(this.tree.get(k.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=m;class p extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=p;class b extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class o extends Error{constructor(f,w,L){super(`TestItem with ID "${f}" is from controller "${w}" and cannot be added as a child of an item from controller "${L}".`)}}e.MixedTestItemController=o;const d=(h,f,w)=>{let L=new Map;return{get size(){return L.size},forEach(t,n){for(const r of L.values())t.call(n,r,this)},[Symbol.iterator](){return L.entries()},replace(t){const n=new Map,r=new Set(L.keys()),i={op:5,ops:[]};for(const l of t){if(!(l instanceof w))throw new b(l.id);const c=f(l).controllerId;if(c!==h.controllerId)throw new o(l.id,c,h.controllerId);if(n.has(l.id))throw new p(l.id);n.set(l.id,l),r.delete(l.id),i.ops.push({op:0,item:l})}for(const l of r.keys())i.ops.push({op:3,id:l});h.listener?.(i),L=n},add(t){if(!(t instanceof w))throw new b(t.id);L.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){L.delete(t)&&h.listener?.({op:3,id:t})},get(t){return L.get(t)},toJSON(){return Array.from(L.values())}}};e.createTestItemChildren=d}),define(pe[130],ve([1,0,129]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,a=(C,k)=>{const v={controllerId:k};return R.set(C,v),v};e.createPrivateApiFor=a;const D=C=>{const k=R.get(C);if(!k)throw new y.InvalidTestItemError(C?.id||"<unknown>");return k};e.getPrivateApiFor=D}),define(pe[270],ve([1,0,24,5]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,R.refineServiceDecorator)(y.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[131],ve([1,0,5]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,y.createDecorator)("configurationResolverService");var R;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator"})(R=e.VariableKind||(e.VariableKind={}));class a extends Error{constructor(C,k){super(k),this.variable=C}}e.VariableError=a}),define(pe[271],ve([1,0,7,28,8,22,3,149,198,131,17]),function(ae,e,y,R,a,D,C,k,v,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(m,p,b,o){this.g=new Map,this.a=m,this.b=p,this.d=b,o&&(this.c=o.then(d=>this.h(d)))}h(m){if(C.isWindows){const p=Object.create(null);return Object.keys(m).forEach(b=>{p[b.toLowerCase()]=m[b]}),p}return m}resolveWithEnvironment(m,p,b){return this.j({env:this.h(m),userHome:void 0},p?p.uri:void 0,b)}async resolveAsync(m,p){const b={env:await this.c,userHome:await this.d};return this.j(b,m?m.uri:void 0,p)}async i(m,p,b,o){const d=D.deepClone(p);C.isWindows&&d.windows?Object.keys(d.windows).forEach(f=>d[f]=d.windows[f]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(f=>d[f]=d.osx[f]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(f=>d[f]=d.linux[f]),delete d.windows,delete d.osx,delete d.linux;const h={env:await this.c,userHome:await this.d};return this.j(h,m?m.uri:void 0,d,b,o)}async resolveAnyAsync(m,p,b){return this.i(m,p,b)}async resolveAnyMap(m,p,b){const o=new Map;return{newConfig:await this.i(m,p,b,o),resolvedVariables:o}}resolveWithInteractionReplace(m,p,b,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,p,b,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,p){if(this.g.has(m))throw new Error("Variable "+m+" is contributed twice.");this.g.set(m,p)}async j(m,p,b,o,d){if(a.isString(b))return this.l(m,p,b,o,d);if(Array.isArray(b))return Promise.all(b.map(h=>this.j(m,p,h,o,d)));if(a.isObject(b)){const h=Object.create(null),f=await Promise.all(Object.keys(b).map(async w=>[await this.l(m,p,w,o,d),await this.j(m,p,b[w],o,d)]));for(const[w,L]of f)h[w]=L;return h}return b}l(m,p,b,o,d){return(0,T.replaceAsync)(b,I.VARIABLE_REGEXP,async(h,f)=>{if(f.includes(I.VARIABLE_LHS))return h;let w=await this.n(m,h,f,p,o);return d?.set(f,w),w!==h&&a.isString(w)&&w.match(I.VARIABLE_REGEXP)&&(w=await this.l(m,p,w,o,d)),w})}m(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async n(m,p,b,o,d){let h;const f=b.split(":");f.length>1&&(b=f[0],h=f[1]);const w=n=>{const r=this.a.getFilePath();if(r)return(0,k.normalizeDriveLetter)(r);throw new g.VariableError(n,(0,v.localize)(0,null,p))},L=n=>{const r=w(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,k.normalizeDriveLetter)(i)}throw new g.VariableError(n,(0,v.localize)(1,null,p,y.basename(r)))},t=n=>{if(h){const r=this.a.getFolderUri(h);if(r)return r;throw new g.VariableError(n,(0,v.localize)(2,null,p,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new g.VariableError(n,(0,v.localize)(3,null,p)):new g.VariableError(n,(0,v.localize)(4,null,p))};switch(b){case"env":if(h){if(m.env){const n=m.env[C.isWindows?h.toLowerCase():h];if(a.isString(n))return n}return""}throw new g.VariableError(g.VariableKind.Env,(0,v.localize)(5,null,p));case"config":if(h){const n=this.a.getConfigurationValue(o,h);if(a.isUndefinedOrNull(n))throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(6,null,p,h));if(a.isObject(n))throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(7,null,p,h));return n}throw new g.VariableError(g.VariableKind.Config,(0,v.localize)(8,null,p));case"command":return this.o(g.VariableKind.Command,p,h,d,"command");case"input":return this.o(g.VariableKind.Input,p,h,d,"input");case"extensionInstallFolder":if(h){const n=await this.a.getExtension(h);if(!n)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,p,h));return this.m(n.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,p));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.m(t(g.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,k.normalizeDriveLetter)(this.m(t(g.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.normalizeDriveLetter)(y.basename(this.m(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,v.localize)(11,null,p))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new g.VariableError(g.VariableKind.LineNumber,(0,v.localize)(12,null,p))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new g.VariableError(g.VariableKind.SelectedText,(0,v.localize)(13,null,p))}case"file":return w(g.VariableKind.File);case"fileWorkspaceFolder":return L(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||h?y.relative(this.m(t(g.VariableKind.RelativeFile)),w(g.VariableKind.RelativeFile)):w(g.VariableKind.RelativeFile);case"relativeFileDirname":{const n=y.dirname(w(g.VariableKind.RelativeFileDirname));if(o||h){const r=y.relative(this.m(t(g.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return y.dirname(w(g.VariableKind.FileDirname));case"fileExtname":return y.extname(w(g.VariableKind.FileExtname));case"fileBasename":return y.basename(w(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=y.basename(w(g.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-y.extname(n).length)}case"fileDirnameBasename":return y.basename(y.dirname(w(g.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||p}case"execInstallFolder":{const n=this.a.getAppRoot();return n||p}case"pathSeparator":return y.sep;default:try{const n=h?`${b}:${h}`:b;return this.o(g.VariableKind.Unknown,p,n,d,void 0)}catch{return p}}}}o(m,p,b,o,d){if(b&&o){const h=d===void 0?o[b]:o[d+":"+b];if(typeof h=="string")return h;throw new g.VariableError(m,(0,v.localize)(14,null,p))}return p}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(pe[272],ve([1,0,5,87]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var a;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(a=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var k;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function g(p){const b=p;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=g;var T;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function E(p){const b=p;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=E;function m(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(pe[132],ve([1,0,5,272]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function a(D){const C=D;return typeof D=="number"||(0,R.isEditorGroup)(C)}e.isPreferredGroup=a}),define(pe[273],ve([1,0,8,270,12,114,85,84,131,87,132,13,218,268]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let p=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(o,d,h,f,w,L,t,n,r,i){this.a=o,this.b=d,this.c=h,this.d=f,this.e=w,this.f=L,this.g=t,this.h=n,this.i=r,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(o,d,h,f,w,L,t,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),i=h?(0,y.withNullAsUndefined)(this.d.getWorkspaceFolder(h)):void 0;let l;try{l=(await this.e.resolveAnyMap(i,{shellLaunchConfig:o,configuration:d})).resolvedVariables}catch(le){this.h.error(le)}if(l)for(const[le,fe]of l.entries())(/^config:/.test(le)||le==="selectedText"||le==="lineNumber")&&(r[le]=fe);const c=[];for(const[le,fe]of this.f.collections.entries())c.push([le,(0,k.serializeEnvironmentVariableCollection)(fe.map)]);const s=await this.g.resolveAuthority(this.a),u=s.options&&s.options.extensionHostEnv,S=this.d.getWorkspace(),A=S.folders,O=h?this.d.getWorkspaceFolder(h):null,B=g.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:g.SideBySideEditor.PRIMARY,filterByScheme:[I.Schemas.file,I.Schemas.vscodeUserData,I.Schemas.vscodeRemote]}),q={configuration:d,resolvedVariables:r,envVariableCollections:c,shellLaunchConfig:o,workspaceId:S.id,workspaceName:this.j.getWorkspaceLabel(S),workspaceFolders:A,activeWorkspaceFolder:O,activeFileResource:B,shouldPersistTerminal:w,options:f,cols:L,rows:t,unicodeVersion:n,resolverEnv:u};return await this.b.call("$createProcess",q)}requestDetachInstance(o,d){return this.b.call("$requestDetachInstance",[o,d])}acceptDetachInstanceReply(o,d){return this.b.call("$acceptDetachInstanceReply",[o,d])}attachToProcess(o){return this.b.call("$attachToProcess",[o])}detachFromProcess(o,d){return this.b.call("$detachFromProcess",[o,d])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(o,d){return this.b.call("$processBinary",[o,d])}start(o){return this.b.call("$start",[o])}input(o,d){return this.b.call("$input",[o,d])}acknowledgeDataEvent(o,d){return this.b.call("$acknowledgeDataEvent",[o,d])}setUnicodeVersion(o,d){return this.b.call("$setUnicodeVersion",[o,d])}shutdown(o,d){return this.b.call("$shutdown",[o,d])}resize(o,d,h){return this.b.call("$resize",[o,d,h])}getInitialCwd(o){return this.b.call("$getInitialCwd",[o])}getCwd(o){return this.b.call("$getCwd",[o])}orphanQuestionReply(o){return this.b.call("$orphanQuestionReply",[o])}sendCommandResult(o,d,h){return this.b.call("$sendCommandResult",[o,d,h])}freePortKillProcess(o){return this.b.call("$freePortKillProcess",[o])}installAutoReply(o,d){return this.b.call("$installAutoReply",[o,d])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(o){return this.b.call("$getDefaultSystemShell",[o])}getProfiles(o,d,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,o,d,h])}acceptPtyHostResolvedVariables(o,d){return this.b.call("$acceptPtyHostResolvedVariables",[o,d])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(o,d){return this.b.call("$getWslPath",[o,d])}setTerminalLayoutInfo(o){const h={workspaceId:this.d.getWorkspace().id,tabs:o?o.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(o,d,h){return this.b.call("$updateTitle",[o,d,h])}updateIcon(o,d,h,f){return this.b.call("$updateIcon",[o,d,h,f])}refreshProperty(o,d){return this.b.call("$refreshProperty",[o,d])}updateProperty(o,d,h){return this.b.call("$updateProperty",[o,d,h])}getTerminalLayoutInfo(){const d={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(o,d){return this.b.call("$reviveTerminalProcesses",[o,d])}getRevivedPtyNewId(o){return this.b.call("$getRevivedPtyNewId",[o])}serializeTerminalState(o){return this.b.call("$serializeTerminalState",[o])}};p=Re([Ae(2,R.IWorkbenchConfigurationService),Ae(3,C.IWorkspaceContextService),Ae(4,v.IConfigurationResolverService),Ae(5,m.IEnvironmentVariableService),Ae(6,D.IRemoteAuthorityResolverService),Ae(7,a.ILogService),Ae(8,T.IEditorService),Ae(9,E.ILabelService)],p),e.RemoteTerminalChannelClient=p}),define(pe[274],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var y;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(y=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class R{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[R.ENV_KEY]=this.pipeName}}R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=R;class a{constructor(){this.type=2}serialize(I){I[a.ENV_KEY]="1"}}a.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=a;class D{constructor(){this.type=3}serialize(I){I[D.ENV_KEY]="1"}}D.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=D;function C(T){delete T[R.ENV_KEY],delete T[a.ENV_KEY],delete T[D.ENV_KEY]}function k(T,I){C(I),T.serialize(I)}e.writeExtHostConnection=k;function v(T){if(T[R.ENV_KEY])return g(T,new R(T[R.ENV_KEY]));if(T[a.ENV_KEY])return g(T,new a);if(T[D.ENV_KEY])return g(T,new D);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=v;function g(T,I){return C(T),I}}),define(pe[133],ve([1,0,49,98,86,13,7,15,6,62,83,12,41,3,58,126,2,274,24]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(i={},l,c,s,u,S){const A=await(0,a.getNLSConfiguration)(c,s.userDataPath);let O={};if(l)try{O=await(0,T.getResolvedShellEnv)(S,u,s.args,process.env)}catch(re){u.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",re)}const q={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(A,void 0,0),...i},le=s.isBuilt?(0,C.join)(s.appRoot,"bin"):(0,C.join)(s.appRoot,"resources","server","bin-dev"),fe=(0,C.join)(le,"remote-cli");let ue=t(q,"PATH");return ue?ue=fe+C.delimiter+ue:ue=fe,n(q,"PATH",ue),s.args["without-browser-env-var"]||(q.BROWSER=(0,C.join)(le,"helpers",m.isWindows?"browser.cmd":"browser.sh")),r(q),q}e.buildUserEnvironment=f;class w{constructor(l,c){this.socket=l,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let l,c,s;return this.socket instanceof g.NodeSocket?(l=!0,c=!1,s=k.VSBuffer.alloc(0)):(l=!1,c=this.socket.permessageDeflate,s=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:l,permessageDeflate:c,inflateBytes:s.buffer.toString("base64")}}}let L=class{constructor(l,c,s,u,S,A,O,B){this.i=l,this.j=S,this.l=A,this.m=O,this.n=B,this.b=new v.Emitter,this.onClose=this.b.event,this.c=!m.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=c,this.g=null,this.h=new w(s,u),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(l){this.l.info(`${this.o}${l}`)}q(l){this.l.error(`${this.o}${l}`)}async r(l,c){const s=new o.DisposableStore;s.add(c.socket),s.add((0,o.toDisposable)(()=>{l.destroy()}));const u=()=>{s.dispose()};s.add(c.socket.onEnd(u)),s.add(c.socket.onClose(u)),s.add(v.Event.fromNodeEventEmitter(l,"end")(u)),s.add(v.Event.fromNodeEventEmitter(l,"close")(u)),s.add(v.Event.fromNodeEventEmitter(l,"error")(u)),s.add(c.socket.onData(S=>l.write(S.buffer))),s.add(v.Event.fromNodeEventEmitter(l,"data")(S=>{c.socket.write(k.VSBuffer.wrap(S))})),c.initialDataChunk.byteLength>0&&l.write(c.initialDataChunk.buffer)}async s(l,c){await c.socketDrain();const s=c.toIExtHostSocketMessage();let u;c.socket instanceof g.NodeSocket?u=c.socket.socket:u=c.socket.socket.socket,l.send(s,u)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const l={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(l)}acceptReconnection(l,c,s){this.f=l,this.p("The client has reconnected.");const u=new w(c,s);if(!this.g){this.h=u;return}this.s(this.g,u)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(l){try{let c=process.execArgv?process.execArgv.filter(fe=>!/^--inspect(-brk)?=/.test(fe)):[];l.port&&!process.pkg&&(c=[`--inspect${l.break?"-brk":""}=${l.port}`]);const s=await f(l.env,!0,l.language,this.j,this.l,this.n);(0,p.removeDangerousEnvVariables)(s);let u;if(this.c)(0,d.writeExtHostConnection)(new d.SocketExtHostConnection,s),u=null;else{const{namedPipeServer:fe,pipeName:ue}=await this.u();(0,d.writeExtHostConnection)(new d.IPCExtHostConnection(ue),s),u=fe}const S={env:s,execArgv:c,silent:!0},A=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];A.push(`--useHostProxy=${O?"true":"false"}`),this.g=y.fork(D.FileAccess.asFileUri("bootstrap-fork").fsPath,A,S);const B=this.g.pid;this.p(`<${B}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const q=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),le=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(q(fe=>this.p(`<${B}> ${fe}`)),le(fe=>this.p(`<${B}><stderr> ${fe}`)),this.g.on("error",fe=>{this.q(`<${B}> Extension Host Process had an error`),this.l.error(fe),this.t()}),this.g.on("exit",(fe,ue)=>{this.m.setExitInfo(this.i,{code:fe,signal:ue}),this.p(`<${B}> Extension Host Process exited with code: ${fe}, signal: ${ue}.`),this.t()}),u)u.on("connection",fe=>{u.close(),this.r(fe,this.h)});else{const fe=ue=>{ue.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",fe),this.s(this.g,this.h),this.h=null)};this.g.on("message",fe)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}u(){return new Promise((l,c)=>{const s=(0,g.createRandomIPCHandle)(),u=R.createServer();u.on("error",c),u.listen(s,()=>{u?.removeListener("error",c),l({pipeName:s,namedPipeServer:u})})})}};L=Re([Ae(4,E.IServerEnvironmentService),Ae(5,I.ILogService),Ae(6,b.IExtensionHostStatusService),Ae(7,h.IConfigurationService)],L),e.ExtensionHostConnection=L;function t(i,l){const c=Object.keys(i).filter(u=>u.toLowerCase()===l.toLowerCase()),s=c.length>0?c[0]:l;return i[s]}function n(i,l,c){const s=Object.keys(i).filter(S=>S.toLowerCase()===l.toLowerCase()),u=s.length>0?s[0]:l;i[u]=c}function r(i){for(const l of Object.keys(i))i[l]===null&&delete i[l]}}),define(pe[275],ve([1,0,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var a;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(a=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function C(g){const T=y.VSBuffer.alloc(1);switch(g){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=C;function k(g,T){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=k;var v;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(v=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(pe[276],ve([1,0,5,6,12,264,275,54,37,22,4,2,196]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let m=class extends I.Disposable{constructor(d,h){super(),this.m=d,this.n=h,this.a=this.B(new R.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=T.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:v.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(f=>{(0,a.isLogLevel)(f)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===a.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,h,f){const w=this.getTelemetryDetails(),L=new p(h,f,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled});return this.l.set(d.identifier.value,L),L.apiTelemetryLogger}$initializeTelemetryLevel(d,h,f){this.f=d,this.g=h,this.c=f??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const h=Object.create(null);switch(h["common.extname"]=`${d.publisher}.${d.name}`,h["common.extversion"]=d.version,h["common.vscodemachineid"]=this.m.telemetryInfo.machineId,h["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,h["common.vscodeversion"]=this.m.version,h["common.isnewappinstall"]=b(this.m.telemetryInfo.firstSessionDate),h["common.product"]=this.m.environment.appHost,this.m.uiKind){case C.UIKind.Web:h["common.uikind"]="web";break;case C.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,k.getRemoteName)((0,v.cleanRemoteAuthority)(this.m.remote.authority)),h}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const h=this.getTelemetryDetails();this.l.forEach((f,w)=>{f.isDisposed&&this.l.delete(w)}),this.l.forEach(f=>{f.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,h){const f=this.l.get(d.value);return f&&f.isDisposed?(this.l.delete(d.value),!1):!f||f.ignoreUnhandledExtHostErrors?!1:(f.logError(h),!0)}};m=Re([Ae(0,D.IExtHostInitDataService),Ae(1,a.ILoggerService)],m),e.ExtHostTelemetry=m;class p{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,h,f,w,L,t,n){this.g=f,this.h=w,this.i=L,this.j=t,this.a=new R.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(d,h){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let h=d.properties??d;return h=(0,v.cleanData)(h,[]),this.c&&(h=(0,g.mixin)(h,this.c)),this.b||(h=(0,g.mixin)(h,this.j)),d.properties?d.properties=h:d=h,d}k(d,h){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(d,h),this.h.trace(d,h))}logUsage(d,h){!this.d.isUsageEnabled||this.k(d,h)}logError(d,h){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,h):this.f.sendErrorData(d,h))}get apiTelemetryLogger(){if(!this.e){const d=this,h={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=p;function b(o){const d=Date.now()-new Date(o).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,y.createDecorator)("IExtHostTelemetry")}),define(pe[277],ve([1,0,6,4,34,228,36,5]),function(ae,e,y,R,a,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class v{constructor(L){this.dependency=L}}e.MissingExtensionDependency=v;var g;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(g=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class T{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:D.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(L,t){const n=[],r=[],i=[],l=[],c=I(this.c),s=I(L),u=(q,le)=>q.extensionLocation.toString()===le.extensionLocation.toString()||q.isBuiltin===le.isBuiltin||q.isUserBuiltin===le.isUserBuiltin||q.isUnderDevelopment===le.isUnderDevelopment;for(const q of this.c){const le=s.get(q.identifier);if(!le){n.push(q.identifier),c.delete(q.identifier);continue}if(!u(q,le)){n.push(q.identifier),c.delete(q.identifier);continue}}for(const q of L){const le=c.get(q.identifier);if(!le){r.push(q);continue}if(!u(le,q)){n.push(le.identifier),c.delete(le.identifier);continue}}const S=new C.ExtensionIdentifierSet(this.d),A=new C.ExtensionIdentifierSet(t);for(const q of this.d)A.has(q)||i.push(q);for(const q of t)S.has(q)||l.push(q);const O=D.ImplicitActivationEvents.createActivationEventsMap(r),B={toRemove:n,toAdd:r,addActivationEvents:O,myToRemove:i,myToAdd:l};return this.delta(B),B}delta(L){const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=L,l=new C.ExtensionIdentifierSet(t),c=new C.ExtensionIdentifierSet(r);for(let s=0;s<this.c.length;s++)l.has(this.c[s].identifier)&&(this.c.splice(s,1),s--);for(let s=0;s<this.d.length;s++)c.has(this.d[s])&&(this.d.splice(s,1),s--);for(const s of n)this.c.push(s);for(const s of i)this.d.push(s)}containsExtension(L){for(const t of this.d)if(C.ExtensionIdentifier.equals(t,L))return!0;return!1}}e.ExtensionHostExtensions=T;function I(w){const L=new C.ExtensionIdentifierMap;for(const t of w)L.set(t.identifier,t);return L}function E(w,L){return!0}e.isProposedApiEnabled=E;function m(w,L){if(!E(w,L))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${L}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${L}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.checkProposedApiEnabled=m;class p{constructor(L,t,n,r){this.codeLoadingTime=L,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.ActivationTimes=p;class b{constructor(L,t){this.description=L,this.value=t}}e.ExtensionPointContribution=b;var o;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function d(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,a.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function h(w,L){return{identifier:new C.ExtensionIdentifier((0,a.getExtensionId)(w.manifest.publisher,w.manifest.name)),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!L,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform}}e.toExtensionDescription=h;class f{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.extensions=[]}activateByEvent(L){return Promise.resolve(void 0)}activationEventIsDone(L){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(L){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(L,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(L){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=f});var Ft=this&&this.__classPrivateFieldSet||function(ae,e,y,R,a){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?a.call(ae,y):a?a.value=y:e.set(ae,y),y},rt=this&&this.__classPrivateFieldGet||function(ae,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(ae):R?R.value:e.get(ae)};define(pe[134],ve([1,0,18,9,96,27,57,17,8,4,21,16,114,128,277]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p){"use strict";var b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O,B,q,le,fe,ue,re,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.NotebookDocumentSaveReason=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee(z){return Object.assign(z,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(z,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[se,...be]=arguments;return Reflect.construct(z,be,se.constructor)}}})}var ne;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(ne=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var ie;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(ie=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let G=t=class{static from(...F){let se=F;return new t(function(){if(se){for(const be of se)be&&typeof be.dispose=="function"&&be.dispose();se=void 0}})}constructor(F){b.set(this,void 0),Ft(this,b,F,"f")}dispose(){typeof rt(this,b,"f")=="function"&&(rt(this,b,"f").call(this),Ft(this,b,void 0,"f"))}};b=new WeakMap,G=t=Re([ee],G),e.Disposable=G;let U=n=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let be=1;be<F.length;be++){const Ue=F[be];Ue.isBefore(se)&&(se=Ue)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let be=1;be<F.length;be++){const Ue=F[be];Ue.isAfter(se)&&(se=Ue)}return se}static isPosition(F){if(!F)return!1;if(F instanceof n)return!0;const{line:se,character:be}=F;return typeof se=="number"&&typeof be=="number"}static of(F){if(F instanceof n)return F;if(this.isPosition(F))return new n(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,se){if(F<0)throw(0,R.illegalArgument)("line must be non-negative");if(se<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=F,this.e=se}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,se=0){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return typeof F>"u"?be=0:typeof F=="number"?be=F:(be=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),be===0&&se===0?this:new n(this.line+be,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return typeof F>"u"?be=this.line:typeof F=="number"?be=F:(be=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),be===this.line&&se===this.character?this:new n(be,se)}toJSON(){return{line:this.line,character:this.character}}};U=n=Re([ee],U),e.Position=U;let Z=r=class{static isRange(F){return F instanceof r?!0:F?U.isPosition(F.start)&&U.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,se,be,Ue){let He,_e;if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Ue=="number"?(He=new U(F,se),_e=new U(be,Ue)):U.isPosition(F)&&U.isPosition(se)&&(He=U.of(F),_e=U.of(se)),!He||!_e)throw new Error("Invalid arguments");He.isBefore(_e)?(this.c=He,this.e=_e):(this.c=_e,this.e=He)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):U.isPosition(F)?!(U.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const se=U.Max(F.start,this.c),be=U.Min(F.end,this.e);if(!se.isAfter(be))return new r(se,be)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=U.Min(F.start,this.c),be=U.Max(F.end,this.end);return new r(se,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,se=this.end){if(F===null||se===null)throw(0,R.illegalArgument)();let be;return F?U.isPosition(F)?be=F:(be=F.start||this.start,se=F.end||this.end):be=this.start,be.isEqual(this.c)&&se.isEqual(this.end)?this:new r(be,se)}toJSON(){return[this.start,this.end]}};Z=r=Re([ee],Z),e.Range=Z;let oe=i=class extends Z{static isSelection(F){return F instanceof i?!0:F?Z.isRange(F)&&U.isPosition(F.anchor)&&U.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,se,be,Ue){let He,_e;if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Ue=="number"?(He=new U(F,se),_e=new U(be,Ue)):U.isPosition(F)&&U.isPosition(se)&&(He=U.of(F),_e=U.of(se)),!He||!_e)throw new Error("Invalid arguments");super(He,_e),this.f=He,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};oe=i=Re([ee],oe),e.Selection=oe;class me{constructor(F,se,be){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,R.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(se),this.connectionToken=be}}e.ResolvedAuthority=me;class $ extends Error{static NotAvailable(F,se){return new $(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new $(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=E.RemoteAuthorityResolverErrorCode.Unknown,be){super(F),this._message=F,this._code=se,this._detail=be,Object.setPrototypeOf(this,$.prototype)}}e.RemoteAuthorityResolverError=$;var W;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var N;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let P=l=class{static isTextEdit(F){return F instanceof l?!0:F?Z.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new l(F,se)}static insert(F,se){return l.replace(new Z(F,F),se)}static delete(F){return l.replace(F,"")}static setEndOfLine(F){const se=new l(new Z(new U(0,0),new U(0,0)),"");return se.newEol=F,se}get range(){return this.c}set range(F){if(F&&!Z.isRange(F))throw(0,R.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.illegalArgument)("newEol");this.f=F}constructor(F,se){this.c=F,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};P=l=Re([ee],P),e.TextEdit=P;var M;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(M=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));let K=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?Ot.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new c(F,se)}static insertCells(F,se){return new c(new Ot(F,F),se)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,se){const be=new c(new Ot(F,F),[]);return be.newCellMetadata=se,be}static updateNotebookMetadata(F){const se=new c(new Ot(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};K=c=Re([ee],K),e.NotebookEdit=K;class te{static isSnippetTextEdit(F){return F instanceof te?!0:F?Z.isRange(F.range)&&J.isSnippetString(F.snippet):!1}static replace(F,se){return new te(F,se)}static insert(F,se){return te.replace(new Z(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.SnippetTextEdit=te;var j;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(j=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,se,be,Ue){this.c.push({_type:1,from:F,to:se,options:be,metadata:Ue})}createFile(F,se,be){this.c.push({_type:1,from:void 0,to:F,options:se,metadata:be})}deleteFile(F,se,be){this.c.push({_type:1,from:F,to:void 0,options:se,metadata:be})}e(F,se,be){this.c.push({_type:3,metadata:be,uri:F,edit:{editType:5,metadata:se},notebookMetadata:se})}f(F,se,be,Ue){const He=se.start,_e=se.end;(He!==_e||be.length>0)&&this.c.push({_type:5,uri:F,index:He,count:_e-He,cells:be,metadata:Ue})}g(F,se,be,Ue){this.c.push({_type:3,metadata:Ue,uri:F,edit:{editType:8,index:se,metadata:be}})}replace(F,se,be,Ue){this.c.push({_type:2,uri:F,edit:new P(se,be),metadata:Ue})}insert(F,se,be,Ue){this.replace(F,new Z(se,se),be,Ue)}delete(F,se,be){this.replace(F,se,"",be)}has(F){return this.c.some(se=>se._type===2&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const be of se){if(!be)continue;let Ue,He;Array.isArray(be)?(Ue=be[0],He=be[1]):Ue=be,K.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(F,Ue.range.start,Ue.newCellMetadata,He):Ue.newNotebookMetadata?this.e(F,Ue.newNotebookMetadata,He):this.f(F,Ue.range,Ue.newCells,He):te.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:F,range:Ue.range,edit:Ue.snippet,metadata:He}):this.c.push({_type:2,uri:F,edit:Ue,metadata:He})}else{for(let be=0;be<this.c.length;be++){const Ue=this.c[be];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===F.toString()&&(this.c[be]=void 0);break}}(0,y.coalesceInPlace)(this.c)}}get(F){const se=[];for(const be of this.c)be._type===2&&be.uri.toString()===F.toString()&&se.push(be.edit);return se}entries(){const F=new D.ResourceMap;for(const se of this.c)if(se._type===2){let be=F.get(se.uri);be||(be=[se.uri,[]],F.set(se.uri,be)),be[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Re([ee],H),e.WorkspaceEdit=H;let J=s=class{static isSnippetString(F){return F instanceof s?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=s.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this.e++){if(typeof F=="function"){const be=new s;be.e=this.e,F(be),this.e=be.e,F=be.value}else F=s.c(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this.e++){const be=F.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const be=new s;be.e=this.e,se(be),this.e=be.e,se=be.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};J=s=Re([ee],J),e.SnippetString=J;var V;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(V=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let x=u=class{static isLocation(F){return F instanceof u?!0:F?Z.isRange(F.range)&&g.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(Z.isRange(se))this.range=Z.of(se);else if(U.isPosition(se))this.range=new Z(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};x=u=Re([ee],x),e.Location=x;let Q=class{static is(F){return F?typeof F.message=="string"&&F.location&&Z.isRange(F.location.range)&&g.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};Q=Re([ee],Q),e.DiagnosticRelatedInformation=Q;let ce=class{constructor(F,se,be=X.Error){if(!Z.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=be}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,y.equals)(F.tags,se.tags)&&(0,y.equals)(F.relatedInformation,se.relatedInformation,Q.isEqual)}};ce=Re([ee],ce),e.Diagnostic=ce;let Ee=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};Ee=Re([ee],Ee),e.Hover=Ee;var Ce;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(F,se=Ce.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};ke=Re([ee],ke),e.DocumentHighlight=ke;var Me;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Me=e.SymbolKind||(e.SymbolKind={}));var $e;(function(z){z[z.Deprecated=1]="Deprecated"})($e=e.SymbolTag||(e.SymbolTag={}));let ge=S=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,be,Ue,He){this.name=F,this.kind=se,this.containerName=He,typeof be=="string"&&(this.containerName=be),Ue instanceof x?this.location=Ue:be instanceof Z&&(this.location=new x(Ue,be)),S.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};ge=S=Re([ee],ge),e.SymbolInformation=ge;let Se=A=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(A.validate)}constructor(F,se,be,Ue,He){this.name=F,this.detail=se,this.kind=be,this.range=Ue,this.selectionRange=He,this.children=[],A.validate(this)}};Se=A=Re([ee],Se),e.DocumentSymbol=Se;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Fe=class{constructor(F,se){this.title=F,this.kind=se}};Fe=Re([ee],Fe),e.CodeAction=Fe;let Ne=O=class{constructor(F){this.value=F}append(F){return new O(this.value?this.value+O.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+O.c)}};Ne.c=".",Ne=O=Re([ee],Ne),e.CodeActionKind=Ne,Ne.Empty=new Ne(""),Ne.QuickFix=Ne.Empty.append("quickfix"),Ne.Refactor=Ne.Empty.append("refactor"),Ne.RefactorExtract=Ne.Refactor.append("extract"),Ne.RefactorInline=Ne.Refactor.append("inline"),Ne.RefactorMove=Ne.Refactor.append("move"),Ne.RefactorRewrite=Ne.Refactor.append("rewrite"),Ne.Source=Ne.Empty.append("source"),Ne.SourceOrganizeImports=Ne.Source.append("organizeImports"),Ne.SourceFixAll=Ne.Source.append("fixAll");let et=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};et=Re([ee],et),e.SelectionRange=et;class Ve{constructor(F,se,be,Ue,He,_e){this.kind=F,this.name=se,this.detail=be,this.uri=Ue,this.range=He,this.selectionRange=_e}}e.CallHierarchyItem=Ve;class Xe{constructor(F,se){this.fromRanges=se,this.from=F}}e.CallHierarchyIncomingCall=Xe;class Qe{constructor(F,se){this.fromRanges=se,this.to=F}}e.CallHierarchyOutgoingCall=Qe;var Ze;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ge=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};Ge=Re([ee],Ge),e.CodeLens=Ge;let he=B=class{static isMarkdownString(F){return F instanceof B?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){o.set(this,void 0),Ft(this,o,new a.MarkdownString(F,{supportThemeIcons:se}),"f")}get value(){return rt(this,o,"f").value}set value(F){rt(this,o,"f").value=F}get isTrusted(){return rt(this,o,"f").isTrusted}set isTrusted(F){rt(this,o,"f").isTrusted=F}get supportThemeIcons(){return rt(this,o,"f").supportThemeIcons}set supportThemeIcons(F){rt(this,o,"f").supportThemeIcons=F}get supportHtml(){return rt(this,o,"f").supportHtml}set supportHtml(F){rt(this,o,"f").supportHtml=F}get baseUri(){return rt(this,o,"f").baseUri}set baseUri(F){rt(this,o,"f").baseUri=F}appendText(F){return rt(this,o,"f").appendText(F),this}appendMarkdown(F){return rt(this,o,"f").appendMarkdown(F),this}appendCodeblock(F,se){return rt(this,o,"f").appendCodeblock(se??"",F),this}};o=new WeakMap,he=B=Re([ee],he),e.MarkdownString=he;let Ie=class{constructor(F,se){this.label=F,this.documentation=se}};Ie=Re([ee],Ie),e.ParameterInformation=Ie;let Te=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};Te=Re([ee],Te),e.SignatureInformation=Te;let Be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Be=Re([ee],Be),e.SignatureHelp=Be;var Le;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var je;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(je=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(F){this.value=F}};We=Re([ee],We),e.InlayHintLabelPart=We;let Ye=class{constructor(F,se,be){this.position=F,this.label=se,this.kind=be}};Ye=Re([ee],Ye),e.InlayHint=Ye;var qe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(z){z[z.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=Re([ee],Je),e.CompletionItem=Je;let lt=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};lt=Re([ee],lt),e.CompletionList=lt;let mt=class{constructor(F,se,be){this.insertText=F,this.range=se,this.command=be}};mt=Re([ee],mt),e.InlineSuggestion=mt;let ot=class{constructor(F){this.commands=void 0,this.items=F}};ot=Re([ee],ot),e.InlineSuggestionList=ot;var $t;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})($t=e.ViewColumn||(e.ViewColumn={}));var Dt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Dt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ut;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var bt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(bt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Tt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Bt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Bt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ct;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Ct=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function F(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Tt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Rt=class{constructor(F,se){if(se&&!g.URI.isUri(se))throw(0,R.illegalArgument)("target");if(!Z.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.target=se}};Rt=Re([ee],Rt),e.DocumentLink=Rt;let Lt=class{constructor(F,se,be,Ue){this.red=F,this.green=se,this.blue=be,this.alpha=Ue}};Lt=Re([ee],Lt),e.Color=Lt;let gt=class{constructor(F,se){if(se&&!(se instanceof Lt))throw(0,R.illegalArgument)("color");if(!Z.isRange(F)||F.isEmpty)throw(0,R.illegalArgument)("range");this.range=F,this.color=se}};gt=Re([ee],gt),e.ColorInformation=gt;let Et=class{constructor(F){if(!F||typeof F!="string")throw(0,R.illegalArgument)("label");this.label=F}};Et=Re([ee],Et),e.ColorPresentation=Et;var st;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(st=e.ColorFormat||(e.ColorFormat={}));var yt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(yt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var wt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(wt=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(F,se,be){if(this.startIndex=F,this.length=se,this.tooltip=be,typeof F!="number"||F<0)throw(0,R.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,R.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=we;class De{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=De;class de{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=de;var Y;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Y=e.TerminalLocation||(e.TerminalLocation={}));class Pe{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Pe;var Oe;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var xe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(xe=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=q=class{static from(F){switch(F){case"clean":return q.Clean;case"build":return q.Build;case"rebuild":return q.Rebuild;case"test":return q.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,R.illegalArgument)("name");this.c=F}get id(){return this.c}};ze.Clean=new q("clean","Clean"),ze.Build=new q("build","Build"),ze.Rebuild=new q("rebuild","Rebuild"),ze.Test=new q("test","Test"),ze=q=Re([ee],ze),e.TaskGroup=ze;function nt(z){let F="";for(let se=0;se<z.length;se++)F+=z[se].replace(/,/g,",,")+",";return F}let at=class{constructor(F,se,be){if(typeof F!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=F,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=be):this.f=se)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const se of this.e)F.push(se);return nt(F)}};at=Re([ee],at),e.ProcessExecution=at;let ut=class{constructor(F,se,be){if(this.f=[],Array.isArray(se)){if(!F)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this.e=F,this.f=se,this.g=be}else{if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this.c=F,this.g=se}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)F.push(typeof se=="string"?se:se.value);return nt(F)}};ut=Re([ee],ut),e.ShellExecution=ut;var Pt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Pt=e.ShellQuoting||(e.ShellQuoting={}));var ht;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ht=e.TaskScope||(e.TaskScope={}));class St{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=St;let Mt=le=class{constructor(F,se,be,Ue,He,_e){this.j=!1,this.k=this.definition=F;let it;typeof se=="string"?(this.m=this.name=se,this.t=this.source=be,this.execution=Ue,it=He,this.j=!0):se===ht.Global||se===ht.Workspace?(this.target=se,this.m=this.name=be,this.t=this.source=Ue,this.execution=He,it=_e):(this.target=se,this.m=this.name=be,this.t=this.source=Ue,this.execution=He,it=_e),typeof it=="string"?(this.o=[it],this.q=!0):Array.isArray(it)?(this.o=it,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof at?this.k={type:le.e,id:this.n.computeId()}:this.n instanceof ut?this.k={type:le.f,id:this.n.computeId()}:this.n instanceof St?this.k={type:le.c,id:this.n.computeId()}:this.k={type:le.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const se=this.k.type;(le.g===se||le.e===se||le.f===se||le.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};Mt.c="customExecution",Mt.e="process",Mt.f="shell",Mt.g="$empty",Mt=le=Re([ee],Mt),e.Task=Mt;var Oi;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Oi=e.ProgressLocation||(e.ProgressLocation={}));var Ni;(function(z){function F(se){const be=se;return(0,v.isNumber)(be.value)?be.tooltip&&!(0,v.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}z.isViewBadge=F})(Ni=e.ViewBadge||(e.ViewBadge={}));let Xt=fe=class{static isTreeItem(F,se){const be=F;if(be.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(se,"treeItemCheckbox");const Ue=(0,v.isNumber)(be.checkboxState)?be.checkboxState:(0,v.isObject)(be.checkboxState)&&(0,v.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,He=!(0,v.isNumber)(be.checkboxState)&&(0,v.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Qt.Checked&&Ue!==Qt.Unchecked||He!==void 0&&!(0,v.isString)(He))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(F instanceof fe)return!0;if(be.label!==void 0&&!(0,v.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,v.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,v.isString)(be.iconPath)&&!g.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,v.isString)(be.iconPath.id))){const Ue=be.iconPath;if(!Ue||!(0,v.isString)(Ue.light)&&!g.URI.isUri(Ue.light)&&!(0,v.isString)(Ue.dark)&&!g.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,v.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!g.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,v.isString)(be.tooltip)&&!(be.tooltip instanceof he)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<Vt.None&&be.collapsibleState>Vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,v.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(F,se=Vt.None){this.collapsibleState=se,g.URI.isUri(F)?this.resourceUri=F:this.label=F}};Xt=fe=Re([ee],Xt),e.TreeItem=Xt;var Vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Qt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,se){this.value=F,this.id=se??(0,T.generateUuid)()}};Zt=Re([ee],Zt),e.DataTransferItem=Zt;let _t=class{constructor(F){d.add(this),h.set(this,new Map);for(const[se,be]of F??[]){const Ue=rt(this,h,"f").get(rt(this,d,"m",f).call(this,se));Ue?Ue.push(be):rt(this,h,"f").set(rt(this,d,"m",f).call(this,se),[be])}}get(F){return rt(this,h,"f").get(rt(this,d,"m",f).call(this,F))?.[0]}set(F,se){rt(this,h,"f").set(rt(this,d,"m",f).call(this,F),[se])}forEach(F,se){for(const[be,Ue]of rt(this,h,"f"))for(const He of Ue)F.call(se,He,be,this)}*[(h=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[F,se]of rt(this,h,"f"))for(const be of se)yield[F,be]}};f=function(F){return F.toLowerCase()},_t=Re([ee],_t),e.DataTransfer=_t;let ei=class{constructor(F){this.insertText=F}};ei=Re([ee],ei),e.DocumentDropEdit=ei;let ti=class{constructor(F){this.insertText=F}};ti=Re([ee],ti),e.DocumentPasteEdit=ti;let kt=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};kt=Re([ee],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let ii=class{constructor(F){this.id=F}};ii=Re([ee],ii),e.ThemeColor=ii;var Fi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Fi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ni=class{get base(){return this.c}set base(F){this.c=F,this.e=g.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!g.URI.isUri(F)&&!g.URI.isUri(F.uri)))throw(0,R.illegalArgument)("base");if(typeof se!="string")throw(0,R.illegalArgument)("pattern");typeof F=="string"?this.baseUri=g.URI.file(F):g.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ni=Re([ee],ni),e.RelativePattern=ni;const Ri=new WeakMap;function Mi(z,F){Ri.set(z,F)}e.setBreakpointId=Mi;let zt=class{constructor(F,se,be,Ue){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof be=="string"&&(this.hitCondition=be),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=Ri.get(this)??(0,T.generateUuid)()),this.c}};zt=Re([ee],zt),e.Breakpoint=zt;let ri=class extends zt{constructor(F,se,be,Ue,He){if(super(se,be,Ue,He),F===null)throw(0,R.illegalArgument)("location");this.location=F}};ri=Re([ee],ri),e.SourceBreakpoint=ri;let si=class extends zt{constructor(F,se,be,Ue,He){super(se,be,Ue,He),this.functionName=F}};si=Re([ee],si),e.FunctionBreakpoint=si;let oi=class extends zt{constructor(F,se,be,Ue,He,_e,it){if(super(Ue,He,_e,it),!se)throw(0,R.illegalArgument)("dataId");this.label=F,this.dataId=se,this.canPersist=be}};oi=Re([ee],oi),e.DataBreakpoint=oi;let ai=class{constructor(F,se,be){this.command=F,this.args=se||[],this.options=be}};ai=Re([ee],ai),e.DebugAdapterExecutable=ai;let li=class{constructor(F,se){this.port=F,this.host=se}};li=Re([ee],li),e.DebugAdapterServer=li;let ci=class{constructor(F){this.path=F}};ci=Re([ee],ci),e.DebugAdapterNamedPipeServer=ci;let ui=class{constructor(F){this.implementation=F}};ui=Re([ee],ui),e.DebugAdapterInlineImplementation=ui;let hi=class{constructor(F,se){this.range=F,this.expression=se}};hi=Re([ee],hi),e.EvaluatableExpression=hi;var Ui;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ui=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let fi=class{constructor(F,se){this.range=F,this.text=se}};fi=Re([ee],fi),e.InlineValueText=fi;let di=class{constructor(F,se,be=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=be}};di=Re([ee],di),e.InlineValueVariableLookup=di;let mi=class{constructor(F,se){this.range=F,this.expression=se}};mi=Re([ee],mi),e.InlineValueEvaluatableExpression=mi;let gi=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};gi=Re([ee],gi),e.InlineValueContext=gi;var Bi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let pi=ue=class extends Error{static FileExists(F){return new ue(F,I.FileSystemProviderErrorCode.FileExists,ue.FileExists)}static FileNotFound(F){return new ue(F,I.FileSystemProviderErrorCode.FileNotFound,ue.FileNotFound)}static FileNotADirectory(F){return new ue(F,I.FileSystemProviderErrorCode.FileNotADirectory,ue.FileNotADirectory)}static FileIsADirectory(F){return new ue(F,I.FileSystemProviderErrorCode.FileIsADirectory,ue.FileIsADirectory)}static NoPermissions(F){return new ue(F,I.FileSystemProviderErrorCode.NoPermissions,ue.NoPermissions)}static Unavailable(F){return new ue(F,I.FileSystemProviderErrorCode.Unavailable,ue.Unavailable)}constructor(F,se=I.FileSystemProviderErrorCode.Unknown,be){super(g.URI.isUri(F)?F.toString(!0):F),this.code=be?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,ue.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};pi=ue=Re([ee],pi),e.FileSystemError=pi;let vi=class{constructor(F,se,be){this.start=F,this.end=se,this.kind=be}};vi=Re([ee],vi),e.FoldingRange=vi;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ji;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(ji=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $i;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})($i=e.CommentMode||(e.CommentMode={}));var Wi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Wi=e.CommentThreadState||(e.CommentThreadState={}));class Hi{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.SemanticTokensLegend=Hi;function Vi(z){return typeof z>"u"||(0,v.isStringArray)(z)}class bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let se=0,be=F.tokenTypes.length;se<be;se++)this.j.set(F.tokenTypes[se],se);for(let se=0,be=F.tokenModifiers.length;se<be;se++)this.k.set(F.tokenModifiers[se],se)}}push(F,se,be,Ue,He){if(typeof F=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Ue=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this.n(F,se,be,Ue,He);if(Z.isRange(F)&&typeof se=="string"&&Vi(be))return this.m(F,se,be);throw(0,R.illegalArgument)()}m(F,se,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Ue=F.start.line,He=F.start.character,_e=F.end.character-F.start.character,it=this.j.get(se);let ct=0;if(be)for(const dt of be){if(!this.k.has(dt))throw new Error("`tokenModifier` is not in the provided legend");const vt=this.k.get(dt);ct|=1<<vt>>>0}this.n(Ue,He,_e,it,ct)}n(F,se,be,Ue,He){if(this.f&&(F<this.c||F===this.c&&se<this.e)){this.f=!1;const ct=this.g.length/5|0;let dt=0,vt=0;for(let It=0;It<ct;It++){let At=this.g[5*It],Wt=this.g[5*It+1];At===0?(At=dt,Wt+=vt):At+=dt,this.g[5*It]=At,this.g[5*It+1]=Wt,dt=At,vt=Wt}}let _e=F,it=se;this.f&&this.h>0&&(_e-=this.c,_e===0&&(it-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=it,this.g[this.h++]=be,this.g[this.h++]=Ue,this.g[this.h++]=He,this.c=F,this.e=se}static o(F){const se=[],be=F.length/5|0;for(let it=0;it<be;it++)se[it]=it;se.sort((it,ct)=>{const dt=F[5*it],vt=F[5*ct];if(dt===vt){const It=F[5*it+1],At=F[5*ct+1];return It-At}return dt-vt});const Ue=new Uint32Array(F.length);let He=0,_e=0;for(let it=0;it<be;it++){const ct=5*se[it],dt=F[ct+0],vt=F[ct+1],It=F[ct+2],At=F[ct+3],Wt=F[ct+4],Li=dt-He,On=Li===0?vt-_e:vt,Ht=5*it;Ue[Ht+0]=Li,Ue[Ht+1]=On,Ue[Ht+2]=It,Ue[Ht+3]=At,Ue[Ht+4]=Wt,He=dt,_e=vt}return Ue}build(F){return this.f?new Ei(new Uint32Array(this.g),F):new Ei(bi.o(this.g),F)}}e.SemanticTokensBuilder=bi;class Ei{constructor(F,se){this.resultId=se,this.data=F}}e.SemanticTokens=Ei;class qi{constructor(F,se,be){this.start=F,this.deleteCount=se,this.data=be}}e.SemanticTokensEdit=qi;class xi{constructor(F,se){this.resultId=se,this.edits=F}}e.SemanticTokensEdits=xi;var Gi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Gi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let qt=class{constructor(){}};qt.Back={iconPath:new kt("arrow-left")},qt=Re([ee],qt),e.QuickInputButtons=qt;var Ki;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ki=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Yi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Yi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ji;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ji=e.ExtensionKind||(e.ExtensionKind={}));class Xi{static validate(F){if(typeof F.badge=="string"){let se=(0,k.nextCharLength)(F.badge,0);if(se<F.badge.length&&(se+=(0,k.nextCharLength)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!kt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,be){this.badge=F,this.tooltip=se,this.color=be}}e.FileDecoration=Xi;let yi=class{constructor(F){this.kind=F}};yi=Re([ee],yi),e.ColorTheme=yi;var Qi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Qi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ot{static isNotebookRange(F){return F instanceof Ot?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,se){if(F<0)throw(0,R.illegalArgument)("start must be positive");if(se<0)throw(0,R.illegalArgument)("end must be positive");F<=se?(this.c=F,this.e=se):(this.c=se,this.e=F)}with(F){let se=this.c,be=this.e;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(be=F.end),se===this.c&&be===this.e?this:new Ot(se,be)}}e.NotebookRange=Ot;class xt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>xt.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,be,Ue,He,_e,it){this.kind=F,this.value=se,this.languageId=be,this.mime=Ue,this.outputs=He??[],this.metadata=_e,this.executionSummary=it,xt.validate(this)}}e.NotebookCellData=xt;class Zi{constructor(F){this.cells=F}}e.NotebookData=Zi;class pt{static isNotebookCellOutputItem(F){return F instanceof pt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return pt.json(se,"application/vnd.code.notebook.error")}static stdout(F){return pt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new pt(F,se)}static text(F,se=C.Mimes.text){const be=rt(pt,w,"f",L).encode(String(F));return new pt(be,se)}static json(F,se="text/x-json"){const be=JSON.stringify(F,void 0,"	");return pt.text(be,se)}constructor(F,se){this.data=F,this.mime=se;const be=(0,C.normalizeMimeType)(se,!0);if(!be)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}w=pt,L={value:new TextEncoder},e.NotebookCellOutputItem=pt;class Gt{static isNotebookCellOutput(F){return F instanceof Gt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const be=new Set,Ue=new Set;for(let He=0;He<F.length;He++){const _e=F[He],it=(0,C.normalizeMimeType)(_e.mime);if(!be.has(it)||(0,m.isTextStreamMime)(it)){be.add(it);continue}Ue.add(He),se&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Ue.size===0?F:F.filter((He,_e)=>!Ue.has(_e))}constructor(F,se,be){this.items=Gt.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=be):(this.id=(0,T.generateUuid)(),this.metadata=se??be)}}e.NotebookCellOutput=Gt;var _i;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(_i=e.NotebookCellKind||(e.NotebookCellKind={}));var en;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(en=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var tn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class rn{constructor(F,se){this.text=F,this.alignment=se}}e.NotebookCellStatusBarItem=rn;var sn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(sn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var on;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(on=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class an{constructor(F,se=[]){this.uri=F,this.provides=(0,y.asArray)(se)}}e.NotebookRendererScript=an;class ln{constructor(F){this.label=F}}e.NotebookKernelSourceAction=ln;let wi=class{constructor(F,se){this.label=F,this.timestamp=se}};wi=Re([ee],wi),e.TimelineItem=wi;var cn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(cn=e.ExtensionMode||(e.ExtensionMode={}));var un;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(un=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.LinkedEditingRanges=fn;class dn{constructor(F,se){this.c=F,this.e=se}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=dn;var mn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(mn=e.TestResultState||(e.TestResultState={}));var gn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(gn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Kt=class{constructor(F=void 0,se=void 0,be=void 0,Ue=!1){this.include=F,this.exclude=se,this.profile=be,this.continuous=Ue}};Kt=Re([ee],Kt),e.TestRunRequest=Kt;let Si=class extends Kt{};Si=Re([ee],Si),e.TestRunRequest2=Si;let Ii=re=class{static diff(F,se,be){const Ue=new re(F);return Ue.expectedOutput=se,Ue.actualOutput=be,Ue}constructor(F){this.message=F}};Ii=re=Re([ee],Ii),e.TestMessage=Ii;let Di=class{constructor(F){this.id=F}};Di=Re([ee],Di),e.TestTag=Di;let jt=class{constructor(F,se){this.covered=F,this.total=se}};jt=Re([ee],jt),e.CoveredCount=jt;let Ci=_=class{static fromDetails(F,se){const be=new jt(0,0),Ue=new jt(0,0),He=new jt(0,0);for(const it of se)if("branches"in it){be.total+=1,be.covered+=it.executionCount>0?1:0;for(const ct of it.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else He.total+=1,He.covered+=it.executionCount>0?1:0;const _e=new _(F,be,Ue.total>0?Ue:void 0,He.total>0?He:void 0);return _e.detailedCoverage=se,_e}constructor(F,se,be,Ue){this.uri=F,this.statementCoverage=se,this.branchCoverage=be,this.functionCoverage=Ue}};Ci=_=Re([ee],Ci),e.FileCoverage=Ci;let Pi=class{constructor(F,se,be=[]){this.executionCount=F,this.location=se,this.branches=be}};Pi=Re([ee],Pi),e.StatementCoverage=Pi;let ki=class{constructor(F,se){this.executionCount=F,this.location=se}};ki=Re([ee],ki),e.BranchCoverage=ki;let Ai=class{constructor(F,se){this.executionCount=F,this.location=se}};Ai=Re([ee],Ai),e.FunctionCoverage=Ai;var pn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(pn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(F,se,be,Ue,He,_e){this.kind=F,this.name=se,this.detail=be,this.uri=Ue,this.range=He,this.selectionRange=_e}}e.TypeHierarchyItem=En;class yn{constructor(F){this.uri=F}}e.TextTabInput=yn;class wn{constructor(F,se){this.original=F,this.modified=se}}e.TextDiffTabInput=wn;class Sn{constructor(F,se,be,Ue){this.base=F,this.input1=se,this.input2=be,this.result=Ue}}e.TextMergeTabInput=Sn;class In{constructor(F,se){this.uri=F,this.viewType=se}}e.CustomEditorTabInput=In;class Dn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Dn;class Cn{constructor(F,se){this.uri=F,this.notebookType=se}}e.NotebookEditorTabInput=Cn;class Pn{constructor(F,se,be){this.original=F,this.modified=se,this.notebookType=be}}e.NotebookDiffEditorTabInput=Pn;class kn{constructor(){}}e.TerminalEditorTabInput=kn;class An{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.InteractiveWindowInput=An;var Tn;(function(z){z[z.Up=1]="Up",z[z.Down=2]="Down"})(Tn=e.InteractiveSessionVoteDirection||(e.InteractiveSessionVoteDirection={}));var Rn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Rn=e.InteractiveSessionCopyKind||(e.InteractiveSessionCopyKind={}));var Ln;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone"})(Ln=e.InteractiveEditorResponseFeedbackKind||(e.InteractiveEditorResponseFeedbackKind={}))}),define(pe[135],ve([1,0,18,15,150,71,96,27,141,61,57,22,8,4,50,158,224,130,87,128,70,88,132,134]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.NotebookDocumentSaveReason=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(we){function De(Y){const{selectionStartLineNumber:Pe,selectionStartColumn:Oe,positionLineNumber:xe,positionColumn:ze}=Y,nt=new n.Position(Pe-1,Oe-1),at=new n.Position(xe-1,ze-1);return new n.Selection(nt,at)}we.to=De;function de(Y){const{anchor:Pe,active:Oe}=Y;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}we.from=de})(r=e.Selection||(e.Selection={}));var i;(function(we){function De(Y){if(!Y)return;const{start:Pe,end:Oe}=Y;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}we.from=De;function de(Y){if(!Y)return;const{startLineNumber:Pe,startColumn:Oe,endLineNumber:xe,endColumn:ze}=Y;return new n.Range(Pe-1,Oe-1,xe-1,ze-1)}we.to=de})(i=e.Range||(e.Range={}));var l;(function(we){function De(de){switch(de){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}we.to=De})(l=e.TokenType||(e.TokenType={}));var c;(function(we){function De(Y){return new n.Position(Y.lineNumber-1,Y.column-1)}we.to=De;function de(Y){return{lineNumber:Y.line+1,column:Y.character+1}}we.from=de})(c=e.Position||(e.Position={}));var s;(function(we){function De(Pe,Oe){return(0,y.coalesce)((0,y.asArray)(Pe).map(xe=>de(xe,Oe)))}we.from=De;function de(Pe,Oe){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Y(Pe.scheme,Oe),pattern:Te.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function Y(Pe,Oe){return Oe&&typeof Pe=="string"?Oe.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(we){function De(Y){switch(Y){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}we.from=De;function de(Y){switch(Y){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}we.to=de})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var S;(function(we){function De(Y){let Pe;return Y.code&&((0,E.isString)(Y.code)||(0,E.isNumber)(Y.code)?Pe=String(Y.code):Pe={value:String(Y.code.value),target:Y.code.target}),{...i.from(Y.range),message:Y.message,source:Y.source,code:Pe,severity:O.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(A.from),tags:Array.isArray(Y.tags)?(0,y.coalesce)(Y.tags.map(u.from)):void 0}}we.from=De;function de(Y){const Pe=new n.Diagnostic(i.to(Y),Y.message,O.to(Y.severity));return Pe.source=Y.source,Pe.code=(0,E.isString)(Y.code)?Y.code:Y.code?.value,Pe.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(A.to),Pe.tags=Y.tags&&(0,y.coalesce)(Y.tags.map(u.to)),Pe}we.to=de})(S=e.Diagnostic||(e.Diagnostic={}));var A;(function(we){function De(Y){return{...i.from(Y.location.range),message:Y.message,resource:Y.location.uri}}we.from=De;function de(Y){return new n.DiagnosticRelatedInformation(new n.Location(Y.resource,i.to(Y)),Y.message)}we.to=de})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(we){function De(Y){switch(Y){case n.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}we.from=De;function de(Y){switch(Y){case o.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}we.to=de})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var B;(function(we){function De(Y){return typeof Y=="number"&&Y>=n.ViewColumn.One?Y-1:Y===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}we.from=De;function de(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=de})(B=e.ViewColumn||(e.ViewColumn={}));function q(we){return typeof we.range<"u"}function le(we){return we.length===0?!0:!!q(we[0])}e.isDecorationOptionsArr=le;var fe;(function(we){function De(ze){return ze.map(we.from)}we.fromMany=De;function de(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function Y(ze){let nt;if(de(ze)){const{language:ht,value:St}=ze;nt={value:"```"+ht+`
`+St+"\n```\n"}}else n.MarkdownString.isMarkdownString(ze)?nt={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?nt={value:ze}:nt={value:""};const at=Object.create(null);nt.uris=at;const ut=ht=>{try{let St=m.URI.parse(ht,!0);St=St.with({query:Pe(St.query,at)}),at[ht]=St}catch{}return""},Pt=new v.marked.Renderer;return Pt.link=ut,Pt.image=ht=>typeof ht=="string"?ut(C.parseHrefAndDimensions(ht).href):"",(0,v.marked)(nt.value,{renderer:Pt}),nt}we.from=Y;function Pe(ze,nt){if(!ze)return ze;let at;try{at=(0,g.parse)(ze)}catch{}if(!at)return ze;let ut=!1;return at=(0,I.cloneAndChange)(at,Pt=>{if(m.URI.isUri(Pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ht]=Pt,ut=!0,ht}else return}),ut?JSON.stringify(at):ze}function Oe(ze){const nt=new n.MarkdownString(ze.value,ze.supportThemeIcons);return nt.isTrusted=ze.isTrusted,nt.supportHtml=ze.supportHtml,nt.baseUri=ze.baseUri?m.URI.from(ze.baseUri):void 0,nt}we.to=Oe;function xe(ze){if(!!ze)return typeof ze=="string"?ze:we.from(ze)}we.fromStrict=xe})(fe=e.MarkdownString||(e.MarkdownString={}));function ue(we){return le(we)?we.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?fe.fromMany(De.hoverMessage):De.hoverMessage?fe.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):we.map(De=>({range:i.from(De)}))}e.fromRangeOrRangeWithMessage=ue;function re(we){return typeof we>"u"?we:typeof we=="string"?m.URI.file(we):we}e.pathOrURIToURI=re;var _;(function(we){function De(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?re(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}we.from=De})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var ee;(function(we){function De(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?re(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?_.from(de.before):void 0,after:de.after?_.from(de.after):void 0}}we.from=De})(ee=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ne;(function(we){function De(de){if(typeof de>"u")return de;switch(de){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=De})(ne=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ie;(function(we){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?ne.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ee.from(de.light):void 0,dark:de.dark?ee.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?re(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?_.from(de.before):void 0,after:de.after?_.from(de.after):void 0}}we.from=De})(ie=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var G;(function(we){function De(Y){return{text:Y.newText,eol:Y.newEol&&Qe.from(Y.newEol),range:i.from(Y.range)}}we.from=De;function de(Y){const Pe=new n.TextEdit(i.to(Y.range),Y.text);return Pe.newEol=typeof Y.eol>"u"?void 0:Qe.to(Y.eol),Pe}we.to=de})(G=e.TextEdit||(e.TextEdit={}));var U;(function(we){function De(Y,Pe){const Oe={edits:[]};if(Y instanceof n.WorkspaceEdit){const xe=new k.ResourceSet;for(const ze of Y._allEntries())ze._type===1&&m.URI.isUri(ze.to)&&ze.from===void 0&&xe.add(ze.to);for(const ze of Y._allEntries())ze._type===1?Oe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,R.encodeBase64)(R.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Oe.edits.push({resource:ze.uri,textEdit:G.from(ze.edit),versionId:xe.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Oe.edits.push({resource:ze.uri,textEdit:{range:i.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:xe.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Oe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Oe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(tt.from)}})}return Oe}we.from=De;function de(Y){const Pe=new n.WorkspaceEdit;for(const Oe of Y.edits)Oe.textEdit?Pe.replace(m.URI.revive(Oe.resource),i.to(Oe.textEdit.range),Oe.textEdit.text):Pe.renameFile(m.URI.revive(Oe.oldResource),m.URI.revive(Oe.newResource),Oe.options);return Pe}we.to=de})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Z;(function(we){const De=Object.create(null);De[n.SymbolKind.File]=0,De[n.SymbolKind.Module]=1,De[n.SymbolKind.Namespace]=2,De[n.SymbolKind.Package]=3,De[n.SymbolKind.Class]=4,De[n.SymbolKind.Method]=5,De[n.SymbolKind.Property]=6,De[n.SymbolKind.Field]=7,De[n.SymbolKind.Constructor]=8,De[n.SymbolKind.Enum]=9,De[n.SymbolKind.Interface]=10,De[n.SymbolKind.Function]=11,De[n.SymbolKind.Variable]=12,De[n.SymbolKind.Constant]=13,De[n.SymbolKind.String]=14,De[n.SymbolKind.Number]=15,De[n.SymbolKind.Boolean]=16,De[n.SymbolKind.Array]=17,De[n.SymbolKind.Object]=18,De[n.SymbolKind.Key]=19,De[n.SymbolKind.Null]=20,De[n.SymbolKind.EnumMember]=21,De[n.SymbolKind.Struct]=22,De[n.SymbolKind.Event]=23,De[n.SymbolKind.Operator]=24,De[n.SymbolKind.TypeParameter]=25;function de(Pe){return typeof De[Pe]=="number"?De[Pe]:6}we.from=de;function Y(Pe){for(const Oe in De)if(De[Oe]===Pe)return Number(Oe);return n.SymbolKind.Property}we.to=Y})(Z=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function De(Y){switch(Y){case n.SymbolTag.Deprecated:return 1}}we.from=De;function de(Y){switch(Y){case 1:return n.SymbolTag.Deprecated}}we.to=de})(oe=e.SymbolTag||(e.SymbolTag={}));var me;(function(we){function De(Y){return{name:Y.name,kind:Z.from(Y.kind),tags:Y.tags&&Y.tags.map(oe.from),containerName:Y.containerName,location:M.from(Y.location)}}we.from=De;function de(Y){const Pe=new n.SymbolInformation(Y.name,Z.to(Y.kind),Y.containerName,M.to(Y.location));return Pe.tags=Y.tags&&Y.tags.map(oe.to),Pe}we.to=de})(me=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(we){function De(Y){const Pe={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),kind:Z.from(Y.kind),tags:Y.tags?.map(oe.from)??[]};return Y.children&&(Pe.children=Y.children.map(De)),Pe}we.from=De;function de(Y){const Pe=new n.DocumentSymbol(Y.name,Y.detail,Z.to(Y.kind),i.to(Y.range),i.to(Y.selectionRange));return(0,y.isNonEmptyArray)(Y.tags)&&(Pe.tags=Y.tags.map(oe.to)),Y.children&&(Pe.children=Y.children.map(de)),Pe}we.to=de})($=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(we){function De(Y){const Pe=new n.CallHierarchyItem(Z.to(Y.kind),Y.name,Y.detail||"",m.URI.revive(Y.uri),i.to(Y.range),i.to(Y.selectionRange));return Pe._sessionId=Y._sessionId,Pe._itemId=Y._itemId,Pe}we.to=De;function de(Y,Pe,Oe){if(Pe=Pe??Y._sessionId,Oe=Oe??Y._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,name:Y.name,detail:Y.detail,kind:Z.from(Y.kind),uri:Y.uri,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),tags:Y.tags?.map(oe.from)}}we.from=de})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(we){function De(de){return new n.CallHierarchyIncomingCall(W.to(de.from),de.fromRanges.map(Y=>i.to(Y)))}we.to=De})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var P;(function(we){function De(de){return new n.CallHierarchyOutgoingCall(W.to(de.to),de.fromRanges.map(Y=>i.to(Y)))}we.to=De})(P=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(we){function De(Y){return{range:Y.range&&i.from(Y.range),uri:Y.uri}}we.from=De;function de(Y){return new n.Location(m.URI.revive(Y.uri),i.to(Y.range))}we.to=de})(M=e.location||(e.location={}));var K;(function(we){function De(Y){const Pe=Y,Oe=Y;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Oe.uri,range:i.from(Pe.targetRange?Pe.targetRange:Oe.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}we.from=De;function de(Y){return{targetUri:m.URI.revive(Y.uri),targetRange:i.to(Y.range),targetSelectionRange:Y.targetSelectionRange?i.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?i.to(Y.originSelectionRange):void 0}}we.to=de})(K=e.DefinitionLink||(e.DefinitionLink={}));var te;(function(we){function De(Y){return{range:i.from(Y.range),contents:fe.fromMany(Y.contents)}}we.from=De;function de(Y){return new n.Hover(Y.contents.map(fe.to),i.to(Y.range))}we.to=de})(te=e.Hover||(e.Hover={}));var j;(function(we){function De(Y){return{range:i.from(Y.range),expression:Y.expression}}we.from=De;function de(Y){return new n.EvaluatableExpression(i.to(Y.range),Y.expression)}we.to=de})(j=e.EvaluatableExpression||(e.EvaluatableExpression={}));var H;(function(we){function De(Y){if(Y instanceof n.InlineValueText)return{type:"text",range:i.from(Y.range),text:Y.text};if(Y instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}we.from=De;function de(Y){switch(Y.type){case"text":return{range:i.to(Y.range),text:Y.text};case"variable":return{range:i.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:i.to(Y.range),expression:Y.expression}}}we.to=de})(H=e.InlineValue||(e.InlineValue={}));var J;(function(we){function De(Y){return{frameId:Y.frameId,stoppedLocation:i.from(Y.stoppedLocation)}}we.from=De;function de(Y){return new n.InlineValueContext(Y.frameId,i.to(Y.stoppedLocation))}we.to=de})(J=e.InlineValueContext||(e.InlineValueContext={}));var V;(function(we){function De(Y){return{range:i.from(Y.range),kind:Y.kind}}we.from=De;function de(Y){return new n.DocumentHighlight(i.to(Y.range),Y.kind)}we.to=de})(V=e.DocumentHighlight||(e.DocumentHighlight={}));var X;(function(we){function De(de){switch(de){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}we.to=De})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var x;(function(we){function De(de){return{triggerKind:X.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}we.to=De})(x=e.CompletionContext||(e.CompletionContext={}));var Q;(function(we){function De(Y){switch(Y){case n.CompletionItemTag.Deprecated:return 1}}we.from=De;function de(Y){switch(Y){case 1:return n.CompletionItemTag.Deprecated}}we.to=de})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var ce;(function(we){const De=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function de(Oe){return De.get(Oe)??9}we.from=de;const Y=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Oe){return Y.get(Oe)??n.CompletionItemKind.Property}we.to=Pe})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Ee;(function(we){function De(de,Y){const Pe=new n.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=ce.to(de.kind),Pe.tags=de.tags?.map(Q.to),Pe.detail=de.detail,Pe.documentation=C.isMarkdownString(de.documentation)?fe.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,p.Range.isIRange(de.range)?Pe.range=i.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:i.to(de.range.insert),replacing:i.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new n.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Oe=>G.to(Oe))),Pe.command=Y&&de.command?Y.fromInternal(de.command):void 0,Pe}we.to=De})(Ee=e.CompletionItem||(e.CompletionItem={}));var Ce;(function(we){function De(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:fe.fromStrict(Y.documentation)}}we.from=De;function de(Y){return{label:Y.label,documentation:C.isMarkdownString(Y.documentation)?fe.to(Y.documentation):Y.documentation}}we.to=de})(Ce=e.ParameterInformation||(e.ParameterInformation={}));var ke;(function(we){function De(Y){return{label:Y.label,documentation:fe.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(Ce.from):[],activeParameter:Y.activeParameter}}we.from=De;function de(Y){return{label:Y.label,documentation:C.isMarkdownString(Y.documentation)?fe.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(Ce.to):[],activeParameter:Y.activeParameter}}we.to=de})(ke=e.SignatureInformation||(e.SignatureInformation={}));var Me;(function(we){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(ke.from):[]}}we.from=De;function de(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(ke.to):[]}}we.to=de})(Me=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(we){function De(de,Y){const Pe=new n.InlayHint(c.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(ge.to.bind(void 0,de)),Y.kind&&Se.to(Y.kind));return Pe.textEdits=Y.textEdits&&Y.textEdits.map(G.to),Pe.tooltip=C.isMarkdownString(Y.tooltip)?fe.to(Y.tooltip):Y.tooltip,Pe.paddingLeft=Y.paddingLeft,Pe.paddingRight=Y.paddingRight,Pe}we.to=De})($e=e.InlayHint||(e.InlayHint={}));var ge;(function(we){function De(de,Y){const Pe=new n.InlayHintLabelPart(Y.label);return Pe.tooltip=C.isMarkdownString(Y.tooltip)?fe.to(Y.tooltip):Y.tooltip,b.Command.is(Y.command)&&(Pe.command=de.fromInternal(Y.command)),Y.location&&(Pe.location=M.to(Y.location)),Pe}we.to=De})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Se;(function(we){function De(Y){return Y}we.from=De;function de(Y){return Y}we.to=de})(Se=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(we){function De(Y){return{range:i.from(Y.range),url:Y.target,tooltip:Y.tooltip}}we.from=De;function de(Y){let Pe;if(Y.url)try{Pe=typeof Y.url=="string"?m.URI.parse(Y.url,!0):m.URI.revive(Y.url)}catch{}return new n.DocumentLink(i.to(Y.range),Pe)}we.to=de})(ye=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(we){function De(Y){const Pe=new n.ColorPresentation(Y.label);return Y.textEdit&&(Pe.textEdit=G.to(Y.textEdit)),Y.additionalTextEdits&&(Pe.additionalTextEdits=Y.additionalTextEdits.map(Oe=>G.to(Oe))),Pe}we.to=De;function de(Y){return{label:Y.label,textEdit:Y.textEdit?G.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Pe=>G.from(Pe)):void 0}}we.from=de})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var Ne;(function(we){function De(Y){return new n.Color(Y[0],Y[1],Y[2],Y[3])}we.to=De;function de(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}we.from=de})(Ne=e.Color||(e.Color={}));var et;(function(we){function De(Y){return{range:i.from(Y.range)}}we.from=De;function de(Y){return new n.SelectionRange(i.to(Y.range))}we.to=de})(et=e.SelectionRange||(e.SelectionRange={}));var Ve;(function(we){function De(de){switch(de){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}we.to=De})(Ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(we){function De(Y){switch(Y){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}we.from=De;function de(Y){switch(Y){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}we.to=de})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Qe;(function(we){function De(Y){if(Y===n.EndOfLine.CRLF)return 1;if(Y===n.EndOfLine.LF)return 0}we.from=De;function de(Y){if(Y===1)return n.EndOfLine.CRLF;if(Y===0)return n.EndOfLine.LF}we.to=de})(Qe=e.EndOfLine||(e.EndOfLine={}));var Ze;(function(we){function De(de){if(typeof de=="object")return de.viewId;switch(de){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=De})(Ze=e.ProgressLocation||(e.ProgressLocation={}));var Ge;(function(we){function De(Y){const Pe={start:Y.start+1,end:Y.end+1};return Y.kind&&(Pe.kind=he.from(Y.kind)),Pe}we.from=De;function de(Y){const Pe={start:Y.start-1,end:Y.end-1};return Y.kind&&(Pe.kind=he.to(Y.kind)),Pe}we.to=de})(Ge=e.FoldingRange||(e.FoldingRange={}));var he;(function(we){function De(Y){if(Y)switch(Y){case n.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}we.from=De;function de(Y){if(Y)switch(Y.value){case b.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}we.to=de})(he=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ie;(function(we){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?i.from(de.selection):void 0,override:typeof de.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=De})(Ie=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Te;(function(we){function De(Oe){return Oe instanceof n.RelativePattern?Oe.toJSON():typeof Oe=="string"?Oe:de(Oe)||Y(Oe)?new n.RelativePattern(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}we.from=De;function de(Oe){const xe=Oe;return xe?m.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function Y(Oe){const xe=Oe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Pe(Oe){return typeof Oe=="string"?Oe:new n.RelativePattern(m.URI.revive(Oe.baseUri),Oe.pattern)}we.to=Pe})(Te=e.GlobPattern||(e.GlobPattern={}));var Be;(function(we){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const Y=de;return{language:Y.language,scheme:Y.scheme,pattern:Te.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}we.from=De})(Be=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(we){function De(de){switch(de){case 2:return n.NotebookDocumentSaveReason.AfterDelay;case 1:return n.NotebookDocumentSaveReason.Manual;case 3:case 4:return n.NotebookDocumentSaveReason.FocusOut}}we.to=De})(Le=e.NotebookDocumentSaveReason||(e.NotebookDocumentSaveReason={}));var je;(function(we){function De(Y){return{start:Y.start,end:Y.end}}we.from=De;function de(Y){return new n.NotebookRange(Y.start,Y.end)}we.to=de})(je=e.NotebookRange||(e.NotebookRange={}));var We;(function(we){function De(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}we.to=De;function de(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}we.from=de})(We=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ye;(function(we){function De(de){if(de===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(de===f.NotebookCellExecutionState.Pending)return;if(de===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}we.to=De})(Ye=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qe;(function(we){function De(Y){switch(Y){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}we.from=De;function de(Y){switch(Y){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}we.to=de})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(we){function De(Y){const Pe={metadata:Y.metadata??Object.create(null),cells:[]};for(const Oe of Y.cells)n.NotebookCellData.validate(Oe),Pe.cells.push(tt.from(Oe));return Pe}we.from=De;function de(Y){const Pe=new n.NotebookData(Y.cells.map(tt.to));return(0,E.isEmptyObject)(Y.metadata)||(Pe.metadata=Y.metadata),Pe}we.to=de})(Ke=e.NotebookData||(e.NotebookData={}));var tt;(function(we){function De(Y){return{cellKind:qe.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:We.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(lt.from):[]}}we.from=De;function de(Y){return new n.NotebookCellData(qe.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(lt.to):void 0,Y.metadata,Y.internalMetadata?We.to(Y.internalMetadata):void 0)}we.to=de})(tt=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(we){function De(Y){return{mime:Y.mime,valueBytes:R.VSBuffer.wrap(Y.data)}}we.from=De;function de(Y){return new n.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}we.to=de})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(we){function De(Y){return{outputId:Y.id,items:Y.items.map(Je.from),metadata:Y.metadata}}we.from=De;function de(Y){const Pe=Y.items.map(Je.to);return new n.NotebookCellOutput(Pe,Y.outputId,Y.metadata)}we.to=de})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var mt;(function(we){function De(Pe){return Y(Pe)?{include:(0,E.withNullAsUndefined)(Te.from(Pe.include)),exclude:(0,E.withNullAsUndefined)(Te.from(Pe.exclude))}:(0,E.withNullAsUndefined)(Te.from(Pe))}we.from=De;function de(Pe){return Y(Pe)?{include:Te.to(Pe.include),exclude:Te.to(Pe.exclude)}:Te.to(Pe)}we.to=de;function Y(Pe){const Oe=Pe;return Oe?!(0,E.isUndefinedOrNull)(Oe.include)&&!(0,E.isUndefinedOrNull)(Oe.exclude):!1}})(mt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ot;(function(we){function De(de,Y,Pe){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Oe,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}we.from=De})(ot=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var $t;(function(we){function De(de,Y,Pe){const Oe=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:Y.toInternal(Oe,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}we.from=De})($t=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Dt;(function(we){function De(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}we.from=De})(Dt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ut;(function(we){function De(Y){return{uri:Y.uri,provides:Y.provides}}we.from=De;function de(Y){return new n.NotebookRendererScript(m.URI.revive(Y.uri),Y.provides)}we.to=de})(Ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var bt;(function(we){function De(Y){return{message:fe.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location&&{range:i.from(Y.location.range),uri:Y.location.uri}}}we.from=De;function de(Y){const Pe=new n.TestMessage(typeof Y.message=="string"?Y.message:fe.to(Y.message));return Pe.actualOutput=Y.actual,Pe.expectedOutput=Y.expected,Pe.location=Y.location?M.to(Y.location):void 0,Pe}we.to=de})(bt=e.TestMessage||(e.TestMessage={}));var ft;(function(we){we.namespace=L.namespaceTestTag,we.denamespace=L.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Tt;(function(we){function De(Y){const Pe=(0,d.getPrivateApiFor)(Y).controllerId;return{extId:w.TestId.fromExtHostTestItem(Y,Pe).toString(),label:Y.label,uri:m.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Oe=>ft.namespace(Pe,Oe.id)),range:p.Range.lift(i.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&fe.fromStrict(Y.error)||null}}we.from=De;function de(Y){return{parent:void 0,error:void 0,id:w.TestId.fromString(Y.extId).localId,label:Y.label,uri:m.URI.revive(Y.uri),tags:(Y.tags||[]).map(Pe=>{const{tagId:Oe}=ft.denamespace(Pe);return new n.TestTag(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}we.toPlain=de})(Tt=e.TestItem||(e.TestItem={})),function(we){function De(Y){return{id:Y.id}}we.from=De;function de(Y){return new n.TestTag(Y.id)}we.to=de}(ft=e.TestTag||(e.TestTag={}));var Bt;(function(we){const De=(Y,Pe)=>{const Oe=[];for(const[ze,nt]of Pe)w.TestId.compare(nt.item.extId,ze)===2&&(Pe.delete(ze),Oe.push(nt));const xe={...Tt.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(nt=>nt.type===0).map(bt.to)})),children:Oe.map(ze=>De(ze,Pe))};for(const ze of xe.children)ze.parent=xe;return xe};function de(Y){const Pe=[],Oe=new Map;for(const xe of Y.items){Oe.set(xe.item.extId,xe);const ze=w.TestId.root(xe.item.extId);Y.request.targets.some(nt=>nt.controllerId===ze&&nt.testIds.includes(xe.item.extId))&&Pe.push(xe)}return{completedAt:Y.completedAt,results:Pe.map(xe=>De(xe,Oe))}}we.to=de})(Bt=e.TestResults||(e.TestResults={}));var Ct;(function(we){function De(Oe){return{covered:Oe.covered,total:Oe.covered}}function de(Oe){return"line"in Oe?c.from(Oe):i.from(Oe)}function Y(Oe){return"branches"in Oe?{count:Oe.executionCount,location:de(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&de(xe.location)})):void 0}:{type:0,count:Oe.executionCount,location:de(Oe.location)}}we.fromDetailed=Y;function Pe(Oe){return{uri:Oe.uri,statement:De(Oe.statementCoverage),branch:Oe.branchCoverage&&De(Oe.branchCoverage),function:Oe.functionCoverage&&De(Oe.functionCoverage),details:Oe.detailedCoverage?.map(Y)}}we.fromFile=Pe})(Ct=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(we){function De(de){switch(de){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}we.to=De})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(we){function De(Y){const Pe=new n.TypeHierarchyItem(Z.to(Y.kind),Y.name,Y.detail||"",m.URI.revive(Y.uri),i.to(Y.range),i.to(Y.selectionRange));return Pe._sessionId=Y._sessionId,Pe._itemId=Y._itemId,Pe}we.to=De;function de(Y,Pe,Oe){if(Pe=Pe??Y._sessionId,Oe=Oe??Y._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,kind:Z.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:i.from(Y.range),selectionRange:i.from(Y.selectionRange),tags:Y.tags?.map(oe.from)}}we.from=de})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var gt;(function(we){function De(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}we.from=De})(gt=e.ViewBadge||(e.ViewBadge={}));var Et;(function(we){function De(Oe,xe,ze){const nt=xe.fileData;return nt?new class extends n.DataTransferItem{asFile(){return{name:nt.name,uri:m.URI.revive(nt.uri),data:(0,D.once)(()=>ze())}}}("",xe.id):Oe===T.Mimes.uriList&&xe.uriListData?new n.DataTransferItem(Pe(xe.uriListData)):new n.DataTransferItem(xe.asString)}we.to=De;async function de(Oe,xe){const ze=await xe.asString();if(Oe===T.Mimes.uriList)return{id:xe.id,asString:ze,fileData:void 0,uriListData:Y(ze)};const nt=xe.asFile();return{id:xe.id,asString:ze,fileData:nt?{name:nt.name,uri:nt.uri}:void 0}}we.from=de;function Y(Oe){return a.UriList.split(Oe).map(xe=>{if(xe.startsWith("#"))return xe;try{return m.URI.parse(xe)}catch{}return xe})}function Pe(Oe){return a.UriList.create(Oe.map(xe=>typeof xe=="string"?xe:m.URI.revive(xe)))}})(Et=e.DataTransferItem||(e.DataTransferItem={}));var st;(function(we){function De(Y,Pe){const Oe=Y.items.map(([xe,ze])=>[xe,Et.to(xe,ze,()=>Pe(ze.id))]);return new n.DataTransfer(Oe)}we.toDataTransfer=De;async function de(Y){const Pe={items:[]},Oe=[];return Y.forEach((xe,ze)=>{Oe.push((async()=>{Pe.items.push([ze,await Et.from(ze,xe)])})())}),await Promise.all(Oe),Pe}we.toDataTransferDTO=de})(st=e.DataTransfer||(e.DataTransfer={}));var yt;(function(we){function De(Y){return{message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}we.to=De;function de(Y){return{kind:"reply",message:Y.message,metadata:Y.metadata,title:Y.title,tooltip:Y.tooltip}}we.from=de})(yt=e.InteractiveSessionReplyFollowup||(e.InteractiveSessionReplyFollowup={}));var wt;(function(we){function De(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",args:de.args}:yt.from(de)}we.from=De})(wt=e.InteractiveSessionFollowup||(e.InteractiveSessionFollowup={}))}),define(pe[278],ve([1,0,50,130,70,129,88,135,4]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(f,w,L,t)=>{let n=w;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!L(n,r)){const i=n;n=r,f.listener?.(t(r,i))}}}},T=(f,w)=>f===w,I={range:(f,w)=>f===w?!0:!f||!w?!1:f.isEqual(w),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(f,w)=>!(f.length!==w.length||f.some(L=>!w.find(t=>L.id===t.id)))},E=f=>w=>({op:4,update:f(w)}),m=(f,w)=>({range:(()=>{let L;const t=E(n=>({range:y.Range.lift(k.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return L},set(n){f.listener?.({op:6}),I.range(L,n)||(L=n,f.listener?.(t(n)))}}})(),label:g(f,w,I.label,E(L=>({label:L}))),description:g(f,void 0,I.description,E(L=>({description:L}))),sortText:g(f,void 0,I.sortText,E(L=>({sortText:L}))),canResolveChildren:g(f,!1,I.canResolveChildren,L=>({op:2,state:L})),busy:g(f,!1,I.busy,E(L=>({busy:L}))),error:g(f,void 0,I.error,E(L=>({error:k.MarkdownString.fromStrict(L)||null}))),tags:g(f,[],I.tags,(L,t)=>({op:1,new:L.map(k.TestTag.from),old:t.map(k.TestTag.from)}))}),p=f=>{const w=a.TestId.fromString(f.extId),L=new o(w.controllerId,w.localId,f.label,v.URI.revive(f.uri)||void 0);return L.range=k.Range.to(f.range||void 0),L.description=f.description||void 0,L.sortText=f.sortText||void 0,L.tags=f.tags.map(t=>k.TestTag.to({id:(0,C.denamespaceTestTag)(t).tagId})),L},b=f=>{let w;for(const L of f.tests){const t=p(L.item);(0,R.getPrivateApiFor)(t).parent=w,w=t}return w};e.toItemFromContext=b;class o{constructor(w,L,t,n){if(L.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(L)} symbol`);const r=(0,R.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,D.createTestItemChildren)(r,R.getPrivateApiFor,o),enumerable:!0,writable:!1},...m(r,t)})}}e.TestItemImpl=o;class d extends o{constructor(w,L){super(w,w,L,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class h extends D.TestItemCollection{constructor(w,L,t){super({controllerId:w,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:R.getPrivateApiFor,getChildren:n=>n.children,root:new d(w,L),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(pe[279],ve([1,0,36,199,51]),function(ae,e,y,R,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function D(C,k,v,g){const T=new y.ExtensionIdentifierMap;return C.forEach(I=>{const E=T.get(I.identifier);E&&g.warn((0,R.localize)(0,null,E.extensionLocation.fsPath,I.extensionLocation.fsPath)),T.set(I.identifier,I)}),k.forEach(I=>{const E=T.get(I.identifier);if(E)if(E.isBuiltin){if(a.gte(E.version,I.version)){g.warn(`Skipping extension ${I.extensionLocation.path} in favour of the builtin extension ${E.extensionLocation.path}.`);return}I.isBuiltin=!0}else g.warn((0,R.localize)(1,null,E.extensionLocation.fsPath,I.extensionLocation.fsPath));else if(I.isBuiltin){g.warn(`Skipping obsolete builtin extension ${I.extensionLocation.path}`);return}T.set(I.identifier,I)}),v.forEach(I=>{g.info((0,R.localize)(2,null,I.extensionLocation.fsPath));const E=T.get(I.identifier);E&&E.isBuiltin&&(I.isBuiltin=!0),T.set(I.identifier,I)}),Array.from(T.values())}e.dedupExtensions=D}),define(pe[280],ve([1,0,7,3,28,4,42,48,65,55,279,13]),function(ae,e,y,R,a,D,C,k,v,g,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class E{constructor(b,o,d,h,f,w,L){this.b=b,this.c=d,this.d=h,this.f=f,this.g=w,this.h=L;const t=o.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!o.args["do-not-sync"],installPreReleaseVersion:!!o.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.a=b.installExtensions([],this.i(t),r,!!o.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},i=>{f.error(i)})}else this.a=Promise.resolve();const n=o.args["install-extension"];n&&(f.trace("Installing extensions passed via args..."),this.a.then(()=>b.installExtensions(this.i(n),[],{isMachineScoped:!!o.args["do-not-sync"],installPreReleaseVersion:!!o.args["pre-release"],isApplicationScoped:!0},!!o.args.force)).then(()=>{f.trace("Finished installing extensions")},r=>{f.error(r)}))}i(b){return b.map(o=>/\.vsix$/i.test(o)?D.URI.file((0,y.isAbsolute)(o)?o:(0,y.join)((0,a.cwd)(),o)):o)}whenExtensionsReady(){return this.a}async scanExtensions(b,o,d,h){C.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${b}`),await this.whenExtensionsReady();const f=d?d.filter(L=>L.scheme===I.Schemas.file).map(L=>L.fsPath):void 0;o=o??this.c.defaultProfile.extensionsResource;const w=await this.j(o,b??R.language,f,h);return this.f.trace("Scanned Extensions",w),this.q(w),C.mark("code/server/didScanExtensions"),w}async scanSingleExtension(b,o,d){await this.whenExtensionsReady();const h=b.scheme===I.Schemas.file?b.fsPath:null;if(!h)return null;const f=await this.n(h,o,d??R.language);return f?(this.q([f]),f):null}async j(b,o,d,h){await this.o(o,h);const[f,w,L]=await Promise.all([this.l(o),this.m(b,o),this.k(o,d)]);return(0,T.dedupExtensions)(f,w,L,this.f)}async k(b,o){return o?(await Promise.all(o.map(d=>this.d.scanOneOrMultipleExtensions(D.URI.file((0,y.resolve)(d)),1,{language:b})))).flat().map(d=>(0,g.toExtensionDescription)(d,!0)):[]}async l(b){return(await this.d.scanSystemExtensions({language:b,useCache:!0})).map(d=>(0,g.toExtensionDescription)(d,!1))}async m(b,o){return(await this.d.scanUserExtensions({profileLocation:b,language:o,useCache:!0})).map(h=>(0,g.toExtensionDescription)(h,!1))}async n(b,o,d){const h=D.URI.file((0,y.resolve)(b)),f=o?0:1,w=await this.d.scanExistingExtension(h,f,{language:d});return w?(0,g.toExtensionDescription)(w,!1):null}async o(b,o){if(!(b===R.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(h=>h.id===b)){this.f.trace(`Language Pack ${b} is already installed. Skipping language pack installation.`);return}}catch(d){this.f.error(d)}if(!o){this.f.trace(`No language pack id provided for language ${b}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${o} for language ${b} is not installed. It will be installed now.`);try{await this.b.installExtensions([o],[],{isMachineScoped:!0},!0)}catch(d){this.f.error(d)}}}q(b){const o=(t,n)=>t.replace(/file/g,"vscode-remote"),d=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(o(t.source,!0),n)},h=new class{mapDefined(t){return v.ContextKeyDefinedExpr.create(t)}mapNot(t){return v.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyEqualsExpr.create(t,o(n,!1)):v.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyNotEqualsExpr.create(t,o(n,!1)):v.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return v.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return v.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return v.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return v.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?v.ContextKeyRegexExpr.create(t,d(n)):v.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return v.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return v.ContextKeyNotInExpr.create(t,n)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=v.ContextKeyExpr.deserialize(t.when);if(!n)return;const r=n.map(h);t.when=r.serialize()},w=t=>{if(Array.isArray(t))for(const n of t)f(n);else f(t)},L=t=>{for(const n in t)w(t[n])};b.forEach(t=>{t.contributes&&(t.contributes.menus&&L(t.contributes.menus),t.contributes.keybindings&&w(t.contributes.keybindings),t.contributes.views&&L(t.contributes.views))})}}e.RemoteExtensionsScannerService=E;class m{constructor(b,o){this.a=b,this.b=o}listen(b,o){throw new Error("Invalid listen")}async call(b,o,d){const h=this.b(b);switch(o){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=d[0],w=d[1]?D.URI.revive(h.transformIncoming(d[1])):void 0,L=Array.isArray(d[2])?d[2].map(r=>D.URI.revive(h.transformIncoming(r))):void 0,t=d[3];return(await this.a.scanExtensions(f,w,L,t)).map(r=>(0,k.transformOutgoingURIs)(r,h))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(D.URI.revive(h.transformIncoming(d[0])),d[1],d[2]);return f?(0,k.transformOutgoingURIs)(f,h):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=m}),define(pe[136],ve([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++y.count}}y.count=0,e.ProxyIdentifier=y;const R=[];function a(k){const v=new y(k);return R[v.nid]=v,v}e.createProxyIdentifier=a;function D(k){return R[k].sid}e.getStringIdentifierForProxy=D;class C{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=C}),define(pe[281],ve([1,0,136]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var a;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(a=e.TabInputKind||(e.TabInputKind={}));var D;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var v;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(v=e.CellOutputKind||(e.CellOutputKind={}));var g;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(g=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(o){return o._id=I.a++,o}}I.a=0,e.IdObject=I;var E;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,y.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,y.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,y.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,y.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,y.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,y.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,y.createProxyIdentifier)("ExtHostLocalization")}});var Ft=this&&this.__classPrivateFieldSet||function(ae,e,y,R,a){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!a:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?a.call(ae,y):a?a.value=y:e.set(ae,y),y},rt=this&&this.__classPrivateFieldGet||function(ae,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(ae):R?R.value:e.get(ae)};define(pe[282],ve([1,0,8,134,135,22,281,18,12,61,50,104,4,2,5,265,278,15,136,39,94,37,276]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(O,B,q){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),Ft(this,n,O.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=B,Ft(this,i,q,"f"),Ft(this,r,O.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,le=>{const fe=this.c.get(le);return fe?.result===u.Void?fe:void 0},B),this.f=[{processArgument(le){return(0,g.revive)(le)}},{processArgument(le){return(0,D.cloneAndChange)(le,function(fe){if(T.Range.isIRange(fe))return a.Range.to(fe);if(I.Position.isIPosition(fe))return a.Position.to(fe);if(T.Range.isIRange(fe.range)&&E.URI.isUri(fe.uri))return a.location.to(fe);if(fe instanceof d.VSBuffer)return fe.buffer.buffer;if(!Array.isArray(fe))return fe})}}]}registerArgumentProcessor(O){this.f.push(O)}registerApiCommand(O){const B=this.registerCommand(!1,O.id,async(...q)=>{const le=O.args.map((ue,re)=>{if(!ue.validate(q[re]))throw new Error(`Invalid argument '${ue.name}' when running '${O.id}', received: ${q[re]}`);return ue.convert(q[re])}),fe=await this.executeCommand(O.internalId,...le);return O.result.convert(fe,q,this.converter)},void 0,{description:O.description,args:O.args,returns:O.result.description});return this.c.set(O.id,O),new R.Disposable(()=>{B.dispose(),this.c.delete(O.id)})}registerCommand(O,B,q,le,fe,ue){if(this.d.trace("ExtHostCommands#registerCommand",B),!B.trim().length)throw new Error("invalid id");if(this.b.has(B))throw new Error(`command '${B}' already exists`);return this.b.set(B,{callback:q,thisArg:le,description:fe,extension:ue}),O&&rt(this,n,"f").$registerCommand(B),new R.Disposable(()=>{this.b.delete(B)&&O&&rt(this,n,"f").$unregisterCommand(B)})}executeCommand(O,...B){return this.d.trace("ExtHostCommands#executeCommand",O),this.g(O,B,!0)}async g(O,B,q){if(this.b.has(O))return rt(this,n,"f").$fireCommandActivationEvent(O),this.h(O,B,!1);{let le=!1;const fe=(0,D.cloneAndChange)(B,function(ue){if(ue instanceof R.Position)return a.Position.from(ue);if(ue instanceof R.Range)return a.Range.from(ue);if(ue instanceof R.Location)return a.location.from(ue);if(R.NotebookRange.isNotebookRange(ue))return a.NotebookRange.from(ue);if(ue instanceof ArrayBuffer)return le=!0,d.VSBuffer.wrap(new Uint8Array(ue));if(ue instanceof Uint8Array)return le=!0,d.VSBuffer.wrap(ue);if(ue instanceof d.VSBuffer)return le=!0,ue;if(!Array.isArray(ue))return ue});try{const ue=await rt(this,n,"f").$executeCommand(O,le?new h.SerializableObjectWithBuffers(fe):fe,q);return(0,g.revive)(ue)}catch(ue){if(ue instanceof Error&&ue.message==="$executeCommand:retry")return this.g(O,B,!1);throw ue}}}async h(O,B,q){const le=this.b.get(O);if(!le)throw new Error("Unknown command");const{callback:fe,thisArg:ue,description:re}=le;if(re)for(let ee=0;ee<re.args.length;ee++)try{(0,y.validateConstraint)(B[ee],re.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${O}' failed. Illegal argument '${re.args[ee].name}' - ${re.args[ee].description}`)}const _=w.StopWatch.create();try{return await fe.apply(ue,B)}catch(ee){if(O===this.converter.delegatingCommandId){const ne=this.converter.getActualCommand(...B);ne&&(O=ne.command)}if(this.d.error(ee,O,le.extension?.identifier),!q)throw ee;if(le.extension?.identifier){const ne=rt(this,i,"f").onExtensionError(le.extension.identifier,ee);this.d.trace("forwarded error to extension?",ne,le.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)(ee)),this.id=O,this.source=le.extension?.displayName??le.extension?.name}}}finally{this.j(le,O,_.elapsed())}}j(O,B,q){!O.extension||rt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:O.extension.identifier.value,id:new L.TelemetryTrustedValue(B),duration:q})}$executeContributedCommand(O,...B){this.d.trace("ExtHostCommands#$executeContributedCommand",O);const q=this.b.get(O);return q?(B=B.map(le=>this.f.reduce((fe,ue)=>ue.processArgument(fe,q.extension?.identifier),le)),this.h(O,B,!0)):Promise.reject(new Error(`Contributed command '${O}' does not exist.`))}getCommands(O=!1){return this.d.trace("ExtHostCommands#getCommands",O),rt(this,n,"f").$getCommands().then(B=>(O&&(B=B.filter(q=>q[0]!=="_")),B))}$getContributedCommandHandlerDescriptions(){const O=Object.create(null);for(const[B,q]of this.b){const{description:le}=q;le&&(O[B]=le)}return Promise.resolve(O)}};n=new WeakMap,r=new WeakMap,i=new WeakMap,l=Re([Ae(0,b.IExtHostRpcService),Ae(1,v.ILogService),Ae(2,t.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class c{constructor(O,B,q){this.d=O,this.f=B,this.g=q,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(O,B){if(!O)return;const q={$ident:void 0,id:O.command,title:O.title,tooltip:O.tooltip};if(!O.command)return q;const le=this.f(O.command);if(le)q.id=le.internalId,q.arguments=le.args.map((fe,ue)=>fe.convert(O.arguments&&O.arguments[ue]));else if((0,k.isNonEmptyArray)(O.arguments)){const fe=`${O.command}/${++this.c}`;this.b.set(fe,O),B.add((0,m.toDisposable)(()=>{this.b.delete(fe),this.g.trace("CommandsConverter#DISPOSE",fe)})),q.$ident=fe,q.id=this.delegatingCommandId,q.arguments=[fe],this.g.trace("CommandsConverter#CREATE",O.command,fe)}return q}fromInternal(O){return typeof O.$ident=="string"?this.b.get(O.$ident):{command:O.id,title:O.title,arguments:O.arguments}}getActualCommand(...O){return this.b.get(O[0])}h(...O){const B=this.getActualCommand(...O);return this.g.trace("CommandsConverter#EXECUTE",O[0],B?B.command:"MISSING"),B?this.d.executeCommand(B.command,...B.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${O[0]}`)}}e.CommandsConverter=c;class s{constructor(O,B,q,le){this.name=O,this.description=B,this.validate=q,this.convert=le}optional(){return new s(this.name,`(optional) ${this.description}`,O=>O==null||this.validate(O),O=>O===void 0?void 0:O===null?null:this.convert(O))}with(O,B){return new s(O??this.name,B??this.description,this.validate,this.convert)}}s.Uri=new s("uri","Uri of a text document",A=>E.URI.isUri(A),A=>A),s.Position=new s("position","A position in a text document",A=>R.Position.isPosition(A),a.Position.from),s.Range=new s("range","A range in a text document",A=>R.Range.isRange(A),a.Range.from),s.Selection=new s("selection","A selection in a text document",A=>R.Selection.isSelection(A),a.Selection.from),s.Number=new s("number","",A=>typeof A=="number",A=>A),s.String=new s("string","",A=>typeof A=="string",A=>A),s.CallHierarchyItem=new s("item","A call hierarchy item",A=>A instanceof R.CallHierarchyItem,a.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",A=>A instanceof R.TypeHierarchyItem,a.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",A=>A instanceof o.TestItemImpl,a.TestItem.from),e.ApiCommandArgument=s;class u{constructor(O,B){this.description=O,this.convert=B}}u.Void=new u("no result",A=>A),e.ApiCommandResult=u;class S{constructor(O,B,q,le,fe){this.id=O,this.internalId=B,this.description=q,this.args=le,this.result=fe}}e.ApiCommand=S}),define(pe[283],ve([1,0,62,262,33,282,4,12,85]),function(ae,e,y,R,a,D,C,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(E,m,p){this.b=E,this.c=m,this.f=p,this.a=R.createServer((b,o)=>this.h(b,o)),this.g().catch(b=>(m.error(b),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,m){const p=(o,d)=>{m.writeHead(o,{"content-type":"application/json"}),m.end(JSON.stringify(d||null),h=>h&&this.c.error(h))},b=[];E.setEncoding("utf8"),E.on("data",o=>b.push(o)),E.on("end",async()=>{try{const o=JSON.parse(b.join(""));let d;switch(o.type){case"open":d=await this.i(o);break;case"openExternal":d=await this.j(o);break;case"status":d=await this.l(o);break;case"extensionManagement":d=await this.k(o);break;default:p(404,`Unknown message type: ${o.type}`);break}p(200,d)}catch(o){const d=o instanceof Error?o.message:JSON.stringify(o);p(500,d),this.c.error("Error while processing pipe request",o)}})}async i(E){const{fileURIs:m,folderURIs:p,forceNewWindow:b,diffMode:o,mergeMode:d,addMode:h,forceReuseWindow:f,gotoLineMode:w,waitMarkerFilePath:L,remoteAuthority:t}=E,n=[];if(Array.isArray(p))for(const c of p)try{n.push({folderUri:C.URI.parse(c)})}catch{}if(Array.isArray(m))for(const c of m)try{(0,v.hasWorkspaceFileExtension)(c)?n.push({workspaceUri:C.URI.parse(c)}):n.push({fileUri:C.URI.parse(c)})}catch{}const r=L?C.URI.file(L):void 0,l={forceNewWindow:b,diffMode:o,mergeMode:d,addMode:h,gotoLineMode:w,forceReuseWindow:f,preferNewWindow:!f&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,l),""}async j(E){for(const m of E.uris){const p=C.URI.parse(m),b=p.scheme==="file"?p:m;await this.b.executeCommand("_remoteCLI.openExternal",b)}}async k(E){const m=b=>b?.map(o=>/\.vsix$/i.test(o)?C.URI.parse(o):o),p={list:E.list,install:m(E.install),uninstall:m(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&a.existsSync(this.f)&&a.unlinkSync(this.f)}}e.CLIServerBase=g;let T=class extends g{constructor(E,m){super(E,m,(0,y.createRandomIPCHandle)())}};T=Re([Ae(0,D.IExtHostCommands),Ae(1,k.ILogService)],T),e.CLIServer=T}),define(pe[284],ve([1,0,29,6,22,2,7,3,4,62,69,283,120,84,269,271,133]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends b.AbstractVariableResolverService{constructor(w,L,t,n,r){super({getFolderUri:i=>{const l=L.filter(c=>c.name===i);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>L.length,getConfigurationValue:(i,l)=>n[`config:${l}`],getExecPath:()=>w.VSCODE_EXEC_PATH,getAppRoot:()=>w.VSCODE_CWD,getFilePath:()=>{if(t)return C.normalize(t.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber,getExtension:async i=>{const c=(await r.getInstalled()).find(s=>s.identifier.id===i);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(w))}}class h extends D.Disposable{constructor(w,L,t,n,r,i){super(),this.g=w,this.h=L,this.i=t,this.j=n,this.l=r,this.m=i,this.a=0,this.b=new Map,this.c=this.B(new R.Emitter),this.onExecuteCommand=this.c.event}async call(w,L,t){switch(L){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,t);case"$createProcess":{const n=(0,T.createURITransformer)(w.remoteAuthority);return this.n(n,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,t)}throw new Error(`IPC Command ${L} not found`)}listen(w,L,t){switch(L){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(w,L){const t={name:L.shellLaunchConfig.name,executable:L.shellLaunchConfig.executable,args:L.shellLaunchConfig.args,cwd:typeof L.shellLaunchConfig.cwd=="string"||typeof L.shellLaunchConfig.cwd>"u"?L.shellLaunchConfig.cwd:v.URI.revive(w.transformIncoming(L.shellLaunchConfig.cwd)),env:L.shellLaunchConfig.env,useShellEnvironment:L.shellLaunchConfig.useShellEnvironment,reconnectionProperties:L.shellLaunchConfig.reconnectionProperties,type:L.shellLaunchConfig.type,isFeatureTerminal:L.shellLaunchConfig.isFeatureTerminal},n=await(0,o.buildUserEnvironment)(L.resolverEnv,!!L.shellLaunchConfig.useShellEnvironment,k.language,this.g,this.h,this.m);this.h.trace("baseEnv",n);const r=re=>({uri:v.URI.revive(w.transformIncoming(re.uri)),name:re.name,index:re.index,toResource:()=>{throw new Error("Not implemented")}}),i=L.workspaceFolders.map(r),l=L.activeWorkspaceFolder?r(L.activeWorkspaceFolder):void 0,c=L.activeFileResource?v.URI.revive(w.transformIncoming(L.activeFileResource)):void 0,s=new d(n,i,c,L.resolvedVariables,this.l),u=p.createVariableResolver(l,process.env,s),S=await p.getCwd(t,y.homedir(),u,l?.uri,L.configuration["terminal.integrated.cwd"],this.h);t.cwd=S;const A=k.isWindows?"terminal.integrated.env.windows":k.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=L.configuration[A],B=await p.createTerminalEnvironment(t,O,u,this.j.version,L.configuration["terminal.integrated.detectLocale"],n);if(!t.strictEnv){const re=[];for(const[ne,ie]of L.envVariableCollections)re.push([ne,{map:(0,m.deserializeEnvironmentVariableCollection)(ie)}]);const _=new Map(re);await new E.MergedEnvironmentVariableCollection(_).applyToProcessEnvironment(B,u)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:S,cols:L.cols,rows:L.rows,env:B});const q=(0,g.createRandomIPCHandle)();B.VSCODE_IPC_HOOK_CLI=q;const le=await this.i.createProcess(t,S,L.cols,L.rows,L.unicodeVersion,B,n,L.options,L.shouldPersistTerminal,L.workspaceId,L.workspaceName),fe={executeCommand:(re,..._)=>this.p(le,re,_,w)},ue=new I.CLIServerBase(fe,this.h,q);return this.i.onProcessExit(re=>re.id===le&&ue.dispose()),{persistentTerminalId:le,resolvedShellLaunchConfig:t}}p(w,L,t,n){let r,i;const l=new Promise((u,S)=>{r=u,i=S}),c=++this.a;this.b.set(c,{resolve:r,reject:i,uriTransformer:n});const s=(0,a.cloneAndChange)(t,u=>{if(u&&u.$mid===1)return n.transformOutgoing(u);if(u&&u instanceof v.URI)return n.transformOutgoingURI(u)});return this.c.fire({reqId:c,persistentProcessId:w,commandId:L,commandArgs:s}),l}r(w,L,t){const n=this.b.get(w);if(!n)return;this.b.delete(w);const r=(0,a.cloneAndChange)(t,i=>{if(i&&i.$mid===1)return n.uriTransformer.transformIncoming(i)});L?n.reject(r):n.resolve(r)}s(w){return this.i.getDefaultSystemShell(w)}async t(w,L,t,n){return this.i.getProfiles?.(w,L,t,n)||[]}u(){return{...process.env}}w(w,L){return this.i.getWslPath(w,L)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=h}),define(pe[285],ve([1,0,9,2,13,213]),function(ae,e,y,R,a,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class C extends D.DiskFileSystemProviderClient{static register(v,g,T){const I=v.getConnection();if(!I)return R.Disposable.None;const E=new R.DisposableStore,m=(async()=>{try{const p=await v.getRawEnvironment();p?g.registerProvider(a.Schemas.vscodeRemote,E.add(new C(p,I))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(p){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.getErrorMessage)(p))}})();return E.add(g.onWillActivateFileSystemProvider(p=>{p.scheme===a.Schemas.vscodeRemote&&p.join(m)})),E}constructor(v,g){super(g.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=C}),define(pe[89],ve([1,0,33,14,7,8,23,166,297,298]),function(ae,e,y,R,a,D,C,k,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const T=new RegExp(e.CorruptZipMessage);class I extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=r}}e.ExtractError=I;function E(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function m(t){if(t instanceof I)return t;let n;return T.test(t.message)&&(n="CorruptZip"),new I(n,t)}function p(t,n,r,i,l,c){const s=a.dirname(n),u=a.join(i,s);if(!u.startsWith(i))return Promise.reject(new Error(k.localize(0,null,n)));const S=a.join(i,n);let A;return c.onCancellationRequested(()=>{A?.destroy()}),Promise.resolve(C.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((O,B)=>{if(!c.isCancellationRequested)try{A=(0,y.createWriteStream)(S,{mode:r}),A.once("close",()=>O()),A.once("error",B),t.once("error",B),t.pipe(A)}catch(q){B(q)}}))}function b(t,n,r,i){let l=(0,R.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{l.cancel(),t.close()}),new Promise((s,u)=>{const S=new R.Sequencer,A=O=>{O.isCancellationRequested||(c++,t.readEntry())};t.once("error",u),t.once("close",()=>l.then(()=>{i.isCancellationRequested||t.entryCount===c?s():u(new I("Incomplete",new Error(k.localize(1,null,c,t.entryCount))))},u)),t.readEntry(),t.on("entry",O=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){A(i);return}const B=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(B)){const fe=a.join(n,B);l=(0,R.createCancelablePromise)(ue=>C.Promises.mkdir(fe,{recursive:!0}).then(()=>A(ue)).then(void 0,u));return}const q=d(t,O),le=E(O);l=(0,R.createCancelablePromise)(fe=>S.queue(()=>q.then(ue=>p(ue,B,le,n,r,fe).then(()=>A(fe)))).then(null,u))})})}function o(t,n=!1){return new Promise((r,i)=>{(0,v.open)(t,n?{lazyEntries:!0}:void 0,(l,c)=>{l?i(m(l)):r((0,D.assertIsDefined)(c))})})}function d(t,n){return new Promise((r,i)=>{t.openReadStream(n,(l,c)=>{l?i(m(l)):r((0,D.assertIsDefined)(c))})})}function h(t,n){return new Promise((r,i)=>{const l=new g.ZipFile;n.forEach(s=>{s.contents?l.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&l.addFile(s.localPath,s.path)}),l.end();const c=(0,y.createWriteStream)(t);l.outputStream.pipe(c),l.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(t))})}e.zip=h;function f(t,n,r={},i){const l=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=o(t,!0);return r.overwrite&&(c=c.then(s=>C.Promises.rm(n).then(()=>s))),c.then(s=>b(s,n,{sourcePathRegex:l},i))}e.extract=f;function w(t,n){return o(t).then(r=>new Promise((i,l)=>{r.on("entry",c=>{c.fileName===n&&d(r,c).then(s=>i(s),s=>l(s))}),r.once("close",()=>l(new Error(k.localize(2,null,n))))}))}function L(t,n){return w(t,n).then(r=>new Promise((i,l)=>{const c=[];r.once("error",l),r.on("data",s=>c.push(s)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=L}),define(pe[286],ve([1,0,14,9,2,13,3,19,51,8,21,23,89,24,25,30,34,79,16,12]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class Ti extends a.Disposable{constructor(t,n,r,i,l,c){super(),this.h=n,this.i=r,this.j=i,this.k=l,this.l=c,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,r){await this.g;const i=(0,k.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,c=>this.i.download(t,c,n))}catch(c){throw new b.ExtensionManagementError(c.message,b.ExtensionManagementErrorCode.Download)}let l=!1;if(r&&this.m(t)){const c=await this.n(t);try{l=await this.k.verify(i.fsPath,c.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(s){const u=s;if(l=u.code,u.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${u.output}`),l===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||l===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(E.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(c)}catch(s){this.l.error(s)}}}return l===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):l===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${l}': ${t.identifier.id}`),{location:i,verificationStatus:l}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,g.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,k.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${Ti.c}`);return await this.r(t,n,r=>this.i.downloadSignatureArchive(t,r)),n}async r(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==D.Schemas.file){await r(n);return}const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(i)||await r(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(l){try{await this.h.del(i)}catch{}if(l.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(l)}. Deleted the file from downloaded location`,i.path),l}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,r){try{await I.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(C.isWindows&&i&&i.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,r);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],i=[];for(const s of t.children)if(s.name.endsWith(Ti.c))i.push(s.resource);else{const u=o.ExtensionKey.parse(s.name);u&&r.push([u,s])}const l=(0,o.groupByExtension)(r,([s])=>s),c=[];for(const s of l)s.sort((u,S)=>v.rcompare(u[0].version,S[0].version)),n.push(...s.slice(1).map(u=>u[1].resource)),c.push(s[0][1]);c.sort((s,u)=>s.mtime-u.mtime),n.push(...c.slice(0,Math.max(0,c.length-this.f)).map(s=>s.resource)),n.push(...i),await y.Promises.settled(n.map(s=>(this.l.trace("Deleting from cache",s.path),this.h.del(s))))}}catch(t){this.l.error(t)}}v(t){return this.f?o.ExtensionKey.create(t).toString().toLowerCase():(0,T.generateUuid)()}};w.c=".sigzip",w=Re([Ae(0,p.INativeEnvironmentService),Ae(1,h.IFileService),Ae(2,b.IExtensionGalleryService),Ae(3,m.IConfigurationService),Ae(4,d.IExtensionSignatureVerificationService),Ae(5,f.ILogService)],w),e.ExtensionsDownloader=w}),define(pe[287],ve([1,0,89,178]),function(ae,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function a(D){return(0,y.buffer)(D,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=a}),define(pe[137],ve([1,0,14,15,20,39,9,6,2,27,13,7,3,19,51,8,4,21,23,89,177,78,25,253,30,34,45,55,286,254,287,229,238,76,16,5,12,26,31,35,32]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O,B,q,le,fe,ue,re,_,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,le.refineServiceDecorator)(r.IExtensionManagementService);let ne=class extends n.AbstractExtensionManagementService{constructor($,W,N,P,M,K,te,j,H,J,V,X){super($,W,N,J,X),this.Z=M,this.ab=K,this.bb=te,this.cb=H,this.db=V,this.X=this.B(new k.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new g.ResourceSet;const x=this.B(j.createInstance(u.ExtensionsLifecycle));this.S=this.B(j.createInstance(ie,ce=>x.postUninstall(ce))),this.U=this.B(new A.ExtensionsManifestCache(X,H,V,this,this.v)),this.W=this.B(j.createInstance(s.ExtensionsDownloader));const Q=this.B(new O.ExtensionsWatcher(this,this.Z,X,K,V,H,N));this.B(Q.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip($){this.v.trace("ExtensionManagementService#zip",$.identifier.id);const W=await this.jb($),N=await(0,f.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,W);return o.URI.file(N)}async unzip($){return this.v.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const{location:W,cleanup:N}=await this.fb($),P=I.resolve(W.fsPath);try{return await(0,S.getManifest)(P)}finally{await N()}}getInstalled($,W=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions($??null,W)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation($){return this.S.scanUserExtensionAtLocation($)}async install($,W={}){this.v.trace("ExtensionManagementService#install",$.toString());const{location:N,cleanup:P}=await this.fb($);try{const M=await(0,S.getManifest)(I.resolve(N.fsPath));if(M.engines&&M.engines.vscode&&!(0,B.isEngineValid)(M.engines.vscode,this.w.version,this.w.date))throw new Error(w.localize(0,null,(0,i.getGalleryExtensionId)(M.publisher,M.name),this.w.version));return await this.z(M,N,W)}finally{await P()}}async installFromLocation($,W){this.v.trace("ExtensionManagementService#installFromLocation",$.toString());const N=await this.S.scanUserExtensionAtLocation($);if(!N)throw new Error(`Cannot find a valid extension from the location ${$.toString()}`);return await this.ob([[N,void 0]],W),this.v.info("Successfully installed extension",N.identifier.id,W.toString()),N}async installExtensionsFromProfile($,W,N){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",$,W.toString(),N.toString());const P=(await this.S.scanExtensions(1,W)).filter(M=>$.some(K=>(0,i.areSameExtensions)(K,M.identifier)));if(P.length){const M=await Promise.all(P.map(K=>this.S.scanMetadata(K,W)));await this.ob(P.map((K,te)=>[K,M[te]]),N),this.v.info("Successfully installed extensions",P.map(K=>K.identifier.id),N.toString())}return P}async updateMetadata($,W,N=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",$.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0),W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.pinned=W.pinned||void 0,$=await this.S.updateMetadata($,W,N),this.U.invalidate(N),this.X.fire($),$}async reinstallFromGallery($){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",$.identifier.id),!this.t.isEnabled())throw new Error(w.localize(1,null));const W=await this.getTargetPlatform(),[N]=await this.t.getExtensions([{...$.identifier,preRelease:$.preRelease}],{targetPlatform:W,compatible:!0},a.CancellationToken.None);if(!N)throw new Error(w.localize(2,null));await this.S.setUninstalled($);try{await this.S.removeUninstalledExtension($)}catch(P){throw new Error(w.localize(3,null,(0,D.toErrorMessage)(P)))}return this.installFromGallery(N)}copyExtensions($,W){return this.S.copyExtensions($,W)}markAsUninstalled(...$){return this.S.setUninstalled(...$)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch($){this.v.error($)}}async download($,W,N){const{location:P}=await this.W.download($,W,!N);return P}async fb($){if($.scheme===T.Schemas.file)return{location:$,async cleanup(){}};this.v.trace("Downloading extension from",$.toString());const W=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)());return await this.bb.download($,W),this.v.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.cb.del(W)}catch(P){this.v.error(P)}}}}P(){return this.y.defaultProfile.extensionsResource}Q($,W,N){if(o.URI.isUri(W))return new Z($,W,N,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const P=i.ExtensionKey.create(W).toString();let M=this.Y.get(P);return M||(this.Y.set(P,M=new U($,W,N,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),M.waitUntilTaskIsFinished().finally(()=>this.Y.delete(P))),M}R($,W){return new oe($,W.profileLocation,this.ab)}async jb($){const W=async P=>{let M=await h.Promises.readdir(P);M=M.map(j=>I.join(P,j));const K=await Promise.all(M.map(j=>h.Promises.stat(j)));let te=Promise.resolve([]);return K.forEach((j,H)=>{const J=M[H];j.isFile()&&(te=te.then(V=>[...V,J])),j.isDirectory()&&(te=te.then(V=>W(J).then(X=>[...V,...X])))}),te};return(await W($.location.fsPath)).map(P=>({path:`extension/${I.relative($.location.fsPath,P)}`,localPath:P}))}async kb({added:$,removed:W}){if(W)for(const N of W.extensions)this.v.info("Extensions removed from another source",N.id,W.profileLocation.toString()),this.p.fire({identifier:N,profileLocation:W.profileLocation});if($){const P=(await this.S.scanExtensions(1,$.profileLocation)).filter(M=>$.extensions.some(K=>(0,i.areSameExtensions)(K,M.identifier)));this.m.fire(P.map(M=>(this.v.info("Extensions added from another source",M.identifier.id,$.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:$.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(W=>this.lb.add(W)));const $=await this.cb.resolve(this.Z.userExtensionsLocation);for(const W of $.children??[])W.isDirectory&&this.lb.add(W.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(W=>this.nb(W)))}async nb($){if(!$.affects(this.Z.userExtensionsLocation,1))return;const W=[];for(const N of $.rawAdded){if(this.lb.has(N)||!this.db.extUri.isEqual(this.db.extUri.dirname(N),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(N,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(N).startsWith(".")||!(await this.cb.stat(N)).isDirectory)continue;const P=await this.S.scanUserExtensionAtLocation(N);P&&P.installedTimestamp===void 0&&(this.lb.add(N),W.push(P))}W.length&&(await this.ob(W.map(N=>[N,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",W.map(N=>N.identifier.id)))}async ob($,W){const N=$.map(P=>P[0]);await this.pb(N),await this.ab.addExtensionsToProfile($,W),this.m.fire(N.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:W})))}async pb($){const W=await this.S.getUninstalledExtensions();for(const N of $){const P=i.ExtensionKey.create(N);!W[P.toString()]||(this.v.trace("Removing the extension from uninstalled list:",P.id),await this.S.setInstalled(P),this.v.info("Removed the extension from uninstalled list:",P.id))}}};ne=Re([Ae(0,r.IExtensionGalleryService),Ae(1,re.ITelemetryService),Ae(2,fe.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,c.IExtensionsScannerService),Ae(5,l.IExtensionsProfileScannerService),Ae(6,L.IDownloadService),Ae(7,le.IInstantiationService),Ae(8,q.IFileService),Ae(9,ue.IProductService),Ae(10,_.IUriIdentityService),Ae(11,ee.IUserDataProfilesService)],ne),e.ExtensionManagementService=ne;let ie=class extends v.Disposable{constructor($,W,N,P,M,K){super(),this.k=$,this.l=W,this.m=N,this.n=P,this.p=M,this.s=K,this.h=this.B(new k.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,m.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new y.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions($,W){const N={includeInvalid:!0,profileLocation:W};let P=[];return $===null||$===0?P.push(...await this.m.scanAllExtensions({includeInvalid:!0},N,!1)):$===1&&P.push(...await this.m.scanUserExtensions(N)),P=$!==null?P.filter(M=>M.type===$):P,Promise.all(P.map(M=>this.y(M)))}async scanAllUserExtensions($){const W=await this.m.scanUserExtensions({includeAllVersions:!$,includeInvalid:!0});return Promise.all(W.map(N=>this.y(N)))}async scanUserExtensionAtLocation($){try{const W=await this.m.scanExistingExtension($,1,{includeInvalid:!0});if(W)return await this.y(W)}catch(W){this.s.error(W)}return null}async extractUserExtension($,W,N,P){await this.j.catch(()=>{});const M=$.toString(),K=I.join(this.m.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),te=I.join(this.m.userExtensionsLocation.fsPath,M);try{await h.Promises.rm(te)}catch{throw new r.ExtensionManagementError(w.localize(4,null,te,$.id),r.ExtensionManagementErrorCode.Delete)}await this.u($,W,K,P),await this.m.updateMetadata(o.URI.file(K),N);try{this.h.fire(o.URI.file(te)),await this.v($,K,te,Date.now()+2*60*1e3),this.s.info("Renamed to",te)}catch(j){try{await h.Promises.rm(K)}catch{}if(j.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",$.id);else throw this.s.info(`Rename failed because of ${(0,C.getErrorMessage)(j)}. Deleted from extracted location`,K),j}return this.w(o.URI.file(te),1)}async scanMetadata($,W){return W?(await this.n.scanProfileExtensions(W)).find(P=>(0,i.areSameExtensions)(P.identifier,$.identifier))?.metadata:this.m.scanMetadata($.location)}async updateMetadata($,W,N){return N?await this.n.updateMetadata([[$,W]],N):await this.m.updateMetadata($.location,W),this.w($.location,$.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...$){const W=$.map(N=>i.ExtensionKey.create(N));await this.t(N=>W.forEach(P=>{N[P.toString()]=!0,this.s.info("Marked extension as uninstalled",P.toString())}))}async setInstalled($){await this.t(W=>delete W[$.toString()])}async removeExtension($,W){this.s.trace(`Deleting ${W} extension from disk`,$.identifier.id,$.location.fsPath);const N=this.p.extUri.joinPath(this.p.extUri.dirname($.location),`.${(0,d.generateUuid)()}`);await this.v($.identifier,$.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.l.del(N,{recursive:!0}),this.s.info("Deleted from disk",$.identifier.id,$.location.fsPath)}async removeUninstalledExtension($){await this.removeExtension($,"uninstalled"),await this.t(W=>delete W[i.ExtensionKey.create($).toString()])}async copyExtensions($,W){const N=await this.scanExtensions(1,$),P=await Promise.all(N.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,$)]));await this.n.addExtensionsToProfile(P,W)}async t($){return this.g.queue(async()=>{let W;try{W=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,q.toFileOperationResult)(P)!==1)throw P}let N={};if(W)try{N=JSON.parse(W)}catch{}return $&&($(N),Object.keys(N).length?await this.l.writeFile(this.c,R.VSBuffer.fromString(JSON.stringify(N))):await this.l.del(this.c)),N})}async u($,W,N,P){this.s.trace(`Started extracting the extension from ${W} to ${N}`);try{await h.Promises.rm(N)}catch(M){throw new r.ExtensionManagementError(this.D(M).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(W,N,{sourcePath:"extension",overwrite:!0},P),this.s.info(`Extracted extension to ${N}:`,$.id)}catch(M){try{await h.Promises.rm(N)}catch{}let K=r.ExtensionManagementErrorCode.Extract;throw M instanceof f.ExtractError&&(M.type==="CorruptZip"?K=r.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(K=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(M.message,K)}}async v($,W,N,P){try{await h.Promises.rename(W,N)}catch(M){if(E.isWindows&&M&&M.code==="EPERM"&&Date.now()<P)return this.s.info(`Failed renaming ${W} to ${N} with 'EPERM' error. Trying again...`,$.id),this.v($,W,N,P);throw new r.ExtensionManagementError(M.message||w.localize(5,null,W,N),M.code||r.ExtensionManagementErrorCode.Rename)}}async w($,W){const N=await this.m.scanExistingExtension($,W,{includeInvalid:!0});if(N)return this.y(N);throw new Error(w.localize(6,null,$.path))}async y($){const W=await this.l.resolve($.location);let N,P;return W.children&&(N=W.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=W.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:$.identifier,type:$.type,isBuiltin:$.isBuiltin||!!$.metadata?.isBuiltin,location:$.location,manifest:$.manifest,targetPlatform:$.targetPlatform,validations:$.validations,isValid:$.isValid,readmeUrl:N,changelogUrl:P,publisherDisplayName:$.metadata?.publisherDisplayName||null,publisherId:$.metadata?.publisherId||null,isApplicationScoped:!!$.metadata?.isApplicationScoped,isMachineScoped:!!$.metadata?.isMachineScoped,isPreReleaseVersion:!!$.metadata?.isPreReleaseVersion,preRelease:!!$.metadata?.preRelease,installedTimestamp:$.metadata?.installedTimestamp,updated:!!$.metadata?.updated,pinned:!!$.metadata?.pinned}}async z(){const $=await this.getUninstalledExtensions();if(Object.keys($).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys($));const W=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const M of W)$[i.ExtensionKey.create(M).toString()]||N.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(W,K=>K.identifier);await y.Promises.settled(M.map(async K=>{const te=K.sort((j,H)=>p.rcompare(j.manifest.version,H.manifest.version))[0];N.has(te.identifier.id.toLowerCase())||await this.k(await this.y(te))}))}catch(M){this.s.error(M)}const P=W.filter(M=>M.metadata&&$[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const $=[];let W;try{W=await this.l.resolve(this.m.userExtensionsLocation)}catch(N){(0,q.toFileOperationResult)(N)!==1&&this.s.error(N)}for(const N of W?.children??[])N.isDirectory&&N.name.startsWith(".")&&(0,d.isUUID)(N.name.substring(1))&&$.push((async()=>{this.s.trace("Deleting the generated extension folder",N.resource.toString());try{await this.l.del(N.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",N.resource.toString())}catch(P){this.s.error(P)}})());await Promise.allSettled($)}D($){const W=Array.isArray($)?$:[$];return W.length===1?W[0]instanceof Error?W[0]:new Error(W[0]):W.reduce((N,P)=>new Error(`${N.message}${N.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}};ie=Re([Ae(1,q.IFileService),Ae(2,c.IExtensionsScannerService),Ae(3,l.IExtensionsProfileScannerService),Ae(4,_.IUriIdentityService),Ae(5,fe.ILogService)],ie),e.ExtensionsScanner=ie;class G extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor($,W,N,P,M,K,te,j,H){super(),this.identifier=$,this.source=W,this.m=N,this.n=P,this.o=M,this.p=K,this.q=te,this.s=j,this.t=H,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h($){const[W,N]=await this.y($);return this.j=W.isBuiltin||W.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[W,N]],this.j),W}async v({zipPath:$,key:W,metadata:N},P){let M=await this.w(W);return M||(this.t.trace("Extracting extension...",W.id),M=await this.n.extractUserExtension(W,$,N,P),this.t.info("Extracting extension completed.",W.id)),M}async w($){return await this.x($)?(this.t.trace("Removing the extension from uninstalled list:",$.id),await this.n.setInstalled($),this.t.info("Removed the extension from uninstalled list:",$.id),(await this.n.scanAllUserExtensions(!0)).find(P=>i.ExtensionKey.create(P).equals($))):void 0}async x($){return!!(await this.n.getUninstalledExtensions())[$.toString()]}}class U extends G{constructor($,W,N,P,M,K,te,j,H,J){super(W.identifier,W,N,M,K,te,j,H,J),this.z=W,this.A=P}async y($){const N=(await this.n.scanExtensions(null,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(te.identifier,this.z.identifier));N&&(this.l=3);const P={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||N?.isMachineScoped,isBuiltin:this.m.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,b.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.z.version)return[await this.n.updateMetadata(N,P),P];const{location:M,verificationStatus:K}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=K,this.C(M.fsPath),[await this.v({zipPath:M.fsPath,key:i.ExtensionKey.create(this.z),metadata:P},$),P]}catch(te){try{await this.A.delete(M)}catch(j){this.t.warn("Error while deleting the downloaded file",M.toString(),(0,C.getErrorMessage)(j))}throw te}}async C($){try{await(0,S.getManifest)($)}catch(W){throw new r.ExtensionManagementError((0,n.joinErrors)(W).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class Z extends G{constructor($,W,N,P,M,K,te,j,H,J){super({id:(0,i.getGalleryExtensionId)($.publisher,$.name)},W,N,M,K,te,j,H,J),this.z=$,this.A=W,this.B=P}async h($){const W=await super.h($);return this.E(W,$),W}async y($){const W=new i.ExtensionKey(this.identifier,this.z.version),P=(await this.n.scanExtensions(1,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),M={isApplicationScoped:this.m.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||P?.isMachineScoped,isBuiltin:this.m.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(P)if(this.l=3,W.equals(new i.ExtensionKey(P.identifier,P.manifest.version)))try{await this.n.removeExtension(P,"existing")}catch{throw new Error(w.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&p.gt(P.manifest.version,this.z.version)&&await this.n.setUninstalled(P);else{const te=await this.w(W);if(te)try{await this.n.removeExtension(te,"existing")}catch{throw new Error(w.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:I.resolve(this.A.fsPath),key:W,metadata:M},$),M]}async E($,W){try{let[N]=await this.B.getExtensions([{id:$.identifier.id,version:$.manifest.version}],W);if(N||([N]=await this.B.getExtensions([{id:$.identifier.id}],W)),N){const P={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata($,P,this.m.profileLocation)}}catch{}}}class oe extends n.AbstractExtensionTask{constructor($,W,N){super(),this.extension=$,this.j=W,this.k=N}async h($){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[138],ve([1,0,82,14,15,9,8,24,25,83,12,44,232,299]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let p=class extends I.AbstractRequestService{constructor(h,f,w,L){super(!!f.isRemoteServer,L),this.j=h,this.k=f,this.l=w,this.m(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const h=this.j.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,f){const{f:w,g:L}=this;let t;try{t=await(0,g.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,D.getErrorMessage)(i)))}const n={...process.env,...t},r=h.agent?h.agent:await(0,E.getProxyAgent)(h.url||"",n,{proxyUrl:w,strictSSL:L});return h.agent=r,h.strictSSL=L,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>o(h,f))}async resolveProxy(h){}};p=Re([Ae(0,k.IConfigurationService),Ae(1,v.INativeEnvironmentService),Ae(2,T.ILogService),Ae(3,T.ILoggerService)],p),e.RequestService=p;async function b(d){return((0,y.parse)(d.url).protocol==="https:"?await new Promise((w,L)=>{ae(["https"],w,L)}):await new Promise((w,L)=>{ae(["http"],w,L)})).request}async function o(d,h){return R.Promises.withAsyncBody(async(f,w)=>{const L=(0,y.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await b(d),n={hostname:L.hostname,port:L.port?parseInt(L.port):L.protocol==="https:"?443:80,protocol:L.protocol,path:L.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,C.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=t(n,i=>{const l=(0,C.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&l>0&&i.headers.location)o({...d,url:i.headers.location,followRedirects:l-1},h).then(f,w);else{let c=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,m.createGunzip)())),f({res:i,stream:(0,a.streamToBufferReadableStream)(c)})}});r.on("error",w),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),h.onCancellationRequested(()=>{r.abort(),w(new D.CancellationError)})})}e.nodeRequest=o}),define(pe[288],ve([1,0,80,12,64,113,24,44,138,37,31,30,124,137,79,107,52,2,108,67,13,16,26,41,116,81,117,9,4,7,28,230,78,35,122,63,3,55,127,32,45,68,125,123,110,111,193]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O,B,q,le,fe,ue,re,_,ee,ne,ie,G,U,Z,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class me extends d.Disposable{constructor(P,M){super(),this.a=P,this.b=M,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const P=await this.f();await P.invokeFunction(async M=>{const K=M.get(R.ILogService);try{await this.g(P.createInstance(r.ExtensionManagementCLI,new R.ConsoleLogger(K.getLevel(),!1)))}catch(te){throw K.error(te),console.error((0,c.getErrorMessage)(te)),te}})}async f(){const P=new y.ServiceCollection,M={_serviceBrand:void 0,...o.default};P.set(t.IProductService,M);const K=new n.ServerEnvironmentService(this.a,M);P.set(n.IServerEnvironmentService,K);const te=new Z.LoggerService((0,R.getLogLevel)(K),K.logsHome);P.set(R.ILoggerService,te);const j=new U.LogService(this.B(te.createLogger("remoteCLI",{name:(0,oe.localize)(0,null)})));P.set(R.ILogService,j),j.trace(`Remote configuration data at ${this.b}`),j.trace("process arguments:",this.a);const H=this.B(new h.FileService(j));P.set(L.IFileService,H),H.registerProvider(w.Schemas.file,this.B(new f.DiskFileSystemProvider(j)));const J=new q.UriIdentityService(H);P.set(B.IUriIdentityService,J);const V=this.B(new ie.ServerUserDataProfilesService(J,K,H,j));P.set(_.IUserDataProfilesService,V);const X=this.B(new D.ConfigurationService(V.defaultProfile.settingsResource,H,new ne.NullPolicyService,j));return P.set(C.IConfigurationService,X),await Promise.all([X.initialize(),V.init()]),P.set(k.IRequestService,new a.SyncDescriptor(v.RequestService)),P.set(O.IDownloadService,new a.SyncDescriptor(A.DownloadService)),P.set(T.ITelemetryService,g.NullTelemetryService),P.set(I.IExtensionGalleryService,new a.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),P.set(ee.IExtensionsProfileScannerService,new a.SyncDescriptor(G.ExtensionsProfileScannerService)),P.set(ue.IExtensionsScannerService,new a.SyncDescriptor(re.ExtensionsScannerService)),P.set(p.IExtensionSignatureVerificationService,new a.SyncDescriptor(p.ExtensionSignatureVerificationService)),P.set(m.INativeServerExtensionManagementService,new a.SyncDescriptor(m.ExtensionManagementService)),P.set(i.ILanguagePackService,new a.SyncDescriptor(l.NativeLanguagePackService)),new b.InstantiationService(P)}async g(P){if(this.a["list-extensions"])return P.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const M={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return P.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),M,!!this.a.force)}else{if(this.a["uninstall-extension"])return P.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return P.locateExtension(this.a["locate-extension"])}}h(P){return P.map(M=>/\.vsix$/i.test(M)?s.URI.file((0,u.isAbsolute)(M)?M:(0,u.join)((0,S.cwd)(),M)):M)}}function $(N){setTimeout(()=>process.exit(N),0)}async function W(N,P,M){if(N.help){const te=o.default.serverApplicationName+(fe.isWindows?".cmd":"");console.log((0,le.buildHelpMessage)(o.default.nameLong,te,o.default.version,M,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,le.buildVersionMessage)(o.default.version,o.default.commit));return}const K=new me(N,P);try{await K.run(),$(0)}catch{$(1)}finally{K.dispose()}}e.run=W}),define(pe[289],ve([1,0,29,6,2,13,7,97,23,43,24,113,77,260,201,78,202,211,220,25,124,30,79,116,212,137,16,108,67,64,107,80,81,117,12,52,26,44,231,138,115,31,37,245,121,252,35,122,266,267,236,242,284,69,41,273,285,126,55,127,45,32,261,68,243,111,125,123,110,109,195,280,227,256]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O,B,q,le,fe,ue,re,_,ee,ne,ie,G,U,Z,oe,me,$,W,N,P,M,K,te,j,H,J,V,X,x,Q,ce,Ee,Ce,ke,Me,$e,ge,Se,ye,Fe,Ne,et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ve="monacoworkbench";async function Xe(Le,je,We,Ye){const qe=new A.ServiceCollection,Ke=new Ge,tt={_serviceBrand:void 0,...le.default};qe.set(fe.IProductService,tt);const Je=new te.ServerEnvironmentService(je,tt);qe.set(f.IEnvironmentService,Je),qe.set(f.INativeEnvironmentService,Je);const lt=new ke.LoggerService((0,q.getLogLevel)(Je),Je.logsHome);qe.set(q.ILoggerService,lt),Ke.registerChannel("logger",new Se.LoggerChannel(lt,st=>Ze(st.remoteAuthority)));const mt=lt.createLogger("remoteagent",{name:(0,ye.localize)(0,null)}),ot=new ge.LogService(mt,[new he((0,q.getLogLevel)(Je))]);qe.set(q.ILogService,ot),setTimeout(()=>Be(Je.logsHome.fsPath).then(null,st=>ot.error(st)),1e4),ot.onDidChangeLogLevel(st=>(0,q.log)(ot,st,`Log level changed to ${(0,q.LogLevelToString)(ot.getLevel())}`)),ot.trace(`Remote configuration data at ${We}`),ot.trace("process arguments:",Je.args),Array.isArray(tt.serverGreeting)&&ot.info(`

${tt.serverGreeting.join(`
`)}

`),Ke.registerChannel(p.ExtensionHostDebugBroadcastChannel.ChannelName,new p.ExtensionHostDebugBroadcastChannel);const $t=new g.StaticRouter(st=>st.clientId==="renderer"),Dt=Ye.add(new c.FileService(ot));qe.set(l.IFileService,Dt),Dt.registerProvider(D.Schemas.file,Ye.add(new s.DiskFileSystemProvider(ot)));const Ut=new me.UriIdentityService(Dt);qe.set(oe.IUriIdentityService,Ut);const bt=new I.ConfigurationService(Je.machineSettingsResource,Dt,new Ee.NullPolicyService,ot);qe.set(T.IConfigurationService,bt);const ft=new Me.ServerUserDataProfilesService(Ut,Je,Dt,ot);qe.set(Q.IUserDataProfilesService,ft),Ke.registerChannel("userDataProfiles",new et.RemoteUserDataProfilesServiceChannel(ft,st=>Ze(st.remoteAuthority)));const[,,Tt]=await Promise.all([bt.initialize(),ft.init(),(0,k.getMachineId)(ot.error.bind(ot))]),Bt=new J.ExtensionHostStatusService;qe.set(J.IExtensionHostStatusService,Bt),qe.set(ue.IRequestService,new u.SyncDescriptor(_.RequestService));let Ct=ie.NullAppender;const Rt=(0,ie.isInternalTelemetry)(tt,bt);if((0,ie.supportsTelemetry)(tt,Je)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?Ct=new Ce.OneDataSystemAppender(!1,Ve,null,()=>new ce.TelemetryClient(st)):tt.aiConfig&&tt.aiConfig.ariaKey&&(Ct=new Ce.OneDataSystemAppender(Rt,Ve,null,tt.aiConfig.ariaKey)),Ye.add((0,a.toDisposable)(()=>Ct?.flush()));const yt={appenders:[Ct],commonProperties:(0,ee.resolveCommonProperties)((0,y.release)(),(0,y.hostname)(),process.arch,tt.commit,tt.version+"-remote",Tt,Rt,"remoteAgent"),piiPaths:(0,ie.getPiiPathsFromEnvironment)(Je)},wt=Je.args["telemetry-level"];let we=3;wt==="all"?we=3:wt==="error"?we=2:wt==="crash"?we=1:wt!==void 0&&(we=0),qe.set(P.IServerTelemetryService,new u.SyncDescriptor(P.ServerTelemetryService,[yt,we]))}else qe.set(P.IServerTelemetryService,P.ServerNullTelemetryService);qe.set(L.IExtensionGalleryService,new u.SyncDescriptor(w.ExtensionGalleryServiceWithNoStorageService));const Lt=Ke.getChannel("download",$t);qe.set(b.IDownloadService,new o.DownloadServiceChannelClient(Lt,()=>Ze("renderer"))),qe.set(x.IExtensionsProfileScannerService,new u.SyncDescriptor($e.ExtensionsProfileScannerService)),qe.set(V.IExtensionsScannerService,new u.SyncDescriptor(X.ExtensionsScannerService)),qe.set(t.IExtensionSignatureVerificationService,new u.SyncDescriptor(t.ExtensionSignatureVerificationService)),qe.set(i.INativeServerExtensionManagementService,new u.SyncDescriptor(i.ExtensionManagementService));const gt=new S.InstantiationService(qe);qe.set(O.ILanguagePackService,gt.createInstance(B.NativeLanguagePackService));const Et=gt.createInstance(Z.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:bt.getValue("terminal.integrated.persistentSessionScrollback")??100},!0);return qe.set(U.IPtyService,Et),qe.set(d.IEncryptionMainService,new u.SyncDescriptor(h.EncryptionMainService,[Tt])),qe.set(E.ICredentialsMainService,new u.SyncDescriptor(m.CredentialsWebMainService)),gt.invokeFunction(st=>{const yt=st.get(i.INativeServerExtensionManagementService),wt=st.get(V.IExtensionsScannerService),we=st.get(L.IExtensionGalleryService),De=st.get(O.ILanguagePackService),de=new $.RemoteAgentEnvironmentChannel(Le,Je,ft,Bt);Ke.registerChannel("remoteextensionsenvironment",de);const Y=new N.ServerTelemetryChannel(st.get(P.IServerTelemetryService),Ct);Ke.registerChannel("telemetry",Y),Ke.registerChannel(j.REMOTE_TERMINAL_CHANNEL_NAME,new M.RemoteTerminalChannel(Je,ot,Et,tt,yt,bt));const Pe=new Fe.RemoteExtensionsScannerService(gt.createInstance(n.ExtensionManagementCLI,ot),Je,ft,wt,ot,we,De);Ke.registerChannel(Ne.RemoteExtensionsScannerChannelName,new Fe.RemoteExtensionsScannerChannel(Pe,ut=>Ze(ut.remoteAuthority)));const Oe=new W.RemoteAgentFileSystemProviderChannel(ot,Je);Ke.registerChannel(H.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Oe),Ke.registerChannel("request",new re.RequestChannel(st.get(ue.IRequestService)));const xe=new r.ExtensionManagementChannel(yt,ut=>Ze(ut.remoteAuthority));Ke.registerChannel("extensions",xe);const ze=g.ProxyChannel.fromService(st.get(O.ILanguagePackService));Ke.registerChannel("languagePacks",ze);const nt=g.ProxyChannel.fromService(st.get(d.IEncryptionMainService));Ke.registerChannel("encryption",nt);const at=g.ProxyChannel.fromService(st.get(E.ICredentialsMainService));return Ke.registerChannel("credentials",at),Pe.whenExtensionsReady().then(()=>yt.cleanUp()),Ye.add(new G.default(st.get(ne.ITelemetryService))),{telemetryService:st.get(ne.ITelemetryService)}}),{socketServer:Ke,instantiationService:gt}}e.setupServerServices=Xe;const Qe=Object.create(null);function Ze(Le){return Qe[Le]||(Qe[Le]=(0,K.createURITransformer)(Le)),Qe[Le]}class Ge extends g.IPCServer{constructor(){const je=new R.Emitter;super(je.event),this.b=je}acceptConnection(je,We){this.b.fire({protocol:je,onDidClientDisconnect:We})}}e.SocketServer=Ge;class he extends q.AbstractLogger{constructor(je=q.DEFAULT_LOG_LEVEL){super(),this.setLevel(je),this.g=Boolean(process.stdout.isTTY)}trace(je,...We){this.f(q.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,je,...We):console.log(`[${Ie()}]`,je,...We))}debug(je,...We){this.f(q.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,je,...We):console.log(`[${Ie()}]`,je,...We))}info(je,...We){this.f(q.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,je,...We):console.log(`[${Ie()}]`,je,...We))}warn(je,...We){this.f(q.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ie()}]\x1B[0m`,je,...We):console.warn(`[${Ie()}]`,je,...We))}error(je,...We){this.f(q.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ie()}]\x1B[0m`,je,...We):console.error(`[${Ie()}]`,je,...We))}dispose(){}flush(){}}function Ie(){const Le=new Date;return`${Te(Le.getHours())}:${Te(Le.getMinutes())}:${Te(Le.getSeconds())}`}function Te(Le){return Le<10?`0${Le}`:String(Le)}async function Be(Le){const je=C.basename(Le),We=C.dirname(Le),Ke=(await v.Promises.readdir(We)).filter(Je=>/^\d{8}T\d{6}$/.test(Je)).sort().filter(Je=>Je!==je),tt=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(tt.map(Je=>v.Promises.rm(C.join(We,Je))))}}),define(pe[290],ve([1,0,118,33,98,291,82,139,15,9,38,2,13,7,42,3,17,4,21,154,102,62,5,12,26,54,31,133,257,258,41,289,263]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E,m,p,b,o,d,h,f,w,L,t,n,r,i,l,c,s,u,S,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const B=5*60*1e3;let q=class extends I.Disposable{constructor(re,_,ee,ne,ie,G,U,Z){super(),this.k=re,this.l=_,this.m=ee,this.n=ie,this.p=G,this.r=U,this.s=Z,this.h=fe.create(this.p),this.i=(0,i.getRemoteServerRootPath)(G),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ne?this.s.createInstance(O.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(re,_){if(re.method!=="GET")return(0,O.serveError)(re,_,405,`Unsupported method ${re.method}`);if(!re.url)return(0,O.serveError)(re,_,400,"Bad request.");const ee=C.parse(re.url,!0);let ne=ee.pathname;if(!ne)return(0,O.serveError)(re,_,400,"Bad request.");if(ne.startsWith(this.i)&&ne.charCodeAt(this.i.length)===47&&(ne=ne.substring(this.i.length)),ne==="/version")return _.writeHead(200,{"Content-Type":"text/plain"}),void _.end(this.p.commit||"");if(ne==="/delay-shutdown")return this.H(),_.writeHead(200),void _.end("OK");if(!(0,u.requestHasValidConnectionToken)(this.l,re,ee))return(0,O.serveError)(re,_,403,"Forbidden.");if(ne==="/vscode-remote-resource"){const ie=ee.query.path;if(typeof ie!="string")return(0,O.serveError)(re,_,400,"Bad request.");let G;try{G=d.URI.from({scheme:E.Schemas.file,path:ie}).fsPath}catch{return(0,O.serveError)(re,_,400,"Bad request.")}const U=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(G,this.n.builtinExtensionsPath,!b.isLinux)||(0,T.isEqualOrParent)(G,this.n.extensionsPath,!b.isLinux))&&(U["Cache-Control"]="public, max-age=31536000"),U.Vary="Origin";const Z=re.headers.origin;return Z&&this.h.matches(Z)&&(U["Access-Control-Allow-Origin"]=Z),(0,O.serveFile)(G,1,this.r,re,_,U)}if(this.g){this.g.handle(re,_,ee);return}return _.writeHead(404,{"Content-Type":"text/plain"}),void _.end("Not found")}handleUpgrade(re,_){let ee=(0,h.generateUuid)(),ne=!1,ie=!1;if(re.url){const $=C.parse(re.url,!0).query;typeof $.reconnectionToken=="string"&&(ee=$.reconnectionToken),$.reconnection==="true"&&(ne=!0),$.skipWebSocketFrames==="true"&&(ie=!0)}if(re.headers.upgrade===void 0||re.headers.upgrade.toLowerCase()!=="websocket"){_.end("HTTP/1.1 400 Bad Request");return}const G=re.headers["sec-websocket-key"],U=y.createHash("sha1");U.update(G+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Z=U.digest("base64"),oe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Z}`];let me=!1;if(!ie&&!this.n.args["disable-websocket-compression"]&&re.headers["sec-websocket-extensions"]){const $=Array.isArray(re.headers["sec-websocket-extensions"])?re.headers["sec-websocket-extensions"]:[re.headers["sec-websocket-extensions"]];for(const W of $)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(W)){if(/\b(permessage-deflate)\b/.test(W)){me=!0,oe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(W)){me=!0,oe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}_.write(oe.join(`\r
`)+`\r
\r
`),_.setTimeout(0),_.setNoDelay(!0),ie?this.v(new L.NodeSocket(_,`server-connection-${ee}`),ne,ee):this.v(new L.WebSocketNodeSocket(new L.NodeSocket(_,`server-connection-${ee}`),me,null,!0),ne,ee)}handleServerError(re){this.r.error("Error occurred in server"),this.r.error(re)}t(re){let _;return re instanceof L.NodeSocket?_=re.socket:_=re.socket.socket,_.remoteAddress||"<unknown>"}async u(re,_,ee){const ne=_.getSocket();this.r.error(`${re} ${ee}.`);const ie={type:"error",reason:ee};_.sendControl(v.VSBuffer.fromString(JSON.stringify(ie))),_.dispose(),await ne.drain(),ne.dispose()}v(re,_,ee){const ne=this.t(re),ie=`[${ne}][${ee.substr(0,8)}]`,G=new w.PersistentProtocol({socket:re}),U=this.m?new this.m.validator:null,Z=this.m?new this.m.signer:null;let oe;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(oe||(oe={}));let me=0;const $=N=>{me=3,W.dispose(),this.u(ie,G,N)},W=G.onControlMessage(N=>{if(me===0){let P;try{P=JSON.parse(N.toString())}catch{return $("Malformed first message")}if(P.type!=="auth")return $("Invalid first message");if(this.l.type===2&&!this.l.validate(P.auth))return $("Unauthorized client refused: auth mismatch");let M=(0,h.generateUuid)();if(Z)try{M=Z.sign(P.data)}catch{}let K=(0,h.generateUuid)();if(U)try{K=U.createNewMessage(K)}catch{}const te={type:"sign",data:K,signedData:M};G.sendControl(v.VSBuffer.fromString(JSON.stringify(te))),me=1}else if(me===1){let P;try{P=JSON.parse(N.toString())}catch{return $("Malformed second message")}if(P.type!=="connectionType")return $("Invalid second message");if(typeof P.signedData!="string")return $("Invalid second message field type");const M=P.commit,K=this.p.commit;if(M&&K&&M!==K)return $("Client refused: version mismatch");let te=!1;if(!U)te=!0;else if(this.l.validate(P.signedData))te=!0;else try{te=U.validate(P.signedData)==="ok"}catch{}if(!te){if(this.n.isBuilt)return $("Unauthorized client refused");this.r.error(`${ie} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const j in this.b)this.b[j].shortenReconnectionGraceTimeIfNecessary();for(const j in this.a)this.a[j].shortenReconnectionGraceTimeIfNecessary();me=2,W.dispose(),this.w(ne,ie,G,re,_,ee,P)}})}async w(re,_,ee,ne,ie,G,U){const Z=U.desiredConnectionType===1?`${_}[ManagementConnection]`:U.desiredConnectionType===2?`${_}[ExtensionHostConnection]`:_;if(U.desiredConnectionType===1)if(ie){if(!this.b[G])return this.f.has(G)?this.u(Z,ee,"Unknown reconnection token (seen before)"):this.u(Z,ee,"Unknown reconnection token (never seen)");ee.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=ee.readEntireBuffer();ee.dispose(),this.b[G].acceptReconnection(re,ne,oe)}else{if(this.b[G])return this.u(Z,ee,"Duplicate reconnection token");ee.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=new s.ManagementConnection(this.r,G,re,ee);this.k.acceptConnection(oe.protocol,oe.onClose),this.b[G]=oe,this.f.add(G),oe.onClose(()=>{delete this.b[G]})}else if(U.desiredConnectionType===2){const oe=U.args||{language:"en"},me=await this.C(oe);if(me.port&&this.r.trace(`${Z} - startParams debug port ${me.port}`),this.r.trace(`${Z} - startParams language: ${me.language}`),this.r.trace(`${Z} - startParams env: ${JSON.stringify(me.env)}`),ie){if(!this.a[G])return this.f.has(G)?this.u(Z,ee,"Unknown reconnection token (seen before)"):this.u(Z,ee,"Unknown reconnection token (never seen)");ee.sendPause(),ee.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const $=ee.readEntireBuffer();ee.dispose(),this.a[G].acceptReconnection(re,ne,$)}else{if(this.a[G])return this.u(Z,ee,"Duplicate reconnection token");ee.sendPause(),ee.sendControl(v.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const $=ee.readEntireBuffer();ee.dispose();const W=this.s.createInstance(c.ExtensionHostConnection,G,re,ne,$);this.a[G]=W,this.f.add(G),W.onClose(()=>{delete this.a[G],this.D()}),W.start(me)}}else if(U.desiredConnectionType===3){const oe=U.args;this.y(ee,oe)}else return this.u(Z,ee,"Unknown initial data received")}async y(re,_){const ee=re.getSocket().socket,ne=re.readEntireBuffer();re.dispose(),ee.pause();const ie=await this.z(_.host,_.port);ne.byteLength>0&&ie.write(ne.buffer),ie.on("end",()=>ee.end()),ie.on("close",()=>ee.end()),ie.on("error",()=>ee.destroy()),ee.on("end",()=>ie.end()),ee.on("close",()=>ie.end()),ee.on("error",()=>ie.destroy()),ie.pipe(ee),ee.pipe(ie)}z(re,_){return new Promise((ee,ne)=>{const ie=a.createConnection({host:re,port:_},()=>{ie.removeListener("error",ne),ie.pause(),ee(ie)});ie.once("error",ne)})}C(re){return typeof re.port=="number"?(0,f.findFreePort)(re.port,10,5e3).then(_=>(re.port=_,re)):(re.debugId=void 0,re.port=void 0,re.break=void 0,Promise.resolve(re))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(re=!1){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]&&!re?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},B))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};q=Re([Ae(4,S.IServerEnvironmentService),Ae(5,r.IProductService),Ae(6,n.ILogService),Ae(7,t.IInstantiationService)],q);async function le(ue,re,_){const ee=await(0,u.determineServerConnectionToken)(re);ee instanceof u.ServerConnectionTokenParseError&&(console.warn(ee.message),process.exit(1));function ne(te){(0,g.setUnexpectedErrorHandler)(j=>{(0,g.isSigPipeError)(j)&&j.stack&&/unexpectedErrorHandler/.test(j.stack)||te(j)})}const ie=[];ne(te=>{ie.push(te),console.error(te)});let G=!1;process.on("SIGPIPE",()=>{G||(G=!0,(0,g.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const U=new I.DisposableStore,{socketServer:Z,instantiationService:oe}=await(0,A.setupServerServices)(ee,re,_,U);oe.invokeFunction(te=>{const j=te.get(n.ILogService);ie.forEach(H=>j.error(H)),ie.length=0,ne(H=>j.error(H))}),oe.invokeFunction(te=>{const j=te.get(n.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,m.join)(process.env.HOMEDRIVE,"node_modules"),J=(0,m.dirname)((0,m.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),V=(0,m.join)(J,"node_modules");if(R.existsSync(H)||R.existsSync(V)){const X=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${V}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;j.warn(X),console.warn(X),process.exit(0)}}});const me=oe.invokeFunction(te=>{const j=te.get(n.ILogService);if(R.existsSync((0,m.join)(E.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(J){j.error(J)}return null}),$=R.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if($&&ue&&typeof ue!="string"){const te=ee.type!==0?`?${E.connectionTokenQueryName}=${ee.value}`:"";console.log(`Web UI available at http://localhost${ue.port===80?"":`:${ue.port}`}/${te}`)}const W=oe.createInstance(q,Z,ee,me,$);p.mark("code/server/ready");const N=D.performance.now(),P=global.vscodeServerStartTime,M=global.vscodeServerListenTime,K=global.vscodeServerCodeLoadedTime;if(oe.invokeFunction(te=>{te.get(l.ITelemetryService).publicLog2("serverStart",{startTime:P,startedTime:M,codeLoadedTime:K,readyTime:N})}),re["print-startup-performance"]){const te=k.LoaderStats.get();let j="";j+=`

### Load AMD-module
`,j+=k.LoaderStats.toMarkdownTable(["Module","Duration"],te.amdLoad),j+=`

### Load commonjs-module
`,j+=k.LoaderStats.toMarkdownTable(["Module","Duration"],te.nodeRequire),j+=`

### Invoke AMD-module factory
`,j+=k.LoaderStats.toMarkdownTable(["Module","Duration"],te.amdInvoke),j+=`

### Invoke commonjs-module
`,j+=k.LoaderStats.toMarkdownTable(["Module","Duration"],te.nodeEval),j+=`Start-up time: ${M-P}
`,j+=`Code loading time: ${K-P}
`,j+=`Initialized time: ${N-P}
`,j+=`
`,console.log(j)}return W}e.createServer=le;class fe{static create(re){const _=re.webEndpointUrlTemplate,ee=re.commit,ne=re.quality;if(!_||!ee||!ne)return new fe(null);const ie=(0,h.generateUuid)(),U=new URL(_.replace("{{uuid}}",ie).replace("{{commit}}",ee).replace("{{quality}}",ne)).origin,Z=(0,o.escapeRegExpCharacters)(U).replace(ie,"[a-zA-Z0-9\\-]+");try{const oe=(0,o.createRegExp)(`^${Z}$`,!0,{matchCase:!1});return new fe(oe)}catch{return new fe(null)}}constructor(re){this.a=re}matches(re){return this.a?this.a.test(re):!1}}}),define(pe[300],ve([1,0,29,33,13,288,290,63,7,291,41,52,42]),function(ae,e,y,R,a,D,C,k,v,g,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=g.performance.now();const m={onMultipleValues:(h,f)=>{console.error(`Option '${h}' can only be defined once. Using value ${f}.`)},onEmptyValue:h=>{console.error(`Ignoring option '${h}': Value must not be empty.`)},onUnknownOption:h=>{console.error(`Ignoring option '${h}': not supported for server.`)},onDeprecatedOption:(h,f)=>{console.warn(`Option '${h}' is deprecated: ${f}`)}};function p(){return(0,k.parseArgs)(process.argv.slice(2),T.serverOptions,m)}function b(h){const f=h["server-data-dir"]||h["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(y.homedir(),I.default.serverDataFolderName||".vscode-remote"),w=h["user-data-dir"]||(0,v.join)(f,"data"),L=(0,v.join)(w,"User"),t=(0,v.join)(L,"globalStorage"),n=(0,v.join)(L,"History"),r=(0,v.join)(w,"Machine");h["user-data-dir"]=w;const i=(0,v.dirname)(a.FileAccess.asFileUri("").fsPath),l=h["builtin-extensions-dir"]||(0,v.join)(i,"extensions");return h["builtin-extensions-dir"]=l,h["extensions-dir"]=h["extensions-dir"]||(0,v.join)(f,"extensions"),[f,h["extensions-dir"],w,L,r,t,n].forEach(c=>{try{R.existsSync(c)||R.mkdirSync(c,{mode:448})}catch(s){console.error(s)}}),f}function o(h=p()){return(0,D.run)(h,b(h),T.serverOptions)}e.spawnCli=o;function d(h,f=p()){return(0,C.createServer)(h,f,b(f))}e.createServer=d})}).call(this);

//# sourceMappingURL=server.main.js.map
